(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source | 
  Boogie/Spec# benchmarks.
  This benchmark was translated by Michal Moskal.
|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun InRange (Int Int) Bool)
(declare-fun this () Int)
(declare-fun int_18446744073709551615 () Int)
(declare-fun Smt.false () Int)
(declare-fun ThenCheck_correct () Int)
(declare-fun then_correct () Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun y () Int)
(declare-fun select1 (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun then_2_join_correct () Int)
(declare-fun CONCVARSYM (Int) Int)
(declare-fun FIELD () Int)
(declare-fun y_0 () Int)
(declare-fun y_1 () Int)
(declare-fun divides (Int Int) Int)
(declare-fun y_2 () Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun ThenCheck_2_GeneratedUnifiedExit_correct () Int)
(declare-fun subtypes (Int Int) Bool)
(declare-fun store1 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun StartCheck_2_GeneratedUnifiedExit_correct () Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun int_2147483647 () Int)
(declare-fun x_0 () Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun ReallyLastGeneratedExit_correct () Int)
(declare-fun int_m9223372036854775808 () Int)
(declare-fun Smt.true () Int)
(declare-fun Heap () Int)
(declare-fun int_4294967295 () Int)
(declare-fun start_correct () Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun StartCheck_correct () Int)
(declare-fun boolNot (Int) Int)
(declare-fun GeneratedUnifiedExit_correct () Int)
(declare-fun Heap_0 () Int)
(declare-fun Heap_1 () Int)
(declare-fun ElseCheck_2_GeneratedUnifiedExit_correct () Int)
(declare-fun Heap_2 () Int)
(declare-fun intLess (Int Int) Int)
(declare-fun JoinCheck_2_GeneratedUnifiedExit_correct () Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun is (Int Int) Int)
(declare-fun join_correct () Int)
(declare-fun int_m2147483648 () Int)
(declare-fun ElseCheck_correct () Int)
(declare-fun OTHERFIELD () Int)
(declare-fun else_correct () Int)
(declare-fun modulo (Int Int) Int)
(declare-fun else_2_join_correct () Int)
(declare-fun JoinCheck_correct () Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun int_9223372036854775807 () Int)
(assert (distinct FIELD OTHERFIELD))
(assert true)
(assert (forall ((?A Int) (?i Int) (?v Int)) (= (select1 (store1 ?A ?i ?v) ?i) ?v)))
(assert (forall ((?A Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A ?i ?v) ?j) (select1 ?A ?j)))))
(assert (forall ((?A Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A ?o ?f ?v) ?o ?f) ?v)))
(assert (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g)))))
(assert (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolIff ?x ?y) Smt.true) (= (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolImplies ?x ?y) Smt.true) (=> (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolAnd ?x ?y) Smt.true) (and (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolOr ?x ?y) Smt.true) (or (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int)) (! (= (= (boolNot ?x) Smt.true) (not (= ?x Smt.true))) :pattern ((boolNot ?x)) )))
(assert (forall ((?x Int) (?y Int)) (= (= (anyEqual ?x ?y) Smt.true) (= ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (! (= (= (anyNeq ?x ?y) Smt.true) (not (= ?x ?y))) :pattern ((anyNeq ?x ?y)) )))
(assert (forall ((?x Int) (?y Int)) (= (= (intLess ?x ?y) Smt.true) (< ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (= (= (intAtMost ?x ?y) Smt.true) (<= ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (= (= (intAtLeast ?x ?y) Smt.true) (>= ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (= (= (intGreater ?x ?y) Smt.true) (> ?x ?y))))
(assert (distinct Smt.false Smt.true))
(assert (forall ((?t Int)) (! (subtypes ?t ?t) :pattern ((subtypes ?t ?t)) )))
(assert (forall ((?t Int) (?u Int) (?v Int)) (! (=> (and (subtypes ?t ?u) (subtypes ?u ?v)) (subtypes ?t ?v)) :pattern ((subtypes ?t ?u) (subtypes ?u ?v)) )))
(assert (forall ((?t Int) (?u Int)) (! (=> (and (subtypes ?t ?u) (subtypes ?u ?t)) (= ?t ?u)) :pattern ((subtypes ?t ?u) (subtypes ?u ?t)) )))
(assert (let ((?v_1 (select2 Heap this FIELD))) (let ((?v_0 (= x_0 ?v_1))) (let ((?v_17 (=> ?v_0 (=> ?v_0 true))) (?v_19 (= start_correct Smt.true)) (?v_8 (and ?v_0 (= x_0 y_0)))) (let ((?v_10 (=> ?v_8 true)) (?v_20 (= else_correct Smt.true)) (?v_21 (= else_2_join_correct Smt.true)) (?v_4 (= y_1 x_0)) (?v_2 (select2 Heap_1 this FIELD))) (let ((?v_5 (= x_0 ?v_2))) (let ((?v_3 (and ?v_5 (= x_0 y_1)))) (let ((?v_6 (=> ?v_3 true)) (?v_22 (= join_correct Smt.true)) (?v_23 (= JoinCheck_correct Smt.true)) (?v_24 (= JoinCheck_2_GeneratedUnifiedExit_correct Smt.true)) (?v_7 (=> true true)) (?v_25 (= GeneratedUnifiedExit_correct Smt.true)) (?v_26 (= ReallyLastGeneratedExit_correct Smt.true)) (?v_9 (= y_0 x_0)) (?v_27 (= ElseCheck_correct Smt.true)) (?v_18 (= Heap_2 Heap)) (?v_28 (= ElseCheck_2_GeneratedUnifiedExit_correct Smt.true)) (?v_14 (select2 Heap_0 this OTHERFIELD))) (let ((?v_16 (= 2 ?v_14)) (?v_13 (= x_0 (select2 Heap_0 this FIELD))) (?v_12 (= x_0 x_0))) (let ((?v_11 (and ?v_16 ?v_13 ?v_12)) (?v_29 (= then_correct Smt.true)) (?v_30 (= then_2_join_correct Smt.true)) (?v_15 (= ?v_14 2)) (?v_31 (= ThenCheck_correct Smt.true)) (?v_32 (= ThenCheck_2_GeneratedUnifiedExit_correct Smt.true)) (?v_33 (= StartCheck_correct Smt.true)) (?v_34 (= StartCheck_2_GeneratedUnifiedExit_correct Smt.true))) (not (=> (and (=> (=> true (=> true ?v_17)) ?v_19) (=> (=> true (=> ?v_0 (=> (= y_0 ?v_1) ?v_10))) ?v_20) (=> (=> true (=> (= Heap_1 Heap) (=> (= y_1 y_0) true))) ?v_21) (=> (=> true (=> (and ?v_4 (= y_1 ?v_2)) ?v_6)) ?v_22) (=> (=> true (=> ?v_3 (and ?v_4 ?v_5 (=> (and ?v_4 ?v_5) ?v_6)))) ?v_23) (=> (=> true (=> (= Heap_2 Heap_1) (=> (= y_2 y_1) true))) ?v_24) (=> ?v_7 ?v_25) (=> ?v_7 ?v_26) (=> (=> true (=> ?v_8 (and ?v_9 ?v_0 (=> (and ?v_9 ?v_0) ?v_10)))) ?v_27) (=> (=> true (=> ?v_18 (=> (= y_2 y_0) true))) ?v_28) (=> (=> true (=> ?v_0 (=> (= Heap_0 (store2 Heap this OTHERFIELD 2)) (=> ?v_11 true)))) ?v_29) (=> (=> true (=> (= Heap_1 Heap_0) (=> ?v_4 true))) ?v_30) (=> (=> true (=> ?v_11 (and ?v_12 ?v_13 ?v_15 (=> (and ?v_12 ?v_13 ?v_15) (=> (and ?v_16 ?v_12 ?v_13) true))))) ?v_31) (=> (=> true (=> (= Heap_2 Heap_0) (=> (= y_2 x_0) true))) ?v_32) (=> (=> true (=> ?v_0 (and ?v_0 ?v_17))) ?v_33) (=> (=> true (=> ?v_18 (=> (= y_2 y) true))) ?v_34)) (and ?v_19 ?v_20 ?v_21 ?v_22 ?v_23 ?v_24 ?v_25 ?v_26 ?v_27 ?v_28 ?v_29 ?v_30 ?v_31 ?v_32 ?v_33 ?v_34)))))))))))))
(check-sat)
(exit)
