(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sls/sls_copy.spl:50:5-6:An invariant might not be maintained by a loop in procedure copy
  tests/spl/sls/sls_copy.spl:36:16:Related location: This is the loop invariant that might not be maintained
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldInt Loc) Int)
(declare-fun read$1 (FldLoc Loc) Loc)
(declare-fun write$0 (FldInt Loc Int) FldInt)
(declare-fun write$1 (FldLoc Loc Loc) FldLoc)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetLoc)
(declare-fun setenum$0 (Loc) SetLoc)
(declare-fun union$0 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun in$0 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Alloc_3$0 () SetLoc)
(declare-fun Axiom_54$0 () Bool)
(declare-fun Axiom_55$0 () Bool)
(declare-fun Axiom_56$0 () Bool)
(declare-fun Axiom_57$0 () Bool)
(declare-fun Axiom_58$0 () Bool)
(declare-fun Axiom_59$0 () Bool)
(declare-fun Axiom_60$0 () Bool)
(declare-fun Axiom_61$0 () Bool)
(declare-fun Axiom_62$0 () Bool)
(declare-fun Axiom_63$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_4$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_2$0 () SetLoc)
(declare-fun cp_4$0 () Loc)
(declare-fun cp_5$0 () Loc)
(declare-fun cp_init$0 () Loc)
(declare-fun curr_4$0 () Loc)
(declare-fun curr_5$0 () Loc)
(declare-fun curr_init$0 () Loc)
(declare-fun data$0 () FldInt)
(declare-fun data_3$0 () FldInt)
(declare-fun lslseg_domain$0 (FldInt FldLoc Loc Loc Int) SetLoc)
(declare-fun lslseg_struct$0 (SetLoc FldInt FldLoc Loc Loc Int) Bool)
(declare-fun lst_2$0 () Loc)
(declare-fun lst_init$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun next_3$0 () FldLoc)
(declare-fun next_4$0 () FldLoc)
(declare-fun old_cp_2$0 () Loc)
(declare-fun old_cp_4$0 () Loc)
(declare-fun old_cp_init$0 () Loc)
(declare-fun res_5$0 () Loc)
(declare-fun res_init$0 () Loc)
(declare-fun sk_?X_116$0 () SetLoc)
(declare-fun sk_?X_117$0 () SetLoc)
(declare-fun sk_?X_118$0 () SetLoc)
(declare-fun sk_?X_119$0 () SetLoc)
(declare-fun sk_?X_120$0 () SetLoc)
(declare-fun sk_?X_121$0 () SetLoc)
(declare-fun sk_?X_122$0 () SetLoc)
(declare-fun sk_?X_123$0 () SetLoc)
(declare-fun sk_?X_124$0 () SetLoc)
(declare-fun sk_?X_125$0 () SetLoc)
(declare-fun sk_?X_126$0 () SetLoc)
(declare-fun sk_?X_127$0 () SetLoc)
(declare-fun sk_?X_128$0 () SetLoc)
(declare-fun sk_?X_129$0 () SetLoc)
(declare-fun sk_?X_130$0 () SetLoc)
(declare-fun sk_?X_131$0 () SetLoc)
(declare-fun sk_?X_132$0 () SetLoc)
(declare-fun sk_?X_133$0 () SetLoc)
(declare-fun sk_?X_134$0 () SetLoc)
(declare-fun sk_?X_135$0 () SetLoc)
(declare-fun sk_FP_1$0 () SetLoc)
(declare-fun sk_l1_3$0 () Loc)
(declare-fun sk_l2_3$0 () Loc)
(declare-fun slseg_domain$0 (FldInt FldLoc Loc Loc) SetLoc)
(declare-fun slseg_struct$0 (SetLoc FldInt FldLoc Loc Loc) Bool)
(declare-fun t_70$0 () Int)
(declare-fun t_71$0 () Int)
(declare-fun t_72$0 () Int)
(declare-fun t_73$0 () Int)
(declare-fun t_74$0 () Int)
(declare-fun t_75$0 () Int)
(declare-fun t_76$0 () Loc)
(declare-fun t_77$0 () Loc)
(declare-fun t_78$0 () Loc)
(declare-fun t_79$0 () Loc)
(declare-fun t_80$0 () Loc)
(declare-fun t_81$0 () Loc)
(declare-fun t_82$0 () Int)
(declare-fun t_83$0 () Int)
(declare-fun t_84$0 () Int)
(declare-fun t_85$0 () Loc)
(declare-fun t_86$0 () Loc)
(declare-fun t_87$0 () Loc)
(declare-fun tmp_4$0 () Loc)
(declare-fun tmp_5$0 () Loc)
(declare-fun tmp_init$0 () Loc)

(assert (= (read$1 next_3$0 cp_5$0) t_87$0))

(assert (= (read$1 next$0 old_cp_4$0) t_86$0))

(assert (= (read$1 next$0 cp_5$0) t_85$0))

(assert (= (read$0 data$0 sk_l2_3$0) t_84$0))

(assert (= (read$0 data$0 sk_l1_3$0) t_83$0))

(assert (= (read$0 data$0 cp_5$0) t_82$0))

(assert (= (read$1 (write$1 next_3$0 cp_5$0 null$0) curr_4$0) t_81$0))

(assert (= (read$1 (write$1 next_3$0 cp_5$0 null$0) cp_5$0) t_80$0))

(assert (= (read$1 (write$1 next$0 old_cp_4$0 cp_5$0) old_cp_4$0) t_79$0))

(assert (= (read$1 (write$1 next$0 old_cp_4$0 cp_5$0) curr_4$0) t_78$0))

(assert (= (read$1 (write$1 next$0 old_cp_4$0 cp_5$0) cp_init$0) t_77$0))

(assert (= (read$1 (write$1 next$0 old_cp_4$0 cp_5$0) cp_5$0) t_76$0))

(assert (= (read$0 (write$0 data$0 cp_5$0 (read$0 data$0 curr_5$0)) sk_l2_3$0)
  t_75$0))

(assert (= (read$0 (write$0 data$0 cp_5$0 (read$0 data$0 curr_5$0)) sk_l1_3$0)
  t_74$0))

(assert (= (read$0 (write$0 data$0 cp_5$0 (read$0 data$0 curr_5$0)) curr_init$0)
  t_73$0))

(assert (= (read$0 (write$0 data$0 cp_5$0 (read$0 data$0 curr_5$0)) curr_5$0) t_72$0))

(assert (= (read$0 (write$0 data$0 cp_5$0 (read$0 data$0 curr_5$0)) cp_init$0)
  t_71$0))

(assert (= (read$0 (write$0 data$0 cp_5$0 (read$0 data$0 curr_5$0)) cp_5$0) t_70$0))

(assert (forall ((?d_36 Loc) (?x Loc) (?y Loc))
        (or (= ?y ?x)
            (= (read$1 next_3$0 ?y) (read$1 (write$1 next_3$0 ?x ?d_36) ?y)))))

(assert (forall ((?d_36 Loc) (?x Loc))
        (= (read$1 (write$1 next_3$0 ?x ?d_36) ?x) ?d_36)))

(assert (forall ((?d_35 Loc) (?x Loc) (?y Loc))
        (or (= ?y ?x)
            (= (read$1 next$0 ?y) (read$1 (write$1 next$0 ?x ?d_35) ?y)))))

(assert (forall ((?d_35 Loc) (?x Loc))
        (= (read$1 (write$1 next$0 ?x ?d_35) ?x) ?d_35)))

(assert (forall ((?d_34 Int) (?x Loc) (?y Loc))
        (or (= ?y ?x)
            (= (read$0 data$0 ?y) (read$0 (write$0 data$0 ?x ?d_34) ?y)))))

(assert (forall ((?d_34 Int) (?x Loc))
        (= (read$0 (write$0 data$0 ?x ?d_34) ?x) ?d_34)))

(assert (forall ((?f FldLoc)) (= (read$1 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Loc)) (not (in$0 x emptyset$0))))

(assert (or (not Axiom_54$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data$0 l1) (read$0 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0))
                (not (in$0 l1 sk_?X_124$0)) (not (in$0 l2 sk_?X_124$0))))))

(assert (or
    (and (Btwn$0 next$0 lst_init$0 curr_init$0 curr_init$0) Axiom_56$0
         Axiom_55$0)
    (not
         (lslseg_struct$0 sk_?X_125$0 data$0 next$0 lst_init$0 curr_init$0
           (read$0 data$0 curr_init$0)))))

(assert (or (not Axiom_57$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data$0 l1) (read$0 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 cp_init$0))
                (not (in$0 l1 sk_?X_122$0)) (not (in$0 l2 sk_?X_122$0))))))

(assert (or (not Axiom_58$0)
    (forall ((l1 Loc))
            (or (<= (read$0 data$0 l1) (read$0 data$0 curr_init$0))
                (not (in$0 l1 sk_?X_122$0))))))

(assert (or (and (Btwn$0 next_4$0 curr_5$0 null$0 null$0) Axiom_59$0)
    (not (slseg_struct$0 sk_?X_134$0 data_3$0 next_4$0 curr_5$0 null$0))))

(assert (or (not Axiom_60$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data_3$0 l1) (read$0 data_3$0 l2))
                (not (Btwn$0 next_4$0 l1 l2 curr_5$0))
                (not (in$0 l1 sk_?X_135$0)) (not (in$0 l2 sk_?X_135$0))))))

(assert (or (not Axiom_61$0)
    (forall ((l1 Loc))
            (or (<= (read$0 data_3$0 l1) (read$0 data_3$0 curr_5$0))
                (not (in$0 l1 sk_?X_135$0))))))

(assert (or (and (Btwn$0 next_4$0 res_5$0 cp_5$0 cp_5$0) Axiom_63$0 Axiom_62$0)
    (not
         (lslseg_struct$0 sk_?X_132$0 data_3$0 next_4$0 res_5$0 cp_5$0
           (read$0 data_3$0 curr_5$0)))))

(assert (= FP_4$0 (union$0 FP$0 (setenum$0 tmp_5$0))))

(assert (= cp_4$0 cp_init$0))

(assert (= curr_4$0 curr_init$0))

(assert (= data_3$0 (write$0 data$0 cp_5$0 (read$0 data$0 curr_5$0))))

(assert (= next_3$0 (write$1 next$0 old_cp_4$0 cp_5$0)))

(assert (= old_cp_2$0 old_cp_init$0))

(assert (= res_5$0 res_init$0))

(assert (= Alloc$0 (union$0 FP_Caller$0 Alloc$0)))

(assert (= (read$1 next$0 cp_init$0) null$0))

(assert (= emptyset$0 (intersection$0 sk_?X_121$0 sk_?X_119$0)))

(assert (= emptyset$0 (intersection$0 sk_?X_125$0 sk_?X_124$0)))

(assert (= sk_?X_116$0 FP$0))

(assert (= sk_?X_118$0 (union$0 sk_?X_121$0 sk_?X_119$0)))

(assert (= sk_?X_120$0 (setenum$0 cp_init$0)))

(assert (= sk_?X_122$0
  (lslseg_domain$0 data$0 next$0 res_init$0 cp_init$0
    (read$0 data$0 curr_init$0))))

(assert (= sk_?X_124$0 (slseg_domain$0 data$0 next$0 curr_init$0 null$0)))

(assert (= FP_Caller$0 (union$0 FP$0 FP_Caller$0)))

(assert (lslseg_struct$0 sk_?X_125$0 data$0 next$0 lst_init$0 curr_init$0
  (read$0 data$0 curr_init$0)))

(assert (not (= curr_init$0 null$0)))

(assert (= sk_?X_127$0 sk_?X_128$0))

(assert (= sk_?X_129$0 sk_?X_130$0))

(assert (= sk_?X_131$0 (union$0 sk_?X_133$0 sk_?X_132$0)))

(assert (= sk_?X_133$0 (union$0 sk_?X_135$0 sk_?X_134$0)))

(assert (= sk_?X_135$0
  (lslseg_domain$0 data_3$0 next_4$0 lst_2$0 curr_5$0
    (read$0 data_3$0 curr_5$0))))

(assert (or (= curr_5$0 null$0)
    (in$0 sk_l1_3$0 (intersection$0 sk_?X_131$0 sk_?X_129$0))
    (in$0 sk_l1_3$0 (intersection$0 sk_?X_135$0 sk_?X_134$0))
    (in$0 sk_l2_3$0 (intersection$0 sk_?X_133$0 sk_?X_132$0))
    (and (in$0 sk_l1_3$0 sk_?X_132$0)
         (not (<= (read$0 data_3$0 sk_l1_3$0) (read$0 data_3$0 curr_5$0))))
    (and (in$0 sk_l2_3$0 sk_?X_135$0)
         (not (<= (read$0 data_3$0 sk_l2_3$0) (read$0 data_3$0 curr_5$0))))
    (and (in$0 sk_l2_3$0 sk_FP_1$0) (not (in$0 sk_l2_3$0 FP_4$0)))
    (not (= (read$0 data_3$0 cp_5$0) (read$0 data_3$0 curr_5$0)))
    (not (= (read$1 next_4$0 cp_5$0) null$0))
    (not (Btwn$0 next_4$0 curr_5$0 null$0 null$0))
    (not (Btwn$0 next_4$0 lst_2$0 curr_5$0 curr_5$0))
    (not (Btwn$0 next_4$0 res_5$0 cp_5$0 cp_5$0))
    (and (Btwn$0 next_4$0 sk_l1_3$0 sk_l2_3$0 cp_5$0)
         (in$0 sk_l1_3$0 sk_?X_132$0) (in$0 sk_l2_3$0 sk_?X_132$0)
         (not (<= (read$0 data_3$0 sk_l1_3$0) (read$0 data_3$0 sk_l2_3$0))))
    (and (Btwn$0 next_4$0 sk_l1_3$0 sk_l2_3$0 curr_5$0)
         (in$0 sk_l1_3$0 sk_?X_135$0) (in$0 sk_l2_3$0 sk_?X_135$0)
         (not (<= (read$0 data_3$0 sk_l1_3$0) (read$0 data_3$0 sk_l2_3$0))))
    (and (Btwn$0 next_4$0 sk_l2_3$0 sk_l1_3$0 null$0)
         (in$0 sk_l1_3$0 sk_?X_134$0) (in$0 sk_l2_3$0 sk_?X_134$0)
         (not (<= (read$0 data_3$0 sk_l2_3$0) (read$0 data_3$0 sk_l1_3$0))))))

(assert (not (= tmp_5$0 null$0)))

(assert (not (in$0 tmp_5$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_init$0 l1 curr_init$0)
                 (in$0 l1
                   (lslseg_domain$0 data$0 next$0 lst_init$0 curr_init$0
                     (read$0 data$0 curr_init$0)))
                 (not (= l1 curr_init$0)))
            (and
                 (or (= l1 curr_init$0)
                     (not (Btwn$0 next$0 lst_init$0 l1 curr_init$0)))
                 (not
                      (in$0 l1
                        (lslseg_domain$0 data$0 next$0 lst_init$0 curr_init$0
                          (read$0 data$0 curr_init$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_4$0 curr_5$0 l1 null$0)
                 (in$0 l1 (slseg_domain$0 data_3$0 next_4$0 curr_5$0 null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next_4$0 curr_5$0 l1 null$0)))
                 (not
                      (in$0 l1
                        (slseg_domain$0 data_3$0 next_4$0 curr_5$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_4$0 res_5$0 l1 cp_5$0)
                 (in$0 l1
                   (lslseg_domain$0 data_3$0 next_4$0 res_5$0 cp_5$0
                     (read$0 data_3$0 curr_5$0)))
                 (not (= l1 cp_5$0)))
            (and (or (= l1 cp_5$0) (not (Btwn$0 next_4$0 res_5$0 l1 cp_5$0)))
                 (not
                      (in$0 l1
                        (lslseg_domain$0 data_3$0 next_4$0 res_5$0 cp_5$0
                          (read$0 data_3$0 curr_5$0))))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$0 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (and (Btwn$0 next$0 curr_init$0 null$0 null$0) Axiom_54$0)
    (not (slseg_struct$0 sk_?X_124$0 data$0 next$0 curr_init$0 null$0))))

(assert (or (not Axiom_55$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data$0 l1) (read$0 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_init$0))
                (not (in$0 l1 sk_?X_125$0)) (not (in$0 l2 sk_?X_125$0))))))

(assert (or (not Axiom_56$0)
    (forall ((l1 Loc))
            (or (<= (read$0 data$0 l1) (read$0 data$0 curr_init$0))
                (not (in$0 l1 sk_?X_125$0))))))

(assert (or
    (and (Btwn$0 next$0 res_init$0 cp_init$0 cp_init$0) Axiom_58$0
         Axiom_57$0)
    (not
         (lslseg_struct$0 sk_?X_122$0 data$0 next$0 res_init$0 cp_init$0
           (read$0 data$0 curr_init$0)))))

(assert (or (not Axiom_59$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data_3$0 l1) (read$0 data_3$0 l2))
                (not (Btwn$0 next_4$0 l1 l2 null$0))
                (not (in$0 l1 sk_?X_134$0)) (not (in$0 l2 sk_?X_134$0))))))

(assert (or (and (Btwn$0 next_4$0 lst_2$0 curr_5$0 curr_5$0) Axiom_61$0 Axiom_60$0)
    (not
         (lslseg_struct$0 sk_?X_135$0 data_3$0 next_4$0 lst_2$0 curr_5$0
           (read$0 data_3$0 curr_5$0)))))

(assert (or (not Axiom_62$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data_3$0 l1) (read$0 data_3$0 l2))
                (not (Btwn$0 next_4$0 l1 l2 cp_5$0))
                (not (in$0 l1 sk_?X_132$0)) (not (in$0 l2 sk_?X_132$0))))))

(assert (or (not Axiom_63$0)
    (forall ((l1 Loc))
            (or (<= (read$0 data_3$0 l1) (read$0 data_3$0 curr_5$0))
                (not (in$0 l1 sk_?X_132$0))))))

(assert (= Alloc_3$0 (union$0 Alloc$0 (setenum$0 tmp_5$0))))

(assert (= FP_Caller_2$0 (setminus$0 FP_Caller$0 FP$0)))

(assert (= cp_5$0 tmp_5$0))

(assert (= curr_5$0 (read$1 next_3$0 curr_4$0)))

(assert (= lst_2$0 lst_init$0))

(assert (= next_4$0 (write$1 next_3$0 cp_5$0 null$0)))

(assert (= old_cp_4$0 cp_4$0))

(assert (= tmp_4$0 tmp_init$0))

(assert (= (read$0 data$0 cp_init$0) (read$0 data$0 curr_init$0)))

(assert (= emptyset$0 emptyset$0))

(assert (= emptyset$0 (intersection$0 sk_?X_123$0 sk_?X_122$0)))

(assert (= sk_?X_116$0 sk_?X_117$0))

(assert (= sk_?X_117$0 sk_?X_118$0))

(assert (= sk_?X_119$0 sk_?X_120$0))

(assert (= sk_?X_121$0 (union$0 sk_?X_123$0 sk_?X_122$0)))

(assert (= sk_?X_123$0 (union$0 sk_?X_125$0 sk_?X_124$0)))

(assert (= sk_?X_125$0
  (lslseg_domain$0 data$0 next$0 lst_init$0 curr_init$0
    (read$0 data$0 curr_init$0))))

(assert (lslseg_struct$0 sk_?X_122$0 data$0 next$0 res_init$0 cp_init$0
  (read$0 data$0 curr_init$0)))

(assert (slseg_struct$0 sk_?X_124$0 data$0 next$0 curr_init$0 null$0))

(assert (= sk_?X_126$0 sk_?X_127$0))

(assert (= sk_?X_128$0 (union$0 sk_?X_131$0 sk_?X_129$0)))

(assert (= sk_?X_130$0 (setenum$0 cp_5$0)))

(assert (= sk_?X_132$0
  (lslseg_domain$0 data_3$0 next_4$0 res_5$0 cp_5$0
    (read$0 data_3$0 curr_5$0))))

(assert (= sk_?X_134$0 (slseg_domain$0 data_3$0 next_4$0 curr_5$0 null$0)))

(assert (= sk_FP_1$0 sk_?X_126$0))

(assert (not (= (read$1 next$0 curr_4$0) null$0)))

(assert (not (in$0 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_init$0 l1 null$0)
                 (in$0 l1 (slseg_domain$0 data$0 next$0 curr_init$0 null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next$0 curr_init$0 l1 null$0)))
                 (not
                      (in$0 l1
                        (slseg_domain$0 data$0 next$0 curr_init$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 res_init$0 l1 cp_init$0)
                 (in$0 l1
                   (lslseg_domain$0 data$0 next$0 res_init$0 cp_init$0
                     (read$0 data$0 curr_init$0)))
                 (not (= l1 cp_init$0)))
            (and
                 (or (= l1 cp_init$0)
                     (not (Btwn$0 next$0 res_init$0 l1 cp_init$0)))
                 (not
                      (in$0 l1
                        (lslseg_domain$0 data$0 next$0 res_init$0 cp_init$0
                          (read$0 data$0 curr_init$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_4$0 lst_2$0 l1 curr_5$0)
                 (in$0 l1
                   (lslseg_domain$0 data_3$0 next_4$0 lst_2$0 curr_5$0
                     (read$0 data_3$0 curr_5$0)))
                 (not (= l1 curr_5$0)))
            (and
                 (or (= l1 curr_5$0)
                     (not (Btwn$0 next_4$0 lst_2$0 l1 curr_5$0)))
                 (not
                      (in$0 l1
                        (lslseg_domain$0 data_3$0 next_4$0 lst_2$0 curr_5$0
                          (read$0 data_3$0 curr_5$0))))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$0 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$0 ?y ?X))
            (in$0 (ep$0 ?f ?X ?x) ?X))))

(assert (forall ((?u Loc) (?v Loc) (?z Loc))
        (and
             (or (Btwn$0 (write$1 next$0 old_cp_4$0 cp_5$0) ?z ?u ?v)
                 (not
                      (or
                          (and (Btwn$0 next$0 ?z ?u ?v)
                               (or (Btwn$0 next$0 ?z ?v old_cp_4$0)
                                   (and (Btwn$0 next$0 ?z ?v ?v)
                                        (not
                                             (Btwn$0 next$0 ?z old_cp_4$0
                                               old_cp_4$0)))))
                          (and (not (= old_cp_4$0 ?v))
                               (or (Btwn$0 next$0 ?z old_cp_4$0 ?v)
                                   (and
                                        (Btwn$0 next$0 ?z old_cp_4$0
                                          old_cp_4$0)
                                        (not (Btwn$0 next$0 ?z ?v ?v))))
                               (Btwn$0 next$0 ?z ?u old_cp_4$0)
                               (or (Btwn$0 next$0 cp_5$0 ?v old_cp_4$0)
                                   (and (Btwn$0 next$0 cp_5$0 ?v ?v)
                                        (not
                                             (Btwn$0 next$0 cp_5$0 old_cp_4$0
                                               old_cp_4$0)))))
                          (and (not (= old_cp_4$0 ?v))
                               (or (Btwn$0 next$0 ?z old_cp_4$0 ?v)
                                   (and
                                        (Btwn$0 next$0 ?z old_cp_4$0
                                          old_cp_4$0)
                                        (not (Btwn$0 next$0 ?z ?v ?v))))
                               (Btwn$0 next$0 cp_5$0 ?u ?v)
                               (or (Btwn$0 next$0 cp_5$0 ?v old_cp_4$0)
                                   (and (Btwn$0 next$0 cp_5$0 ?v ?v)
                                        (not
                                             (Btwn$0 next$0 cp_5$0 old_cp_4$0
                                               old_cp_4$0))))))))
             (or
                 (and (Btwn$0 next$0 ?z ?u ?v)
                      (or (Btwn$0 next$0 ?z ?v old_cp_4$0)
                          (and (Btwn$0 next$0 ?z ?v ?v)
                               (not (Btwn$0 next$0 ?z old_cp_4$0 old_cp_4$0)))))
                 (and (not (= old_cp_4$0 ?v))
                      (or (Btwn$0 next$0 ?z old_cp_4$0 ?v)
                          (and (Btwn$0 next$0 ?z old_cp_4$0 old_cp_4$0)
                               (not (Btwn$0 next$0 ?z ?v ?v))))
                      (Btwn$0 next$0 ?z ?u old_cp_4$0)
                      (or (Btwn$0 next$0 cp_5$0 ?v old_cp_4$0)
                          (and (Btwn$0 next$0 cp_5$0 ?v ?v)
                               (not
                                    (Btwn$0 next$0 cp_5$0 old_cp_4$0
                                      old_cp_4$0)))))
                 (and (not (= old_cp_4$0 ?v))
                      (or (Btwn$0 next$0 ?z old_cp_4$0 ?v)
                          (and (Btwn$0 next$0 ?z old_cp_4$0 old_cp_4$0)
                               (not (Btwn$0 next$0 ?z ?v ?v))))
                      (Btwn$0 next$0 cp_5$0 ?u ?v)
                      (or (Btwn$0 next$0 cp_5$0 ?v old_cp_4$0)
                          (and (Btwn$0 next$0 cp_5$0 ?v ?v)
                               (not
                                    (Btwn$0 next$0 cp_5$0 old_cp_4$0
                                      old_cp_4$0)))))
                 (not (Btwn$0 (write$1 next$0 old_cp_4$0 cp_5$0) ?z ?u ?v))))))

(assert (forall ((?u Loc) (?v Loc) (?z Loc))
        (and
             (or (Btwn$0 (write$1 next_3$0 cp_5$0 null$0) ?z ?u ?v)
                 (not
                      (or
                          (and (Btwn$0 next_3$0 ?z ?u ?v)
                               (or (Btwn$0 next_3$0 ?z ?v cp_5$0)
                                   (and (Btwn$0 next_3$0 ?z ?v ?v)
                                        (not
                                             (Btwn$0 next_3$0 ?z cp_5$0
                                               cp_5$0)))))
                          (and (not (= cp_5$0 ?v))
                               (or (Btwn$0 next_3$0 ?z cp_5$0 ?v)
                                   (and (Btwn$0 next_3$0 ?z cp_5$0 cp_5$0)
                                        (not (Btwn$0 next_3$0 ?z ?v ?v))))
                               (Btwn$0 next_3$0 ?z ?u cp_5$0)
                               (or (Btwn$0 next_3$0 null$0 ?v cp_5$0)
                                   (and (Btwn$0 next_3$0 null$0 ?v ?v)
                                        (not
                                             (Btwn$0 next_3$0 null$0 cp_5$0
                                               cp_5$0)))))
                          (and (not (= cp_5$0 ?v))
                               (or (Btwn$0 next_3$0 ?z cp_5$0 ?v)
                                   (and (Btwn$0 next_3$0 ?z cp_5$0 cp_5$0)
                                        (not (Btwn$0 next_3$0 ?z ?v ?v))))
                               (Btwn$0 next_3$0 null$0 ?u ?v)
                               (or (Btwn$0 next_3$0 null$0 ?v cp_5$0)
                                   (and (Btwn$0 next_3$0 null$0 ?v ?v)
                                        (not
                                             (Btwn$0 next_3$0 null$0 cp_5$0
                                               cp_5$0))))))))
             (or
                 (and (Btwn$0 next_3$0 ?z ?u ?v)
                      (or (Btwn$0 next_3$0 ?z ?v cp_5$0)
                          (and (Btwn$0 next_3$0 ?z ?v ?v)
                               (not (Btwn$0 next_3$0 ?z cp_5$0 cp_5$0)))))
                 (and (not (= cp_5$0 ?v))
                      (or (Btwn$0 next_3$0 ?z cp_5$0 ?v)
                          (and (Btwn$0 next_3$0 ?z cp_5$0 cp_5$0)
                               (not (Btwn$0 next_3$0 ?z ?v ?v))))
                      (Btwn$0 next_3$0 ?z ?u cp_5$0)
                      (or (Btwn$0 next_3$0 null$0 ?v cp_5$0)
                          (and (Btwn$0 next_3$0 null$0 ?v ?v)
                               (not (Btwn$0 next_3$0 null$0 cp_5$0 cp_5$0)))))
                 (and (not (= cp_5$0 ?v))
                      (or (Btwn$0 next_3$0 ?z cp_5$0 ?v)
                          (and (Btwn$0 next_3$0 ?z cp_5$0 cp_5$0)
                               (not (Btwn$0 next_3$0 ?z ?v ?v))))
                      (Btwn$0 next_3$0 null$0 ?u ?v)
                      (or (Btwn$0 next_3$0 null$0 ?v cp_5$0)
                          (and (Btwn$0 next_3$0 null$0 ?v ?v)
                               (not (Btwn$0 next_3$0 null$0 cp_5$0 cp_5$0)))))
                 (not (Btwn$0 (write$1 next_3$0 cp_5$0 null$0) ?z ?u ?v))))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$1 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$1 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$1 ?f ?x) (read$1 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
