(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sl_sorted_set/delete.spl:51:8-15:This deallocation might be unsafe
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldLoc Loc) Loc)
(declare-fun read$1 (FldInt Loc) Int)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetInt)
(declare-fun emptyset$1 () SetLoc)
(declare-fun setenum$0 (Int) SetInt)
(declare-fun setenum$1 (Loc) SetLoc)
(declare-fun union$0 (SetInt SetInt) SetInt)
(declare-fun union$1 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetInt SetInt) SetInt)
(declare-fun intersection$1 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetInt SetInt) SetInt)
(declare-fun setminus$1 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun Frame$0 (SetLoc SetLoc FldInt FldInt) Bool)
(declare-fun Frame$1 (SetLoc SetLoc FldLoc FldLoc) Bool)
(declare-fun in$0 (Int SetInt) Bool)
(declare-fun in$1 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Axiom_8$0 () Bool)
(declare-fun Axiom_9$0 () Bool)
(declare-fun Axiom_10$0 () Bool)
(declare-fun Axiom_11$0 () Bool)
(declare-fun Axiom_12$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_1$0 () SetLoc)
(declare-fun FP_2$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_1$0 () SetLoc)
(declare-fun c1_2$0 () SetInt)
(declare-fun c1_3$0 () SetInt)
(declare-fun c2_2$0 () SetInt)
(declare-fun c2_3$0 () SetInt)
(declare-fun content$0 () SetInt)
(declare-fun content_1$0 () SetInt)
(declare-fun curr_2$0 () Loc)
(declare-fun curr_3$0 () Loc)
(declare-fun curr_4$0 () Loc)
(declare-fun data$0 () FldInt)
(declare-fun lst$0 () Loc)
(declare-fun lst_1$0 () Loc)
(declare-fun n_2$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun prev_2$0 () Loc)
(declare-fun prev_3$0 () Loc)
(declare-fun sk_?X_26$0 () SetLoc)
(declare-fun sk_?X_27$0 () SetLoc)
(declare-fun sk_?X_28$0 () SetLoc)
(declare-fun sk_?X_29$0 () SetLoc)
(declare-fun sk_?X_30$0 () SetLoc)
(declare-fun sk_?X_31$0 () SetLoc)
(declare-fun sk_?X_32$0 () SetLoc)
(declare-fun sk_?X_33$0 () SetLoc)
(declare-fun sk_?X_34$0 () SetLoc)
(declare-fun sk_?X_35$0 () SetLoc)
(declare-fun sk_?X_36$0 () SetLoc)
(declare-fun sk_?X_37$0 () SetLoc)
(declare-fun sk_?X_38$0 () SetLoc)
(declare-fun sk_?X_39$0 () SetLoc)
(declare-fun sk_?X_40$0 () SetLoc)
(declare-fun sk_?X_41$0 () SetLoc)
(declare-fun sk_?X_42$0 () SetLoc)
(declare-fun sorted_set_c$0 (FldInt FldLoc Loc Loc) SetInt)
(declare-fun sorted_set_domain$0 (FldInt FldLoc Loc Loc) SetLoc)
(declare-fun sorted_set_struct$0 (SetLoc FldInt FldLoc Loc Loc SetInt) Bool)
(declare-fun t_149$0 () Int)
(declare-fun t_150$0 () Int)
(declare-fun t_151$0 () Int)
(declare-fun t_152$0 () Int)
(declare-fun t_153$0 () Int)
(declare-fun t_154$0 () Int)
(declare-fun t_155$0 () Int)
(declare-fun t_156$0 () Int)
(declare-fun t_157$0 () Int)
(declare-fun t_158$0 () Int)
(declare-fun t_159$0 () Int)
(declare-fun t_160$0 () Int)
(declare-fun t_161$0 () Int)
(declare-fun t_162$0 () Int)
(declare-fun t_163$0 () Int)
(declare-fun t_164$0 () Int)
(declare-fun t_165$0 () Int)
(declare-fun t_166$0 () Int)
(declare-fun t_167$0 () Int)
(declare-fun t_168$0 () Int)
(declare-fun t_169$0 () Int)
(declare-fun t_170$0 () Int)
(declare-fun t_171$0 () Int)
(declare-fun t_172$0 () Int)
(declare-fun t_173$0 () Int)
(declare-fun t_174$0 () Int)
(declare-fun t_175$0 () Int)
(declare-fun t_176$0 () Int)
(declare-fun t_177$0 () Int)
(declare-fun t_178$0 () Int)
(declare-fun t_179$0 () Loc)
(declare-fun t_180$0 () Loc)
(declare-fun t_181$0 () Loc)
(declare-fun t_182$0 () Loc)
(declare-fun t_183$0 () Loc)
(declare-fun t_184$0 () Loc)
(declare-fun t_185$0 () Loc)
(declare-fun t_186$0 () Loc)
(declare-fun t_187$0 () Loc)
(declare-fun t_188$0 () Loc)
(declare-fun t_189$0 () Loc)
(declare-fun t_190$0 () Loc)
(declare-fun t_191$0 () Loc)
(declare-fun t_192$0 () Loc)
(declare-fun t_193$0 () Loc)
(declare-fun t_194$0 () Loc)
(declare-fun t_195$0 () Loc)
(declare-fun t_196$0 () Loc)
(declare-fun t_197$0 () Loc)
(declare-fun t_198$0 () Loc)
(declare-fun t_199$0 () Loc)
(declare-fun t_200$0 () Loc)
(declare-fun t_201$0 () Loc)
(declare-fun t_202$0 () Loc)
(declare-fun t_203$0 () Loc)
(declare-fun t_204$0 () Loc)
(declare-fun t_205$0 () Loc)
(declare-fun t_206$0 () Loc)
(declare-fun t_207$0 () Loc)
(declare-fun t_208$0 () Loc)
(declare-fun t_209$0 () Loc)
(declare-fun t_210$0 () Loc)
(declare-fun t_211$0 () Loc)
(declare-fun t_212$0 () Loc)
(declare-fun t_213$0 () Loc)
(declare-fun t_214$0 () Loc)
(declare-fun t_215$0 () Loc)
(declare-fun t_216$0 () Loc)
(declare-fun t_217$0 () Loc)
(declare-fun t_218$0 () Loc)
(declare-fun t_219$0 () Loc)
(declare-fun t_220$0 () Loc)
(declare-fun t_221$0 () Loc)
(declare-fun t_222$0 () Loc)
(declare-fun t_223$0 () Loc)
(declare-fun t_224$0 () Loc)
(declare-fun t_225$0 () Loc)
(declare-fun t_226$0 () Loc)
(declare-fun t_227$0 () Loc)
(declare-fun t_228$0 () Loc)
(declare-fun t_229$0 () Loc)
(declare-fun t_230$0 () Loc)
(declare-fun t_231$0 () Loc)
(declare-fun t_232$0 () Loc)
(declare-fun t_233$0 () Loc)
(declare-fun t_234$0 () Loc)
(declare-fun t_235$0 () Loc)
(declare-fun t_236$0 () Loc)
(declare-fun t_237$0 () Loc)
(declare-fun t_238$0 () Loc)
(declare-fun t_239$0 () Loc)
(declare-fun t_240$0 () Loc)
(declare-fun t_241$0 () Loc)
(declare-fun t_242$0 () Loc)
(declare-fun t_243$0 () Loc)
(declare-fun t_244$0 () Loc)
(declare-fun val$0 () Int)
(declare-fun val_1$0 () Int)
(declare-fun witness$0 (FldInt Int SetInt) Loc)

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_244$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_243$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_242$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_241$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_240$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_239$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_238$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_237$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_236$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_235$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_234$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_233$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_232$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_231$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_230$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_229$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_228$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_227$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_226$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_225$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_224$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_223$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_222$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_221$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_220$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_219$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_218$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_217$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_216$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_215$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_214$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_213$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_212$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_211$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_210$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_209$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_208$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_207$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_206$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_205$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_204$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_203$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_202$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_201$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_200$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_199$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_198$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_197$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_196$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_195$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_194$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_193$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_192$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_191$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_190$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_189$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_188$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_187$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_186$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_185$0))

(assert (= (ep$0 next$0 FP_1$0 n_2$0) t_184$0))

(assert (= (ep$0 next$0 FP_1$0 lst_1$0) t_183$0))

(assert (= (ep$0 next$0 FP_1$0 lst$0) t_182$0))

(assert (= (ep$0 next$0 FP_1$0 curr_3$0) t_181$0))

(assert (= (ep$0 next$0 FP_1$0 curr_2$0) t_180$0))

(assert (= (ep$0 next$0 FP_1$0 null$0) t_179$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_178$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_177$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_176$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_175$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_174$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_173$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_172$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_171$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_170$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_169$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_168$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_167$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_166$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_165$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_164$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_163$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_162$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_161$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_160$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_159$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_158$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_157$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_156$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_155$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_154$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_153$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_152$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_151$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_150$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_149$0))

(assert (forall ((?f FldLoc)) (= (read$0 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$1 x (setenum$1 y)))
            (and (not (= x y)) (not (in$1 x (setenum$1 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x (setminus$1 X Y)) (not (in$1 x Y)))
            (and (or (in$1 x Y) (not (in$1 x X)))
                 (not (in$1 x (setminus$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x Y) (in$1 x (intersection$1 X Y)))
            (and (or (not (in$1 x X)) (not (in$1 x Y)))
                 (not (in$1 x (intersection$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x (union$1 X Y)) (or (in$1 x X) (in$1 x Y)))
            (and (not (in$1 x X)) (not (in$1 x Y))
                 (not (in$1 x (union$1 X Y)))))))

(assert (forall ((x Loc)) (not (in$1 x emptyset$1))))

(assert (forall ((x Int) (y Int))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Int)) (not (in$0 x emptyset$0))))

(assert (or (and (Btwn$0 next$0 curr_2$0 null$0 null$0) Axiom_8$0)
    (not
         (sorted_set_struct$0 sk_?X_39$0 data$0 next$0 curr_2$0 null$0
           c1_2$0))))

(assert (or (not Axiom_9$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_28$0))
                (not (in$1 l2 sk_?X_28$0))))))

(assert (or (and (Btwn$0 next$0 lst$0 null$0 null$0) Axiom_10$0)
    (not
         (sorted_set_struct$0 sk_?X_42$0 data$0 next$0 lst$0 null$0
           content$0))))

(assert (or (not Axiom_11$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_2$0))
                (not (in$1 l1 sk_?X_41$0)) (not (in$1 l2 sk_?X_41$0))))))

(assert (or (and (Btwn$0 next$0 lst_1$0 curr_3$0 curr_3$0) Axiom_12$0)
    (not
         (sorted_set_struct$0 sk_?X_26$0 data$0 next$0 lst_1$0 curr_3$0
           c2_3$0))))

(assert (= FP_2$0
  (union$1 (setminus$1 FP$0 FP_1$0)
    (union$1 (intersection$1 Alloc$0 FP_1$0) (setminus$1 Alloc$0 Alloc$0)))))

(assert (= c1_2$0 content$0))

(assert (= content_1$0 content$0))

(assert (= curr_4$0 (read$0 next$0 curr_3$0)))

(assert (= n_2$0 curr_3$0))

(assert (= val_1$0 val$0))

(assert (Frame$1 FP_1$0 Alloc$0 next$0 next$0))

(assert (= Alloc$0 (union$1 FP_Caller$0 Alloc$0)))

(assert (= sk_?X_42$0 FP$0))

(assert (= FP_Caller$0 (union$1 FP$0 FP_Caller$0)))

(assert (= sk_?X_26$0 (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0)))

(assert (= sk_?X_28$0 (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0)))

(assert (= sk_?X_30$0 (union$1 sk_?X_27$0 sk_?X_29$0)))

(assert (= sk_?X_32$0 sk_?X_30$0))

(assert (or
    (and (= (read$0 next$0 prev_3$0) curr_3$0) (= emptyset$1 emptyset$1)
         (= emptyset$1 (intersection$1 sk_?X_27$0 sk_?X_29$0))
         (= c1_3$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
         (= c2_3$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
         (= content_1$0 (union$0 c1_3$0 c2_3$0))
         (= sk_?X_32$0
           (union$1 (intersection$1 Alloc$0 FP_1$0)
             (setminus$1 Alloc$0 Alloc$0)))
         (> val_1$0 (read$1 data$0 prev_3$0))
         (Btwn$0 next$0 lst_1$0 prev_3$0 curr_3$0)
         (sorted_set_struct$0 sk_?X_26$0 data$0 next$0 lst_1$0 curr_3$0
           c2_3$0)
         (sorted_set_struct$0 sk_?X_28$0 data$0 next$0 curr_3$0 null$0
           c1_3$0)
         (or (= curr_3$0 null$0) (= prev_3$0 null$0)
             (< (read$1 data$0 prev_3$0) (read$1 data$0 curr_3$0)))
         (not (= prev_3$0 curr_3$0)))
    (and (= emptyset$1 emptyset$1)
         (= c1_3$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
         (= c2_3$0 emptyset$0) (= content_1$0 (union$0 c1_3$0 c2_3$0))
         (= curr_3$0 lst_1$0) (= prev_3$0 null$0)
         (= sk_?X_33$0
           (union$1 (intersection$1 Alloc$0 FP_1$0)
             (setminus$1 Alloc$0 Alloc$0)))
         (sorted_set_struct$0 sk_?X_28$0 data$0 next$0 curr_3$0 null$0
           c1_3$0)
         (or (= curr_3$0 null$0) (= prev_3$0 null$0)
             (< (read$1 data$0 prev_3$0) (read$1 data$0 curr_3$0))))))

(assert (= sk_?X_35$0 sk_?X_37$0))

(assert (= sk_?X_37$0 (union$1 sk_?X_40$0 sk_?X_38$0)))

(assert (= sk_?X_39$0 (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0)))

(assert (= sk_?X_41$0 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0)))

(assert (or
    (and (= (read$0 next$0 prev_2$0) curr_2$0) (= emptyset$1 emptyset$1)
         (= emptyset$1 (intersection$1 sk_?X_40$0 sk_?X_38$0))
         (= c1_2$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
         (= c2_2$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
         (= content$0 (union$0 c1_2$0 c2_2$0)) (= sk_?X_35$0 FP_1$0)
         (> val$0 (read$1 data$0 prev_2$0))
         (Btwn$0 next$0 lst$0 prev_2$0 curr_2$0)
         (sorted_set_struct$0 sk_?X_39$0 data$0 next$0 curr_2$0 null$0
           c1_2$0)
         (sorted_set_struct$0 sk_?X_41$0 data$0 next$0 lst$0 curr_2$0 c2_2$0)
         (or (= curr_2$0 null$0) (= prev_2$0 null$0)
             (< (read$1 data$0 prev_2$0) (read$1 data$0 curr_2$0)))
         (not (= prev_2$0 curr_2$0)))
    (and (= emptyset$1 emptyset$1)
         (= c1_2$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
         (= c2_2$0 emptyset$0) (= content$0 (union$0 c1_2$0 c2_2$0))
         (= curr_2$0 lst$0) (= prev_2$0 null$0) (= sk_?X_34$0 FP_1$0)
         (sorted_set_struct$0 sk_?X_39$0 data$0 next$0 curr_2$0 null$0
           c1_2$0)
         (or (= curr_2$0 null$0) (= prev_2$0 null$0)
             (< (read$1 data$0 prev_2$0) (read$1 data$0 curr_2$0))))))

(assert (not (in$1 null$0 Alloc$0)))

(assert (not (in$1 n_2$0 FP_2$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
            (not
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst$0 null$0))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_3$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_3$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst$0 l1 curr_2$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))
                 (not (= l1 curr_2$0)))
            (and (or (= l1 curr_2$0) (not (Btwn$0 next$0 lst$0 l1 curr_2$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 null$0))
              (sorted_set_domain$0 data$0 next$0 lst$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
              (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$1 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (= curr_3$0 null$0) (not (< (read$1 data$0 curr_3$0) val_1$0))))

(assert (or (not Axiom_8$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_39$0))
                (not (in$1 l2 sk_?X_39$0))))))

(assert (or (and (Btwn$0 next$0 curr_3$0 null$0 null$0) Axiom_9$0)
    (not
         (sorted_set_struct$0 sk_?X_28$0 data$0 next$0 curr_3$0 null$0
           c1_3$0))))

(assert (or (not Axiom_10$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_42$0))
                (not (in$1 l2 sk_?X_42$0))))))

(assert (or (and (Btwn$0 next$0 lst$0 curr_2$0 curr_2$0) Axiom_11$0)
    (not
         (sorted_set_struct$0 sk_?X_41$0 data$0 next$0 lst$0 curr_2$0 c2_2$0))))

(assert (or (not Axiom_12$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_3$0))
                (not (in$1 l1 sk_?X_26$0)) (not (in$1 l2 sk_?X_26$0))))))

(assert (= (read$1 data$0 curr_3$0) val_1$0))

(assert (= FP_Caller_1$0 (setminus$1 FP_Caller$0 FP$0)))

(assert (= c2_2$0 emptyset$0))

(assert (= curr_2$0 lst$0))

(assert (= lst_1$0 lst$0))

(assert (= prev_2$0 null$0))

(assert (Frame$0 FP_1$0 Alloc$0 data$0 data$0))

(assert (= Alloc$0 (union$1 FP_2$0 Alloc$0)))

(assert (= content$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))

(assert (= sk_?X_42$0 (sorted_set_domain$0 data$0 next$0 lst$0 null$0)))

(assert (sorted_set_struct$0 sk_?X_42$0 data$0 next$0 lst$0 null$0 content$0))

(assert (= sk_?X_27$0 sk_?X_26$0))

(assert (= sk_?X_29$0 sk_?X_28$0))

(assert (= sk_?X_31$0 sk_?X_29$0))

(assert (= sk_?X_33$0 sk_?X_31$0))

(assert (= sk_?X_34$0 sk_?X_36$0))

(assert (= sk_?X_36$0 sk_?X_38$0))

(assert (= sk_?X_38$0 sk_?X_39$0))

(assert (= sk_?X_40$0 sk_?X_41$0))

(assert (= FP$0 (union$1 FP_1$0 FP$0)))

(assert (not (= curr_3$0 null$0)))

(assert (not (in$1 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
            (not
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_2$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_2$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst$0 l1 null$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 lst$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_1$0 l1 curr_3$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))
                 (not (= l1 curr_3$0)))
            (and
                 (or (= l1 curr_3$0)
                     (not (Btwn$0 next$0 lst_1$0 l1 curr_3$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
              (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$1 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$1 ?y ?X))
            (in$1 (ep$0 ?f ?X ?x) ?X))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$0 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$0 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$0 ?f ?x) (read$0 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
