(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sl_sorted_set/insert.spl:53:2-16:Possible heap access through null or dangling reference
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldLoc Loc) Loc)
(declare-fun read$1 (FldInt Loc) Int)
(declare-fun write$0 (FldLoc Loc Loc) FldLoc)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetInt)
(declare-fun emptyset$1 () SetLoc)
(declare-fun setenum$0 (Int) SetInt)
(declare-fun setenum$1 (Loc) SetLoc)
(declare-fun union$0 (SetInt SetInt) SetInt)
(declare-fun union$1 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetInt SetInt) SetInt)
(declare-fun intersection$1 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetInt SetInt) SetInt)
(declare-fun setminus$1 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun Frame$0 (SetLoc SetLoc FldLoc FldLoc) Bool)
(declare-fun Frame$1 (SetLoc SetLoc FldInt FldInt) Bool)
(declare-fun in$0 (Int SetInt) Bool)
(declare-fun in$1 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Alloc_1$0 () SetLoc)
(declare-fun Axiom_14$0 () Bool)
(declare-fun Axiom_15$0 () Bool)
(declare-fun Axiom_16$0 () Bool)
(declare-fun Axiom_17$0 () Bool)
(declare-fun Axiom_18$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_1$0 () SetLoc)
(declare-fun FP_2$0 () SetLoc)
(declare-fun FP_3$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_1$0 () SetLoc)
(declare-fun FP_Caller_final$0 () SetLoc)
(declare-fun FP_Caller_final_1$0 () SetLoc)
(declare-fun c1_2$0 () SetInt)
(declare-fun c1_3$0 () SetInt)
(declare-fun c2_2$0 () SetInt)
(declare-fun c2_3$0 () SetInt)
(declare-fun content$0 () SetInt)
(declare-fun content_1$0 () SetInt)
(declare-fun curr_2$0 () Loc)
(declare-fun curr_3$0 () Loc)
(declare-fun data$0 () FldInt)
(declare-fun lst$0 () Loc)
(declare-fun lst_1$0 () Loc)
(declare-fun n_2$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun next_1$0 () FldLoc)
(declare-fun prev_2$0 () Loc)
(declare-fun prev_3$0 () Loc)
(declare-fun res$0 () Loc)
(declare-fun res_1$0 () Loc)
(declare-fun sk_?X_44$0 () SetLoc)
(declare-fun sk_?X_45$0 () SetLoc)
(declare-fun sk_?X_46$0 () SetLoc)
(declare-fun sk_?X_47$0 () SetLoc)
(declare-fun sk_?X_48$0 () SetLoc)
(declare-fun sk_?X_49$0 () SetLoc)
(declare-fun sk_?X_50$0 () SetLoc)
(declare-fun sk_?X_51$0 () SetLoc)
(declare-fun sk_?X_52$0 () SetLoc)
(declare-fun sk_?X_53$0 () SetLoc)
(declare-fun sk_?X_54$0 () SetLoc)
(declare-fun sk_?X_55$0 () SetLoc)
(declare-fun sk_?X_56$0 () SetLoc)
(declare-fun sk_?X_57$0 () SetLoc)
(declare-fun sk_?X_58$0 () SetLoc)
(declare-fun sk_?X_59$0 () SetLoc)
(declare-fun sk_?X_60$0 () SetLoc)
(declare-fun sorted_set_c$0 (FldInt FldLoc Loc Loc) SetInt)
(declare-fun sorted_set_domain$0 (FldInt FldLoc Loc Loc) SetLoc)
(declare-fun sorted_set_struct$0 (SetLoc FldInt FldLoc Loc Loc SetInt) Bool)
(declare-fun t_321$0 () Loc)
(declare-fun t_322$0 () Loc)
(declare-fun t_323$0 () Loc)
(declare-fun t_324$0 () Int)
(declare-fun t_325$0 () Int)
(declare-fun t_326$0 () Int)
(declare-fun t_327$0 () Int)
(declare-fun t_328$0 () Int)
(declare-fun t_329$0 () Int)
(declare-fun t_330$0 () Int)
(declare-fun t_331$0 () Int)
(declare-fun t_332$0 () Int)
(declare-fun t_333$0 () Int)
(declare-fun t_334$0 () Int)
(declare-fun t_335$0 () Int)
(declare-fun t_336$0 () Int)
(declare-fun t_337$0 () Int)
(declare-fun t_338$0 () Int)
(declare-fun t_339$0 () Int)
(declare-fun t_340$0 () Int)
(declare-fun t_341$0 () Int)
(declare-fun t_342$0 () Int)
(declare-fun t_343$0 () Int)
(declare-fun t_344$0 () Int)
(declare-fun t_345$0 () Int)
(declare-fun t_346$0 () Int)
(declare-fun t_347$0 () Int)
(declare-fun t_348$0 () Int)
(declare-fun t_349$0 () Int)
(declare-fun t_350$0 () Int)
(declare-fun t_351$0 () Int)
(declare-fun t_352$0 () Int)
(declare-fun t_353$0 () Int)
(declare-fun t_354$0 () Loc)
(declare-fun t_355$0 () Loc)
(declare-fun t_356$0 () Loc)
(declare-fun t_357$0 () Loc)
(declare-fun t_358$0 () Loc)
(declare-fun t_359$0 () Loc)
(declare-fun t_360$0 () Loc)
(declare-fun t_361$0 () Loc)
(declare-fun t_362$0 () Loc)
(declare-fun t_363$0 () Loc)
(declare-fun t_364$0 () Loc)
(declare-fun t_365$0 () Loc)
(declare-fun t_366$0 () Loc)
(declare-fun t_367$0 () Loc)
(declare-fun t_368$0 () Loc)
(declare-fun t_369$0 () Loc)
(declare-fun t_370$0 () Loc)
(declare-fun t_371$0 () Loc)
(declare-fun t_372$0 () Loc)
(declare-fun t_373$0 () Loc)
(declare-fun t_374$0 () Loc)
(declare-fun t_375$0 () Loc)
(declare-fun t_376$0 () Loc)
(declare-fun t_377$0 () Loc)
(declare-fun t_378$0 () Loc)
(declare-fun t_379$0 () Loc)
(declare-fun t_380$0 () Loc)
(declare-fun t_381$0 () Loc)
(declare-fun t_382$0 () Loc)
(declare-fun t_383$0 () Loc)
(declare-fun t_384$0 () Loc)
(declare-fun t_385$0 () Loc)
(declare-fun t_386$0 () Loc)
(declare-fun t_387$0 () Loc)
(declare-fun t_388$0 () Loc)
(declare-fun t_389$0 () Loc)
(declare-fun t_390$0 () Loc)
(declare-fun t_391$0 () Loc)
(declare-fun t_392$0 () Loc)
(declare-fun t_393$0 () Loc)
(declare-fun t_394$0 () Loc)
(declare-fun t_395$0 () Loc)
(declare-fun t_396$0 () Loc)
(declare-fun t_397$0 () Loc)
(declare-fun t_398$0 () Loc)
(declare-fun t_399$0 () Loc)
(declare-fun t_400$0 () Loc)
(declare-fun t_401$0 () Loc)
(declare-fun t_402$0 () Loc)
(declare-fun t_403$0 () Loc)
(declare-fun t_404$0 () Loc)
(declare-fun t_405$0 () Loc)
(declare-fun t_406$0 () Loc)
(declare-fun t_407$0 () Loc)
(declare-fun t_408$0 () Loc)
(declare-fun t_409$0 () Loc)
(declare-fun t_410$0 () Loc)
(declare-fun t_411$0 () Loc)
(declare-fun t_412$0 () Loc)
(declare-fun t_413$0 () Loc)
(declare-fun t_414$0 () Loc)
(declare-fun t_415$0 () Loc)
(declare-fun t_416$0 () Loc)
(declare-fun t_417$0 () Loc)
(declare-fun t_418$0 () Loc)
(declare-fun t_419$0 () Loc)
(declare-fun t_420$0 () Loc)
(declare-fun t_421$0 () Loc)
(declare-fun tmp_1$0 () Loc)
(declare-fun val$0 () Int)
(declare-fun val_1$0 () Int)
(declare-fun witness$0 (FldInt Int SetInt) Loc)

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_421$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_420$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_419$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_418$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_417$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_416$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_415$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_414$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_413$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_412$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_411$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_410$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_409$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_408$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_407$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_406$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_405$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_404$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_403$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_402$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_401$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_400$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_399$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_398$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_397$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_396$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_395$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_394$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_393$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_392$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_391$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_390$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_389$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_388$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_387$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_386$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_385$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_384$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_383$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_382$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_381$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_380$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_379$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_378$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_377$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_376$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_375$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_374$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_373$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_372$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_371$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_370$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_369$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_368$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_367$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_366$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_365$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_364$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_363$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_362$0))

(assert (= (ep$0 next$0 FP_1$0 tmp_1$0) t_361$0))

(assert (= (ep$0 next$0 FP_1$0 n_2$0) t_360$0))

(assert (= (ep$0 next$0 FP_1$0 lst_1$0) t_359$0))

(assert (= (ep$0 next$0 FP_1$0 lst$0) t_358$0))

(assert (= (ep$0 next$0 FP_1$0 curr_3$0) t_357$0))

(assert (= (ep$0 next$0 FP_1$0 curr_2$0) t_356$0))

(assert (= (ep$0 next$0 FP_1$0 null$0) t_355$0))

(assert (= (read$0 next$0 n_2$0) t_354$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_353$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_352$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_351$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_350$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_349$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_348$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_347$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_346$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_345$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_344$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_343$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_342$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_341$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_340$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_339$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_338$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_337$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_336$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_335$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_334$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_333$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_332$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_331$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_330$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_329$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_328$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_327$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_326$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_325$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_324$0))

(assert (= (read$0 (write$0 next$0 n_2$0 curr_3$0) prev_3$0) t_323$0))

(assert (= (read$0 (write$0 next$0 n_2$0 curr_3$0) prev_2$0) t_322$0))

(assert (= (read$0 (write$0 next$0 n_2$0 curr_3$0) n_2$0) t_321$0))

(assert (forall ((?d_8 Loc) (?x Loc) (?y Loc))
        (or (= ?y ?x)
            (= (read$0 next$0 ?y) (read$0 (write$0 next$0 ?x ?d_8) ?y)))))

(assert (forall ((?d_8 Loc) (?x Loc)) (= (read$0 (write$0 next$0 ?x ?d_8) ?x) ?d_8)))

(assert (forall ((?f FldLoc)) (= (read$0 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$1 x (setenum$1 y)))
            (and (not (= x y)) (not (in$1 x (setenum$1 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x (setminus$1 X Y)) (not (in$1 x Y)))
            (and (or (in$1 x Y) (not (in$1 x X)))
                 (not (in$1 x (setminus$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x Y) (in$1 x (intersection$1 X Y)))
            (and (or (not (in$1 x X)) (not (in$1 x Y)))
                 (not (in$1 x (intersection$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x (union$1 X Y)) (or (in$1 x X) (in$1 x Y)))
            (and (not (in$1 x X)) (not (in$1 x Y))
                 (not (in$1 x (union$1 X Y)))))))

(assert (forall ((x Loc)) (not (in$1 x emptyset$1))))

(assert (forall ((x Int) (y Int))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Int)) (not (in$0 x emptyset$0))))

(assert (or (= curr_3$0 null$0) (not (= (read$1 data$0 curr_3$0) val_1$0))))

(assert (or (and (Btwn$0 next$0 curr_2$0 null$0 null$0) Axiom_14$0)
    (not
         (sorted_set_struct$0 sk_?X_57$0 data$0 next$0 curr_2$0 null$0
           c1_2$0))))

(assert (or (not Axiom_15$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_46$0))
                (not (in$1 l2 sk_?X_46$0))))))

(assert (or (and (Btwn$0 next$0 lst$0 null$0 null$0) Axiom_16$0)
    (not
         (sorted_set_struct$0 sk_?X_60$0 data$0 next$0 lst$0 null$0
           content$0))))

(assert (or (not Axiom_17$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_2$0))
                (not (in$1 l1 sk_?X_59$0)) (not (in$1 l2 sk_?X_59$0))))))

(assert (or (and (Btwn$0 next$0 lst_1$0 curr_3$0 curr_3$0) Axiom_18$0)
    (not
         (sorted_set_struct$0 sk_?X_44$0 data$0 next$0 lst_1$0 curr_3$0
           c2_3$0))))

(assert (= FP_2$0
  (union$1 (setminus$1 FP$0 FP_1$0)
    (union$1 (intersection$1 Alloc$0 FP_1$0) (setminus$1 Alloc$0 Alloc$0)))))

(assert (= FP_Caller_1$0 (setminus$1 FP_Caller$0 FP$0)))

(assert (= c1_2$0 content$0))

(assert (= content_1$0 content$0))

(assert (= lst_1$0 lst$0))

(assert (= next_1$0 (write$0 next$0 n_2$0 curr_3$0)))

(assert (= res_1$0 res$0))

(assert (Frame$1 FP_1$0 Alloc$0 data$0 data$0))

(assert (= Alloc$0 (union$1 FP_2$0 Alloc$0)))

(assert (= content$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))

(assert (= sk_?X_60$0 (sorted_set_domain$0 data$0 next$0 lst$0 null$0)))

(assert (sorted_set_struct$0 sk_?X_60$0 data$0 next$0 lst$0 null$0 content$0))

(assert (= sk_?X_45$0 sk_?X_44$0))

(assert (= sk_?X_47$0 sk_?X_46$0))

(assert (= sk_?X_49$0 sk_?X_47$0))

(assert (= sk_?X_51$0 sk_?X_49$0))

(assert (= sk_?X_52$0 sk_?X_54$0))

(assert (= sk_?X_54$0 sk_?X_56$0))

(assert (= sk_?X_56$0 sk_?X_57$0))

(assert (= sk_?X_58$0 sk_?X_59$0))

(assert (= FP$0 (union$1 FP_1$0 FP$0)))

(assert (not (= tmp_1$0 null$0)))

(assert (not (in$1 null$0 Alloc$0)))

(assert (not (in$1 tmp_1$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
            (not
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst$0 null$0))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_3$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_3$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst$0 l1 curr_2$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))
                 (not (= l1 curr_2$0)))
            (and (or (= l1 curr_2$0) (not (Btwn$0 next$0 lst$0 l1 curr_2$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 null$0))
              (sorted_set_domain$0 data$0 next$0 lst$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
              (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$1 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (= curr_3$0 null$0) (not (< (read$1 data$0 curr_3$0) val_1$0))))

(assert (or (not Axiom_14$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_57$0))
                (not (in$1 l2 sk_?X_57$0))))))

(assert (or (and (Btwn$0 next$0 curr_3$0 null$0 null$0) Axiom_15$0)
    (not
         (sorted_set_struct$0 sk_?X_46$0 data$0 next$0 curr_3$0 null$0
           c1_3$0))))

(assert (or (not Axiom_16$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_60$0))
                (not (in$1 l2 sk_?X_60$0))))))

(assert (or (and (Btwn$0 next$0 lst$0 curr_2$0 curr_2$0) Axiom_17$0)
    (not
         (sorted_set_struct$0 sk_?X_59$0 data$0 next$0 lst$0 curr_2$0 c2_2$0))))

(assert (or (not Axiom_18$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_3$0))
                (not (in$1 l1 sk_?X_44$0)) (not (in$1 l2 sk_?X_44$0))))))

(assert (= Alloc_1$0 (union$1 Alloc$0 (setenum$1 tmp_1$0))))

(assert (= FP_3$0 (union$1 FP_2$0 (setenum$1 tmp_1$0))))

(assert (= FP_Caller_final_1$0 FP_Caller_final$0))

(assert (= c2_2$0 emptyset$0))

(assert (= curr_2$0 lst$0))

(assert (= n_2$0 tmp_1$0))

(assert (= prev_2$0 null$0))

(assert (= val_1$0 val$0))

(assert (Frame$0 FP_1$0 Alloc$0 next$0 next$0))

(assert (= Alloc$0 (union$1 FP_Caller$0 Alloc$0)))

(assert (= sk_?X_60$0 FP$0))

(assert (= FP_Caller$0 (union$1 FP$0 FP_Caller$0)))

(assert (= sk_?X_44$0 (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0)))

(assert (= sk_?X_46$0 (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0)))

(assert (= sk_?X_48$0 (union$1 sk_?X_45$0 sk_?X_47$0)))

(assert (= sk_?X_50$0 sk_?X_48$0))

(assert (or
    (and (= (read$0 next$0 prev_3$0) curr_3$0) (= emptyset$1 emptyset$1)
         (= emptyset$1 (intersection$1 sk_?X_45$0 sk_?X_47$0))
         (= c1_3$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
         (= c2_3$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
         (= content_1$0 (union$0 c1_3$0 c2_3$0))
         (= sk_?X_50$0
           (union$1 (intersection$1 Alloc$0 FP_1$0)
             (setminus$1 Alloc$0 Alloc$0)))
         (> val_1$0 (read$1 data$0 prev_3$0))
         (Btwn$0 next$0 lst_1$0 prev_3$0 curr_3$0)
         (sorted_set_struct$0 sk_?X_44$0 data$0 next$0 lst_1$0 curr_3$0
           c2_3$0)
         (sorted_set_struct$0 sk_?X_46$0 data$0 next$0 curr_3$0 null$0
           c1_3$0)
         (or (= curr_3$0 null$0) (= prev_3$0 null$0)
             (< (read$1 data$0 prev_3$0) (read$1 data$0 curr_3$0)))
         (not (= prev_3$0 curr_3$0)))
    (and (= emptyset$1 emptyset$1)
         (= c1_3$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
         (= c2_3$0 emptyset$0) (= content_1$0 (union$0 c1_3$0 c2_3$0))
         (= curr_3$0 lst_1$0) (= prev_3$0 null$0)
         (= sk_?X_51$0
           (union$1 (intersection$1 Alloc$0 FP_1$0)
             (setminus$1 Alloc$0 Alloc$0)))
         (sorted_set_struct$0 sk_?X_46$0 data$0 next$0 curr_3$0 null$0
           c1_3$0)
         (or (= curr_3$0 null$0) (= prev_3$0 null$0)
             (< (read$1 data$0 prev_3$0) (read$1 data$0 curr_3$0))))))

(assert (= sk_?X_53$0 sk_?X_55$0))

(assert (= sk_?X_55$0 (union$1 sk_?X_58$0 sk_?X_56$0)))

(assert (= sk_?X_57$0 (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0)))

(assert (= sk_?X_59$0 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0)))

(assert (or
    (and (= (read$0 next$0 prev_2$0) curr_2$0) (= emptyset$1 emptyset$1)
         (= emptyset$1 (intersection$1 sk_?X_58$0 sk_?X_56$0))
         (= c1_2$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
         (= c2_2$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
         (= content$0 (union$0 c1_2$0 c2_2$0)) (= sk_?X_53$0 FP_1$0)
         (> val$0 (read$1 data$0 prev_2$0))
         (Btwn$0 next$0 lst$0 prev_2$0 curr_2$0)
         (sorted_set_struct$0 sk_?X_57$0 data$0 next$0 curr_2$0 null$0
           c1_2$0)
         (sorted_set_struct$0 sk_?X_59$0 data$0 next$0 lst$0 curr_2$0 c2_2$0)
         (or (= curr_2$0 null$0) (= prev_2$0 null$0)
             (< (read$1 data$0 prev_2$0) (read$1 data$0 curr_2$0)))
         (not (= prev_2$0 curr_2$0)))
    (and (= emptyset$1 emptyset$1)
         (= c1_2$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
         (= c2_2$0 emptyset$0) (= content$0 (union$0 c1_2$0 c2_2$0))
         (= curr_2$0 lst$0) (= prev_2$0 null$0) (= sk_?X_52$0 FP_1$0)
         (sorted_set_struct$0 sk_?X_57$0 data$0 next$0 curr_2$0 null$0
           c1_2$0)
         (or (= curr_2$0 null$0) (= prev_2$0 null$0)
             (< (read$1 data$0 prev_2$0) (read$1 data$0 curr_2$0))))))

(assert (not (in$1 null$0 Alloc$0)))

(assert (not (in$1 n_2$0 FP_3$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
            (not
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_2$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_2$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst$0 l1 null$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 lst$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_1$0 l1 curr_3$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))
                 (not (= l1 curr_3$0)))
            (and
                 (or (= l1 curr_3$0)
                     (not (Btwn$0 next$0 lst_1$0 l1 curr_3$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
              (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$1 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$1 ?y ?X))
            (in$1 (ep$0 ?f ?X ?x) ?X))))

(assert (forall ((?u Loc) (?v Loc) (?z Loc))
        (and
             (or (Btwn$0 (write$0 next$0 n_2$0 curr_3$0) ?z ?u ?v)
                 (not
                      (or
                          (and (Btwn$0 next$0 ?z ?u ?v)
                               (or (Btwn$0 next$0 ?z ?v n_2$0)
                                   (and (Btwn$0 next$0 ?z ?v ?v)
                                        (not (Btwn$0 next$0 ?z n_2$0 n_2$0)))))
                          (and (not (= n_2$0 ?v))
                               (or (Btwn$0 next$0 ?z n_2$0 ?v)
                                   (and (Btwn$0 next$0 ?z n_2$0 n_2$0)
                                        (not (Btwn$0 next$0 ?z ?v ?v))))
                               (Btwn$0 next$0 ?z ?u n_2$0)
                               (or (Btwn$0 next$0 curr_3$0 ?v n_2$0)
                                   (and (Btwn$0 next$0 curr_3$0 ?v ?v)
                                        (not
                                             (Btwn$0 next$0 curr_3$0 n_2$0
                                               n_2$0)))))
                          (and (not (= n_2$0 ?v))
                               (or (Btwn$0 next$0 ?z n_2$0 ?v)
                                   (and (Btwn$0 next$0 ?z n_2$0 n_2$0)
                                        (not (Btwn$0 next$0 ?z ?v ?v))))
                               (Btwn$0 next$0 curr_3$0 ?u ?v)
                               (or (Btwn$0 next$0 curr_3$0 ?v n_2$0)
                                   (and (Btwn$0 next$0 curr_3$0 ?v ?v)
                                        (not
                                             (Btwn$0 next$0 curr_3$0 n_2$0
                                               n_2$0))))))))
             (or
                 (and (Btwn$0 next$0 ?z ?u ?v)
                      (or (Btwn$0 next$0 ?z ?v n_2$0)
                          (and (Btwn$0 next$0 ?z ?v ?v)
                               (not (Btwn$0 next$0 ?z n_2$0 n_2$0)))))
                 (and (not (= n_2$0 ?v))
                      (or (Btwn$0 next$0 ?z n_2$0 ?v)
                          (and (Btwn$0 next$0 ?z n_2$0 n_2$0)
                               (not (Btwn$0 next$0 ?z ?v ?v))))
                      (Btwn$0 next$0 ?z ?u n_2$0)
                      (or (Btwn$0 next$0 curr_3$0 ?v n_2$0)
                          (and (Btwn$0 next$0 curr_3$0 ?v ?v)
                               (not (Btwn$0 next$0 curr_3$0 n_2$0 n_2$0)))))
                 (and (not (= n_2$0 ?v))
                      (or (Btwn$0 next$0 ?z n_2$0 ?v)
                          (and (Btwn$0 next$0 ?z n_2$0 n_2$0)
                               (not (Btwn$0 next$0 ?z ?v ?v))))
                      (Btwn$0 next$0 curr_3$0 ?u ?v)
                      (or (Btwn$0 next$0 curr_3$0 ?v n_2$0)
                          (and (Btwn$0 next$0 curr_3$0 ?v ?v)
                               (not (Btwn$0 next$0 curr_3$0 n_2$0 n_2$0)))))
                 (not (Btwn$0 (write$0 next$0 n_2$0 curr_3$0) ?z ?u ?v))))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$0 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$0 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$0 ?f ?x) (read$0 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
