(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sls/sls_quicksort.spl:55:45-46:A postcondition of procedure quicksort might not hold at this return point
  tests/spl/sls/sls_quicksort.spl:49:11-31:Related location: This is the postcondition that might not hold
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldInt Loc) Int)
(declare-fun read$1 (FldLoc Loc) Loc)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetLoc)
(declare-fun setenum$0 (Loc) SetLoc)
(declare-fun union$0 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun Frame$0 (SetLoc SetLoc FldLoc FldLoc) Bool)
(declare-fun Frame$1 (SetLoc SetLoc FldInt FldInt) Bool)
(declare-fun in$0 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Axiom_41$0 () Bool)
(declare-fun Axiom_42$0 () Bool)
(declare-fun Axiom_43$0 () Bool)
(declare-fun Axiom_44$0 () Bool)
(declare-fun Axiom_45$0 () Bool)
(declare-fun Axiom_46$0 () Bool)
(declare-fun Axiom_47$0 () Bool)
(declare-fun Axiom_48$0 () Bool)
(declare-fun Axiom_49$0 () Bool)
(declare-fun Axiom_50$0 () Bool)
(declare-fun Axiom_51$0 () Bool)
(declare-fun Axiom_52$0 () Bool)
(declare-fun Axiom_53$0 () Bool)
(declare-fun Axiom_54$0 () Bool)
(declare-fun Axiom_55$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_1$0 () SetLoc)
(declare-fun FP_2$0 () SetLoc)
(declare-fun FP_3$0 () SetLoc)
(declare-fun FP_4$0 () SetLoc)
(declare-fun FP_5$0 () SetLoc)
(declare-fun FP_6$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_1$0 () SetLoc)
(declare-fun FP_Caller_final_1$0 () SetLoc)
(declare-fun blseg_domain$0 (FldInt FldLoc Loc Loc Int Int) SetLoc)
(declare-fun blseg_struct$0 (SetLoc FldInt FldLoc Loc Loc Int Int) Bool)
(declare-fun bslseg_domain$0 (FldInt FldLoc Loc Loc Int Int) SetLoc)
(declare-fun bslseg_struct$0 (SetLoc FldInt FldLoc Loc Loc Int Int) Bool)
(declare-fun data$0 () FldInt)
(declare-fun data_1$0 () FldInt)
(declare-fun data_2$0 () FldInt)
(declare-fun data_3$0 () FldInt)
(declare-fun lb$0 () Int)
(declare-fun next$0 () FldLoc)
(declare-fun pivot$0 () Loc)
(declare-fun pivot_3$0 () Loc)
(declare-fun sk_?X_61$0 () SetLoc)
(declare-fun sk_?X_62$0 () SetLoc)
(declare-fun sk_?X_63$0 () SetLoc)
(declare-fun sk_?X_64$0 () SetLoc)
(declare-fun sk_?X_65$0 () SetLoc)
(declare-fun sk_?X_66$0 () SetLoc)
(declare-fun sk_?X_67$0 () SetLoc)
(declare-fun sk_?X_68$0 () SetLoc)
(declare-fun sk_?X_69$0 () SetLoc)
(declare-fun sk_?X_70$0 () SetLoc)
(declare-fun sk_?X_71$0 () SetLoc)
(declare-fun sk_?X_72$0 () SetLoc)
(declare-fun sk_?X_73$0 () SetLoc)
(declare-fun sk_?X_74$0 () SetLoc)
(declare-fun sk_?X_75$0 () SetLoc)
(declare-fun sk_l1_3$0 () Loc)
(declare-fun sk_l2$0 () Loc)
(declare-fun t_39$0 () Int)
(declare-fun t_40$0 () Int)
(declare-fun t_41$0 () Int)
(declare-fun t_42$0 () Int)
(declare-fun t_43$0 () Int)
(declare-fun t_44$0 () Int)
(declare-fun t_45$0 () Int)
(declare-fun t_46$0 () Int)
(declare-fun t_47$0 () Loc)
(declare-fun t_48$0 () Loc)
(declare-fun t_49$0 () Loc)
(declare-fun t_50$0 () Loc)
(declare-fun t_51$0 () Loc)
(declare-fun t_52$0 () Loc)
(declare-fun t_53$0 () Loc)
(declare-fun t_54$0 () Loc)
(declare-fun t_55$0 () Loc)
(declare-fun t_56$0 () Loc)
(declare-fun t_57$0 () Loc)
(declare-fun t_58$0 () Loc)
(declare-fun t_59$0 () Loc)
(declare-fun t_60$0 () Loc)
(declare-fun t_61$0 () Loc)
(declare-fun t_62$0 () Loc)
(declare-fun t_63$0 () Loc)
(declare-fun t_64$0 () Loc)
(declare-fun ub$0 () Int)
(declare-fun x$0 () Loc)
(declare-fun y$0 () Loc)

(assert (= (ep$0 next$0 FP_5$0 x$0) t_64$0))

(assert (= (ep$0 next$0 FP_5$0 sk_l2$0) t_63$0))

(assert (= (ep$0 next$0 FP_5$0 sk_l1_3$0) t_62$0))

(assert (= (ep$0 next$0 FP_5$0 pivot_3$0) t_61$0))

(assert (= (ep$0 next$0 FP_5$0 (read$1 next$0 pivot_3$0)) t_60$0))

(assert (= (ep$0 next$0 FP_5$0 null$0) t_59$0))

(assert (= (ep$0 next$0 FP_3$0 x$0) t_58$0))

(assert (= (ep$0 next$0 FP_3$0 sk_l2$0) t_57$0))

(assert (= (ep$0 next$0 FP_3$0 sk_l1_3$0) t_56$0))

(assert (= (ep$0 next$0 FP_3$0 pivot_3$0) t_55$0))

(assert (= (ep$0 next$0 FP_3$0 (read$1 next$0 pivot_3$0)) t_54$0))

(assert (= (ep$0 next$0 FP_3$0 null$0) t_53$0))

(assert (= (ep$0 next$0 FP_1$0 x$0) t_52$0))

(assert (= (ep$0 next$0 FP_1$0 sk_l2$0) t_51$0))

(assert (= (ep$0 next$0 FP_1$0 sk_l1_3$0) t_50$0))

(assert (= (ep$0 next$0 FP_1$0 pivot_3$0) t_49$0))

(assert (= (ep$0 next$0 FP_1$0 (read$1 next$0 pivot_3$0)) t_48$0))

(assert (= (ep$0 next$0 FP_1$0 null$0) t_47$0))

(assert (= (read$0 data_3$0 pivot_3$0) t_46$0))

(assert (= (read$0 data_2$0 sk_l2$0) t_45$0))

(assert (= (read$0 data_2$0 sk_l1_3$0) t_44$0))

(assert (= (read$0 data_1$0 sk_l2$0) t_43$0))

(assert (= (read$0 data_1$0 sk_l1_3$0) t_42$0))

(assert (= (read$0 data$0 sk_l2$0) t_41$0))

(assert (= (read$0 data$0 sk_l1_3$0) t_40$0))

(assert (= (read$0 data$0 pivot_3$0) t_39$0))

(assert (forall ((?f FldLoc)) (= (read$1 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Loc)) (not (in$0 x emptyset$0))))

(assert (or (not Axiom_41$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$0 data_2$0 l1) ub$0)
                     (<= (read$0 data_2$0 pivot_3$0) (read$0 data_2$0 l1)))
                (not (in$0 l1 sk_?X_74$0))))))

(assert (or
    (and (Btwn$0 next$0 (read$1 next$0 pivot_3$0) y$0 y$0) Axiom_43$0
         Axiom_42$0)
    (not
         (bslseg_struct$0 sk_?X_72$0 data_3$0 next$0
           (read$1 next$0 pivot_3$0) y$0 (read$0 data_2$0 pivot_3$0) ub$0))))

(assert (or (not Axiom_44$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$0 data_1$0 l1) ub$0)
                     (<= (read$0 data_1$0 pivot_3$0) (read$0 data_1$0 l1)))
                (not (in$0 l1 sk_?X_64$0))))))

(assert (or (and (Btwn$0 next$0 x$0 pivot_3$0 pivot_3$0) Axiom_45$0)
    (not
         (blseg_struct$0 sk_?X_63$0 data_1$0 next$0 x$0 pivot_3$0 lb$0
           (read$0 data_1$0 pivot_3$0)))))

(assert (or (not Axiom_46$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$0 data_1$0 l1) (read$0 data_1$0 pivot_3$0))
                     (<= lb$0 (read$0 data_1$0 l1)))
                (not (in$0 l1 sk_?X_75$0))))))

(assert (or (and (Btwn$0 next$0 x$0 pivot_3$0 pivot_3$0) Axiom_48$0 Axiom_47$0)
    (not
         (bslseg_struct$0 sk_?X_73$0 data_2$0 next$0 x$0 pivot_3$0 lb$0
           (read$0 data_1$0 pivot_3$0)))))

(assert (or (not Axiom_49$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$0 data$0 l1) ub$0)
                     (<= lb$0 (read$0 data$0 l1)))
                (not (in$0 l1 sk_?X_61$0))))))

(assert (or (and (Btwn$0 next$0 x$0 y$0 y$0) Axiom_50$0)
    (not (blseg_struct$0 sk_?X_71$0 data$0 next$0 x$0 y$0 lb$0 ub$0))))

(assert (or (not Axiom_51$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data_3$0 l1) (read$0 data_3$0 l2))
                (not (Btwn$0 next$0 l1 l2 y$0)) (not (in$0 l1 sk_?X_62$0))
                (not (in$0 l2 sk_?X_62$0))))))

(assert (or (not Axiom_52$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$0 data_3$0 l1) ub$0)
                     (<= lb$0 (read$0 data_3$0 l1)))
                (not (in$0 l1 sk_?X_62$0))))))

(assert (or
    (and (or (= (read$1 next$0 x$0) y$0) (= x$0 y$0)) (= FP_6$0 FP$0)
         (= data_3$0 data$0) (= pivot_3$0 pivot$0))
    (and
         (= FP_2$0
           (union$0 (setminus$0 FP$0 FP_1$0)
             (union$0 (intersection$0 Alloc$0 FP_1$0)
               (setminus$0 Alloc$0 Alloc$0))))
         (= FP_4$0
           (union$0 (setminus$0 FP_2$0 FP_3$0)
             (union$0 (intersection$0 Alloc$0 FP_3$0)
               (setminus$0 Alloc$0 Alloc$0))))
         (= FP_6$0
           (union$0 (setminus$0 FP_4$0 FP_5$0)
             (union$0 (intersection$0 Alloc$0 FP_5$0)
               (setminus$0 Alloc$0 Alloc$0))))
         (Frame$1 FP_1$0 Alloc$0 data$0 data_1$0)
         (Frame$0 FP_1$0 Alloc$0 next$0 next$0)
         (Frame$1 FP_3$0 Alloc$0 data_1$0 data_2$0)
         (Frame$0 FP_3$0 Alloc$0 next$0 next$0)
         (Frame$1 FP_5$0 Alloc$0 data_2$0 data_3$0)
         (Frame$0 FP_5$0 Alloc$0 next$0 next$0)
         (= Alloc$0 (union$0 FP_2$0 Alloc$0))
         (= Alloc$0 (union$0 FP_4$0 Alloc$0))
         (= Alloc$0 (union$0 FP_6$0 Alloc$0))
         (and (= emptyset$0 emptyset$0)
              (= emptyset$0 (intersection$0 sk_?X_63$0 sk_?X_65$0))
              (= emptyset$0 (intersection$0 sk_?X_66$0 sk_?X_67$0))
              (= sk_?X_63$0
                (blseg_domain$0 data_1$0 next$0 x$0 pivot_3$0 lb$0
                  (read$0 data_1$0 pivot_3$0)))
              (= sk_?X_64$0
                (blseg_domain$0 data_1$0 next$0 pivot_3$0 y$0
                  (read$0 data_1$0 pivot_3$0) ub$0))
              (= sk_?X_65$0 sk_?X_64$0)
              (= sk_?X_66$0 (union$0 sk_?X_63$0 sk_?X_65$0))
              (= sk_?X_67$0 emptyset$0)
              (= sk_?X_68$0 (union$0 sk_?X_66$0 sk_?X_67$0))
              (= sk_?X_69$0
                (union$0 (intersection$0 Alloc$0 FP_1$0)
                  (setminus$0 Alloc$0 Alloc$0)))
              (= sk_?X_69$0 sk_?X_68$0) (<= (read$0 data_1$0 pivot_3$0) ub$0)
              (<= lb$0 (read$0 data_1$0 pivot_3$0))
              (Btwn$0 next$0 x$0 pivot_3$0 y$0)
              (blseg_struct$0 sk_?X_63$0 data_1$0 next$0 x$0 pivot_3$0 lb$0
                (read$0 data_1$0 pivot_3$0))
              (blseg_struct$0 sk_?X_64$0 data_1$0 next$0 pivot_3$0 y$0
                (read$0 data_1$0 pivot_3$0) ub$0)
              (not (= pivot_3$0 y$0)))
         (and (= emptyset$0 emptyset$0) (= sk_?X_70$0 sk_?X_71$0)
              (= sk_?X_70$0 FP_1$0)
              (= sk_?X_71$0 (blseg_domain$0 data$0 next$0 x$0 y$0 lb$0 ub$0))
              (= FP$0 (union$0 FP_1$0 FP$0))
              (blseg_struct$0 sk_?X_71$0 data$0 next$0 x$0 y$0 lb$0 ub$0)
              (not (= x$0 y$0)))
         (and
              (= sk_?X_72$0
                (union$0 (intersection$0 Alloc$0 FP_5$0)
                  (setminus$0 Alloc$0 Alloc$0)))
              (= sk_?X_72$0
                (bslseg_domain$0 data_3$0 next$0 (read$1 next$0 pivot_3$0)
                  y$0 (read$0 data_2$0 pivot_3$0) ub$0))
              (bslseg_struct$0 sk_?X_72$0 data_3$0 next$0
                (read$1 next$0 pivot_3$0) y$0 (read$0 data_2$0 pivot_3$0)
                ub$0))
         (and
              (= sk_?X_73$0
                (union$0 (intersection$0 Alloc$0 FP_3$0)
                  (setminus$0 Alloc$0 Alloc$0)))
              (= sk_?X_73$0
                (bslseg_domain$0 data_2$0 next$0 x$0 pivot_3$0 lb$0
                  (read$0 data_1$0 pivot_3$0)))
              (bslseg_struct$0 sk_?X_73$0 data_2$0 next$0 x$0 pivot_3$0 lb$0
                (read$0 data_1$0 pivot_3$0)))
         (and (= sk_?X_74$0 FP_5$0)
              (= sk_?X_74$0
                (blseg_domain$0 data_2$0 next$0 (read$1 next$0 pivot_3$0) y$0
                  (read$0 data_2$0 pivot_3$0) ub$0))
              (= FP_4$0 (union$0 FP_5$0 FP_4$0))
              (blseg_struct$0 sk_?X_74$0 data_2$0 next$0
                (read$1 next$0 pivot_3$0) y$0 (read$0 data_2$0 pivot_3$0)
                ub$0))
         (and (= sk_?X_75$0 FP_3$0)
              (= sk_?X_75$0
                (blseg_domain$0 data_1$0 next$0 x$0 pivot_3$0 lb$0
                  (read$0 data_1$0 pivot_3$0)))
              (= FP_2$0 (union$0 FP_3$0 FP_2$0))
              (blseg_struct$0 sk_?X_75$0 data_1$0 next$0 x$0 pivot_3$0 lb$0
                (read$0 data_1$0 pivot_3$0)))
         (not (= (read$1 next$0 x$0) y$0)) (not (= x$0 y$0))
         (not (in$0 null$0 Alloc$0)) (not (in$0 null$0 Alloc$0))
         (not (in$0 null$0 Alloc$0)))))

(assert (= FP_Caller_final_1$0 (union$0 FP_Caller_1$0 FP_6$0)))

(assert (= sk_?X_61$0 FP$0))

(assert (= FP_Caller$0 (union$0 FP$0 FP_Caller$0)))

(assert (= sk_?X_62$0
  (union$0 (intersection$0 Alloc$0 FP$0) (setminus$0 Alloc$0 Alloc$0))))

(assert (not (in$0 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 (read$1 next$0 pivot_3$0) l1 y$0)
                 (in$0 l1
                   (bslseg_domain$0 data_3$0 next$0 (read$1 next$0 pivot_3$0)
                     y$0 (read$0 data_2$0 pivot_3$0) ub$0))
                 (not (= l1 y$0)))
            (and
                 (or (= l1 y$0)
                     (not (Btwn$0 next$0 (read$1 next$0 pivot_3$0) l1 y$0)))
                 (not
                      (in$0 l1
                        (bslseg_domain$0 data_3$0 next$0
                          (read$1 next$0 pivot_3$0) y$0
                          (read$0 data_2$0 pivot_3$0) ub$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 x$0 l1 pivot_3$0)
                 (in$0 l1
                   (blseg_domain$0 data_1$0 next$0 x$0 pivot_3$0 lb$0
                     (read$0 data_1$0 pivot_3$0)))
                 (not (= l1 pivot_3$0)))
            (and (or (= l1 pivot_3$0) (not (Btwn$0 next$0 x$0 l1 pivot_3$0)))
                 (not
                      (in$0 l1
                        (blseg_domain$0 data_1$0 next$0 x$0 pivot_3$0 lb$0
                          (read$0 data_1$0 pivot_3$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 x$0 l1 y$0)
                 (in$0 l1 (blseg_domain$0 data$0 next$0 x$0 y$0 lb$0 ub$0))
                 (not (= l1 y$0)))
            (and (or (= l1 y$0) (not (Btwn$0 next$0 x$0 l1 y$0)))
                 (not
                      (in$0 l1
                        (blseg_domain$0 data$0 next$0 x$0 y$0 lb$0 ub$0)))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$0 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$0 ?y ?X))
            (in$0 (ep$0 ?f ?X ?x) ?X))))

(assert (or (not (Frame$1 FP_1$0 Alloc$0 data$0 data_1$0)) Axiom_53$0))

(assert (or (not Axiom_54$0)
    (forall ((?x Loc))
            (or (= (read$0 data_1$0 ?x) (read$0 data_2$0 ?x))
                (not (in$0 ?x (setminus$0 Alloc$0 FP_3$0)))))))

(assert (or (not (Frame$1 FP_5$0 Alloc$0 data_2$0 data_3$0)) Axiom_55$0))

(assert (or (and (Btwn$0 next$0 (read$1 next$0 pivot_3$0) y$0 y$0) Axiom_41$0)
    (not
         (blseg_struct$0 sk_?X_74$0 data_2$0 next$0 (read$1 next$0 pivot_3$0)
           y$0 (read$0 data_2$0 pivot_3$0) ub$0))))

(assert (or (not Axiom_42$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data_3$0 l1) (read$0 data_3$0 l2))
                (not (Btwn$0 next$0 l1 l2 y$0)) (not (in$0 l1 sk_?X_72$0))
                (not (in$0 l2 sk_?X_72$0))))))

(assert (or (not Axiom_43$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$0 data_2$0 pivot_3$0) (read$0 data_3$0 l1))
                     (<= (read$0 data_3$0 l1) ub$0))
                (not (in$0 l1 sk_?X_72$0))))))

(assert (or (and (Btwn$0 next$0 pivot_3$0 y$0 y$0) Axiom_44$0)
    (not
         (blseg_struct$0 sk_?X_64$0 data_1$0 next$0 pivot_3$0 y$0
           (read$0 data_1$0 pivot_3$0) ub$0))))

(assert (or (not Axiom_45$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$0 data_1$0 l1) (read$0 data_1$0 pivot_3$0))
                     (<= lb$0 (read$0 data_1$0 l1)))
                (not (in$0 l1 sk_?X_63$0))))))

(assert (or (and (Btwn$0 next$0 x$0 pivot_3$0 pivot_3$0) Axiom_46$0)
    (not
         (blseg_struct$0 sk_?X_75$0 data_1$0 next$0 x$0 pivot_3$0 lb$0
           (read$0 data_1$0 pivot_3$0)))))

(assert (or (not Axiom_47$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data_2$0 l1) (read$0 data_2$0 l2))
                (not (Btwn$0 next$0 l1 l2 pivot_3$0))
                (not (in$0 l1 sk_?X_73$0)) (not (in$0 l2 sk_?X_73$0))))))

(assert (or (not Axiom_48$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$0 data_2$0 l1) (read$0 data_1$0 pivot_3$0))
                     (<= lb$0 (read$0 data_2$0 l1)))
                (not (in$0 l1 sk_?X_73$0))))))

(assert (or (and (Btwn$0 next$0 x$0 y$0 y$0) Axiom_49$0)
    (not (blseg_struct$0 sk_?X_61$0 data$0 next$0 x$0 y$0 lb$0 ub$0))))

(assert (or (not Axiom_50$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$0 data$0 l1) ub$0)
                     (<= lb$0 (read$0 data$0 l1)))
                (not (in$0 l1 sk_?X_71$0))))))

(assert (or (and (Btwn$0 next$0 x$0 y$0 y$0) Axiom_52$0 Axiom_51$0)
    (not (bslseg_struct$0 sk_?X_62$0 data_3$0 next$0 x$0 y$0 lb$0 ub$0))))

(assert (= FP_Caller_1$0 (setminus$0 FP_Caller$0 FP$0)))

(assert (= Alloc$0 (union$0 FP_Caller$0 Alloc$0)))

(assert (= sk_?X_61$0 (blseg_domain$0 data$0 next$0 x$0 y$0 lb$0 ub$0)))

(assert (blseg_struct$0 sk_?X_61$0 data$0 next$0 x$0 y$0 lb$0 ub$0))

(assert (or
    (and (in$0 sk_l1_3$0 (bslseg_domain$0 data_3$0 next$0 x$0 y$0 lb$0 ub$0))
         (not (in$0 sk_l1_3$0 sk_?X_62$0)))
    (and (in$0 sk_l1_3$0 sk_?X_62$0)
         (not
              (in$0 sk_l1_3$0
                (bslseg_domain$0 data_3$0 next$0 x$0 y$0 lb$0 ub$0))))
    (and (in$0 sk_l2$0 sk_?X_62$0)
         (or (not (<= (read$0 data_3$0 sk_l2$0) ub$0))
             (not (<= lb$0 (read$0 data_3$0 sk_l2$0)))))
    (not (Btwn$0 next$0 x$0 y$0 y$0))
    (and (Btwn$0 next$0 sk_l1_3$0 sk_l2$0 y$0) (in$0 sk_l1_3$0 sk_?X_62$0)
         (in$0 sk_l2$0 sk_?X_62$0)
         (not (<= (read$0 data_3$0 sk_l1_3$0) (read$0 data_3$0 sk_l2$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 (read$1 next$0 pivot_3$0) l1 y$0)
                 (in$0 l1
                   (blseg_domain$0 data_2$0 next$0 (read$1 next$0 pivot_3$0)
                     y$0 (read$0 data_2$0 pivot_3$0) ub$0))
                 (not (= l1 y$0)))
            (and
                 (or (= l1 y$0)
                     (not (Btwn$0 next$0 (read$1 next$0 pivot_3$0) l1 y$0)))
                 (not
                      (in$0 l1
                        (blseg_domain$0 data_2$0 next$0
                          (read$1 next$0 pivot_3$0) y$0
                          (read$0 data_2$0 pivot_3$0) ub$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 pivot_3$0 l1 y$0)
                 (in$0 l1
                   (blseg_domain$0 data_1$0 next$0 pivot_3$0 y$0
                     (read$0 data_1$0 pivot_3$0) ub$0))
                 (not (= l1 y$0)))
            (and (or (= l1 y$0) (not (Btwn$0 next$0 pivot_3$0 l1 y$0)))
                 (not
                      (in$0 l1
                        (blseg_domain$0 data_1$0 next$0 pivot_3$0 y$0
                          (read$0 data_1$0 pivot_3$0) ub$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 x$0 l1 pivot_3$0)
                 (in$0 l1
                   (bslseg_domain$0 data_2$0 next$0 x$0 pivot_3$0 lb$0
                     (read$0 data_1$0 pivot_3$0)))
                 (not (= l1 pivot_3$0)))
            (and (or (= l1 pivot_3$0) (not (Btwn$0 next$0 x$0 l1 pivot_3$0)))
                 (not
                      (in$0 l1
                        (bslseg_domain$0 data_2$0 next$0 x$0 pivot_3$0 lb$0
                          (read$0 data_1$0 pivot_3$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 x$0 l1 y$0)
                 (in$0 l1
                   (bslseg_domain$0 data_3$0 next$0 x$0 y$0 lb$0 ub$0))
                 (not (= l1 y$0)))
            (and (or (= l1 y$0) (not (Btwn$0 next$0 x$0 l1 y$0)))
                 (not
                      (in$0 l1
                        (bslseg_domain$0 data_3$0 next$0 x$0 y$0 lb$0 ub$0)))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$0 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (not Axiom_53$0)
    (forall ((?x Loc))
            (or (= (read$0 data$0 ?x) (read$0 data_1$0 ?x))
                (not (in$0 ?x (setminus$0 Alloc$0 FP_1$0)))))))

(assert (or (not (Frame$1 FP_3$0 Alloc$0 data_1$0 data_2$0)) Axiom_54$0))

(assert (or (not Axiom_55$0)
    (forall ((?x Loc))
            (or (= (read$0 data_2$0 ?x) (read$0 data_3$0 ?x))
                (not (in$0 ?x (setminus$0 Alloc$0 FP_5$0)))))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$1 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$1 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$1 ?f ?x) (read$1 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
