(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sl_sorted_set/traverse.spl:46:3-4:An invariant might not be maintained by a loop in procedure traverse
  tests/spl/sl_sorted_set/traverse.spl:36:14:Related location: This is the loop invariant that might not be maintained
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldLoc Loc) Loc)
(declare-fun read$1 (FldInt Loc) Int)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetInt)
(declare-fun emptyset$1 () SetLoc)
(declare-fun setenum$0 (Int) SetInt)
(declare-fun setenum$1 (Loc) SetLoc)
(declare-fun union$0 (SetInt SetInt) SetInt)
(declare-fun union$1 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetInt SetInt) SetInt)
(declare-fun intersection$1 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetInt SetInt) SetInt)
(declare-fun setminus$1 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun in$0 (Int SetInt) Bool)
(declare-fun in$1 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Axiom_15$0 () Bool)
(declare-fun Axiom_16$0 () Bool)
(declare-fun Axiom_17$0 () Bool)
(declare-fun Axiom_18$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_2$0 () SetLoc)
(declare-fun c1_4$0 () SetInt)
(declare-fun c1_5$0 () SetInt)
(declare-fun c1_init$0 () SetInt)
(declare-fun c2_4$0 () SetInt)
(declare-fun c2_5$0 () SetInt)
(declare-fun c2_init$0 () SetInt)
(declare-fun content_2$0 () SetInt)
(declare-fun content_init$0 () SetInt)
(declare-fun curr_4$0 () Loc)
(declare-fun curr_5$0 () Loc)
(declare-fun curr_init$0 () Loc)
(declare-fun data$0 () FldInt)
(declare-fun lst_2$0 () Loc)
(declare-fun lst_init$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun prev_4$0 () Loc)
(declare-fun prev_5$0 () Loc)
(declare-fun prev_init$0 () Loc)
(declare-fun sk_?X_51$0 () SetLoc)
(declare-fun sk_?X_52$0 () SetLoc)
(declare-fun sk_?X_53$0 () SetLoc)
(declare-fun sk_?X_54$0 () SetLoc)
(declare-fun sk_?X_55$0 () SetLoc)
(declare-fun sk_?X_56$0 () SetLoc)
(declare-fun sk_?X_57$0 () SetLoc)
(declare-fun sk_?X_58$0 () SetLoc)
(declare-fun sk_?X_59$0 () SetLoc)
(declare-fun sk_?X_60$0 () SetLoc)
(declare-fun sk_?X_61$0 () SetLoc)
(declare-fun sk_?X_62$0 () SetLoc)
(declare-fun sk_?X_63$0 () SetLoc)
(declare-fun sk_?X_64$0 () SetLoc)
(declare-fun sk_?X_65$0 () SetLoc)
(declare-fun sk_?X_66$0 () SetLoc)
(declare-fun sk_?e_3$0 () Int)
(declare-fun sk_?e_4$0 () Int)
(declare-fun sk_FP_2$0 () SetLoc)
(declare-fun sk_FP_3$0 () SetLoc)
(declare-fun sk_l1_3$0 () Loc)
(declare-fun sk_l1_4$0 () Loc)
(declare-fun sk_l2_3$0 () Loc)
(declare-fun sk_l2_4$0 () Loc)
(declare-fun sorted_set_c$0 (FldInt FldLoc Loc Loc) SetInt)
(declare-fun sorted_set_domain$0 (FldInt FldLoc Loc Loc) SetLoc)
(declare-fun sorted_set_struct$0 (SetLoc FldInt FldLoc Loc Loc SetInt) Bool)
(declare-fun t_192$0 () Int)
(declare-fun t_193$0 () Int)
(declare-fun t_194$0 () Int)
(declare-fun t_195$0 () Int)
(declare-fun t_196$0 () Int)
(declare-fun t_197$0 () Int)
(declare-fun t_198$0 () Int)
(declare-fun t_199$0 () Int)
(declare-fun t_200$0 () Int)
(declare-fun t_201$0 () Int)
(declare-fun t_202$0 () Int)
(declare-fun t_203$0 () Int)
(declare-fun t_204$0 () Int)
(declare-fun t_205$0 () Int)
(declare-fun t_206$0 () Int)
(declare-fun t_207$0 () Int)
(declare-fun t_208$0 () Int)
(declare-fun t_209$0 () Int)
(declare-fun t_210$0 () Int)
(declare-fun t_211$0 () Int)
(declare-fun t_212$0 () Int)
(declare-fun t_213$0 () Int)
(declare-fun t_214$0 () Int)
(declare-fun t_215$0 () Int)
(declare-fun t_216$0 () Int)
(declare-fun t_217$0 () Int)
(declare-fun t_218$0 () Int)
(declare-fun t_219$0 () Int)
(declare-fun t_220$0 () Int)
(declare-fun t_221$0 () Int)
(declare-fun t_222$0 () Int)
(declare-fun t_223$0 () Int)
(declare-fun t_224$0 () Int)
(declare-fun t_225$0 () Int)
(declare-fun t_226$0 () Int)
(declare-fun t_227$0 () Int)
(declare-fun t_228$0 () Int)
(declare-fun t_229$0 () Int)
(declare-fun t_230$0 () Int)
(declare-fun t_231$0 () Int)
(declare-fun t_232$0 () Int)
(declare-fun t_233$0 () Int)
(declare-fun t_234$0 () Int)
(declare-fun t_235$0 () Int)
(declare-fun t_236$0 () Loc)
(declare-fun t_237$0 () Loc)
(declare-fun t_238$0 () Loc)
(declare-fun t_239$0 () Loc)
(declare-fun t_240$0 () Loc)
(declare-fun t_241$0 () Loc)
(declare-fun t_242$0 () Loc)
(declare-fun t_243$0 () Loc)
(declare-fun t_244$0 () Loc)
(declare-fun t_245$0 () Loc)
(declare-fun t_246$0 () Loc)
(declare-fun t_247$0 () Loc)
(declare-fun t_248$0 () Loc)
(declare-fun t_249$0 () Loc)
(declare-fun t_250$0 () Loc)
(declare-fun t_251$0 () Loc)
(declare-fun t_252$0 () Loc)
(declare-fun t_253$0 () Loc)
(declare-fun t_254$0 () Loc)
(declare-fun t_255$0 () Loc)
(declare-fun t_256$0 () Loc)
(declare-fun t_257$0 () Loc)
(declare-fun t_258$0 () Loc)
(declare-fun t_259$0 () Loc)
(declare-fun t_260$0 () Loc)
(declare-fun t_261$0 () Loc)
(declare-fun t_262$0 () Loc)
(declare-fun t_263$0 () Loc)
(declare-fun t_264$0 () Loc)
(declare-fun t_265$0 () Loc)
(declare-fun t_266$0 () Loc)
(declare-fun t_267$0 () Loc)
(declare-fun t_268$0 () Loc)
(declare-fun t_269$0 () Loc)
(declare-fun t_270$0 () Loc)
(declare-fun t_271$0 () Loc)
(declare-fun t_272$0 () Loc)
(declare-fun t_273$0 () Loc)
(declare-fun t_274$0 () Loc)
(declare-fun t_275$0 () Loc)
(declare-fun t_276$0 () Loc)
(declare-fun t_277$0 () Loc)
(declare-fun t_278$0 () Loc)
(declare-fun t_279$0 () Loc)
(declare-fun witness$0 (FldInt Int SetInt) Loc)

(assert (=
  (witness$0 data$0 sk_?e_4$0
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_279$0))

(assert (=
  (witness$0 data$0 sk_?e_4$0
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_278$0))

(assert (=
  (witness$0 data$0 sk_?e_4$0
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_277$0))

(assert (=
  (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_276$0))

(assert (=
  (witness$0 data$0 sk_?e_3$0
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_275$0))

(assert (=
  (witness$0 data$0 sk_?e_3$0
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_274$0))

(assert (=
  (witness$0 data$0 sk_?e_3$0
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_273$0))

(assert (=
  (witness$0 data$0 sk_?e_3$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_272$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_271$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_270$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_269$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_268$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_267$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_266$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_265$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_264$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_263$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_262$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_261$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_260$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_259$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_258$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_257$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_256$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_init$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_255$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_init$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_254$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_init$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_253$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_init$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_252$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_5$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_251$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_5$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_250$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_5$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_249$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_5$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_248$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_init$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_247$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_init$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_246$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_init$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_245$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_init$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_244$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_5$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_243$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_5$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_242$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_5$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_241$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_5$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_240$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_4$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_239$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_4$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_238$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_4$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_237$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_4$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_236$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_235$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_234$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_233$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_232$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_3$0
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_231$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_3$0
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_230$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_3$0
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_229$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_3$0
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_228$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_227$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_226$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_225$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_224$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_223$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_222$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_221$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_220$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_219$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_218$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_217$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_216$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_215$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_214$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_213$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_212$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_init$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_211$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_init$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_210$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_init$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_209$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_init$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_208$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_5$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_207$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_5$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_206$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_5$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_205$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_5$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_204$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_init$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_203$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_init$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_202$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_init$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_201$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_init$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_200$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_5$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_199$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_5$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_198$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_5$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_197$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_5$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_196$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_4$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_195$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_4$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_194$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_4$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_193$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_4$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_192$0))

(assert (forall ((?f FldLoc)) (= (read$0 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$1 x (setenum$1 y)))
            (and (not (= x y)) (not (in$1 x (setenum$1 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x (setminus$1 X Y)) (not (in$1 x Y)))
            (and (or (in$1 x Y) (not (in$1 x X)))
                 (not (in$1 x (setminus$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x Y) (in$1 x (intersection$1 X Y)))
            (and (or (not (in$1 x X)) (not (in$1 x Y)))
                 (not (in$1 x (intersection$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x (union$1 X Y)) (or (in$1 x X) (in$1 x Y)))
            (and (not (in$1 x X)) (not (in$1 x Y))
                 (not (in$1 x (union$1 X Y)))))))

(assert (forall ((x Loc)) (not (in$1 x emptyset$1))))

(assert (forall ((x Int) (y Int))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Int)) (not (in$0 x emptyset$0))))

(assert (or (not Axiom_15$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_64$0))
                (not (in$1 l2 sk_?X_64$0))))))

(assert (or (and (Btwn$0 next$0 curr_init$0 null$0 null$0) Axiom_16$0)
    (not
         (sorted_set_struct$0 sk_?X_56$0 data$0 next$0 curr_init$0 null$0
           c1_init$0))))

(assert (or (not Axiom_17$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_5$0))
                (not (in$1 l1 sk_?X_66$0)) (not (in$1 l2 sk_?X_66$0))))))

(assert (or (and (Btwn$0 next$0 lst_init$0 curr_init$0 curr_init$0) Axiom_18$0)
    (not
         (sorted_set_struct$0 sk_?X_58$0 data$0 next$0 lst_init$0 curr_init$0
           c2_init$0))))

(assert (= c1_4$0 c1_init$0))

(assert (= c2_4$0 c2_init$0))

(assert (= content_2$0 content_init$0))

(assert (= curr_5$0 (read$0 next$0 curr_4$0)))

(assert (= prev_4$0 prev_init$0))

(assert (= Alloc$0 (union$1 FP_Caller$0 Alloc$0)))

(assert (= sk_?X_52$0 sk_?X_54$0))

(assert (= sk_?X_54$0 (union$1 sk_?X_57$0 sk_?X_55$0)))

(assert (= sk_?X_56$0 (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0)))

(assert (= sk_?X_58$0 (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0)))

(assert (or
    (and (= (read$0 next$0 prev_init$0) curr_init$0)
         (= emptyset$1 emptyset$1)
         (= emptyset$1 (intersection$1 sk_?X_57$0 sk_?X_55$0))
         (= c1_init$0 (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
         (= c2_init$0 (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
         (= content_init$0 (union$0 c1_init$0 c2_init$0)) (= sk_?X_52$0 FP$0)
         (Btwn$0 next$0 lst_init$0 prev_init$0 curr_init$0)
         (sorted_set_struct$0 sk_?X_56$0 data$0 next$0 curr_init$0 null$0
           c1_init$0)
         (sorted_set_struct$0 sk_?X_58$0 data$0 next$0 lst_init$0 curr_init$0
           c2_init$0)
         (or (= curr_init$0 null$0) (= prev_init$0 null$0)
             (< (read$1 data$0 prev_init$0) (read$1 data$0 curr_init$0)))
         (not (= prev_init$0 curr_init$0)))
    (and (= emptyset$1 emptyset$1)
         (= c1_init$0 (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
         (= c2_init$0 emptyset$0)
         (= content_init$0 (union$0 c1_init$0 c2_init$0))
         (= curr_init$0 lst_init$0) (= prev_init$0 null$0)
         (= sk_?X_51$0 FP$0)
         (sorted_set_struct$0 sk_?X_56$0 data$0 next$0 curr_init$0 null$0
           c1_init$0)
         (or (= curr_init$0 null$0) (= prev_init$0 null$0)
             (< (read$1 data$0 prev_init$0) (read$1 data$0 curr_init$0))))))

(assert (= sk_?X_60$0 sk_?X_62$0))

(assert (= sk_?X_62$0 (union$1 sk_?X_65$0 sk_?X_63$0)))

(assert (= sk_?X_64$0 (sorted_set_domain$0 data$0 next$0 curr_5$0 null$0)))

(assert (= sk_?X_66$0 (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_5$0)))

(assert (= sk_FP_3$0 sk_?X_59$0))

(assert (or (in$0 sk_?e_4$0 c2_5$0)
    (and (in$0 sk_?e_4$0 (union$0 c1_5$0 c2_5$0))
         (not (in$0 sk_?e_4$0 content_2$0)))
    (and (in$0 sk_?e_4$0 c1_5$0)
         (not
              (in$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))))
    (and (in$0 sk_?e_4$0 content_2$0)
         (not (in$0 sk_?e_4$0 (union$0 c1_5$0 c2_5$0))))
    (and (in$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
         (not (in$0 sk_?e_4$0 c1_5$0)))
    (and (in$1 sk_l2_4$0 sk_FP_3$0) (not (in$1 sk_l2_4$0 FP$0)))
    (and (not (= curr_5$0 null$0)) (not (= prev_5$0 null$0))
         (not (< (read$1 data$0 prev_5$0) (read$1 data$0 curr_5$0))))
    (not (= curr_5$0 lst_2$0)) (not (= prev_5$0 null$0))
    (not (Btwn$0 next$0 curr_5$0 null$0 null$0))
    (and (Btwn$0 next$0 sk_l1_4$0 sk_l2_4$0 null$0)
         (in$1 sk_l1_4$0 sk_?X_64$0) (in$1 sk_l2_4$0 sk_?X_64$0)
         (not (= sk_l1_4$0 sk_l2_4$0))
         (not (< (read$1 data$0 sk_l1_4$0) (read$1 data$0 sk_l2_4$0))))))

(assert (not (in$1 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_init$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next$0 curr_init$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_init$0
                          null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_init$0 l1 curr_init$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))
                 (not (= l1 curr_init$0)))
            (and
                 (or (= l1 curr_init$0)
                     (not (Btwn$0 next$0 lst_init$0 l1 curr_init$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst_init$0
                          curr_init$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))))
            (not
                 (in$0 v
                   (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
              (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))
            (not
                 (in$0 v
                   (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$1 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (and (Btwn$0 next$0 curr_5$0 null$0 null$0) Axiom_15$0)
    (not
         (sorted_set_struct$0 sk_?X_64$0 data$0 next$0 curr_5$0 null$0
           c1_5$0))))

(assert (or (not Axiom_16$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_56$0))
                (not (in$1 l2 sk_?X_56$0))))))

(assert (or (and (Btwn$0 next$0 lst_2$0 curr_5$0 curr_5$0) Axiom_17$0)
    (not
         (sorted_set_struct$0 sk_?X_66$0 data$0 next$0 lst_2$0 curr_5$0
           c2_5$0))))

(assert (or (not Axiom_18$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_init$0))
                (not (in$1 l1 sk_?X_58$0)) (not (in$1 l2 sk_?X_58$0))))))

(assert (= FP_Caller_2$0 (setminus$1 FP_Caller$0 FP$0)))

(assert (= c1_5$0 (setminus$0 c1_4$0 (setenum$0 (read$1 data$0 curr_4$0)))))

(assert (= c2_5$0 (union$0 c2_4$0 (setenum$0 (read$1 data$0 curr_4$0)))))

(assert (= curr_4$0 curr_init$0))

(assert (= lst_2$0 lst_init$0))

(assert (= prev_5$0 curr_4$0))

(assert (= sk_?X_51$0 sk_?X_53$0))

(assert (= sk_?X_53$0 sk_?X_55$0))

(assert (= sk_?X_55$0 sk_?X_56$0))

(assert (= sk_?X_57$0 sk_?X_58$0))

(assert (= FP_Caller$0 (union$1 FP$0 FP_Caller$0)))

(assert (= sk_?X_59$0 sk_?X_61$0))

(assert (= sk_?X_61$0 sk_?X_63$0))

(assert (= sk_?X_63$0 sk_?X_64$0))

(assert (= sk_?X_65$0 sk_?X_66$0))

(assert (= sk_FP_2$0 sk_?X_60$0))

(assert (or (= prev_5$0 curr_5$0)
    (in$1 sk_l1_3$0 (intersection$1 sk_?X_65$0 sk_?X_63$0))
    (and (in$0 sk_?e_3$0 (union$0 c1_5$0 c2_5$0))
         (not (in$0 sk_?e_3$0 content_2$0)))
    (and (in$0 sk_?e_3$0 c1_5$0)
         (not
              (in$0 sk_?e_3$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))))
    (and (in$0 sk_?e_3$0 c2_5$0)
         (not
              (in$0 sk_?e_3$0
                (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))))
    (and (in$0 sk_?e_3$0 content_2$0)
         (not (in$0 sk_?e_3$0 (union$0 c1_5$0 c2_5$0))))
    (and (in$0 sk_?e_3$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
         (not (in$0 sk_?e_3$0 c1_5$0)))
    (and (in$0 sk_?e_3$0 (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
         (not (in$0 sk_?e_3$0 c2_5$0)))
    (and (in$1 sk_l1_3$0 sk_FP_2$0) (not (in$1 sk_l1_3$0 FP$0)))
    (and (not (= curr_5$0 null$0)) (not (= prev_5$0 null$0))
         (not (< (read$1 data$0 prev_5$0) (read$1 data$0 curr_5$0))))
    (not (= (read$0 next$0 prev_5$0) curr_5$0))
    (not (Btwn$0 next$0 curr_5$0 null$0 null$0))
    (not (Btwn$0 next$0 lst_2$0 curr_5$0 curr_5$0))
    (not (Btwn$0 next$0 lst_2$0 prev_5$0 curr_5$0))
    (and (Btwn$0 next$0 sk_l1_3$0 sk_l2_3$0 null$0)
         (in$1 sk_l1_3$0 sk_?X_64$0) (in$1 sk_l2_3$0 sk_?X_64$0)
         (not (= sk_l1_3$0 sk_l2_3$0))
         (not (< (read$1 data$0 sk_l1_3$0) (read$1 data$0 sk_l2_3$0))))
    (and (Btwn$0 next$0 sk_l1_3$0 sk_l2_3$0 curr_5$0)
         (in$1 sk_l1_3$0 sk_?X_66$0) (in$1 sk_l2_3$0 sk_?X_66$0)
         (not (= sk_l1_3$0 sk_l2_3$0))
         (not (< (read$1 data$0 sk_l1_3$0) (read$1 data$0 sk_l2_3$0))))))

(assert (not (= curr_4$0 null$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_5$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_5$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_5$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_5$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_5$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_5$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_5$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_5$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_2$0 l1 curr_5$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_5$0))
                 (not (= l1 curr_5$0)))
            (and
                 (or (= l1 curr_5$0)
                     (not (Btwn$0 next$0 lst_2$0 l1 curr_5$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_5$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_5$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
              (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_5$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$1 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$1 ?y ?X))
            (in$1 (ep$0 ?f ?X ?x) ?X))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$0 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$0 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$0 ?f ?x) (read$0 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
