(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sl_sorted_set/union.spl:38:8-44:Possible heap access through null or dangling reference
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldLoc Loc) Loc)
(declare-fun read$1 (FldInt Loc) Int)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetInt)
(declare-fun emptyset$1 () SetLoc)
(declare-fun setenum$0 (Int) SetInt)
(declare-fun setenum$1 (Loc) SetLoc)
(declare-fun union$0 (SetInt SetInt) SetInt)
(declare-fun union$1 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetInt SetInt) SetInt)
(declare-fun intersection$1 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetInt SetInt) SetInt)
(declare-fun setminus$1 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun Frame$0 (SetLoc SetLoc FldLoc FldLoc) Bool)
(declare-fun Frame$1 (SetLoc SetLoc FldInt FldInt) Bool)
(declare-fun in$0 (Int SetInt) Bool)
(declare-fun in$1 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Alloc_3$0 () SetLoc)
(declare-fun Axiom_35$0 () Bool)
(declare-fun Axiom_36$0 () Bool)
(declare-fun Axiom_37$0 () Bool)
(declare-fun Axiom_38$0 () Bool)
(declare-fun Axiom_39$0 () Bool)
(declare-fun Axiom_40$0 () Bool)
(declare-fun Axiom_41$0 () Bool)
(declare-fun Axiom_42$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_4$0 () SetLoc)
(declare-fun FP_5$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_1$0 () SetLoc)
(declare-fun content1$0 () SetInt)
(declare-fun content1_2$0 () SetInt)
(declare-fun content2$0 () SetInt)
(declare-fun content2_2$0 () SetInt)
(declare-fun data$0 () FldInt)
(declare-fun lst1$0 () Loc)
(declare-fun lst2$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun next_2$0 () FldLoc)
(declare-fun sk_?X_41$0 () SetLoc)
(declare-fun sk_?X_42$0 () SetLoc)
(declare-fun sk_?X_43$0 () SetLoc)
(declare-fun sk_?X_44$0 () SetLoc)
(declare-fun sk_?X_45$0 () SetLoc)
(declare-fun sk_?X_46$0 () SetLoc)
(declare-fun sk_?X_47$0 () SetLoc)
(declare-fun sorted_set_c$0 (FldInt FldLoc Loc Loc) SetInt)
(declare-fun sorted_set_domain$0 (FldInt FldLoc Loc Loc) SetLoc)
(declare-fun sorted_set_struct$0 (SetLoc FldInt FldLoc Loc Loc SetInt) Bool)
(declare-fun t_215$0 () Int)
(declare-fun t_216$0 () Int)
(declare-fun t_217$0 () Int)
(declare-fun t_218$0 () Int)
(declare-fun t_219$0 () Int)
(declare-fun t_220$0 () Int)
(declare-fun t_221$0 () Int)
(declare-fun t_222$0 () Int)
(declare-fun t_223$0 () Loc)
(declare-fun t_224$0 () Loc)
(declare-fun t_225$0 () Loc)
(declare-fun t_226$0 () Loc)
(declare-fun t_227$0 () Loc)
(declare-fun t_228$0 () Loc)
(declare-fun t_229$0 () Loc)
(declare-fun t_230$0 () Loc)
(declare-fun t_231$0 () Loc)
(declare-fun t_232$0 () Loc)
(declare-fun t_233$0 () Loc)
(declare-fun t_234$0 () Loc)
(declare-fun t_235$0 () Loc)
(declare-fun t_236$0 () Loc)
(declare-fun t_237$0 () Loc)
(declare-fun t_238$0 () Loc)
(declare-fun t_239$0 () Loc)
(declare-fun t_240$0 () Loc)
(declare-fun t_241$0 () Loc)
(declare-fun t_242$0 () Loc)
(declare-fun t_243$0 () Loc)
(declare-fun t_244$0 () Loc)
(declare-fun tmp_2$0 () Loc)
(declare-fun witness$0 (FldInt Int SetInt) Loc)

(assert (=
  (witness$0 data$0 (read$1 data$0 lst2$0)
    (sorted_set_c$0 data$0 next_2$0 tmp_2$0 null$0))
  t_244$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 lst2$0)
    (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
  t_243$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 lst2$0)
    (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
  t_242$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 lst2$0)
    (sorted_set_c$0 data$0 next$0 (read$0 next$0 lst2$0) null$0))
  t_241$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 lst1$0)
    (sorted_set_c$0 data$0 next_2$0 tmp_2$0 null$0))
  t_240$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 lst1$0)
    (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
  t_239$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 lst1$0)
    (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
  t_238$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 lst1$0)
    (sorted_set_c$0 data$0 next$0 (read$0 next$0 lst2$0) null$0))
  t_237$0))

(assert (=
  (ep$0 next$0 FP_4$0
    (witness$0 data$0 (read$1 data$0 lst2$0)
      (sorted_set_c$0 data$0 next_2$0 tmp_2$0 null$0)))
  t_236$0))

(assert (=
  (ep$0 next$0 FP_4$0
    (witness$0 data$0 (read$1 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_235$0))

(assert (=
  (ep$0 next$0 FP_4$0
    (witness$0 data$0 (read$1 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_234$0))

(assert (=
  (ep$0 next$0 FP_4$0
    (witness$0 data$0 (read$1 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 (read$0 next$0 lst2$0) null$0)))
  t_233$0))

(assert (=
  (ep$0 next$0 FP_4$0
    (witness$0 data$0 (read$1 data$0 lst1$0)
      (sorted_set_c$0 data$0 next_2$0 tmp_2$0 null$0)))
  t_232$0))

(assert (=
  (ep$0 next$0 FP_4$0
    (witness$0 data$0 (read$1 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_231$0))

(assert (=
  (ep$0 next$0 FP_4$0
    (witness$0 data$0 (read$1 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_230$0))

(assert (=
  (ep$0 next$0 FP_4$0
    (witness$0 data$0 (read$1 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 (read$0 next$0 lst2$0) null$0)))
  t_229$0))

(assert (= (ep$0 next$0 FP_4$0 tmp_2$0) t_228$0))

(assert (= (ep$0 next$0 FP_4$0 lst2$0) t_227$0))

(assert (= (ep$0 next$0 FP_4$0 lst1$0) t_226$0))

(assert (= (ep$0 next$0 FP_4$0 (read$0 next$0 lst2$0)) t_225$0))

(assert (= (ep$0 next$0 FP_4$0 null$0) t_224$0))

(assert (= (read$0 next_2$0 lst2$0) t_223$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 lst2$0)
      (sorted_set_c$0 data$0 next_2$0 tmp_2$0 null$0)))
  t_222$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_221$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_220$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 (read$0 next$0 lst2$0) null$0)))
  t_219$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 lst1$0)
      (sorted_set_c$0 data$0 next_2$0 tmp_2$0 null$0)))
  t_218$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_217$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_216$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 (read$0 next$0 lst2$0) null$0)))
  t_215$0))

(assert (forall ((?f FldLoc)) (= (read$0 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$1 x (setenum$1 y)))
            (and (not (= x y)) (not (in$1 x (setenum$1 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x (setminus$1 X Y)) (not (in$1 x Y)))
            (and (or (in$1 x Y) (not (in$1 x X)))
                 (not (in$1 x (setminus$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x Y) (in$1 x (intersection$1 X Y)))
            (and (or (not (in$1 x X)) (not (in$1 x Y)))
                 (not (in$1 x (intersection$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x (union$1 X Y)) (or (in$1 x X) (in$1 x Y)))
            (and (not (in$1 x X)) (not (in$1 x Y))
                 (not (in$1 x (union$1 X Y)))))))

(assert (forall ((x Loc)) (not (in$1 x emptyset$1))))

(assert (forall ((x Int) (y Int))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Int)) (not (in$0 x emptyset$0))))

(assert (or (and (Btwn$0 next$0 (read$0 next$0 lst2$0) null$0 null$0) Axiom_35$0)
    (not
         (sorted_set_struct$0 sk_?X_46$0 data$0 next$0 (read$0 next$0 lst2$0)
           null$0 content2_2$0))))

(assert (or (not Axiom_36$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_44$0))
                (not (in$1 l2 sk_?X_44$0))))))

(assert (or (and (Btwn$0 next$0 lst1$0 null$0 null$0) Axiom_37$0)
    (not
         (sorted_set_struct$0 sk_?X_47$0 data$0 next$0 lst1$0 null$0
           content1_2$0))))

(assert (or (not Axiom_38$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_43$0))
                (not (in$1 l2 sk_?X_43$0))))))

(assert (or (and (Btwn$0 next_2$0 tmp_2$0 null$0 null$0) Axiom_39$0)
    (not
         (sorted_set_struct$0 sk_?X_41$0 data$0 next_2$0 tmp_2$0 null$0
           (union$0 content1_2$0 content2_2$0)))))

(assert (= FP_Caller_1$0 (setminus$1 FP_Caller$0 FP$0)))

(assert (Frame$1 FP_4$0 Alloc$0 data$0 data$0))

(assert (= Alloc_3$0 (union$1 FP_5$0 Alloc_3$0)))

(assert (= emptyset$1 (intersection$1 sk_?X_44$0 sk_?X_43$0)))

(assert (= content2$0 (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))

(assert (= sk_?X_42$0 FP$0))

(assert (= sk_?X_44$0 (sorted_set_domain$0 data$0 next$0 lst1$0 null$0)))

(assert (sorted_set_struct$0 sk_?X_43$0 data$0 next$0 lst2$0 null$0 content2$0))

(assert (= emptyset$1 (intersection$1 sk_?X_47$0 sk_?X_46$0)))

(assert (= content2_2$0 (sorted_set_c$0 data$0 next$0 (read$0 next$0 lst2$0) null$0)))

(assert (= sk_?X_45$0 FP_4$0))

(assert (= sk_?X_47$0 (sorted_set_domain$0 data$0 next$0 lst1$0 null$0)))

(assert (sorted_set_struct$0 sk_?X_46$0 data$0 next$0 (read$0 next$0 lst2$0) null$0
  content2_2$0))

(assert (= (union$0 content1_2$0 content2_2$0)
  (sorted_set_c$0 data$0 next_2$0 tmp_2$0 null$0)))

(assert (= sk_?X_41$0 (sorted_set_domain$0 data$0 next_2$0 tmp_2$0 null$0)))

(assert (not (= lst1$0 null$0)))

(assert (not (< (read$1 data$0 lst1$0) (read$1 data$0 lst2$0))))

(assert (not (in$1 null$0 Alloc_3$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 (read$0 next$0 lst2$0) null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 (read$0 next$0 lst2$0)
                     null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 (read$0 next$0 lst2$0) null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 (read$0 next$0 lst2$0)
                     null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 (read$0 next$0 lst2$0) l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 (read$0 next$0 lst2$0)
                     null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next$0 (read$0 next$0 lst2$0) l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0
                          (read$0 next$0 lst2$0) null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst2$0 l1 null$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst2$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 lst2$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst2$0 null$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 (read$0 next$0 lst2$0)
                    null$0))))
            (not
                 (in$0 v
                   (sorted_set_c$0 data$0 next$0 (read$0 next$0 lst2$0)
                     null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst2$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 (read$0 next$0 lst2$0) null$0))
              null$0)
            (in$0 v
              (sorted_set_c$0 data$0 next$0 (read$0 next$0 lst2$0) null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 (read$0 next$0 lst2$0) null$0))
              (sorted_set_domain$0 data$0 next$0 (read$0 next$0 lst2$0)
                null$0))
            (not
                 (in$0 v
                   (sorted_set_c$0 data$0 next$0 (read$0 next$0 lst2$0)
                     null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
              (sorted_set_domain$0 data$0 next$0 lst2$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst2$0 null$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$1 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$1 ?y ?X))
            (in$1 (ep$0 ?f ?X ?x) ?X))))

(assert (or (and Axiom_42$0 Axiom_41$0 Axiom_40$0)
    (not (Frame$0 FP_4$0 Alloc$0 next$0 next_2$0))))

(assert (or (not Axiom_35$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_46$0))
                (not (in$1 l2 sk_?X_46$0))))))

(assert (or (and (Btwn$0 next$0 lst1$0 null$0 null$0) Axiom_36$0)
    (not
         (sorted_set_struct$0 sk_?X_44$0 data$0 next$0 lst1$0 null$0
           content1$0))))

(assert (or (not Axiom_37$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_47$0))
                (not (in$1 l2 sk_?X_47$0))))))

(assert (or (and (Btwn$0 next$0 lst2$0 null$0 null$0) Axiom_38$0)
    (not
         (sorted_set_struct$0 sk_?X_43$0 data$0 next$0 lst2$0 null$0
           content2$0))))

(assert (or (not Axiom_39$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next_2$0 l1 l2 null$0))
                (not (in$1 l1 sk_?X_41$0)) (not (in$1 l2 sk_?X_41$0))))))

(assert (= FP_5$0
  (union$1 (setminus$1 FP$0 FP_4$0)
    (union$1 (intersection$1 Alloc_3$0 FP_4$0)
      (setminus$1 Alloc_3$0 Alloc$0)))))

(assert (> (read$1 data$0 lst1$0) (read$1 data$0 lst2$0)))

(assert (Frame$0 FP_4$0 Alloc$0 next$0 next_2$0))

(assert (= Alloc$0 (union$1 FP_Caller$0 Alloc$0)))

(assert (= content1$0 (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))

(assert (= sk_?X_42$0 (union$1 sk_?X_44$0 sk_?X_43$0)))

(assert (= sk_?X_43$0 (sorted_set_domain$0 data$0 next$0 lst2$0 null$0)))

(assert (= FP_Caller$0 (union$1 FP$0 FP_Caller$0)))

(assert (sorted_set_struct$0 sk_?X_44$0 data$0 next$0 lst1$0 null$0 content1$0))

(assert (= content1_2$0 (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))

(assert (= sk_?X_45$0 (union$1 sk_?X_47$0 sk_?X_46$0)))

(assert (= sk_?X_46$0
  (sorted_set_domain$0 data$0 next$0 (read$0 next$0 lst2$0) null$0)))

(assert (= FP$0 (union$1 FP_4$0 FP$0)))

(assert (sorted_set_struct$0 sk_?X_47$0 data$0 next$0 lst1$0 null$0 content1_2$0))

(assert (= sk_?X_41$0
  (union$1 (intersection$1 Alloc_3$0 FP_4$0) (setminus$1 Alloc_3$0 Alloc$0))))

(assert (sorted_set_struct$0 sk_?X_41$0 data$0 next_2$0 tmp_2$0 null$0
  (union$0 content1_2$0 content2_2$0)))

(assert (not (= lst2$0 null$0)))

(assert (not (in$1 null$0 Alloc$0)))

(assert (not (in$1 lst2$0 FP_5$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst1$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next_2$0 tmp_2$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_2$0 tmp_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst1$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next_2$0 tmp_2$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_2$0 tmp_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst1$0 l1 null$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst1$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 lst1$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst1$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_2$0 tmp_2$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_2$0 tmp_2$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next_2$0 tmp_2$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next_2$0 tmp_2$0 null$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst1$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst1$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next_2$0 tmp_2$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next_2$0 tmp_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next_2$0 tmp_2$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next_2$0 tmp_2$0 null$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
              (sorted_set_domain$0 data$0 next$0 lst1$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst1$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next_2$0 tmp_2$0 null$0))
              (sorted_set_domain$0 data$0 next_2$0 tmp_2$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next_2$0 tmp_2$0 null$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$1 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (not Axiom_40$0)
    (forall ((?x Loc) (?y Loc) (?z Loc))
            (or (in$1 ?x FP_4$0)
                (and (Btwn$0 next$0 ?x ?z ?y) (Btwn$0 next_2$0 ?x ?z ?y))
                (and (not (Btwn$0 next$0 ?x ?z ?y))
                     (not (Btwn$0 next_2$0 ?x ?z ?y)))
                (not (= ?x (ep$0 next$0 FP_4$0 ?x)))))))

(assert (or (not Axiom_41$0)
    (forall ((?x Loc) (?y Loc) (?z Loc))
            (or (and (Btwn$0 next$0 ?x ?z ?y) (Btwn$0 next_2$0 ?x ?z ?y))
                (and (not (Btwn$0 next$0 ?x ?z ?y))
                     (not (Btwn$0 next_2$0 ?x ?z ?y)))
                (not
                     (or (Btwn$0 next$0 ?x ?y (ep$0 next$0 FP_4$0 ?x))
                         (and (Btwn$0 next$0 ?x ?y ?y)
                              (not
                                   (Btwn$0 next$0 ?x (ep$0 next$0 FP_4$0 ?x)
                                     (ep$0 next$0 FP_4$0 ?x))))))))))

(assert (or (not Axiom_42$0)
    (forall ((?x Loc))
            (or (= (read$0 next$0 ?x) (read$0 next_2$0 ?x))
                (not (in$1 ?x (setminus$1 Alloc$0 FP_4$0)))))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$0 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$0 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$0 ?f ?x) (read$0 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
