(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S4)
(declare-fun f4 (S5 S4) S2)
(declare-fun f5 () S5)
(declare-fun f6 () S2)
(declare-fun f7 () S3)
(declare-fun f8 () S4)
(declare-fun f9 (S6 S3) Int)
(declare-fun f10 (S7 Int) S6)
(declare-fun f11 () S7)
(declare-fun f12 (S8 Int) S3)
(declare-fun f13 () S8)
(declare-fun f14 (S9 Int) Int)
(declare-fun f15 () S9)
(declare-fun f16 () S4)
(declare-fun f17 () S6)
(declare-fun f18 (S10 S4) S4)
(declare-fun f19 () S10)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 (f3 f6 f7)) f7) f8)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f8) ?v0) f8)))
(assert (forall ((?v0 S3)) (= (f9 (f10 f11 1) ?v0) 1)))
(assert (= (f3 (f4 f5 f8) (f12 f13 2)) f8))
(assert (= (f9 (f10 f11 1) (f12 f13 2)) 1))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f12 f13 0)) f8)))
(assert (forall ((?v0 Int)) (= (f9 (f10 f11 ?v0) (f12 f13 0)) 1)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f12 f13 0)) f8)))
(assert (forall ((?v0 Int)) (= (f9 (f10 f11 ?v0) (f12 f13 0)) 1)))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f14 f15 (f9 (f10 f11 ?v0) ?v1)) (f9 (f10 f11 (f14 f15 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 (f10 f11 ?v0) (f12 f13 2)))) (= (f14 f15 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f9 (f10 f11 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f9 (f10 f11 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f13 2))) (= (f9 (f10 f11 (f14 f15 ?v0)) ?v_0) (f9 (f10 f11 ?v0) ?v_0)))))
(assert (= (f14 f15 1) 1))
(assert (forall ((?v0 S4)) (= (= f8 ?v0) (= ?v0 f8))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S3)) (not (= (f3 f6 ?v0) f16))))
(assert (= (f14 f15 0) 0))
(assert (forall ((?v0 S4)) (= (= f16 ?v0) (= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= (f14 f15 ?v0) 0) (= ?v0 0))))
(assert (not (= f16 f8)))
(assert (not (= 0 1)))
(assert (not (= f8 f16)))
(assert (not (= 1 0)))
(assert (forall ((?v0 S4) (?v1 S3)) (=> (not (= ?v0 f16)) (not (= (f3 (f4 f5 ?v0) ?v1) f16)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (not (= ?v0 0)) (not (= (f9 (f10 f11 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S4)) (= (= (f3 (f4 f5 ?v0) (f12 f13 2)) f16) (= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (= (f9 (f10 f11 ?v0) (f12 f13 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S4) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f16) (and (= ?v0 f16) (not (= ?v1 (f12 f13 0)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f9 (f10 f11 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f12 f13 0)))))))
(assert (= (f3 (f4 f5 f16) (f12 f13 2)) f16))
(assert (= (f9 (f10 f11 0) (f12 f13 2)) 0))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f16) (f12 f13 (+ (f9 f17 ?v0) 1))) f16)))
(assert (forall ((?v0 S3)) (= (f9 (f10 f11 0) (f12 f13 (+ (f9 f17 ?v0) 1))) 0)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f16) ?v0) (ite (= ?v0 (f12 f13 0)) f8 f16))))
(assert (forall ((?v0 S3)) (= (f9 (f10 f11 0) ?v0) (ite (= ?v0 (f12 f13 0)) 1 0))))
(assert (= (f18 f19 f16) f8))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f10 f11 ?v2))) (=> (<= (f9 f17 ?v0) (f9 f17 ?v1)) (=> (<= 0 ?v2) (=> (<= ?v2 1) (<= (f9 ?v_0 ?v1) (f9 ?v_0 ?v0))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f10 f11 ?v2))) (=> (< (f9 f17 ?v0) (f9 f17 ?v1)) (=> (< 0 ?v2) (=> (< ?v2 1) (< (f9 ?v_0 ?v1) (f9 ?v_0 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f9 (f10 f11 ?v0) (f12 f13 (+ (f9 f17 ?v1) 1))) 1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f10 f11 ?v2))) (=> (<= (f9 f17 ?v0) (f9 f17 ?v1)) (=> (<= 1 ?v2) (<= (f9 ?v_0 ?v0) (f9 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 1 ?v0) (<= 1 (f9 (f10 f11 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f10 f11 ?v2))) (=> (< (f9 f17 ?v0) (f9 f17 ?v1)) (=> (< 1 ?v2) (< (f9 ?v_0 ?v0) (f9 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f11 ?v0))) (=> (< 1 ?v0) (=> (< (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) (< (f9 f17 ?v1) (f9 f17 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (< 1 ?v0) (=> (< 0 (f9 f17 ?v1)) (< 1 (f9 (f10 f11 ?v0) ?v1))))))
(assert (forall ((?v0 S3)) (= (f12 f13 (f9 f17 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f9 f17 (f12 f13 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f9 f17 (f12 f13 ?v0)) 0))))
(check-sat)
(exit)
