(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S4)
(declare-fun f4 (S5 S4) S2)
(declare-fun f5 () S5)
(declare-fun f6 () S2)
(declare-fun f7 (S6 Int) S3)
(declare-fun f8 () S6)
(declare-fun f9 (S7 S3) Int)
(declare-fun f10 () S7)
(declare-fun f11 () S3)
(declare-fun f12 (S8 S4) S4)
(declare-fun f13 () S8)
(declare-fun f14 () S4)
(declare-fun f15 (S9 Int) Int)
(declare-fun f16 (S10 Int) S9)
(declare-fun f17 () S10)
(declare-fun f18 (S11 Int) S7)
(declare-fun f19 () S11)
(declare-fun f20 (S12 S4) S8)
(declare-fun f21 () S12)
(declare-fun f22 (S13 S3) S3)
(declare-fun f23 (S14 S3) S13)
(declare-fun f24 () S14)
(declare-fun f25 () S14)
(declare-fun f26 () S3)
(declare-fun f27 () S9)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 (f3 f6 (f7 f8 (* 2 (f9 f10 f11))))) f11) (f12 f13 f14))))
(assert (< 0 (f9 f10 f11)))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 ?v0))) (=> (< 0 ?v_0) (= (f3 (f4 f5 (f3 f6 (f7 f8 (* ?v_0 2)))) (f7 f8 (* ?v_0 1))) (f3 (f4 f5 (f3 f6 (f7 f8 2))) (f7 f8 1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 ?v0))) (=> (< 0 ?v_0) (= (f3 (f4 f5 (f3 f6 (f7 f8 (* ?v_0 2)))) (f7 f8 (* ?v_0 1))) (f3 (f4 f5 (f3 f6 (f7 f8 2))) (f7 f8 1)))))))
(assert (= (f3 f6 (f7 f8 1)) f14))
(assert (= (f3 f6 (f7 f8 0)) f14))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 (f3 f6 ?v0)) ?v0) f14)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f17 (f9 f10 ?v1))) (?v_1 (f9 f10 ?v2))) (= (f3 (f4 f5 (f3 f6 (f7 f8 (* 2 (f9 f10 ?v0))))) (f7 f8 (f15 ?v_0 (* 2 ?v_1)))) (f3 (f4 f5 (f3 f6 ?v0)) (f7 f8 (f15 ?v_0 ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f9 f10 ?v0))) (let ((?v_1 (f16 f17 ?v_0))) (=> (< 0 ?v_0) (= (f3 (f4 f5 (f3 f6 (f7 f8 (f15 ?v_1 (f9 f10 ?v1))))) (f7 f8 (f15 ?v_1 (f9 f10 ?v2)))) (f3 (f4 f5 (f3 f6 ?v1)) ?v2)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f12 f13 f14))) (= (f3 (f4 f5 ?v_0) (f7 f8 (+ (* 2 (f9 f10 ?v0)) 1))) ?v_0))))
(assert (forall ((?v0 S3)) (= (f9 (f18 f19 (- 1)) (f7 f8 (+ (* 2 (f9 f10 ?v0)) 1))) (- 1))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 (f12 f13 f14)) (f7 f8 (* 2 (f9 f10 ?v0)))) f14)))
(assert (forall ((?v0 S3)) (= (f9 (f18 f19 (- 1)) (f7 f8 (* 2 (f9 f10 ?v0)))) 1)))
(assert (forall ((?v0 S4) (?v1 S3)) (= (f3 (f4 f5 (f12 f13 ?v0)) ?v1) (f12 (f20 f21 (f3 (f4 f5 (f12 f13 f14)) ?v1)) (f3 (f4 f5 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f9 (f18 f19 (- ?v0)) ?v1) (f15 (f16 f17 (f9 (f18 f19 (- 1)) ?v1)) (f9 (f18 f19 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f7 f8 (* 2 (f9 f10 ?v1))))) (= (f9 (f18 f19 (- ?v0)) ?v_0) (f9 (f18 f19 ?v0) ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f7 f8 (* 2 (f9 f10 ?v1))))) (= (f3 (f4 f5 (f12 f13 ?v0)) ?v_0) (f3 (f4 f5 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f18 f19 ?v0))) (= (f9 ?v_0 (f7 f8 (+ (* 2 (f9 f10 ?v1)) 1))) (f15 (f16 f17 ?v0) (f9 (f18 f19 (f9 ?v_0 ?v1)) (f7 f8 2)))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (* 2 (f9 f10 ?v1)) 1))) (f12 (f20 f21 ?v0) (f3 (f4 f5 (f3 ?v_0 ?v1)) (f7 f8 2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f7 f8 (+ (* 2 (f9 f10 ?v1)) 1))) (f22 (f23 f25 ?v0) (f22 (f23 f24 (f22 ?v_0 ?v1)) (f7 f8 2)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f18 f19 ?v0))) (let ((?v_1 (f9 ?v_0 ?v1))) (= (f9 ?v_0 (f7 f8 (+ (* 2 (f9 f10 ?v1)) 1))) (f15 (f16 f17 ?v0) (f15 (f16 f17 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f7 f8 (+ (* 2 (f9 f10 ?v1)) 1))) (f12 (f20 f21 ?v0) (f12 (f20 f21 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (let ((?v_1 (f22 ?v_0 ?v1))) (= (f22 ?v_0 (f7 f8 (+ (* 2 (f9 f10 ?v1)) 1))) (f22 (f23 f25 ?v0) (f22 (f23 f25 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f18 f19 ?v0))) (let ((?v_1 (f9 ?v_0 ?v1))) (= (f9 ?v_0 (f7 f8 (* 2 (f9 f10 ?v1)))) (f15 (f16 f17 ?v_1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f7 f8 (* 2 (f9 f10 ?v1)))) (f12 (f20 f21 ?v_1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (let ((?v_1 (f22 ?v_0 ?v1))) (= (f22 ?v_0 (f7 f8 (* 2 (f9 f10 ?v1)))) (f22 (f23 f25 ?v_1) ?v_1))))))
(assert (forall ((?v0 S4)) (= (= (f3 (f4 f5 ?v0) (f7 f8 2)) f14) (or (= ?v0 f14) (= ?v0 (f12 f13 f14))))))
(assert (forall ((?v0 Int)) (= (= (f9 (f18 f19 ?v0) (f7 f8 2)) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 S4)) (= (f12 f13 ?v0) (f12 (f20 f21 (f12 f13 f14)) ?v0))))
(assert (forall ((?v0 Int)) (= (- ?v0) (* (- 1) ?v0))))
(assert (forall ((?v0 S4)) (= (= (f12 (f20 f21 ?v0) ?v0) f14) (or (= ?v0 f14) (= ?v0 (f12 f13 f14))))))
(assert (forall ((?v0 Int)) (= (= (f15 (f16 f17 ?v0) ?v0) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 ?v1) (ite (= ?v1 (f7 f8 0)) f26 (f22 (f23 f25 ?v0) (f22 ?v_0 (f7 f8 (- (f9 f10 ?v1) 1)))))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f7 f8 0)) f14 (f12 (f20 f21 ?v0) (f3 ?v_0 (f7 f8 (- (f9 f10 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f18 f19 ?v0))) (= (f9 ?v_0 ?v1) (ite (= ?v1 (f7 f8 0)) 1 (f15 (f16 f17 ?v0) (f9 ?v_0 (f7 f8 (- (f9 f10 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f18 f19 ?v0))) (= (f9 ?v_0 (f7 f8 (f15 (f16 f17 (f9 f10 ?v1)) (f9 f10 ?v2)))) (f9 (f18 f19 (f9 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f7 f8 (f15 (f16 f17 (f9 f10 ?v1)) (f9 f10 ?v2)))) (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f7 f8 (f15 (f16 f17 (f9 f10 ?v1)) (f9 f10 ?v2)))) (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 ?v1) (ite (= ?v1 (f7 f8 0)) (f7 f8 1) (f7 f8 (f15 (f16 f17 (f9 f10 ?v0)) (f9 f10 (f22 ?v_0 (f7 f8 (- (f9 f10 ?v1) 1)))))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f20 f21 ?v0))) (= (f12 (f20 f21 (f12 ?v_0 ?v1)) (f12 (f20 f21 ?v2) ?v3)) (f12 (f20 f21 (f12 ?v_0 ?v2)) (f12 (f20 f21 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f23 f25 ?v0))) (= (f22 (f23 f25 (f22 ?v_0 ?v1)) (f22 (f23 f25 ?v2) ?v3)) (f22 (f23 f25 (f22 ?v_0 ?v2)) (f22 (f23 f25 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) (f15 (f16 f17 ?v2) ?v3)) (f15 (f16 f17 (f15 ?v_0 ?v2)) (f15 (f16 f17 ?v1) ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f20 f21 (f12 (f20 f21 ?v0) ?v1))) (?v_0 (f20 f21 ?v2))) (= (f12 ?v_1 (f12 ?v_0 ?v3)) (f12 ?v_0 (f12 ?v_1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f23 f25 (f22 (f23 f25 ?v0) ?v1))) (?v_0 (f23 f25 ?v2))) (= (f22 ?v_1 (f22 ?v_0 ?v3)) (f22 ?v_0 (f22 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f16 f17 (f15 (f16 f17 ?v0) ?v1))) (?v_0 (f16 f17 ?v2))) (= (f15 ?v_1 (f15 ?v_0 ?v3)) (f15 ?v_0 (f15 ?v_1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f20 f21 ?v0)) (?v_1 (f12 (f20 f21 ?v2) ?v3))) (= (f12 (f20 f21 (f12 ?v_0 ?v1)) ?v_1) (f12 ?v_0 (f12 (f20 f21 ?v1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f23 f25 ?v0)) (?v_1 (f22 (f23 f25 ?v2) ?v3))) (= (f22 (f23 f25 (f22 ?v_0 ?v1)) ?v_1) (f22 ?v_0 (f22 (f23 f25 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f16 f17 ?v0)) (?v_1 (f15 (f16 f17 ?v2) ?v3))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v_1) (f15 ?v_0 (f15 (f16 f17 ?v1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f20 f21 ?v0))) (= (f12 (f20 f21 (f12 ?v_0 ?v1)) ?v2) (f12 (f20 f21 (f12 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f25 ?v0))) (= (f22 (f23 f25 (f22 ?v_0 ?v1)) ?v2) (f22 (f23 f25 (f22 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2) (f15 (f16 f17 (f15 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f20 f21 ?v0))) (= (f12 (f20 f21 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f12 (f20 f21 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f25 ?v0))) (= (f22 (f23 f25 (f22 ?v_0 ?v1)) ?v2) (f22 ?v_0 (f22 (f23 f25 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f15 (f16 f17 ?v1) ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f27 ?v0))) (= (f15 (f16 f17 ?v_0) ?v_0) (f15 (f16 f17 ?v0) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f20 f21 ?v0))) (= (f12 ?v_0 (f12 (f20 f21 ?v1) ?v2)) (f12 (f20 f21 (f12 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f25 ?v0))) (= (f22 ?v_0 (f22 (f23 f25 ?v1) ?v2)) (f22 (f23 f25 (f22 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f15 (f16 f17 ?v1) ?v2)) (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f20 f21 ?v0)) (?v_0 (f20 f21 ?v1))) (= (f12 ?v_1 (f12 ?v_0 ?v2)) (f12 ?v_0 (f12 ?v_1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f23 f25 ?v0)) (?v_0 (f23 f25 ?v1))) (= (f22 ?v_1 (f22 ?v_0 ?v2)) (f22 ?v_0 (f22 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f16 f17 ?v0)) (?v_0 (f16 f17 ?v1))) (= (f15 ?v_1 (f15 ?v_0 ?v2)) (f15 ?v_0 (f15 ?v_1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f12 (f20 f21 ?v0) ?v1) (f12 (f20 f21 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f22 (f23 f25 ?v0) ?v1) (f22 (f23 f25 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 (f16 f17 ?v0) ?v1) (f15 (f16 f17 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 f27 (f15 (f16 f17 ?v0) ?v1)) (f15 (f16 f17 (f15 f27 ?v0)) (f15 f27 ?v1)))))
(assert (= (f15 f27 1) 1))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2))) (= (f9 (f18 f19 (f15 f27 ?v0)) ?v_0) (f9 (f18 f19 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f9 (f18 f19 ?v0) (f7 f8 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f7 f8 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f22 (f23 f24 ?v0) (f7 f8 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f7 f8 (f9 f10 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f9 f10 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f9 f10 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
