(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S1)
(declare-fun f4 (S3 S2) S2)
(declare-fun f5 (S4 S2) S3)
(declare-fun f6 () S4)
(declare-fun f7 () S2)
(declare-fun f8 () S4)
(declare-fun f9 (S5 S6) S2)
(declare-fun f10 (S7 S2) S5)
(declare-fun f11 () S7)
(declare-fun f12 () S6)
(declare-fun f13 () S2)
(declare-fun f14 () S2)
(declare-fun f15 (S8 Int) S6)
(declare-fun f16 () S8)
(declare-fun f17 (S9 S6) Int)
(declare-fun f18 () S9)
(declare-fun f19 (S10 Int) S9)
(declare-fun f20 () S10)
(declare-fun f21 (S11 Int) Int)
(declare-fun f22 (S12 Int) S11)
(declare-fun f23 () S12)
(declare-fun f24 () S11)
(assert (not (= f1 f2)))
(assert (not (= f3 f1)))
(assert (forall ((?v0 S2)) (=> (= (f4 (f5 f6 f7) (f4 (f5 f8 (f9 (f10 f11 ?v0) f12)) f13)) f14) (= f3 f1))))
(assert (exists ((?v0 S2)) (= (f4 (f5 f6 f7) (f4 (f5 f8 ?v0) (f4 (f5 f8 f13) (f9 (f10 f11 ?v0) (f15 f16 (- (f17 f18 f12) 1)))))) f14)))
(assert (not (= f12 (f15 f16 0))))
(assert (not (= f12 (f15 f16 0))))
(assert (not (= f13 f14)))
(assert (exists ((?v0 S2)) (= (f4 (f5 f6 f7) (f4 (f5 f8 ?v0) (f4 (f5 f8 f13) (f9 (f10 f11 ?v0) (f15 f16 (- (f17 f18 f12) 1)))))) f14)))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f19 f20 ?v0))) (= (f17 ?v_0 ?v1) (ite (= ?v1 (f15 f16 0)) 1 (f21 (f22 f23 ?v0) (f17 ?v_0 (f15 f16 (- (f17 f18 ?v1) 1)))))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 ?v1) (ite (= ?v1 (f15 f16 0)) f7 (f4 (f5 f8 ?v0) (f9 ?v_0 (f15 f16 (- (f17 f18 ?v1) 1)))))))))
(assert (forall ((?v0 S6)) (= (f17 (f19 f20 0) ?v0) (ite (= ?v0 (f15 f16 0)) 1 0))))
(assert (forall ((?v0 S6)) (= (f9 (f10 f11 f14) ?v0) (ite (= ?v0 (f15 f16 0)) f7 f14))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (= (+ (f17 (f19 f20 ?v0) ?v_0) (f17 (f19 f20 ?v1) ?v_0)) 0) (and (= ?v0 0) (= ?v1 0))))))
(assert (forall ((?v0 Int)) (= (+ ?v0 ?v0) (f21 (f22 f23 (+ 1 1)) ?v0))))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 ?v0) ?v0) (f4 (f5 f8 (f4 (f5 f6 f7) f7)) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (f21 (f22 f23 ?v1) ?v0)) (f21 (f22 f23 (+ ?v1 1)) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f5 f6 ?v0) (f4 (f5 f8 ?v1) ?v0)) (f4 (f5 f8 (f4 (f5 f6 ?v1) f7)) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f21 (f22 f23 ?v0) ?v1) ?v1) (f21 (f22 f23 (+ ?v0 1)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f5 f6 (f4 (f5 f8 ?v0) ?v1)) ?v1) (f4 (f5 f8 (f4 (f5 f6 ?v0) f7)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ (f21 (f22 f23 ?v0) ?v0) (f21 (f22 f23 ?v1) ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f22 f23 ?v0))) (=> (not (= ?v0 0)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (+ ?v1 (f21 ?v_0 ?v3)) (+ ?v2 (f21 ?v_0 ?v4)))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f5 f8 ?v0))) (=> (not (= ?v0 f14)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f4 (f5 f6 ?v1) (f4 ?v_0 ?v3)) (f4 (f5 f6 ?v2) (f4 ?v_0 ?v4)))))))))
(assert (forall ((?v0 S6)) (= (f17 (f19 f20 1) ?v0) 1)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f11 f7) ?v0) f7)))
(assert (= (f17 (f19 f20 1) (f15 f16 2)) 1))
(assert (= (f9 (f10 f11 f7) (f15 f16 2)) f7))
(assert (forall ((?v0 Int)) (= (f17 (f19 f20 ?v0) (f15 f16 0)) 1)))
(assert (forall ((?v0 S2)) (= (f9 (f10 f11 ?v0) (f15 f16 0)) f7)))
(assert (forall ((?v0 Int)) (= (f17 (f19 f20 ?v0) (f15 f16 0)) 1)))
(assert (forall ((?v0 S2)) (= (f9 (f10 f11 ?v0) (f15 f16 0)) f7)))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f15 f16 (f21 (f22 f23 (f17 f18 ?v1)) (f17 f18 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f19 f20 ?v0))) (= (f17 (f19 f20 (f17 ?v_0 ?v1)) ?v2) (f17 ?v_0 (f15 f16 (f21 (f22 f23 (f17 f18 ?v1)) (f17 f18 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f15 f16 (* 2 (f17 f18 ?v1)))) (f9 (f10 f11 (f9 ?v_0 ?v1)) (f15 f16 2))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f19 f20 ?v0))) (= (f17 ?v_0 (f15 f16 (* 2 (f17 f18 ?v1)))) (f17 (f19 f20 (f17 ?v_0 ?v1)) (f15 f16 2))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f15 f16 (f21 (f22 f23 (f17 f18 ?v1)) (f17 f18 ?v2)))) (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f19 f20 ?v0))) (= (f17 ?v_0 (f15 f16 (f21 (f22 f23 (f17 f18 ?v1)) (f17 f18 ?v2)))) (f17 (f19 f20 (f17 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 (f22 f23 (f21 ?v_0 ?v1)) (f21 (f22 f23 ?v2) ?v3)) (f21 (f22 f23 (f21 ?v_0 ?v2)) (f21 (f22 f23 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f5 f8 ?v0))) (= (f4 (f5 f8 (f4 ?v_0 ?v1)) (f4 (f5 f8 ?v2) ?v3)) (f4 (f5 f8 (f4 ?v_0 ?v2)) (f4 (f5 f8 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f22 f23 (f21 (f22 f23 ?v0) ?v1))) (?v_0 (f22 f23 ?v2))) (= (f21 ?v_1 (f21 ?v_0 ?v3)) (f21 ?v_0 (f21 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f5 f8 (f4 (f5 f8 ?v0) ?v1))) (?v_0 (f5 f8 ?v2))) (= (f4 ?v_1 (f4 ?v_0 ?v3)) (f4 ?v_0 (f4 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f22 f23 ?v0)) (?v_1 (f21 (f22 f23 ?v2) ?v3))) (= (f21 (f22 f23 (f21 ?v_0 ?v1)) ?v_1) (f21 ?v_0 (f21 (f22 f23 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f5 f8 ?v0)) (?v_1 (f4 (f5 f8 ?v2) ?v3))) (= (f4 (f5 f8 (f4 ?v_0 ?v1)) ?v_1) (f4 ?v_0 (f4 (f5 f8 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 (f22 f23 (f21 ?v_0 ?v1)) ?v2) (f21 (f22 f23 (f21 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f8 ?v0))) (= (f4 (f5 f8 (f4 ?v_0 ?v1)) ?v2) (f4 (f5 f8 (f4 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 (f22 f23 (f21 ?v_0 ?v1)) ?v2) (f21 ?v_0 (f21 (f22 f23 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f8 ?v0))) (= (f4 (f5 f8 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f8 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 ?v_0 (f21 (f22 f23 ?v1) ?v2)) (f21 (f22 f23 (f21 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f8 ?v0))) (= (f4 ?v_0 (f4 (f5 f8 ?v1) ?v2)) (f4 (f5 f8 (f4 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f22 f23 ?v0)) (?v_0 (f22 f23 ?v1))) (= (f21 ?v_1 (f21 ?v_0 ?v2)) (f21 ?v_0 (f21 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f5 f8 ?v0)) (?v_0 (f5 f8 ?v1))) (= (f4 ?v_1 (f4 ?v_0 ?v2)) (f4 ?v_0 (f4 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f21 (f22 f23 ?v0) ?v1) (f21 (f22 f23 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f5 f8 ?v0) ?v1) (f4 (f5 f8 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) (f4 (f5 f6 ?v2) ?v3)) (f4 (f5 f6 (f4 ?v_0 ?v2)) (f4 (f5 f6 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 (f5 f6 (f4 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2)) (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f5 f6 ?v0)) (?v_0 (f5 f6 ?v1))) (= (f4 ?v_1 (f4 ?v_0 ?v2)) (f4 ?v_0 (f4 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f16 2))) (= (f17 (f19 f20 (f21 f24 ?v0)) ?v_0) (f17 (f19 f20 ?v0) ?v_0)))))
(assert (forall ((?v0 S2)) (= (f9 (f10 f11 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f17 (f19 f20 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f9 (f10 f11 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f17 (f19 f20 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 (f19 f20 ?v0) (f15 f16 2)))) (= (f21 f24 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S6)) (= (f21 f24 (f17 (f19 f20 ?v0) ?v1)) (f17 (f19 f20 (f21 f24 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f8 ?v0) f14) f14)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f8 f14) ?v0) f14)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (+ ?v0 ?v1)) (= ?v1 0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= ?v0 (f4 (f5 f6 ?v0) ?v1)) (= ?v1 f14))))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 ?v0) f14) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 f14) ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f22 f23 ?v0)) (?v_1 (f22 f23 ?v2))) (= (= (+ (f21 ?v_0 ?v1) (f21 ?v_1 ?v3)) (+ (f21 ?v_0 ?v3) (f21 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f5 f8 ?v0)) (?v_1 (f5 f8 ?v2))) (= (= (f4 (f5 f6 (f4 ?v_0 ?v1)) (f4 ?v_1 ?v3)) (f4 (f5 f6 (f4 ?v_0 ?v3)) (f4 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f21 (f22 f23 ?v0) ?v1) (f21 (f22 f23 ?v2) ?v1)) (f21 (f22 f23 (+ ?v0 ?v2)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f6 (f4 (f5 f8 ?v0) ?v1)) (f4 (f5 f8 ?v2) ?v1)) (f4 (f5 f8 (f4 (f5 f6 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f21 (f22 f23 (+ ?v0 ?v1)) ?v2) (+ (f21 (f22 f23 ?v0) ?v2) (f21 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f8 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f6 (f4 (f5 f8 ?v0) ?v2)) (f4 (f5 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f22 f23 ?v0)) (?v_1 (f22 f23 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (+ (f21 ?v_0 ?v2) (f21 ?v_1 ?v3)) (+ (f21 ?v_0 ?v3) (f21 ?v_1 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f5 f8 ?v0)) (?v_1 (f5 f8 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f4 (f5 f6 (f4 ?v_0 ?v2)) (f4 ?v_1 ?v3)) (f4 (f5 f6 (f4 ?v_0 ?v3)) (f4 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 ?v_0 (+ ?v1 ?v2)) (+ (f21 ?v_0 ?v1) (f21 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f8 ?v0))) (= (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2)) (f4 (f5 f6 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f8 ?v0) f7) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f8 f7) ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (not (= ?v0 0)) (not (= (f17 (f19 f20 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (not (= ?v0 f14)) (not (= (f9 (f10 f11 ?v0) ?v1) f14)))))
(assert (forall ((?v0 Int)) (= (= (f17 (f19 f20 ?v0) (f15 f16 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (= (f9 (f10 f11 ?v0) (f15 f16 2)) f14) (= ?v0 f14))))
(assert (forall ((?v0 Int) (?v1 S6)) (= (= (f17 (f19 f20 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f15 f16 0)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (= (f9 (f10 f11 ?v0) ?v1) f14) (and (= ?v0 f14) (not (= ?v1 (f15 f16 0)))))))
(assert (= (f17 (f19 f20 0) (f15 f16 2)) 0))
(assert (= (f9 (f10 f11 f14) (f15 f16 2)) f14))
(assert (forall ((?v0 S6)) (= (f17 (f19 f20 0) (f15 f16 (+ (f17 f18 ?v0) 1))) 0)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f11 f14) (f15 f16 (+ (f17 f18 ?v0) 1))) f14)))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f17 f18 ?v1)) (?v_1 (f17 f18 ?v0)) (?v_2 (f10 f11 ?v2))) (=> (<= ?v_1 ?v_0) (= (f9 ?v_2 (f15 f16 (- (+ ?v_0 1) ?v_1))) (f4 (f5 f8 (f9 ?v_2 (f15 f16 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 Int)) (let ((?v_0 (f17 f18 ?v1)) (?v_1 (f17 f18 ?v0)) (?v_2 (f19 f20 ?v2))) (=> (<= ?v_1 ?v_0) (= (f17 ?v_2 (f15 f16 (- (+ ?v_0 1) ?v_1))) (f21 (f22 f23 (f17 ?v_2 (f15 f16 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f4 (f5 f8 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) (f9 ?v_0 (f15 f16 (+ (f17 f18 ?v1) (f17 f18 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f19 f20 ?v0))) (= (f21 (f22 f23 (f17 ?v_0 ?v1)) (f17 ?v_0 ?v2)) (f17 ?v_0 (f15 f16 (+ (f17 f18 ?v1) (f17 f18 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S6)) (= (f9 (f10 f11 (f4 (f5 f8 ?v0) ?v1)) ?v2) (f4 (f5 f8 (f9 (f10 f11 ?v0) ?v2)) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (= (f17 (f19 f20 (f21 (f22 f23 ?v0) ?v1)) ?v2) (f21 (f22 f23 (f17 (f19 f20 ?v0) ?v2)) (f17 (f19 f20 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S6)) (= (f9 (f10 f11 (f4 (f5 f8 ?v0) ?v1)) ?v2) (f4 (f5 f8 (f9 (f10 f11 ?v0) ?v2)) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (= (f17 (f19 f20 (f21 (f22 f23 ?v0) ?v1)) ?v2) (f21 (f22 f23 (f17 (f19 f20 ?v0) ?v2)) (f17 (f19 f20 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f9 (f10 f11 ?v0) ?v1))) (= (f4 (f5 f8 ?v_0) ?v0) (f4 (f5 f8 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f17 (f19 f20 ?v0) ?v1))) (= (f21 (f22 f23 ?v_0) ?v0) (f21 (f22 f23 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f4 (f5 f8 (f9 ?v_0 ?v1)) ?v0) (f9 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f19 f20 ?v0))) (= (f21 (f22 f23 (f17 ?v_0 ?v1)) ?v0) (f17 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (let ((?v_1 (f9 ?v_0 ?v1))) (= (f9 ?v_0 (f15 f16 (* 2 (f17 f18 ?v1)))) (f4 (f5 f8 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f19 f20 ?v0))) (let ((?v_1 (f17 ?v_0 ?v1))) (= (f17 ?v_0 (f15 f16 (* 2 (f17 f18 ?v1)))) (f21 (f22 f23 ?v_1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f15 f16 (+ (f17 f18 ?v1) (f17 f18 ?v2)))) (f4 (f5 f8 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f19 f20 ?v0))) (= (f17 ?v_0 (f15 f16 (+ (f17 f18 ?v1) (f17 f18 ?v2)))) (f21 (f22 f23 (f17 ?v_0 ?v1)) (f17 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f4 (f5 f8 ?v0) (f9 ?v_0 ?v1)) (f9 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f19 f20 ?v0))) (= (f21 (f22 f23 ?v0) (f17 ?v_0 ?v1)) (f17 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1)))))))
(assert (forall ((?v0 S6)) (= (f15 f16 (f17 f18 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f17 f18 (f15 f16 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f17 f18 (f15 f16 ?v0)) 0))))
(check-sat)
(exit)
