(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S2) S1)
(declare-fun f4 (S3 S2) S2)
(declare-fun f5 (S4 S2) S3)
(declare-fun f6 () S4)
(declare-fun f7 () S3)
(declare-fun f8 () S4)
(declare-fun f9 () S2)
(declare-fun f10 () S2)
(declare-fun f11 () S2)
(declare-fun f12 (S2 S2) S1)
(declare-fun f13 () S2)
(declare-fun f14 () S2)
(declare-fun f15 () S2)
(declare-fun f16 () S5)
(declare-fun f17 () S5)
(declare-fun f18 (S6 Int) Int)
(declare-fun f19 () S6)
(declare-fun f20 () S4)
(declare-fun f21 (S7 Int) S6)
(declare-fun f22 () S7)
(declare-fun f23 () S4)
(declare-fun f24 () S7)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 f6 (f4 f7 (f4 (f5 f8 f9) f10))) f11) f9) f1)))
(assert (= (f12 f13 f11) f1))
(assert (= (f3 f11 f10) f1))
(assert (= (f12 f10 f9) f1))
(assert (= (f3 f13 f14) f1))
(assert (forall ((?v0 S2)) (=> (= (f3 f13 ?v0) f1) (exists ((?v1 S2)) (and (= (f3 f13 ?v1) f1) (and (= (f3 ?v1 f9) f1) (= (f3 ?v1 ?v0) f1)))))))
(assert (forall ((?v0 S2)) (= (f3 f13 (f4 (f5 f6 f9) (f4 f7 ?v0))) f1)))
(assert (= (f3 f15 f9) f1))
(assert (= (f3 f13 f15) f1))
(assert (< 0 (+ 1 1)))
(assert (= (f3 f13 (f4 (f5 f6 f9) f9)) f1))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 f13 ?v0) f1) (=> (= (f12 f13 ?v1) f1) (= (f3 f13 (f4 (f5 f6 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f12 f13 ?v0) f1) (=> (= (f3 f13 ?v1) f1) (= (f3 f13 (f4 (f5 f6 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 f13 ?v0) f1) (=> (= (f12 ?v1 ?v2) f1) (= (f3 ?v1 (f4 (f5 f6 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (<= ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f12 f13 ?v0) f1) (=> (= (f3 ?v1 ?v2) f1) (= (f3 ?v1 (f4 (f5 f6 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 f13) f1) (=> (= (f12 ?v1 f13) f1) (= (f3 (f4 (f5 f6 ?v0) ?v1) f13) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (<= ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f12 ?v0 f13) f1) (=> (= (f3 ?v1 f13) f1) (= (f3 (f4 (f5 f6 ?v0) ?v1) f13) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S2)) (not (= (f3 (f4 (f5 f6 (f4 f7 ?v0)) f9) ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f12 ?v0 ?v1) f1) (= (f12 (f4 (f5 f8 ?v0) ?v1) f13) f1))))
(assert (not (= f16 f17)))
(assert (forall ((?v0 S2)) (= (= (f4 f7 ?v0) f13) (= ?v0 f13))))
(assert (forall ((?v0 Int)) (= (= (f18 f19 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= f17 ?v0) (= ?v0 f17))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (= f13 ?v0) (= ?v0 f13))))
(assert (= (f4 f7 f13) f13))
(assert (= (f18 f19 0) 0))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f12 (f4 f7 ?v0) ?v1) f1) (= (f12 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f18 f19 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S2)) (= (f12 ?v0 (f4 f7 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 (f18 f19 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 ?v0 ?v1) f1) false) (=> (=> (= (f3 ?v1 ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (= (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f6 (f4 (f5 f20 ?v0) ?v1)) ?v2) (f4 (f5 f20 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f18 (f21 f22 ?v0) ?v1) ?v2) (f18 (f21 f22 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f6 (f4 (f5 f23 ?v0) ?v1)) ?v2) (f4 (f5 f23 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f18 (f21 f24 ?v0) ?v1) ?v2) (f18 (f21 f24 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 (f5 f6 (f4 f7 ?v0)) (f4 f7 ?v1)))) (= (f4 f7 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f18 f19 ?v0) (f18 f19 ?v1)))) (= (f18 f19 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S2)) (= (= f9 ?v0) (= ?v0 f9))))
(assert (= (f4 f7 f9) f9))
(assert (= (f18 f19 1) 1))
(check-sat)
(exit)
