(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) S1)
(declare-fun f7 (S6 S5) S4)
(declare-fun f8 () S6)
(declare-fun f9 () S5)
(declare-fun f10 () S5)
(declare-fun f11 () S6)
(declare-fun f12 () S5)
(declare-fun f13 () S5)
(declare-fun f14 () S7)
(declare-fun f15 (S8 Int) S7)
(declare-fun f16 () S8)
(declare-fun f17 (S9 Int) Int)
(declare-fun f18 () S9)
(declare-fun f19 (S10 S5) S5)
(declare-fun f20 () S10)
(declare-fun f21 () S11)
(declare-fun f22 () S11)
(declare-fun f23 () S11)
(declare-fun f24 (S12 Int) S9)
(declare-fun f25 () S12)
(declare-fun f26 (S13 S5) S10)
(declare-fun f27 () S13)
(declare-fun f28 () S12)
(declare-fun f29 () S13)
(declare-fun f30 (S14 S5) Int)
(declare-fun f31 (S15 Int) S5)
(declare-fun f32 (S16 S3) S12)
(declare-fun f33 () S16)
(declare-fun f34 (S17 S6) S13)
(declare-fun f35 () S17)
(declare-fun f36 () S16)
(declare-fun f37 () S17)
(declare-fun f38 () S10)
(declare-fun f39 () S9)
(declare-fun f40 () S10)
(declare-fun f41 (S18 S11) S11)
(declare-fun f42 () S18)
(declare-fun f43 () S10)
(declare-fun f44 () S13)
(declare-fun f45 () S18)
(declare-fun f46 (S19 S11) S18)
(declare-fun f47 () S19)
(declare-fun f48 (S20 S7) Int)
(declare-fun f49 () S20)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (<= ?v0 ?v1))))
(assert (not (= (f6 (f7 f8 f9) f10) f1)))
(assert (= (f6 (f7 f11 f12) f9) f1))
(assert (= (f6 (f7 f11 f9) f10) f1))
(assert (= (f6 (f7 f11 f12) f9) f1))
(assert (= (f6 (f7 f11 f9) f10) f1))
(assert (= (f6 (f7 f11 f12) f13) f1))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f11 f12) ?v0) f1) (exists ((?v1 S5)) (let ((?v_0 (f7 f11 ?v1))) (and (= (f6 (f7 f11 f12) ?v1) f1) (and (= (f6 ?v_0 f10) f1) (= (f6 ?v_0 ?v0) f1))))))))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) ?v0) f1)))
(assert (not (= (f6 (f7 f8 f10) f12) f1)))
(assert (not (<= 1 0)))
(assert (= (f6 (f7 f8 f12) f10) f1))
(assert (<= 0 1))
(assert (not (= f14 (f15 f16 0))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) ?v0) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (= (f17 f18 1) 1))
(assert (= (f19 f20 f10) f10))
(assert (forall ((?v0 S11)) (= (= f21 ?v0) (= ?v0 f21))))
(assert (forall ((?v0 S5)) (= (= f10 ?v0) (= ?v0 f10))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f17 f18 ?v0))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) (f19 f20 ?v0)) f1)))
(assert (not (= f22 f23)))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 S5)) (not (= (f6 (f7 f11 ?v0) ?v0) f1))))
(assert (forall ((?v0 Int)) (not (< (f17 f18 ?v0) 0))))
(assert (forall ((?v0 S5)) (not (= (f6 (f7 f11 (f19 f20 ?v0)) f12) f1))))
(assert (= (f17 f18 0) 0))
(assert (= (f19 f20 f12) f12))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= ?v0 ?v1)) (or (= (f6 (f7 f11 ?v0) ?v1) f1) (= (f6 (f7 f11 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= (f6 (f7 f11 ?v0) ?v1) f1)) (or (= (f6 (f7 f11 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5)) (= (= f12 ?v0) (= ?v0 f12))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S11)) (= (= f23 ?v0) (= ?v0 f23))))
(assert (forall ((?v0 Int)) (= (< 0 (f17 f18 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f11 f12) (f19 f20 ?v0)) f1) (not (= ?v0 f12)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f11 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f6 (f7 f11 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f17 (f24 f25 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f11 ?v0))) (= (= (f6 ?v_0 (f19 (f26 f27 ?v1) ?v2)) f1) (or (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f17 (f24 f28 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f11 ?v0))) (= (= (f6 ?v_0 (f19 (f26 f29 ?v1) ?v2)) f1) (and (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int)) (= (= (f17 f18 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f19 f20 ?v0) f12) (= ?v0 f12))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f17 (f24 f25 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f11 (f19 (f26 f27 ?v0) ?v1)) ?v2) f1) (and (= (f6 (f7 f11 ?v0) ?v2) f1) (= (f6 (f7 f11 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f17 (f24 f28 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f11 (f19 (f26 f29 ?v0) ?v1)) ?v2) f1) (or (= (f6 (f7 f11 ?v0) ?v2) f1) (= (f6 (f7 f11 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f11 ?v0) ?v1) f1)) (= (not (= (f6 (f7 f11 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f6 (f7 f11 ?v0) ?v1) f1) false) (=> (=> (= (f6 (f7 f11 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f6 (f7 f11 ?v0) ?v1) f1) false) (=> (=> (= (f6 (f7 f11 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f17 f18 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f11 f12) ?v0) f1) (= (f19 f20 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (not (= (f6 (f7 f11 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (= (not (= (f6 (f7 f11 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S1)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (= (=> (= (f6 (f7 f11 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (=> (= (f6 (f7 f11 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (=> (= (f6 (f7 f11 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= ?v0 ?v1) (=> (= (f6 (f7 f11 ?v1) ?v2) f1) (= (f6 (f7 f11 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f11 ?v2))) (=> (= ?v0 ?v1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f11 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f6 (f7 f11 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f11 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f11 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f11 ?v2))) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (=> (=> (not false) (= (f6 (f7 f11 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (=> (= (f6 (f7 f11 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f6 (f7 f11 ?v1) ?v0) f1) false) false)))))
(assert (= (f6 (f7 f11 f12) f10) f1))
(assert (< 0 1))
(assert (not (= (f6 (f7 f11 f10) f12) f1)))
(assert (not (< 1 0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f11 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f11 ?v1) ?v2) f1) (= (f6 (f7 f11 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) ?v0) f1) (= (f6 (f7 f11 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f11 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (not (= ?v1 ?v0)) (= (f6 (f7 f11 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (not (= ?v0 ?v1)) (= (f6 (f7 f11 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (or (= (f6 (f7 f11 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (not (= (f6 (f7 f11 ?v0) ?v1) f1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (not (= (f6 (f7 f11 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= (f6 (f7 f11 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f11 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f11 ?v0) ?v1) f1)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f8 ?v0) ?v1) f1)) (= (f6 (f7 f11 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f11 ?v0) ?v1) f1)) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (or (= (f6 (f7 f11 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f11 ?v0) ?v1) f1) (and (= (f6 (f7 f8 ?v0) ?v1) f1) (not (= (f6 (f7 f8 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f11 ?v0) ?v1) f1) (and (= (f6 (f7 f8 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f11 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= (f6 (f7 f8 ?v0) ?v1) f1)) (= (f6 (f7 f11 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= (f6 (f7 f11 ?v0) ?v1) f1)) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f17 f18 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f8 f12) ?v0) f1) (= (f19 f20 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f17 f18 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f8 (f19 f20 ?v0)) f12) f1) (= ?v0 f12))))
(assert (forall ((?v0 Int)) (<= 0 (f17 f18 ?v0))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f12) (f19 f20 ?v0)) f1)))
(assert (not (= f23 f21)))
(assert (not (= f12 f10)))
(assert (not (= 0 1)))
(assert (not (= f21 f23)))
(assert (not (= f10 f12)))
(assert (not (= 1 0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (or (= (f6 (f7 f11 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f11 ?v0) ?v1) f1) (and (= (f6 (f7 f8 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (not (= f12 f10)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (=> (= (f6 (f7 f8 ?v0) ?v1) f1) false) (=> (=> (= (f6 (f7 f8 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f17 f18 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 (f19 f20 ?v0)) ?v1) f1) (= (f6 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f6 (f7 f8 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v2))) (=> (= ?v0 ?v1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= ?v0 ?v1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 (f7 f8 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= ?v0 ?v1) (= (f6 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f17 (f24 f28 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f8 (f19 (f26 f29 ?v0) ?v1)) ?v2) f1) (or (= (f6 (f7 f8 ?v0) ?v2) f1) (= (f6 (f7 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f17 (f24 f25 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (= (f6 ?v_0 (f19 (f26 f27 ?v1) ?v2)) f1) (or (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 ?v1) (and (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f11 f12))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (exists ((?v2 S5)) (let ((?v_1 (f7 f11 ?v2))) (and (= (f6 ?v_0 ?v2) f1) (and (= (f6 ?v_1 ?v0) f1) (= (f6 ?v_1 ?v1) f1))))))))))
(assert (forall ((?v0 S14) (?v1 S5) (?v2 Int) (?v3 S5)) (=> (<= (f30 ?v0 ?v1) ?v2) (=> (= (f6 (f7 f11 ?v3) ?v1) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f11 ?v5) ?v4) f1) (< (f30 ?v0 ?v5) (f30 ?v0 ?v4)))) (< (f30 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S15) (?v1 Int) (?v2 S5) (?v3 Int)) (=> (= (f6 (f7 f8 (f31 ?v0 ?v1)) ?v2) f1) (=> (< ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f6 (f7 f11 (f31 ?v0 ?v5)) (f31 ?v0 ?v4)) f1))) (= (f6 (f7 f11 (f31 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S14) (?v1 S5) (?v2 Int) (?v3 S5)) (=> (< (f30 ?v0 ?v1) ?v2) (=> (= (f6 (f7 f8 ?v3) ?v1) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v5) ?v4) f1) (<= (f30 ?v0 ?v5) (f30 ?v0 ?v4)))) (< (f30 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S15) (?v1 Int) (?v2 S5) (?v3 Int)) (=> (= (f6 (f7 f11 (f31 ?v0 ?v1)) ?v2) f1) (=> (<= ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f6 (f7 f8 (f31 ?v0 ?v5)) (f31 ?v0 ?v4)) f1))) (= (f6 (f7 f11 (f31 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S14) (?v2 S5) (?v3 S5)) (=> (<= ?v0 (f30 ?v1 ?v2)) (=> (= (f6 (f7 f11 ?v2) ?v3) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f11 ?v4) ?v5) f1) (< (f30 ?v1 ?v4) (f30 ?v1 ?v5)))) (< ?v0 (f30 ?v1 ?v3)))))))
(assert (forall ((?v0 S5) (?v1 S15) (?v2 Int) (?v3 Int)) (=> (= (f6 (f7 f8 ?v0) (f31 ?v1 ?v2)) f1) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f6 (f7 f11 (f31 ?v1 ?v4)) (f31 ?v1 ?v5)) f1))) (= (f6 (f7 f11 ?v0) (f31 ?v1 ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 S14) (?v2 S5) (?v3 S5)) (=> (< ?v0 (f30 ?v1 ?v2)) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v4) ?v5) f1) (<= (f30 ?v1 ?v4) (f30 ?v1 ?v5)))) (< ?v0 (f30 ?v1 ?v3)))))))
(assert (forall ((?v0 S5) (?v1 S15) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f11 ?v0))) (=> (= (f6 ?v_0 (f31 ?v1 ?v2)) f1) (=> (<= ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f6 (f7 f8 (f31 ?v1 ?v4)) (f31 ?v1 ?v5)) f1))) (= (f6 ?v_0 (f31 ?v1 ?v3)) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S14) (?v3 Int)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (< (f30 ?v2 ?v1) ?v3) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v4) ?v5) f1) (<= (f30 ?v2 ?v4) (f30 ?v2 ?v5)))) (< (f30 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S15) (?v3 S5)) (=> (<= ?v0 ?v1) (=> (= (f6 (f7 f11 (f31 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f6 (f7 f8 (f31 ?v2 ?v4)) (f31 ?v2 ?v5)) f1))) (= (f6 (f7 f11 (f31 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S14) (?v3 Int)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (=> (<= (f30 ?v2 ?v1) ?v3) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f11 ?v4) ?v5) f1) (< (f30 ?v2 ?v4) (f30 ?v2 ?v5)))) (< (f30 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S15) (?v3 S5)) (=> (< ?v0 ?v1) (=> (= (f6 (f7 f8 (f31 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f6 (f7 f11 (f31 ?v2 ?v4)) (f31 ?v2 ?v5)) f1))) (= (f6 (f7 f11 (f31 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int) (?v3 S14)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (< ?v2 (f30 ?v3 ?v0)) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v5) ?v4) f1) (<= (f30 ?v3 ?v5) (f30 ?v3 ?v4)))) (< ?v2 (f30 ?v3 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 S15)) (let ((?v_0 (f7 f11 ?v2))) (=> (<= ?v0 ?v1) (=> (= (f6 ?v_0 (f31 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f6 (f7 f8 (f31 ?v3 ?v5)) (f31 ?v3 ?v4)) f1))) (= (f6 ?v_0 (f31 ?v3 ?v1)) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int) (?v3 S14)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (=> (<= ?v2 (f30 ?v3 ?v0)) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f11 ?v5) ?v4) f1) (< (f30 ?v3 ?v5) (f30 ?v3 ?v4)))) (< ?v2 (f30 ?v3 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 S15)) (=> (< ?v0 ?v1) (=> (= (f6 (f7 f8 ?v2) (f31 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f6 (f7 f11 (f31 ?v3 ?v5)) (f31 ?v3 ?v4)) f1))) (= (f6 (f7 f11 ?v2) (f31 ?v3 ?v1)) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (=> (forall ((?v3 S5)) (=> (= (f6 (f7 f11 ?v0) ?v3) f1) (=> (= (f6 (f7 f11 ?v3) ?v1) f1) (= (f6 (f7 f8 ?v3) ?v2) f1)))) (= (f6 (f7 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (=> (= (f6 (f7 f11 ?v2) ?v0) f1) (= (f6 (f7 f8 ?v2) ?v1) f1))) (= (f6 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 S4)) (=> (exists ((?v1 S5)) (= (f6 ?v0 ?v1) f1)) (=> (exists ((?v1 S5)) (forall ((?v2 S5)) (=> (= (f6 ?v0 ?v2) f1) (= (f6 (f7 f11 ?v2) ?v1) f1)))) (exists ((?v1 S5)) (forall ((?v2 S5)) (= (exists ((?v3 S5)) (and (= (f6 ?v0 ?v3) f1) (= (f6 (f7 f11 ?v2) ?v3) f1))) (= (f6 (f7 f11 ?v2) ?v1) f1))))))))
(assert (forall ((?v0 S15) (?v1 Int) (?v2 S5) (?v3 Int)) (=> (= (f6 (f7 f11 (f31 ?v0 ?v1)) ?v2) f1) (=> (< ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f6 (f7 f11 (f31 ?v0 ?v5)) (f31 ?v0 ?v4)) f1))) (= (f6 (f7 f11 (f31 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S14) (?v1 S5) (?v2 Int) (?v3 S5)) (=> (< (f30 ?v0 ?v1) ?v2) (=> (= (f6 (f7 f11 ?v3) ?v1) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f11 ?v5) ?v4) f1) (< (f30 ?v0 ?v5) (f30 ?v0 ?v4)))) (< (f30 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (= (f6 (f7 f11 ?v0) ?v1) f1))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (= (f6 (f7 f11 ?v1) ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (exists ((?v2 S5)) (and (= (f6 (f7 f11 ?v0) ?v2) f1) (= (f6 (f7 f11 ?v2) ?v1) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int) (?v3 S14)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (=> (< ?v2 (f30 ?v3 ?v0)) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f11 ?v5) ?v4) f1) (< (f30 ?v3 ?v5) (f30 ?v3 ?v4)))) (< ?v2 (f30 ?v3 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 S15)) (let ((?v_0 (f7 f11 ?v2))) (=> (< ?v0 ?v1) (=> (= (f6 ?v_0 (f31 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f6 (f7 f11 (f31 ?v3 ?v5)) (f31 ?v3 ?v4)) f1))) (= (f6 ?v_0 (f31 ?v3 ?v1)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f17 ?v1 ?v2)) (=> (< ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f17 ?v1 ?v5) (f17 ?v1 ?v4)))) (< (f17 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S10) (?v2 S5) (?v3 S5)) (=> (= ?v0 (f19 ?v1 ?v2)) (=> (= (f6 (f7 f11 ?v3) ?v2) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f11 ?v5) ?v4) f1) (= (f6 (f7 f11 (f19 ?v1 ?v5)) (f19 ?v1 ?v4)) f1))) (= (f6 (f7 f11 (f19 ?v1 ?v3)) ?v0) f1))))))
(assert (forall ((?v0 S5) (?v1 S15) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f11 ?v0))) (=> (= (f6 ?v_0 (f31 ?v1 ?v2)) f1) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f6 (f7 f11 (f31 ?v1 ?v4)) (f31 ?v1 ?v5)) f1))) (= (f6 ?v_0 (f31 ?v1 ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S14) (?v2 S5) (?v3 S5)) (=> (< ?v0 (f30 ?v1 ?v2)) (=> (= (f6 (f7 f11 ?v2) ?v3) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f11 ?v4) ?v5) f1) (< (f30 ?v1 ?v4) (f30 ?v1 ?v5)))) (< ?v0 (f30 ?v1 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 S14) (?v2 S5) (?v3 S5)) (=> (= ?v0 (f30 ?v1 ?v2)) (=> (= (f6 (f7 f11 ?v2) ?v3) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f11 ?v4) ?v5) f1) (< (f30 ?v1 ?v4) (f30 ?v1 ?v5)))) (< ?v0 (f30 ?v1 ?v3)))))))
(assert (forall ((?v0 S5) (?v1 S15) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f31 ?v1 ?v2)) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f6 (f7 f11 (f31 ?v1 ?v4)) (f31 ?v1 ?v5)) f1))) (= (f6 (f7 f11 ?v0) (f31 ?v1 ?v3)) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S14) (?v3 Int)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (=> (< (f30 ?v2 ?v1) ?v3) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f11 ?v4) ?v5) f1) (< (f30 ?v2 ?v4) (f30 ?v2 ?v5)))) (< (f30 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S15) (?v3 S5)) (=> (< ?v0 ?v1) (=> (= (f6 (f7 f11 (f31 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f6 (f7 f11 (f31 ?v2 ?v4)) (f31 ?v2 ?v5)) f1))) (= (f6 (f7 f11 (f31 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S9) (?v3 Int)) (=> (< ?v0 ?v1) (=> (= (f17 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f17 ?v2 ?v5) (f17 ?v2 ?v4)))) (< ?v3 (f17 ?v2 ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S10) (?v3 S5)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (=> (= (f19 ?v2 ?v0) ?v3) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f11 ?v5) ?v4) f1) (= (f6 (f7 f11 (f19 ?v2 ?v5)) (f19 ?v2 ?v4)) f1))) (= (f6 (f7 f11 ?v3) (f19 ?v2 ?v1)) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S14) (?v3 Int)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (=> (= (f30 ?v2 ?v1) ?v3) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f11 ?v4) ?v5) f1) (< (f30 ?v2 ?v4) (f30 ?v2 ?v5)))) (< (f30 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S15) (?v3 S5)) (=> (< ?v0 ?v1) (=> (= (f31 ?v2 ?v1) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f6 (f7 f11 (f31 ?v2 ?v4)) (f31 ?v2 ?v5)) f1))) (= (f6 (f7 f11 (f31 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S15) (?v1 Int) (?v2 S5) (?v3 Int)) (=> (= (f6 (f7 f8 (f31 ?v0 ?v1)) ?v2) f1) (=> (<= ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f6 (f7 f8 (f31 ?v0 ?v5)) (f31 ?v0 ?v4)) f1))) (= (f6 (f7 f8 (f31 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S14) (?v1 S5) (?v2 Int) (?v3 S5)) (=> (<= (f30 ?v0 ?v1) ?v2) (=> (= (f6 (f7 f8 ?v3) ?v1) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v5) ?v4) f1) (<= (f30 ?v0 ?v5) (f30 ?v0 ?v4)))) (<= (f30 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f17 ?v1 ?v2)) (=> (<= ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f17 ?v1 ?v5) (f17 ?v1 ?v4)))) (<= (f17 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S10) (?v2 S5) (?v3 S5)) (=> (= ?v0 (f19 ?v1 ?v2)) (=> (= (f6 (f7 f8 ?v3) ?v2) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v5) ?v4) f1) (= (f6 (f7 f8 (f19 ?v1 ?v5)) (f19 ?v1 ?v4)) f1))) (= (f6 (f7 f8 (f19 ?v1 ?v3)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f17 (f24 f25 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (= (f6 (f7 f8 ?v0) ?v2) f1)) (= (f19 (f26 f27 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f17 (f24 f25 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (= (f6 (f7 f8 ?v0) ?v2) f1)) (= (f19 (f26 f27 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f17 (f24 f28 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (= (f6 (f7 f8 ?v0) ?v2) f1)) (= (f19 (f26 f29 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f17 (f24 f28 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (= (f6 (f7 f8 ?v0) ?v2) f1)) (= (f19 (f26 f29 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S15) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 (f31 ?v1 ?v2)) f1) (=> (<= ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f6 (f7 f8 (f31 ?v1 ?v4)) (f31 ?v1 ?v5)) f1))) (= (f6 ?v_0 (f31 ?v1 ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S14) (?v2 S5) (?v3 S5)) (=> (<= ?v0 (f30 ?v1 ?v2)) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v4) ?v5) f1) (<= (f30 ?v1 ?v4) (f30 ?v1 ?v5)))) (<= ?v0 (f30 ?v1 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 S14) (?v2 S5) (?v3 S5)) (=> (= ?v0 (f30 ?v1 ?v2)) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v4) ?v5) f1) (<= (f30 ?v1 ?v4) (f30 ?v1 ?v5)))) (<= ?v0 (f30 ?v1 ?v3)))))))
(assert (forall ((?v0 S5) (?v1 S15) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f31 ?v1 ?v2)) (=> (<= ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f6 (f7 f8 (f31 ?v1 ?v4)) (f31 ?v1 ?v5)) f1))) (= (f6 (f7 f8 ?v0) (f31 ?v1 ?v3)) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S14) (?v3 Int)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (<= (f30 ?v2 ?v1) ?v3) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v4) ?v5) f1) (<= (f30 ?v2 ?v4) (f30 ?v2 ?v5)))) (<= (f30 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S15) (?v3 S5)) (=> (<= ?v0 ?v1) (=> (= (f6 (f7 f8 (f31 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f6 (f7 f8 (f31 ?v2 ?v4)) (f31 ?v2 ?v5)) f1))) (= (f6 (f7 f8 (f31 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S14) (?v3 Int)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f30 ?v2 ?v1) ?v3) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v4) ?v5) f1) (<= (f30 ?v2 ?v4) (f30 ?v2 ?v5)))) (<= (f30 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S15) (?v3 S5)) (=> (<= ?v0 ?v1) (=> (= (f31 ?v2 ?v1) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f6 (f7 f8 (f31 ?v2 ?v4)) (f31 ?v2 ?v5)) f1))) (= (f6 (f7 f8 (f31 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int) (?v3 S14)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (<= ?v2 (f30 ?v3 ?v0)) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v5) ?v4) f1) (<= (f30 ?v3 ?v5) (f30 ?v3 ?v4)))) (<= ?v2 (f30 ?v3 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 S15)) (let ((?v_0 (f7 f8 ?v2))) (=> (<= ?v0 ?v1) (=> (= (f6 ?v_0 (f31 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f6 (f7 f8 (f31 ?v3 ?v5)) (f31 ?v3 ?v4)) f1))) (= (f6 ?v_0 (f31 ?v3 ?v1)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S9) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (= (f17 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f17 ?v2 ?v5) (f17 ?v2 ?v4)))) (<= ?v3 (f17 ?v2 ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S10) (?v3 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f19 ?v2 ?v0) ?v3) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v5) ?v4) f1) (= (f6 (f7 f8 (f19 ?v2 ?v5)) (f19 ?v2 ?v4)) f1))) (= (f6 (f7 f8 ?v3) (f19 ?v2 ?v1)) f1))))))
(assert (= f25 (f32 f33 f5)))
(assert (= f27 (f34 f35 f8)))
(assert (= f28 (f32 f36 f5)))
(assert (= f29 (f34 f37 f8)))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f11 f12) ?v0) f1) (= (f19 f38 ?v0) f10))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f17 f39 ?v0) 1))))
(assert (forall ((?v0 S5)) (= (= (f19 f38 ?v0) f10) (= (f6 (f7 f11 f12) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (= (f17 f39 ?v0) 1) (< 0 ?v0))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f8 f12) (f19 f40 ?v0)) f1) (=> (= (f6 (f7 f11 f12) ?v0) f1) (= (f6 (f7 f8 f10) ?v0) f1)))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f11 f12) ?v0) f1) (= (f6 (f7 f11 (f19 f40 ?v0)) ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f11 f12))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (= (f19 f40 ?v0) (f19 f40 ?v1)) (= ?v0 ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f11 f12))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (= (f6 (f7 f11 (f19 f40 ?v0)) (f19 f40 ?v1)) f1) (= (f6 (f7 f11 ?v0) ?v1) f1)))))))
(assert (= (f19 f40 f10) f12))
(assert (= (f17 f39 0) 0))
(assert (= (f19 f38 f12) f12))
(assert (forall ((?v0 Int)) (= (= (f17 f39 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f19 f38 ?v0) f12) (= ?v0 f12))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f39 ?v0))) (= (f17 f39 ?v_0) ?v_0))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f19 f38 ?v0))) (= (f19 f38 ?v_0) ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f11 f12))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (= (f6 (f7 f8 (f19 f40 ?v0)) (f19 f40 ?v1)) f1) (= (f6 (f7 f8 ?v0) ?v1) f1)))))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f8 f10) ?v0) f1) (= (f6 (f7 f8 f12) (f19 f40 ?v0)) f1))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f11 f10) ?v0) f1) (= (f6 (f7 f11 f12) (f19 f40 ?v0)) f1))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f7 f11 f12))) (=> (= (f6 ?v_0 ?v0) f1) (= (= (f6 ?v_0 (f19 f40 ?v0)) f1) (= (f6 (f7 f11 f10) ?v0) f1))))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f11 f12) ?v0) f1) (= (= (f19 f40 ?v0) f12) (= ?v0 f10)))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f11 f12) ?v0) f1) (= (= (f6 (f7 f11 (f19 f40 ?v0)) f12) f1) (= (f6 (f7 f11 ?v0) f10) f1)))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f11 f12) ?v0) f1) (=> (= (f6 (f7 f11 ?v0) f10) f1) (= (f6 (f7 f11 (f19 f40 ?v0)) f12) f1)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f7 f11 f12))) (=> (= (f6 ?v_0 (f19 f40 ?v0)) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 (f7 f11 f10) ?v0) f1))))))
(assert (forall ((?v0 Int)) (= (< (f17 f39 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f11 (f19 f38 ?v0)) f12) f1) (= (f6 (f7 f11 ?v0) f12) f1))))
(assert (forall ((?v0 Int)) (= (< 0 (f17 f39 ?v0)) (< 0 ?v0))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f7 f11 f12))) (= (= (f6 ?v_0 (f19 f38 ?v0)) f1) (= (f6 ?v_0 ?v0) f1)))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f11 f12) ?v0) f1) (= (= (f6 (f7 f8 f12) (f19 f40 ?v0)) f1) (= (f6 (f7 f8 f10) ?v0) f1)))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f11 f12) ?v0) f1) (= (f19 f38 ?v0) f10))))
(assert (= (f41 f42 f21) f21))
(assert (= (f19 f38 f10) f10))
(assert (= (f41 f42 f23) f23))
(assert (= (f19 f38 f12) f12))
(assert (forall ((?v0 S11)) (= (= (f41 f42 ?v0) f23) (= ?v0 f23))))
(assert (forall ((?v0 S5)) (= (= (f19 f38 ?v0) f12) (= ?v0 f12))))
(assert (forall ((?v0 S5)) (= (f19 f38 ?v0) (ite (= ?v0 f12) f12 (ite (= (f6 (f7 f11 f12) ?v0) f1) f10 (f19 f43 f10))))))
(assert (forall ((?v0 S5)) (= (f19 f38 ?v0) (ite (= ?v0 f12) f12 (ite (= (f6 (f7 f11 f12) ?v0) f1) f10 (f19 f43 f10))))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f8 f12) ?v0) f1) (= (f6 (f7 f8 (f19 f40 (f19 (f26 f44 f10) ?v0))) ?v0) f1))))
(assert (forall ((?v0 S11)) (= (f41 f42 (f41 f45 ?v0)) (f41 f45 (f41 f42 ?v0)))))
(assert (forall ((?v0 S5)) (= (f19 f38 (f19 f43 ?v0)) (f19 f43 (f19 f38 ?v0)))))
(assert (forall ((?v0 Int)) (=> (<= ?v0 0) (= (f17 f18 ?v0) (- ?v0)))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f8 ?v0) f12) f1) (= (f19 f20 ?v0) (f19 f43 ?v0)))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f8 (f19 f43 ?v0)) ?v0) f1) (= (f6 (f7 f8 f12) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (<= (- ?v0) ?v0) (<= 0 ?v0))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f8 (f19 f43 ?v0)) f12) f1) (= (f6 (f7 f8 f12) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (<= (- ?v0) 0) (<= 0 ?v0))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (= (f6 ?v_0 (f19 f43 ?v0)) f1) (= (f6 ?v_0 f12) f1)))))
(assert (forall ((?v0 Int)) (= (<= ?v0 (- ?v0)) (<= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f8 f12) (f19 f43 ?v0)) f1) (= (f6 (f7 f8 ?v0) f12) f1))))
(assert (forall ((?v0 Int)) (= (<= 0 (- ?v0)) (<= ?v0 0))))
(assert (forall ((?v0 Int)) (<= (- (f17 f18 ?v0)) 0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 (f19 f43 (f19 f20 ?v0))) f12) f1)))
(assert (forall ((?v0 Int)) (= (f17 f18 ?v0) (ite (< ?v0 0) (- ?v0) ?v0))))
(assert (forall ((?v0 S5)) (= (f19 f20 ?v0) (ite (= (f6 (f7 f11 ?v0) f12) f1) (f19 f43 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f11 f12) (f19 f43 ?v0)) f1) (= (f6 (f7 f11 ?v0) f12) f1))))
(assert (forall ((?v0 Int)) (= (< 0 (- ?v0)) (< ?v0 0))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f7 f11 ?v0))) (= (= (f6 ?v_0 (f19 f43 ?v0)) f1) (= (f6 ?v_0 f12) f1)))))
(assert (forall ((?v0 Int)) (= (< ?v0 (- ?v0)) (< ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f11 (f19 f43 ?v0)) f12) f1) (= (f6 (f7 f11 f12) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (< (- ?v0) 0) (< 0 ?v0))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f11 (f19 f43 ?v0)) ?v0) f1) (= (f6 (f7 f11 f12) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (< (- ?v0) ?v0) (< 0 ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f17 f18 ?v0) (- ?v0)))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f11 ?v0) f12) f1) (= (f19 f20 ?v0) (f19 f43 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f11 (f19 (f26 f44 ?v0) ?v1)) f12) f1) (= (f6 (f7 f11 ?v1) (f19 f43 ?v0)) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f11 f12) (f19 (f26 f44 ?v0) ?v1)) f1) (= (f6 (f7 f11 (f19 f43 ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) (- ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f11 (f19 f43 ?v0)) (f19 f43 ?v1)) f1) (= (f6 (f7 f11 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f17 f18 ?v0) ?v1) (and (< ?v0 ?v1) (< (- ?v0) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f11 (f19 f20 ?v0)) ?v1) f1) (and (= (f6 (f7 f11 ?v0) ?v1) f1) (= (f6 (f7 f11 (f19 f43 ?v0)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) ?v1) (< (- ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f11 (f19 f43 ?v0)) ?v1) f1) (= (f6 (f7 f11 (f19 f43 ?v1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 (- ?v1)) (< ?v1 (- ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f11 ?v0) (f19 f43 ?v1)) f1) (= (f6 (f7 f11 ?v1) (f19 f43 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f44 ?v0))) (=> (= (f6 (f7 f11 (f19 ?v_0 ?v1)) (f19 ?v_0 ?v2)) f1) (= (f6 (f7 f11 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f11 (f19 (f26 f44 ?v0) ?v1)) (f19 (f26 f44 ?v2) ?v1)) f1) (= (f6 (f7 f11 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (=> (= (f6 (f7 f11 ?v2) ?v3) f1) (= (f6 (f7 f11 (f19 (f26 f44 ?v0) ?v2)) (f19 (f26 f44 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f44 ?v2))) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (= (f6 (f7 f11 (f19 ?v_0 ?v0)) (f19 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f11 ?v0) ?v1) f1) (= (f6 (f7 f11 (f19 (f26 f44 ?v0) ?v2)) (f19 (f26 f44 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f44 ?v0))) (= (= (f6 (f7 f11 (f19 ?v_0 ?v1)) (f19 ?v_0 ?v2)) f1) (= (f6 (f7 f11 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f11 (f19 (f26 f44 ?v0) ?v1)) (f19 (f26 f44 ?v2) ?v1)) f1) (= (f6 (f7 f11 ?v0) ?v2) f1))))
(assert (forall ((?v0 S11)) (= (f41 f45 (f41 f45 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (= (- (- ?v0)) ?v0)))
(assert (forall ((?v0 S5)) (= (f19 f43 (f19 f43 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (= (f17 f18 (- ?v0)) (f17 f18 ?v0))))
(assert (forall ((?v0 S5)) (= (f19 f20 (f19 f43 ?v0)) (f19 f20 ?v0))))
(assert (forall ((?v0 S11) (?v1 S11)) (= (f41 f45 (f41 (f46 f47 ?v0) ?v1)) (f41 (f46 f47 (f41 f45 ?v0)) (f41 f45 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1)) (+ (- ?v0) (- ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f19 f43 (f19 (f26 f44 ?v0) ?v1)) (f19 (f26 f44 (f19 f43 ?v0)) (f19 f43 ?v1)))))
(assert (forall ((?v0 S11) (?v1 S11)) (= (f41 f45 (f41 (f46 f47 ?v0) ?v1)) (f41 (f46 f47 (f41 f45 ?v1)) (f41 f45 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1)) (+ (- ?v1) (- ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f19 f43 (f19 (f26 f44 ?v0) ?v1)) (f19 (f26 f44 (f19 f43 ?v1)) (f19 f43 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f17 (f24 f25 ?v0) ?v1)) (f17 (f24 f28 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f19 f43 (f19 (f26 f27 ?v0) ?v1)) (f19 (f26 f29 (f19 f43 ?v0)) (f19 f43 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f17 (f24 f28 ?v0) ?v1)) (f17 (f24 f25 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f19 f43 (f19 (f26 f29 ?v0) ?v1)) (f19 (f26 f27 (f19 f43 ?v0)) (f19 f43 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f19 f20 (f19 (f26 f44 ?v0) (f19 f43 ?v1))) (f19 f20 (f19 (f26 f44 ?v1) (f19 f43 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f17 f18 ?v0) (f17 f18 ?v1)))) (= (f17 f18 ?v_0) ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f19 (f26 f44 (f19 f20 ?v0)) (f19 f20 ?v1)))) (= (f19 f20 ?v_0) ?v_0))))
(assert (forall ((?v0 S11) (?v1 S11)) (= (= ?v0 (f41 f45 ?v1)) (= ?v1 (f41 f45 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (- ?v1)) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 (f19 f43 ?v1)) (= ?v1 (f19 f43 ?v0)))))
(assert (forall ((?v0 S11) (?v1 S11)) (= (f41 (f46 f47 ?v0) (f41 (f46 f47 (f41 f45 ?v0)) ?v1)) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (+ (- ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f19 (f26 f44 ?v0) (f19 (f26 f44 (f19 f43 ?v0)) ?v1)) ?v1)))
(assert (forall ((?v0 S11) (?v1 S11)) (= (= (f41 f45 ?v0) ?v1) (= (f41 f45 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) ?v1) (= (- ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f19 f43 ?v0) ?v1) (= (f19 f43 ?v1) ?v0))))
(assert (forall ((?v0 S11) (?v1 S11)) (= (= (f41 f45 ?v0) (f41 f45 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) (- ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f19 f43 ?v0) (f19 f43 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S11) (?v1 S11)) (= (f41 (f46 f47 (f41 f45 ?v0)) (f41 (f46 f47 ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (- ?v0) (+ ?v0 ?v1)) ?v1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f19 (f26 f44 (f19 f43 ?v0)) (f19 (f26 f44 ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (let ((?v_0 (f46 f47 ?v0))) (= (f41 (f46 f47 (f41 ?v_0 ?v1)) ?v2) (f41 ?v_0 (f41 (f46 f47 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f44 ?v0))) (= (f19 (f26 f44 (f19 ?v_0 ?v1)) ?v2) (f19 ?v_0 (f19 (f26 f44 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f17 (f24 f25 ?v0) ?v1) ?v2) (f17 (f24 f25 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f19 (f26 f44 (f19 (f26 f27 ?v0) ?v1)) ?v2) (f19 (f26 f27 (f19 (f26 f44 ?v0) ?v2)) (f19 (f26 f44 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f17 (f24 f28 ?v0) ?v1) ?v2) (f17 (f24 f28 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f19 (f26 f44 (f19 (f26 f29 ?v0) ?v1)) ?v2) (f19 (f26 f29 (f19 (f26 f44 ?v0) ?v2)) (f19 (f26 f44 ?v1) ?v2)))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (let ((?v_0 (f46 f47 ?v0))) (= (= (f41 ?v_0 ?v1) (f41 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f44 ?v0))) (= (= (f19 ?v_0 ?v1) (f19 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (= (= (f41 (f46 f47 ?v0) ?v1) (f41 (f46 f47 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f19 (f26 f44 ?v0) ?v1) (f19 (f26 f44 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (let ((?v_0 (f46 f47 ?v0))) (=> (= (f41 ?v_0 ?v1) (f41 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f44 ?v0))) (=> (= (f19 ?v_0 ?v1) (f19 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (let ((?v_0 (f46 f47 ?v0))) (=> (= (f41 ?v_0 ?v1) (f41 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f44 ?v0))) (=> (= (f19 ?v_0 ?v1) (f19 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f19 (f26 f44 ?v0) ?v1) (f19 (f26 f44 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f44 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 (f19 ?v_0 ?v0)) (f19 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 (f19 f20 ?v0)) ?v1) f1) (and (= (f6 (f7 f8 (f19 f43 ?v1)) ?v0) f1) (= (f6 (f7 f8 ?v0) ?v1) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f44 ?v0))) (=> (= (f6 (f7 f8 (f19 ?v_0 ?v1)) (f19 ?v_0 ?v2)) f1) (= (f6 (f7 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 (f19 (f26 f44 ?v0) ?v1)) (f19 (f26 f44 ?v2) ?v1)) f1) (= (f6 (f7 f8 ?v0) ?v2) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (= (f6 (f7 f8 (f19 (f26 f44 ?v0) ?v2)) (f19 (f26 f44 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f44 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 (f19 ?v_0 ?v0)) (f19 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 (f19 (f26 f44 ?v0) ?v2)) (f19 (f26 f44 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f44 ?v0))) (= (= (f6 (f7 f8 (f19 ?v_0 ?v1)) (f19 ?v_0 ?v2)) f1) (= (f6 (f7 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f8 (f19 (f26 f44 ?v0) ?v1)) (f19 (f26 f44 ?v2) ?v1)) f1) (= (f6 (f7 f8 ?v0) ?v2) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f19 f20 (f19 (f26 f44 ?v0) ?v1))) (f19 (f26 f44 (f19 f20 ?v0)) (f19 f20 ?v1))) f1)))
(assert (forall ((?v0 S5)) (= (f19 (f26 f44 f12) ?v0) ?v0)))
(assert (forall ((?v0 S11)) (= (f41 (f46 f47 f23) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f19 (f26 f44 f12) ?v0) ?v0)))
(assert (forall ((?v0 S11)) (= (f41 (f46 f47 f23) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (= f12 (f19 (f26 f44 ?v0) ?v0)) (= ?v0 f12))))
(assert (forall ((?v0 Int)) (= (= 0 (+ ?v0 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (f19 (f26 f44 ?v0) f12) ?v0)))
(assert (forall ((?v0 S11)) (= (f41 (f46 f47 ?v0) f23) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S5)) (= (f19 (f26 f44 ?v0) f12) ?v0)))
(assert (forall ((?v0 S11)) (= (f41 (f46 f47 ?v0) f23) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 (f19 f20 ?v0)) ?v1) f1) (= (f6 (f7 f8 (f19 f43 ?v0)) ?v1) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 (f19 f43 ?v0)) ?v1) f1) (= (f6 (f7 f8 (f19 f20 ?v0)) ?v1) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 (f19 f43 ?v1)) (f19 f43 ?v0)) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 (f19 f43 ?v0)) (f19 f43 ?v1)) f1) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 (f19 f20 ?v0)) ?v1) f1) (and (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 (f19 f43 ?v0)) ?v1) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 (f19 f43 ?v0)) ?v1) f1) (= (f6 (f7 f8 (f19 f43 ?v1)) ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) (f19 f43 ?v1)) f1) (= (f6 (f7 f8 ?v1) (f19 f43 ?v0)) f1))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 (f19 f43 ?v0)) (f19 f20 ?v0)) f1)))
(assert (= (f41 f45 f23) f23))
(assert (= 0 0))
(assert (= (f19 f43 f12) f12))
(assert (forall ((?v0 S11)) (= (= f23 (f41 f45 ?v0)) (= f23 ?v0))))
(assert (forall ((?v0 Int)) (= (= 0 (- ?v0)) (= 0 ?v0))))
(assert (forall ((?v0 S5)) (= (= f12 (f19 f43 ?v0)) (= f12 ?v0))))
(assert (forall ((?v0 Int)) (= (= ?v0 (- ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= ?v0 (f19 f43 ?v0)) (= ?v0 f12))))
(assert (forall ((?v0 S11)) (= (= (f41 f45 ?v0) f23) (= ?v0 f23))))
(assert (forall ((?v0 Int)) (= (= (- ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f19 f43 ?v0) f12) (= ?v0 f12))))
(assert (forall ((?v0 Int)) (= (= (- ?v0) ?v0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f19 f43 ?v0) ?v0) (= ?v0 f12))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 f12) (f19 (f26 f44 ?v0) ?v1)) f1) (= (f6 (f7 f8 (f19 f43 ?v0)) ?v1) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 (f19 (f26 f44 ?v0) ?v1)) f12) f1) (= (f6 (f7 f8 ?v1) (f19 f43 ?v0)) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f19 (f26 f44 ?v0) ?v1) f12) (= ?v1 (f19 f43 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f19 (f26 f44 ?v0) (f19 f43 ?v1)) f12) (= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f26 f44 ?v0)) (?v_1 (f19 f43 ?v2)) (?v_2 (f19 f43 ?v3))) (= (f6 (f7 f8 (f19 f20 (f19 (f26 f44 (f19 ?v_0 ?v1)) (f19 (f26 f44 ?v_1) ?v_2)))) (f19 (f26 f44 (f19 f20 (f19 ?v_0 ?v_1))) (f19 f20 (f19 (f26 f44 ?v1) ?v_2)))) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f19 (f26 f44 ?v0) ?v1) f12) (= (f19 f43 ?v0) ?v1))))
(assert (forall ((?v0 S11) (?v1 S11)) (=> (= (f41 (f46 f47 ?v0) ?v1) f23) (= (f41 f45 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (+ ?v0 ?v1) 0) (= (- ?v0) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f19 (f26 f44 ?v0) ?v1) f12) (= ?v1 (f19 f43 ?v0)))))
(assert (forall ((?v0 S11) (?v1 S11)) (= (= (f41 (f46 f47 ?v0) ?v1) f23) (= ?v1 (f41 f45 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ ?v0 ?v1) 0) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 S5)) (= (f19 (f26 f44 (f19 f43 ?v0)) ?v0) f12)))
(assert (forall ((?v0 S11)) (= (f41 (f46 f47 (f41 f45 ?v0)) ?v0) f23)))
(assert (forall ((?v0 Int)) (= (+ (- ?v0) ?v0) 0)))
(assert (forall ((?v0 S7)) (= (f15 f16 (f48 f49 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f48 f49 (f15 f16 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f48 f49 (f15 f16 ?v0)) 0))))
(check-sat)
(exit)
