(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S5) S3)
(declare-fun f5 () S4)
(declare-fun f6 () S5)
(declare-fun f7 () S2)
(declare-fun f8 (S6 S5) S5)
(declare-fun f9 (S7 S2) S6)
(declare-fun f10 () S7)
(declare-fun f11 () S2)
(declare-fun f12 () S5)
(declare-fun f13 (S8 S9) Int)
(declare-fun f14 () S8)
(declare-fun f15 (S10 S5) S9)
(declare-fun f16 (S11 S2) S10)
(declare-fun f17 () S11)
(declare-fun f18 () S10)
(declare-fun f19 (S12 Int) S9)
(declare-fun f20 () S12)
(assert (not (= f1 f2)))
(assert (not (forall ((?v0 S2)) (not (= (f3 (f4 f5 f6) ?v0) f7)))))
(assert (= f6 (f8 (f9 f10 f11) f12)))
(assert (not (= f11 f7)))
(assert (forall ((?v0 S5) (?v1 S2)) (=> (not (= ?v0 f12)) (<= (f13 f14 (f15 (f16 f17 ?v1) ?v0)) (f13 f14 (f15 f18 ?v0))))))
(assert (= (f15 f18 f6) (f19 f20 0)))
(assert (not (= f6 f12)))
(assert (forall ((?v0 S9)) (= (f19 f20 (f13 f14 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f13 f14 (f19 f20 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f13 f14 (f19 f20 ?v0)) 0))))
(check-sat)
(exit)
