(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 Int) Int)
(declare-fun f9 (S7 Int) S6)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S2) Int)
(declare-fun f12 () S8)
(declare-fun f13 (S9 S10) S10)
(declare-fun f14 () S9)
(declare-fun f15 (S11 Int) S10)
(declare-fun f16 () S11)
(declare-fun f17 () S6)
(declare-fun f18 () S6)
(declare-fun f19 () Int)
(declare-fun f20 (S12 S2) S10)
(declare-fun f21 (S13 S10) S12)
(declare-fun f22 () S13)
(declare-fun f23 (S14 S10) S9)
(declare-fun f24 () S14)
(declare-fun f25 () S9)
(declare-fun f26 () S6)
(declare-fun f27 () S5)
(declare-fun f28 () S14)
(declare-fun f29 (Int) S1)
(declare-fun f30 (S10) S1)
(declare-fun f31 (Int S15) S1)
(declare-fun f32 () S15)
(declare-fun f33 (S10 S16) S1)
(declare-fun f34 () S16)
(declare-fun f35 () S14)
(declare-fun f36 () S10)
(declare-fun f37 (S16 S10) S1)
(declare-fun f38 (S10) S16)
(declare-fun f39 () S4)
(declare-fun f40 () S4)
(declare-fun f41 (S2 S17) S1)
(declare-fun f42 (S17 S2) S1)
(declare-fun f43 (S15 Int) S1)
(declare-fun f44 () S4)
(declare-fun f45 (S18 Int) S8)
(declare-fun f46 () S18)
(declare-fun f47 () S6)
(declare-fun f48 () S9)
(declare-fun f49 () S17)
(declare-fun f50 () S10)
(declare-fun f51 () S10)
(declare-fun f52 () S2)
(declare-fun f53 (S2) S1)
(declare-fun f54 (S2) S17)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))))))
(assert (let ((?v_0 (f8 f17 (f8 f18 f19)))) (not (= (f13 f14 (f15 f16 (f8 f17 ?v_0))) (f13 f14 (f20 (f21 f22 (f15 f16 ?v_0)) (f6 f7 2)))))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f8 f17 (f8 f18 f19))) (?v_1 (f6 f7 2))) (= (f13 (f23 f24 (f20 (f21 f22 ?v0) ?v_1)) (f15 f16 (f8 f17 ?v_0))) (f20 (f21 f22 (f13 (f23 f24 ?v0) (f15 f16 ?v_0))) ?v_1)))))
(assert (forall ((?v0 S10) (?v1 S2)) (= (f13 f14 (f20 (f21 f22 ?v0) ?v1)) (f20 (f21 f22 (f13 f14 ?v0)) ?v1))))
(assert (forall ((?v0 S10)) (= (f13 f14 (f20 (f21 f22 ?v0) (f6 f7 2))) (f13 f25 ?v0))))
(assert (= (f8 f17 f19) f19))
(assert (forall ((?v0 Int)) (= (- f19 (f8 f17 ?v0)) (f8 f17 (- f19 ?v0)))))
(assert (forall ((?v0 Int)) (= (= f19 (f8 f17 ?v0)) (= f19 ?v0))))
(assert (forall ((?v0 Int)) (= (< f19 (f8 f17 ?v0)) (< f19 ?v0))))
(assert (forall ((?v0 Int)) (= (<= f19 (f8 f17 ?v0)) (<= f19 ?v0))))
(assert (forall ((?v0 Int)) (= (= (f8 f17 ?v0) f19) (= ?v0 f19))))
(assert (forall ((?v0 Int)) (= (< (f8 f17 ?v0) f19) (< ?v0 f19))))
(assert (forall ((?v0 Int)) (= (<= (f8 f17 ?v0) f19) (<= ?v0 f19))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 f17 ?v0) (f8 f18 ?v1)) false)))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f13 f14 (f13 (f23 f24 ?v0) ?v1)) (f13 (f23 f24 (f13 f14 ?v0)) (f13 f14 ?v1)))))
(assert (forall ((?v0 S10)) (= (f13 (f23 f24 ?v0) (f15 f16 (f8 f18 f19))) ?v0)))
(assert (forall ((?v0 S10)) (= (f13 (f23 f24 ?v0) (f15 f16 (f8 f18 f19))) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 f26 ?v0) (f8 f26 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 f16 ?v0) (f15 f16 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f6 f27 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f26 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f15 f16 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f8 f18 ?v0) (f8 f18 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f8 f18 ?v0) (f8 f18 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f8 f18 ?v0) (f8 f18 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f8 f18 ?v0) (f8 f18 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 f18 ?v0) (f8 f18 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (< (f8 f18 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (f8 f18 ?v0) (+ (+ 1 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (- ?v0 f19) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 f19) ?v0)))
(assert (forall ((?v0 Int)) (= (+ f19 ?v0) ?v0)))
(assert (= (<= f19 f19) true))
(assert (= (< f19 0) false))
(assert (= (< f19 f19) false))
(assert (= (= f19 f19) true))
(assert (= (- f19) f19))
(assert (= f19 0))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f8 f17 ?v0) (f8 f17 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f8 f17 ?v0) (f8 f17 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f8 f17 ?v0) (f8 f17 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f8 f17 ?v0) (f8 f17 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 f17 ?v0) (f8 f17 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f8 f17 ?v0) (f8 f17 ?v1)) (f8 f17 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f8 f17 ?v0) (f8 f17 ?v1)) (f8 f17 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (= (< (f8 f17 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (- (f8 f17 ?v0)) (f8 f17 (- ?v0)))))
(assert (forall ((?v0 Int)) (= (f8 f17 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f13 f14 ?v0) (f13 f14 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (<= (f8 f18 ?v0) f19) (< ?v0 f19))))
(assert (forall ((?v0 Int)) (= (< (f8 f18 ?v0) f19) (< ?v0 f19))))
(assert (forall ((?v0 Int)) (= (= (f8 f18 ?v0) f19) false)))
(assert (forall ((?v0 Int)) (= (<= f19 (f8 f18 ?v0)) (<= f19 ?v0))))
(assert (forall ((?v0 Int)) (= (< f19 (f8 f18 ?v0)) (<= f19 ?v0))))
(assert (forall ((?v0 Int)) (= (= f19 (f8 f18 ?v0)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f8 f18 ?v0) (f8 f17 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f8 f18 ?v0) (f8 f17 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f8 f17 ?v0) (f8 f18 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f8 f17 ?v0) (f8 f18 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f8 f18 ?v0) (f8 f17 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f8 f18 ?v0) (f8 f17 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f8 f17 ?v0) (f8 f18 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f8 f17 ?v0) (f8 f18 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f8 f18 ?v0) (f8 f18 ?v1)) (f8 f17 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f8 f18 ?v0) (f8 f17 ?v1)) (f8 f18 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f8 f18 ?v0) (f8 f17 ?v1)) (f8 f18 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f8 f17 ?v0) (f8 f18 ?v1)) (f8 f18 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 f18 ?v0) (f8 f17 ?v1)) false)))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S2)) (= (f20 (f21 f22 (f13 (f23 f24 ?v0) ?v1)) ?v2) (f13 (f23 f24 (f20 (f21 f22 ?v0) ?v2)) (f20 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f8 f17 (f8 f18 f19))) (?v_1 (f6 f7 2))) (= (f13 (f23 f28 (f15 f16 (f8 f17 ?v_0))) (f20 (f21 f22 ?v0) ?v_1)) (f20 (f21 f22 (f13 (f23 f28 (f15 f16 ?v_0)) ?v0)) ?v_1)))))
(assert (not (= (f29 1) f1)))
(assert (not (= (f30 (f15 f16 (f8 f18 f19))) f1)))
(assert (forall ((?v0 Int)) (=> (<= f19 ?v0) (= (f31 (f8 f26 ?v0) f32) f1))))
(assert (forall ((?v0 Int)) (=> (<= f19 ?v0) (= (f33 (f15 f16 ?v0) f34) f1))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f23 f28 (f15 f16 (f8 f17 (f8 f18 f19))))) (?v_1 (f23 f24 ?v1))) (= (= ?v0 (f13 ?v_1 (f13 ?v_0 ?v2))) (= (f13 ?v_0 ?v0) (f13 ?v_1 ?v2))))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f13 (f23 f24 ?v0) (f15 f16 (f8 f17 (f8 f18 f19)))))) (= (f13 (f23 f35 ?v_0) ?v_0) ?v0))))
(assert (let ((?v_0 (f15 f16 (f8 f17 (f8 f18 f19))))) (not (= (f13 (f23 f24 f36) ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (= (f29 (f8 f26 (f8 f17 ?v0))) f1) (= (f29 (f8 f26 ?v0)) f1))))
(assert (forall ((?v0 Int)) (= (= (f30 (f15 f16 (f8 f17 ?v0))) f1) (= (f30 (f15 f16 ?v0)) f1))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_1 (f6 f7 2)) (?v_0 (f13 (f23 f24 ?v1) (f13 f14 (f15 f16 (f8 f17 (f8 f18 f19))))))) (=> (= (f37 (f38 (f13 f25 ?v0)) ?v_0) f1) (=> (= (f37 (f38 (f13 f25 ?v2)) ?v_0) f1) (= (f37 (f38 (f13 f14 (f13 (f23 f35 (f20 (f21 f22 ?v0) ?v_1)) (f20 (f21 f22 ?v2) ?v_1)))) ?v1) f1))))))
(assert (= (f29 0) f1))
(assert (= (f30 (f15 f16 f19)) f1))
(assert (forall ((?v0 Int)) (not (= (f29 (f8 f26 (f8 f18 ?v0))) f1))))
(assert (forall ((?v0 Int)) (not (= (f30 (f15 f16 (f8 f18 ?v0))) f1))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 Int)) (let ((?v_0 (f15 f16 ?v2))) (= (f13 (f23 f28 (f13 (f23 f35 ?v0) ?v1)) ?v_0) (f13 (f23 f35 (f13 (f23 f28 ?v0) ?v_0)) (f13 (f23 f28 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f8 f26 ?v2))) (= (f8 (f9 f10 (+ ?v0 ?v1)) ?v_0) (+ (f8 (f9 f10 ?v0) ?v_0) (f8 (f9 f10 ?v1) ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f6 f27 ?v2))) (= (f3 (f4 f39 (f3 (f4 f40 ?v0) ?v1)) ?v_0) (f3 (f4 f40 (f3 (f4 f39 ?v0) ?v_0)) (f3 (f4 f39 ?v1) ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S17)) (= (= (f41 ?v0 ?v1) f1) (= (f42 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S15)) (= (= (f31 ?v0 ?v1) f1) (= (f43 ?v1 ?v0) f1))))
(assert (forall ((?v0 S10) (?v1 S16)) (= (= (f33 ?v0 ?v1) f1) (= (f37 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f23 f28 (f15 f16 ?v0)))) (= (f13 ?v_0 (f13 (f23 f35 ?v1) ?v2)) (f13 (f23 f35 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 (f8 f26 ?v0)))) (= (f8 ?v_0 (+ ?v1 ?v2)) (+ (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f39 (f6 f27 ?v0)))) (= (f3 ?v_0 (f3 (f4 f40 ?v1) ?v2)) (f3 (f4 f40 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (f8 f26 ?v0)) (f8 (f9 f10 (f8 f26 ?v1)) ?v2)) (f8 (f9 f10 (f8 f26 (f8 (f9 f10 ?v0) ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (= (f13 (f23 f28 (f15 f16 ?v0)) (f13 (f23 f28 (f15 f16 ?v1)) ?v2)) (f13 (f23 f28 (f15 f16 (f8 (f9 f10 ?v0) ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (f8 f26 ?v0)) (f8 f26 ?v1)) (f8 f26 (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f13 (f23 f28 (f15 f16 ?v0)) (f15 f16 ?v1)) (f15 f16 (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 f26 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f8 f26 ?v0)) (f8 f26 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 f16 (f8 (f9 f10 ?v0) ?v1)) (f13 (f23 f28 (f15 f16 ?v0)) (f15 f16 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f44 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f39 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f45 f46 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f13 (f23 f28 ?v0) (f20 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f44 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f39 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f45 f46 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 (f11 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f13 (f23 f28 (f20 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f44 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f3 (f4 f39 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f45 f46 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S2) (?v2 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f13 (f23 f28 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f3 (f4 f44 ?v0) ?v1))) (= (f3 (f4 f39 ?v_0) ?v0) (f3 (f4 f39 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f11 (f45 f46 ?v0) ?v1))) (= (f8 (f9 f10 ?v_0) ?v0) (f8 (f9 f10 ?v0) ?v_0)))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f20 (f21 f22 ?v0) ?v1))) (= (f13 (f23 f28 ?v_0) ?v0) (f13 (f23 f28 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f4 f44 (f3 (f4 f39 ?v0) ?v1)) ?v2) (f3 (f4 f39 (f3 (f4 f44 ?v0) ?v2)) (f3 (f4 f44 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f11 (f45 f46 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f11 (f45 f46 ?v0) ?v2)) (f11 (f45 f46 ?v1) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S2)) (= (f20 (f21 f22 (f13 (f23 f28 ?v0) ?v1)) ?v2) (f13 (f23 f28 (f20 (f21 f22 ?v0) ?v2)) (f20 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f4 f44 ?v2))) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f3 (f4 f39 (f3 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f45 f46 ?v2))) (=> (<= ?v_1 ?v_0) (= (f11 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f8 (f9 f10 (f11 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S10)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f21 f22 ?v2))) (=> (<= ?v_1 ?v_0) (= (f20 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f13 (f23 f28 (f20 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_0 (f6 f7 2))) (let ((?v_1 (f13 (f23 f28 (f13 (f23 f35 (f20 (f21 f22 ?v0) ?v_0)) (f20 (f21 f22 ?v1) ?v_0))) (f13 (f23 f35 (f20 (f21 f22 ?v2) ?v_0)) (f20 (f21 f22 ?v3) ?v_0))))) (= (f20 (f21 f22 (f13 f14 ?v_1)) ?v_0) ?v_1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 f16 (+ ?v0 ?v1)) (f13 (f23 f35 (f15 f16 ?v0)) (f15 f16 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 f26 (+ ?v0 ?v1)) (+ (f8 f26 ?v0) (f8 f26 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f13 (f23 f35 (f15 f16 ?v0)) (f15 f16 ?v1)) (f15 f16 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f8 f26 ?v0) (f8 f26 ?v1)) (f8 f26 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (= (f13 (f23 f35 (f15 f16 ?v0)) (f13 (f23 f35 (f15 f16 ?v1)) ?v2)) (f13 (f23 f35 (f15 f16 (+ ?v0 ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f8 f26 ?v0) (+ (f8 f26 ?v1) ?v2)) (+ (f8 f26 (+ ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f37 (f38 (f15 f16 ?v0)) (f15 f16 ?v1)) f1) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f8 f26 ?v0) (f8 f26 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f23 f28 ?v0))) (= (f13 (f23 f24 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v0)) (f13 (f23 f24 ?v1) ?v0)))))
(assert (forall ((?v0 S10)) (= (f13 f14 (f13 (f23 f28 ?v0) ?v0)) (f13 f25 ?v0))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f13 f14 (f13 (f23 f28 ?v0) ?v1)) (f13 (f23 f28 (f13 f14 ?v0)) (f13 f14 ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f37 (f38 (f13 f14 ?v0)) (f13 f14 ?v1)) f1) (= (f37 (f38 ?v0) ?v1) f1))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f37 (f38 ?v0) ?v1) f1) (= (f37 (f38 (f13 f14 ?v0)) (f13 f14 ?v1)) f1))))
(assert (= (f37 (f38 f36) (f15 f16 (f8 f17 (f8 f17 (f8 f18 f19))))) f1))
(assert (forall ((?v0 S10)) (= (f13 (f23 f28 ?v0) (f15 f16 (f8 f17 (f8 f18 f19)))) (f13 (f23 f35 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* ?v0 2) (+ ?v0 ?v0))))
(assert (forall ((?v0 S10)) (= (f13 (f23 f28 ?v0) (f15 f16 (f8 f17 (f8 f18 f19)))) (f13 (f23 f35 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* ?v0 2) (+ ?v0 ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f39 ?v0) (f6 f27 (f8 f17 (f8 f18 f19)))) (f3 (f4 f40 ?v0) ?v0))))
(assert (forall ((?v0 S10)) (= (f13 (f23 f28 (f15 f16 (f8 f17 (f8 f18 f19)))) ?v0) (f13 (f23 f35 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* 2 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S10)) (= (f13 (f23 f28 (f15 f16 (f8 f17 (f8 f18 f19)))) ?v0) (f13 (f23 f35 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* 2 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f39 (f6 f27 (f8 f17 (f8 f18 f19)))) ?v0) (f3 (f4 f40 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 f26 ?v0) (f8 f26 ?v1)) (= (f29 (f8 f26 (+ ?v0 (- ?v1)))) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 f16 ?v0) (f15 f16 ?v1)) (= (f30 (f15 f16 (+ ?v0 (- ?v1)))) f1))))
(assert (let ((?v_0 (f15 f16 (f8 f17 (f8 f18 f19))))) (= (f37 (f38 (f13 (f23 f24 f36) ?v_0)) ?v_0) f1)))
(assert (forall ((?v0 S10)) (= (f13 (f23 f35 ?v0) (f15 f16 f19)) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S10)) (= (f13 (f23 f35 (f15 f16 f19)) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S10)) (= (f13 (f23 f28 ?v0) (f15 f16 (f8 f18 f19))) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S10)) (= (f13 (f23 f28 (f15 f16 (f8 f18 f19))) ?v0) ?v0)))
(assert (forall ((?v0 S10) (?v1 S2)) (= (f13 f25 (f20 (f21 f22 ?v0) ?v1)) (f20 (f21 f22 (f13 f25 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f8 f47 (f11 (f45 f46 ?v0) ?v1)) (f11 (f45 f46 (f8 f47 ?v0)) ?v1))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f44 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f11 (f45 f46 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S10)) (= (f20 (f21 f22 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f6 f7 2))) (= (f20 (f21 f22 (f13 (f23 f35 ?v0) ?v1)) ?v_0) (f13 (f23 f35 (f13 (f23 f35 (f20 (f21 f22 ?v0) ?v_0)) (f20 (f21 f22 ?v1) ?v_0))) (f13 (f23 f28 (f13 (f23 f28 (f15 f16 (f8 f17 (f8 f18 f19)))) ?v0)) ?v1))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f38 ?v0))) (=> (= (f37 ?v_0 ?v1) f1) (= (f37 ?v_0 (f13 (f23 f24 (f13 (f23 f35 ?v0) ?v1)) (f15 f16 (f8 f17 (f8 f18 f19))))) f1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f37 (f38 ?v0) ?v1) f1) (= (f37 (f38 (f13 (f23 f24 (f13 (f23 f35 ?v0) ?v1)) (f15 f16 (f8 f17 (f8 f18 f19))))) ?v1) f1))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f6 f7 2))) (= (f20 (f21 f22 (f13 (f23 f35 ?v0) ?v1)) ?v_0) (f13 (f23 f35 (f13 (f23 f35 (f20 (f21 f22 ?v0) ?v_0)) (f20 (f21 f22 ?v1) ?v_0))) (f13 (f23 f28 (f13 (f23 f28 (f15 f16 (f8 f17 (f8 f18 f19)))) ?v0)) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f45 f46 (+ ?v0 ?v1)) ?v_0) (+ (+ (f11 (f45 f46 ?v0) ?v_0) (f11 (f45 f46 ?v1) ?v_0)) (f8 (f9 f10 (* 2 ?v0)) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 2))) (= (f3 (f4 f44 (f3 (f4 f40 ?v0) ?v1)) ?v_0) (f3 (f4 f40 (f3 (f4 f40 (f3 (f4 f44 ?v0) ?v_0)) (f3 (f4 f44 ?v1) ?v_0))) (f3 (f4 f39 (f3 (f4 f39 (f6 f27 (f8 f17 (f8 f18 f19)))) ?v0)) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f19 ?v0) (=> (<= f19 ?v1) (= (f13 (f23 f35 (f15 f16 ?v0)) (f15 f16 ?v1)) (f15 f16 (+ ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f19 ?v0) (=> (<= f19 ?v1) (= (+ (f8 f26 ?v0) (f8 f26 ?v1)) (f8 f26 (+ ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f19 ?v0) (=> (<= f19 ?v1) (= (f3 (f4 f40 (f6 f27 ?v0)) (f6 f27 ?v1)) (f6 f27 (+ ?v0 ?v1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f27 ?v0))) (= (f3 (f4 f44 ?v_0) (f6 f7 2)) (f3 (f4 f39 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f26 ?v0))) (= (f11 (f45 f46 ?v_0) (f6 f7 2)) (f8 (f9 f10 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f16 ?v0))) (= (f20 (f21 f22 ?v_0) (f6 f7 2)) (f13 (f23 f28 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (= (f6 f7 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0)))) (f11 f12 (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f45 f46 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (+ ?v1 ?v2)) (+ (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (- ?v1 ?v2)) (- (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) ?v1) (- (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (f8 f26 ?v0)) (f8 f26 ?v1)) (f8 f26 (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (+ ?v0 ?v1)) ?v2) (+ (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (- ?v0 ?v1)) ?v2) (- (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v0)))) (f11 f12 (f6 f7 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f11 f12 ?v2))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f8 ?v_1 ?v0) (f8 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 (f9 f10 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f27 ?v0))) (f8 (f9 f10 (f11 f12 (f6 f27 ?v1))) ?v_0))) (ite (< ?v0 f19) (f6 f7 0) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f27 (f8 (f9 f10 ?v0) ?v1)))) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f27 ?v0))) (f11 f12 (f6 f27 ?v1)))) (ite (< ?v0 f19) (f6 f7 0) (f6 f7 (f8 f26 (f8 (f9 f10 ?v0) ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f44 ?v0))) (= (f3 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f3 (f4 f44 (f3 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f45 f46 ?v0))) (= (f11 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f11 (f45 f46 (f11 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f20 (f21 f22 (f20 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 f19) ?v0) f19)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (f8 f17 ?v0)) ?v1) (f8 f17 (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f44 ?v0))) (= (f3 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f3 (f4 f44 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f45 f46 ?v0))) (= (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f11 (f45 f46 (f11 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S2) (?v2 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f20 (f21 f22 (f20 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (f8 f18 ?v0)) ?v1) (+ (f8 f17 (f8 (f9 f10 ?v0) ?v1)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f11 f12 (f6 f27 ?v0)) (f11 f12 (f6 f27 ?v1))) (ite (< ?v0 ?v1) (< f19 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f11 f12 (f6 f27 ?v0)) (f11 f12 (f6 f27 ?v1))) (ite (<= ?v0 ?v1) true (<= ?v0 f19)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 f7 (+ (f11 f12 (f6 f27 ?v0)) (f11 f12 (f6 f27 ?v1)))) (ite (< ?v0 f19) (f6 f7 (f8 f26 ?v1)) (ite (< ?v1 f19) (f6 f7 (f8 f26 ?v0)) (f6 f7 (f8 f26 (+ ?v0 ?v1))))))))
(assert (forall ((?v0 Int)) (= (= (f6 f7 (f8 f26 ?v0)) (f6 f7 0)) (<= ?v0 f19))))
(assert (forall ((?v0 Int)) (= (= (f6 f7 0) (f6 f7 (f8 f26 ?v0))) (<= ?v0 f19))))
(assert (forall ((?v0 Int)) (= (< 0 (f11 f12 (f6 f27 ?v0))) (< f19 ?v0))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f6 f7 2))) (= (f20 (f21 f22 (f13 f25 ?v0)) ?v_0) (f20 (f21 f22 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f45 f46 (f8 f47 ?v0)) ?v_0) (f11 (f45 f46 ?v0) ?v_0)))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f20 (f21 f22 ?v0) (f6 f7 2)))) (= (f13 f25 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 (f45 f46 ?v0) (f6 f7 2)))) (= (f8 f47 ?v_0) ?v_0))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f13 (f23 f28 ?v0) ?v1) (f13 (f23 f28 ?v1) ?v0))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f23 f28 ?v0))) (= (f13 (f23 f28 (f13 ?v_0 ?v1)) ?v2) (f13 ?v_0 (f13 (f23 f28 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f4 f44 ?v1))) (=> (< 0 ?v_0) (= (f3 (f4 f39 (f3 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f45 f46 ?v1))) (=> (< 0 ?v_0) (= (f8 (f9 f10 (f11 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f11 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S10)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f21 f22 ?v1))) (=> (< 0 ?v_0) (= (f13 (f23 f28 (f20 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f20 ?v_1 ?v0))))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f44 ?v0) (f6 f7 3)) (f3 (f4 f39 (f3 (f4 f39 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f45 f46 ?v0) (f6 f7 3)) (f8 (f9 f10 (f8 (f9 f10 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S10)) (= (f20 (f21 f22 ?v0) (f6 f7 3)) (f13 (f23 f28 (f13 (f23 f28 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f44 ?v0) (f6 f7 2)) (f3 (f4 f39 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f45 f46 ?v0) (f6 f7 2)) (f8 (f9 f10 ?v0) ?v0))))
(assert (forall ((?v0 S10)) (= (f20 (f21 f22 ?v0) (f6 f7 2)) (f13 (f23 f28 ?v0) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f44 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f3 (f4 f39 ?v0) (f3 (f4 f44 (f3 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f45 f46 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f8 (f9 f10 ?v0) (f11 (f45 f46 (f11 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f13 (f23 f28 ?v0) (f20 (f21 f22 (f20 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (= (f13 (f23 f28 (f13 (f23 f35 ?v0) ?v1)) ?v2) (f13 (f23 f35 (f13 (f23 f28 ?v0) ?v2)) (f13 (f23 f28 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f19 ?v0) (=> (<= f19 ?v1) (= (f8 (f9 f10 (f8 f26 ?v0)) (f8 f26 ?v1)) (f8 f26 (f8 (f9 f10 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f19 ?v0) (=> (<= f19 ?v1) (= (f13 (f23 f28 (f15 f16 ?v0)) (f15 f16 ?v1)) (f15 f16 (f8 (f9 f10 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f19 ?v0) (=> (<= f19 ?v1) (= (f3 (f4 f39 (f6 f27 ?v0)) (f6 f27 ?v1)) (f6 f27 (f8 (f9 f10 ?v0) ?v1)))))))
(assert (forall ((?v0 S10)) (= (f37 (f38 (f13 f48 ?v0)) (f13 (f23 f24 f36) (f15 f16 (f8 f17 (f8 f18 f19))))) f1)))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f33 ?v0 f34) f1) (=> (= (f33 ?v1 f34) f1) (= (f33 (f13 (f23 f35 ?v0) ?v1) f34) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f31 ?v0 f32) f1) (=> (= (f31 ?v1 f32) f1) (= (f31 (+ ?v0 ?v1) f32) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f41 ?v0 f49) f1) (=> (= (f41 ?v1 f49) f1) (= (f41 (f3 (f4 f40 ?v0) ?v1) f49) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f31 ?v0 f32) f1) (=> (= (f31 ?v1 f32) f1) (= (f31 (f8 (f9 f10 ?v0) ?v1) f32) f1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f33 ?v0 f34) f1) (=> (= (f33 ?v1 f34) f1) (= (f33 (f13 (f23 f28 ?v0) ?v1) f34) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f41 ?v0 f49) f1) (=> (= (f41 ?v1 f49) f1) (= (f41 (f3 (f4 f39 ?v0) ?v1) f49) f1)))))
(assert (forall ((?v0 S10)) (=> (= (f37 (f38 f50) ?v0) f1) (= (f37 (f38 (f13 (f23 f24 ?v0) (f13 f14 (f15 f16 (f8 f17 (f8 f18 f19)))))) ?v0) f1))))
(assert (not (= f51 f50)))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f45 f46 ?v0))) (= (f11 (f45 f46 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_2 (f11 f12 ?v0)) (?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (or (= ?v1 (f6 f7 1)) (= ?v0 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_3 (f11 f12 ?v3)) (?v_1 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_3 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v2))) (let ((?v_2 (f9 f10 ?v_0))) (=> (< ?v_1 ?v_3) (=> (< 0 ?v_0) (< (f8 ?v_2 ?v_1) (f8 ?v_2 ?v_3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f9 f10 (f11 f12 ?v2)))) (=> (<= ?v_0 ?v_2) (<= (f8 ?v_1 ?v_0) (f8 ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f8 (f9 f10 ?v_0) ?v_2) (f8 (f9 f10 ?v_1) ?v_2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f12 (f6 f27 ?v0)))) (=> (< 0 ?v_0) (= (f6 f7 (f8 f26 ?v0)) (f6 f7 (+ (f11 f12 (f6 f7 (- ?v_0 1))) 1)))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f23 f28 ?v0))) (=> (not (= ?v0 f50)) (= (= (f13 ?v_0 ?v1) (f13 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (=> (not (= ?v0 f50)) (= (= (f13 (f23 f28 ?v1) ?v0) (f13 (f23 f28 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (<= (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (< (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1)))) (= (= (f6 f7 (f8 ?v_0 (f11 f12 ?v1))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) ?v_0)) (f6 f7 (f8 (f9 f10 (f11 f12 ?v2)) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0)))) (= (= (f6 f7 (f8 ?v_0 (f11 f12 ?v1))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (<= (f8 (f9 f10 ?v_1) ?v_0) (f8 (f9 f10 ?v_2) ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v0))) (let ((?v_0 (f9 f10 ?v_1)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (= (<= (f8 ?v_0 ?v_2) (f8 ?v_0 ?v_3)) (=> (< 0 ?v_1) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (< (f8 (f9 f10 ?v_1) ?v_0) (f8 (f9 f10 ?v_2) ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v0))) (let ((?v_0 (f9 f10 ?v_1)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (= (< (f8 ?v_0 ?v_2) (f8 ?v_0 ?v_3)) (and (< 0 ?v_1) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_2)))) ?v_1)) (f6 f7 (- (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (+ ?v_0 ?v_2)) ?v_1)) (f6 f7 (+ (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f8 ?v_0 ?v_1)) ?v_2)) (f6 f7 (f8 ?v_0 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (* 2 ?v_0)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 (+ ?v_1 1)) ?v_0)) (f6 f7 (+ ?v_0 (f8 (f9 f10 ?v_1) ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (= (<= ?v_0 (f8 (f9 f10 ?v_1) ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_0 (f11 f12 (f6 f7 (- ?v_1 ?v_2))))) (f6 f7 (- (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 ?v_0 (+ ?v_1 ?v_2))) (f6 f7 (+ (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (* ?v_0 2)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0)) (?v_2 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_1 (+ ?v_2 1))) (f6 f7 (+ ?v_0 (f8 ?v_1 ?v_2))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f6 f7 (+ ?v_1 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f44 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) (f6 f7 1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 (f3 ?v_0 (f6 f7 (- (f11 f12 ?v1) 1)))))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)) (f6 f7 (f8 (f9 f10 ?v_0) ?v_1))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 0)) (f6 f7 0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (< 0 (f8 (f9 f10 ?v_0) ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 1 (f11 f12 ?v0))) ?v0)))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 0 (f11 f12 ?v0))) (f6 f7 0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 (f8 f26 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 (f8 f26 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0))) (<= ?v_0 (f8 ?v_1 (f8 ?v_1 ?v_0)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (<= ?v_0 (f8 (f9 f10 ?v_0) ?v_0)))))
(assert (= (f20 (f21 f22 f50) (f6 f7 2)) f50))
(assert (= (f11 (f45 f46 0) (f6 f7 2)) 0))
(assert (= (f3 (f4 f44 f52) (f6 f7 2)) f52))
(assert (forall ((?v0 S10)) (= (= (f20 (f21 f22 ?v0) (f6 f7 2)) f50) (= ?v0 f50))))
(assert (forall ((?v0 Int)) (= (= (f11 (f45 f46 ?v0) (f6 f7 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S10)) (= (= (f13 (f23 f35 ?v0) ?v0) f50) (= ?v0 f50))))
(assert (forall ((?v0 Int)) (= (= (+ ?v0 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S10) (?v1 S2)) (=> (not (= ?v0 f50)) (not (= (f20 (f21 f22 ?v0) ?v1) f50)))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (not (= ?v0 0)) (not (= (f11 (f45 f46 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S10) (?v1 S2)) (= (= (f20 (f21 f22 ?v0) ?v1) f50) (and (= ?v0 f50) (not (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f11 (f45 f46 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f4 f44 ?v0) ?v1) f52) (and (= ?v0 f52) (not (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2)) (= (f20 (f21 f22 f50) (f6 f7 (+ (f11 f12 ?v0) 1))) f50)))
(assert (forall ((?v0 S2)) (= (f11 (f45 f46 0) (f6 f7 (+ (f11 f12 ?v0) 1))) 0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f44 f52) (f6 f7 (+ (f11 f12 ?v0) 1))) f52)))
(assert (not (= f36 f50)))
(assert (forall ((?v0 S10)) (= (= (f13 f14 ?v0) f50) (= ?v0 f50))))
(assert (= (f13 f14 f50) f50))
(assert (= (f33 f50 f34) f1))
(assert (= (f31 0 f32) f1))
(assert (= (f41 f52 f49) f1))
(assert (= (f13 f48 f50) f50))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f6 f7 (f11 (f45 f46 ?v0) ?v1)) (f3 (f4 f44 (f6 f7 ?v0)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_0 (f8 f26 ?v1))) (= (= (f11 f12 ?v0) ?v_0) (and (= ?v0 (f6 f7 ?v_0)) (<= 0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f8 f26 ?v0) (f8 f26 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f8 f26 ?v0) (f8 f26 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f8 f26 ?v0) (f8 f26 ?v1)) (f8 f26 (+ ?v0 (- ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f8 f26 ?v0) (f8 f26 ?v1)) (f8 f26 (+ ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 (f45 f46 (f11 f12 ?v0)) ?v1) (f11 f12 (f3 (f4 f44 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (< 0 (f11 (f45 f46 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 f12 (f3 (f4 f44 ?v0) ?v1)) (f11 (f45 f46 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (- (f8 f26 ?v0)) (f8 f26 (- ?v0)))))
(assert (forall ((?v0 Int)) (= (f8 f26 ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f11 (f45 f46 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f37 (f38 ?v0) ?v1) f1) (= (f37 (f38 (f13 f48 ?v0)) (f13 f48 ?v1)) f1))))
(assert (= (f30 f50) f1))
(assert (= (f29 0) f1))
(assert (= (f53 f52) f1))
(assert (forall ((?v0 S10)) (= (= (f30 ?v0) f1) (= ?v0 f50))))
(assert (forall ((?v0 Int)) (= (= (f29 ?v0) f1) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (= (f53 ?v0) f1) (= ?v0 f52))))
(assert (forall ((?v0 S10)) (= (= (f37 (f38 (f13 (f23 f35 ?v0) ?v0)) f50) f1) (= (f37 (f38 ?v0) f50) f1))))
(assert (forall ((?v0 Int)) (= (< (+ ?v0 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f13 (f23 f35 (f13 (f23 f28 ?v0) ?v0)) (f13 (f23 f28 ?v1) ?v1)) f50) (and (= ?v0 f50) (= ?v1 f50)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ (f8 (f9 f10 ?v0) ?v0) (f8 (f9 f10 ?v1) ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f38 f50))) (=> (= (f37 ?v_0 ?v0) f1) (= (f37 ?v_0 (f20 (f21 f22 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (< 0 ?v0) (< 0 (f11 (f45 f46 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f54 f52))) (=> (= (f42 ?v_0 ?v0) f1) (= (f42 ?v_0 (f3 (f4 f44 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S10)) (= (= (f37 (f38 f50) (f20 (f21 f22 ?v0) (f6 f7 2))) f1) (not (= ?v0 f50)))))
(assert (forall ((?v0 Int)) (= (< 0 (f11 (f45 f46 ?v0) (f6 f7 2))) (not (= ?v0 0)))))
(assert (forall ((?v0 S10)) (not (= (f37 (f38 (f20 (f21 f22 ?v0) (f6 f7 2))) f50) f1))))
(assert (forall ((?v0 Int)) (not (< (f11 (f45 f46 ?v0) (f6 f7 2)) 0))))
(assert (forall ((?v0 S10) (?v1 S2)) (=> (= (f37 (f38 ?v0) f50) f1) (= (f37 (f38 (f20 (f21 f22 ?v0) (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1)))) f50) f1))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (< ?v0 0) (< (f11 (f45 f46 ?v0) (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) 0))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f6 f7 2))) (= (= (f13 (f23 f35 (f20 (f21 f22 ?v0) ?v_0)) (f20 (f21 f22 ?v1) ?v_0)) f50) (and (= ?v0 f50) (= ?v1 f50))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (= (+ (f11 (f45 f46 ?v0) ?v_0) (f11 (f45 f46 ?v1) ?v_0)) 0) (and (= ?v0 0) (= ?v1 0))))))
(assert (= (f15 f16 f19) f50))
(assert (= 0 0))
(assert (= (f15 f16 f19) f50))
(assert (= 0 0))
(assert (= (f6 f27 f19) f52))
(assert (= f50 (f15 f16 f19)))
(assert (= 0 0))
(assert (forall ((?v0 S10) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1)) (?v_2 (f21 f22 ?v0))) (=> (not (= ?v0 f50)) (=> (<= ?v_1 ?v_0) (= (f20 ?v_2 (f6 f7 (- ?v_0 ?v_1))) (f13 (f23 f24 (f20 ?v_2 ?v2)) (f20 ?v_2 ?v1))))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S2)) (=> (not (= ?v0 f50)) (= (f20 (f21 f22 (f13 (f23 f24 ?v1) ?v0)) ?v2) (f13 (f23 f24 (f20 (f21 f22 ?v1) ?v2)) (f20 (f21 f22 ?v0) ?v2))))))
(assert (forall ((?v0 S10)) (= (not (= (f37 (f38 f50) (f13 (f23 f28 ?v0) ?v0)) f1)) (= ?v0 f50))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
