(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 Int) Int)
(declare-fun f7 (S5 Int) S4)
(declare-fun f8 () S5)
(declare-fun f9 (S6 S7) S1)
(declare-fun f10 (S8 S7) S6)
(declare-fun f11 () S8)
(declare-fun f12 (S9 S10) S7)
(declare-fun f13 () S9)
(declare-fun f14 () S10)
(declare-fun f15 (S11 S7) S7)
(declare-fun f16 (S12 S7) S11)
(declare-fun f17 () S12)
(declare-fun f18 (S13 S10) S10)
(declare-fun f19 (S14 S10) S13)
(declare-fun f20 () S14)
(declare-fun f21 () S10)
(declare-fun f22 () S12)
(declare-fun f23 () S13)
(declare-fun f24 () S11)
(declare-fun f25 () S14)
(declare-fun f26 () S4)
(declare-fun f27 () S11)
(declare-fun f28 () S11)
(declare-fun f29 () S5)
(declare-fun f30 () S5)
(declare-fun f31 () S12)
(declare-fun f32 () S12)
(declare-fun f33 (S15 Int) S7)
(declare-fun f34 (S16 S7) Int)
(declare-fun f35 (S17 S18) S7)
(declare-fun f36 (S19 Int) S18)
(declare-fun f37 () S19)
(declare-fun f38 (S20 S18) Int)
(declare-fun f39 () S20)
(declare-fun f40 (S21 S3) S5)
(declare-fun f41 () S21)
(declare-fun f42 (S22 S8) S12)
(declare-fun f43 () S22)
(declare-fun f44 () S21)
(declare-fun f45 () S22)
(declare-fun f46 () S7)
(declare-fun f47 () S8)
(declare-fun f48 () S10)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 ?v0) ?v1) (- ?v0 ?v1))))
(assert (not (= (f9 (f10 f11 (f12 f13 f14)) (f15 (f16 f17 (f12 f13 (f18 (f19 f20 f14) f21))) (f12 f13 f21))) f1)))
(assert (let ((?v_0 (f18 (f19 f20 f14) f21)) (?v_1 (f18 f23 f21))) (= (f9 (f10 f11 (f15 (f16 f22 (f12 f13 (f18 (f19 f20 ?v_0) ?v_1))) (f12 f13 ?v_0))) (f12 f13 ?v_1)) f1)))
(assert (let ((?v_0 (f18 (f19 f20 f14) f21)) (?v_1 (f18 f23 f21))) (= (f9 (f10 f11 (f15 (f16 f22 (f12 f13 (f18 (f19 f20 ?v_0) ?v_1))) (f12 f13 ?v_0))) (f12 f13 ?v_1)) f1)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f11 (f15 f24 (f15 (f16 f17 ?v0) ?v1))) (f15 (f16 f17 (f15 f24 ?v0)) (f15 f24 ?v1))) f1)))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f9 (f10 f11 (f12 f13 (f18 (f19 f20 ?v0) ?v1))) (f15 (f16 f17 (f12 f13 ?v0)) (f12 f13 ?v1))) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S7)) (= (f9 (f10 f11 ?v0) ?v0) f1)))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (= (f9 (f10 f11 (f15 f24 (f15 (f16 f22 (f15 (f16 f17 ?v0) ?v1)) (f15 (f16 f17 ?v2) ?v3)))) (f15 (f16 f17 (f15 f24 (f15 (f16 f22 ?v0) ?v2))) (f15 f24 (f15 (f16 f22 ?v1) ?v3)))) f1)))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (= (f9 (f10 f11 (f12 f13 (f18 (f19 f25 (f18 (f19 f20 ?v0) ?v1)) (f18 (f19 f20 ?v2) ?v3)))) (f15 (f16 f17 (f12 f13 (f18 (f19 f25 ?v0) ?v2))) (f12 f13 (f18 (f19 f25 ?v1) ?v3)))) f1)))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v2))) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f11 (f15 ?v_0 ?v0)) (f15 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f6 f26 (+ ?v0 ?v1)) (+ (f6 f26 ?v0) (f6 f26 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f11 (f15 f27 (f15 (f16 f17 ?v0) ?v1))) (f15 (f16 f17 (f15 f27 ?v0)) (f15 f27 ?v1))) f1)))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f9 (f10 f11 (f15 (f16 f17 ?v0) ?v1)) (f15 (f16 f17 ?v2) ?v1)) f1) (= (f9 (f10 f11 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (= (f9 (f10 f11 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2)) f1) (= (f9 (f10 f11 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f11 (f15 (f16 f17 ?v0) ?v2)) (f15 (f16 f17 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v2))) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f11 (f15 ?v_0 ?v0)) (f15 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f9 (f10 f11 ?v2) ?v3) f1) (= (f9 (f10 f11 (f15 (f16 f17 ?v0) ?v2)) (f15 (f16 f17 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f11 (f15 (f16 f17 ?v0) ?v1)) (f15 (f16 f17 ?v2) ?v1)) f1) (= (f9 (f10 f11 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (=> (= (f9 (f10 f11 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2)) f1) (= (f9 (f10 f11 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 Int)) (= (- (- ?v0)) ?v0)))
(assert (forall ((?v0 S10)) (= (f18 f23 (f18 f23 ?v0)) ?v0)))
(assert (forall ((?v0 S7)) (= (f15 f28 (f15 f28 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (= (f6 f26 (- ?v0)) (f6 f26 ?v0))))
(assert (forall ((?v0 S7)) (= (f15 f27 (f15 f28 ?v0)) (f15 f27 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 f26 (- ?v0 ?v1)) (f6 f26 (- ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 f27 (f15 (f16 f22 ?v0) ?v1)) (f15 f27 (f15 (f16 f22 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (- ?v0 ?v1)) (- ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 f28 (f15 (f16 f22 ?v0) ?v1)) (f15 (f16 f22 ?v1) ?v0))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 f23 (f18 (f19 f25 ?v0) ?v1)) (f18 (f19 f25 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f6 (f7 f29 ?v0) ?v1)) (f6 (f7 f30 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 f28 (f15 (f16 f31 ?v0) ?v1)) (f15 (f16 f32 (f15 f28 ?v0)) (f15 f28 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f6 (f7 f30 ?v0) ?v1)) (f6 (f7 f29 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 f28 (f15 (f16 f32 ?v0) ?v1)) (f15 (f16 f31 (f15 f28 ?v0)) (f15 f28 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (- ?v1)) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= ?v0 (f18 f23 ?v1)) (= ?v1 (f18 f23 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= ?v0 (f15 f28 ?v1)) (= ?v1 (f15 f28 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) ?v1) (= (- ?v1) ?v0))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f18 f23 ?v0) ?v1) (= (f18 f23 ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f15 f28 ?v0) ?v1) (= (f15 f28 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) (- ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f18 f23 ?v0) (f18 f23 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f15 f28 ?v0) (f15 f28 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f6 (f7 f29 ?v0) ?v1) ?v2) (f6 (f7 f29 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (f15 (f16 f22 (f15 (f16 f31 ?v0) ?v1)) ?v2) (f15 (f16 f31 (f15 (f16 f22 ?v0) ?v2)) (f15 (f16 f22 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f6 (f7 f30 ?v0) ?v1) ?v2) (f6 (f7 f30 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (f15 (f16 f22 (f15 (f16 f32 ?v0) ?v1)) ?v2) (f15 (f16 f32 (f15 (f16 f22 ?v0) ?v2)) (f15 (f16 f22 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f15 (f16 f22 ?v0) ?v1) (f15 (f16 f22 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (=> (= (f18 (f19 f25 ?v0) ?v1) (f18 (f19 f25 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 (f16 f22 ?v0) (f15 f28 ?v1)) (f15 (f16 f17 ?v0) ?v1))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 (f19 f25 ?v0) (f18 f23 ?v1)) (f18 (f19 f20 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- ?v0 (- ?v1)) (+ ?v0 ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 (f16 f22 ?v0) ?v1) (f15 (f16 f17 ?v0) (f15 f28 ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 (f19 f25 ?v0) ?v1) (f18 (f19 f20 ?v0) (f18 f23 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- ?v0 ?v1) (+ ?v0 (- ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 (f16 f22 ?v0) ?v1) (f15 (f16 f17 ?v0) (f15 f28 ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 (f19 f25 ?v0) ?v1) (f18 (f19 f20 ?v0) (f18 f23 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- ?v0 ?v1) (+ ?v0 (- ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (<= ?v0 ?v1) (<= ?v2 ?v3)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f15 (f16 f22 ?v0) ?v1) (f15 (f16 f22 ?v2) ?v3)) (= (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f11 ?v2) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f6 f26 ?v0) (f6 f26 ?v1)) (f6 f26 (- ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f11 (f15 (f16 f22 (f15 f27 ?v0)) (f15 f27 ?v1))) (f15 f27 (f15 (f16 f22 ?v1) ?v0))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f6 f26 ?v0) (f6 f26 ?v1)) (f6 f26 (- ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f11 (f15 (f16 f22 (f15 f27 ?v0)) (f15 f27 ?v1))) (f15 f27 (f15 (f16 f22 ?v0) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f6 f26 (- (f6 f26 ?v0) (f6 f26 ?v1))) (f6 f26 (- ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f11 (f15 f27 (f15 (f16 f22 (f15 f27 ?v0)) (f15 f27 ?v1)))) (f15 f27 (f15 (f16 f22 ?v0) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f6 f26 ?v0) ?v1) (<= (- ?v0) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 (f15 f27 ?v0)) ?v1) f1) (= (f9 (f10 f11 (f15 f28 ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= (- ?v0) ?v1) (<= (f6 f26 ?v0) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f9 (f10 f11 (f15 f28 ?v0)) ?v1) f1) (= (f9 (f10 f11 (f15 f27 ?v0)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (<= (- ?v1) (- ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f11 (f15 f28 ?v1)) (f15 f28 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (- ?v0) (- ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f11 (f15 f28 ?v0)) (f15 f28 ?v1)) f1) (= (f9 (f10 f11 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f6 f26 ?v0) ?v1) (and (<= ?v0 ?v1) (<= (- ?v0) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f11 (f15 f27 ?v0)) ?v1) f1) (and (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f11 (f15 f28 ?v0)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (- ?v0) ?v1) (<= (- ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f11 (f15 f28 ?v0)) ?v1) f1) (= (f9 (f10 f11 (f15 f28 ?v1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 (- ?v1)) (<= ?v1 (- ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f11 ?v0) (f15 f28 ?v1)) f1) (= (f9 (f10 f11 ?v1) (f15 f28 ?v0)) f1))))
(assert (forall ((?v0 Int)) (<= (- ?v0) (f6 f26 ?v0))))
(assert (forall ((?v0 S7)) (= (f9 (f10 f11 (f15 f28 ?v0)) (f15 f27 ?v0)) f1)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 (f16 f22 (f15 (f16 f17 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 (f19 f25 (f18 (f19 f20 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 (f16 f17 (f15 (f16 f22 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 (f19 f20 (f18 (f19 f25 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (- ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 (f16 f17 (f15 f28 ?v0)) (f15 (f16 f17 ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 (f19 f20 (f18 f23 ?v0)) (f18 (f19 f20 ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (- ?v0) (+ ?v0 ?v1)) ?v1)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 (f16 f17 ?v0) (f15 (f16 f17 (f15 f28 ?v0)) ?v1)) ?v1)))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 (f19 f20 ?v0) (f18 (f19 f20 (f18 f23 ?v0)) ?v1)) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (+ (- ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 f28 (f15 (f16 f17 ?v0) ?v1)) (f15 (f16 f17 (f15 f28 ?v1)) (f15 f28 ?v0)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 f23 (f18 (f19 f20 ?v0) ?v1)) (f18 (f19 f20 (f18 f23 ?v1)) (f18 f23 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1)) (+ (- ?v1) (- ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 f28 (f15 (f16 f17 ?v0) ?v1)) (f15 (f16 f17 (f15 f28 ?v0)) (f15 f28 ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 f23 (f18 (f19 f20 ?v0) ?v1)) (f18 (f19 f20 (f18 f23 ?v0)) (f18 f23 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1)) (+ (- ?v0) (- ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 f24 (f15 (f16 f22 ?v0) ?v1)) (f15 f24 (f15 (f16 f22 ?v1) ?v0)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f12 f13 (f18 (f19 f25 ?v0) ?v1)) (f12 f13 (f18 (f19 f25 ?v1) ?v0)))))
(assert (forall ((?v0 S10)) (= (f12 f13 (f18 f23 ?v0)) (f12 f13 ?v0))))
(assert (forall ((?v0 S7)) (= (f15 f24 (f15 f28 ?v0)) (f15 f24 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f11 (f15 (f16 f22 (f15 f24 ?v0)) (f15 f24 ?v1))) (f15 f24 (f15 (f16 f22 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f9 (f10 f11 (f15 (f16 f22 (f12 f13 ?v0)) (f12 f13 ?v1))) (f12 f13 (f18 (f19 f25 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f11 (f15 f27 (f15 (f16 f22 (f15 f24 ?v0)) (f15 f24 ?v1)))) (f15 f24 (f15 (f16 f22 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f9 (f10 f11 (f15 f27 (f15 (f16 f22 (f12 f13 ?v0)) (f12 f13 ?v1)))) (f12 f13 (f18 (f19 f25 ?v0) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (=> (= (f9 (f10 f11 ?v0) ?v1) f1) false) (=> (=> (= (f9 (f10 f11 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f6 f26 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 (f15 f27 ?v0)) ?v1) f1) (= (f9 (f10 f11 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v2))) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f9 ?v_0 ?v0) f1) (= (f9 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f9 (f10 f11 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= (f9 (f10 f11 ?v1) ?v2) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f9 (f10 f11 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f9 (f10 f11 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v2))) (=> (= ?v0 ?v1) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= ?v0 ?v1) (=> (= (f9 (f10 f11 ?v1) ?v2) f1) (= (f9 (f10 f11 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (= (f9 (f10 f11 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= ?v0 ?v1) (= (f9 (f10 f11 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f6 (f7 f30 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f9 (f10 f11 (f15 (f16 f32 ?v0) ?v1)) ?v2) f1) (or (= (f9 (f10 f11 ?v0) ?v2) f1) (= (f9 (f10 f11 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f6 (f7 f29 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (= (= (f9 ?v_0 (f15 (f16 f31 ?v1) ?v2)) f1) (or (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= ?v0 ?v1) (and (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f11 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (or (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f11 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f6 f26 ?v0))))
(assert (forall ((?v0 S7)) (= (f9 (f10 f11 ?v0) (f15 f27 ?v0)) f1)))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f15 (f16 f17 ?v0) ?v1) (f15 (f16 f17 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (=> (= (f18 (f19 f20 ?v0) ?v1) (f18 (f19 f20 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (=> (= (f15 ?v_0 ?v1) (f15 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f19 f20 ?v0))) (=> (= (f18 ?v_0 ?v1) (f18 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (=> (= (f15 ?v_0 ?v1) (f15 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f19 f20 ?v0))) (=> (= (f18 ?v_0 ?v1) (f18 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f15 (f16 f17 ?v0) ?v1) (f15 (f16 f17 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (= (= (f18 (f19 f20 ?v0) ?v1) (f18 (f19 f20 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (= (f15 ?v_0 ?v1) (f15 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f19 f20 ?v0))) (= (= (f18 ?v_0 ?v1) (f18 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (f15 (f16 f17 (f15 (f16 f32 ?v0) ?v1)) ?v2) (f15 (f16 f32 (f15 (f16 f17 ?v0) ?v2)) (f15 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f6 (f7 f30 ?v0) ?v1) ?v2) (f6 (f7 f30 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (f15 (f16 f17 (f15 (f16 f31 ?v0) ?v1)) ?v2) (f15 (f16 f31 (f15 (f16 f17 ?v0) ?v2)) (f15 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f6 (f7 f29 ?v0) ?v1) ?v2) (f6 (f7 f29 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f15 (f16 f17 ?v1) ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f6 f26 ?v0) (f6 f26 ?v1)))) (= (f6 f26 ?v_0) ?v_0))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f15 (f16 f17 (f15 f27 ?v0)) (f15 f27 ?v1)))) (= (f15 f27 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (<= (f6 f26 (- (+ ?v0 ?v1) (+ ?v2 ?v3))) (+ (f6 f26 (- ?v0 ?v2)) (f6 f26 (- ?v1 ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (= (f9 (f10 f11 (f15 f27 (f15 (f16 f22 (f15 (f16 f17 ?v0) ?v1)) (f15 (f16 f17 ?v2) ?v3)))) (f15 (f16 f17 (f15 f27 (f15 (f16 f22 ?v0) ?v2))) (f15 f27 (f15 (f16 f22 ?v1) ?v3)))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f6 f26 (- ?v0 ?v1)) (+ (f6 f26 ?v0) (f6 f26 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f11 (f15 f27 (f15 (f16 f22 ?v0) ?v1))) (f15 (f16 f17 (f15 f27 ?v0)) (f15 f27 ?v1))) f1)))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f9 (f10 f11 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= (f9 (f10 f11 ?v1) ?v2) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (or (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f11 ?v1) ?v0) f1))))
(assert (forall ((?v0 S7)) (= (f9 (f10 f11 ?v0) ?v0) f1)))
(assert (forall ((?v0 S7)) (let ((?v_0 (f15 f24 ?v0))) (= (f15 f27 ?v_0) ?v_0))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f12 f13 ?v0))) (= (f15 f27 ?v_0) ?v_0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f11 (f15 (f16 f22 (f15 f24 ?v0)) (f15 f24 ?v1))) (f15 f24 (f15 (f16 f17 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f9 (f10 f11 (f15 (f16 f22 (f12 f13 ?v0)) (f12 f13 ?v1))) (f12 f13 (f18 (f19 f20 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f11 (f15 f24 (f15 (f16 f22 ?v0) ?v1))) (f15 (f16 f17 (f15 f24 ?v0)) (f15 f24 ?v1))) f1)))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f9 (f10 f11 (f12 f13 (f18 (f19 f25 ?v0) ?v1))) (f15 (f16 f17 (f12 f13 ?v0)) (f12 f13 ?v1))) f1)))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f9 (f10 f11 (f15 (f16 f22 (f12 f13 (f18 (f19 f20 ?v0) ?v1))) (f12 f13 ?v0))) (f12 f13 ?v1)) f1)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 (f16 f22 ?v0) ?v1) (f15 (f16 f17 ?v0) (f15 f28 ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 (f19 f25 ?v0) ?v1) (f18 (f19 f20 ?v0) (f18 f23 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- ?v0 ?v1) (+ ?v0 (- ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 (f19 f25 ?v0) ?v1) (f18 (f19 f20 ?v0) (f18 f23 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (- ?v0) (- ?v1)) (- (- ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 (f16 f22 (f15 f28 ?v0)) (f15 f28 ?v1)) (f15 f28 (f15 (f16 f22 ?v0) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 (f19 f25 (f18 f23 ?v0)) (f18 f23 ?v1)) (f18 f23 (f18 (f19 f25 ?v0) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (= (f15 (f16 f22 (f15 (f16 f17 ?v0) ?v1)) (f15 (f16 f17 ?v2) ?v3)) (f15 (f16 f17 (f15 (f16 f22 ?v0) ?v2)) (f15 (f16 f22 ?v1) ?v3)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (= (f18 (f19 f25 (f18 (f19 f20 ?v0) ?v1)) (f18 (f19 f20 ?v2) ?v3)) (f18 (f19 f20 (f18 (f19 f25 ?v0) ?v2)) (f18 (f19 f25 ?v1) ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (- (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (- ?v0 ?v2) (- ?v1 ?v3)))))
(assert (forall ((?v0 S15) (?v1 Int) (?v2 S7) (?v3 Int)) (=> (= (f9 (f10 f11 (f33 ?v0 ?v1)) ?v2) f1) (=> (<= ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f9 (f10 f11 (f33 ?v0 ?v5)) (f33 ?v0 ?v4)) f1))) (= (f9 (f10 f11 (f33 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S16) (?v1 S7) (?v2 Int) (?v3 S7)) (=> (<= (f34 ?v0 ?v1) ?v2) (=> (= (f9 (f10 f11 ?v3) ?v1) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v5) ?v4) f1) (<= (f34 ?v0 ?v5) (f34 ?v0 ?v4)))) (<= (f34 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f6 ?v1 ?v2)) (=> (<= ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f6 ?v1 ?v5) (f6 ?v1 ?v4)))) (<= (f6 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 S7) (?v1 S11) (?v2 S7) (?v3 S7)) (=> (= ?v0 (f15 ?v1 ?v2)) (=> (= (f9 (f10 f11 ?v3) ?v2) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v5) ?v4) f1) (= (f9 (f10 f11 (f15 ?v1 ?v5)) (f15 ?v1 ?v4)) f1))) (= (f9 (f10 f11 (f15 ?v1 ?v3)) ?v0) f1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f11 (f15 f27 ?v0)) ?v1) f1) (and (= (f9 (f10 f11 (f15 f28 ?v1)) ?v0) f1) (= (f9 (f10 f11 ?v0) ?v1) f1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 f27 (f15 (f16 f17 ?v0) (f15 f28 ?v1))) (f15 f27 (f15 (f16 f17 ?v1) (f15 f28 ?v0))))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f12 f13 ?v0))) (= (f9 (f10 f11 (f15 f28 ?v_0)) ?v_0) f1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_0 (f16 f17 ?v0)) (?v_1 (f15 f28 ?v2)) (?v_2 (f15 f28 ?v3))) (= (f9 (f10 f11 (f15 f27 (f15 (f16 f17 (f15 ?v_0 ?v1)) (f15 (f16 f17 ?v_1) ?v_2)))) (f15 (f16 f17 (f15 f27 (f15 ?v_0 ?v_1))) (f15 f27 (f15 (f16 f17 ?v1) ?v_2)))) f1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 (f16 f22 ?v0) ?v1) (f15 (f16 f17 ?v0) (f15 f28 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 (f16 f22 ?v0) ?v1) (f15 (f16 f17 ?v0) (f15 f28 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f6 (f7 f29 ?v0) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f11 ?v0) (f15 (f16 f31 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f6 (f7 f29 ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f11 ?v0) (f15 (f16 f31 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f6 (f7 f30 ?v0) ?v1) ?v0)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f11 (f15 (f16 f32 ?v0) ?v1)) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f6 (f7 f30 ?v0) ?v1) ?v1)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f11 (f15 (f16 f32 ?v0) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f6 (f7 f29 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f15 (f16 f31 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f6 (f7 f30 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f15 (f16 f32 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f6 (f7 f30 ?v1) ?v2)) (and (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (= (= (f9 ?v_0 (f15 (f16 f32 ?v1) ?v2)) f1) (and (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f29 ?v0))) (<= (f6 ?v_0 (f6 (f7 f30 ?v1) ?v2)) (f6 (f7 f30 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f31 ?v0))) (= (f9 (f10 f11 (f15 ?v_0 (f15 (f16 f32 ?v1) ?v2))) (f15 (f16 f32 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2))) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f6 (f7 f29 ?v0) ?v1) ?v2) (and (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f9 (f10 f11 (f15 (f16 f31 ?v0) ?v1)) ?v2) f1) (and (= (f9 (f10 f11 ?v0) ?v2) f1) (= (f9 (f10 f11 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f30 ?v0))) (<= (f6 (f7 f29 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 (f7 f29 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f32 ?v0))) (= (f9 (f10 f11 (f15 (f16 f31 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2))) (f15 ?v_0 (f15 (f16 f31 ?v1) ?v2))) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f6 (f7 f29 ?v1) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 (f15 (f16 f31 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f6 (f7 f29 ?v2) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 (f15 (f16 f31 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f6 (f7 f30 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f11 (f15 (f16 f32 ?v0) ?v2)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f6 (f7 f30 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f11 (f15 (f16 f32 ?v2) ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f6 (f7 f29 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f15 (f16 f31 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f6 (f7 f30 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f15 (f16 f32 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f6 (f7 f29 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f15 (f16 f31 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f6 (f7 f30 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f15 (f16 f32 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f6 (f7 f30 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= (f9 ?v_0 ?v2) f1) (= (f9 ?v_0 (f15 (f16 f32 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f6 (f7 f30 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= (f9 ?v_0 ?v2) f1) (= (f9 ?v_0 (f15 (f16 f32 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f6 (f7 f29 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f9 (f10 f11 ?v2) ?v1) f1) (= (f9 (f10 f11 (f15 (f16 f31 ?v0) ?v2)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f6 (f7 f29 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f9 (f10 f11 ?v2) ?v1) f1) (= (f9 (f10 f11 (f15 (f16 f31 ?v0) ?v2)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f6 (f7 f29 ?v0) ?v2) (f6 (f7 f29 ?v1) ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f9 (f10 f11 ?v2) ?v3) f1) (= (f9 (f10 f11 (f15 (f16 f31 ?v0) ?v2)) (f15 (f16 f31 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f6 (f7 f30 ?v0) ?v2) (f6 (f7 f30 ?v1) ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f9 (f10 f11 ?v2) ?v3) f1) (= (f9 (f10 f11 (f15 (f16 f32 ?v0) ?v2)) (f15 (f16 f32 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 (f6 (f7 f30 ?v1) ?v2)) (=> (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) false)) false))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f9 ?v_0 (f15 (f16 f32 ?v1) ?v2)) f1) (=> (=> (= (f9 ?v_0 ?v1) f1) (=> (= (f9 ?v_0 ?v2) f1) false)) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (f6 (f7 f29 ?v0) ?v1) ?v2) (=> (=> (<= ?v0 ?v2) (=> (<= ?v1 ?v2) false)) false))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f11 (f15 (f16 f31 ?v0) ?v1)) ?v2) f1) (=> (=> (= (f9 (f10 f11 ?v0) ?v2) f1) (=> (= (f9 (f10 f11 ?v1) ?v2) f1) false)) false))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 (f16 f17 ?v0) ?v1) (f15 (f16 f17 ?v1) ?v0))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 (f19 f20 ?v0) ?v1) (f18 (f19 f20 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_1 (f16 f17 ?v0)) (?v_0 (f16 f17 ?v1))) (= (f15 ?v_1 (f15 ?v_0 ?v2)) (f15 ?v_0 (f15 ?v_1 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_1 (f19 f20 ?v0)) (?v_0 (f19 f20 ?v1))) (= (f18 ?v_1 (f18 ?v_0 ?v2)) (f18 ?v_0 (f18 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f15 (f16 f17 ?v1) ?v2)) (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2)) (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f15 (f16 f17 ?v1) ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2) (f15 (f16 f17 (f15 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2) (f18 (f19 f20 (f18 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) (f15 (f16 f17 ?v2) ?v3)) (f15 (f16 f17 (f15 ?v_0 ?v2)) (f15 (f16 f17 ?v1) ?v3))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) (f18 (f19 f20 ?v2) ?v3)) (f18 (f19 f20 (f18 ?v_0 ?v2)) (f18 (f19 f20 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S17) (?v1 S18) (?v2 S18)) (=> (forall ((?v3 S18)) (= (f9 (f10 f11 (f35 ?v0 ?v3)) (f35 ?v0 (f36 f37 (+ (f38 f39 ?v3) 1)))) f1)) (= (f9 (f10 f11 (f35 ?v0 ?v1)) (f35 ?v0 (f36 f37 (+ (f38 f39 ?v1) (f38 f39 ?v2))))) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f6 (f7 f29 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (forall ((?v2 S7)) (= (f9 (f10 f11 ?v0) ?v2) f1)) (= (f15 (f16 f31 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f6 (f7 f29 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (forall ((?v2 S7)) (= (f9 (f10 f11 ?v0) ?v2) f1)) (= (f15 (f16 f31 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f6 (f7 f30 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (forall ((?v2 S7)) (= (f9 (f10 f11 ?v0) ?v2) f1)) (= (f15 (f16 f32 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 S7) (?v1 S15) (?v2 Int) (?v3 Int)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f9 ?v_0 (f33 ?v1 ?v2)) f1) (=> (<= ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f9 (f10 f11 (f33 ?v1 ?v4)) (f33 ?v1 ?v5)) f1))) (= (f9 ?v_0 (f33 ?v1 ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S16) (?v2 S7) (?v3 S7)) (=> (<= ?v0 (f34 ?v1 ?v2)) (=> (= (f9 (f10 f11 ?v2) ?v3) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v4) ?v5) f1) (<= (f34 ?v1 ?v4) (f34 ?v1 ?v5)))) (<= ?v0 (f34 ?v1 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 S16) (?v2 S7) (?v3 S7)) (=> (= ?v0 (f34 ?v1 ?v2)) (=> (= (f9 (f10 f11 ?v2) ?v3) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v4) ?v5) f1) (<= (f34 ?v1 ?v4) (f34 ?v1 ?v5)))) (<= ?v0 (f34 ?v1 ?v3)))))))
(assert (forall ((?v0 S7) (?v1 S15) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f33 ?v1 ?v2)) (=> (<= ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f9 (f10 f11 (f33 ?v1 ?v4)) (f33 ?v1 ?v5)) f1))) (= (f9 (f10 f11 ?v0) (f33 ?v1 ?v3)) f1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S16) (?v3 Int)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (<= (f34 ?v2 ?v1) ?v3) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v4) ?v5) f1) (<= (f34 ?v2 ?v4) (f34 ?v2 ?v5)))) (<= (f34 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S15) (?v3 S7)) (=> (<= ?v0 ?v1) (=> (= (f9 (f10 f11 (f33 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f9 (f10 f11 (f33 ?v2 ?v4)) (f33 ?v2 ?v5)) f1))) (= (f9 (f10 f11 (f33 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f6 (f7 f30 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (forall ((?v2 S7)) (= (f9 (f10 f11 ?v0) ?v2) f1)) (= (f15 (f16 f32 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int) (?v3 S16)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (<= ?v2 (f34 ?v3 ?v0)) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v5) ?v4) f1) (<= (f34 ?v3 ?v5) (f34 ?v3 ?v4)))) (<= ?v2 (f34 ?v3 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 S15)) (let ((?v_0 (f10 f11 ?v2))) (=> (<= ?v0 ?v1) (=> (= (f9 ?v_0 (f33 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f9 (f10 f11 (f33 ?v3 ?v5)) (f33 ?v3 ?v4)) f1))) (= (f9 ?v_0 (f33 ?v3 ?v1)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (= (f6 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f6 ?v2 ?v5) (f6 ?v2 ?v4)))) (<= ?v3 (f6 ?v2 ?v1)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S11) (?v3 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f15 ?v2 ?v0) ?v3) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v5) ?v4) f1) (= (f9 (f10 f11 (f15 ?v2 ?v5)) (f15 ?v2 ?v4)) f1))) (= (f9 (f10 f11 ?v3) (f15 ?v2 ?v1)) f1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S16) (?v3 Int)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f34 ?v2 ?v1) ?v3) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v4) ?v5) f1) (<= (f34 ?v2 ?v4) (f34 ?v2 ?v5)))) (<= (f34 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S15) (?v3 S7)) (=> (<= ?v0 ?v1) (=> (= (f33 ?v2 ?v1) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f9 (f10 f11 (f33 ?v2 ?v4)) (f33 ?v2 ?v5)) f1))) (= (f9 (f10 f11 (f33 ?v2 ?v0)) ?v3) f1))))))
(assert (= f30 (f40 f41 f5)))
(assert (= f32 (f42 f43 f11)))
(assert (= f29 (f40 f44 f5)))
(assert (= f31 (f42 f45 f11)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f11 f46) (f15 (f16 f17 ?v0) ?v1)) f1) (= (f9 (f10 f11 (f15 f28 ?v0)) ?v1) f1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f11 (f15 (f16 f17 ?v0) ?v1)) f46) f1) (= (f9 (f10 f11 ?v1) (f15 f28 ?v0)) f1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f9 (f10 f47 (f15 f24 ?v0)) ?v1) f1) (=> (= (f9 (f10 f47 (f15 f24 ?v2)) ?v3) f1) (= (f9 (f10 f47 (f15 f24 (f15 (f16 f17 ?v0) ?v2))) (f15 (f16 f17 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S10) (?v1 S7) (?v2 S10) (?v3 S7)) (=> (= (f9 (f10 f47 (f12 f13 ?v0)) ?v1) f1) (=> (= (f9 (f10 f47 (f12 f13 ?v2)) ?v3) f1) (= (f9 (f10 f47 (f12 f13 (f18 (f19 f20 ?v0) ?v2))) (f15 (f16 f17 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f6 (f7 f30 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f47 ?v0) ?v1) f1) (= (f9 (f10 f47 (f15 (f16 f32 ?v2) ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f6 (f7 f30 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f47 ?v0) ?v1) f1) (= (f9 (f10 f47 (f15 (f16 f32 ?v0) ?v2)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f6 (f7 f29 ?v2) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f47 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 (f15 (f16 f31 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f6 (f7 f29 ?v1) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f47 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 (f15 (f16 f31 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f47 ?v0) f46) f1) (=> (= (f9 (f10 f47 ?v1) f46) f1) (= (f9 (f10 f47 (f15 (f16 f17 ?v0) ?v1)) f46) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f10 f47 f46))) (=> (= (f9 ?v_0 ?v0) f1) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 (f15 (f16 f17 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S7)) (= (= (f9 (f10 f47 (f15 (f16 f17 ?v0) ?v0)) f46) f1) (= (f9 (f10 f47 ?v0) f46) f1))))
(assert (forall ((?v0 Int)) (= (< (+ ?v0 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f10 f47 f46))) (= (= (f9 ?v_0 (f15 (f16 f17 ?v0) ?v0)) f1) (= (f9 ?v_0 ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (< 0 (+ ?v0 ?v0)) (< 0 ?v0))))
(assert (forall ((?v0 S7)) (not (= (f9 (f10 f47 (f15 f24 ?v0)) f46) f1))))
(assert (forall ((?v0 S10)) (not (= (f9 (f10 f47 (f12 f13 ?v0)) f46) f1))))
(assert (forall ((?v0 S10)) (= (= (f12 f13 ?v0) f46) (= ?v0 f48))))
(assert (forall ((?v0 S7)) (= (= (f15 f24 ?v0) f46) (= ?v0 f46))))
(assert (= (f12 f13 f48) f46))
(assert (= (f15 f24 f46) f46))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f10 f47 f46))) (=> (= (f9 ?v_0 ?v0) f1) (=> (= (f9 (f10 f11 f46) ?v1) f1) (= (f9 ?v_0 (f15 (f16 f17 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f10 f47 f46))) (=> (= (f9 (f10 f11 f46) ?v0) f1) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 (f15 (f16 f17 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f47 f46) ?v0) f1) (=> (= (f9 (f10 f11 ?v1) ?v2) f1) (= (f9 (f10 f47 ?v1) (f15 (f16 f17 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (<= ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f47 ?v1))) (=> (= (f9 (f10 f11 f46) ?v0) f1) (=> (= (f9 ?v_0 ?v2) f1) (= (f9 ?v_0 (f15 (f16 f17 ?v0) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f47 ?v0) f46) f1) (=> (= (f9 (f10 f11 ?v1) f46) f1) (= (f9 (f10 f47 (f15 (f16 f17 ?v0) ?v1)) f46) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (<= ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) f46) f1) (=> (= (f9 (f10 f47 ?v1) f46) f1) (= (f9 (f10 f47 (f15 (f16 f17 ?v0) ?v1)) f46) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S10)) (= (= (f9 (f10 f11 (f12 f13 ?v0)) f46) f1) (= ?v0 f48))))
(assert (forall ((?v0 S7)) (= (= (f9 (f10 f11 (f15 f24 ?v0)) f46) f1) (= ?v0 f46))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (not (= (f9 (f10 f47 ?v0) ?v1) f1)) (= (f9 (f10 f11 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (not (= (f9 (f10 f11 ?v0) ?v1) f1)) (= (f9 (f10 f47 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (or (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f47 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f47 ?v0) ?v1) f1) (and (= (f9 (f10 f11 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f47 ?v0) ?v1) f1) (and (= (f9 (f10 f11 ?v0) ?v1) f1) (not (= (f9 (f10 f11 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f11 ?v0) ?v1) f1) (or (= (f9 (f10 f47 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= (f9 (f10 f47 ?v0) ?v1) f1)) (= (f9 (f10 f11 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= (f9 (f10 f11 ?v0) ?v1) f1)) (= (f9 (f10 f47 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= (f9 (f10 f47 ?v0) ?v1) f1)) (= (= (f9 (f10 f11 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= ?v0 ?v1)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f47 ?v0) ?v1) f1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= ?v0 ?v1)) (=> (= (f9 (f10 f11 ?v1) ?v0) f1) (= (f9 (f10 f47 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (not (= (f9 (f10 f47 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f47 ?v0) ?v1) f1) (= (f9 (f10 f11 ?v0) ?v1) f1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (not (= (f9 (f10 f47 ?v0) ?v1) f1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (or (= (f9 (f10 f47 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (not (= ?v0 ?v1)) (= (f9 (f10 f47 ?v0) ?v1) f1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (not (= ?v1 ?v0)) (= (f9 (f10 f47 ?v0) ?v1) f1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f47 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= (f9 (f10 f11 ?v1) ?v2) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f47 ?v0) ?v1) f1) (=> (= (f9 (f10 f11 ?v2) ?v0) f1) (= (f9 (f10 f47 ?v2) ?v1) f1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f9 (f10 f47 ?v1) ?v2) f1) (= (f9 (f10 f47 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f47 ?v2))) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f9 ?v_0 ?v0) f1) (= (f9 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f9 (f10 f47 (f15 (f16 f17 ?v0) ?v1)) (f15 (f16 f17 ?v2) ?v1)) f1) (= (f9 (f10 f47 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (= (f9 (f10 f47 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2)) f1) (= (f9 (f10 f47 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f47 ?v0) ?v1) f1) (= (f9 (f10 f47 (f15 (f16 f17 ?v0) ?v2)) (f15 (f16 f17 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v2))) (=> (= (f9 (f10 f47 ?v0) ?v1) f1) (= (f9 (f10 f47 (f15 ?v_0 ?v0)) (f15 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f9 (f10 f47 ?v0) ?v1) f1) (=> (= (f9 (f10 f47 ?v2) ?v3) f1) (= (f9 (f10 f47 (f15 (f16 f17 ?v0) ?v2)) (f15 (f16 f17 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f47 (f15 (f16 f17 ?v0) ?v1)) (f15 (f16 f17 ?v2) ?v1)) f1) (= (f9 (f10 f47 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (=> (= (f9 (f10 f47 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2)) f1) (= (f9 (f10 f47 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f47 ?v0) ?v1) f1) (and (= (f9 (f10 f11 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f11 ?v0) ?v1) f1) (or (= (f9 (f10 f47 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (=> (= (f9 (f10 f47 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f9 (f10 f47 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f47 ?v0) ?v1) f1) (=> (=> (not false) (= (f9 (f10 f47 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f47 ?v2))) (=> (= (f9 (f10 f47 ?v0) ?v1) f1) (=> (= (f9 ?v_0 ?v0) f1) (= (f9 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f47 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= (f9 (f10 f47 ?v1) ?v2) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f47 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f9 (f10 f47 ?v2) ?v1) f1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f47 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f47 ?v2))) (=> (= ?v0 ?v1) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= ?v0 ?v1) (=> (= (f9 (f10 f47 ?v1) ?v2) f1) (= (f9 (f10 f47 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f47 ?v0) ?v1) f1) (=> (= (f9 (f10 f47 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f47 ?v0) ?v1) f1) (=> (= (f9 (f10 f47 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S1)) (=> (= (f9 (f10 f47 ?v0) ?v1) f1) (= (=> (= (f9 (f10 f47 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f47 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f47 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f47 ?v0) ?v1) f1) (= (not (= (f9 (f10 f47 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f47 ?v0) ?v1) f1) (not (= (f9 (f10 f47 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f47 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S7)) (=> (= (f9 (f10 f47 f46) ?v0) f1) (= (f15 f27 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f6 f26 ?v0) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f9 (f10 f47 ?v0) ?v1) f1) false) (=> (=> (= (f9 (f10 f47 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= (f9 (f10 f47 ?v0) ?v1) f1)) (= (not (= (f9 (f10 f47 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f9 (f10 f47 (f15 (f16 f32 ?v0) ?v1)) ?v2) f1) (or (= (f9 (f10 f47 ?v0) ?v2) f1) (= (f9 (f10 f47 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f9 (f10 f47 (f15 (f16 f31 ?v0) ?v1)) ?v2) f1) (and (= (f9 (f10 f47 ?v0) ?v2) f1) (= (f9 (f10 f47 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S7)) (= (= (f15 f27 ?v0) f46) (= ?v0 f46))))
(assert (forall ((?v0 Int)) (= (= (f6 f26 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f47 ?v0))) (= (= (f9 ?v_0 (f15 (f16 f32 ?v1) ?v2)) f1) (and (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f47 ?v0))) (= (= (f9 ?v_0 (f15 (f16 f31 ?v1) ?v2)) f1) (or (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (or (= (f9 (f10 f47 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f9 (f10 f47 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S7)) (= (= (f9 (f10 f47 f46) (f15 f24 ?v0)) f1) (not (= ?v0 f46)))))
(assert (forall ((?v0 S10)) (= (= (f9 (f10 f47 f46) (f12 f13 ?v0)) f1) (not (= ?v0 f48)))))
(assert (forall ((?v0 S7)) (= (= (f9 (f10 f47 f46) (f15 f27 ?v0)) f1) (not (= ?v0 f46)))))
(assert (forall ((?v0 Int)) (= (< 0 (f6 f26 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S7)) (= (= f46 ?v0) (= ?v0 f46))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (not (= (f9 (f10 f47 ?v0) ?v1) f1)) (or (= (f9 (f10 f47 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (not (= ?v0 ?v1)) (or (= (f9 (f10 f47 ?v0) ?v1) f1) (= (f9 (f10 f47 ?v1) ?v0) f1)))))
(assert (= (f15 f27 f46) f46))
(assert (= (f6 f26 0) 0))
(assert (forall ((?v0 S7)) (not (= (f9 (f10 f47 (f15 f27 ?v0)) f46) f1))))
(assert (forall ((?v0 Int)) (not (< (f6 f26 ?v0) 0))))
(assert (forall ((?v0 S7)) (not (= (f9 (f10 f47 ?v0) ?v0) f1))))
(assert (forall ((?v0 S7)) (= (= (f15 f28 ?v0) ?v0) (= ?v0 f46))))
(assert (forall ((?v0 Int)) (= (= (- ?v0) ?v0) (= ?v0 0))))
(assert (forall ((?v0 S7)) (= (= (f15 f28 ?v0) f46) (= ?v0 f46))))
(assert (forall ((?v0 Int)) (= (= (- ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S10)) (= (= (f18 f23 ?v0) f48) (= ?v0 f48))))
(assert (forall ((?v0 S7)) (= (= ?v0 (f15 f28 ?v0)) (= ?v0 f46))))
(assert (forall ((?v0 Int)) (= (= ?v0 (- ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S7)) (= (= f46 (f15 f28 ?v0)) (= f46 ?v0))))
(assert (forall ((?v0 Int)) (= (= 0 (- ?v0)) (= 0 ?v0))))
(assert (forall ((?v0 S10)) (= (= f48 (f18 f23 ?v0)) (= f48 ?v0))))
(assert (= (f15 f28 f46) f46))
(assert (= 0 0))
(assert (= (f18 f23 f48) f48))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f15 (f16 f22 ?v0) ?v1) f46) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0 ?v1) 0) (= ?v0 ?v1))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f18 (f19 f25 ?v0) ?v1) f48) (= ?v0 ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= ?v0 ?v1) (= (f15 (f16 f22 ?v0) ?v1) f46))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= ?v0 ?v1) (= (f18 (f19 f25 ?v0) ?v1) f48))))
(assert (forall ((?v0 S7)) (= (f15 (f16 f22 ?v0) ?v0) f46)))
(assert (forall ((?v0 Int)) (= (- ?v0 ?v0) 0)))
(assert (forall ((?v0 S10)) (= (f18 (f19 f25 ?v0) ?v0) f48)))
(assert (forall ((?v0 S18)) (= (f36 f37 (f38 f39 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f38 f39 (f36 f37 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f38 f39 (f36 f37 ?v0)) 0))))
(check-sat)
(exit)
