(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S4) S4)
(declare-fun f4 (S5 S2) S3)
(declare-fun f5 () S5)
(declare-fun f6 () S4)
(declare-fun f7 (S6 S4) S3)
(declare-fun f8 () S6)
(declare-fun f9 (S7 S4) S8)
(declare-fun f10 () S7)
(declare-fun f11 () S5)
(declare-fun f12 (S9 Int) S8)
(declare-fun f13 () S9)
(declare-fun f14 (S10 S2) S4)
(declare-fun f15 (S11 S4) S10)
(declare-fun f16 () S11)
(declare-fun f17 (S12 S8) Int)
(declare-fun f18 () S12)
(declare-fun f19 () S2)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f5 ?v0) f6) f6)))
(assert (forall ((?v0 S4)) (= (f3 (f7 f8 f6) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f9 f10 (f3 (f4 f11 ?v0) f6)) (f12 f13 0))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S2)) (let ((?v_0 (f4 f11 ?v0)) (?v_1 (f14 (f15 f16 ?v1) ?v2))) (= (f14 (f15 f16 (f3 ?v_0 ?v1)) ?v2) (f3 (f7 f8 (f3 (f4 f5 ?v2) ?v_1)) (f3 ?v_0 ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 ?v1))) (=> (< (f17 f18 (f9 f10 ?v0)) (f17 f18 ?v_0)) (= (f9 f10 (f3 (f7 f8 ?v0) ?v1)) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S4)) (<= (f17 f18 (f9 f10 (f3 (f4 f5 ?v0) ?v1))) (f17 f18 (f9 f10 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S2)) (=> (not (= ?v0 f6)) (= (f9 f10 (f3 (f4 f11 ?v1) ?v0)) (f12 f13 (+ (f17 f18 (f9 f10 ?v0)) 1))))))
(assert (forall ((?v0 S4) (?v1 S2)) (= (= (f14 (f15 f16 ?v0) ?v1) f6) (= ?v0 f6))))
(assert (forall ((?v0 S2) (?v1 S4)) (= (f9 f10 (f3 (f4 f11 ?v0) ?v1)) (ite (= ?v1 f6) (f12 f13 0) (f12 f13 (+ (f17 f18 (f9 f10 ?v1)) 1))))))
(assert (not (forall ((?v0 S2) (?v1 S4)) (let ((?v_0 (f3 (f4 f11 ?v0) ?v1))) (=> (= (f9 f10 (f14 (f15 f16 ?v1) f19)) (f9 f10 ?v1)) (= (f9 f10 (f14 (f15 f16 ?v_0) f19)) (f9 f10 ?v_0)))))))
(assert (forall ((?v0 S8)) (= (f12 f13 (f17 f18 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f17 f18 (f12 f13 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f17 f18 (f12 f13 ?v0)) 0))))
(check-sat)
(exit)
