(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 (S4 S5) S3)
(declare-fun f6 () S4)
(declare-fun f7 (S6 S5) S5)
(declare-fun f8 (S7 S8) S6)
(declare-fun f9 () S7)
(declare-fun f10 () S8)
(declare-fun f11 (S9 S8) S5)
(declare-fun f12 (S10 S5) S9)
(declare-fun f13 () S10)
(declare-fun f14 () S5)
(declare-fun f15 () S7)
(declare-fun f16 () S8)
(declare-fun f17 () S5)
(declare-fun f18 (S11 Int) S3)
(declare-fun f19 () S11)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f11 (f12 f13 f14) f10))) (not (< (f3 f4 (f5 f6 (f7 (f8 f9 f10) ?v_0))) (f3 f4 (f5 f6 (f7 (f8 f15 f16) ?v_0)))))))
(assert (= (f5 f6 (f11 (f12 f13 f14) f10)) (f5 f6 f14)))
(assert (not (= f14 f17)))
(assert (forall ((?v0 S8) (?v1 S5)) (<= (f3 f4 (f5 f6 (f7 (f8 f9 ?v0) ?v1))) (f3 f4 (f5 f6 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S8)) (= (= (f11 (f12 f13 ?v0) ?v1) f17) (= ?v0 f17))))
(assert (forall ((?v0 S3)) (= (f18 f19 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f18 f19 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f18 f19 ?v0)) 0))))
(check-sat)
(exit)
