(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S1)
(declare-fun f4 (S3) S2)
(declare-fun f5 (S4 S5) S3)
(declare-fun f6 () S4)
(declare-fun f7 (S6 S5) S5)
(declare-fun f8 (S7 S5) S6)
(declare-fun f9 () S7)
(declare-fun f10 () S5)
(declare-fun f11 () S5)
(declare-fun f12 () S3)
(declare-fun f13 () S7)
(declare-fun f14 () S5)
(declare-fun f15 (S8 S3) S3)
(declare-fun f16 () S8)
(declare-fun f17 (S9 S3) S8)
(declare-fun f18 () S9)
(declare-fun f19 () S8)
(declare-fun f20 () S9)
(declare-fun f21 (S10 Int) Int)
(declare-fun f22 () S10)
(declare-fun f23 () S9)
(declare-fun f24 (S11 Int) S10)
(declare-fun f25 () S11)
(declare-fun f26 () S9)
(declare-fun f27 () S11)
(declare-fun f28 (S3) S2)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f8 f9 f10)) (?v_1 (f8 f13 f10))) (not (or (= (f3 (f4 (f5 f6 (f7 ?v_0 f11))) f12) f1) (or (= (f3 (f4 (f5 f6 (f7 ?v_1 f11))) f12) f1) (or (= (f3 (f4 (f5 f6 (f7 ?v_0 f14))) f12) f1) (= (f3 (f4 (f5 f6 (f7 ?v_1 f14))) f12) f1)))))))
(assert (= (f5 f6 f10) f12))
(assert (= (f15 f16 f12) f12))
(assert (= (f5 f6 f11) f12))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 (f15 f16 ?v0)) ?v1) f1) (=> (= (f3 (f4 (f15 f16 ?v2)) ?v3) f1) (= (f3 (f4 (f15 f16 (f15 (f17 f18 ?v0) ?v2))) (f15 (f17 f18 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S5) (?v1 S3) (?v2 S5) (?v3 S3)) (=> (= (f3 (f4 (f5 f6 ?v0)) ?v1) f1) (=> (= (f3 (f4 (f5 f6 ?v2)) ?v3) f1) (= (f3 (f4 (f5 f6 (f7 (f8 f9 ?v0) ?v2))) (f15 (f17 f18 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 (f15 f19 (f15 (f17 f20 ?v0) ?v1))) ?v2) f1) (and (= (f3 (f4 (f15 (f17 f20 ?v1) ?v2)) ?v0) f1) (= (f3 (f4 ?v0) (f15 (f17 f18 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f21 f22 (- ?v0 ?v1)) ?v2) (and (< (- ?v1 ?v2) ?v0) (< ?v0 (+ ?v1 ?v2))))))
(assert (forall ((?v0 Int)) (< ?v0 (+ ?v0 1))))
(assert (forall ((?v0 S3)) (= (f3 (f4 ?v0) (f15 (f17 f18 ?v0) f12)) f1)))
(assert (not (= f14 f11)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f5 f6 (f7 (f8 f13 ?v0) ?v1)) (f5 f6 (f7 (f8 f13 ?v1) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f15 f16 (f15 (f17 f20 ?v0) ?v1)) (f15 f16 (f15 (f17 f20 ?v1) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f15 (f17 f18 (f15 (f17 f20 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f9 (f7 (f8 f13 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (- ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f15 (f17 f20 (f15 (f17 f18 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f13 (f7 (f8 f9 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f15 (f17 f20 (f15 (f17 f18 ?v0) ?v1)) (f15 (f17 f18 ?v2) ?v3)) (f15 (f17 f18 (f15 (f17 f20 ?v0) ?v2)) (f15 (f17 f20 ?v1) ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (= (f7 (f8 f13 (f7 (f8 f9 ?v0) ?v1)) (f7 (f8 f9 ?v2) ?v3)) (f7 (f8 f9 (f7 (f8 f13 ?v0) ?v2)) (f7 (f8 f13 ?v1) ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (- (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (- ?v0 ?v2) (- ?v1 ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f15 (f17 f20 ?v0) ?v1) (f15 (f17 f20 ?v2) ?v3)) (= (= (f3 (f4 ?v0) ?v1) f1) (= (f3 (f4 ?v2) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (< ?v0 ?v1) (< ?v2 ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 (f15 (f17 f18 ?v0) ?v1)) (f15 (f17 f18 ?v2) ?v1)) f1) (= (f3 (f4 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 ?v0))) (= (= (f3 (f4 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2)) f1) (= (f3 (f4 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f15 (f17 f18 ?v0) ?v1) (f15 (f17 f18 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 ?v0))) (=> (= (f15 ?v_0 ?v1) (f15 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 ?v0))) (=> (= (f15 ?v_0 ?v1) (f15 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f15 (f17 f18 ?v0) ?v1) (f15 (f17 f18 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 ?v0))) (= (= (f15 ?v_0 ?v1) (f15 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f15 (f17 f18 (f15 (f17 f23 ?v0) ?v1)) ?v2) (f15 (f17 f23 (f15 (f17 f18 ?v0) ?v2)) (f15 (f17 f18 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f21 (f24 f25 ?v0) ?v1) ?v2) (f21 (f24 f25 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f15 (f17 f18 (f15 (f17 f26 ?v0) ?v1)) ?v2) (f15 (f17 f26 (f15 (f17 f18 ?v0) ?v2)) (f15 (f17 f18 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f21 (f24 f27 ?v0) ?v1) ?v2) (f21 (f24 f27 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 ?v0))) (= (f15 (f17 f18 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f15 (f17 f18 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f15 (f17 f18 (f15 f19 ?v0)) (f15 f19 ?v1)))) (= (f15 f19 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f21 f22 ?v0) (f21 f22 ?v1)))) (= (f21 f22 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S3)) (= (= f12 ?v0) (= ?v0 f12))))
(assert (forall ((?v0 S5)) (= (= f11 ?v0) (= ?v0 f11))))
(assert (= (f15 f19 f12) f12))
(assert (= (f21 f22 1) 1))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f7 (f8 f13 ?v0) ?v1) (f7 (f8 f13 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f15 (f17 f20 ?v0) ?v1) (f15 (f17 f20 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f21 (f24 f25 ?v0) ?v1) ?v2) (f21 (f24 f25 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f15 (f17 f20 (f15 (f17 f23 ?v0) ?v1)) ?v2) (f15 (f17 f23 (f15 (f17 f20 ?v0) ?v2)) (f15 (f17 f20 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f21 (f24 f27 ?v0) ?v1) ?v2) (f21 (f24 f27 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f15 (f17 f20 (f15 (f17 f26 ?v0) ?v1)) ?v2) (f15 (f17 f26 (f15 (f17 f20 ?v0) ?v2)) (f15 (f17 f20 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f15 f19 (f15 (f17 f20 ?v0) ?v1)) (f15 f19 (f15 (f17 f20 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f21 f22 (- ?v0 ?v1)) (f21 f22 (- ?v1 ?v0)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f5 f6 ?v0))) (= (f15 f19 ?v_0) ?v_0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f15 f16 ?v0))) (= (f15 f19 ?v_0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 ?v0))) (=> (= (f3 (f4 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2)) f1) (= (f3 (f4 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 (f15 (f17 f18 ?v0) ?v1)) (f15 (f17 f18 ?v2) ?v1)) f1) (= (f3 (f4 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 ?v2) ?v3) f1) (= (f3 (f4 (f15 (f17 f18 ?v0) ?v2)) (f15 (f17 f18 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 ?v2))) (=> (= (f3 (f4 ?v0) ?v1) f1) (= (f3 (f4 (f15 ?v_0 ?v0)) (f15 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 ?v0) ?v1) f1) (= (f3 (f4 (f15 (f17 f18 ?v0) ?v2)) (f15 (f17 f18 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 (f15 (f17 f18 (f15 f19 ?v0)) f12)) ?v0) f1))))
(assert (forall ((?v0 S2)) (=> (exists ((?v1 S3)) (= (f3 ?v0 ?v1) f1)) (=> (exists ((?v1 S3)) (forall ((?v2 S3)) (=> (= (f3 ?v0 ?v2) f1) (= (f3 (f4 ?v2) ?v1) f1)))) (exists ((?v1 S3)) (forall ((?v2 S3)) (= (exists ((?v3 S3)) (and (= (f3 ?v0 ?v3) f1) (= (f3 (f4 ?v2) ?v3) f1))) (= (f3 (f4 ?v2) ?v1) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f3 (f28 (f15 f16 (f15 (f17 f20 (f15 (f17 f18 ?v0) ?v1)) (f15 (f17 f18 ?v2) ?v3)))) (f15 (f17 f18 (f15 f16 (f15 (f17 f20 ?v0) ?v2))) (f15 f16 (f15 (f17 f20 ?v1) ?v3)))) f1)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (= (f3 (f28 (f5 f6 (f7 (f8 f13 (f7 (f8 f9 ?v0) ?v1)) (f7 (f8 f9 ?v2) ?v3)))) (f15 (f17 f18 (f5 f6 (f7 (f8 f13 ?v0) ?v2))) (f5 f6 (f7 (f8 f13 ?v1) ?v3)))) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f3 (f28 (f5 f6 ?v0)) (f15 (f17 f18 (f5 f6 (f7 (f8 f9 ?v0) ?v1))) (f5 f6 ?v1))) f1)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f17 f18 ?v0))) (= (f15 (f17 f18 (f15 ?v_0 ?v1)) (f15 (f17 f18 ?v2) ?v3)) (f15 (f17 f18 (f15 ?v_0 ?v2)) (f15 (f17 f18 ?v1) ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) (f7 (f8 f9 ?v2) ?v3)) (f7 (f8 f9 (f7 ?v_0 ?v2)) (f7 (f8 f9 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 ?v0))) (= (f15 (f17 f18 (f15 ?v_0 ?v1)) ?v2) (f15 (f17 f18 (f15 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2) (f7 (f8 f9 (f7 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 ?v0))) (= (f15 (f17 f18 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f15 (f17 f18 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 ?v0))) (= (f15 ?v_0 (f15 (f17 f18 ?v1) ?v2)) (f15 (f17 f18 (f15 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2)) (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f17 f18 ?v0)) (?v_0 (f17 f18 ?v1))) (= (f15 ?v_1 (f15 ?v_0 ?v2)) (f15 ?v_0 (f15 ?v_1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1))) (= (f7 ?v_1 (f7 ?v_0 ?v2)) (f7 ?v_0 (f7 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S3)) (= (f3 (f28 ?v0) (f15 f19 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 (f21 f22 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f28 (f15 f19 ?v0)) ?v1) f1) (= (f3 (f28 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f21 f22 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f28 (f15 (f17 f26 ?v0) ?v1)) ?v2) f1) (=> (=> (= (f3 (f28 ?v0) ?v2) f1) (=> (= (f3 (f28 ?v1) ?v2) f1) false)) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (f21 (f24 f27 ?v0) ?v1) ?v2) (=> (=> (<= ?v0 ?v2) (=> (<= ?v1 ?v2) false)) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f28 ?v0))) (=> (= (f3 ?v_0 (f15 (f17 f23 ?v1) ?v2)) f1) (=> (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) false)) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 (f21 (f24 f25 ?v1) ?v2)) (=> (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) false)) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f28 ?v0) ?v1) f1) (=> (= (f3 (f28 ?v2) ?v3) f1) (= (f3 (f28 (f15 (f17 f23 ?v0) ?v2)) (f15 (f17 f23 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f21 (f24 f25 ?v0) ?v2) (f21 (f24 f25 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f28 ?v0) ?v1) f1) (=> (= (f3 (f28 ?v2) ?v3) f1) (= (f3 (f28 (f15 (f17 f26 ?v0) ?v2)) (f15 (f17 f26 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f21 (f24 f27 ?v0) ?v2) (f21 (f24 f27 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f28 ?v0) ?v1) f1) (=> (= (f3 (f28 ?v2) ?v1) f1) (= (f3 (f28 (f15 (f17 f26 ?v0) ?v2)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f21 (f24 f27 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f28 ?v0) ?v1) f1) (=> (= (f3 (f28 ?v2) ?v1) f1) (= (f3 (f28 (f15 (f17 f26 ?v0) ?v2)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f21 (f24 f27 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f28 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 ?v_0 (f15 (f17 f23 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f21 (f24 f25 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f28 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 ?v_0 (f15 (f17 f23 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f21 (f24 f25 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f28 ?v0) ?v1) f1) (=> (= (f3 (f28 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f28 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f28 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f28 ?v0) ?v1) f1) (= (f15 (f17 f23 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f21 (f24 f25 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f28 ?v0) ?v1) f1) (= (f15 (f17 f26 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f21 (f24 f27 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f28 ?v0) ?v1) f1) (= (f15 (f17 f23 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f21 (f24 f25 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f28 ?v0) ?v1) f1) (= (f15 (f17 f26 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f21 (f24 f27 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f28 ?v0) ?v1) f1) (= (f3 (f28 (f15 (f17 f23 ?v2) ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f21 (f24 f25 ?v2) ?v0) ?v1))))
(check-sat)
(exit)
