(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S4)
(declare-fun f4 () S3)
(declare-fun f5 (S5 S6) S4)
(declare-fun f6 () S5)
(declare-fun f7 (S7 S2) S6)
(declare-fun f8 () S7)
(declare-fun f9 (S8 S2) S2)
(declare-fun f10 () S8)
(declare-fun f11 () S8)
(declare-fun f12 () S3)
(declare-fun f13 () S5)
(declare-fun f14 (S8) S3)
(declare-fun f15 (S9 S8) S3)
(declare-fun f16 (S3) S9)
(declare-fun f17 (S10 S7) S3)
(declare-fun f18 (S5) S10)
(declare-fun f19 (S8) S3)
(declare-fun f20 (S11 S7) S7)
(declare-fun f21 () S11)
(declare-fun f22 (S12 S6) S6)
(declare-fun f23 () S12)
(declare-fun f24 (S3) S3)
(declare-fun f25 (S4) S4)
(declare-fun f26 (S13 S2) Int)
(declare-fun f27 (S14 S13) S13)
(declare-fun f28 () S14)
(declare-fun f29 (S7) S3)
(declare-fun f30 (S7) S3)
(declare-fun f31 (S8) S3)
(declare-fun f32 (S15 S2) S7)
(declare-fun f33 (S16 S7) S15)
(declare-fun f34 () S16)
(declare-fun f35 (S17 Int) S2)
(declare-fun f36 () S17)
(declare-fun f37 () S13)
(declare-fun f38 (S18 S2) S3)
(declare-fun f39 (S3) S18)
(declare-fun f40 (S3) S1)
(declare-fun f41 (S8) S1)
(declare-fun f42 (S3) S1)
(declare-fun f43 (S7) S1)
(declare-fun f44 (S4 S4) S1)
(declare-fun f45 (S6) S4)
(declare-fun f46 () S4)
(declare-fun f47 (S5) S1)
(declare-fun f48 (S4) S4)
(declare-fun f49 (S4 S4) S4)
(declare-fun f50 () S4)
(declare-fun f51 (S3) S1)
(declare-fun f52 (S7) S1)
(declare-fun f53 (S13) S1)
(declare-fun f54 (S19 S8) S7)
(declare-fun f55 (S20 S7) S19)
(declare-fun f56 () S20)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 f4 ?v0) (f5 f6 (f7 f8 (f9 f10 (f9 f11 ?v0)))))))
(assert (forall ((?v0 S2)) (= (f3 f12 ?v0) (f5 f13 (f7 f8 (f9 f10 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S2)) (= (f3 (f14 ?v0) ?v1) (f3 (f15 (f16 (f17 (f18 f6) f8)) f10) (f9 ?v0 ?v1)))))
(assert (forall ((?v0 S8) (?v1 S2)) (= (f3 (f19 ?v0) ?v1) (f3 (f17 (f18 f13) f8) (f9 ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S2)) (= (f7 (f20 f21 ?v0) ?v1) (f22 f23 (f7 ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S2)) (= (f3 (f24 ?v0) ?v1) (f25 (f3 ?v0 ?v1)))))
(assert (forall ((?v0 S13) (?v1 S2)) (= (f26 (f27 f28 ?v0) ?v1) (- (f26 ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S2)) (= (f3 (f29 ?v0) ?v1) (f5 f13 (f7 ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S2)) (= (f3 (f30 ?v0) ?v1) (f5 f6 (f7 ?v0 ?v1)))))
(assert (forall ((?v0 S8) (?v1 S2)) (= (f3 (f31 ?v0) ?v1) (f5 f6 (f7 f8 (f9 f10 (f9 ?v0 ?v1)))))))
(assert (forall ((?v0 S7) (?v1 S2) (?v2 S2)) (= (f7 (f32 (f33 f34 ?v0) ?v1) ?v2) (f7 ?v0 (f35 f36 (+ (f26 f37 ?v2) (f26 f37 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S2)) (= (f3 (f38 (f39 ?v0) ?v1) ?v2) (f3 ?v0 (f35 f36 (+ (f26 f37 ?v2) (f26 f37 ?v1)))))))
(assert (not (= (f40 f12) f1)))
(assert (= (f41 f11) f1))
(assert (= (f41 f10) f1))
(assert (= (f42 f12) f1))
(assert (forall ((?v0 S3) (?v1 S2)) (=> (= (f40 ?v0) f1) (= (f40 (f38 (f39 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S7) (?v1 S2)) (=> (= (f43 ?v0) f1) (= (f43 (f32 (f33 f34 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S3) (?v1 S2)) (=> (= (f40 (f38 (f39 ?v0) ?v1)) f1) (= (f40 ?v0) f1))))
(assert (forall ((?v0 S7) (?v1 S2)) (=> (= (f43 (f32 (f33 f34 ?v0) ?v1)) f1) (= (f43 ?v0) f1))))
(assert (= (f42 f4) f1))
(assert (=> (forall ((?v0 S8)) (=> (= (f41 ?v0) f1) (=> (= (f42 (f31 ?v0)) f1) false))) false))
(assert (exists ((?v0 S8)) (and (= (f41 ?v0) f1) (= (f42 (f19 ?v0)) f1))))
(assert (forall ((?v0 S2)) (= (f44 (f45 (f7 f8 ?v0)) f46) f1)))
(assert (= (f44 (f45 (f7 f8 (f35 f36 0))) f46) f1))
(assert (= (f47 f13) f1))
(assert (forall ((?v0 S2)) (= (f44 (f48 (f5 f13 (f7 f8 ?v0))) (f49 f46 f50)) f1)))
(assert (exists ((?v0 S8)) (and (= (f41 ?v0) f1) (= (f42 (f14 ?v0)) f1))))
(assert (forall ((?v0 S3)) (= (= (f40 (f24 ?v0)) f1) (= (f40 ?v0) f1))))
(assert (forall ((?v0 S7)) (= (= (f43 (f20 f21 ?v0)) f1) (= (f43 ?v0) f1))))
(assert (forall ((?v0 S3)) (=> (= (f51 ?v0) f1) (= (f40 ?v0) f1))))
(assert (forall ((?v0 S7)) (=> (= (f52 ?v0) f1) (= (f43 ?v0) f1))))
(assert (= (f47 f6) f1))
(assert (forall ((?v0 S6)) (= (f44 (f5 f13 ?v0) (f45 ?v0)) f1)))
(assert (forall ((?v0 S8)) (= (= (f41 ?v0) f1) (forall ((?v1 S2) (?v2 S2)) (=> (< (f26 f37 ?v1) (f26 f37 ?v2)) (< (f26 f37 (f9 ?v0 ?v1)) (f26 f37 (f9 ?v0 ?v2))))))))
(assert (forall ((?v0 S8)) (= (= (f41 ?v0) f1) (forall ((?v1 S2)) (< (f26 f37 (f9 ?v0 ?v1)) (f26 f37 (f9 ?v0 (f35 f36 (+ (f26 f37 ?v1) 1)))))))))
(assert (forall ((?v0 S3)) (= (= (f42 ?v0) f1) (or (forall ((?v1 S2) (?v2 S2)) (=> (<= (f26 f37 ?v1) (f26 f37 ?v2)) (= (f44 (f3 ?v0 ?v1) (f3 ?v0 ?v2)) f1))) (forall ((?v1 S2) (?v2 S2)) (=> (<= (f26 f37 ?v1) (f26 f37 ?v2)) (= (f44 (f3 ?v0 ?v2) (f3 ?v0 ?v1)) f1)))))))
(assert (forall ((?v0 S13)) (= (= (f53 ?v0) f1) (or (forall ((?v1 S2) (?v2 S2)) (=> (<= (f26 f37 ?v1) (f26 f37 ?v2)) (<= (f26 ?v0 ?v1) (f26 ?v0 ?v2)))) (forall ((?v1 S2) (?v2 S2)) (=> (<= (f26 f37 ?v1) (f26 f37 ?v2)) (<= (f26 ?v0 ?v2) (f26 ?v0 ?v1))))))))
(assert (forall ((?v0 S3)) (= (= (f42 ?v0) f1) (or (forall ((?v1 S2)) (= (f44 (f3 ?v0 ?v1) (f3 ?v0 (f35 f36 (+ (f26 f37 ?v1) 1)))) f1)) (forall ((?v1 S2)) (= (f44 (f3 ?v0 (f35 f36 (+ (f26 f37 ?v1) 1))) (f3 ?v0 ?v1)) f1))))))
(assert (forall ((?v0 S13)) (= (= (f53 ?v0) f1) (or (forall ((?v1 S2)) (<= (f26 ?v0 ?v1) (f26 ?v0 (f35 f36 (+ (f26 f37 ?v1) 1))))) (forall ((?v1 S2)) (<= (f26 ?v0 (f35 f36 (+ (f26 f37 ?v1) 1))) (f26 ?v0 ?v1)))))))
(assert (forall ((?v0 S6)) (= (f44 (f48 (f5 f6 ?v0)) (f45 ?v0)) f1)))
(assert (forall ((?v0 S6)) (= (f44 (f48 (f5 f13 ?v0)) (f45 ?v0)) f1)))
(assert (forall ((?v0 S6)) (let ((?v_0 (f45 ?v0))) (= (f44 (f25 ?v_0) ?v_0) f1))))
(assert (forall ((?v0 S6)) (= (f5 f6 (f22 f23 ?v0)) (f25 (f5 f6 ?v0)))))
(assert (forall ((?v0 S6)) (= (f5 f13 (f22 f23 ?v0)) (f25 (f5 f13 ?v0)))))
(assert (forall ((?v0 S7)) (=> (= (f52 ?v0) f1) (= (f51 (f30 ?v0)) f1))))
(assert (forall ((?v0 S3)) (=> (= (f42 ?v0) f1) (= (f42 (f24 ?v0)) f1))))
(assert (forall ((?v0 S13)) (=> (= (f53 ?v0) f1) (= (f53 (f27 f28 ?v0)) f1))))
(assert (forall ((?v0 S8) (?v1 S2)) (=> (= (f41 ?v0) f1) (<= (f26 f37 ?v1) (f26 f37 (f9 ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (= (f51 ?v0) f1) (=> (= (f41 ?v1) f1) (= (f51 (f15 (f16 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S7) (?v1 S8)) (=> (= (f52 ?v0) f1) (=> (= (f41 ?v1) f1) (= (f52 (f54 (f55 f56 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S7)) (=> (= (f52 ?v0) f1) (= (f51 (f29 ?v0)) f1))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f5 f13 ?v0) (f5 f13 ?v1)) (=> (= (f5 f6 ?v0) (f5 f6 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2)) (= (f35 f36 (f26 f37 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f26 f37 (f35 f36 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f26 f37 (f35 f36 ?v0)) 0))))
(check-sat)
(exit)
