(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 Int) Int)
(declare-fun f7 (S5 Int) S4)
(declare-fun f8 () S5)
(declare-fun f9 (S6 S7) S1)
(declare-fun f10 (S8 S7) S6)
(declare-fun f11 () S8)
(declare-fun f12 (S9 S7) S7)
(declare-fun f13 () S9)
(declare-fun f14 (S10 S7) S9)
(declare-fun f15 () S10)
(declare-fun f16 () S7)
(declare-fun f17 () S7)
(declare-fun f18 () S7)
(declare-fun f19 () S8)
(declare-fun f20 () S10)
(declare-fun f21 () S4)
(declare-fun f22 () S5)
(declare-fun f23 () S10)
(declare-fun f24 () S5)
(declare-fun f25 () S10)
(declare-fun f26 (S11 S7) Int)
(declare-fun f27 (S12 Int) S7)
(declare-fun f28 (S13 S14) S7)
(declare-fun f29 (S15 Int) S14)
(declare-fun f30 () S15)
(declare-fun f31 (S16 S14) Int)
(declare-fun f32 () S16)
(declare-fun f33 (S17 S3) S5)
(declare-fun f34 () S17)
(declare-fun f35 (S18 S8) S10)
(declare-fun f36 () S18)
(declare-fun f37 () S17)
(declare-fun f38 () S18)
(declare-fun f39 () S6)
(declare-fun f40 () S7)
(declare-fun f41 () S7)
(declare-fun f42 () S7)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 ?v0) ?v1) (- ?v0 ?v1))))
(assert (not (= (f9 (f10 f11 (f12 f13 (f12 (f14 f15 f16) f17))) f18) f1)))
(assert (= (f9 (f10 f19 f17) f16) f1))
(assert (= (f9 (f10 f11 f16) (f12 (f14 f20 f17) f18)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f6 f21 (- ?v0 ?v1)) ?v2) (and (< (- ?v1 ?v2) ?v0) (< ?v0 (+ ?v1 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f9 (f10 f11 (f12 f13 (f12 (f14 f15 ?v0) ?v1))) ?v2) f1) (and (= (f9 (f10 f11 (f12 (f14 f15 ?v1) ?v2)) ?v0) f1) (= (f9 (f10 f11 ?v0) (f12 (f14 f20 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f6 f21 (- ?v0 ?v1)) (+ (f6 f21 ?v0) (f6 f21 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f19 (f12 f13 (f12 (f14 f15 ?v0) ?v1))) (f12 (f14 f20 (f12 f13 ?v0)) (f12 f13 ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (<= (f6 f21 (- (+ ?v0 ?v1) (+ ?v2 ?v3))) (+ (f6 f21 (- ?v0 ?v2)) (f6 f21 (- ?v1 ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (= (f9 (f10 f19 (f12 f13 (f12 (f14 f15 (f12 (f14 f20 ?v0) ?v1)) (f12 (f14 f20 ?v2) ?v3)))) (f12 (f14 f20 (f12 f13 (f12 (f14 f15 ?v0) ?v2))) (f12 f13 (f12 (f14 f15 ?v1) ?v3)))) f1)))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f9 (f10 f19 ?v2) ?v3) f1) (= (f9 (f10 f11 (f12 (f14 f20 ?v0) ?v2)) (f12 (f14 f20 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (= (f9 (f10 f11 ?v2) ?v3) f1) (= (f9 (f10 f11 (f12 (f14 f20 ?v0) ?v2)) (f12 (f14 f20 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S7)) (= (f9 (f10 f19 ?v0) ?v0) f1)))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f20 ?v2))) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (= (f9 (f10 f19 (f12 ?v_0 ?v0)) (f12 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f11 ?v0) ?v1) f1) (and (= (f9 (f10 f19 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f19 ?v0) ?v1) f1) (or (= (f9 (f10 f11 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f12 (f14 f20 (f12 (f14 f15 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (- ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f12 (f14 f15 (f12 (f14 f20 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (= (f12 (f14 f15 (f12 (f14 f20 ?v0) ?v1)) (f12 (f14 f20 ?v2) ?v3)) (f12 (f14 f20 (f12 (f14 f15 ?v0) ?v2)) (f12 (f14 f15 ?v1) ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (- (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (- ?v0 ?v2) (- ?v1 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (=> (= (f9 (f10 f19 ?v0) ?v1) f1) false) (=> (=> (= (f9 (f10 f19 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f6 f21 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f19 (f12 f13 ?v0)) ?v1) f1) (= (f9 (f10 f19 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f19 ?v2))) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (= (f9 ?v_0 ?v0) f1) (= (f9 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (= (f9 (f10 f19 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f19 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= (f9 (f10 f19 ?v1) ?v2) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (= (f9 (f10 f19 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f9 (f10 f19 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f19 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f19 ?v2))) (=> (= ?v0 ?v1) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= ?v0 ?v1) (=> (= (f9 (f10 f19 ?v1) ?v2) f1) (= (f9 (f10 f19 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (= (= (f9 (f10 f19 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= ?v0 ?v1) (= (f9 (f10 f19 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f6 (f7 f22 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f9 (f10 f19 (f12 (f14 f23 ?v0) ?v1)) ?v2) f1) (or (= (f9 (f10 f19 ?v0) ?v2) f1) (= (f9 (f10 f19 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f6 (f7 f24 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f19 ?v0))) (= (= (f9 ?v_0 (f12 (f14 f25 ?v1) ?v2)) f1) (or (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= ?v0 ?v1) (and (= (f9 (f10 f19 ?v0) ?v1) f1) (= (f9 (f10 f19 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (or (= (f9 (f10 f19 ?v0) ?v1) f1) (= (f9 (f10 f19 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f6 f21 ?v0))))
(assert (forall ((?v0 S7)) (= (f9 (f10 f19 ?v0) (f12 f13 ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (=> (= (f9 (f10 f11 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f9 (f10 f11 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (=> (not false) (= (f9 (f10 f11 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v2))) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f9 ?v_0 ?v0) f1) (= (f9 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= (f9 (f10 f11 ?v1) ?v2) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f9 (f10 f11 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v2))) (=> (= ?v0 ?v1) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= ?v0 ?v1) (=> (= (f9 (f10 f11 ?v1) ?v2) f1) (= (f9 (f10 f11 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f9 (f10 f11 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f9 (f10 f11 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S1)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (=> (= (f9 (f10 f11 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (not (= (f9 (f10 f11 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (not (= (f9 (f10 f11 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f9 (f10 f11 ?v0) ?v1) f1) false) (=> (=> (= (f9 (f10 f11 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= (f9 (f10 f11 ?v0) ?v1) f1)) (= (not (= (f9 (f10 f11 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f6 (f7 f22 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f9 (f10 f11 (f12 (f14 f23 ?v0) ?v1)) ?v2) f1) (or (= (f9 (f10 f11 ?v0) ?v2) f1) (= (f9 (f10 f11 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f6 (f7 f24 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f9 (f10 f11 (f12 (f14 f25 ?v0) ?v1)) ?v2) f1) (and (= (f9 (f10 f11 ?v0) ?v2) f1) (= (f9 (f10 f11 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f6 (f7 f22 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (= (= (f9 ?v_0 (f12 (f14 f23 ?v1) ?v2)) f1) (and (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f6 (f7 f24 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (= (= (f9 ?v_0 (f12 (f14 f25 ?v1) ?v2)) f1) (or (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (or (= (f9 (f10 f11 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f9 (f10 f11 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (not (= (f9 (f10 f11 ?v0) ?v1) f1)) (or (= (f9 (f10 f11 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (not (= ?v0 ?v1)) (or (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f11 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 S7)) (not (= (f9 (f10 f11 ?v0) ?v0) f1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f12 (f14 f20 ?v0) ?v1) (f12 (f14 f20 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f20 ?v0))) (=> (= (f12 ?v_0 ?v1) (f12 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f20 ?v0))) (=> (= (f12 ?v_0 ?v1) (f12 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f12 (f14 f20 ?v0) ?v1) (f12 (f14 f20 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f20 ?v0))) (= (= (f12 ?v_0 ?v1) (f12 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (f12 (f14 f20 (f12 (f14 f23 ?v0) ?v1)) ?v2) (f12 (f14 f23 (f12 (f14 f20 ?v0) ?v2)) (f12 (f14 f20 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f6 (f7 f22 ?v0) ?v1) ?v2) (f6 (f7 f22 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (f12 (f14 f20 (f12 (f14 f25 ?v0) ?v1)) ?v2) (f12 (f14 f25 (f12 (f14 f20 ?v0) ?v2)) (f12 (f14 f20 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f6 (f7 f24 ?v0) ?v1) ?v2) (f6 (f7 f24 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f20 ?v0))) (= (f12 (f14 f20 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f12 (f14 f20 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f6 f21 ?v0) (f6 f21 ?v1)))) (= (f6 f21 ?v_0) ?v_0))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f12 (f14 f20 (f12 f13 ?v0)) (f12 f13 ?v1)))) (= (f12 f13 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f12 (f14 f15 ?v0) ?v1) (f12 (f14 f15 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f6 (f7 f22 ?v0) ?v1) ?v2) (f6 (f7 f22 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (f12 (f14 f15 (f12 (f14 f23 ?v0) ?v1)) ?v2) (f12 (f14 f23 (f12 (f14 f15 ?v0) ?v2)) (f12 (f14 f15 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f6 (f7 f24 ?v0) ?v1) ?v2) (f6 (f7 f24 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (f12 (f14 f15 (f12 (f14 f25 ?v0) ?v1)) ?v2) (f12 (f14 f25 (f12 (f14 f15 ?v0) ?v2)) (f12 (f14 f15 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 f21 (- ?v0 ?v1)) (f6 f21 (- ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f12 f13 (f12 (f14 f15 ?v0) ?v1)) (f12 f13 (f12 (f14 f15 ?v1) ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (= (f9 (f10 f19 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f19 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= (f9 (f10 f19 ?v1) ?v2) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (or (= (f9 (f10 f19 ?v0) ?v1) f1) (= (f9 (f10 f19 ?v1) ?v0) f1))))
(assert (forall ((?v0 S7)) (= (f9 (f10 f19 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v2))) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (= (f9 ?v_0 ?v0) f1) (= (f9 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (= (f9 (f10 f11 ?v1) ?v2) f1) (= (f9 (f10 f11 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f9 (f10 f19 ?v2) ?v0) f1) (= (f9 (f10 f11 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= (f9 (f10 f19 ?v1) ?v2) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (not (= ?v1 ?v0)) (= (f9 (f10 f11 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (not (= ?v0 ?v1)) (= (f9 (f10 f11 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (or (= (f9 (f10 f11 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (= (not (= (f9 (f10 f11 ?v0) ?v1) f1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f19 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (not (= (f9 (f10 f11 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= ?v0 ?v1)) (=> (= (f9 (f10 f19 ?v1) ?v0) f1) (= (f9 (f10 f11 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= ?v0 ?v1)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (= (f9 (f10 f11 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= (f9 (f10 f11 ?v0) ?v1) f1)) (= (= (f9 (f10 f19 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= (f9 (f10 f19 ?v0) ?v1) f1)) (= (f9 (f10 f11 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= (f9 (f10 f11 ?v0) ?v1) f1)) (= (f9 (f10 f19 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f19 ?v0) ?v1) f1) (or (= (f9 (f10 f11 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f11 ?v0) ?v1) f1) (and (= (f9 (f10 f19 ?v0) ?v1) f1) (not (= (f9 (f10 f19 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f11 ?v0) ?v1) f1) (and (= (f9 (f10 f19 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (or (= (f9 (f10 f19 ?v0) ?v1) f1) (= (f9 (f10 f11 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (not (= (f9 (f10 f19 ?v0) ?v1) f1)) (= (f9 (f10 f11 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (not (= (f9 (f10 f11 ?v0) ?v1) f1)) (= (f9 (f10 f19 ?v1) ?v0) f1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f20 ?v0))) (=> (= (f9 (f10 f19 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2)) f1) (= (f9 (f10 f19 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f19 (f12 (f14 f20 ?v0) ?v1)) (f12 (f14 f20 ?v2) ?v1)) f1) (= (f9 (f10 f19 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (= (f9 (f10 f19 ?v2) ?v3) f1) (= (f9 (f10 f19 (f12 (f14 f20 ?v0) ?v2)) (f12 (f14 f20 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f20 ?v2))) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (= (f9 (f10 f19 (f12 ?v_0 ?v0)) (f12 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (= (f9 (f10 f19 (f12 (f14 f20 ?v0) ?v2)) (f12 (f14 f20 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f20 ?v0))) (= (= (f9 (f10 f19 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2)) f1) (= (f9 (f10 f19 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f9 (f10 f19 (f12 (f14 f20 ?v0) ?v1)) (f12 (f14 f20 ?v2) ?v1)) f1) (= (f9 (f10 f19 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f6 f21 (+ ?v0 ?v1)) (+ (f6 f21 ?v0) (f6 f21 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f19 (f12 f13 (f12 (f14 f20 ?v0) ?v1))) (f12 (f14 f20 (f12 f13 ?v0)) (f12 f13 ?v1))) f1)))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f20 ?v0))) (=> (= (f9 (f10 f11 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2)) f1) (= (f9 (f10 f11 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f11 (f12 (f14 f20 ?v0) ?v1)) (f12 (f14 f20 ?v2) ?v1)) f1) (= (f9 (f10 f11 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f9 (f10 f11 ?v2) ?v3) f1) (= (f9 (f10 f11 (f12 (f14 f20 ?v0) ?v2)) (f12 (f14 f20 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f20 ?v2))) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f11 (f12 ?v_0 ?v0)) (f12 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f11 (f12 (f14 f20 ?v0) ?v2)) (f12 (f14 f20 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f20 ?v0))) (= (= (f9 (f10 f11 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2)) f1) (= (f9 (f10 f11 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f9 (f10 f11 (f12 (f14 f20 ?v0) ?v1)) (f12 (f14 f20 ?v2) ?v1)) f1) (= (f9 (f10 f11 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (<= ?v0 ?v1) (<= ?v2 ?v3)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f12 (f14 f15 ?v0) ?v1) (f12 (f14 f15 ?v2) ?v3)) (= (= (f9 (f10 f19 ?v0) ?v1) f1) (= (f9 (f10 f19 ?v2) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f6 f21 ?v0) (f6 f21 ?v1)) (f6 f21 (- ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f19 (f12 (f14 f15 (f12 f13 ?v0)) (f12 f13 ?v1))) (f12 f13 (f12 (f14 f15 ?v1) ?v0))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f6 f21 ?v0) (f6 f21 ?v1)) (f6 f21 (- ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f19 (f12 (f14 f15 (f12 f13 ?v0)) (f12 f13 ?v1))) (f12 f13 (f12 (f14 f15 ?v0) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f6 f21 (- (f6 f21 ?v0) (f6 f21 ?v1))) (f6 f21 (- ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f19 (f12 f13 (f12 (f14 f15 (f12 f13 ?v0)) (f12 f13 ?v1)))) (f12 f13 (f12 (f14 f15 ?v0) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (< ?v0 ?v1) (< ?v2 ?v3)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f12 (f14 f15 ?v0) ?v1) (f12 (f14 f15 ?v2) ?v3)) (= (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f11 ?v2) ?v3) f1)))))
(assert (forall ((?v0 S11) (?v1 S7) (?v2 Int) (?v3 S7)) (=> (<= (f26 ?v0 ?v1) ?v2) (=> (= (f9 (f10 f11 ?v3) ?v1) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v5) ?v4) f1) (< (f26 ?v0 ?v5) (f26 ?v0 ?v4)))) (< (f26 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S12) (?v1 Int) (?v2 S7) (?v3 Int)) (=> (= (f9 (f10 f19 (f27 ?v0 ?v1)) ?v2) f1) (=> (< ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f9 (f10 f11 (f27 ?v0 ?v5)) (f27 ?v0 ?v4)) f1))) (= (f9 (f10 f11 (f27 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S11) (?v1 S7) (?v2 Int) (?v3 S7)) (=> (< (f26 ?v0 ?v1) ?v2) (=> (= (f9 (f10 f19 ?v3) ?v1) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f19 ?v5) ?v4) f1) (<= (f26 ?v0 ?v5) (f26 ?v0 ?v4)))) (< (f26 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S12) (?v1 Int) (?v2 S7) (?v3 Int)) (=> (= (f9 (f10 f11 (f27 ?v0 ?v1)) ?v2) f1) (=> (<= ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f9 (f10 f19 (f27 ?v0 ?v5)) (f27 ?v0 ?v4)) f1))) (= (f9 (f10 f11 (f27 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S11) (?v2 S7) (?v3 S7)) (=> (<= ?v0 (f26 ?v1 ?v2)) (=> (= (f9 (f10 f11 ?v2) ?v3) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v4) ?v5) f1) (< (f26 ?v1 ?v4) (f26 ?v1 ?v5)))) (< ?v0 (f26 ?v1 ?v3)))))))
(assert (forall ((?v0 S7) (?v1 S12) (?v2 Int) (?v3 Int)) (=> (= (f9 (f10 f19 ?v0) (f27 ?v1 ?v2)) f1) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f9 (f10 f11 (f27 ?v1 ?v4)) (f27 ?v1 ?v5)) f1))) (= (f9 (f10 f11 ?v0) (f27 ?v1 ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 S11) (?v2 S7) (?v3 S7)) (=> (< ?v0 (f26 ?v1 ?v2)) (=> (= (f9 (f10 f19 ?v2) ?v3) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f19 ?v4) ?v5) f1) (<= (f26 ?v1 ?v4) (f26 ?v1 ?v5)))) (< ?v0 (f26 ?v1 ?v3)))))))
(assert (forall ((?v0 S7) (?v1 S12) (?v2 Int) (?v3 Int)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f9 ?v_0 (f27 ?v1 ?v2)) f1) (=> (<= ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f9 (f10 f19 (f27 ?v1 ?v4)) (f27 ?v1 ?v5)) f1))) (= (f9 ?v_0 (f27 ?v1 ?v3)) f1)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S11) (?v3 Int)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (< (f26 ?v2 ?v1) ?v3) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f19 ?v4) ?v5) f1) (<= (f26 ?v2 ?v4) (f26 ?v2 ?v5)))) (< (f26 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S12) (?v3 S7)) (=> (<= ?v0 ?v1) (=> (= (f9 (f10 f11 (f27 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f9 (f10 f19 (f27 ?v2 ?v4)) (f27 ?v2 ?v5)) f1))) (= (f9 (f10 f11 (f27 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S11) (?v3 Int)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (<= (f26 ?v2 ?v1) ?v3) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v4) ?v5) f1) (< (f26 ?v2 ?v4) (f26 ?v2 ?v5)))) (< (f26 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S12) (?v3 S7)) (=> (< ?v0 ?v1) (=> (= (f9 (f10 f19 (f27 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f9 (f10 f11 (f27 ?v2 ?v4)) (f27 ?v2 ?v5)) f1))) (= (f9 (f10 f11 (f27 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int) (?v3 S11)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (< ?v2 (f26 ?v3 ?v0)) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f19 ?v5) ?v4) f1) (<= (f26 ?v3 ?v5) (f26 ?v3 ?v4)))) (< ?v2 (f26 ?v3 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 S12)) (let ((?v_0 (f10 f11 ?v2))) (=> (<= ?v0 ?v1) (=> (= (f9 ?v_0 (f27 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f9 (f10 f19 (f27 ?v3 ?v5)) (f27 ?v3 ?v4)) f1))) (= (f9 ?v_0 (f27 ?v3 ?v1)) f1)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int) (?v3 S11)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (<= ?v2 (f26 ?v3 ?v0)) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v5) ?v4) f1) (< (f26 ?v3 ?v5) (f26 ?v3 ?v4)))) (< ?v2 (f26 ?v3 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 S12)) (=> (< ?v0 ?v1) (=> (= (f9 (f10 f19 ?v2) (f27 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f9 (f10 f11 (f27 ?v3 ?v5)) (f27 ?v3 ?v4)) f1))) (= (f9 (f10 f11 ?v2) (f27 ?v3 ?v1)) f1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (forall ((?v3 S7)) (=> (= (f9 (f10 f11 ?v0) ?v3) f1) (=> (= (f9 (f10 f11 ?v3) ?v1) f1) (= (f9 (f10 f19 ?v3) ?v2) f1)))) (= (f9 (f10 f19 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (forall ((?v2 S7)) (=> (= (f9 (f10 f11 ?v2) ?v0) f1) (= (f9 (f10 f19 ?v2) ?v1) f1))) (= (f9 (f10 f19 ?v0) ?v1) f1))))
(assert (forall ((?v0 S6)) (=> (exists ((?v1 S7)) (= (f9 ?v0 ?v1) f1)) (=> (exists ((?v1 S7)) (forall ((?v2 S7)) (=> (= (f9 ?v0 ?v2) f1) (= (f9 (f10 f11 ?v2) ?v1) f1)))) (exists ((?v1 S7)) (forall ((?v2 S7)) (= (exists ((?v3 S7)) (and (= (f9 ?v0 ?v3) f1) (= (f9 (f10 f11 ?v2) ?v3) f1))) (= (f9 (f10 f11 ?v2) ?v1) f1))))))))
(assert (forall ((?v0 S13) (?v1 S14) (?v2 S14)) (=> (forall ((?v3 S14)) (= (f9 (f10 f19 (f28 ?v0 ?v3)) (f28 ?v0 (f29 f30 (+ (f31 f32 ?v3) 1)))) f1)) (= (f9 (f10 f19 (f28 ?v0 ?v1)) (f28 ?v0 (f29 f30 (+ (f31 f32 ?v1) (f31 f32 ?v2))))) f1))))
(assert (forall ((?v0 S7)) (exists ((?v1 S7)) (= (f9 (f10 f11 ?v0) ?v1) f1))))
(assert (forall ((?v0 S7)) (exists ((?v1 S7)) (= (f9 (f10 f11 ?v1) ?v0) f1))))
(assert (forall ((?v0 S12) (?v1 Int) (?v2 S7) (?v3 Int)) (=> (= (f9 (f10 f11 (f27 ?v0 ?v1)) ?v2) f1) (=> (< ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f9 (f10 f11 (f27 ?v0 ?v5)) (f27 ?v0 ?v4)) f1))) (= (f9 (f10 f11 (f27 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S11) (?v1 S7) (?v2 Int) (?v3 S7)) (=> (< (f26 ?v0 ?v1) ?v2) (=> (= (f9 (f10 f11 ?v3) ?v1) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v5) ?v4) f1) (< (f26 ?v0 ?v5) (f26 ?v0 ?v4)))) (< (f26 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f6 ?v1 ?v2)) (=> (< ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f6 ?v1 ?v5) (f6 ?v1 ?v4)))) (< (f6 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 S7) (?v1 S9) (?v2 S7) (?v3 S7)) (=> (= ?v0 (f12 ?v1 ?v2)) (=> (= (f9 (f10 f11 ?v3) ?v2) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v5) ?v4) f1) (= (f9 (f10 f11 (f12 ?v1 ?v5)) (f12 ?v1 ?v4)) f1))) (= (f9 (f10 f11 (f12 ?v1 ?v3)) ?v0) f1))))))
(assert (forall ((?v0 S7) (?v1 S12) (?v2 Int) (?v3 Int)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f9 ?v_0 (f27 ?v1 ?v2)) f1) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f9 (f10 f11 (f27 ?v1 ?v4)) (f27 ?v1 ?v5)) f1))) (= (f9 ?v_0 (f27 ?v1 ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S11) (?v2 S7) (?v3 S7)) (=> (< ?v0 (f26 ?v1 ?v2)) (=> (= (f9 (f10 f11 ?v2) ?v3) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v4) ?v5) f1) (< (f26 ?v1 ?v4) (f26 ?v1 ?v5)))) (< ?v0 (f26 ?v1 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 S11) (?v2 S7) (?v3 S7)) (=> (= ?v0 (f26 ?v1 ?v2)) (=> (= (f9 (f10 f11 ?v2) ?v3) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v4) ?v5) f1) (< (f26 ?v1 ?v4) (f26 ?v1 ?v5)))) (< ?v0 (f26 ?v1 ?v3)))))))
(assert (forall ((?v0 S7) (?v1 S12) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f27 ?v1 ?v2)) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f9 (f10 f11 (f27 ?v1 ?v4)) (f27 ?v1 ?v5)) f1))) (= (f9 (f10 f11 ?v0) (f27 ?v1 ?v3)) f1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (exists ((?v2 S7)) (and (= (f9 (f10 f11 ?v0) ?v2) f1) (= (f9 (f10 f11 ?v2) ?v1) f1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int) (?v3 S11)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (< ?v2 (f26 ?v3 ?v0)) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v5) ?v4) f1) (< (f26 ?v3 ?v5) (f26 ?v3 ?v4)))) (< ?v2 (f26 ?v3 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 S12)) (let ((?v_0 (f10 f11 ?v2))) (=> (< ?v0 ?v1) (=> (= (f9 ?v_0 (f27 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f9 (f10 f11 (f27 ?v3 ?v5)) (f27 ?v3 ?v4)) f1))) (= (f9 ?v_0 (f27 ?v3 ?v1)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4) (?v3 Int)) (=> (< ?v0 ?v1) (=> (= (f6 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f6 ?v2 ?v5) (f6 ?v2 ?v4)))) (< ?v3 (f6 ?v2 ?v1)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S9) (?v3 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f12 ?v2 ?v0) ?v3) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v5) ?v4) f1) (= (f9 (f10 f11 (f12 ?v2 ?v5)) (f12 ?v2 ?v4)) f1))) (= (f9 (f10 f11 ?v3) (f12 ?v2 ?v1)) f1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S11) (?v3 Int)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (= (f26 ?v2 ?v1) ?v3) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v4) ?v5) f1) (< (f26 ?v2 ?v4) (f26 ?v2 ?v5)))) (< (f26 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S12) (?v3 S7)) (=> (< ?v0 ?v1) (=> (= (f27 ?v2 ?v1) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f9 (f10 f11 (f27 ?v2 ?v4)) (f27 ?v2 ?v5)) f1))) (= (f9 (f10 f11 (f27 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S11) (?v3 Int)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (=> (< (f26 ?v2 ?v1) ?v3) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f11 ?v4) ?v5) f1) (< (f26 ?v2 ?v4) (f26 ?v2 ?v5)))) (< (f26 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S12) (?v3 S7)) (=> (< ?v0 ?v1) (=> (= (f9 (f10 f11 (f27 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f9 (f10 f11 (f27 ?v2 ?v4)) (f27 ?v2 ?v5)) f1))) (= (f9 (f10 f11 (f27 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S12) (?v1 Int) (?v2 S7) (?v3 Int)) (=> (= (f9 (f10 f19 (f27 ?v0 ?v1)) ?v2) f1) (=> (<= ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f9 (f10 f19 (f27 ?v0 ?v5)) (f27 ?v0 ?v4)) f1))) (= (f9 (f10 f19 (f27 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S11) (?v1 S7) (?v2 Int) (?v3 S7)) (=> (<= (f26 ?v0 ?v1) ?v2) (=> (= (f9 (f10 f19 ?v3) ?v1) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f19 ?v5) ?v4) f1) (<= (f26 ?v0 ?v5) (f26 ?v0 ?v4)))) (<= (f26 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f6 ?v1 ?v2)) (=> (<= ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f6 ?v1 ?v5) (f6 ?v1 ?v4)))) (<= (f6 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 S7) (?v1 S9) (?v2 S7) (?v3 S7)) (=> (= ?v0 (f12 ?v1 ?v2)) (=> (= (f9 (f10 f19 ?v3) ?v2) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f19 ?v5) ?v4) f1) (= (f9 (f10 f19 (f12 ?v1 ?v5)) (f12 ?v1 ?v4)) f1))) (= (f9 (f10 f19 (f12 ?v1 ?v3)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f6 (f7 f24 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (forall ((?v2 S7)) (= (f9 (f10 f19 ?v0) ?v2) f1)) (= (f12 (f14 f25 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f6 (f7 f24 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (forall ((?v2 S7)) (= (f9 (f10 f19 ?v0) ?v2) f1)) (= (f12 (f14 f25 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f6 (f7 f22 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (forall ((?v2 S7)) (= (f9 (f10 f19 ?v0) ?v2) f1)) (= (f12 (f14 f23 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 S7) (?v1 S12) (?v2 Int) (?v3 Int)) (let ((?v_0 (f10 f19 ?v0))) (=> (= (f9 ?v_0 (f27 ?v1 ?v2)) f1) (=> (<= ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f9 (f10 f19 (f27 ?v1 ?v4)) (f27 ?v1 ?v5)) f1))) (= (f9 ?v_0 (f27 ?v1 ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S11) (?v2 S7) (?v3 S7)) (=> (<= ?v0 (f26 ?v1 ?v2)) (=> (= (f9 (f10 f19 ?v2) ?v3) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f19 ?v4) ?v5) f1) (<= (f26 ?v1 ?v4) (f26 ?v1 ?v5)))) (<= ?v0 (f26 ?v1 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 S11) (?v2 S7) (?v3 S7)) (=> (= ?v0 (f26 ?v1 ?v2)) (=> (= (f9 (f10 f19 ?v2) ?v3) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f19 ?v4) ?v5) f1) (<= (f26 ?v1 ?v4) (f26 ?v1 ?v5)))) (<= ?v0 (f26 ?v1 ?v3)))))))
(assert (forall ((?v0 S7) (?v1 S12) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f27 ?v1 ?v2)) (=> (<= ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f9 (f10 f19 (f27 ?v1 ?v4)) (f27 ?v1 ?v5)) f1))) (= (f9 (f10 f19 ?v0) (f27 ?v1 ?v3)) f1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S11) (?v3 Int)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (<= (f26 ?v2 ?v1) ?v3) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f19 ?v4) ?v5) f1) (<= (f26 ?v2 ?v4) (f26 ?v2 ?v5)))) (<= (f26 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S12) (?v3 S7)) (=> (<= ?v0 ?v1) (=> (= (f9 (f10 f19 (f27 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f9 (f10 f19 (f27 ?v2 ?v4)) (f27 ?v2 ?v5)) f1))) (= (f9 (f10 f19 (f27 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f6 (f7 f22 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (forall ((?v2 S7)) (= (f9 (f10 f19 ?v0) ?v2) f1)) (= (f12 (f14 f23 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int) (?v3 S11)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (<= ?v2 (f26 ?v3 ?v0)) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f19 ?v5) ?v4) f1) (<= (f26 ?v3 ?v5) (f26 ?v3 ?v4)))) (<= ?v2 (f26 ?v3 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 S12)) (let ((?v_0 (f10 f19 ?v2))) (=> (<= ?v0 ?v1) (=> (= (f9 ?v_0 (f27 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f9 (f10 f19 (f27 ?v3 ?v5)) (f27 ?v3 ?v4)) f1))) (= (f9 ?v_0 (f27 ?v3 ?v1)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (= (f6 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f6 ?v2 ?v5) (f6 ?v2 ?v4)))) (<= ?v3 (f6 ?v2 ?v1)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S9) (?v3 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (= (f12 ?v2 ?v0) ?v3) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f19 ?v5) ?v4) f1) (= (f9 (f10 f19 (f12 ?v2 ?v5)) (f12 ?v2 ?v4)) f1))) (= (f9 (f10 f19 ?v3) (f12 ?v2 ?v1)) f1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S11) (?v3 Int)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (= (f26 ?v2 ?v1) ?v3) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f9 (f10 f19 ?v4) ?v5) f1) (<= (f26 ?v2 ?v4) (f26 ?v2 ?v5)))) (<= (f26 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S12) (?v3 S7)) (=> (<= ?v0 ?v1) (=> (= (f27 ?v2 ?v1) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f9 (f10 f19 (f27 ?v2 ?v4)) (f27 ?v2 ?v5)) f1))) (= (f9 (f10 f19 (f27 ?v2 ?v0)) ?v3) f1))))))
(assert (= f22 (f33 f34 f5)))
(assert (= f23 (f35 f36 f19)))
(assert (= f24 (f33 f37 f5)))
(assert (= f25 (f35 f38 f19)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 f39 (f12 (f14 f15 ?v1) ?v0)) f1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 f39 ?v0) f1) (=> (= (f9 f39 ?v1) f1) (= (f9 f39 (f12 (f14 f20 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (f6 (f7 f24 ?v0) ?v1) ?v2) (=> (=> (<= ?v0 ?v2) (=> (<= ?v1 ?v2) false)) false))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f19 (f12 (f14 f25 ?v0) ?v1)) ?v2) f1) (=> (=> (= (f9 (f10 f19 ?v0) ?v2) f1) (=> (= (f9 (f10 f19 ?v1) ?v2) f1) false)) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 (f6 (f7 f22 ?v1) ?v2)) (=> (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) false)) false))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f19 ?v0))) (=> (= (f9 ?v_0 (f12 (f14 f23 ?v1) ?v2)) f1) (=> (=> (= (f9 ?v_0 ?v1) f1) (=> (= (f9 ?v_0 ?v2) f1) false)) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f6 (f7 f22 ?v0) ?v2) (f6 (f7 f22 ?v1) ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (= (f9 (f10 f19 ?v2) ?v3) f1) (= (f9 (f10 f19 (f12 (f14 f23 ?v0) ?v2)) (f12 (f14 f23 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f6 (f7 f24 ?v0) ?v2) (f6 (f7 f24 ?v1) ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (= (f9 (f10 f19 ?v2) ?v3) f1) (= (f9 (f10 f19 (f12 (f14 f25 ?v0) ?v2)) (f12 (f14 f25 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f6 (f7 f24 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (= (f9 (f10 f19 ?v2) ?v1) f1) (= (f9 (f10 f19 (f12 (f14 f25 ?v0) ?v2)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f6 (f7 f24 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (=> (= (f9 (f10 f19 ?v2) ?v1) f1) (= (f9 (f10 f19 (f12 (f14 f25 ?v0) ?v2)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f6 (f7 f22 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f19 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= (f9 ?v_0 ?v2) f1) (= (f9 ?v_0 (f12 (f14 f23 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f6 (f7 f22 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f19 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= (f9 ?v_0 ?v2) f1) (= (f9 ?v_0 (f12 (f14 f23 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f6 (f7 f22 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (= (f12 (f14 f23 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f6 (f7 f24 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (= (f12 (f14 f25 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f6 (f7 f22 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (= (f12 (f14 f23 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f6 (f7 f24 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (= (f12 (f14 f25 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f6 (f7 f22 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (= (f9 (f10 f19 (f12 (f14 f23 ?v2) ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f6 (f7 f22 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f19 ?v0) ?v1) f1) (= (f9 (f10 f19 (f12 (f14 f23 ?v0) ?v2)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f6 (f7 f24 ?v2) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f19 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 (f12 (f14 f25 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f6 (f7 f24 ?v1) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f19 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 (f12 (f14 f25 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f22 ?v0))) (<= (f6 (f7 f24 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 (f7 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f23 ?v0))) (= (f9 (f10 f19 (f12 (f14 f25 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2))) (f12 ?v_0 (f12 (f14 f25 ?v1) ?v2))) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f6 (f7 f24 ?v0) ?v1) ?v2) (and (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f9 (f10 f19 (f12 (f14 f25 ?v0) ?v1)) ?v2) f1) (and (= (f9 (f10 f19 ?v0) ?v2) f1) (= (f9 (f10 f19 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f24 ?v0))) (<= (f6 ?v_0 (f6 (f7 f22 ?v1) ?v2)) (f6 (f7 f22 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f25 ?v0))) (= (f9 (f10 f19 (f12 ?v_0 (f12 (f14 f23 ?v1) ?v2))) (f12 (f14 f23 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2))) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f6 (f7 f22 ?v1) ?v2)) (and (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f19 ?v0))) (= (= (f9 ?v_0 (f12 (f14 f23 ?v1) ?v2)) f1) (and (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f6 (f7 f22 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f19 ?v0) ?v1) f1) (= (f12 (f14 f23 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f6 (f7 f24 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f19 ?v0) ?v1) f1) (= (f12 (f14 f25 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f6 (f7 f22 ?v0) ?v1) ?v1)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f19 (f12 (f14 f23 ?v0) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f6 (f7 f22 ?v0) ?v1) ?v0)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f19 (f12 (f14 f23 ?v0) ?v1)) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f6 (f7 f24 ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f19 ?v0) (f12 (f14 f25 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f6 (f7 f24 ?v0) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f9 (f10 f19 ?v0) (f12 (f14 f25 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f6 (f7 f22 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f11 (f12 (f14 f23 ?v2) ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f6 (f7 f22 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f11 (f12 (f14 f23 ?v0) ?v2)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f6 (f7 f24 ?v2) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 (f12 (f14 f25 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f6 (f7 f24 ?v1) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 (f12 (f14 f25 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_0 (f14 f20 ?v0))) (= (f12 (f14 f20 (f12 ?v_0 ?v1)) (f12 (f14 f20 ?v2) ?v3)) (f12 (f14 f20 (f12 ?v_0 ?v2)) (f12 (f14 f20 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f20 ?v0))) (= (f12 (f14 f20 (f12 ?v_0 ?v1)) ?v2) (f12 (f14 f20 (f12 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f20 ?v0))) (= (f12 (f14 f20 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f12 (f14 f20 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f12 (f14 f20 ?v0) ?v1) (f12 (f14 f20 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_1 (f14 f20 ?v0)) (?v_0 (f14 f20 ?v1))) (= (f12 ?v_1 (f12 ?v_0 ?v2)) (f12 ?v_0 (f12 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f20 ?v0))) (= (f12 ?v_0 (f12 (f14 f20 ?v1) ?v2)) (f12 (f14 f20 (f12 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f9 (f10 f11 ?v0) ?v1) f1) false) (=> (=> (= (f9 (f10 f11 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int)) (exists ((?v1 Int)) (forall ((?v2 Int)) (=> (< ?v2 ?v1) (= (<= ?v0 ?v2) false))))))
(assert (forall ((?v0 S7)) (exists ((?v1 S7)) (forall ((?v2 S7)) (=> (= (f9 (f10 f11 ?v2) ?v1) f1) (= (= (f9 (f10 f19 ?v0) ?v2) f1) false))))))
(assert (forall ((?v0 Int)) (exists ((?v1 Int)) (forall ((?v2 Int)) (=> (< ?v1 ?v2) (= (<= ?v2 ?v0) false))))))
(assert (forall ((?v0 S7)) (exists ((?v1 S7)) (forall ((?v2 S7)) (=> (= (f9 (f10 f11 ?v1) ?v2) f1) (= (= (f9 (f10 f19 ?v2) ?v0) f1) false))))))
(assert (forall ((?v0 Int)) (exists ((?v1 Int)) (forall ((?v2 Int)) (=> (< ?v2 ?v1) (= (<= ?v2 ?v0) true))))))
(assert (forall ((?v0 S7)) (exists ((?v1 S7)) (forall ((?v2 S7)) (=> (= (f9 (f10 f11 ?v2) ?v1) f1) (= (= (f9 (f10 f19 ?v2) ?v0) f1) true))))))
(assert (forall ((?v0 Int)) (exists ((?v1 Int)) (forall ((?v2 Int)) (=> (< ?v1 ?v2) (= (<= ?v0 ?v2) true))))))
(assert (forall ((?v0 S7)) (exists ((?v1 S7)) (forall ((?v2 S7)) (=> (= (f9 (f10 f11 ?v1) ?v2) f1) (= (= (f9 (f10 f19 ?v0) ?v2) f1) true))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v4 ?v5) (= (= (f3 ?v0 ?v5) f1) (= (f3 ?v1 ?v5) f1))))) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v4 ?v5) (= (= (f3 ?v2 ?v5) f1) (= (f3 ?v3 ?v5) f1))))) (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v4 ?v5) (= (or (= (f3 ?v0 ?v5) f1) (= (f3 ?v2 ?v5) f1)) (or (= (f3 ?v1 ?v5) f1) (= (f3 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (exists ((?v4 S7)) (forall ((?v5 S7)) (=> (= (f9 (f10 f11 ?v4) ?v5) f1) (= (= (f9 ?v0 ?v5) f1) (= (f9 ?v1 ?v5) f1))))) (=> (exists ((?v4 S7)) (forall ((?v5 S7)) (=> (= (f9 (f10 f11 ?v4) ?v5) f1) (= (= (f9 ?v2 ?v5) f1) (= (f9 ?v3 ?v5) f1))))) (exists ((?v4 S7)) (forall ((?v5 S7)) (=> (= (f9 (f10 f11 ?v4) ?v5) f1) (= (or (= (f9 ?v0 ?v5) f1) (= (f9 ?v2 ?v5) f1)) (or (= (f9 ?v1 ?v5) f1) (= (f9 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v4 ?v5) (= (= (f3 ?v0 ?v5) f1) (= (f3 ?v1 ?v5) f1))))) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v4 ?v5) (= (= (f3 ?v2 ?v5) f1) (= (f3 ?v3 ?v5) f1))))) (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v4 ?v5) (= (and (= (f3 ?v0 ?v5) f1) (= (f3 ?v2 ?v5) f1)) (and (= (f3 ?v1 ?v5) f1) (= (f3 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (exists ((?v4 S7)) (forall ((?v5 S7)) (=> (= (f9 (f10 f11 ?v4) ?v5) f1) (= (= (f9 ?v0 ?v5) f1) (= (f9 ?v1 ?v5) f1))))) (=> (exists ((?v4 S7)) (forall ((?v5 S7)) (=> (= (f9 (f10 f11 ?v4) ?v5) f1) (= (= (f9 ?v2 ?v5) f1) (= (f9 ?v3 ?v5) f1))))) (exists ((?v4 S7)) (forall ((?v5 S7)) (=> (= (f9 (f10 f11 ?v4) ?v5) f1) (= (and (= (f9 ?v0 ?v5) f1) (= (f9 ?v2 ?v5) f1)) (and (= (f9 ?v1 ?v5) f1) (= (f9 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (exists ((?v4 S7)) (forall ((?v5 S7)) (=> (= (f9 (f10 f11 ?v5) ?v4) f1) (= (= (f9 ?v0 ?v5) f1) (= (f9 ?v1 ?v5) f1))))) (=> (exists ((?v4 S7)) (forall ((?v5 S7)) (=> (= (f9 (f10 f11 ?v5) ?v4) f1) (= (= (f9 ?v2 ?v5) f1) (= (f9 ?v3 ?v5) f1))))) (exists ((?v4 S7)) (forall ((?v5 S7)) (=> (= (f9 (f10 f11 ?v5) ?v4) f1) (= (or (= (f9 ?v0 ?v5) f1) (= (f9 ?v2 ?v5) f1)) (or (= (f9 ?v1 ?v5) f1) (= (f9 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S7)) (exists ((?v1 S7)) (forall ((?v2 S7)) (=> (= (f9 (f10 f11 ?v2) ?v1) f1) (= (not (= ?v2 ?v0)) true))))))
(assert (forall ((?v0 S7)) (exists ((?v1 S7)) (forall ((?v2 S7)) (=> (= (f9 (f10 f11 ?v1) ?v2) f1) (= (not (= ?v2 ?v0)) true))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (exists ((?v4 S7)) (forall ((?v5 S7)) (=> (= (f9 (f10 f11 ?v5) ?v4) f1) (= (= (f9 ?v0 ?v5) f1) (= (f9 ?v1 ?v5) f1))))) (=> (exists ((?v4 S7)) (forall ((?v5 S7)) (=> (= (f9 (f10 f11 ?v5) ?v4) f1) (= (= (f9 ?v2 ?v5) f1) (= (f9 ?v3 ?v5) f1))))) (exists ((?v4 S7)) (forall ((?v5 S7)) (=> (= (f9 (f10 f11 ?v5) ?v4) f1) (= (and (= (f9 ?v0 ?v5) f1) (= (f9 ?v2 ?v5) f1)) (and (= (f9 ?v1 ?v5) f1) (= (f9 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S7)) (exists ((?v1 S7)) (forall ((?v2 S7)) (=> (= (f9 (f10 f11 ?v1) ?v2) f1) (= (= (f9 (f10 f11 ?v2) ?v0) f1) false))))))
(assert (forall ((?v0 S7)) (exists ((?v1 S7)) (forall ((?v2 S7)) (=> (= (f9 (f10 f11 ?v2) ?v1) f1) (= (= (f9 (f10 f11 ?v0) ?v2) f1) false))))))
(assert (forall ((?v0 S7)) (exists ((?v1 S7)) (forall ((?v2 S7)) (=> (= (f9 (f10 f11 ?v1) ?v2) f1) (= (= (f9 (f10 f11 ?v0) ?v2) f1) true))))))
(assert (forall ((?v0 S7)) (exists ((?v1 S7)) (forall ((?v2 S7)) (=> (= (f9 (f10 f11 ?v1) ?v2) f1) (= (= ?v2 ?v0) false))))))
(assert (forall ((?v0 S7)) (exists ((?v1 S7)) (forall ((?v2 S7)) (let ((?v_0 (f10 f11 ?v2))) (=> (= (f9 ?v_0 ?v1) f1) (= (= (f9 ?v_0 ?v0) f1) true)))))))
(assert (forall ((?v0 S7)) (exists ((?v1 S7)) (forall ((?v2 S7)) (=> (= (f9 (f10 f11 ?v2) ?v1) f1) (= (= ?v2 ?v0) false))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f19 ?v0) f40) f1) (=> (= (f9 (f10 f11 ?v1) f40) f1) (= (f9 (f10 f11 (f12 (f14 f20 ?v0) ?v1)) f40) f1)))))
(assert (= (f9 (f10 f11 f40) f41) f1))
(assert (= (f9 (f10 f19 f40) f42) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v1))) (=> (= (f9 (f10 f11 f40) ?v0) f1) (=> (= (f9 ?v_0 ?v2) f1) (= (f9 ?v_0 (f12 (f14 f20 ?v0) ?v2)) f1))))))
(assert (forall ((?v0 S7)) (= (f12 (f14 f15 ?v0) f40) ?v0)))
(assert (forall ((?v0 Int)) (= (- ?v0 0) ?v0)))
(assert (forall ((?v0 S7)) (= (f12 (f14 f15 ?v0) ?v0) f40)))
(assert (forall ((?v0 Int)) (= (- ?v0 ?v0) 0)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= ?v0 ?v1) (= (f12 (f14 f15 ?v0) ?v1) f40))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f12 (f14 f15 ?v0) ?v1) f40) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0 ?v1) 0) (= ?v0 ?v1))))
(assert (not (= (f9 f39 f40) f1)))
(assert (forall ((?v0 S7)) (not (= (f9 (f10 f11 (f12 f13 ?v0)) f40) f1))))
(assert (forall ((?v0 Int)) (not (< (f6 f21 ?v0) 0))))
(assert (forall ((?v0 S7)) (= (= (f9 (f10 f11 f40) (f12 f13 ?v0)) f1) (not (= ?v0 f40)))))
(assert (forall ((?v0 Int)) (= (< 0 (f6 f21 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S7)) (=> (= (f9 (f10 f11 f40) ?v0) f1) (= (f12 f13 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f6 f21 ?v0) ?v0))))
(assert (= (f12 f13 f40) f40))
(assert (= (f6 f21 0) 0))
(assert (forall ((?v0 S7)) (= (= f40 ?v0) (= ?v0 f40))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S7)) (= (= (f12 f13 ?v0) f40) (= ?v0 f40))))
(assert (forall ((?v0 Int)) (= (= (f6 f21 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S7)) (= (f12 (f14 f20 ?v0) f40) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S7)) (= (f12 (f14 f20 ?v0) f40) ?v0)))
(assert (forall ((?v0 Int)) (= (= 0 (+ ?v0 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S7)) (= (= f40 (f12 (f14 f20 ?v0) ?v0)) (= ?v0 f40))))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f12 (f14 f20 f40) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f12 (f14 f20 f40) ?v0) ?v0)))
(assert (forall ((?v0 S7)) (=> (= (f9 (f10 f19 f40) ?v0) f1) (= (f12 f13 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f21 ?v0) ?v0))))
(assert (forall ((?v0 S7)) (= (= (f9 (f10 f19 (f12 f13 ?v0)) f40) f1) (= ?v0 f40))))
(assert (forall ((?v0 Int)) (= (<= (f6 f21 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S7)) (= (f9 (f10 f19 f40) (f12 f13 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= 0 (f6 f21 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f19 ?v0) ?v1) f1) (= (f9 (f10 f19 (f12 (f14 f15 ?v0) ?v1)) f40) f1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f11 ?v0) ?v1) f1) (= (f9 (f10 f11 (f12 (f14 f15 ?v0) ?v1)) f40) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (< (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 (f10 f19 ?v0) ?v1) f1) (= (f9 (f10 f19 (f12 (f14 f15 ?v0) ?v1)) f40) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (<= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f11 ?v0) f40) f1) (=> (= (f9 (f10 f11 ?v1) f40) f1) (= (f9 (f10 f11 (f12 (f14 f20 ?v0) ?v1)) f40) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f10 f11 f40))) (=> (= (f9 ?v_0 ?v0) f1) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 (f12 (f14 f20 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int)) (= (< (+ ?v0 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 S7)) (= (= (f9 (f10 f11 (f12 (f14 f20 ?v0) ?v0)) f40) f1) (= (f9 (f10 f11 ?v0) f40) f1))))
(assert (forall ((?v0 Int)) (= (< 0 (+ ?v0 ?v0)) (< 0 ?v0))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f10 f11 f40))) (= (= (f9 ?v_0 (f12 (f14 f20 ?v0) ?v0)) f1) (= (f9 ?v_0 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f9 (f10 f19 ?v0) f40) f1) (=> (= (f9 (f10 f19 ?v1) f40) f1) (= (f9 (f10 f19 (f12 (f14 f20 ?v0) ?v1)) f40) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v2 ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f19 ?v1))) (=> (= (f9 (f10 f19 f40) ?v0) f1) (=> (= (f9 ?v_0 ?v2) f1) (= (f9 ?v_0 (f12 (f14 f20 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f19 ?v1))) (=> (= (f9 (f10 f19 f40) ?v0) f1) (=> (= (f9 ?v_0 ?v2) f1) (= (f9 ?v_0 (f12 (f14 f20 ?v0) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (+ ?v0 ?v1) 0) (and (= ?v0 0) (= ?v1 0)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f10 f19 f40))) (=> (= (f9 ?v_0 ?v0) f1) (=> (= (f9 ?v_0 ?v1) f1) (= (= (f12 (f14 f20 ?v0) ?v1) f40) (and (= ?v0 f40) (= ?v1 f40))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f10 f19 f40))) (=> (= (f9 ?v_0 ?v0) f1) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 (f12 (f14 f20 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S14)) (= (f29 f30 (f31 f32 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f31 f32 (f29 f30 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f31 f32 (f29 f30 ?v0)) 0))))
(check-sat)
(exit)
