(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2) S1)
(declare-fun f4 (S2 S2) S1)
(declare-fun f5 (S3 S4) Int)
(declare-fun f6 () S3)
(declare-fun f7 (S5 S2) S4)
(declare-fun f8 () S5)
(declare-fun f9 (S6) S1)
(declare-fun f10 (S6 S6) S1)
(declare-fun f11 (S7 S6) S4)
(declare-fun f12 () S7)
(declare-fun f13 (S9 S6) S2)
(declare-fun f14 (S8) S9)
(declare-fun f15 (S11 S2) S6)
(declare-fun f16 (S10) S11)
(declare-fun f17 (S13) S1)
(declare-fun f18 (S12 S6) S13)
(declare-fun f19 () S6)
(declare-fun f20 () S8)
(declare-fun f21 (S14) S1)
(declare-fun f22 (S15 Int) S4)
(declare-fun f23 () S15)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0) f1) (=> (= (f4 ?v1 ?v0) f1) (=> (<= (f5 f6 (f7 f8 ?v0)) (f5 f6 (f7 f8 ?v1))) (= ?v1 ?v0))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f9 ?v0) f1) (=> (= (f10 ?v1 ?v0) f1) (=> (<= (f5 f6 (f11 f12 ?v0)) (f5 f6 (f11 f12 ?v1))) (= ?v1 ?v0))))))
(assert (forall ((?v0 S6) (?v1 S8)) (=> (= (f9 ?v0) f1) (= (f3 (f13 (f14 ?v1) ?v0)) f1))))
(assert (forall ((?v0 S2) (?v1 S10)) (=> (= (f3 ?v0) f1) (= (f9 (f15 (f16 ?v1) ?v0)) f1))))
(assert (forall ((?v0 S6) (?v1 S12)) (=> (= (f9 ?v0) f1) (= (f17 (f18 ?v1 ?v0)) f1))))
(assert (not (forall ((?v0 S2) (?v1 S14)) (let ((?v_0 (f13 (f14 f20) f19))) (=> (= (f9 f19) f1) (=> (= (f4 ?v0 ?v_0) f1) (=> (= (f7 f8 ?v0) (f7 f8 ?v_0)) (=> (= (f21 ?v1) f1) (= ?v0 ?v_0)))))))))
(assert (forall ((?v0 S4)) (= (f22 f23 (f5 f6 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f5 f6 (f22 f23 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f5 f6 (f22 f23 ?v0)) 0))))
(check-sat)
(exit)
