(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status sat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-sort S24 0)
(declare-sort S25 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 (S4 Int) S3)
(declare-fun f5 (S5 Int) S4)
(declare-fun f6 () S5)
(declare-fun f7 () S4)
(declare-fun f8 (S6 S7) S1)
(declare-fun f9 (Int S2) S6)
(declare-fun f10 () Int)
(declare-fun f11 () S2)
(declare-fun f12 (S8) S7)
(declare-fun f13 (S9) S8)
(declare-fun f14 (S10 S9) S9)
(declare-fun f15 (S11 S2) S10)
(declare-fun f16 (S12 Int) S11)
(declare-fun f17 (S13 Int) S12)
(declare-fun f18 () S13)
(declare-fun f19 (S14 S2) Int)
(declare-fun f20 () S14)
(declare-fun f21 (S15 S9) S2)
(declare-fun f22 (S16 S17) S15)
(declare-fun f23 () S16)
(declare-fun f24 () S17)
(declare-fun f25 () S9)
(declare-fun f26 (S18 S2) S2)
(declare-fun f27 (S19 Int) S18)
(declare-fun f28 () S19)
(declare-fun f29 () S2)
(declare-fun f30 (S20 S9) S9)
(declare-fun f31 (S21 Int) S20)
(declare-fun f32 () S21)
(declare-fun f33 () Int)
(declare-fun f34 (S22 Int) Int)
(declare-fun f35 (S23 Int) S22)
(declare-fun f36 () S23)
(declare-fun f37 () S17)
(declare-fun f38 (S24 S9) S9)
(declare-fun f39 (S4 S5 S5) S24)
(declare-fun f40 (S10 S24) S1)
(declare-fun f41 () S13)
(declare-fun f42 () Int)
(declare-fun f43 () Int)
(declare-fun f44 () Int)
(declare-fun f45 () S2)
(declare-fun f46 (S9) S24)
(declare-fun f47 () S10)
(declare-fun f48 () S2)
(declare-fun f49 (S17 S10) Int)
(declare-fun f50 () S8)
(declare-fun f51 (Int S25) S1)
(declare-fun f52 (S2) S25)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (= (f3 (f4 (f5 f6 ?v0) ?v1) ?v2) f1) true)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f3 (f4 f7 ?v0) ?v1) f1) false)))
(assert (not false))
(assert (let ((?v_0 (f19 f20 (f21 (f22 f23 f24) f25)))) (= (f8 (f9 f10 f11) (f12 (f13 (f14 (f15 (f16 (f17 f18 ?v_0) 0) (f26 (f27 f28 1) f29)) (f30 (f31 f32 ?v_0) f25))))) f1)))
(assert (<= 0 f33))
(assert (let ((?v_0 (f19 f20 (f21 (f22 f23 f24) f25)))) (< f33 (f34 (f35 f36 ?v_0) (f19 f20 (f21 (f22 f23 f37) (f38 (f39 f7 f6 f6) (f30 (f31 f32 ?v_0) f25))))))))
(assert (= (f40 (f15 (f16 (f17 f41 f42) f43) (f26 (f27 f28 f44) f45)) (f46 f25)) f1))
(assert (= f47 (f15 (f16 (f17 f41 f42) f43) (f26 (f27 f28 f44) f45))))
(assert (= f48 (f26 (f27 f28 f44) f45)))
(assert (forall ((?v0 S10)) (=> (= (f40 ?v0 (f46 f25)) f1) (and (not (= (f49 f24 ?v0) 0)) (not (= (f49 f37 ?v0) 0))))))
(assert (let ((?v_0 (f19 f20 (f21 (f22 f23 f24) f25)))) (not (= (f13 (f14 (f15 (f16 (f17 f18 ?v_0) 0) (f26 (f27 f28 1) f29)) (f30 (f31 f32 ?v_0) f25))) f50))))
(assert (not (= f44 0)))
(assert (forall ((?v0 Int)) (=> (= (f51 ?v0 (f52 (f21 (f22 f23 f24) f25))) f1) (not (= ?v0 0)))))
(assert (= (f51 f44 (f52 (f21 (f22 f23 f24) f25))) f1))
(assert (let ((?v_0 (f19 f20 (f21 (f22 f23 f24) f25)))) (or (and (<= ?v_0 0) (< f44 ?v_0)) (= f42 0))))
(assert (forall ((?v0 S2)) (=> (forall ((?v1 Int)) (=> (= (f51 ?v1 (f52 ?v0)) f1) (not (= ?v1 0)))) (< 0 (f19 f20 ?v0)))))
(check-sat)
(exit)
