(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 () S3)
(declare-fun f5 (S2 S3) S1)
(declare-fun f6 (S4 S5) S3)
(declare-fun f7 () S4)
(declare-fun f8 () S5)
(declare-fun f9 (S6 S7) S3)
(declare-fun f10 (S8 S7) S6)
(declare-fun f11 (S9) S8)
(declare-fun f12 () S9)
(declare-fun f13 () S7)
(declare-fun f14 (S11 S10) S1)
(declare-fun f15 (S9 Int) S11)
(declare-fun f16 (S2) S9)
(declare-fun f17 (Int S12) S1)
(declare-fun f18 (S13 S2) Int)
(declare-fun f19 () S13)
(declare-fun f20 (S14 S12) S12)
(declare-fun f21 (Int) S14)
(declare-fun f22 () S12)
(declare-fun f23 (S7 Int) S9)
(declare-fun f24 (S2) S7)
(declare-fun f25 (S15 Int) Int)
(declare-fun f26 () S15)
(declare-fun f27 (S3) S3)
(declare-fun f28 () S13)
(declare-fun f29 (S12 S10) S1)
(declare-fun f30 (S16 S10) S12)
(declare-fun f31 () S16)
(declare-fun f32 (S12 Int) S1)
(declare-fun f33 (S3 S5) S1)
(declare-fun f34 (S17 S10) S10)
(declare-fun f35 (S18 Int) S17)
(declare-fun f36 (S19 S15) S18)
(declare-fun f37 () S19)
(declare-fun f38 (S12 S10) S1)
(declare-fun f39 (S3 S5) S1)
(declare-fun f40 (S20 S10) S2)
(declare-fun f41 (S21 Int) S20)
(declare-fun f42 () S21)
(declare-fun f43 (S22 Int) S21)
(declare-fun f44 () S22)
(declare-fun f45 () S22)
(declare-fun f46 (S12 S10) S1)
(declare-fun f47 (S3 S5) S1)
(declare-fun f48 () S16)
(declare-fun f49 () S4)
(declare-fun f50 (Int S10) S1)
(declare-fun f51 (S2 S5) S1)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (= (f3 f4 ?v0) f1) (and (= (f5 ?v0 (f6 f7 f8)) f1) (= (f3 (f9 (f10 (f11 f12) f13) f13) ?v0) f1)))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 S10)) (= (= (f14 (f15 (f16 ?v0) ?v1) ?v2) f1) (= (f17 (f18 f19 ?v0) (f20 (f21 1) (f20 (f21 (- 1)) f22))) f1))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int) (?v3 S10)) (= (= (f14 (f15 (f23 (f24 ?v0) ?v1) ?v2) ?v3) f1) (= (f18 f19 ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (= (= (f14 (f15 (f23 f13 ?v0) ?v1) ?v2) f1) true)))
(assert (forall ((?v0 Int) (?v1 S10)) (= (= (f14 (f15 f12 ?v0) ?v1) f1) false)))
(assert (forall ((?v0 Int)) (= (f25 f26 ?v0) ?v0)))
(assert (not (forall ((?v0 S2)) (=> (= (f5 ?v0 (f27 f4)) f1) (= (f18 f19 ?v0) 1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f24 ?v0))) (=> (= (f5 ?v0 (f6 f7 f8)) f1) (= (f3 (f9 (f10 (f11 (f16 ?v0)) ?v_0) ?v_0) ?v0) f1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f24 ?v0))) (=> (= (f5 ?v0 (f6 f7 f8)) f1) (= (f3 (f9 (f10 (f11 (f16 ?v0)) ?v_0) ?v_0) ?v0) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f5 ?v0 (f6 f7 f8)) f1) (not (= (f18 f28 ?v0) 0)))))
(assert (forall ((?v0 S12) (?v1 S10)) (= (= (f29 ?v0 ?v1) f1) (exists ((?v2 Int)) (and (and (= (f17 ?v2 (f30 f31 ?v1)) f1) (= (f32 ?v0 ?v2) f1)) (forall ((?v3 Int)) (=> (and (= (f17 ?v3 (f30 f31 ?v1)) f1) (= (f32 ?v0 ?v3) f1)) (= ?v3 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S5)) (= (= (f33 ?v0 ?v1) f1) (exists ((?v2 S2)) (and (and (= (f5 ?v2 (f6 f7 ?v1)) f1) (= (f3 ?v0 ?v2) f1)) (forall ((?v3 S2)) (=> (and (= (f5 ?v3 (f6 f7 ?v1)) f1) (= (f3 ?v0 ?v3) f1)) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (= (f17 ?v0 (f30 f31 ?v1)) f1) (= (f34 (f35 (f36 f37 f26) ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S12) (?v1 S10)) (= (= (f38 ?v0 ?v1) f1) (exists ((?v2 Int)) (and (= (f17 ?v2 (f30 f31 ?v1)) f1) (= (f32 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S5)) (= (= (f39 ?v0 ?v1) f1) (exists ((?v2 S2)) (and (= (f5 ?v2 (f6 f7 ?v1)) f1) (= (f3 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S9) (?v1 S7) (?v2 S7) (?v3 Int) (?v4 S10)) (= (= (f3 (f9 (f10 (f11 ?v0) ?v1) ?v2) (f40 (f41 f42 ?v3) ?v4)) f1) (= (f14 (f15 ?v0 ?v3) ?v4) f1))))
(assert (forall ((?v0 S9) (?v1 S7) (?v2 S7) (?v3 Int) (?v4 Int) (?v5 S10)) (= (= (f3 (f9 (f10 (f11 ?v0) ?v1) ?v2) (f40 (f41 (f43 f44 ?v3) ?v4) ?v5)) f1) (= (f14 (f15 (f23 ?v2 ?v3) ?v4) ?v5) f1))))
(assert (forall ((?v0 S9) (?v1 S7) (?v2 S7) (?v3 Int) (?v4 Int) (?v5 S10)) (= (= (f3 (f9 (f10 (f11 ?v0) ?v1) ?v2) (f40 (f41 (f43 f45 ?v3) ?v4) ?v5)) f1) (= (f14 (f15 (f23 ?v1 ?v3) ?v4) ?v5) f1))))
(assert (forall ((?v0 S12) (?v1 S10)) (= (= (f46 ?v0 ?v1) f1) (forall ((?v2 Int)) (=> (= (f17 ?v2 (f30 f31 ?v1)) f1) (= (f32 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S5)) (= (= (f47 ?v0 ?v1) f1) (forall ((?v2 S2)) (=> (= (f5 ?v2 (f6 f7 ?v1)) f1) (= (f3 ?v0 ?v2) f1))))))
(assert (= f48 f31))
(assert (= f49 f7))
(assert (forall ((?v0 S12) (?v1 S10)) (= (= (f29 ?v0 ?v1) f1) (exists ((?v2 Int)) (and (and (= (f17 ?v2 (f30 f31 ?v1)) f1) (= (f32 ?v0 ?v2) f1)) (forall ((?v3 Int)) (=> (and (= (f17 ?v3 (f30 f31 ?v1)) f1) (= (f32 ?v0 ?v3) f1)) (= ?v3 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S5)) (= (= (f33 ?v0 ?v1) f1) (exists ((?v2 S2)) (and (and (= (f5 ?v2 (f6 f7 ?v1)) f1) (= (f3 ?v0 ?v2) f1)) (forall ((?v3 S2)) (=> (and (= (f5 ?v3 (f6 f7 ?v1)) f1) (= (f3 ?v0 ?v3) f1)) (= ?v3 ?v2))))))))
(assert (forall ((?v0 S10) (?v1 Int)) (= (= (f32 (f30 f48 ?v0) ?v1) f1) (= (f17 ?v1 (f30 f31 ?v0)) f1))))
(assert (forall ((?v0 S5) (?v1 S2)) (= (= (f3 (f6 f49 ?v0) ?v1) f1) (= (f5 ?v1 (f6 f7 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (= (f50 ?v0 ?v1) f1) (= (f17 ?v0 (f30 f31 ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S5)) (= (= (f51 ?v0 ?v1) f1) (= (f5 ?v0 (f6 f7 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (= (f17 ?v0 (f30 f31 ?v1)) f1) (= (f32 (f30 f48 ?v1) ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S5)) (= (= (f5 ?v0 (f6 f7 ?v1)) f1) (= (f3 (f6 f49 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int) (?v3 Int) (?v4 S10)) (not (= (f40 (f41 f42 ?v0) ?v1) (f40 (f41 (f43 f45 ?v2) ?v3) ?v4)))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int) (?v3 Int) (?v4 S10)) (not (= (f40 (f41 f42 ?v0) ?v1) (f40 (f41 (f43 f44 ?v2) ?v3) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10) (?v3 Int) (?v4 S10)) (not (= (f40 (f41 (f43 f45 ?v0) ?v1) ?v2) (f40 (f41 f42 ?v3) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10) (?v3 Int) (?v4 S10)) (not (= (f40 (f41 (f43 f44 ?v0) ?v1) ?v2) (f40 (f41 f42 ?v3) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10) (?v3 Int) (?v4 Int) (?v5 S10)) (not (= (f40 (f41 (f43 f45 ?v0) ?v1) ?v2) (f40 (f41 (f43 f44 ?v3) ?v4) ?v5)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10) (?v3 Int) (?v4 Int) (?v5 S10)) (not (= (f40 (f41 (f43 f44 ?v0) ?v1) ?v2) (f40 (f41 (f43 f45 ?v3) ?v4) ?v5)))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (f18 f28 (f40 (f41 f42 ?v0) ?v1)) 1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (= (f18 f28 (f40 (f41 (f43 f45 ?v0) ?v1) ?v2)) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (= (f18 f28 (f40 (f41 (f43 f44 ?v0) ?v1) ?v2)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int) (?v3 S10)) (= (= (f40 (f41 f42 ?v0) ?v1) (f40 (f41 f42 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10) (?v3 Int) (?v4 Int) (?v5 S10)) (= (= (f40 (f41 (f43 f45 ?v0) ?v1) ?v2) (f40 (f41 (f43 f45 ?v3) ?v4) ?v5)) (and (= ?v0 ?v3) (and (= ?v1 ?v4) (= ?v2 ?v5))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10) (?v3 Int) (?v4 Int) (?v5 S10)) (= (= (f40 (f41 (f43 f44 ?v0) ?v1) ?v2) (f40 (f41 (f43 f44 ?v3) ?v4) ?v5)) (and (= ?v0 ?v3) (and (= ?v1 ?v4) (= ?v2 ?v5))))))
(assert (forall ((?v0 S10) (?v1 S12)) (= (forall ((?v2 Int)) (=> (= (f17 ?v2 (f30 f31 ?v0)) f1) (= (f32 ?v1 ?v2) f1))) (= (f46 ?v1 ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S3)) (= (forall ((?v2 S2)) (=> (= (f5 ?v2 (f6 f7 ?v0)) f1) (= (f3 ?v1 ?v2) f1))) (= (f47 ?v1 ?v0) f1))))
(assert (forall ((?v0 S12) (?v1 S10)) (= (= (f46 ?v0 ?v1) f1) (forall ((?v2 Int)) (=> (= (f17 ?v2 (f30 f31 ?v1)) f1) (= (f32 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S5)) (= (= (f47 ?v0 ?v1) f1) (forall ((?v2 S2)) (=> (= (f5 ?v2 (f6 f7 ?v1)) f1) (= (f3 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S10) (?v1 S12)) (= (exists ((?v2 Int)) (and (= (f17 ?v2 (f30 f31 ?v0)) f1) (= (f32 ?v1 ?v2) f1))) (= (f38 ?v1 ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S3)) (= (exists ((?v2 S2)) (and (= (f5 ?v2 (f6 f7 ?v0)) f1) (= (f3 ?v1 ?v2) f1))) (= (f39 ?v1 ?v0) f1))))
(assert (forall ((?v0 S12) (?v1 S10)) (= (= (f38 ?v0 ?v1) f1) (exists ((?v2 Int)) (and (= (f17 ?v2 (f30 f31 ?v1)) f1) (= (f32 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S5)) (= (= (f39 ?v0 ?v1) f1) (exists ((?v2 S2)) (and (= (f5 ?v2 (f6 f7 ?v1)) f1) (= (f3 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (f30 f31 (f34 (f35 (f36 f37 f26) ?v0) ?v1)) (f20 (f21 ?v0) (f30 f31 ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S12) (?v3 S12)) (=> (= ?v0 ?v1) (=> (forall ((?v4 Int)) (=> (= (f17 ?v4 (f30 f31 ?v1)) f1) (= (= (f32 ?v2 ?v4) f1) (= (f32 ?v3 ?v4) f1)))) (= (= (f38 ?v2 ?v0) f1) (= (f38 ?v3 ?v1) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S3) (?v3 S3)) (=> (= ?v0 ?v1) (=> (forall ((?v4 S2)) (=> (= (f5 ?v4 (f6 f7 ?v1)) f1) (= (= (f3 ?v2 ?v4) f1) (= (f3 ?v3 ?v4) f1)))) (= (= (f39 ?v2 ?v0) f1) (= (f39 ?v3 ?v1) f1))))))
(check-sat)
(exit)
