(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status sat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 () S3)
(declare-fun f5 (S2 S3) S1)
(declare-fun f6 (S4) S3)
(declare-fun f7 () S4)
(declare-fun f8 (S5 S6 S6 S2) S1)
(declare-fun f9 () S5)
(declare-fun f10 () S6)
(declare-fun f11 () S3)
(declare-fun f12 () S5)
(declare-fun f13 () S3)
(declare-fun f14 () S5)
(declare-fun f15 () S6)
(declare-fun f16 (S5 Int) S7)
(declare-fun f17 (S1 S5) S7)
(declare-fun f18 () S5)
(declare-fun f19 () S5)
(declare-fun f20 (S7 S8) S1)
(declare-fun f21 (S6 Int) S5)
(declare-fun f22 (S3) S3)
(declare-fun f23 () S3)
(declare-fun f24 (S3 S3) S3)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (= (f3 f4 ?v0) f1) (and (= (f5 ?v0 (f6 f7)) f1) (= (f8 f9 f10 f10 ?v0) f1)))))
(assert (forall ((?v0 S2)) (= (= (f3 f11 ?v0) f1) (and (= (f5 ?v0 (f6 f7)) f1) (= (f8 f12 f10 f10 ?v0) f1)))))
(assert (forall ((?v0 S2)) (= (= (f3 f13 ?v0) f1) (and (= (f5 ?v0 (f6 f7)) f1) (= (f8 f14 f15 f15 ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (f16 f9 ?v0) (f17 f2 f18))))
(assert (forall ((?v0 Int)) (= (f16 f12 ?v0) (f17 f2 f19))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (= (f20 (f16 f18 ?v0) ?v1) f1) (< ?v0 0))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (= (f20 (f16 f19 ?v0) ?v1) f1) (< 0 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (= (f20 (f16 (f21 f10 ?v0) ?v1) ?v2) f1) false)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (= (f20 (f16 (f21 f15 ?v0) ?v1) ?v2) f1) true)))
(assert (forall ((?v0 Int) (?v1 S8)) (= (= (f20 (f16 f14 ?v0) ?v1) f1) false)))
(assert (not (= (f6 f7) (f22 f13))))
(assert (= (f22 f11) f23))
(assert (= (f22 f4) f23))
(assert (= (f6 f7) (f24 (f24 (f22 f13) (f22 f11)) (f22 f4))))
(check-sat)
(exit)
