(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 () S3)
(declare-fun f5 (S2 S3) S1)
(declare-fun f6 (S4) S3)
(declare-fun f7 () S4)
(declare-fun f8 (S5 S6) S3)
(declare-fun f9 (S7 S6) S5)
(declare-fun f10 (S8) S7)
(declare-fun f11 () S8)
(declare-fun f12 () S6)
(declare-fun f13 (S8 Int) S9)
(declare-fun f14 (S1 S8) S9)
(declare-fun f15 () S8)
(declare-fun f16 (S10 Int) S1)
(declare-fun f17 () S10)
(declare-fun f18 (S12 S11) Int)
(declare-fun f19 (S13 S11) S12)
(declare-fun f20 () S13)
(declare-fun f21 (S14 S11) S11)
(declare-fun f22 () S14)
(declare-fun f23 () S11)
(declare-fun f24 (S15 S11) S2)
(declare-fun f25 (S16 Int) S15)
(declare-fun f26 () S16)
(declare-fun f27 (S3) S3)
(declare-fun f28 (S9 S11) S1)
(declare-fun f29 (S17 S3) S3)
(declare-fun f30 (S2) S17)
(declare-fun f31 (S18 S10) S10)
(declare-fun f32 (Int) S18)
(declare-fun f33 (Int S10) S1)
(declare-fun f34 (S2) S17)
(declare-fun f35 (Int) S18)
(declare-fun f36 (S2) S8)
(declare-fun f37 (S19 S2) Int)
(declare-fun f38 () S19)
(declare-fun f39 (Int) S18)
(declare-fun f40 () S10)
(declare-fun f41 (S6 Int) S8)
(declare-fun f42 (S2) S6)
(declare-fun f43 () S3)
(declare-fun f44 () S10)
(declare-fun f45 (S10) S10)
(declare-fun f46 () S19)
(declare-fun f47 (S4) S20)
(declare-fun f48 () S20)
(declare-fun f49 () S3)
(declare-fun f50 () S1)
(declare-fun f51 (S21 S22 S11) S1)
(declare-fun f52 () S21)
(declare-fun f53 (S4) S22)
(declare-fun f54 (S2) S17)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (= (f3 f4 ?v0) f1) (and (= (f5 ?v0 (f6 f7)) f1) (= (f3 (f8 (f9 (f10 f11) f12) f12) ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (f13 f11 ?v0) (f14 f2 f15))))
(assert (forall ((?v0 Int)) (= (= (f16 f17 ?v0) f1) (exists ((?v1 S11) (?v2 Int)) (and (= ?v0 (- (f18 (f19 f20 (f21 f22 ?v1)) f23) ?v2)) (= (f5 (f24 (f25 f26 ?v2) ?v1) (f27 f4)) f1))))))
(assert (forall ((?v0 Int) (?v1 S11)) (= (= (f28 (f13 f15 ?v0) ?v1) f1) (< ?v0 0))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f29 (f30 ?v0) ?v1) ?v2) f1) (or (= ?v2 ?v0) (= (f5 ?v2 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (= (= (f16 (f31 (f32 ?v0) ?v1) ?v2) f1) (or (= ?v2 ?v0) (= (f33 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f29 (f34 ?v0) ?v1) ?v2) f1) (=> (not (= ?v2 ?v0)) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (= (= (f16 (f31 (f35 ?v0) ?v1) ?v2) f1) (=> (not (= ?v2 ?v0)) (= (f16 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 S11)) (= (= (f28 (f13 (f36 ?v0) ?v1) ?v2) f1) (= (f33 (f37 f38 ?v0) (f31 (f39 1) (f31 (f39 (- 1)) f40))) f1))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int) (?v3 S11)) (= (= (f28 (f13 (f41 (f42 ?v0) ?v1) ?v2) ?v3) f1) (= (f37 f38 ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S11)) (= (= (f28 (f13 (f41 f12 ?v0) ?v1) ?v2) f1) false)))
(assert (forall ((?v0 S2)) (= (= (f3 f43 ?v0) f1) false)))
(assert (forall ((?v0 Int)) (= (= (f16 f44 ?v0) f1) false)))
(assert (not (not (= (f45 f17) f40))))
(assert (forall ((?v0 S2)) (=> (= (f5 ?v0 (f6 f7)) f1) (not (= (f37 f46 ?v0) 0)))))
(assert (= (f47 f7) f48))
(assert (forall ((?v0 S8) (?v1 S6) (?v2 S6) (?v3 Int) (?v4 S11)) (= (= (f3 (f8 (f9 (f10 ?v0) ?v1) ?v2) (f24 (f25 f26 ?v3) ?v4)) f1) (= (f28 (f13 ?v0 ?v3) ?v4) f1))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f42 ?v0))) (=> (= (f5 ?v0 (f6 f7)) f1) (= (f3 (f8 (f9 (f10 (f36 ?v0)) ?v_0) ?v_0) ?v0) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f5 ?v0 f49) f1) false)))
(assert (forall ((?v0 Int)) (=> (= (f33 ?v0 f40) f1) false)))
(assert (forall ((?v0 S2)) (= (= (f3 f49 ?v0) f1) (= f50 f1))))
(assert (forall ((?v0 Int)) (= (= (f16 f40 ?v0) f1) (= f50 f1))))
(assert (forall ((?v0 S2)) (= (= (f3 f49 ?v0) f1) (= f50 f1))))
(assert (forall ((?v0 Int)) (= (= (f16 f40 ?v0) f1) (= f50 f1))))
(assert (= (f51 f52 (f53 f7) f23) f1))
(assert (forall ((?v0 Int) (?v1 S11) (?v2 Int) (?v3 S11)) (= (= (f24 (f25 f26 ?v0) ?v1) (f24 (f25 f26 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S2)) (= (= (f3 f49 ?v0) f1) (= (f5 ?v0 f49) f1))))
(assert (forall ((?v0 Int)) (= (= (f16 f40 ?v0) f1) (= (f33 ?v0 f40) f1))))
(assert (= f40 (f45 f44)))
(assert (= f49 (f27 f43)))
(assert (forall ((?v0 S3)) (= (forall ((?v1 S2)) (not (= (f5 ?v1 ?v0) f1))) (= ?v0 f49))))
(assert (forall ((?v0 S10)) (= (forall ((?v1 Int)) (not (= (f33 ?v1 ?v0) f1))) (= ?v0 f40))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (=> (= (f5 ?v0 (f29 (f54 ?v1) ?v2)) f1) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f5 ?v0 ?v2) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (=> (= (f33 ?v0 (f31 (f39 ?v1) ?v2)) f1) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f33 ?v0 ?v2) f1) false) false)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (=> (=> (not (= (f5 ?v0 ?v1) f1)) (= ?v0 ?v2)) (= (f5 ?v0 (f29 (f54 ?v2) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (=> (=> (not (= (f33 ?v0 ?v1) f1)) (= ?v0 ?v2)) (= (f33 ?v0 (f31 (f39 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f5 ?v0 (f29 (f54 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 S10)) (= (f33 ?v0 (f31 (f39 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f29 (f54 ?v0) ?v1) (f27 (f29 (f30 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (f31 (f39 ?v0) ?v1) (f45 (f31 (f32 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f29 (f54 ?v0) (f27 ?v1)) (f27 (f29 (f34 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (f31 (f39 ?v0) (f45 ?v1)) (f45 (f31 (f35 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f54 ?v0))) (let ((?v_1 (f29 ?v_0 ?v1))) (= (f29 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f39 ?v0))) (let ((?v_1 (f31 ?v_0 ?v1))) (= (f31 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (let ((?v_1 (f54 ?v0)) (?v_0 (f54 ?v1))) (= (f29 ?v_1 (f29 ?v_0 ?v2)) (f29 ?v_0 (f29 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (let ((?v_1 (f39 ?v0)) (?v_0 (f39 ?v1))) (= (f31 ?v_1 (f31 ?v_0 ?v2)) (f31 ?v_0 (f31 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (= (= (f5 ?v0 (f29 (f54 ?v1) ?v2)) f1) (or (= ?v0 ?v1) (= (f5 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (= (= (f33 ?v0 (f31 (f39 ?v1) ?v2)) f1) (or (= ?v0 ?v1) (= (f33 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f29 (f54 ?v0) ?v1) ?v2) f1) (or (= ?v0 ?v2) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (= (= (f16 (f31 (f39 ?v0) ?v1) ?v2) f1) (or (= ?v0 ?v2) (= (f16 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f29 (f54 ?v0) ?v1) (f27 (f29 (f30 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (f31 (f39 ?v0) ?v1) (f45 (f31 (f32 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (let ((?v_0 (f54 ?v0))) (=> (not (= (f5 ?v0 ?v1) f1)) (=> (not (= (f5 ?v0 ?v2) f1)) (= (= (f29 ?v_0 ?v1) (f29 ?v_0 ?v2)) (= ?v1 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f39 ?v0))) (=> (not (= (f33 ?v0 ?v1) f1)) (=> (not (= (f33 ?v0 ?v2) f1)) (= (= (f31 ?v_0 ?v1) (f31 ?v_0 ?v2)) (= ?v1 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (=> (= (f5 ?v0 ?v1) f1) (= (f5 ?v0 (f29 (f54 ?v2) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (=> (= (f33 ?v0 ?v1) f1) (= (f33 ?v0 (f31 (f39 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S3)) (=> (= (f5 ?v0 ?v1) f1) (= (f29 (f54 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (= (f33 ?v0 ?v1) f1) (= (f31 (f39 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f29 (f54 ?v0) f49) (f29 (f54 ?v1) f49)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f31 (f39 ?v0) f40) (f31 (f39 ?v1) f40)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f5 ?v0 (f29 (f54 ?v1) f49)) f1) (=> (=> (= ?v0 ?v1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f33 ?v0 (f31 (f39 ?v1) f40)) f1) (=> (=> (= ?v0 ?v1) false) false))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (= (f29 (f54 ?v0) (f29 (f54 ?v1) f49)) (f29 (f54 ?v2) (f29 (f54 ?v3) f49))) (or (and (= ?v0 ?v2) (= ?v1 ?v3)) (and (= ?v0 ?v3) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (= (f31 (f39 ?v0) (f31 (f39 ?v1) f40)) (f31 (f39 ?v2) (f31 (f39 ?v3) f40))) (or (and (= ?v0 ?v2) (= ?v1 ?v3)) (and (= ?v0 ?v3) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f5 ?v0 (f29 (f54 ?v1) f49)) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f33 ?v0 (f31 (f39 ?v1) f40)) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S3)) (not (= (f29 (f54 ?v0) ?v1) f49))))
(assert (forall ((?v0 Int) (?v1 S10)) (not (= (f31 (f39 ?v0) ?v1) f40))))
(assert (forall ((?v0 S2) (?v1 S3)) (not (= f49 (f29 (f54 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S10)) (not (= f40 (f31 (f39 ?v0) ?v1)))))
(check-sat)
(exit)
