(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 (S4 Int) S3)
(declare-fun f5 () S4)
(declare-fun f6 (Int S5) S1)
(declare-fun f7 (S6 S7) Int)
(declare-fun f8 () S6)
(declare-fun f9 () S7)
(declare-fun f10 (S8 S5) S5)
(declare-fun f11 (Int) S8)
(declare-fun f12 () S5)
(declare-fun f13 (S9 S7) S1)
(declare-fun f14 (S7) S9)
(declare-fun f15 (S5 Int) S1)
(declare-fun f16 (Int) S5)
(declare-fun f17 (S7) S9)
(declare-fun f18 (Int) S5)
(declare-fun f19 (S10 S9) S9)
(declare-fun f20 (S7) S10)
(declare-fun f21 (S7 S9) S1)
(declare-fun f22 (Int) S8)
(declare-fun f23 (S7) S10)
(declare-fun f24 (Int) S8)
(declare-fun f25 (S7) S10)
(declare-fun f26 (Int) S8)
(declare-fun f27 (S7) S10)
(declare-fun f28 (Int) S8)
(declare-fun f29 (S11 Int) S4)
(declare-fun f30 () S11)
(declare-fun f31 () S9)
(declare-fun f32 () S5)
(declare-fun f33 (S12 S11) S9)
(declare-fun f34 (S13 S11) S12)
(declare-fun f35 (S4) S13)
(declare-fun f36 (S7) S10)
(declare-fun f37 () S9)
(declare-fun f38 (S9) S9)
(declare-fun f39 (S5) S5)
(declare-fun f40 (S14) S9)
(declare-fun f41 (S14) S14)
(declare-fun f42 () S14)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f6 (f7 f8 f9) (f10 (f11 1) (f10 (f11 (- 1)) f12))) f1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f13 (f14 ?v0) ?v1) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 (f16 ?v0) ?v1) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f13 (f17 ?v0) ?v1) f1) (= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 (f18 ?v0) ?v1) f1) (= ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S9) (?v2 S7)) (= (= (f13 (f19 (f20 ?v0) ?v1) ?v2) f1) (or (= ?v2 ?v0) (= (f21 ?v2 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (= (= (f15 (f10 (f22 ?v0) ?v1) ?v2) f1) (or (= ?v2 ?v0) (= (f6 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S7) (?v1 S9) (?v2 S7)) (= (= (f13 (f19 (f23 ?v0) ?v1) ?v2) f1) (and (= ?v0 ?v2) (= (f13 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (= (= (f15 (f10 (f24 ?v0) ?v1) ?v2) f1) (and (= ?v0 ?v2) (= (f15 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S7) (?v1 S9) (?v2 S7)) (= (= (f13 (f19 (f25 ?v0) ?v1) ?v2) f1) (and (= ?v2 ?v0) (= (f13 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (= (= (f15 (f10 (f26 ?v0) ?v1) ?v2) f1) (and (= ?v2 ?v0) (= (f15 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S7) (?v1 S9) (?v2 S7)) (= (= (f13 (f19 (f27 ?v0) ?v1) ?v2) f1) (=> (not (= ?v2 ?v0)) (= (f13 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (= (= (f15 (f10 (f28 ?v0) ?v1) ?v2) f1) (=> (not (= ?v2 ?v0)) (= (f15 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (= (f3 (f4 (f29 f30 ?v0) ?v1) ?v2) f1) (= (f7 f8 f9) 1))))
(assert (forall ((?v0 S7)) (= (= (f13 f31 ?v0) f1) false)))
(assert (forall ((?v0 Int)) (= (= (f15 f32 ?v0) f1) false)))
(assert (not (= (f13 (f33 (f34 (f35 f5) f30) f30) f9) f1)))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S9)) (=> (= (f21 ?v0 (f19 (f36 ?v1) ?v2)) f1) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f21 ?v0 ?v2) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f6 ?v0 (f10 (f11 ?v1) ?v2)) f1) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f6 ?v0 ?v2) f1) false) false)))))
(assert (forall ((?v0 S7) (?v1 S9) (?v2 S7)) (=> (=> (not (= (f21 ?v0 ?v1) f1)) (= ?v0 ?v2)) (= (f21 ?v0 (f19 (f36 ?v2) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (=> (=> (not (= (f6 ?v0 ?v1) f1)) (= ?v0 ?v2)) (= (f6 ?v0 (f10 (f11 ?v2) ?v1)) f1))))
(assert (forall ((?v0 Int)) (=> (= (f6 ?v0 f12) f1) false)))
(assert (forall ((?v0 S7)) (=> (= (f21 ?v0 f37) f1) false)))
(assert (forall ((?v0 S7)) (= (f38 (f14 ?v0)) (f19 (f36 ?v0) f37))))
(assert (forall ((?v0 Int)) (= (f39 (f16 ?v0)) (f10 (f11 ?v0) f12))))
(assert (forall ((?v0 S7)) (= (f38 (f17 ?v0)) (f19 (f36 ?v0) f37))))
(assert (forall ((?v0 Int)) (= (f39 (f18 ?v0)) (f10 (f11 ?v0) f12))))
(assert (forall ((?v0 S7) (?v1 S9)) (= (f38 (f19 (f23 ?v0) ?v1)) (ite (= (f13 ?v1 ?v0) f1) (f19 (f36 ?v0) f37) f37))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f39 (f10 (f24 ?v0) ?v1)) (ite (= (f15 ?v1 ?v0) f1) (f10 (f11 ?v0) f12) f12))))
(assert (forall ((?v0 S7) (?v1 S9)) (= (f38 (f19 (f25 ?v0) ?v1)) (ite (= (f13 ?v1 ?v0) f1) (f19 (f36 ?v0) f37) f37))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f39 (f10 (f26 ?v0) ?v1)) (ite (= (f15 ?v1 ?v0) f1) (f10 (f11 ?v0) f12) f12))))
(assert (= (f21 f9 (f40 (f41 f42))) f1))
(assert (forall ((?v0 S7) (?v1 S9)) (not (= f37 (f19 (f36 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S5)) (not (= f12 (f10 (f11 ?v0) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S9)) (not (= (f19 (f36 ?v0) ?v1) f37))))
(assert (forall ((?v0 Int) (?v1 S5)) (not (= (f10 (f11 ?v0) ?v1) f12))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f21 ?v0 (f19 (f36 ?v1) f37)) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f6 ?v0 (f10 (f11 ?v1) f12)) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (= (= (f19 (f36 ?v0) (f19 (f36 ?v1) f37)) (f19 (f36 ?v2) (f19 (f36 ?v3) f37))) (or (and (= ?v0 ?v2) (= ?v1 ?v3)) (and (= ?v0 ?v3) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (= (f10 (f11 ?v0) (f10 (f11 ?v1) f12)) (f10 (f11 ?v2) (f10 (f11 ?v3) f12))) (or (and (= ?v0 ?v2) (= ?v1 ?v3)) (and (= ?v0 ?v3) (= ?v1 ?v2))))))
(assert (forall ((?v0 S7)) (=> (= (f21 ?v0 (f40 f42)) f1) (not (= (f7 f8 ?v0) 0)))))
(assert (forall ((?v0 S5) (?v1 Int)) (=> (= ?v0 f12) (not (= (f6 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S9) (?v1 S7)) (=> (= ?v0 f37) (not (= (f21 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S9)) (= (= (f38 ?v0) f37) (forall ((?v1 S7)) (not (= (f13 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S5)) (= (= (f39 ?v0) f12) (forall ((?v1 Int)) (not (= (f15 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int)) (= (= (f6 ?v0 f12) f1) false)))
(assert (forall ((?v0 S7)) (= (= (f21 ?v0 f37) f1) false)))
(assert (forall ((?v0 S9)) (= (= f37 (f38 ?v0)) (forall ((?v1 S7)) (not (= (f13 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S5)) (= (= f12 (f39 ?v0)) (forall ((?v1 Int)) (not (= (f15 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S5)) (= (forall ((?v1 Int)) (=> (= (f6 ?v1 f12) f1) (= (f15 ?v0 ?v1) f1))) true)))
(assert (forall ((?v0 S9)) (= (forall ((?v1 S7)) (=> (= (f21 ?v1 f37) f1) (= (f13 ?v0 ?v1) f1))) true)))
(assert (forall ((?v0 S5)) (= (exists ((?v1 Int)) (and (= (f6 ?v1 f12) f1) (= (f15 ?v0 ?v1) f1))) false)))
(assert (forall ((?v0 S9)) (= (exists ((?v1 S7)) (and (= (f21 ?v1 f37) f1) (= (f13 ?v0 ?v1) f1))) false)))
(assert (forall ((?v0 S5)) (= (exists ((?v1 Int)) (= (f6 ?v1 ?v0) f1)) (not (= ?v0 f12)))))
(assert (forall ((?v0 S9)) (= (exists ((?v1 S7)) (= (f21 ?v1 ?v0) f1)) (not (= ?v0 f37)))))
(assert (forall ((?v0 S5)) (= (forall ((?v1 Int)) (not (= (f6 ?v1 ?v0) f1))) (= ?v0 f12))))
(assert (forall ((?v0 S9)) (= (forall ((?v1 S7)) (not (= (f21 ?v1 ?v0) f1))) (= ?v0 f37))))
(assert (= f37 (f38 f31)))
(assert (= f12 (f39 f32)))
(assert (forall ((?v0 S7) (?v1 S9)) (=> (= (f21 ?v0 ?v1) f1) (= (f19 (f36 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (= (f6 ?v0 ?v1) f1) (= (f10 (f11 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S7) (?v1 S9) (?v2 S7)) (=> (= (f21 ?v0 ?v1) f1) (= (f21 ?v0 (f19 (f36 ?v2) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (=> (= (f6 ?v0 ?v1) f1) (= (f6 ?v0 (f10 (f11 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S7) (?v1 S9) (?v2 S9)) (let ((?v_0 (f36 ?v0))) (=> (not (= (f21 ?v0 ?v1) f1)) (=> (not (= (f21 ?v0 ?v2) f1)) (= (= (f19 ?v_0 ?v1) (f19 ?v_0 ?v2)) (= ?v1 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 ?v0))) (=> (not (= (f6 ?v0 ?v1) f1)) (=> (not (= (f6 ?v0 ?v2) f1)) (= (= (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) (= ?v1 ?v2)))))))
(assert (forall ((?v0 S7) (?v1 S9) (?v2 S7)) (= (= (f13 (f19 (f36 ?v0) ?v1) ?v2) f1) (or (= ?v0 ?v2) (= (f13 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (= (= (f15 (f10 (f11 ?v0) ?v1) ?v2) f1) (or (= ?v0 ?v2) (= (f15 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S9)) (= (= (f21 ?v0 (f19 (f36 ?v1) ?v2)) f1) (or (= ?v0 ?v1) (= (f21 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (= (f6 ?v0 (f10 (f11 ?v1) ?v2)) f1) (or (= ?v0 ?v1) (= (f6 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S9)) (let ((?v_1 (f36 ?v0)) (?v_0 (f36 ?v1))) (= (f19 ?v_1 (f19 ?v_0 ?v2)) (f19 ?v_0 (f19 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (let ((?v_1 (f11 ?v0)) (?v_0 (f11 ?v1))) (= (f10 ?v_1 (f10 ?v_0 ?v2)) (f10 ?v_0 (f10 ?v_1 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S9)) (let ((?v_0 (f36 ?v0))) (let ((?v_1 (f19 ?v_0 ?v1))) (= (f19 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f11 ?v0))) (let ((?v_1 (f10 ?v_0 ?v1))) (= (f10 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S7) (?v1 S9)) (= (f19 (f36 ?v0) (f38 ?v1)) (f38 (f19 (f27 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f10 (f11 ?v0) (f39 ?v1)) (f39 (f10 (f28 ?v0) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S9)) (= (f19 (f36 ?v0) ?v1) (f38 (f19 (f20 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f10 (f11 ?v0) ?v1) (f39 (f10 (f22 ?v0) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S9)) (= (f21 ?v0 (f19 (f36 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f6 ?v0 (f10 (f11 ?v0) ?v1)) f1)))
(check-sat)
(exit)
