(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2) S1)
(declare-fun f4 (S3 S4) S2)
(declare-fun f5 (S5 S2) S3)
(declare-fun f6 () S5)
(declare-fun f7 () S2)
(declare-fun f8 () S4)
(declare-fun f9 (S6 S4) Int)
(declare-fun f10 () S6)
(declare-fun f11 (S7 Int) S4)
(declare-fun f12 () S7)
(declare-fun f13 (S8 S4) S5)
(declare-fun f14 () S8)
(declare-fun f15 (S9 S2) S2)
(declare-fun f16 () S9)
(declare-fun f17 (S10 S2) S5)
(declare-fun f18 () S10)
(declare-fun f19 () S3)
(declare-fun f20 (S2 S2) S1)
(declare-fun f21 (S11 S2) S9)
(declare-fun f22 () S11)
(declare-fun f23 (S12 S2 S13) S1)
(declare-fun f24 (S14 S13) S12)
(declare-fun f25 (S15 S4) S14)
(declare-fun f26 (S16 S12) S15)
(declare-fun f27 () S16)
(declare-fun f28 (S12 S4) S13)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 f6 f7) f8)) f1)))
(assert (= (f3 f7) f1))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (let ((?v_0 (+ (f9 f10 ?v1) 1)) (?v_1 (f5 f6 ?v2))) (=> (< (f9 f10 ?v0) ?v_0) (= (f4 (f5 f6 (f4 ?v_1 ?v0)) (f11 f12 ?v_0)) (f4 (f5 f6 (f4 ?v_1 ?v1)) ?v0))))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4)) (= (f4 (f5 (f13 f14 (f11 f12 (+ (f9 f10 ?v0) 1))) ?v1) ?v2) (f4 (f5 f6 (f4 (f5 (f13 f14 ?v0) ?v1) ?v2)) ?v2))))
(assert (forall ((?v0 S2)) (=> (= (f3 ?v0) f1) (= (f3 (f15 f16 ?v0)) f1))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S2)) (= (f4 (f5 (f17 f18 (f4 (f5 f6 ?v0) ?v1)) ?v2) ?v1) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2)) (let ((?v_0 (+ (f9 f10 ?v1) 1))) (=> (< (f9 f10 ?v0) ?v_0) (= (f4 (f5 f6 (f4 (f5 (f17 f18 ?v2) ?v3) ?v1)) ?v0) (f4 (f5 (f17 f18 (f4 (f5 f6 ?v2) ?v0)) (f4 (f5 f6 ?v3) ?v0)) (f11 f12 ?v_0)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2)) (let ((?v_0 (+ (f9 f10 ?v1) 1))) (=> (< (f9 f10 ?v0) ?v_0) (= (f4 (f5 f6 (f4 (f5 (f17 f18 ?v2) ?v3) ?v0)) ?v1) (f4 (f5 (f17 f18 (f4 (f5 f6 ?v2) (f11 f12 ?v_0))) (f4 (f5 f6 ?v3) ?v1)) ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (+ (f9 f10 ?v1) 1)) (?v_1 (f17 f18 ?v2))) (=> (< (f9 f10 ?v0) ?v_0) (= (f4 (f5 (f17 f18 (f4 (f5 ?v_1 (f4 (f5 f6 ?v3) ?v0)) (f11 f12 ?v_0))) (f4 (f5 (f17 f18 ?v4) ?v3) ?v1)) ?v0) (f4 (f5 (f17 f18 (f4 (f5 ?v_1 ?v4) ?v0)) ?v3) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S4)) (= (f4 (f5 f6 (f15 f16 ?v0)) ?v1) (f15 f16 (f4 (f5 f6 ?v0) (f11 f12 (+ (f9 f10 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f4 f19 ?v0)) (?v_1 (f9 f10 ?v0))) (= (f4 (f5 f6 ?v_0) ?v1) (ite (< ?v_1 (f9 f10 ?v1)) ?v_0 (f4 f19 (f11 f12 (+ ?v_1 1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (=> (= (f20 ?v0 ?v1) f1) (= (f20 (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (= (f4 (f5 f6 (f15 (f21 f22 ?v0) ?v1)) ?v2) (f15 (f21 f22 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 S12) (?v1 S2) (?v2 S13) (?v3 S4) (?v4 S13)) (=> (= (f23 ?v0 ?v1 ?v2) f1) (= (f23 (f24 (f25 (f26 f27 ?v0) ?v3) ?v4) (f4 (f5 f6 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f20 ?v0 ?v1) f1) (= (f20 (f15 (f21 f22 ?v0) ?v2) (f15 (f21 f22 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f21 f22 ?v2))) (=> (= (f20 ?v0 ?v1) f1) (= (f20 (f15 ?v_0 ?v0) (f15 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f20 ?v0 ?v1) f1) (= (f20 (f15 f16 ?v0) (f15 f16 ?v1)) f1))))
(assert (forall ((?v0 S4) (?v1 S2)) (=> (= (f20 (f4 f19 ?v0) ?v1) f1) false)))
(assert (forall ((?v0 S12) (?v1 S4) (?v2 S13)) (=> (= (f28 ?v0 ?v1) ?v2) (= (f23 ?v0 (f4 f19 ?v1) ?v2) f1))))
(assert (forall ((?v0 S12) (?v1 S4) (?v2 S13)) (=> (= (f23 ?v0 (f4 f19 ?v1) ?v2) f1) (=> (=> (= (f28 ?v0 ?v1) ?v2) false) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f20 (f15 (f21 f22 (f15 f16 ?v0)) ?v1) (f4 (f5 (f17 f18 ?v0) ?v1) (f11 f12 0))) f1)))
(assert (forall ((?v0 S2) (?v1 S4)) (not (= (f15 f16 ?v0) (f4 f19 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S2)) (not (= (f4 f19 ?v0) (f15 f16 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f15 f16 ?v0) (f15 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S2)) (not (= (f4 f19 ?v0) (f15 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f15 (f21 f22 ?v0) ?v1) (f15 f16 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (not (= (f15 (f21 f22 ?v0) ?v1) (f4 f19 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f15 f16 ?v0) (f15 f16 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f4 f19 ?v0) (f4 f19 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (= (f15 (f21 f22 ?v0) ?v1) (f15 (f21 f22 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S4)) (= (f4 (f5 (f13 f14 (f11 f12 0)) ?v0) ?v1) ?v0)))
(assert (forall ((?v0 S12) (?v1 S4) (?v2 S13) (?v3 S4)) (let ((?v_0 (f9 f10 ?v3))) (= (f28 (f24 (f25 (f26 f27 ?v0) ?v1) ?v2) ?v3) (ite (< ?v_0 (f9 f10 ?v1)) (f28 ?v0 ?v3) (ite (= ?v3 ?v1) ?v2 (f28 ?v0 (f11 f12 (- ?v_0 1)))))))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4)) (let ((?v_0 (f13 f14 ?v0))) (= (f4 (f5 ?v_0 (f15 f16 ?v1)) ?v2) (f15 f16 (f4 (f5 ?v_0 ?v1) (f11 f12 (+ (f9 f10 ?v2) 1))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f4 f19 ?v1)) (?v_1 (f9 f10 ?v1))) (= (f4 (f5 (f13 f14 ?v0) ?v_0) ?v2) (ite (< ?v_1 (f9 f10 ?v2)) ?v_0 (f4 f19 (f11 f12 (+ ?v_1 (f9 f10 ?v0)))))))))
(assert (forall ((?v0 S4)) (= (f11 f12 (f9 f10 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f9 f10 (f11 f12 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f9 f10 (f11 f12 ?v0)) 0))))
(check-sat)
(exit)
