(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 () S3)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S2) S2)
(declare-fun f7 (S5 S2) S4)
(declare-fun f8 () S5)
(declare-fun f9 (S6 S7) S2)
(declare-fun f10 () S6)
(declare-fun f11 () S7)
(declare-fun f12 (S8 S3) S3)
(declare-fun f13 (S3) S8)
(declare-fun f14 (S9 S10) S2)
(declare-fun f15 (S11 S2) S9)
(declare-fun f16 (S12 S5) S11)
(declare-fun f17 () S12)
(declare-fun f18 () S7)
(declare-fun f19 () S10)
(declare-fun f20 (S3 S10) S1)
(declare-fun f21 (S13 S2) S6)
(declare-fun f22 (S14 S2) S13)
(declare-fun f23 () S14)
(declare-fun f24 () S4)
(declare-fun f25 (S15 S2 S16) S1)
(declare-fun f26 (S15 S7) S16)
(declare-fun f27 (S17 Int) S7)
(declare-fun f28 () S17)
(declare-fun f29 (S18 S7) Int)
(declare-fun f30 () S18)
(declare-fun f31 (S2) S3)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (= (f3 f4 ?v0) f1) (and (= (f3 f5 ?v0) f1) (= (f3 f5 (f6 (f7 f8 ?v0) (f9 f10 f11))) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (= (= (f3 (f12 (f13 ?v0) ?v1) ?v2) f1) (and (= (f3 ?v0 ?v2) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (not (= (f3 f5 (f6 (f7 f8 (f14 (f15 (f16 f17 f8) (f9 f10 f18)) f19)) (f9 f10 f11))) f1)))
(assert (= (f20 f4 f19) f1))
(assert (forall ((?v0 S7)) (= (f3 f5 (f9 f10 ?v0)) f1)))
(assert (forall ((?v0 S10) (?v1 S7)) (=> (= (f20 f5 ?v0) f1) (= (f3 f5 (f14 (f15 (f16 f17 f8) (f9 f10 ?v1)) ?v0)) f1))))
(assert (forall ((?v0 S7) (?v1 S10) (?v2 S7) (?v3 S10)) (let ((?v_0 (f16 f17 f8))) (= (= (f14 (f15 ?v_0 (f9 f10 ?v0)) ?v1) (f14 (f15 ?v_0 (f9 f10 ?v2)) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S7) (?v1 S2) (?v2 S2)) (not (= (f9 f10 ?v0) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S7)) (not (= (f6 (f7 f8 ?v0) ?v1) (f9 f10 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S10) (?v2 S2)) (let ((?v_0 (f16 f17 f8))) (= (= (f14 (f15 ?v_0 ?v0) ?v1) (f14 (f15 ?v_0 ?v2) ?v1)) (= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S10)) (= (= (f20 (f12 (f13 ?v0) ?v1) ?v2) f1) (and (= (f20 ?v0 ?v2) f1) (= (f20 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f9 f10 ?v0) (f9 f10 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (= (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S7) (?v2 S7)) (=> (= (f3 f5 ?v0) f1) (= (f3 f5 (f9 (f21 (f22 f23 ?v0) (f9 f10 ?v1)) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S7) (?v3 S10)) (not (= (f6 (f7 f8 (f6 f24 ?v0)) ?v1) (f14 (f15 (f16 f17 f8) (f9 f10 ?v2)) ?v3)))))
(assert (forall ((?v0 S7) (?v1 S10) (?v2 S2) (?v3 S10)) (let ((?v_0 (f16 f17 f8))) (not (= (f14 (f15 ?v_0 (f9 f10 ?v0)) ?v1) (f14 (f15 ?v_0 (f6 f24 ?v2)) ?v3))))))
(assert (forall ((?v0 S15) (?v1 S7) (?v2 S10) (?v3 S16) (?v4 S16)) (let ((?v_0 (f14 (f15 (f16 f17 f8) (f9 f10 ?v1)) ?v2))) (=> (= (f25 ?v0 ?v_0 ?v3) f1) (=> (= (f25 ?v0 ?v_0 ?v4) f1) (= ?v3 ?v4))))))
(assert (forall ((?v0 S15) (?v1 S7) (?v2 S16)) (=> (= (f25 ?v0 (f9 f10 ?v1) ?v2) f1) (=> (=> (= (f26 ?v0 ?v1) ?v2) false) false))))
(assert (forall ((?v0 S15) (?v1 S7) (?v2 S16)) (=> (= (f26 ?v0 ?v1) ?v2) (= (f25 ?v0 (f9 f10 ?v1) ?v2) f1))))
(assert (forall ((?v0 S2)) (=> (= (f3 f5 ?v0) f1) (= (f3 f5 (f6 f24 ?v0)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S10)) (let ((?v_0 (f16 f17 f8))) (=> (= (f3 f5 (f14 (f15 ?v_0 (f9 (f21 (f22 f23 ?v0) ?v1) (f27 f28 0))) ?v2)) f1) (=> (= (f3 f5 ?v1) f1) (= (f3 f5 (f14 (f15 ?v_0 (f6 (f7 f8 (f6 f24 ?v0)) ?v1)) ?v2)) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f6 f24 ?v0) (f6 f24 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f6 (f7 f8 ?v0) ?v1) (f6 f24 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f6 f24 ?v0) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S7)) (= (f9 (f21 (f22 f23 (f6 (f7 f8 ?v0) ?v1)) ?v2) ?v3) (f6 (f7 f8 (f9 (f21 (f22 f23 ?v0) ?v2) ?v3)) (f9 (f21 (f22 f23 ?v1) ?v2) ?v3)))))
(assert (forall ((?v0 S7) (?v1 S2)) (not (= (f9 f10 ?v0) (f6 f24 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S7)) (not (= (f6 f24 ?v0) (f9 f10 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S2)) (let ((?v_0 (f29 f30 ?v1))) (=> (< (f29 f30 ?v0) ?v_0) (= (f9 (f21 (f22 f23 (f9 f10 ?v1)) ?v2) ?v0) (f9 f10 (f27 f28 (- ?v_0 1))))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S2)) (let ((?v_0 (f9 f10 ?v0))) (=> (< (f29 f30 ?v0) (f29 f30 ?v1)) (= (f9 (f21 (f22 f23 ?v_0) ?v2) ?v1) ?v_0)))))
(assert (forall ((?v0 S7) (?v1 S2) (?v2 S7)) (let ((?v_1 (f9 f10 ?v0)) (?v_0 (f29 f30 ?v0))) (= (f9 (f21 (f22 f23 ?v_1) ?v1) ?v2) (ite (< (f29 f30 ?v2) ?v_0) (f9 f10 (f27 f28 (- ?v_0 1))) (ite (= ?v0 ?v2) ?v1 ?v_1))))))
(assert (forall ((?v0 S7) (?v1 S2)) (= (f9 (f21 (f22 f23 (f9 f10 ?v0)) ?v1) ?v0) ?v1)))
(assert (forall ((?v0 S2) (?v1 S10) (?v2 S2) (?v3 S10)) (let ((?v_0 (f16 f17 f8))) (= (= (f14 (f15 ?v_0 (f6 f24 ?v0)) ?v1) (f14 (f15 ?v_0 (f6 f24 ?v2)) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S2)) (= (= (f3 f5 ?v0) f1) (or (exists ((?v1 S10) (?v2 S7)) (and (= ?v0 (f14 (f15 (f16 f17 f8) (f9 f10 ?v2)) ?v1)) (= (f20 f5 ?v1) f1))) (or (exists ((?v1 S2)) (and (= ?v0 (f6 f24 ?v1)) (= (f3 f5 ?v1) f1))) (exists ((?v1 S2) (?v2 S2) (?v3 S10)) (let ((?v_0 (f16 f17 f8))) (and (= ?v0 (f14 (f15 ?v_0 (f6 (f7 f8 (f6 f24 ?v1)) ?v2)) ?v3)) (and (= (f3 f5 (f14 (f15 ?v_0 (f9 (f21 (f22 f23 ?v1) ?v2) (f27 f28 0))) ?v3)) f1) (= (f3 f5 ?v2) f1))))))))))
(assert (forall ((?v0 S5) (?v1 S2) (?v2 S10) (?v3 S2)) (let ((?v_0 (f16 f17 ?v0))) (=> (forall ((?v4 S2) (?v5 S2) (?v6 S2)) (let ((?v_1 (f7 ?v0 ?v6))) (= (f6 (f7 ?v0 (f6 ?v_1 ?v4)) ?v5) (f6 (f7 ?v0 (f6 ?v_1 ?v5)) ?v4)))) (= (f6 (f7 ?v0 (f14 (f15 ?v_0 ?v1) ?v2)) ?v3) (f14 (f15 ?v_0 (f6 (f7 ?v0 ?v1) ?v3)) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f31 (f6 (f7 f8 (f6 f24 ?v0)) ?v1)) (f9 (f21 (f22 f23 ?v0) ?v1) (f27 f28 0))) f1)))
(assert (forall ((?v0 S2)) (=> (forall ((?v1 S7)) (=> (= ?v0 (f9 f10 ?v1)) false)) (=> (forall ((?v1 S2) (?v2 S2)) (=> (= ?v0 (f6 (f7 f8 ?v1) ?v2)) false)) (=> (forall ((?v1 S2)) (=> (= ?v0 (f6 f24 ?v1)) false)) false)))))
(assert (forall ((?v0 S7)) (= (f27 f28 (f29 f30 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f29 f30 (f27 f28 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f29 f30 (f27 f28 ?v0)) 0))))
(check-sat)
(exit)
