(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2) S1)
(declare-fun f4 (S3 S2) S2)
(declare-fun f5 (S4 S2) S3)
(declare-fun f6 () S4)
(declare-fun f7 () S3)
(declare-fun f8 () S2)
(declare-fun f9 (S5 S6) S2)
(declare-fun f10 () S5)
(declare-fun f11 () S6)
(declare-fun f12 (S7 S2) S5)
(declare-fun f13 (S8 S2) S7)
(declare-fun f14 () S8)
(declare-fun f15 (S9 S6) Int)
(declare-fun f16 () S9)
(declare-fun f17 (S10 Int) S6)
(declare-fun f18 () S10)
(declare-fun f19 (S12 S11) S2)
(declare-fun f20 (S13 S2) S12)
(declare-fun f21 (S14 S4) S13)
(declare-fun f22 () S14)
(declare-fun f23 (S2 S2) S1)
(declare-fun f24 (S15 S2) S6)
(declare-fun f25 () S15)
(declare-fun f26 () S7)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 f6 (f4 f7 f8)) (f9 f10 f11))) f1)))
(assert (= (f3 f8) f1))
(assert (= (f3 (f4 (f5 f6 f8) (f9 f10 f11))) f1))
(assert (forall ((?v0 S6)) (= (f3 (f9 f10 ?v0)) f1)))
(assert (forall ((?v0 S2)) (=> (= (f3 ?v0) f1) (= (f3 (f4 f7 ?v0)) f1))))
(assert (forall ((?v0 S2) (?v1 S6)) (not (= (f4 f7 ?v0) (f9 f10 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S2)) (not (= (f9 f10 ?v0) (f4 f7 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f4 f7 ?v0) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f4 (f5 f6 ?v0) ?v1) (f4 f7 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S2) (?v2 S2)) (not (= (f9 f10 ?v0) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S6)) (not (= (f4 (f5 f6 ?v0) ?v1) (f9 f10 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 f7 ?v0) (f4 f7 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f9 f10 ?v0) (f9 f10 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (= (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (=> (= (f3 ?v0) f1) (= (f3 (f9 (f12 (f13 f14 ?v0) (f9 f10 ?v1)) ?v2)) f1))))
(assert (forall ((?v0 S2)) (=> (forall ((?v1 S6)) (=> (= ?v0 (f9 f10 ?v1)) false)) (=> (forall ((?v1 S2) (?v2 S2)) (=> (= ?v0 (f4 (f5 f6 ?v1) ?v2)) false)) (=> (forall ((?v1 S2)) (=> (= ?v0 (f4 f7 ?v1)) false)) false)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S6)) (= (f9 (f12 (f13 f14 (f4 (f5 f6 ?v0) ?v1)) ?v2) ?v3) (f4 (f5 f6 (f9 (f12 (f13 f14 ?v0) ?v2) ?v3)) (f9 (f12 (f13 f14 ?v1) ?v2) ?v3)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f15 f16 ?v1))) (=> (< (f15 f16 ?v0) ?v_0) (= (f9 (f12 (f13 f14 (f9 f10 ?v1)) ?v2) ?v0) (f9 f10 (f17 f18 (- ?v_0 1))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f9 f10 ?v0))) (=> (< (f15 f16 ?v0) (f15 f16 ?v1)) (= (f9 (f12 (f13 f14 ?v_0) ?v2) ?v1) ?v_0)))))
(assert (forall ((?v0 S6) (?v1 S2) (?v2 S6)) (let ((?v_1 (f9 f10 ?v0)) (?v_0 (f15 f16 ?v0))) (= (f9 (f12 (f13 f14 ?v_1) ?v1) ?v2) (ite (< (f15 f16 ?v2) ?v_0) (f9 f10 (f17 f18 (- ?v_0 1))) (ite (= ?v0 ?v2) ?v1 ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S2)) (= (f9 (f12 (f13 f14 (f9 f10 ?v0)) ?v1) ?v0) ?v1)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S11)) (let ((?v_0 (f21 f22 f6))) (=> (= (f3 (f19 (f20 ?v_0 (f9 (f12 (f13 f14 ?v0) ?v1) (f17 f18 0))) ?v2)) f1) (=> (= (f3 ?v1) f1) (= (f3 (f19 (f20 ?v_0 (f4 (f5 f6 (f4 f7 ?v0)) ?v1)) ?v2)) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f23 (f4 (f5 f6 (f4 f7 ?v0)) ?v1) (f9 (f12 (f13 f14 ?v0) ?v1) (f17 f18 0))) f1)))
(assert (forall ((?v0 S2)) (= (f24 f25 (f4 f7 ?v0)) (f17 f18 (+ (f15 f16 (f24 f25 ?v0)) (+ 0 1))))))
(assert (forall ((?v0 S6)) (= (f24 f25 (f9 f10 ?v0)) (f17 f18 0))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S6)) (= (f9 (f12 (f13 f14 (f4 f7 ?v0)) ?v1) ?v2) (f4 f7 (f9 (f12 (f13 f14 ?v0) (f9 (f12 f26 ?v1) (f17 f18 0))) (f17 f18 (+ (f15 f16 ?v2) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f24 f25 (f4 (f5 f6 ?v0) ?v1)) (f17 f18 (+ (+ (f15 f16 (f24 f25 ?v0)) (f15 f16 (f24 f25 ?v1))) (+ 0 1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f23 ?v0 ?v1) f1) (= (f23 (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v2))) (=> (= (f23 ?v0 ?v1) f1) (= (f23 (f4 ?v_0 ?v0) (f4 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S6) (?v1 S2)) (=> (= (f23 (f9 f10 ?v0) ?v1) f1) false)))
(assert (forall ((?v0 S6)) (= (f17 f18 (f15 f16 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f15 f16 (f17 f18 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f15 f16 (f17 f18 ?v0)) 0))))
(check-sat)
(exit)
