(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 () S3)
(declare-fun f5 (S4 S5) S2)
(declare-fun f6 (S6 S2) S4)
(declare-fun f7 (S7 S2) S6)
(declare-fun f8 () S7)
(declare-fun f9 () S2)
(declare-fun f10 () S5)
(declare-fun f11 () S3)
(declare-fun f12 () S6)
(declare-fun f13 (S8 Int) S5)
(declare-fun f14 () S8)
(declare-fun f15 (S9 S5) S3)
(declare-fun f16 () S9)
(declare-fun f17 (S10 S2) S9)
(declare-fun f18 () S10)
(declare-fun f19 (S11 S2) S1)
(declare-fun f20 (S12 S11) S11)
(declare-fun f21 (S11) S12)
(declare-fun f22 () S11)
(declare-fun f23 (S13 S14) S2)
(declare-fun f24 (S15 S2) S13)
(declare-fun f25 (S16 S17) S15)
(declare-fun f26 () S16)
(declare-fun f27 () S17)
(declare-fun f28 () S2)
(declare-fun f29 (S18 S5) Int)
(declare-fun f30 () S18)
(declare-fun f31 () S2)
(declare-fun f32 (S19 S14) S14)
(declare-fun f33 (S20 S3) S19)
(declare-fun f34 () S20)
(declare-fun f35 () S14)
(declare-fun f36 () S2)
(declare-fun f37 () S2)
(declare-fun f38 (S17 S2) S3)
(declare-fun f39 (S2) S11)
(declare-fun f40 () S3)
(declare-fun f41 (S11 S14) S1)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 f4 ?v0) (f5 (f6 (f7 f8 ?v0) f9) f10))))
(assert (forall ((?v0 S2)) (= (f3 f11 ?v0) (f5 (f6 f12 ?v0) (f13 f14 0)))))
(assert (forall ((?v0 S5) (?v1 S2)) (= (f3 (f15 f16 ?v0) ?v1) (f5 (f6 f12 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S2)) (= (f3 (f15 (f17 f18 ?v0) ?v1) ?v2) (f5 (f6 (f7 f8 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S2)) (= (= (f19 (f20 (f21 ?v0) ?v1) ?v2) f1) (and (= (f19 ?v0 ?v2) f1) (= (f19 ?v1 ?v2) f1)))))
(assert (let ((?v_0 (f13 f14 0))) (not (= (f19 f22 (f23 (f24 (f25 f26 f27) (f5 (f6 (f7 f8 (f5 (f6 (f7 f8 f28) (f5 (f6 f12 f9) ?v_0)) (f13 f14 (+ (f29 f30 f10) 1)))) (f5 (f6 (f7 f8 f31) f9) f10)) ?v_0)) (f32 (f33 f34 f4) f35))) f1))))
(assert (= (f19 f22 (f5 (f6 (f7 f8 (f23 (f24 (f25 f26 f27) (f5 (f6 (f7 f8 f28) f31) (f13 f14 0))) f35)) f9) f10)) f1))
(assert (= (f19 f22 f36) f1))
(assert (= (f19 f22 f37) f1))
(assert (= (f19 f22 f31) f1))
(assert (= (f19 f22 f9) f1))
(assert (= (f19 f22 (f23 (f24 (f25 f26 f27) (f5 (f6 (f7 f8 f28) f31) (f13 f14 0))) f35)) f1))
(assert (= (f19 f22 (f5 (f6 (f7 f8 (f23 (f24 (f25 f26 f27) (f5 (f6 (f7 f8 f28) f31) (f13 f14 0))) f35)) f9) f10)) f1))
(assert (forall ((?v0 S2) (?v1 S5)) (=> (= (f19 f22 ?v0) f1) (= (f19 f22 (f5 (f6 f12 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S14) (?v2 S5)) (let ((?v_0 (f25 f26 f27))) (= (f5 (f6 f12 (f23 (f24 ?v_0 ?v0) ?v1)) ?v2) (f23 (f24 ?v_0 (f5 (f6 f12 ?v0) ?v2)) (f32 (f33 f34 (f15 f16 ?v2)) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S14) (?v2 S2) (?v3 S5)) (let ((?v_0 (f25 f26 f27))) (= (f5 (f6 (f7 f8 (f23 (f24 ?v_0 ?v0) ?v1)) ?v2) ?v3) (f23 (f24 ?v_0 (f5 (f6 (f7 f8 ?v0) ?v2) ?v3)) (f32 (f33 f34 (f15 (f17 f18 ?v2) ?v3)) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S2)) (= (f5 (f6 (f7 f8 (f5 (f6 f12 ?v0) ?v1)) ?v2) ?v1) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S2) (?v3 S2)) (let ((?v_0 (+ (f29 f30 ?v1) 1))) (=> (< (f29 f30 ?v0) ?v_0) (= (f5 (f6 f12 (f5 (f6 (f7 f8 ?v2) ?v3) ?v1)) ?v0) (f5 (f6 (f7 f8 (f5 (f6 f12 ?v2) ?v0)) (f5 (f6 f12 ?v3) ?v0)) (f13 f14 ?v_0)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S2) (?v3 S2)) (let ((?v_0 (+ (f29 f30 ?v1) 1))) (=> (< (f29 f30 ?v0) ?v_0) (= (f5 (f6 f12 (f5 (f6 (f7 f8 ?v2) ?v3) ?v0)) ?v1) (f5 (f6 (f7 f8 (f5 (f6 f12 ?v2) (f13 f14 ?v_0))) (f5 (f6 f12 ?v3) ?v1)) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (+ (f29 f30 ?v1) 1)) (?v_1 (f7 f8 ?v2))) (=> (< (f29 f30 ?v0) ?v_0) (= (f5 (f6 (f7 f8 (f5 (f6 ?v_1 (f5 (f6 f12 ?v3) ?v0)) (f13 f14 ?v_0))) (f5 (f6 (f7 f8 ?v4) ?v3) ?v1)) ?v0) (f5 (f6 (f7 f8 (f5 (f6 ?v_1 ?v4) ?v0)) ?v3) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S5)) (= (f5 (f6 f12 (f3 (f38 f27 ?v0) ?v1)) ?v2) (f3 (f38 f27 (f5 (f6 f12 ?v0) ?v2)) (f5 (f6 f12 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S5)) (= (f5 (f6 (f7 f8 (f3 (f38 f27 ?v0) ?v1)) ?v2) ?v3) (f3 (f38 f27 (f5 (f6 (f7 f8 ?v0) ?v2) ?v3)) (f5 (f6 (f7 f8 ?v1) ?v2) ?v3)))))
(assert (forall ((?v0 S2) (?v1 S14) (?v2 S2)) (let ((?v_0 (f25 f26 f27))) (= (= (f23 (f24 ?v_0 ?v0) ?v1) (f23 (f24 ?v_0 ?v2) ?v1)) (= ?v0 ?v2)))))
(assert (let ((?v_0 (f25 f26 f27))) (= (f19 (f39 (f23 (f24 ?v_0 (f3 (f38 f27 (f3 f40 f28)) f31)) f35)) (f23 (f24 ?v_0 (f5 (f6 (f7 f8 f28) f31) (f13 f14 0))) f35)) f1)))
(assert (forall ((?v0 S14)) (=> (= (f41 f22 ?v0) f1) (= (f41 f22 (f32 (f33 f34 f11) ?v0)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f38 f27 ?v2))) (=> (= (f19 (f39 ?v0) ?v1) f1) (= (f19 (f39 (f3 ?v_0 ?v0)) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f19 (f39 ?v0) ?v1) f1) (= (f19 (f39 (f3 (f38 f27 ?v0) ?v2)) (f3 (f38 f27 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f19 (f39 ?v0) ?v1) f1) (= (f19 (f39 (f3 f40 ?v0)) (f3 f40 ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f19 (f39 (f3 (f38 f27 (f3 f40 ?v0)) ?v1)) (f5 (f6 (f7 f8 ?v0) ?v1) (f13 f14 0))) f1)))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S14)) (= (= (f41 (f20 (f21 ?v0) ?v1) ?v2) f1) (and (= (f41 ?v0 ?v2) f1) (= (f41 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 f40 ?v0) (f3 f40 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f3 (f38 f27 ?v0) ?v1) (f3 f40 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f3 f40 ?v0) (f3 (f38 f27 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S5)) (=> (= (f19 (f39 ?v0) ?v1) f1) (= (f19 (f39 (f5 (f6 (f7 f8 ?v0) ?v2) ?v3)) (f5 (f6 (f7 f8 ?v1) ?v2) ?v3)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S5)) (=> (= (f19 (f39 ?v0) ?v1) f1) (= (f19 (f39 (f5 (f6 f12 ?v0) ?v2)) (f5 (f6 f12 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S5)) (= (f5 (f6 f12 (f3 f40 ?v0)) ?v1) (f3 f40 (f5 (f6 f12 ?v0) (f13 f14 (+ (f29 f30 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S14) (?v2 S2) (?v3 S14)) (let ((?v_0 (f25 f26 f27))) (= (= (f23 (f24 ?v_0 (f3 f40 ?v0)) ?v1) (f23 (f24 ?v_0 (f3 f40 ?v2)) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S5)) (= (f5 (f6 (f7 f8 (f3 f40 ?v0)) ?v1) ?v2) (f3 f40 (f5 (f6 (f7 f8 ?v0) (f5 (f6 f12 ?v1) (f13 f14 0))) (f13 f14 (+ (f29 f30 ?v2) 1)))))))
(assert (forall ((?v0 S5)) (= (f13 f14 (f29 f30 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f29 f30 (f13 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f29 f30 (f13 f14 ?v0)) 0))))
(check-sat)
(exit)
