(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2) S1)
(declare-fun f4 () S2)
(declare-fun f5 (S3 S2 S4) S1)
(declare-fun f6 () S3)
(declare-fun f7 () S4)
(declare-fun f8 (S6 S5) S2)
(declare-fun f9 (S7 S2) S6)
(declare-fun f10 () S7)
(declare-fun f11 () S6)
(declare-fun f12 (S8 S2) S2)
(declare-fun f13 () S8)
(declare-fun f14 (S9 S2) S7)
(declare-fun f15 () S9)
(declare-fun f16 (S10 S4) S3)
(declare-fun f17 (S11 S5) S10)
(declare-fun f18 (S12 S3) S11)
(declare-fun f19 () S12)
(declare-fun f20 (S13 S2) S8)
(declare-fun f21 () S13)
(declare-fun f22 (S3 S5) S4)
(declare-fun f23 (S14 Int) S5)
(declare-fun f24 () S14)
(declare-fun f25 (S15 S5) Int)
(declare-fun f26 () S15)
(assert (not (= f1 f2)))
(assert (not (= (f3 f4) f1)))
(assert (= (f5 f6 f4 f7) f1))
(assert (= (f5 f6 f4 f7) f1))
(assert (forall ((?v0 S2) (?v1 S5)) (=> (= (f3 ?v0) f1) (= (f3 (f8 (f9 f10 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S5)) (= (f3 (f8 f11 ?v0)) f1)))
(assert (forall ((?v0 S2)) (=> (= (f3 ?v0) f1) (= (f3 (f12 f13 ?v0)) f1))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5)) (=> (= (f3 ?v0) f1) (= (f3 (f8 (f9 (f14 f15 ?v0) (f8 f11 ?v1)) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S5) (?v3 S4) (?v4 S4) (?v5 S2)) (=> (= (f3 ?v0) f1) (=> (= (f5 (f16 (f17 (f18 f19 ?v1) ?v2) ?v3) ?v0 ?v4) f1) (=> (= (f3 ?v5) f1) (=> (= (f5 ?v1 ?v5 ?v3) f1) (= (f3 (f8 (f9 (f14 f15 ?v0) ?v5) ?v2)) f1)))))))
(assert (forall ((?v0 S2) (?v1 S5)) (=> (= (f3 ?v0) f1) (= (f3 (f12 (f20 f21 ?v0) (f8 f11 ?v1))) f1))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S4) (?v3 S5) (?v4 S4)) (=> (= (f5 ?v0 ?v1 ?v2) f1) (= (f5 (f16 (f17 (f18 f19 ?v0) ?v3) ?v4) (f8 (f9 f10 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 S5) (?v2 S4)) (=> (= (f22 ?v0 ?v1) ?v2) (= (f5 ?v0 (f8 f11 ?v1) ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 S5) (?v2 S4)) (=> (= (f5 ?v0 (f8 f11 ?v1) ?v2) f1) (=> (=> (= (f22 ?v0 ?v1) ?v2) false) false))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S4) (?v3 S3) (?v4 S2) (?v5 S4) (?v6 S5)) (=> (= (f5 ?v0 ?v1 ?v2) f1) (=> (= (f5 ?v3 ?v4 ?v5) f1) (=> (= ?v0 (f16 (f17 (f18 f19 ?v3) ?v6) ?v5)) (= (f5 ?v3 (f8 (f9 (f14 f15 ?v1) ?v4) ?v6) ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S5)) (= (f8 (f9 (f14 f15 (f12 f13 ?v0)) ?v1) ?v2) (f12 f13 (f8 (f9 (f14 f15 ?v0) (f8 (f9 f10 ?v1) (f23 f24 0))) (f23 f24 (+ (f25 f26 ?v2) 1)))))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S2)) (= (f8 (f9 (f14 f15 (f8 (f9 f10 ?v0) ?v1)) ?v2) ?v1) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S2) (?v3 S2)) (let ((?v_0 (+ (f25 f26 ?v1) 1))) (=> (< (f25 f26 ?v0) ?v_0) (= (f8 (f9 f10 (f8 (f9 (f14 f15 ?v2) ?v3) ?v1)) ?v0) (f8 (f9 (f14 f15 (f8 (f9 f10 ?v2) ?v0)) (f8 (f9 f10 ?v3) ?v0)) (f23 f24 ?v_0)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S2) (?v3 S2)) (let ((?v_0 (+ (f25 f26 ?v1) 1))) (=> (< (f25 f26 ?v0) ?v_0) (= (f8 (f9 f10 (f8 (f9 (f14 f15 ?v2) ?v3) ?v0)) ?v1) (f8 (f9 (f14 f15 (f8 (f9 f10 ?v2) (f23 f24 ?v_0))) (f8 (f9 f10 ?v3) ?v1)) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (+ (f25 f26 ?v1) 1)) (?v_1 (f14 f15 ?v2))) (=> (< (f25 f26 ?v0) ?v_0) (= (f8 (f9 (f14 f15 (f8 (f9 ?v_1 (f8 (f9 f10 ?v3) ?v0)) (f23 f24 ?v_0))) (f8 (f9 (f14 f15 ?v4) ?v3) ?v1)) ?v0) (f8 (f9 (f14 f15 (f8 (f9 ?v_1 ?v4) ?v0)) ?v3) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S5)) (= (f8 (f9 f10 (f12 f13 ?v0)) ?v1) (f12 f13 (f8 (f9 f10 ?v0) (f23 f24 (+ (f25 f26 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f8 f11 ?v0)) (?v_1 (f25 f26 ?v0))) (= (f8 (f9 f10 ?v_0) ?v1) (ite (< ?v_1 (f25 f26 ?v1)) ?v_0 (f8 f11 (f23 f24 (+ ?v_1 1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (= (f12 (f20 f21 ?v0) ?v1) (f12 (f20 f21 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f8 f11 ?v0) (f8 f11 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f12 f13 ?v0) (f12 f13 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S2)) (let ((?v_0 (+ (f25 f26 ?v1) 1)) (?v_1 (f9 f10 ?v2))) (=> (< (f25 f26 ?v0) ?v_0) (= (f8 (f9 f10 (f8 ?v_1 ?v0)) (f23 f24 ?v_0)) (f8 (f9 f10 (f8 ?v_1 ?v1)) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S3) (?v3 S4)) (let ((?v_0 (f25 f26 ?v1))) (=> (< (f25 f26 ?v0) ?v_0) (= (f22 (f16 (f17 (f18 f19 ?v2) ?v0) ?v3) ?v1) (f22 ?v2 (f23 f24 (- ?v_0 1))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S3) (?v3 S4)) (=> (< (f25 f26 ?v0) (f25 f26 ?v1)) (= (f22 (f16 (f17 (f18 f19 ?v2) ?v1) ?v3) ?v0) (f22 ?v2 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S3) (?v3 S4)) (=> (= ?v0 ?v1) (= (f22 (f16 (f17 (f18 f19 ?v2) ?v0) ?v3) ?v1) ?v3))))
(assert (forall ((?v0 S3) (?v1 S5) (?v2 S4) (?v3 S4)) (let ((?v_1 (f23 f24 0)) (?v_0 (f18 f19 ?v0))) (= (f16 (f17 (f18 f19 (f16 (f17 ?v_0 ?v1) ?v2)) ?v_1) ?v3) (f16 (f17 (f18 f19 (f16 (f17 ?v_0 ?v_1) ?v3)) (f23 f24 (+ (f25 f26 ?v1) 1))) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S5) (?v2 S4) (?v3 S5)) (let ((?v_0 (f25 f26 ?v3))) (= (f22 (f16 (f17 (f18 f19 ?v0) ?v1) ?v2) ?v3) (ite (< ?v_0 (f25 f26 ?v1)) (f22 ?v0 ?v3) (ite (= ?v3 ?v1) ?v2 (f22 ?v0 (f23 f24 (- ?v_0 1)))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S5)) (not (= (f12 (f20 f21 ?v0) ?v1) (f8 f11 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S2) (?v2 S2)) (not (= (f8 f11 ?v0) (f12 (f20 f21 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f12 (f20 f21 ?v0) ?v1) (f12 f13 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f12 f13 ?v0) (f12 (f20 f21 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S5)) (= (f8 (f9 (f14 f15 (f12 (f20 f21 ?v0) ?v1)) ?v2) ?v3) (f12 (f20 f21 (f8 (f9 (f14 f15 ?v0) ?v2) ?v3)) (f8 (f9 (f14 f15 ?v1) ?v2) ?v3)))))
(assert (forall ((?v0 S5)) (= (f23 f24 (f25 f26 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f25 f26 (f23 f24 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f25 f26 (f23 f24 ?v0)) 0))))
(check-sat)
(exit)
