(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int) S1)
(declare-fun f4 (S2 Int) Int)
(declare-fun f5 (S3 Int) S2)
(declare-fun f6 () S3)
(declare-fun f7 () Int)
(declare-fun f8 () Int)
(declare-fun f9 (S5 S4) Int)
(declare-fun f10 () S5)
(declare-fun f11 (S6 Int) S1)
(declare-fun f12 () S2)
(declare-fun f13 (S7 Int) S4)
(declare-fun f14 () S7)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 f6 f7) f8)) f1)))
(assert (= (f3 f7) f1))
(assert (= (f3 f8) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (+ ?v1 ?v2)) (+ (f4 ?v_0 ?v1) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (- ?v1 ?v2)) (- (f4 ?v_0 ?v1) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 (f5 f6 (- ?v0)) ?v1) (- (f4 (f5 f6 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f4 (f5 f6 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f4 (f5 f6 (+ ?v0 ?v1)) ?v2) (+ (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f4 (f5 f6 (- ?v0 ?v1)) ?v2) (- (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f5 f6 ?v1))) (= (+ (f4 (f5 f6 (- ?v0 (f4 ?v_0 ?v2))) ?v3) (f4 (f5 f6 (- ?v4 (f4 ?v_0 ?v5))) ?v6)) (- (+ (f4 (f5 f6 ?v0) ?v3) (f4 (f5 f6 ?v4) ?v6)) (f4 ?v_0 (+ (f4 (f5 f6 ?v2) ?v3) (f4 (f5 f6 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f4 (f5 f6 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f4 (f5 f6 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f4 (f5 f6 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f4 (f5 f6 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4)) (let ((?v_0 (f9 f10 ?v2))) (let ((?v_1 (f5 f6 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f4 ?v_1 ?v0) (f4 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f4 ?v_0 ?v0) (f4 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int)) (=> (< 0 ?v0) (=> (forall ((?v3 Int)) (=> (= (f11 ?v1 ?v3) f1) (= (f11 ?v1 (- ?v3 ?v0)) f1))) (=> (<= 0 ?v2) (forall ((?v3 Int)) (=> (= (f11 ?v1 ?v3) f1) (= (f11 ?v1 (- ?v3 (f4 (f5 f6 ?v2) ?v0))) f1))))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int)) (=> (< 0 ?v0) (=> (forall ((?v3 Int)) (=> (= (f11 ?v1 ?v3) f1) (= (f11 ?v1 (+ ?v3 ?v0)) f1))) (=> (<= 0 ?v2) (forall ((?v3 Int)) (=> (= (f11 ?v1 ?v3) f1) (= (f11 ?v1 (+ ?v3 (f4 (f5 f6 ?v2) ?v0))) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f4 (f5 f6 ?v3) ?v4) ?v5))) (=> (= (+ (f4 (f5 f6 ?v0) ?v1) ?v2) ?v_0) (=> (< ?v_0 0) (=> (< ?v2 ?v0) (=> (<= 0 ?v5) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v4 ?v1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f5 f6 ?v0))) (=> (<= (+ (f4 ?v_0 ?v1) ?v2) (+ (f4 ?v_0 ?v3) ?v4)) (=> (<= ?v4 0) (=> (< ?v0 ?v4) (=> (< ?v0 ?v2) (<= ?v3 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f4 (f5 f6 ?v3) ?v4) ?v5))) (=> (= (+ (f4 (f5 f6 ?v0) ?v1) ?v2) ?v_0) (=> (<= 0 ?v_0) (=> (< ?v5 ?v3) (=> (<= 0 ?v2) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v1 ?v4))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f5 f6 ?v0))) (=> (<= (+ (f4 ?v_0 ?v1) ?v2) (+ (f4 ?v_0 ?v3) ?v4)) (=> (<= 0 ?v2) (=> (< ?v2 ?v0) (=> (< ?v4 ?v0) (<= ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ (f4 (f5 f6 ?v0) ?v1) ?v2) 0) (=> (<= 0 ?v2) (=> (< 0 ?v0) (<= ?v1 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 (+ (f4 (f5 f6 ?v0) ?v1) ?v2)) (=> (< ?v2 ?v0) (=> (< 0 ?v0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f4 (f5 f6 ?v0) ?v2))) (=> (< ?v1 ?v0) (<= 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f4 (f5 f6 ?v0) ?v2))) (=> (<= 0 ?v1) (<= ?v2 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f4 (f5 f6 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (let ((?v_1 (f4 (f5 f6 ?v2) ?v0))) (let ((?v_0 (- ?v1 ?v_1))) (<= (ite (< ?v_0 0) (* (- 2) ?v_0) (- (* 2 ?v1) (* 2 ?v_1))) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f4 (f5 f6 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 f12 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f6 (f4 f12 ?v0)) (f4 f12 ?v1)))))
(assert (forall ((?v0 S4)) (= (f13 f14 (f9 f10 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f9 f10 (f13 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f9 f10 (f13 f14 ?v0)) 0))))
(check-sat)
(exit)
