(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 Int) Int)
(declare-fun f9 (S7 Int) S6)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S2) Int)
(declare-fun f12 () S8)
(declare-fun f13 (S9 Int) S1)
(declare-fun f14 () S9)
(declare-fun f15 (S10 S9) S1)
(declare-fun f16 () S10)
(declare-fun f17 () Int)
(declare-fun f18 () S9)
(declare-fun f19 () S5)
(declare-fun f20 () S7)
(declare-fun f21 (S11 Int) S10)
(declare-fun f22 () S11)
(declare-fun f23 (S12 Int) S9)
(declare-fun f24 (S13 Int) S12)
(declare-fun f25 () S13)
(declare-fun f26 () S12)
(declare-fun f27 () S10)
(declare-fun f28 (S14 S2) S1)
(declare-fun f29 () S14)
(declare-fun f30 () S13)
(declare-fun f31 (S15 S9) S2)
(declare-fun f32 () S15)
(declare-fun f33 () S12)
(declare-fun f34 () S12)
(declare-fun f35 (S16 S9) S12)
(declare-fun f36 () S9)
(declare-fun f37 () S9)
(declare-fun f38 () S6)
(declare-fun f39 (S17 S9) S9)
(declare-fun f40 () S17)
(declare-fun f41 (S18 S10) S1)
(declare-fun f42 (S19 S9) S18)
(declare-fun f43 () S19)
(declare-fun f44 () S11)
(declare-fun f45 () S18)
(declare-fun f46 () S10)
(declare-fun f47 (S20 S10) S2)
(declare-fun f48 () S20)
(declare-fun f49 (S21 S10) S10)
(declare-fun f50 () S21)
(declare-fun f51 () S17)
(declare-fun f52 (S22 S9) S7)
(declare-fun f53 () S22)
(declare-fun f54 () S1)
(declare-fun f55 (S23 S2) S14)
(declare-fun f56 () S23)
(declare-fun f57 () S4)
(declare-fun f58 () S6)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))))))
(assert (forall ((?v0 Int)) (= (= (f13 f14 ?v0) f1) false)))
(assert (forall ((?v0 S9)) (= (= (f15 f16 ?v0) f1) false)))
(assert (not (<= (+ (* 4 f17) 1) 1)))
(assert (<= f17 0))
(assert (<= f17 0))
(assert (not (<= 1 f17)))
(assert (= (f13 f18 (+ (* 4 f17) 1)) f1))
(assert (= (f13 f18 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f13 f18 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int)) (=> (= (f13 f18 ?v0) f1) (= (f6 f19 ?v0) (f6 f7 (- ?v0 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 f18 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= ?v1 (f8 (f9 f20 ?v0) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 f18 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f8 (f9 f20 ?v0) ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 f18 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f8 (f9 f20 ?v0) ?v1) 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f13 f18 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (not (= (f8 (f9 f20 ?v0) ?v1) ?v_0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 f18 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (< 1 (f8 (f9 f20 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f13 f18 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (< (f8 (f9 f20 ?v0) ?v1) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f20 ?v0))) (=> (= (f13 f18 ?v0) f1) (=> (<= 5 ?v0) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f8 ?v_0 (f8 ?v_0 ?v1)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f13 f18 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (< 1 ?v2) (=> (<= ?v2 ?v1) (= (f15 (f21 f22 ?v2) (f23 (f24 f25 ?v1) ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f13 f18 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (= (f15 (f21 f22 ?v2) (f23 (f24 f25 ?v1) ?v0)) f1) (< 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f21 f22 ?v1))) (=> (< 1 ?v0) (=> (= (f15 ?v_0 (f23 (f24 f25 (- ?v0 1)) ?v2)) f1) (= (f15 ?v_0 (f23 (f24 f25 ?v0) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f21 f22 ?v1))) (=> (< 1 ?v0) (=> (not (= (f15 ?v_0 (f23 (f24 f25 (- ?v0 1)) ?v2)) f1)) (=> (= (f15 ?v_0 (f23 (f24 f25 ?v0) ?v2)) f1) (or (= ?v1 ?v0) (= ?v1 (f8 (f9 f20 ?v2) ?v0)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (= (f15 (f21 f22 ?v0) (f23 (f24 f25 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 (f24 f25 ?v1) ?v0))) (=> (= (f13 f18 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 (- ?v0 1)) (=> (= (f15 (f21 f22 ?v2) ?v_0) f1) (= (f15 (f21 f22 (f8 (f9 f20 ?v0) ?v2)) ?v_0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1)) (?v_1 (f23 (f24 f25 ?v1) ?v0))) (=> (= (f13 f18 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 ?v_0) (=> (< 1 ?v2) (=> (< ?v2 ?v_0) (=> (= (f15 (f21 f22 (f8 (f9 f20 ?v0) ?v2)) ?v_1) f1) (= (f15 (f21 f22 ?v2) ?v_1) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f13 f18 ?v0) f1) (=> (< ?v1 ?v_0) (=> (= (f15 (f21 f22 ?v2) (f23 (f24 f25 ?v1) ?v0)) f1) (< ?v2 ?v_0)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (- ?v0 2))) (=> (= (f13 f18 ?v0) f1) (= (f23 f26 ?v_0) (f23 (f24 f25 ?v_0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 f27 (f23 (f24 f25 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S2)) (=> (= (f28 f29 ?v0) f1) (= (f13 f18 (f11 f12 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 f18 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f13 (f23 (f24 f30 (f8 (f9 f10 ?v1) (f8 (f9 f20 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int)) (= (f6 f19 ?v0) (f31 f32 (f23 f33 ?v0)))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f13 f18 ?v1) f1) (= (f13 (f23 f34 ?v1) ?v0) f1))))))
(assert (forall ((?v0 S16) (?v1 Int) (?v2 Int)) (=> (forall ((?v3 Int) (?v4 Int)) (= (f13 (f23 (f35 ?v0 f36) ?v3) ?v4) f1)) (=> (forall ((?v3 Int) (?v4 Int)) (let ((?v_0 (- ?v3 1))) (=> (< 1 ?v3) (=> (= (f13 (f23 (f35 ?v0 (f23 (f24 f25 ?v_0) ?v4)) ?v_0) ?v4) f1) (= (f13 (f23 (f35 ?v0 (f23 (f24 f25 ?v3) ?v4)) ?v3) ?v4) f1))))) (= (f13 (f23 (f35 ?v0 (f23 (f24 f25 ?v1) ?v2)) ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f13 f18 ?v0) f1) (= (= (f15 (f21 f22 ?v0) f37) f1) (< 2 ?v0)))))
(assert (forall ((?v0 Int)) (=> (= (f13 f18 ?v0) f1) (= (f13 (f23 (f24 f30 (f8 f38 (- ?v0 1))) (- 1)) ?v0) f1))))
(assert (forall ((?v0 S9) (?v1 Int)) (= (= (f13 (f39 f40 ?v0) ?v1) f1) (and (= (f41 (f42 f43 ?v0) (f21 f44 ?v1)) f1) (= (f31 f32 ?v0) (f6 f19 ?v1))))))
(assert (forall ((?v0 S9) (?v1 Int)) (=> (= (f41 (f42 f43 ?v0) (f21 f44 ?v1)) f1) (= (f15 f27 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 Int) (?v3 Int)) (=> (< 1 ?v0) (=> (= (f13 (f39 f40 ?v1) ?v0) f1) (=> (= (f13 (f23 (f24 f30 ?v2) ?v3) ?v0) f1) (=> (= (f15 (f21 f22 ?v2) ?v1) f1) (=> (= (f15 (f21 f22 ?v3) ?v1) f1) (= ?v2 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f8 (f9 f10 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f13 (f23 (f24 f30 (f8 (f9 f10 ?v0) ?v_0)) 1) ?v1) f1) (= (f13 (f23 (f24 f30 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int)) (= (f41 (f42 f43 f36) (f21 f44 ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 (f21 f22 ?v0) f37) f1) (=> (= (f15 (f21 f22 ?v1) f37) f1) (= (f15 (f21 f22 (f8 (f9 f10 ?v0) ?v1)) f37) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 (+ (* 2 ?v1) 1)) (= (f15 (f21 f22 ?v0) f37) f1))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f13 (f23 (f24 f30 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 (f21 f22 (f8 (f9 f10 ?v0) ?v1)) f37) f1) (= (f15 (f21 f22 ?v0) f37) f1))))
(assert (= (f15 f27 f36) f1))
(assert (= (f41 f45 f46) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f34 ?v1))) (=> (<= 0 ?v0) (=> (= (f13 f18 ?v1) f1) (=> (= (f13 ?v_0 (f8 (f9 f10 ?v0) ?v2)) f1) (or (= (f13 ?v_0 ?v0) f1) (= (f13 ?v_0 ?v2) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f34 ?v0))) (=> (= (f13 f18 ?v0) f1) (=> (= (f13 ?v_0 (f8 (f9 f10 ?v1) ?v2)) f1) (or (= (f13 ?v_0 ?v1) f1) (= (f13 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f24 f30 ?v1))) (=> (= (f13 f18 ?v0) f1) (=> (< 0 ?v1) (=> (= (f13 (f23 (f24 f30 (f8 (f9 f10 ?v1) ?v1)) 1) ?v0) f1) (or (= (f13 (f23 ?v_0 1) ?v0) f1) (= (f13 (f23 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f13 f18 ?v0) f1) (=> (< 0 ?v1) (=> (= (f13 (f23 (f24 f30 (f8 (f9 f10 ?v1) ?v2)) 0) ?v0) f1) (or (= (f13 (f23 (f24 f30 ?v1) 0) ?v0) f1) (= (f13 (f23 (f24 f30 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f13 f18 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f13 (f23 (f24 f30 ?v1) 0) ?v0) f1)) (not (= (f13 (f23 (f24 f30 ?v2) 0) ?v0) f1))) (not (= (f13 (f23 (f24 f30 (f8 (f9 f10 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 f18 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f13 (f23 (f24 f30 (f8 (f9 f10 ?v1) ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f13 f18 ?v0) f1) (=> (not (= (f13 (f23 (f24 f30 ?v1) 0) ?v0) f1)) (=> (not (= (f13 (f23 (f24 f30 ?v2) 0) ?v0) f1)) (not (= (f13 (f23 (f24 f30 (f8 (f9 f10 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 S9)) (= (< 0 (f11 f12 (f31 f32 ?v0))) (and (not (= ?v0 f36)) (= (f15 f27 ?v0) f1)))))
(assert (forall ((?v0 S10)) (= (< 0 (f11 f12 (f47 f48 ?v0))) (and (not (= ?v0 f46)) (= (f41 f45 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f9 f10 ?v1))) (= (+ (f8 (f9 f10 (- ?v0 (f8 ?v_0 ?v2))) ?v3) (f8 (f9 f10 (- ?v4 (f8 ?v_0 ?v5))) ?v6)) (- (+ (f8 (f9 f10 ?v0) ?v3) (f8 (f9 f10 ?v4) ?v6)) (f8 ?v_0 (+ (f8 (f9 f10 ?v2) ?v3) (f8 (f9 f10 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f13 (f23 (f24 f30 ?v0) ?v1) ?v2) f1) (=> (= (f13 (f23 (f24 f30 ?v3) ?v4) ?v2) f1) (= (f13 (f23 (f24 f30 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f13 (f23 (f24 f30 ?v0) ?v1) ?v2) f1) (=> (= (f13 (f23 (f24 f30 ?v3) ?v4) ?v2) f1) (= (f13 (f23 (f24 f30 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f24 f30 ?v0))) (=> (= (f13 (f23 ?v_0 ?v1) ?v2) f1) (=> (= (f13 (f23 (f24 f30 ?v1) ?v3) ?v2) f1) (= (f13 (f23 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f24 f30 ?v0))) (=> (= (f13 (f23 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f13 (f23 (f24 f30 ?v3) ?v4) ?v2) f1) (= (f13 (f23 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f13 (f23 (f24 f30 ?v0) ?v1) ?v2) f1) (= (f13 (f23 (f24 f30 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f24 f30 ?v1))) (=> (< 2 ?v0) (=> (= (f13 (f23 ?v_0 (- 1)) ?v0) f1) (not (= (f13 (f23 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f13 (f23 (f24 f30 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f13 (f23 (f24 f30 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f13 (f23 (f24 f30 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f13 (f23 (f24 f30 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f13 (f23 (f24 f30 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f13 (f23 (f24 f30 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f13 (f23 (f24 f30 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f13 (f23 (f24 f30 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int)) (= (f13 (f23 (f24 f30 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 (f24 f30 ?v0) ?v1))) (= (= (f13 ?v_0 (- ?v2)) f1) (= (f13 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f13 (f23 (f24 f30 ?v0) ?v1) ?v2) f1) (= (f13 (f23 (f24 f30 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 (f23 (f24 f30 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 (f23 f34 ?v0) ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (= (f31 f32 f36) (f6 f7 0)))
(assert (= (f47 f48 f46) (f6 f7 0)))
(assert (forall ((?v0 S9)) (=> (< 0 (f11 f12 (f31 f32 ?v0))) (= (f15 f27 ?v0) f1))))
(assert (forall ((?v0 S10)) (=> (< 0 (f11 f12 (f47 f48 ?v0))) (= (f41 f45 ?v0) f1))))
(assert (forall ((?v0 S9)) (=> (not (= (f15 f27 ?v0) f1)) (= (f31 f32 ?v0) (f6 f7 0)))))
(assert (forall ((?v0 S10)) (=> (not (= (f41 f45 ?v0) f1)) (= (f47 f48 ?v0) (f6 f7 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f13 (f23 (f24 f30 ?v0) ?v1) ?v2) f1) (=> (= (f13 (f23 (f24 f30 ?v3) ?v4) ?v2) f1) (= (f13 (f23 (f24 f30 (f8 (f9 f10 ?v0) ?v3)) (f8 (f9 f10 ?v1) ?v4)) ?v2) f1)))))
(assert (forall ((?v0 S9) (?v1 S10)) (= (= (f41 (f42 f43 ?v0) ?v1) f1) (= (f15 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S9)) (= (= (f15 (f21 f22 ?v0) ?v1) f1) (= (f13 ?v1 ?v0) f1))))
(assert (forall ((?v0 S10)) (= (f49 f50 ?v0) ?v0)))
(assert (forall ((?v0 S9)) (= (f39 f51 ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v3))) (=> (= (f13 (f23 (f24 f30 ?v0) ?v1) ?v2) f1) (= (f13 (f23 (f24 f30 (f8 ?v_0 ?v0)) (f8 ?v_0 ?v1)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f13 (f23 (f24 f30 ?v0) ?v1) ?v2) f1) (= (f13 (f23 (f24 f30 (f8 (f9 f10 ?v0) ?v3)) (f8 (f9 f10 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f24 f30 ?v3)) (?v_1 (f9 f10 ?v4))) (=> (= (f13 (f23 (f24 f30 ?v0) ?v1) ?v2) f1) (= (= (f13 (f23 ?v_0 (f8 ?v_1 ?v0)) ?v2) f1) (= (f13 (f23 ?v_0 (f8 ?v_1 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f24 f30 ?v3))) (=> (= (f13 (f23 (f24 f30 ?v0) ?v1) ?v2) f1) (= (= (f13 (f23 ?v_0 (f8 (f9 f10 ?v0) ?v4)) ?v2) f1) (= (f13 (f23 ?v_0 (f8 (f9 f10 ?v1) ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f13 (f23 (f24 f30 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 ?v2) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f13 (f23 (f24 f30 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f8 (f9 f10 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f13 (f23 (f24 f30 ?v0) ?v1) ?v2) f1) (= (f13 (f23 f34 ?v2) (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 (f23 (f24 f30 ?v0) 0) ?v1) f1) (= (f13 (f23 f34 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 (f23 (f24 f30 ?v0) 0) ?v1) f1) (= (f13 (f23 f34 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (= (f13 f18 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f13 (f23 f34 ?v1) ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 S9)) (= (= (f31 f32 ?v0) (f6 f7 0)) (or (= ?v0 f36) (not (= (f15 f27 ?v0) f1))))))
(assert (forall ((?v0 S10)) (= (= (f47 f48 ?v0) (f6 f7 0)) (or (= ?v0 f46) (not (= (f41 f45 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (= (f15 (f21 f22 ?v0) f37) f1) (exists ((?v2 Int)) (let ((?v_1 (f8 (f9 f10 ?v2) ?v0))) (let ((?v_0 (- ?v1 ?v_1))) (< (ite (< ?v_0 0) (* (- 2) ?v_0) (- (* 2 ?v1) (* 2 ?v_1))) ?v0))))))))
(assert (forall ((?v0 Int)) (= (f15 f27 (f23 f26 ?v0)) f1)))
(assert (forall ((?v0 Int)) (= (f8 f38 ?v0) (ite (<= ?v0 0) 1 (f8 (f9 f10 ?v0) (f8 f38 (- ?v0 1)))))))
(assert (forall ((?v0 S9)) (=> (= (f41 (f42 f43 ?v0) f46) f1) false)))
(assert (forall ((?v0 Int)) (=> (= (f15 (f21 f22 ?v0) f36) f1) false)))
(assert (forall ((?v0 S10)) (=> (= (f41 f45 ?v0) f1) (=> (forall ((?v1 S9)) (=> (= (f41 (f42 f43 ?v1) ?v0) f1) (= (f6 f7 1) (f6 f7 0)))) (= (f47 f48 ?v0) (f6 f7 0))))))
(assert (forall ((?v0 S9)) (=> (= (f15 f27 ?v0) f1) (=> (forall ((?v1 Int)) (=> (= (f15 (f21 f22 ?v1) ?v0) f1) (= (f6 f7 1) (f6 f7 0)))) (= (f31 f32 ?v0) (f6 f7 0))))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 Int)) (let ((?v_0 (f8 (f9 (f52 f53 ?v1) ?v0) ?v2))) (=> (< 1 ?v0) (=> (= (f13 (f39 f40 ?v1) ?v0) f1) (=> (= (f15 (f21 f22 ?v2) ?v1) f1) (and (= (f13 (f23 (f24 f30 ?v2) ?v_0) ?v0) f1) (= (f15 (f21 f22 ?v_0) (f23 f33 ?v0)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f13 (f23 f34 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f13 (f23 f34 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f23 f34 ?v0))) (=> (= (f13 ?v_0 ?v1) f1) (= (= (f13 ?v_0 (+ ?v2 ?v3)) f1) (= (f13 ?v_0 (+ (+ ?v2 (f8 (f9 f10 ?v4) ?v1)) ?v3)) f1))))))
(assert (= f36 (f39 f51 f14)))
(assert (= f46 (f49 f50 f16)))
(assert (forall ((?v0 S10)) (= (forall ((?v1 S9)) (not (= (f41 (f42 f43 ?v1) ?v0) f1))) (= ?v0 f46))))
(assert (forall ((?v0 S9)) (= (forall ((?v1 Int)) (not (= (f15 (f21 f22 ?v1) ?v0) f1))) (= ?v0 f36))))
(assert (forall ((?v0 S10)) (= (exists ((?v1 S9)) (= (f41 (f42 f43 ?v1) ?v0) f1)) (not (= ?v0 f46)))))
(assert (forall ((?v0 S9)) (= (exists ((?v1 Int)) (= (f15 (f21 f22 ?v1) ?v0) f1)) (not (= ?v0 f36)))))
(assert (forall ((?v0 S10)) (= (exists ((?v1 S9)) (and (= (f41 (f42 f43 ?v1) f46) f1) (= (f15 ?v0 ?v1) f1))) false)))
(assert (forall ((?v0 S9)) (= (exists ((?v1 Int)) (and (= (f15 (f21 f22 ?v1) f36) f1) (= (f13 ?v0 ?v1) f1))) false)))
(assert (forall ((?v0 S10)) (= (forall ((?v1 S9)) (=> (= (f41 (f42 f43 ?v1) f46) f1) (= (f15 ?v0 ?v1) f1))) true)))
(assert (forall ((?v0 S9)) (= (forall ((?v1 Int)) (=> (= (f15 (f21 f22 ?v1) f36) f1) (= (f13 ?v0 ?v1) f1))) true)))
(assert (forall ((?v0 S9)) (= (= f36 (f39 f51 ?v0)) (forall ((?v1 Int)) (not (= (f13 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S10)) (= (= f46 (f49 f50 ?v0)) (forall ((?v1 S9)) (not (= (f15 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S9)) (= (= (f41 (f42 f43 ?v0) f46) f1) false)))
(assert (forall ((?v0 Int)) (= (= (f15 (f21 f22 ?v0) f36) f1) false)))
(assert (forall ((?v0 S9)) (= (= (f39 f51 ?v0) f36) (forall ((?v1 Int)) (not (= (f13 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S10)) (= (= (f49 f50 ?v0) f46) (forall ((?v1 S9)) (not (= (f15 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S10) (?v1 S9)) (=> (= ?v0 f46) (not (= (f41 (f42 f43 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S9) (?v1 Int)) (=> (= ?v0 f36) (not (= (f15 (f21 f22 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (+ ?v1 ?v2)) (+ (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (- ?v1 ?v2)) (- (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) ?v1) (- (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (+ ?v0 ?v1)) ?v2) (+ (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (- ?v0 ?v1)) ?v2) (- (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f11 f12 ?v2))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f8 ?v_1 ?v0) (f8 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 (f9 f10 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int)) (= (= (f13 (f23 f34 ?v0) 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f13 (f23 f34 ?v1) ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f13 (f23 f34 ?v0) ?v1) f1) (=> (= (f13 (f23 f34 ?v1) ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f13 (f23 f34 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 (f23 f34 ?v0) ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 (f23 f34 ?v0) ?v1) f1) (=> (= (f13 (f23 f34 ?v1) ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f34 ?v0))) (=> (= (f13 ?v_0 (- ?v1 ?v2)) f1) (=> (= (f13 ?v_0 ?v2) f1) (= (f13 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (<= ?v0 ?v1) (= (f15 (f21 f22 ?v0) (f23 f26 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= (f15 (f21 f22 ?v1) (f23 f26 ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 (f21 f22 ?v0) (f23 f26 ?v1)) f1) (< 1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 (f21 f22 ?v0) (f23 f26 ?v1)) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 Int)) (=> (< 1 ?v0) (=> (= (f13 (f39 f40 ?v1) ?v0) f1) (=> (= (f15 (f21 f22 ?v2) ?v1) f1) (= (f13 (f23 (f24 f30 ?v2) (f8 (f9 (f52 f53 ?v1) ?v0) ?v2)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 Int)) (=> (< 1 ?v0) (=> (= (f13 (f39 f40 ?v1) ?v0) f1) (=> (= (f15 (f21 f22 ?v2) ?v1) f1) (= (f15 (f21 f22 (f8 (f9 (f52 f53 ?v1) ?v0) ?v2)) (f23 f33 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f34 ?v0))) (= (= (f13 ?v_0 (+ ?v1 (f8 (f9 f10 ?v0) ?v2))) f1) (= (f13 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f13 (f23 f34 (f8 (f9 f10 ?v0) ?v1)) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (not (= ?v0 0)) (= (= (f13 (f23 f34 ?v1) ?v2) f1) (= (f13 (f23 f34 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S9)) (=> (not (= (f15 f27 ?v0) f1)) (not (= ?v0 f36)))))
(assert (forall ((?v0 S10)) (=> (not (= (f41 f45 ?v0) f1)) (not (= ?v0 f46)))))
(assert (forall ((?v0 Int)) (= (= (f13 f36 ?v0) f1) (= f54 f1))))
(assert (forall ((?v0 S9)) (= (= (f15 f46 ?v0) f1) (= f54 f1))))
(assert (forall ((?v0 Int)) (= (= (f13 f36 ?v0) f1) (= f54 f1))))
(assert (forall ((?v0 S9)) (= (= (f15 f46 ?v0) f1) (= f54 f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f28 (f55 f56 ?v0) (f3 (f4 f57 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f13 (f23 f34 ?v0) (f8 (f9 f10 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (= (f6 f7 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0)))) (f11 f12 (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v0)))) (f11 f12 (f6 f7 (- ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f28 (f55 f56 ?v0) ?v1) f1) (= (f13 (f23 f34 (f11 f12 ?v0)) (f11 f12 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f13 (f23 f34 ?v0) (f11 f12 ?v1)) f1) (= (f28 (f55 f56 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0))) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 Int)) (= (= (f13 (f23 f34 (f11 f12 ?v0)) ?v1) f1) (= (f28 (f55 f56 ?v0) (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f28 (f55 f56 (f6 f7 ?v0)) ?v1) f1) (ite (<= 0 ?v0) (= (f13 (f23 f34 ?v0) (f11 f12 ?v1)) f1) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f58 ?v0))) (= (f8 (f9 f10 ?v_0) ?v_0) (f8 (f9 f10 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 f58 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f8 f58 ?v0)) (f8 f58 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 f58 ?v0) (f8 f58 ?v1)) (= (f13 (f23 f34 ?v0) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f55 f56 ?v0))) (=> (= (f28 ?v_0 ?v1) f1) (=> (= (f28 (f55 f56 ?v1) ?v2) f1) (= (f28 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f34 ?v0))) (=> (= (f13 ?v_0 ?v1) f1) (=> (= (f13 (f23 f34 ?v1) ?v2) f1) (= (f13 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 (f23 f34 (f8 f58 ?v0)) ?v1) f1) (= (f13 (f23 f34 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f23 f34 ?v0))) (= (= (f13 ?v_0 (f8 f58 ?v1)) f1) (= (f13 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 S2)) (= (f28 (f55 f56 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int)) (= (f13 (f23 f34 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f8 (f9 f10 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f8 (f9 f10 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 (f23 f34 ?v0) ?v1) f1) (= (f13 (f23 f34 (- ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f23 f34 ?v0))) (= (= (f13 ?v_0 ?v1) f1) (= (f13 ?v_0 (- ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f28 (f55 f56 (f3 (f4 f57 ?v0) ?v1)) ?v2) f1) (= (f28 (f55 f56 ?v1) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f13 (f23 f34 (f8 (f9 f10 ?v0) ?v1)) ?v2) f1) (= (f13 (f23 f34 ?v1) ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f28 (f55 f56 (f3 (f4 f57 ?v0) ?v1)) ?v2) f1) (= (f28 (f55 f56 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f13 (f23 f34 (f8 (f9 f10 ?v0) ?v1)) ?v2) f1) (= (f13 (f23 f34 ?v0) ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= ?v0 (f3 (f4 f57 ?v1) ?v2)) (= (f28 (f55 f56 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 (f8 (f9 f10 ?v1) ?v2)) (= (f13 (f23 f34 ?v1) ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f28 (f55 f56 ?v0) ?v1) f1) (=> (= (f28 (f55 f56 ?v2) ?v3) f1) (= (f28 (f55 f56 (f3 (f4 f57 ?v0) ?v2)) (f3 (f4 f57 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f13 (f23 f34 ?v0) ?v1) f1) (=> (= (f13 (f23 f34 ?v2) ?v3) f1) (= (f13 (f23 f34 (f8 (f9 f10 ?v0) ?v2)) (f8 (f9 f10 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f55 f56 ?v0))) (=> (= (f28 ?v_0 ?v1) f1) (= (f28 ?v_0 (f3 (f4 f57 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f34 ?v0))) (=> (= (f13 ?v_0 ?v1) f1) (= (f13 ?v_0 (f8 (f9 f10 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f55 f56 ?v0))) (=> (= (f28 ?v_0 ?v1) f1) (= (f28 ?v_0 (f3 (f4 f57 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f34 ?v0))) (=> (= (f13 ?v_0 ?v1) f1) (= (f13 ?v_0 (f8 (f9 f10 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f28 (f55 f56 ?v0) (f3 (f4 f57 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f13 (f23 f34 ?v0) (f8 (f9 f10 ?v1) ?v0)) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f28 (f55 f56 ?v0) ?v1) f1) (=> (forall ((?v2 S2)) (=> (= ?v1 (f3 (f4 f57 ?v0) ?v2)) false)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 (f23 f34 ?v0) ?v1) f1) (=> (forall ((?v2 Int)) (=> (= ?v1 (f8 (f9 f10 ?v0) ?v2)) false)) false))))
(assert (forall ((?v0 Int)) (=> (= (f15 (f21 f22 ?v0) f37) f1) (=> (forall ((?v1 Int)) (=> (= ?v0 (+ (* 2 ?v1) 1)) false)) false))))
(assert (forall ((?v0 S17) (?v1 Int)) (=> (forall ((?v2 Int)) (= (f13 (f39 ?v0 f36) ?v2) f1)) (=> (forall ((?v2 Int)) (let ((?v_0 (- ?v2 1))) (=> (< 1 ?v2) (=> (= (f13 (f39 ?v0 (f23 f26 ?v_0)) ?v_0) f1) (= (f13 (f39 ?v0 (f23 f26 ?v2)) ?v2) f1))))) (= (f13 (f39 ?v0 (f23 f26 ?v1)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f13 (f23 (f24 f30 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f13 (f23 (f24 f30 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f12 (f6 f7 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f6 f7 (f8 (f9 f10 ?v_0) ?v_0)) (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v0 1)))) (f11 f12 (f6 f7 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f55 f56 ?v0))) (=> (= (f28 f29 ?v0) f1) (=> (= (f28 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) f1) (or (= (f28 ?v_0 ?v1) f1) (= (f28 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f55 f56 ?v0))) (=> (= (f28 f29 ?v0) f1) (=> (= (f28 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) f1) (or (= (f28 ?v_0 ?v1) f1) (= (f28 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f55 f56 ?v0))) (=> (= (f28 f29 ?v0) f1) (= (= (f28 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) f1) (or (= (f28 ?v_0 ?v1) f1) (= (f28 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f55 f56 ?v0))) (=> (= (f28 ?v_0 ?v1) f1) (=> (= (f28 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) f1) (= (f28 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f28 (f55 f56 ?v0) ?v1) f1) (or (= ?v1 (f6 f7 0)) (<= (f11 f12 ?v0) (f11 f12 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (and (= (f28 (f55 f56 ?v0) ?v1) f1) (= (f28 (f55 f56 ?v1) ?v0) f1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (=> (= (f28 f29 ?v0) f1) (<= 2 (f11 f12 ?v0)))))
(assert (= (f28 f29 (f6 f7 2)) f1))
(assert (not (= (f28 f29 (f6 f7 (+ 0 1))) f1)))
(assert (not (= (f28 f29 (f6 f7 0)) f1)))
(assert (not (= (f28 f29 (f6 f7 1)) f1)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v3))) (=> (= ?v0 (f6 f7 (+ (f8 (f9 f10 (f11 f12 ?v1)) ?v_1) ?v_0))) (=> (< 0 ?v_0) (=> (< ?v_0 ?v_1) (not (= (f28 (f55 f56 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v2)))) (=> (= (f28 (f55 f56 ?v0) ?v1) f1) (= (f28 (f55 f56 (f6 f7 (f8 ?v_0 (f11 f12 ?v0)))) (f6 f7 (f8 ?v_0 (f11 f12 ?v1)))) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v2))) (=> (= (f28 (f55 f56 ?v0) ?v1) f1) (= (f28 (f55 f56 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) ?v_0))) (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) ?v_0))) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f28 (f55 f56 ?v0) ?v1) f1) (or (= ?v1 (f6 f7 0)) (or (= ?v1 ?v0) (<= (* 2 (f11 f12 ?v0)) (f11 f12 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v1))) (= (= (f28 (f55 f56 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) ?v_0))) (f6 f7 (f8 (f9 f10 (f11 f12 ?v2)) ?v_0))) f1) (or (= ?v1 (f6 f7 0)) (= (f28 (f55 f56 ?v0) ?v2) f1))))))
(assert (forall ((?v0 S2)) (= (= (f28 f29 ?v0) f1) (and (< 1 (f11 f12 ?v0)) (forall ((?v1 S2)) (=> (= (f28 (f55 f56 ?v1) ?v0) f1) (or (= ?v1 (f6 f7 1)) (= ?v1 ?v0))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v2))) (=> (= (f28 f29 ?v0) f1) (=> (not (= ?v1 (f6 f7 0))) (=> (= ?v1 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) ?v_0))) (< ?v_0 (f11 f12 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (=> (= (f28 f29 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) f1) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 (f6 f7 1))) (exists ((?v1 S2)) (and (= (f28 f29 ?v1) f1) (= (f28 (f55 f56 ?v1) ?v0) f1))))))
(assert (forall ((?v0 S2)) (= (f28 (f55 f56 (f6 f7 (+ 0 1))) ?v0) f1)))
(assert (forall ((?v0 S2)) (= (f28 (f55 f56 ?v0) ?v0) f1)))
(assert (forall ((?v0 S2)) (let ((?v_0 (= (f28 (f55 f56 ?v0) ?v0) f1))) (not (and ?v_0 (not ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f28 (f55 f56 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= ?v0 ?v1) (and (= (f28 (f55 f56 ?v0) ?v1) f1) (= (f28 (f55 f56 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f28 (f55 f56 ?v0) ?v1) f1))) (= ?v_0 (or (and ?v_0 (not (= (f28 (f55 f56 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f28 (f55 f56 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f55 f56 ?v0))) (= (= (f28 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v0)))) f1) (= (f28 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f28 (f55 f56 ?v0) ?v1) f1))) (= (and ?v_0 (not (= (f28 (f55 f56 ?v1) ?v0) f1))) (and ?v_0 (not (= ?v0 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (and (= (f28 (f55 f56 ?v0) ?v1) f1) (not (= (f28 (f55 f56 ?v1) ?v0) f1))))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f28 (f55 f56 ?v0) ?v1) f1))) (=> (not (= ?v0 ?v1)) (=> ?v_0 (and ?v_0 (not (= (f28 (f55 f56 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (=> (< ?v_0 (f11 f12 ?v1)) (not (= (f28 (f55 f56 ?v1) ?v0) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 ?v1) (= (f28 (f55 f56 ?v0) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f28 (f55 f56 ?v0) ?v1) f1) (= (= (f28 (f55 f56 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f28 (f55 f56 ?v0) ?v1) f1))) (=> ?v_0 (or (and ?v_0 (not (= (f28 (f55 f56 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f28 (f55 f56 ?v0) ?v1) f1))) (=> ?v_0 (=> (not (= ?v0 ?v1)) (and ?v_0 (not (= (f28 (f55 f56 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v1))) (=> (= (f28 (f55 f56 ?v0) ?v1) f1) (=> (< 0 ?v_0) (<= (f11 f12 ?v0) ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= ?v0 ?v1) (=> (= (f28 (f55 f56 ?v1) ?v2) f1) (= (f28 (f55 f56 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f55 f56 ?v0))) (=> (= (f28 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f28 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f28 (f55 f56 ?v0) ?v1) f1) (=> (= (f28 (f55 f56 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f28 (f55 f56 ?v0) ?v1) f1) (=> (= (f28 (f55 f56 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f55 f56 ?v0))) (=> (= (f28 ?v_0 ?v1) f1) (=> (= (f28 (f55 f56 ?v1) ?v2) f1) (= (f28 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f55 f56 ?v0))) (=> (= (f28 ?v_0 ?v1) f1) (=> (= (f28 ?v_0 ?v2) f1) (= (f28 ?v_0 (f6 f7 (- (f11 f12 ?v1) (f11 f12 ?v2)))) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f55 f56 ?v2))) (=> (= ?v0 ?v1) (=> (and (= (f28 (f55 f56 ?v1) ?v2) f1) (not (= (f28 ?v_0 ?v1) f1))) (and (= (f28 (f55 f56 ?v0) ?v2) f1) (not (= (f28 ?v_0 ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f55 f56 ?v0)) (?v_1 (f55 f56 ?v2))) (=> (= (f28 ?v_0 ?v1) f1) (=> (and (= (f28 (f55 f56 ?v1) ?v2) f1) (not (= (f28 ?v_1 ?v1) f1))) (and (= (f28 ?v_0 ?v2) f1) (not (= (f28 ?v_1 ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f55 f56 ?v0)) (?v_1 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (=> (= (f28 ?v_0 (f6 f7 (- ?v_2 ?v_1))) f1) (=> (= (f28 ?v_0 ?v1) f1) (=> (<= ?v_1 ?v_2) (= (f28 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f55 f56 ?v0)) (?v_1 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (=> (= (f28 ?v_0 (f6 f7 (- ?v_2 ?v_1))) f1) (=> (= (f28 ?v_0 ?v2) f1) (=> (<= ?v_1 ?v_2) (= (f28 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (and (= (f28 (f55 f56 ?v0) ?v1) f1) (not (= (f28 (f55 f56 ?v1) ?v0) f1))) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (= (f28 (f55 f56 ?v0) ?v1) f1)) (?v_0 (= (f28 (f55 f56 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (not (and ?v_0 (not ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f28 (f55 f56 ?v0) ?v1) f1))) (=> (and ?v_0 (not (= (f28 (f55 f56 ?v1) ?v0) f1))) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (= (f28 (f55 f56 ?v0) ?v1) f1)) (?v_0 (= (f28 (f55 f56 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (not (and ?v_0 (not ?v_1))) true)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (and (= (f28 (f55 f56 ?v0) ?v1) f1) (not (= (f28 (f55 f56 ?v1) ?v0) f1))) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (and (= (f28 (f55 f56 ?v0) ?v1) f1) (not (= (f28 (f55 f56 ?v1) ?v0) f1))) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S1)) (let ((?v_1 (= (f28 (f55 f56 ?v0) ?v1) f1)) (?v_0 (= (f28 (f55 f56 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (=> (and ?v_0 (not ?v_1)) (= ?v2 f1)) true)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f55 f56 ?v0))) (=> (and (= (f28 ?v_0 ?v1) f1) (not (= (f28 (f55 f56 ?v1) ?v0) f1))) (=> (= ?v1 ?v2) (and (= (f28 ?v_0 ?v2) f1) (not (= (f28 (f55 f56 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f55 f56 ?v0)) (?v_0 (f55 f56 ?v1))) (=> (and (= (f28 ?v_1 ?v1) f1) (not (= (f28 ?v_0 ?v0) f1))) (=> (= (f28 ?v_0 ?v2) f1) (and (= (f28 ?v_1 ?v2) f1) (not (= (f28 (f55 f56 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (= (f28 (f55 f56 ?v0) ?v1) f1)) (?v_0 (= (f28 (f55 f56 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (and ?v_0 (not ?v_1)) false)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f55 f56 ?v0)) (?v_0 (f55 f56 ?v1)) (?v_2 (f55 f56 ?v2))) (=> (and (= (f28 ?v_1 ?v1) f1) (not (= (f28 ?v_0 ?v0) f1))) (=> (and (= (f28 ?v_0 ?v2) f1) (not (= (f28 ?v_2 ?v1) f1))) (and (= (f28 ?v_1 ?v2) f1) (not (= (f28 ?v_2 ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (= (f28 (f55 f56 ?v0) ?v1) f1)) (?v_0 (= (f28 (f55 f56 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (=> (not false) (and ?v_0 (not ?v_1))) false)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (<= ?v_0 (f8 (f9 f10 ?v_0) ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0))) (<= ?v_0 (f8 ?v_1 (f8 ?v_1 ?v_0)))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 0 (f11 f12 ?v0))) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 1 (f11 f12 ?v0))) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (< 0 (f8 (f9 f10 ?v_0) ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 0)) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)) (f6 f7 (f8 (f9 f10 ?v_0) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0)) (?v_2 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_1 (+ ?v_2 1))) (f6 f7 (+ ?v_0 (f8 ?v_1 ?v_2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 ?v_0 (+ ?v_1 ?v_2))) (f6 f7 (+ (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_0 (f11 f12 (f6 f7 (- ?v_1 ?v_2))))) (f6 f7 (- (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (= (<= ?v_0 (f8 (f9 f10 ?v_1) ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 (+ ?v_1 1)) ?v_0)) (f6 f7 (+ ?v_0 (f8 (f9 f10 ?v_1) ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f8 ?v_0 ?v_1)) ?v_2)) (f6 f7 (f8 ?v_0 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (+ ?v_0 ?v_2)) ?v_1)) (f6 f7 (+ (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_2)))) ?v_1)) (f6 f7 (- (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
