(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 () Int)
(declare-fun f7 (S4 Int) S1)
(declare-fun f8 (Int) S4)
(declare-fun f9 (Int) S1)
(declare-fun f10 (S5 Int) S4)
(declare-fun f11 (Int) S5)
(declare-fun f12 () S2)
(declare-fun f13 (Int S4) S1)
(declare-fun f14 (Int S4) S1)
(declare-fun f15 () S3)
(assert (not (= f1 f2)))
(assert (not (not (= (f3 (f4 f5 (- 1)) (+ (* 4 f6) 1)) 1))))
(assert (not (= (f7 (f8 (+ (* 4 f6) 1)) (- 1)) f1)))
(assert (not (= (f7 (f8 (+ (* 4 f6) 1)) (- 1)) f1)))
(assert (= (f3 (f4 f5 (- 1)) (+ (* 4 f6) 1)) 1))
(assert (= (f9 (+ (* 4 f6) 1)) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f9 ?v_0) f1) (= (f3 (f4 f5 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (ite (= (f7 (f10 (f11 ?v0) 0) ?v1) f1) 0 (ite (= (f7 (f8 ?v1) ?v0) f1) 1 (- 1))))))
(assert (= (f9 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f9 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f7 (f10 (f11 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f7 (f10 (f11 ?v0) ?v1) ?v2) f1) (= (f7 (f10 (f11 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 (f11 ?v0) ?v1))) (= (= (f7 ?v_0 (- ?v2)) f1) (= (f7 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int)) (= (f7 (f10 (f11 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f10 (f11 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f10 (f11 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f7 (f10 (f11 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f7 (f10 (f11 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f7 (f10 (f11 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f7 (f10 (f11 ?v0) ?v1) ?v2) f1) (=> (= (f7 (f10 (f11 ?v3) ?v4) ?v2) f1) (= (f7 (f10 (f11 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f7 (f10 (f11 ?v0) ?v1) ?v2) f1) (=> (= (f7 (f10 (f11 ?v3) ?v4) ?v2) f1) (= (f7 (f10 (f11 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 ?v0))) (=> (= (f7 (f10 ?v_0 ?v1) ?v2) f1) (=> (= (f7 (f10 (f11 ?v1) ?v3) ?v2) f1) (= (f7 (f10 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f11 ?v0))) (=> (= (f7 (f10 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f7 (f10 (f11 ?v3) ?v4) ?v2) f1) (= (f7 (f10 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f7 (f10 (f11 ?v0) ?v1) ?v2) f1) (= (f7 (f10 (f11 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 ?v1))) (=> (< 2 ?v0) (=> (= (f7 (f10 ?v_0 (- 1)) ?v0) f1) (not (= (f7 (f10 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f7 (f10 (f11 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f7 (f10 (f11 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f7 (f10 (f11 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int)) (=> (= (f9 ?v0) f1) (= (f7 (f10 (f11 (f3 f12 (- ?v0 1))) (- 1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f7 (f10 (f11 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f7 (f10 (f11 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f7 (f10 (f11 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (= (f13 ?v0 ?v1) f1) (forall ((?v2 Int) (?v3 Int)) (=> (and (= (f14 ?v2 ?v1) f1) (and (= (f14 ?v3 ?v1) f1) (= (f7 (f10 (f11 ?v2) ?v3) ?v0) f1))) (= ?v2 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f11 ?v1)) (?v_0 (f4 f15 ?v0))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f7 (f10 ?v_1 0) ?v0) f1)) (=> (not (= (f7 (f10 (f11 ?v2) 0) ?v0) f1)) (=> (= (f7 (f10 (f11 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) ?v0) f1) (= (f7 (f10 ?v_1 ?v2) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f15 ?v0))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f7 (f10 (f11 ?v1) 0) ?v0) f1)) (= (f7 (f10 (f11 (f3 ?v_0 (f3 ?v_0 ?v1))) ?v1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f7 (f10 (f11 ?v1) 0) ?v0) f1)) (not (= (f7 (f10 (f11 (f3 (f4 f15 ?v0) ?v1)) 0) ?v0) f1)))))))
(check-sat)
(exit)
