(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 Int) Int)
(declare-fun f9 (S7 Int) S6)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S2) Int)
(declare-fun f12 () S8)
(declare-fun f13 () Int)
(declare-fun f14 (Int) S1)
(declare-fun f15 () S7)
(declare-fun f16 (S9 Int) S1)
(declare-fun f17 (Int) S9)
(declare-fun f18 (S10 Int) S9)
(declare-fun f19 (Int) S10)
(declare-fun f20 (S11 Int) S8)
(declare-fun f21 () S11)
(declare-fun f22 () Int)
(declare-fun f23 () S6)
(declare-fun f24 () S7)
(declare-fun f25 () S6)
(declare-fun f26 () S4)
(declare-fun f27 (Int S9) S1)
(declare-fun f28 (Int S9) S1)
(declare-fun f29 () S7)
(declare-fun f30 () S4)
(declare-fun f31 () S7)
(declare-fun f32 (Int) S10)
(declare-fun f33 (Int) S9)
(declare-fun f34 (Int) S1)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))))))
(assert (not (< 0 (+ (* 4 f13) 1))))
(assert (= (f14 (+ (* 4 f13) 1)) f1))
(assert (= (f14 (+ (* 4 f13) 1)) f1))
(assert (= (f8 (f9 f15 (- 1)) (+ (* 4 f13) 1)) 1))
(assert (= (f16 (f17 (+ (* 4 f13) 1)) (- 1)) f1))
(assert (let ((?v_0 (+ (* 4 f13) 1))) (=> (not (= (f16 (f17 ?v_0) (- 1)) f1)) (not (= (f8 (f9 f15 (- 1)) ?v_0) 1)))))
(assert (= (f16 (f18 (f19 (f11 (f20 f21 f22) (f6 f7 2))) (- 1)) (+ (* 4 f13) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f16 (f18 (f19 (f11 (f20 f21 ?v0) (f6 f7 2))) (- 1)) (+ (* 4 f13) 1)) f1) false)) false))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f14 ?v_0) f1) (= (f8 (f9 f15 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f15 ?v0) ?v1) (ite (= (f16 (f18 (f19 ?v0) 0) ?v1) f1) 0 (ite (= (f16 (f17 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 (f17 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f16 (f18 (f19 (f11 (f20 f21 ?v2) (f6 f7 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f20 f21 (- 1)))) (let ((?v_1 (f11 ?v_0 ?v1)) (?v_2 (f11 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f16 (f18 (f19 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S2)) (=> (= (f16 (f18 (f19 ?v0) ?v1) ?v2) f1) (= (f16 (f18 (f19 (f11 (f20 f21 ?v0) ?v3)) (f11 (f20 f21 ?v1) ?v3)) ?v2) f1))))
(assert (= (f14 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f14 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f11 (f20 f21 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f11 (f20 f21 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 2))) (let ((?v_0 (f11 (f20 f21 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f20 f21 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 3))) (let ((?v_0 (f11 (f20 f21 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f20 f21 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (< 0 (f11 (f20 f21 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f19 ?v0))) (=> (= (f16 (f18 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f16 (f18 (f19 ?v3) ?v4) ?v2) f1) (= (f16 (f18 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f16 (f18 (f19 ?v0) ?v1) ?v2) f1) (= (f16 (f18 (f19 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 ?v1))) (=> (< 2 ?v0) (=> (= (f16 (f18 ?v_0 (- 1)) ?v0) f1) (not (= (f16 (f18 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f16 (f18 (f19 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f16 (f18 (f19 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f16 (f18 (f19 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f16 (f18 (f19 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int)) (= (f16 (f18 (f19 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int)) (=> (= (f11 (f20 f21 ?v0) (f6 f7 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 (f20 f21 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (= (f11 (f20 f21 ?v0) ?v_0) (f11 (f20 f21 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2)) (?v_1 (f20 f21 ?v0))) (= (f11 (f20 f21 (f11 ?v_1 ?v_0)) ?v_0) (f11 ?v_1 (f6 f7 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 3))) (= (f11 (f20 f21 (- ?v0)) ?v_0) (- (f11 (f20 f21 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (=> (= (f14 ?v0) f1) (= (f16 (f18 (f19 (f8 f23 (- ?v0 1))) (- 1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (<= 0 (f11 (f20 f21 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f16 (f18 (f19 ?v0) ?v1) ?v2) f1) (=> (= (f16 (f18 (f19 ?v3) ?v4) ?v2) f1) (= (f16 (f18 (f19 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f16 (f18 (f19 ?v0) ?v1) ?v2) f1) (=> (= (f16 (f18 (f19 ?v3) ?v4) ?v2) f1) (= (f16 (f18 (f19 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f19 ?v0))) (=> (= (f16 (f18 ?v_0 ?v1) ?v2) f1) (=> (= (f16 (f18 (f19 ?v1) ?v3) ?v2) f1) (= (f16 (f18 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f16 (f18 (f19 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f16 (f18 (f19 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f16 (f18 (f19 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f18 (f19 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f18 (f19 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 (f18 (f19 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f16 (f18 (f19 ?v0) ?v1) ?v2) f1) (= (f16 (f18 (f19 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f18 (f19 ?v0) ?v1))) (= (= (f16 ?v_0 (- ?v2)) f1) (= (f16 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f16 (f18 (f19 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f16 (f18 (f19 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f14 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f16 (f18 (f19 ?v1) 0) ?v0) f1)) (=> (not (= (f16 (f17 ?v0) ?v1) f1)) (= (f16 (f18 (f19 (f8 f23 ?v_0)) (f11 (f20 f21 ?v1) (f6 f7 (f8 (f9 f24 ?v_0) 2)))) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (= (f16 (f18 (f19 (f8 (f9 f15 ?v1) ?v0)) (f11 (f20 f21 ?v1) (f6 f7 (f8 (f9 f24 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f8 f25 (f11 (f20 f21 ?v0) ?v1)) (f11 (f20 f21 (f8 f25 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 (f20 f21 ?v0) (f6 f7 2)))) (= (f8 f25 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f11 (f20 f21 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f26 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f11 (f20 f21 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f26 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f20 f21 (f8 f25 ?v0)) ?v_0) (f11 (f20 f21 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f6 f7 (f11 (f20 f21 ?v0) ?v1)) (f3 (f4 f26 (f6 f7 ?v0)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 (f20 f21 (f11 f12 ?v0)) ?v1) (f11 f12 (f3 (f4 f26 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 f12 (f3 (f4 f26 ?v0) ?v1)) (f11 (f20 f21 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f3 (f4 f26 (f6 f7 ?v0)) ?v1) (f6 f7 (f11 (f20 f21 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 (f20 f21 (f11 f12 ?v0)) ?v1) (f11 f12 (f3 (f4 f26 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (= (f16 (f18 (f19 ?v1) 0) ?v0) f1) (= (f16 (f18 (f19 0) (f11 (f20 f21 ?v1) (f6 f7 (f8 (f9 f24 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f16 (f18 (f19 ?v1) 0) ?v0) f1)) (=> (= (f16 (f17 ?v0) ?v1) f1) (= (f16 (f18 (f19 (f11 (f20 f21 ?v1) (f6 f7 (f8 (f9 f24 (- ?v0 1)) 2)))) 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f16 (f18 (f19 ?v1) 0) ?v0) f1)) (=> (not (= (f16 (f17 ?v0) ?v1) f1)) (= (f16 (f18 (f19 (f11 (f20 f21 ?v1) (f6 f7 (f8 (f9 f24 (- ?v0 1)) 2)))) (- 1)) ?v0) f1)))))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f20 f21 ?v1))) (=> (< 0 ?v_1) (=> (< 0 ?v1) (= (f8 (f9 f24 (f11 ?v_0 ?v0)) ?v1) (f11 ?v_0 (f6 f7 (- ?v_1 (+ 0 1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 0) (<= (f8 (f9 f24 ?v1) ?v2) (f8 (f9 f24 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< 0 ?v2) (<= (f8 (f9 f24 ?v0) ?v2) (f8 (f9 f24 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f8 (f9 f24 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f24 ?v0))) (=> (< ?v0 0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< 0 ?v1) (<= (f8 (f9 f24 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f8 (f9 f24 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f11 f12 (f3 (f4 f26 ?v0) ?v1))) (or (< 0 (f11 f12 ?v0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (f3 (f4 f26 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f3 (f4 f26 ?v0) ?v1) ?v_0) (or (= ?v1 (f6 f7 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f26 ?v0))) (=> (< 0 (f11 f12 ?v0)) (=> (< (f11 f12 (f3 ?v_0 ?v1)) (f11 f12 (f3 ?v_0 ?v2))) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f11 f12 ?v0)) (<= ?v_0 (f11 f12 (f3 (f4 f26 ?v0) ?v1)))))))
(assert (forall ((?v0 Int)) (= (f8 (f9 f24 0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f8 (f9 f24 ?v0) (- 1)) (- ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f24 ?v0) (- ?v1)) (f8 (f9 f24 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S9)) (= (= (f27 ?v0 ?v1) f1) (= (f16 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f24 (- ?v0)) (- ?v1)) (f8 (f9 f24 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f24 ?v0) ?v1) 0) (or (= ?v1 0) (or (and (<= 0 ?v0) (< ?v0 ?v1)) (and (<= ?v0 0) (< ?v1 ?v0)))))))
(assert (forall ((?v0 Int)) (=> (not (= ?v0 0)) (= (f8 (f9 f24 ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (<= 0 (f8 (f9 f24 ?v1) ?v0)) (<= 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< 0 (f8 (f9 f24 ?v1) ?v0)) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (< 0 (f8 (f9 f24 ?v0) ?v1)) (and (<= ?v1 ?v0) (< 0 ?v1))))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f8 (f9 f24 (- 1)) ?v0) (- 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f8 (f9 f24 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f8 (f9 f24 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< (f8 (f9 f24 ?v1) ?v0) 0) (< ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f8 (f9 f24 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 1 ?v1) (< (f8 (f9 f24 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f24 ?v0))) (=> (<= 0 ?v0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f8 ?v_0 ?v2) (f8 ?v_0 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v1 0) (<= (f8 (f9 f24 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f8 (f9 f24 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= (+ ?v0 ?v1) 0) (= (f8 (f9 f24 ?v0) ?v1) (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (<= 0 (f8 (f9 f24 ?v1) ?v0)) (<= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f8 (f9 f24 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f8 (f9 f24 (+ ?v1 1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (< (f8 (f9 f24 ?v1) ?v0) 0) (< 0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f11 f12 (f3 (f4 f26 ?v0) ?v1))) (or (= ?v1 (f6 f7 0)) (< 0 (f11 f12 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f3 (f4 f26 ?v0) ?v1) ?v_0) (and (not (= ?v1 ?v_0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f3 (f4 f26 ?v0) ?v1) ?v_0) (or (= ?v0 ?v_0) (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))) (= (= (f3 (f4 f26 ?v0) ?v_0) (f3 (f4 f26 ?v2) ?v_0)) (= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))) (= (< (f11 f12 (f3 (f4 f26 ?v0) ?v_0)) (f11 f12 (f3 (f4 f26 ?v2) ?v_0))) (< (f11 f12 ?v0) (f11 f12 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))) (= (<= (f11 f12 (f3 (f4 f26 ?v0) ?v_0)) (f11 f12 (f3 (f4 f26 ?v2) ?v_0))) (<= (f11 f12 ?v0) (f11 f12 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S9)) (= (= (f28 ?v0 ?v1) f1) (forall ((?v2 Int) (?v3 Int)) (=> (and (= (f27 ?v2 ?v1) f1) (and (= (f27 ?v3 ?v1) f1) (= (f16 (f18 (f19 ?v2) ?v3) ?v0) f1))) (= ?v2 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f19 ?v1)) (?v_0 (f9 f29 ?v0))) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f16 (f18 ?v_1 0) ?v0) f1)) (=> (not (= (f16 (f18 (f19 ?v2) 0) ?v0) f1)) (=> (= (f16 (f18 (f19 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) ?v0) f1) (= (f16 (f18 ?v_1 ?v2) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f29 ?v0))) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f16 (f18 (f19 ?v1) 0) ?v0) f1)) (= (f16 (f18 (f19 (f8 ?v_0 (f8 ?v_0 ?v1))) ?v1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f16 (f18 (f19 ?v1) 0) ?v0) f1)) (not (= (f16 (f18 (f19 (f8 (f9 f29 ?v0) ?v1)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f29 ?v0))) (=> (< 2 ?v0) (=> (= (f16 (f18 (f19 ?v1) ?v2) ?v0) f1) (= (f16 (f18 (f19 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f29 ?v0) ?v1) (f11 (f20 f21 ?v1) (f6 f7 (- ?v0 2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f19 ?v2))) (=> (= (f14 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f16 (f18 (f19 ?v1) 0) ?v0) f1)) (=> (not (= (f16 (f18 ?v_0 0) ?v0) f1)) (=> (not (= (f16 (f17 ?v0) ?v1) f1)) (not (= (f16 (f18 ?v_0 (f8 (f9 f10 ?v1) (f8 (f9 f29 ?v0) ?v2))) ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f8 (f9 f29 ?v0) ?v1))) (let ((?v_0 (f9 f10 ?v_1))) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f16 (f18 (f19 ?v1) 0) ?v0) f1)) (=> (= (f16 (f18 (f19 (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2)) (f8 ?v_0 ?v3)) ?v0) f1) (= (f16 (f18 (f19 ?v2) (f8 (f9 f10 ?v3) ?v_1)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f19 (f8 (f9 f10 ?v2) ?v1)))) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f16 (f18 (f19 ?v1) 0) ?v0) f1)) (=> (= (f16 (f18 ?v_0 (f8 (f9 f10 (f8 (f9 f10 ?v3) (f8 (f9 f29 ?v0) ?v1))) ?v1)) ?v0) f1) (= (f16 (f18 ?v_0 ?v3) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f19 ?v1)) (?v_0 (f19 ?v2)) (?v_2 (f9 f10 ?v3)) (?v_3 (f9 f29 ?v0))) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f16 (f18 ?v_1 0) ?v0) f1)) (=> (not (= (f16 (f18 ?v_0 0) ?v0) f1)) (=> (= (f16 (f18 ?v_0 (f8 ?v_2 (f8 ?v_3 ?v1))) ?v0) f1) (= (f16 (f18 ?v_1 (f8 ?v_2 (f8 ?v_3 ?v2))) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_2 (f19 ?v3)) (?v_0 (f9 f10 ?v1)) (?v_1 (f9 f29 ?v0))) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f16 (f18 (f19 ?v1) 0) ?v0) f1)) (=> (not (= (f16 (f18 (f19 ?v2) 0) ?v0) f1)) (=> (not (= (f16 (f18 ?v_2 0) ?v0) f1)) (=> (= (f16 (f18 (f19 (f8 ?v_0 (f8 ?v_1 ?v3))) (f8 ?v_0 (f8 ?v_1 ?v2))) ?v0) f1) (= (f16 (f18 ?v_2 ?v2) ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f16 (f18 (f19 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f8 (f9 f10 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f16 (f18 (f19 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 ?v2) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f16 (f18 (f19 ?v0) ?v1) ?v2) f1) (= (f16 (f18 (f19 (f8 (f9 f10 ?v0) ?v3)) (f8 (f9 f10 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v3))) (=> (= (f16 (f18 (f19 ?v0) ?v1) ?v2) f1) (= (f16 (f18 (f19 (f8 ?v_0 ?v0)) (f8 ?v_0 ?v1)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f16 (f18 (f19 ?v0) ?v1) ?v2) f1) (=> (= (f16 (f18 (f19 ?v3) ?v4) ?v2) f1) (= (f16 (f18 (f19 (f8 (f9 f10 ?v0) ?v3)) (f8 (f9 f10 ?v1) ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f16 (f18 (f19 (f8 (f9 f10 ?v0) ?v_0)) 1) ?v1) f1) (= (f16 (f18 (f19 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f19 ?v3))) (=> (= (f16 (f18 (f19 ?v0) ?v1) ?v2) f1) (= (= (f16 (f18 ?v_0 (f8 (f9 f10 ?v0) ?v4)) ?v2) f1) (= (f16 (f18 ?v_0 (f8 (f9 f10 ?v1) ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f19 ?v3)) (?v_1 (f9 f10 ?v4))) (=> (= (f16 (f18 (f19 ?v0) ?v1) ?v2) f1) (= (= (f16 (f18 ?v_0 (f8 ?v_1 ?v0)) ?v2) f1) (= (f16 (f18 ?v_0 (f8 ?v_1 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f8 (f9 f10 ?v0) (f11 (f20 f21 (f11 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f3 (f4 f30 ?v0) (f3 (f4 f26 (f3 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f20 f21 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f8 (f9 f10 ?v0) (f8 (f9 f10 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f3 (f4 f30 ?v0) (f3 (f4 f30 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f20 f21 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f8 (f9 f10 ?v_1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f3 (f4 f30 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f8 (f9 f10 ?v0) ?v2))) (=> (<= 0 ?v1) (<= ?v2 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f8 (f9 f10 ?v0) ?v2))) (=> (< ?v1 ?v0) (<= 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 (+ (f8 (f9 f10 ?v0) ?v1) ?v2)) (=> (< ?v2 ?v0) (=> (< 0 ?v0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ (f8 (f9 f10 ?v0) ?v1) ?v2) 0) (=> (<= 0 ?v2) (=> (< 0 ?v0) (<= ?v1 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (<= (+ (f8 ?v_0 ?v1) ?v2) (+ (f8 ?v_0 ?v3) ?v4)) (=> (<= 0 ?v2) (=> (< ?v2 ?v0) (=> (< ?v4 ?v0) (<= ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f8 (f9 f10 ?v3) ?v4) ?v5))) (=> (= (+ (f8 (f9 f10 ?v0) ?v1) ?v2) ?v_0) (=> (<= 0 ?v_0) (=> (< ?v5 ?v3) (=> (<= 0 ?v2) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v1 ?v4))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (<= (+ (f8 ?v_0 ?v1) ?v2) (+ (f8 ?v_0 ?v3) ?v4)) (=> (<= ?v4 0) (=> (< ?v0 ?v4) (=> (< ?v0 ?v2) (<= ?v3 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f8 (f9 f10 ?v3) ?v4) ?v5))) (=> (= (+ (f8 (f9 f10 ?v0) ?v1) ?v2) ?v_0) (=> (< ?v_0 0) (=> (< ?v2 ?v0) (=> (<= 0 ?v5) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v4 ?v1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f9 f10 ?v1))) (= (+ (f8 (f9 f10 (- ?v0 (f8 ?v_0 ?v2))) ?v3) (f8 (f9 f10 (- ?v4 (f8 ?v_0 ?v5))) ?v6)) (- (+ (f8 (f9 f10 ?v0) ?v3) (f8 (f9 f10 ?v4) ?v6)) (f8 ?v_0 (+ (f8 (f9 f10 ?v2) ?v3) (f8 (f9 f10 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f8 (f9 f10 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (+ ?v1 ?v2)) (+ (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (- ?v1 ?v2)) (- (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) ?v1) (- (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (+ ?v0 ?v1)) ?v2) (+ (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (- ?v0 ?v1)) ?v2) (- (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f8 (f9 f10 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f11 f12 ?v2))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f8 ?v_1 ?v0) (f8 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 (f9 f10 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f30 ?v0) ?v1) (f3 (f4 f30 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f4 f30 ?v0)) (?v_0 (f4 f30 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f9 f10 ?v0)) (?v_0 (f9 f10 ?v1))) (= (f8 ?v_1 (f8 ?v_0 ?v2)) (f8 ?v_0 (f8 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f30 ?v0))) (= (f3 ?v_0 (f3 (f4 f30 ?v1) ?v2)) (f3 (f4 f30 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2)) (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f30 ?v0))) (= (f3 (f4 f30 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f30 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f30 ?v0))) (= (f3 (f4 f30 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f30 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 (f9 f10 (f8 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f30 ?v0)) (?v_1 (f3 (f4 f30 ?v2) ?v3))) (= (f3 (f4 f30 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f4 f30 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0)) (?v_1 (f8 (f9 f10 ?v2) ?v3))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v_1) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f4 f30 (f3 (f4 f30 ?v0) ?v1))) (?v_0 (f4 f30 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f9 f10 (f8 (f9 f10 ?v0) ?v1))) (?v_0 (f9 f10 ?v2))) (= (f8 ?v_1 (f8 ?v_0 ?v3)) (f8 ?v_0 (f8 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f30 ?v0))) (= (f3 (f4 f30 (f3 ?v_0 ?v1)) (f3 (f4 f30 ?v2) ?v3)) (f3 (f4 f30 (f3 ?v_0 ?v2)) (f3 (f4 f30 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) (f8 (f9 f10 ?v2) ?v3)) (f8 (f9 f10 (f8 ?v_0 ?v2)) (f8 (f9 f10 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 (f4 f30 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f11 (f20 f21 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f11 (f20 f21 ?v0) ?v2)) (f11 (f20 f21 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f4 f26 (f3 (f4 f30 ?v0) ?v1)) ?v2) (f3 (f4 f30 (f3 (f4 f26 ?v0) ?v2)) (f3 (f4 f26 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f11 (f20 f21 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f11 (f20 f21 ?v0) ?v2)) (f11 (f20 f21 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f4 f26 (f3 (f4 f30 ?v0) ?v1)) ?v2) (f3 (f4 f30 (f3 (f4 f26 ?v0) ?v2)) (f3 (f4 f26 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f11 (f20 f21 ?v0) ?v1))) (= (f8 (f9 f10 ?v_0) ?v0) (f8 (f9 f10 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f3 (f4 f26 ?v0) ?v1))) (= (f3 (f4 f30 ?v_0) ?v0) (f3 (f4 f30 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f8 (f9 f10 (f11 ?v_0 ?v1)) ?v0) (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 (f4 f30 (f3 ?v_0 ?v1)) ?v0) (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f3 (f4 f30 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1)) (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 (f4 f30 ?v0) (f3 ?v_0 ?v1)) (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int)) (= (f11 (f20 f21 ?v0) (f6 f7 3)) (f8 (f9 f10 (f8 (f9 f10 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f26 ?v0) (f6 f7 3)) (f3 (f4 f30 (f3 (f4 f30 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f20 f21 ?v0) (f6 f7 2)) (f8 (f9 f10 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f26 ?v0) (f6 f7 2)) (f3 (f4 f30 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 (f11 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f30 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f30 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f30 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 ?v0) ?v0) (f11 (f20 f21 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f30 ?v0) ?v0) (f3 (f4 f26 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (f8 (f9 f10 ?v0) (f8 (f9 f24 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (f8 (f9 f10 ?v2) ?v0)) (< (f8 (f9 f24 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (f8 (f9 f10 ?v2) ?v0) ?v0)) (<= (f8 (f9 f24 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S9) (?v1 Int) (?v2 Int)) (= (= (f16 ?v0 (f8 (f9 f24 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f16 ?v0 0) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (f8 (f9 f10 ?v2) ?v3) ?v4)))) (= (f16 ?v0 ?v3) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (f8 (f9 f10 ?v2) ?v3) ?v4)))) (= (f16 ?v0 ?v3) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f24 ?v1))) (=> (< 0 ?v0) (= (f8 ?v_0 (f8 (f9 f10 ?v2) ?v0)) (f8 (f9 f24 (f8 ?v_0 ?v2)) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (f8 (f9 f10 ?v1) ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f8 (f9 f24 ?v0) ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f20 f21 ?v1)) (?v_1 (f6 f7 ?v0))) (=> (< 0 ?v0) (= (f11 ?v_0 ?v_1) (f8 (f9 f10 ?v1) (f11 ?v_0 (f6 f7 (- (f11 f12 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f8 (f9 f10 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f11 (f20 f21 ?v0) ?v_0) (f11 (f20 f21 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f6 f7 2)) (?v_0 (f6 f7 3)) (?v_3 (f20 f21 ?v1)) (?v_1 (f20 f21 ?v0))) (= (f11 (f20 f21 (- ?v0 ?v1)) ?v_0) (- (+ (- (f11 ?v_1 ?v_0) (f8 (f9 f10 (* 3 (f11 ?v_1 ?v_2))) ?v1)) (f8 (f9 f10 (* 3 ?v0)) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f6 f7 2)) (?v_0 (f6 f7 3)) (?v_1 (f20 f21 ?v0)) (?v_3 (f20 f21 ?v1))) (= (f11 (f20 f21 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f11 ?v_1 ?v_0) (f8 (f9 f10 (* 3 (f11 ?v_1 ?v_2))) ?v1)) (f8 (f9 f10 (* 3 ?v0)) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f20 f21 (- ?v0 ?v1)) ?v_0) (+ (- (f11 (f20 f21 ?v0) ?v_0) (f8 (f9 f10 (* 2 ?v0)) ?v1)) (f11 (f20 f21 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f20 f21 (+ ?v0 ?v1)) ?v_0) (+ (+ (f11 (f20 f21 ?v0) ?v_0) (f8 (f9 f10 (* 2 ?v0)) ?v1)) (f11 (f20 f21 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f20 f21 ?v0))) (= (f8 (f9 f10 ?v0) (f11 ?v_0 (f6 f7 2))) (f11 ?v_0 (f6 f7 3))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f14 ?v0) f1) (=> (< 0 ?v1) (=> (= (f16 (f18 (f19 (f8 (f9 f10 ?v1) ?v2)) 0) ?v0) f1) (or (= (f16 (f18 (f19 ?v1) 0) ?v0) f1) (= (f16 (f18 (f19 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f14 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f16 (f18 (f19 ?v1) 0) ?v0) f1)) (not (= (f16 (f18 (f19 ?v2) 0) ?v0) f1))) (not (= (f16 (f18 (f19 (f8 (f9 f10 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f14 ?v0) f1) (=> (not (= (f16 (f18 (f19 ?v1) 0) ?v0) f1)) (=> (not (= (f16 (f18 (f19 ?v2) 0) ?v0) f1)) (not (= (f16 (f18 (f19 (f8 (f9 f10 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 ?v1))) (=> (= (f14 ?v0) f1) (=> (< 0 ?v1) (=> (= (f16 (f18 (f19 (f8 (f9 f10 ?v1) ?v1)) 1) ?v0) f1) (or (= (f16 (f18 ?v_0 1) ?v0) f1) (= (f16 (f18 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f16 (f18 (f19 (f8 (f9 f10 ?v1) ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 (f8 (f9 f29 ?v3) ?v0)))) (=> (= (f16 (f18 (f19 (f8 (f9 f10 ?v0) ?v1)) ?v2) ?v3) f1) (= (f16 (f18 (f19 (f8 (f9 f10 (f8 ?v_0 ?v0)) ?v1)) (f8 ?v_0 ?v2)) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f8 (f9 f10 ?v1) (f8 (f9 f29 ?v2) ?v3)))) (=> (= (f16 (f18 (f19 ?v0) ?v_0) ?v2) f1) (= (f16 (f18 (f19 (f8 (f9 f10 ?v0) ?v3)) (f8 (f9 f10 ?v_0) ?v3)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v3)) (?v_1 (f9 f29 ?v0))) (=> (< 2 ?v0) (=> (= (f16 (f18 (f19 ?v1) ?v2) ?v0) f1) (= (f16 (f18 (f19 (f8 ?v_0 (f8 ?v_1 ?v1))) (f8 ?v_0 (f8 ?v_1 ?v2))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f16 (f18 (f19 ?v1) 0) ?v0) f1)) (= (f16 (f18 (f19 (f8 (f9 f10 ?v1) (f8 (f9 f29 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f29 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (let ((?v_2 (f8 ?v_0 ?v_1))) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f16 (f18 (f19 ?v1) 0) ?v0) f1)) (= (f16 (f18 (f19 ?v_2) (f8 (f9 f10 (f8 (f9 f10 ?v1) ?v_1)) ?v_2)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f16 (f18 (f19 ?v1) 0) ?v0) f1)) (= (f16 (f18 (f19 (f8 (f9 f10 (f8 (f9 f29 ?v0) ?v1)) ?v1)) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f29 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (not (= (f16 (f18 (f19 ?v1) 0) ?v0) f1)) (= (f16 (f18 (f19 (f8 (f9 f10 (f8 (f9 f10 ?v1) ?v_1)) (f8 ?v_0 ?v_1))) ?v1) ?v0) f1))))))))
(assert (forall ((?v0 Int)) (= (f8 f23 ?v0) (ite (<= ?v0 0) 1 (f8 (f9 f10 ?v0) (f8 f23 (- ?v0 1)))))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f20 f21 ?v1))) (=> (< 0 ?v_0) (= (f8 (f9 f10 (f11 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f11 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f4 f26 ?v1))) (=> (< 0 ?v_0) (= (f3 (f4 f30 (f3 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f20 f21 ?v2))) (=> (<= ?v_1 ?v_0) (= (f11 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f8 (f9 f10 (f11 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f4 f26 ?v2))) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f3 (f4 f30 (f3 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f16 (f18 (f19 (f8 (f9 f10 ?v1) (f8 (f9 f31 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1)))) (f6 f7 (f8 (f9 f10 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (= (f6 f7 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0)))) (f11 f12 (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v0)))) (f11 f12 (f6 f7 (- ?v1)))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f12 (f6 f7 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f6 f7 (f8 (f9 f10 ?v_0) ?v_0)) (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v0 1)))) (f11 f12 (f6 f7 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f6 f7 (+ ?v_1 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (* ?v_0 2)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (* 2 ?v_0)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f11 (f20 f21 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 (f4 f26 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f11 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f11 (f20 f21 (f11 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f3 (f4 f26 (f3 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f11 (f20 f21 (f11 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f3 (f4 f26 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 (f9 f24 (- ?v0 1)) 2))) (= (f6 f7 (* 2 (f11 f12 (f6 f7 ?v_0)))) (f6 f7 (* 2 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f11 (f20 f21 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 2)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (= (f6 f7 (- (f11 f12 (f3 (f4 f26 ?v0) ?v_0)) (f11 f12 (f3 (f4 f26 ?v1) ?v_0)))) (f6 f7 (f8 (f9 f10 (+ ?v_1 ?v_2)) (f11 f12 (f6 f7 (- ?v_1 ?v_2)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) (f6 f7 1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 (f3 ?v_0 (f6 f7 (- (f11 f12 ?v1) 1)))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= ?v1 (f8 (f9 f31 ?v0) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f8 (f9 f31 ?v0) ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f8 (f9 f31 ?v0) ?v1) 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f14 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (not (= (f8 (f9 f31 ?v0) ?v1) ?v_0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (< 1 (f8 (f9 f31 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f14 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (< (f8 (f9 f31 ?v0) ?v1) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f31 ?v0))) (=> (= (f14 ?v0) f1) (=> (<= 5 ?v0) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f8 ?v_0 (f8 ?v_0 ?v1)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 S2)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f16 (f18 (f19 (f11 ?v_0 ?v1)) 1) ?v2) f1) (= (f16 (f18 (f19 (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v3))))) 1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (let ((?v_1 (f8 (f9 f10 ?v2) ?v0))) (let ((?v_0 (- ?v1 ?v_1))) (<= (ite (< ?v_0 0) (* (- 2) ?v_0) (- (* 2 ?v1) (* 2 ?v_1))) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f18 (f32 ?v1) ?v0))) (=> (= (f14 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 (- ?v0 1)) (=> (= (f27 ?v2 ?v_0) f1) (= (f27 (f8 (f9 f31 ?v0) ?v2) ?v_0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 1 ?v0) (=> (not (= (f27 ?v1 (f18 (f32 (- ?v0 1)) ?v2)) f1)) (=> (= (f27 ?v1 (f18 (f32 ?v0) ?v2)) f1) (or (= ?v1 ?v0) (= ?v1 (f8 (f9 f31 ?v2) ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f14 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (< 1 ?v2) (=> (<= ?v2 ?v1) (= (f27 ?v2 (f18 (f32 ?v1) ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f14 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (= (f27 ?v2 (f18 (f32 ?v1) ?v0)) f1) (< 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f14 ?v0) f1) (=> (< ?v1 ?v_0) (=> (= (f27 ?v2 (f18 (f32 ?v1) ?v0)) f1) (< ?v2 ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (= (f27 ?v0 (f18 (f32 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 1 ?v0) (=> (= (f27 ?v1 (f18 (f32 (- ?v0 1)) ?v2)) f1) (= (f27 ?v1 (f18 (f32 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1)) (?v_1 (f18 (f32 ?v1) ?v0))) (=> (= (f14 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 ?v_0) (=> (< 1 ?v2) (=> (< ?v2 ?v_0) (=> (= (f27 (f8 (f9 f31 ?v0) ?v2) ?v_1) f1) (= (f27 ?v2 ?v_1) f1))))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (- ?v0 2))) (=> (= (f14 ?v0) f1) (= (f33 ?v_0) (f18 (f32 ?v_0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f34 ?v0) f1) (=> (= (f34 ?v1) f1) (= (f34 (f8 (f9 f10 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f27 ?v0 (f33 ?v1)) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f27 ?v0 (f33 ?v1)) f1) (< 1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= (f27 ?v1 (f33 ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (<= ?v0 ?v1) (= (f27 ?v0 (f33 ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (<= ?v_0 (f8 (f9 f10 ?v_0) ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0))) (<= ?v_0 (f8 ?v_1 (f8 ?v_1 ?v_0)))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 0 (f11 f12 ?v0))) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 1 (f11 f12 ?v0))) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (< 0 (f8 (f9 f10 ?v_0) ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 0)) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
