(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S1)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S2) Int)
(declare-fun f7 () S4)
(declare-fun f8 () Int)
(declare-fun f9 () Int)
(declare-fun f10 (Int) S1)
(declare-fun f11 (S5 Int) Int)
(declare-fun f12 (S6 Int) S5)
(declare-fun f13 () S6)
(declare-fun f14 (S7 Int) S4)
(declare-fun f15 () S7)
(declare-fun f16 () Int)
(declare-fun f17 (S8 S9) Int)
(declare-fun f18 () S8)
(declare-fun f19 (Int Int) S9)
(declare-fun f20 (Int) S1)
(declare-fun f21 () S6)
(declare-fun f22 (Int Int) S1)
(declare-fun f23 (Int Int) S1)
(declare-fun f24 (Int Int Int) S1)
(declare-fun f25 () Int)
(assert (not (= f1 f2)))
(assert (not (= f3 f1)))
(assert (forall ((?v0 S2)) (=> (= ?v0 (f4 f5 (- (f6 f7 (f4 f5 f8)) 1))) (=> (< 0 (f6 f7 ?v0)) (= f3 f1)))))
(assert (< 1 f8))
(assert (< 1 f8))
(assert (<= 1 f8))
(assert (< f8 (+ (* 4 f9) 1)))
(assert (= (f10 (f11 (f12 f13 (+ (* 4 f9) 1)) f8)) f1))
(assert (=> (= f8 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 2))) (= (+ (f6 (f14 f15 ?v0) ?v_0) (f6 (f14 f15 ?v1) ?v_0)) (+ (* 4 f9) 1))))))
(assert (= (+ (f6 (f14 f15 f16) (f4 f5 2)) 1) (f11 (f12 f13 (+ (* 4 f9) 1)) f8)))
(assert (< 0 (+ (* 4 f9) 1)))
(assert (= (f17 f18 (f19 f16 1)) (f11 (f12 f13 (+ (* 4 f9) 1)) f8)))
(assert (let ((?v_0 (f6 (f14 f15 f16) (f4 f5 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (= (f20 (+ (* 4 f9) 1)) f1))
(assert (= (f11 (f12 f21 (- 1)) (+ (* 4 f9) 1)) 1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f6 (f14 f15 f16) (f4 f5 2)) 1) (f11 (f12 f13 (+ (* 4 f9) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f12 f13 ?v0)) (?v_1 (f12 f13 ?v1))) (= (f11 (f12 f13 (f17 f18 (f19 ?v0 ?v1))) (f17 f18 (f19 ?v2 ?v3))) (f17 f18 (f19 (+ (f11 ?v_0 ?v2) (f11 ?v_1 ?v3)) (- (f11 ?v_0 ?v3) (f11 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (= (f10 ?v1) f1) (= (f10 (f11 (f12 f13 ?v0) ?v1)) f1)))))
(assert (= (f22 (+ (* 4 f9) 1) (- 1)) f1))
(assert (forall ((?v0 Int)) (= (= (f10 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f17 f18 (f19 ?v1 ?v2)) ?v0)))))
(assert (= (f23 (+ (* 4 f9) 1) (+ (f6 (f14 f15 f16) (f4 f5 2)) 1)) f1))
(assert (= (f23 (+ (* 4 f9) 1) (- (f6 (f14 f15 f16) (f4 f5 2)) (- 1))) f1))
(assert (= (f24 (f6 (f14 f15 f16) (f4 f5 2)) (- 1) (+ (* 4 f9) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f9) 1))) (and (<= 0 f16) (and (< f16 ?v_0) (= (f24 f25 f16 ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f6 ?v_0 (f4 f5 (+ (f6 f7 ?v1) (f6 f7 ?v2)))) (f11 (f12 f13 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f14 f15 ?v0))) (= (f11 (f12 f13 ?v0) (f6 ?v_0 (f4 f5 2))) (f6 ?v_0 (f4 f5 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 2))) (= (f6 (f14 f15 (+ ?v0 ?v1)) ?v_0) (+ (+ (f6 (f14 f15 ?v0) ?v_0) (f11 (f12 f13 (* 2 ?v0)) ?v1)) (f6 (f14 f15 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 2))) (= (f6 (f14 f15 (- ?v0 ?v1)) ?v_0) (+ (- (f6 (f14 f15 ?v0) ?v_0) (f11 (f12 f13 (* 2 ?v0)) ?v1)) (f6 (f14 f15 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f4 f5 2)) (?v_0 (f4 f5 3)) (?v_1 (f14 f15 ?v0)) (?v_3 (f14 f15 ?v1))) (= (f6 (f14 f15 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f6 ?v_1 ?v_0) (f11 (f12 f13 (* 3 (f6 ?v_1 ?v_2))) ?v1)) (f11 (f12 f13 (* 3 ?v0)) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (= (f24 (f6 (f14 f15 f25) (f4 f5 2)) (- 1) (+ (* 4 f9) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f9) 1))) (=> (not (= (f22 ?v_0 (- 1)) f1)) (not (= (f11 (f12 f21 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f24 (f6 (f14 f15 ?v0) (f4 f5 2)) (- 1) (+ (* 4 f9) 1)) f1) false)) false))
(assert (let ((?v_0 (f4 f5 2))) (= (f24 (f6 (f14 f15 f16) ?v_0) (f6 (f14 f15 f25) ?v_0) (+ (* 4 f9) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f9) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f24 f25 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f9) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f24 f25 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f24 f25 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f20 ?v0) f1) (=> (= (f23 ?v0 (f6 (f14 f15 ?v1) ?v2)) f1) (= (f23 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f23 ?v0 (- ?v1 ?v2)) f1) (=> (= (f23 ?v0 ?v2) f1) (= (f23 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f23 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f20 ?v_0) f1) (= (f11 (f12 f21 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f23 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (= (= (f23 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (= (f20 2) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f13 ?v0))) (=> (= (f23 (f11 ?v_0 ?v1) (f11 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f23 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f23 ?v0 ?v1) f1) (= (= (f23 ?v0 (+ ?v2 ?v3)) f1) (= (f23 ?v0 (+ (+ ?v2 (f11 (f12 f13 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f23 (f11 (f12 f13 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f23 ?v0 (+ ?v1 (f11 (f12 f13 ?v0) ?v2))) f1) (= (f23 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f6 (f14 f15 ?v0) ?v2))) (=> (= (f20 ?v0) f1) (=> (not (= (f23 ?v0 ?v1) f1)) (=> (= (f23 ?v_0 (f11 (f12 f13 ?v3) ?v1)) f1) (= (f23 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f6 (f14 f15 ?v0) ?v2))) (=> (= (f20 ?v0) f1) (=> (not (= (f23 ?v0 ?v1) f1)) (=> (= (f23 ?v_0 (f11 (f12 f13 ?v1) ?v3)) f1) (= (f23 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 (f12 f13 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 (f12 f13 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f6 f7 ?v2))) (let ((?v_1 (f12 f13 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f11 ?v_1 ?v0) (f11 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f13 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f11 ?v_0 ?v0) (f11 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f11 (f12 f13 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f11 (f12 f13 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f11 (f12 f13 (- ?v0 ?v1)) ?v2) (- (f11 (f12 f13 ?v0) ?v2) (f11 (f12 f13 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f11 (f12 f13 (+ ?v0 ?v1)) ?v2) (+ (f11 (f12 f13 ?v0) ?v2) (f11 (f12 f13 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f13 ?v0))) (= (f11 (f12 f13 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f11 (f12 f13 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f11 (f12 f13 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f13 (- ?v0)) ?v1) (- (f11 (f12 f13 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f13 ?v0))) (= (f11 ?v_0 (- ?v1 ?v2)) (- (f11 ?v_0 ?v1) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f13 ?v0))) (= (f11 ?v_0 (+ ?v1 ?v2)) (+ (f11 ?v_0 ?v1) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f13 ?v0) ?v1) (f11 (f12 f13 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f6 (f14 f15 ?v0) (f4 f5 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 2))) (= (= (f6 (f14 f15 ?v0) ?v_0) (f6 (f14 f15 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 2)) (?v_1 (f14 f15 ?v0))) (= (f6 (f14 f15 (f6 ?v_1 ?v_0)) ?v_0) (f6 ?v_1 (f4 f5 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 3))) (= (f6 (f14 f15 (- ?v0)) ?v_0) (- (f6 (f14 f15 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (< 0 (f6 (f14 f15 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f4 f5 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f4 f5 3))) (let ((?v_0 (f6 (f14 f15 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f6 (f14 f15 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f4 f5 2))) (let ((?v_0 (f6 (f14 f15 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f6 (f14 f15 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f6 (f14 f15 ?v0) (f4 f5 2)))))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f6 (f14 f15 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 2))) (= (f11 (f12 f13 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f6 (f14 f15 ?v0) ?v_0) (f6 (f14 f15 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f4 f5 2)) (?v_0 (f4 f5 3)) (?v_3 (f14 f15 ?v1)) (?v_1 (f14 f15 ?v0))) (= (f6 (f14 f15 (- ?v0 ?v1)) ?v_0) (- (+ (- (f6 ?v_1 ?v_0) (f11 (f12 f13 (* 3 (f6 ?v_1 ?v_2))) ?v1)) (f11 (f12 f13 (* 3 ?v0)) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0) f1) (=> (not (= (f23 ?v0 ?v1) f1)) (= (f24 (f6 (f14 f15 ?v1) (f4 f5 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f21 ?v0) ?v1) (ite (= (f24 ?v0 0 ?v1) f1) 0 (ite (= (f22 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f22 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f24 (f6 (f14 f15 ?v2) (f4 f5 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f20 ?v0) f1) (=> (= (f23 ?v0 (f6 (f14 f15 ?v1) ?v2)) f1) (=> (< 0 (f6 f7 ?v2)) (= (f23 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f20 ?v0) f1) (=> (= (f23 ?v0 (f11 (f12 f13 ?v1) ?v2)) f1) (or (= (f23 ?v0 ?v1) f1) (= (f23 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f20 ?v1) f1) (=> (= (f23 ?v1 (f11 (f12 f13 ?v0) ?v2)) f1) (or (= (f23 ?v1 ?v0) f1) (= (f23 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f20 ?v0) f1) (=> (not (= (f24 ?v1 0 ?v0) f1)) (=> (not (= (f24 ?v2 0 ?v0) f1)) (not (= (f24 (f11 (f12 f13 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f24 (f11 (f12 f13 ?v1) ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f20 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f24 ?v1 0 ?v0) f1)) (not (= (f24 ?v2 0 ?v0) f1))) (not (= (f24 (f11 (f12 f13 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f20 ?v0) f1) (=> (< 0 ?v1) (=> (= (f24 (f11 (f12 f13 ?v1) ?v2) 0 ?v0) f1) (or (= (f24 ?v1 0 ?v0) f1) (= (f24 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f12 f13 ?v1))) (= (+ (f11 (f12 f13 (- ?v0 (f11 ?v_0 ?v2))) ?v3) (f11 (f12 f13 (- ?v4 (f11 ?v_0 ?v5))) ?v6)) (- (+ (f11 (f12 f13 ?v0) ?v3) (f11 (f12 f13 ?v4) ?v6)) (f11 ?v_0 (+ (f11 (f12 f13 ?v2) ?v3) (f11 (f12 f13 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f24 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f24 ?v0 ?v1 ?v2) f1) (= (f24 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f24 ?v0 ?v1 (- ?v2)) f1) (= (f24 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int)) (= (f24 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f24 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f24 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f24 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f24 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f24 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f24 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f24 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f24 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f24 ?v1 (- 1) ?v0) f1) (not (= (f24 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f24 ?v0 ?v1 ?v2) f1) (= (f24 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f24 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f24 ?v3 ?v4 ?v2) f1) (= (f24 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f24 ?v0 ?v1 ?v2) f1) (=> (= (f24 ?v1 ?v3 ?v2) f1) (= (f24 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f24 ?v0 ?v1 ?v2) f1) (=> (= (f24 ?v3 ?v4 ?v2) f1) (= (f24 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f24 ?v0 ?v1 ?v2) f1) (=> (= (f24 ?v3 ?v4 ?v2) f1) (= (f24 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f24 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f11 (f12 f13 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f24 (f11 (f12 f13 ?v0) ?v1) (f11 (f12 f13 ?v2) ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f24 ?v0 ?v1 ?v2) f1) (= (= (f24 ?v3 (f11 (f12 f13 ?v0) ?v4) ?v2) f1) (= (f24 ?v3 (f11 (f12 f13 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f12 f13 ?v4))) (=> (= (f24 ?v0 ?v1 ?v2) f1) (= (= (f24 ?v3 (f11 ?v_0 ?v0) ?v2) f1) (= (f24 ?v3 (f11 ?v_0 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f24 ?v0 ?v1 ?v2) f1) (= (f24 (f11 (f12 f13 ?v0) ?v3) (f11 (f12 f13 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f12 f13 ?v3))) (=> (= (f24 ?v0 ?v1 ?v2) f1) (= (f24 (f11 ?v_0 ?v0) (f11 ?v_0 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f24 ?v0 ?v1 ?v2) f1) (=> (= (f24 ?v3 ?v4 ?v2) f1) (= (f24 (f11 (f12 f13 ?v0) ?v3) (f11 (f12 f13 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f24 ?v0 0 ?v1) f1) (= (f23 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f24 ?v0 0 ?v1) f1) (= (f23 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f24 ?v0 ?v1 ?v2) f1) (= (f23 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S2)) (=> (= (f24 ?v0 ?v1 ?v2) f1) (= (f24 (f6 (f14 f15 ?v0) ?v3) (f6 (f14 f15 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (=> (< 0 (f6 f7 ?v0)) (=> (= (f23 ?v1 ?v2) f1) (= (f23 ?v1 (f6 (f14 f15 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int)) (= (= (f20 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f23 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0) f1) (=> (< 0 ?v1) (=> (= (f24 (f11 (f12 f13 ?v1) ?v1) 1 ?v0) f1) (or (= (f24 ?v1 1 ?v0) f1) (= (f24 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f24 ?v0 0 ?v1) f1)) (=> (= (f24 (f6 (f14 f15 ?v2) (f4 f5 2)) ?v0 ?v1) f1) (not (= (f23 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f20 ?v1) f1) (= (f23 ?v1 ?v0) f1))))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f4 f5 0))) (= (= (f23 (f6 (f14 f15 ?v1) ?v0) (f6 (f14 f15 ?v2) ?v0)) f1) (= (f23 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int)) (=> (= (f23 (f6 (f14 f15 ?v0) ?v1) (f6 (f14 f15 ?v2) ?v1)) f1) (=> (not (= ?v1 (f4 f5 0))) (= (f23 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f14 f15 (- 1)))) (let ((?v_1 (f6 ?v_0 ?v1)) (?v_2 (f6 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f24 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 ?v1)) (?v_1 (f4 f5 ?v0))) (=> (< 0 ?v0) (= (f6 ?v_0 ?v_1) (f11 (f12 f13 ?v1) (f6 ?v_0 (f4 f5 (- (f6 f7 ?v_1) 1)))))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f24 1 (- 1) ?v0) f1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 (f14 f15 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f13 ?v0))) (=> (not (= ?v0 0)) (= (= (f23 ?v1 ?v2) f1) (= (f23 (f11 ?v_0 ?v1) (f11 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S2)) (= (f4 f5 (f6 f7 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f4 f5 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f6 f7 (f4 f5 ?v0)) 0))))
(check-sat)
(exit)
