(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () Int)
(declare-fun f4 () Int)
(declare-fun f5 () Int)
(declare-fun f6 (S2 S3) Int)
(declare-fun f7 () S2)
(declare-fun f8 () S3)
(declare-fun f9 () S3)
(declare-fun f10 (S4 Int) S3)
(declare-fun f11 () S4)
(declare-fun f12 (Int Int) S1)
(declare-fun f13 (S5 Int) S2)
(declare-fun f14 () S5)
(declare-fun f15 (S6 Int) Int)
(declare-fun f16 (S7 Int) S6)
(declare-fun f17 () S7)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () Int)
(declare-fun f22 () Int)
(declare-fun f23 () Int)
(declare-fun f24 (Int) S1)
(declare-fun f25 (Int) S1)
(declare-fun f26 () S7)
(declare-fun f27 () Int)
(declare-fun f28 (Int Int) S1)
(declare-fun f29 (Int Int Int) S1)
(declare-fun f30 (S8 S9) Int)
(declare-fun f31 () S8)
(declare-fun f32 (Int Int) S9)
(declare-fun f33 () Int)
(assert (not (= f1 f2)))
(assert (not (and (<= 0 (ite (< f3 0) (* (- 2) f3) (* 2 f3))) (<= 0 (ite (< f4 0) (* (- 2) f4) (* 2 f4))))))
(assert (< 1 f5))
(assert (< 0 (f6 f7 f8)))
(assert (= f9 (f10 f11 (- (f6 f7 (f10 f11 f5)) 1))))
(assert (<= 1 f5))
(assert (let ((?v_0 (f10 f11 2))) (= (f12 (+ 1 (f6 f7 f8)) (+ (f6 (f13 f14 f3) ?v_0) (f6 (f13 f14 f4) ?v_0))) f1)))
(assert (let ((?v_0 (f10 f11 2))) (= (+ (f6 (f13 f14 f3) ?v_0) (f6 (f13 f14 f4) ?v_0)) (f15 (f16 f17 (+ 1 (f6 f7 f8))) f18))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f10 f11 2))) (=> (= (+ (f6 (f13 f14 f3) ?v_0) (f6 (f13 f14 f4) ?v_0)) (f15 (f16 f17 (+ 1 (f6 f7 f8))) ?v0)) false))) false))
(assert (let ((?v_0 (+ 1 (f6 f7 f8)))) (and (= f3 (- f19 (f15 (f16 f17 f20) ?v_0))) (<= (ite (< f3 0) (* (- 2) f3) (* 2 f3)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f6 f7 f8)))) (and (= f4 (- f21 (f15 (f16 f17 f22) ?v_0))) (<= (ite (< f4 0) (* (- 2) f4) (* 2 f4)) ?v_0))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f10 f11 (- (f6 f7 (f10 f11 f5)) 1))) (=> (< 0 (f6 f7 ?v0)) false))) false))
(assert (< 0 (+ 1 (f6 f7 f8))))
(assert (< 0 (+ (* 4 f23) 1)))
(assert (< 0 (f6 f7 f9)))
(assert (not (< f18 (+ 1 (f6 f7 f8)))))
(assert (not (= (f24 (f15 (f16 f17 (+ (* 4 f23) 1)) (+ 1 0))) f1)))
(assert (< f5 (+ (* 4 f23) 1)))
(assert (<= (- (+ 1 (f6 f7 f8)) f18) 0))
(assert (< (- (+ 2 (* 2 (f6 f7 f8))) (* 4 f18)) 0))
(assert (<= (- (+ 4 (* 4 (f6 f7 f8))) (* 4 f18)) 0))
(assert (let ((?v_1 (+ 1 (f6 f7 f8))) (?v_0 (+ (* 4 f23) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f24 (f15 (f16 f17 ?v_0) ?v_1)) f1))))))
(assert (let ((?v_0 (f6 f7 f8))) (< (f15 (f16 f17 (+ 1 ?v_0)) (- (+ 2 (* 2 ?v_0)) (* 4 f18))) 0)))
(assert (let ((?v_0 (f6 f7 f8))) (< (f15 (f16 f17 (+ 1 ?v_0)) (- (+ 2 (* 2 ?v_0)) (* 4 f18))) (+ 0 (* 0 ?v_0)))))
(assert (let ((?v_0 (f10 f11 2))) (= (+ (f6 (f13 f14 f19) ?v_0) (f6 (f13 f14 f21) ?v_0)) (f15 (f16 f17 (+ (* 4 f23) 1)) (+ 1 (f6 f7 f8))))))
(assert (= (f25 (+ (* 4 f23) 1)) f1))
(assert (= (f15 (f16 f26 (- 1)) (+ (* 4 f23) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f6 f7 f8)))) (=> (and (= ?v1 (- f19 (f15 (f16 f17 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f6 f7 f8)))) (=> (and (= ?v1 (- f21 (f15 (f16 f17 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (=> (= (+ (f6 (f13 f14 ?v0) ?v_0) (f6 (f13 f14 ?v1) ?v_0)) (f15 (f16 f17 (+ (* 4 f23) 1)) (+ 1 (f6 f7 f8)))) false))) false))
(assert (= (+ (f6 (f13 f14 f27) (f10 f11 2)) 1) (f15 (f16 f17 (+ (* 4 f23) 1)) f5)))
(assert (let ((?v_1 (+ 1 (f6 f7 f8))) (?v_0 (+ (* 4 f23) 1))) (and (< ?v_1 ?v_0) (= (f24 (f15 (f16 f17 ?v_0) ?v_1)) f1))))
(assert (= (f24 (f15 (f16 f17 (+ (* 4 f23) 1)) f5)) f1))
(assert (=> (= f5 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (+ (f6 (f13 f14 ?v0) ?v_0) (f6 (f13 f14 ?v1) ?v_0)) (+ (* 4 f23) 1))))))
(assert (= (f28 (+ (* 4 f23) 1) (- 1)) f1))
(assert (= (f12 (+ (* 4 f23) 1) (+ (f6 (f13 f14 f27) (f10 f11 2)) 1)) f1))
(assert (= (f12 (+ (* 4 f23) 1) (- (f6 (f13 f14 f27) (f10 f11 2)) (- 1))) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f6 (f13 f14 f27) (f10 f11 2)) 1) (f15 (f16 f17 (+ (* 4 f23) 1)) ?v0)) false)) false))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f10 f11 0))) (= (= (f12 (f6 (f13 f14 ?v1) ?v0) (f6 (f13 f14 ?v2) ?v0)) f1) (= (f12 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f6 f7 ?v0)) (=> (= (f12 ?v1 ?v2) f1) (= (f12 ?v1 (f6 (f13 f14 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f12 (f6 (f13 f14 ?v0) ?v1) (f6 (f13 f14 ?v2) ?v1)) f1) (=> (not (= ?v1 (f10 f11 0))) (= (f12 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f13 f14 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (f6 f7 ?v1) (f6 f7 ?v2)))) (f15 (f16 f17 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f15 (f16 f17 ?v0) (f6 ?v_0 (f10 f11 2))) (f6 ?v_0 (f10 f11 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (f6 (f13 f14 (+ ?v0 ?v1)) ?v_0) (+ (+ (f6 (f13 f14 ?v0) ?v_0) (f15 (f16 f17 (* 2 ?v0)) ?v1)) (f6 (f13 f14 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (f6 (f13 f14 (- ?v0 ?v1)) ?v_0) (+ (- (f6 (f13 f14 ?v0) ?v_0) (f15 (f16 f17 (* 2 ?v0)) ?v1)) (f6 (f13 f14 ?v1) ?v_0))))))
(assert (let ((?v_0 (f6 (f13 f14 f27) (f10 f11 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f23) 1))) (=> (not (= (f28 ?v_0 (- 1)) f1)) (not (= (f15 (f16 f26 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f25 ?v_0) f1) (= (f15 (f16 f26 (- 1)) ?v_0) 1)))))
(assert (= (f25 2) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f25 ?v0) f1) (=> (= (f12 ?v0 (f15 (f16 f17 ?v1) ?v2)) f1) (or (= (f12 ?v0 ?v1) f1) (= (f12 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f25 ?v0) f1) (=> (= (f12 ?v0 (f6 (f13 f14 ?v1) ?v2)) f1) (=> (< 0 (f6 f7 ?v2)) (= (f12 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f25 ?v0) f1) (=> (= (f12 ?v0 (f6 (f13 f14 ?v1) ?v2)) f1) (= (f12 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f6 (f13 f14 ?v0) ?v2))) (=> (= (f25 ?v0) f1) (=> (not (= (f12 ?v0 ?v1) f1)) (=> (= (f12 ?v_0 (f15 (f16 f17 ?v3) ?v1)) f1) (= (f12 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f6 (f13 f14 ?v0) ?v2))) (=> (= (f25 ?v0) f1) (=> (not (= (f12 ?v0 ?v1) f1)) (=> (= (f12 ?v_0 (f15 (f16 f17 ?v1) ?v3)) f1) (= (f12 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 ?v0) f1) (=> (= (f24 ?v1) f1) (= (f24 (f15 (f16 f17 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 (f16 f17 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 (f16 f17 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f6 f7 ?v2))) (let ((?v_1 (f16 f17 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f15 ?v_1 ?v0) (f15 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f17 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f15 ?v_0 ?v0) (f15 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f15 (f16 f17 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f15 (f16 f17 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f15 (f16 f17 (- ?v0 ?v1)) ?v2) (- (f15 (f16 f17 ?v0) ?v2) (f15 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f15 (f16 f17 (+ ?v0 ?v1)) ?v2) (+ (f15 (f16 f17 ?v0) ?v2) (f15 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f15 (f16 f17 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 (f16 f17 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 (f16 f17 (- ?v0)) ?v1) (- (f15 (f16 f17 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (- ?v1 ?v2)) (- (f15 ?v_0 ?v1) (f15 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (+ ?v1 ?v2)) (+ (f15 ?v_0 ?v1) (f15 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 (f16 f17 ?v0) ?v1) (f15 (f16 f17 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f12 ?v0 (- ?v1 ?v2)) f1) (=> (= (f12 ?v0 ?v2) f1) (= (f12 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f12 ?v0 ?v1) f1) (=> (= (f12 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f12 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f12 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f12 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f12 ?v0 ?v1) f1) (=> (= (f12 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f12 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (= (= (f12 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int)) (=> (= (f6 (f13 f14 ?v0) (f10 f11 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (= (f6 (f13 f14 ?v0) ?v_0) (f6 (f13 f14 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f11 2)) (?v_1 (f13 f14 ?v0))) (= (f6 (f13 f14 (f6 ?v_1 ?v_0)) ?v_0) (f6 ?v_1 (f10 f11 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f11 3))) (= (f6 (f13 f14 (- ?v0)) ?v_0) (- (f6 (f13 f14 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f6 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f10 f11 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f10 f11 3))) (let ((?v_0 (f6 (f13 f14 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f6 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f10 f11 2))) (let ((?v_0 (f6 (f13 f14 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f6 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f6 (f13 f14 ?v0) (f10 f11 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f6 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f17 ?v0))) (=> (= (f12 (f15 ?v_0 ?v1) (f15 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f12 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f12 ?v0 ?v1) f1) (= (= (f12 ?v0 (+ ?v2 ?v3)) f1) (= (f12 ?v0 (+ (+ ?v2 (f15 (f16 f17 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f12 (f15 (f16 f17 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f12 ?v0 (+ ?v1 (f15 (f16 f17 ?v0) ?v2))) f1) (= (f12 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (f15 (f16 f17 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f6 (f13 f14 ?v0) ?v_0) (f6 (f13 f14 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f10 f11 2)) (?v_0 (f10 f11 3)) (?v_3 (f13 f14 ?v1)) (?v_1 (f13 f14 ?v0))) (= (f6 (f13 f14 (- ?v0 ?v1)) ?v_0) (- (+ (- (f6 ?v_1 ?v_0) (f15 (f16 f17 (* 3 (f6 ?v_1 ?v_2))) ?v1)) (f15 (f16 f17 (* 3 ?v0)) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f10 f11 2)) (?v_0 (f10 f11 3)) (?v_1 (f13 f14 ?v0)) (?v_3 (f13 f14 ?v1))) (= (f6 (f13 f14 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f6 ?v_1 ?v_0) (f15 (f16 f17 (* 3 (f6 ?v_1 ?v_2))) ?v1)) (f15 (f16 f17 (* 3 ?v0)) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (= (f29 (f6 (f13 f14 f27) (f10 f11 2)) (- 1) (+ (* 4 f23) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f25 ?v1) f1) (=> (= (f12 ?v1 (f15 (f16 f17 ?v0) ?v2)) f1) (or (= (f12 ?v1 ?v0) f1) (= (f12 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f25 ?v1) f1) (= (f12 ?v1 ?v0) f1))))))
(assert (= (f30 f31 (f32 f27 1)) (f15 (f16 f17 (+ (* 4 f23) 1)) f5)))
(assert (let ((?v_0 (+ (* 4 f23) 1))) (and (<= 0 f27) (and (< f27 ?v_0) (= (f29 f33 f27 ?v_0) f1)))))
(assert (forall ((?v0 Int)) (= (= (f25 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f12 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 ?v1)) (?v_1 (f10 f11 ?v0))) (=> (< 0 ?v0) (= (f6 ?v_0 ?v_1) (f15 (f16 f17 ?v1) (f6 ?v_0 (f10 f11 (- (f6 f7 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f17 ?v0))) (=> (not (= ?v0 0)) (= (= (f12 ?v1 ?v2) f1) (= (f12 (f15 ?v_0 ?v1) (f15 ?v_0 ?v2)) f1))))))
(assert (= (f29 (f6 (f13 f14 f33) (f10 f11 2)) (- 1) (+ (* 4 f23) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f29 (f6 (f13 f14 ?v0) (f10 f11 2)) (- 1) (+ (* 4 f23) 1)) f1) false)) false))
(assert (let ((?v_0 (f10 f11 2))) (= (f29 (f6 (f13 f14 f27) ?v_0) (f6 (f13 f14 f33) ?v_0) (+ (* 4 f23) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f23) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f29 f33 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f23) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f29 ?v1 (- 1) ?v0) f1) (not (= (f29 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f29 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f29 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int)) (= (f29 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (f15 (f16 f17 ?v0) ?v3) (f15 (f16 f17 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f16 f17 ?v3))) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f15 ?v_0 ?v0) (f15 ?v_0 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f15 (f16 f17 ?v0) ?v3) (f15 (f16 f17 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f29 (f15 (f16 f17 ?v0) ?v1) (f15 (f16 f17 ?v2) ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f15 (f16 f17 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (= (f12 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 (- ?v2)) f1) (= (f29 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f29 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f29 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f29 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 S3)) (= (f10 f11 (f6 f7 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f10 f11 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f6 f7 (f10 f11 ?v0)) 0))))
(check-sat)
(exit)
