(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 Int) Int)
(declare-fun f9 (S7 Int) S6)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S2) Int)
(declare-fun f12 () S8)
(declare-fun f13 () Int)
(declare-fun f14 () S2)
(declare-fun f15 (S9 Int) S8)
(declare-fun f16 () S9)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () Int)
(declare-fun f22 () Int)
(declare-fun f23 (Int) S1)
(declare-fun f24 (Int) S1)
(declare-fun f25 () S7)
(declare-fun f26 () Int)
(declare-fun f27 () Int)
(declare-fun f28 (Int Int) S1)
(declare-fun f29 () S2)
(declare-fun f30 (Int Int) S1)
(declare-fun f31 () Int)
(declare-fun f32 (Int Int Int) S1)
(declare-fun f33 (S10 S11) Int)
(declare-fun f34 () S10)
(declare-fun f35 (Int Int) S11)
(declare-fun f36 () Int)
(declare-fun f37 (S2 S2) S1)
(declare-fun f38 () S4)
(declare-fun f39 () S6)
(declare-fun f40 () S4)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))))))
(assert (let ((?v_1 (+ 1 (f11 f12 f14))) (?v_0 (f6 f7 2))) (let ((?v_2 (f9 f10 (f11 (f15 f16 ?v_1) ?v_0))) (?v_3 (f9 f10 f19)) (?v_4 (f9 f10 f20))) (not (= (f8 (f9 f10 (f8 (f9 f10 (+ (* 4 f13) 1)) ?v_1)) (+ (f11 (f15 f16 f17) ?v_0) (f11 (f15 f16 f18) ?v_0))) (+ (f8 ?v_2 (f11 (f15 f16 (+ (+ (f8 ?v_3 f17) (f8 ?v_4 f18)) f21)) ?v_0)) (f8 ?v_2 (f11 (f15 f16 (- (f8 ?v_3 f18) (f8 ?v_4 f17))) ?v_0))))))))
(assert (let ((?v_1 (+ 1 (f11 f12 f14))) (?v_0 (f6 f7 2)) (?v_3 (f9 f10 f19)) (?v_4 (f9 f10 f20))) (let ((?v_2 (f9 f10 ?v_1))) (= (f8 (f9 f10 (f8 (f9 f10 (+ (* 4 f13) 1)) ?v_1)) (+ (f11 (f15 f16 f17) ?v_0) (f11 (f15 f16 f18) ?v_0))) (+ (f11 (f15 f16 (+ (+ (f8 ?v_2 (f8 ?v_3 f17)) (f8 ?v_2 (f8 ?v_4 f18))) (f8 ?v_2 f21))) ?v_0) (f11 (f15 f16 (- (f8 ?v_2 (f8 ?v_3 f18)) (f8 ?v_2 (f8 ?v_4 f17)))) ?v_0))))))
(assert (< 1 f22))
(assert (< 0 (f11 f12 f14)))
(assert (< 0 (+ 1 (f11 f12 f14))))
(assert (< 0 (+ (* 4 f13) 1)))
(assert (not (= (f23 (f8 (f9 f10 (+ (* 4 f13) 1)) (+ 1 0))) f1)))
(assert (let ((?v_0 (+ (* 4 f13) 1)) (?v_1 (+ 1 (f11 f12 f14)))) (not (=> (< ?v_1 ?v_0) (not (= (f23 (f8 (f9 f10 ?v_0) ?v_1)) f1))))))
(assert (< f21 (+ 1 (f11 f12 f14))))
(assert (let ((?v_0 (f6 f7 2))) (= (+ (f11 (f15 f16 f17) ?v_0) (f11 (f15 f16 f18) ?v_0)) (f8 (f9 f10 (+ 1 (f11 f12 f14))) f21))))
(assert (let ((?v_1 (+ 1 (f11 f12 f14))) (?v_0 (f6 f7 2)) (?v_3 (f9 f10 f19)) (?v_4 (f9 f10 f20))) (let ((?v_2 (f9 f10 ?v_1))) (= (f8 (f9 f10 (f8 (f9 f10 (+ (* 4 f13) 1)) ?v_1)) (+ (f11 (f15 f16 f17) ?v_0) (f11 (f15 f16 f18) ?v_0))) (+ (f11 (f15 f16 (+ (+ (f8 ?v_2 (f8 ?v_3 f17)) (f8 ?v_2 (f8 ?v_4 f18))) (f8 ?v_2 f21))) ?v_0) (f11 (f15 f16 (- (f8 ?v_2 (f8 ?v_3 f18)) (f8 ?v_2 (f8 ?v_4 f17)))) ?v_0))))))
(assert (= (f24 (+ (* 4 f13) 1)) f1))
(assert (= (f8 (f9 f25 (- 1)) (+ (* 4 f13) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (=> (= (+ (f11 (f15 f16 ?v0) ?v_0) (f11 (f15 f16 ?v1) ?v_0)) (f8 (f9 f10 (+ (* 4 f13) 1)) (+ 1 (f11 f12 f14)))) false))) false))
(assert (let ((?v_0 (+ 1 (f11 f12 f14)))) (and (= f17 (- f26 (f8 (f9 f10 f19) ?v_0))) (<= (ite (< f17 0) (* (- 2) f17) (* 2 f17)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f11 f12 f14)))) (and (= f18 (- f27 (f8 (f9 f10 f20) ?v_0))) (<= (ite (< f18 0) (* (- 2) f18) (* 2 f18)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f11 f12 f14))) (?v_3 (f6 f7 2)) (?v_4 (f9 f10 f19)) (?v_6 (f9 f10 f20))) (let ((?v_5 (f9 f10 ?v_0)) (?v_1 (f9 f10 (+ (f8 ?v_4 ?v_0) f17))) (?v_2 (f9 f10 (+ (f8 ?v_6 ?v_0) f18)))) (= (+ (f11 (f15 f16 (+ (f8 ?v_1 f17) (f8 ?v_2 f18))) ?v_3) (f11 (f15 f16 (- (f8 ?v_1 f18) (f8 ?v_2 f17))) ?v_3)) (+ (f11 (f15 f16 (+ (+ (f8 ?v_5 (f8 ?v_4 f17)) (f8 ?v_5 (f8 ?v_6 f18))) (+ (f11 (f15 f16 f17) ?v_3) (f11 (f15 f16 f18) ?v_3)))) ?v_3) (f11 (f15 f16 (- (f8 ?v_5 (f8 ?v_4 f18)) (f8 ?v_5 (f8 ?v_6 f17)))) ?v_3))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (=> (= (+ (f11 (f15 f16 f17) ?v_0) (f11 (f15 f16 f18) ?v_0)) (f8 (f9 f10 (+ 1 (f11 f12 f14))) ?v0)) false))) false))
(assert (let ((?v_1 (f6 f7 2)) (?v_2 (f9 f10 f19)) (?v_3 (f9 f10 f20)) (?v_0 (f9 f10 (+ 1 (f11 f12 f14))))) (let ((?v_4 (+ (f8 ?v_0 (f8 ?v_2 f17)) (f8 ?v_0 (f8 ?v_3 f18)))) (?v_5 (f11 (f15 f16 (- (f8 ?v_0 (f8 ?v_2 f18)) (f8 ?v_0 (f8 ?v_3 f17)))) ?v_1))) (= (+ (f11 (f15 f16 (+ ?v_4 (+ (f11 (f15 f16 f17) ?v_1) (f11 (f15 f16 f18) ?v_1)))) ?v_1) ?v_5) (+ (f11 (f15 f16 (+ ?v_4 (f8 ?v_0 f21))) ?v_1) ?v_5)))))
(assert (let ((?v_0 (+ (* 4 f13) 1)) (?v_1 (+ 1 (f11 f12 f14)))) (and (< ?v_1 ?v_0) (= (f23 (f8 (f9 f10 ?v_0) ?v_1)) f1))))
(assert (= (f28 (+ (* 4 f13) 1) (- 1)) f1))
(assert (= f29 (f6 f7 (- (f11 f12 (f6 f7 f22)) 1))))
(assert (let ((?v_0 (f6 f7 2))) (= (f30 (+ 1 (f11 f12 f14)) (+ (f11 (f15 f16 f17) ?v_0) (f11 (f15 f16 f18) ?v_0))) f1)))
(assert (let ((?v_0 (f6 f7 2))) (= (+ (f11 (f15 f16 f26) ?v_0) (f11 (f15 f16 f27) ?v_0)) (f8 (f9 f10 (+ (* 4 f13) 1)) (+ 1 (f11 f12 f14))))))
(assert (let ((?v_3 (+ 1 (f11 f12 f14))) (?v_2 (f6 f7 2))) (let ((?v_4 (f9 f10 (+ (f8 (f9 f10 f19) ?v_3) f17))) (?v_5 (f9 f10 (+ (f8 (f9 f10 f20) ?v_3) f18))) (?v_0 (f9 f10 f26)) (?v_1 (f9 f10 f27))) (= (+ (f11 (f15 f16 (+ (f8 ?v_0 f17) (f8 ?v_1 f18))) ?v_2) (f11 (f15 f16 (- (f8 ?v_0 f18) (f8 ?v_1 f17))) ?v_2)) (+ (f11 (f15 f16 (+ (f8 ?v_4 f17) (f8 ?v_5 f18))) ?v_2) (f11 (f15 f16 (- (f8 ?v_4 f18) (f8 ?v_5 f17))) ?v_2))))))
(assert (< f22 (+ (* 4 f13) 1)))
(assert (let ((?v_0 (f6 f7 2))) (let ((?v_1 (+ (f11 (f15 f16 f17) ?v_0) (f11 (f15 f16 f18) ?v_0)))) (= (f8 (f9 f10 (f8 (f9 f10 (+ (* 4 f13) 1)) (+ 1 (f11 f12 f14)))) ?v_1) (f8 (f9 f10 (+ (f11 (f15 f16 f26) ?v_0) (f11 (f15 f16 f27) ?v_0))) ?v_1)))))
(assert (= (+ (f11 (f15 f16 f31) (f6 f7 2)) 1) (f8 (f9 f10 (+ (* 4 f13) 1)) f22)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f11 (f15 f16 f31) (f6 f7 2)) 1) (f8 (f9 f10 (+ (* 4 f13) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f15 f16 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f16 ?v0))) (= (f8 (f9 f10 ?v0) (f11 ?v_0 (f6 f7 2))) (f11 ?v_0 (f6 f7 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f15 f16 (+ ?v0 ?v1)) ?v_0) (+ (+ (f11 (f15 f16 ?v0) ?v_0) (f8 (f9 f10 (* 2 ?v0)) ?v1)) (f11 (f15 f16 ?v1) ?v_0))))))
(assert (< 0 (f11 f12 f29)))
(assert (<= 1 f22))
(assert (let ((?v_0 (f11 (f15 f16 f31) (f6 f7 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 S2)) (=> (= ?v0 (f6 f7 (- (f11 f12 (f6 f7 f22)) 1))) (=> (< 0 (f11 f12 ?v0)) false))) false))
(assert (let ((?v_0 (+ (* 4 f13) 1))) (=> (not (= (f28 ?v_0 (- 1)) f1)) (not (= (f8 (f9 f25 (- 1)) ?v_0) 1)))))
(assert (= (f30 (+ (* 4 f13) 1) (- (f11 (f15 f16 f31) (f6 f7 2)) (- 1))) f1))
(assert (= (f30 (+ (* 4 f13) 1) (+ (f11 (f15 f16 f31) (f6 f7 2)) 1)) f1))
(assert (= (f23 (f8 (f9 f10 (+ (* 4 f13) 1)) f22)) f1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f11 f12 f14)))) (=> (and (= ?v1 (- f27 (f8 (f9 f10 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f11 f12 f14)))) (=> (and (= ?v1 (- f26 (f8 (f9 f10 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (f6 f7 2)) (?v_1 (f9 f10 f26)) (?v_2 (f9 f10 f27))) (= (f8 (f9 f10 (+ (f11 (f15 f16 f26) ?v_0) (f11 (f15 f16 f27) ?v_0))) (+ (f11 (f15 f16 f17) ?v_0) (f11 (f15 f16 f18) ?v_0))) (+ (f11 (f15 f16 (+ (f8 ?v_1 f17) (f8 ?v_2 f18))) ?v_0) (f11 (f15 f16 (- (f8 ?v_1 f18) (f8 ?v_2 f17))) ?v_0)))))
(assert (=> (= f22 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (+ (f11 (f15 f16 ?v0) ?v_0) (f11 (f15 f16 ?v1) ?v_0)) (+ (* 4 f13) 1))))))
(assert (= (f24 2) f1))
(assert (forall ((?v0 Int)) (= (= (f30 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f24 ?v0) f1) (=> (= (f30 ?v0 (f11 (f15 f16 ?v1) ?v2)) f1) (= (f30 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f30 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f24 ?v_0) f1) (= (f8 (f9 f25 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f30 ?v0 ?v1) f1) (=> (= (f30 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f30 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f30 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f30 ?v0 ?v1) f1) (=> (= (f30 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f30 ?v0 (- ?v1 ?v2)) f1) (=> (= (f30 ?v0 ?v2) f1) (= (f30 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f30 (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f30 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1) f1) (= (= (f30 ?v0 (+ ?v2 ?v3)) f1) (= (f30 ?v0 (+ (+ ?v2 (f8 (f9 f10 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f30 (f8 (f9 f10 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 (+ ?v1 (f8 (f9 f10 ?v0) ?v2))) f1) (= (f30 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f11 (f15 f16 ?v0) ?v2))) (=> (= (f24 ?v0) f1) (=> (not (= (f30 ?v0 ?v1) f1)) (=> (= (f30 ?v_0 (f8 (f9 f10 ?v3) ?v1)) f1) (= (f30 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f11 (f15 f16 ?v0) ?v2))) (=> (= (f24 ?v0) f1) (=> (not (= (f30 ?v0 ?v1) f1)) (=> (= (f30 ?v_0 (f8 (f9 f10 ?v1) ?v3)) f1) (= (f30 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0) f1) (=> (= (f23 ?v1) f1) (= (f23 (f8 (f9 f10 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 (f9 f10 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f11 f12 ?v2))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f8 ?v_1 ?v0) (f8 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f8 (f9 f10 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (- ?v0 ?v1)) ?v2) (- (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (+ ?v0 ?v1)) ?v2) (+ (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) ?v1) (- (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (- ?v1 ?v2)) (- (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (+ ?v1 ?v2)) (+ (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f11 (f15 f16 ?v0) (f6 f7 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (= (f11 (f15 f16 ?v0) ?v_0) (f11 (f15 f16 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2)) (?v_1 (f15 f16 ?v0))) (= (f11 (f15 f16 (f11 ?v_1 ?v_0)) ?v_0) (f11 ?v_1 (f6 f7 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 3))) (= (f11 (f15 f16 (- ?v0)) ?v_0) (- (f11 (f15 f16 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (< 0 (f11 (f15 f16 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 3))) (let ((?v_0 (f11 (f15 f16 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f15 f16 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 2))) (let ((?v_0 (f11 (f15 f16 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f15 f16 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f11 (f15 f16 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f11 (f15 f16 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f8 (f9 f10 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f11 (f15 f16 ?v0) ?v_0) (f11 (f15 f16 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f6 f7 2)) (?v_0 (f6 f7 3)) (?v_3 (f15 f16 ?v1)) (?v_1 (f15 f16 ?v0))) (= (f11 (f15 f16 (- ?v0 ?v1)) ?v_0) (- (+ (- (f11 ?v_1 ?v_0) (f8 (f9 f10 (* 3 (f11 ?v_1 ?v_2))) ?v1)) (f8 (f9 f10 (* 3 ?v0)) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f6 f7 2)) (?v_0 (f6 f7 3)) (?v_1 (f15 f16 ?v0)) (?v_3 (f15 f16 ?v1))) (= (f11 (f15 f16 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f11 ?v_1 ?v_0) (f8 (f9 f10 (* 3 (f11 ?v_1 ?v_2))) ?v1)) (f8 (f9 f10 (* 3 ?v0)) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f15 f16 (- ?v0 ?v1)) ?v_0) (+ (- (f11 (f15 f16 ?v0) ?v_0) (f8 (f9 f10 (* 2 ?v0)) ?v1)) (f11 (f15 f16 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f24 ?v0) f1) (=> (= (f30 ?v0 (f11 (f15 f16 ?v1) ?v2)) f1) (=> (< 0 (f11 f12 ?v2)) (= (f30 ?v0 ?v1) f1))))))
(assert (= (f32 (f11 (f15 f16 f31) (f6 f7 2)) (- 1) (+ (* 4 f13) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f24 ?v0) f1) (=> (= (f30 ?v0 (f8 (f9 f10 ?v1) ?v2)) f1) (or (= (f30 ?v0 ?v1) f1) (= (f30 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f24 ?v1) f1) (=> (= (f30 ?v1 (f8 (f9 f10 ?v0) ?v2)) f1) (or (= (f30 ?v1 ?v0) f1) (= (f30 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f24 ?v1) f1) (= (f30 ?v1 ?v0) f1))))))
(assert (= (f33 f34 (f35 f31 1)) (f8 (f9 f10 (+ (* 4 f13) 1)) f22)))
(assert (let ((?v_0 (+ (* 4 f13) 1))) (and (<= 0 f31) (and (< f31 ?v_0) (= (f32 f36 f31 ?v_0) f1)))))
(assert (forall ((?v0 Int)) (= (= (f24 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f30 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int)) (=> (= (f30 (f11 (f15 f16 ?v0) ?v1) (f11 (f15 f16 ?v2) ?v1)) f1) (=> (not (= ?v1 (f6 f7 0))) (= (f30 ?v0 ?v2) f1)))))
(assert (= (f32 (f11 (f15 f16 f36) (f6 f7 2)) (- 1) (+ (* 4 f13) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f32 (f11 (f15 f16 ?v0) (f6 f7 2)) (- 1) (+ (* 4 f13) 1)) f1) false)) false))
(assert (let ((?v_0 (f6 f7 2))) (= (f32 (f11 (f15 f16 f31) ?v_0) (f11 (f15 f16 f36) ?v_0) (+ (* 4 f13) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f13) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f32 f36 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f32 f36 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f13) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f32 f36 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f32 ?v0 ?v1 ?v2) f1) (=> (= (f32 ?v3 ?v4 ?v2) f1) (= (f32 (f8 (f9 f10 ?v0) ?v3) (f8 (f9 f10 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v3))) (=> (= (f32 ?v0 ?v1 ?v2) f1) (= (f32 (f8 ?v_0 ?v0) (f8 ?v_0 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f32 ?v0 ?v1 ?v2) f1) (= (f32 (f8 (f9 f10 ?v0) ?v3) (f8 (f9 f10 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f9 f10 ?v4))) (=> (= (f32 ?v0 ?v1 ?v2) f1) (= (= (f32 ?v3 (f8 ?v_0 ?v0) ?v2) f1) (= (f32 ?v3 (f8 ?v_0 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f32 ?v0 ?v1 ?v2) f1) (= (= (f32 ?v3 (f8 (f9 f10 ?v0) ?v4) ?v2) f1) (= (f32 ?v3 (f8 (f9 f10 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f32 (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v2) ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f32 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f8 (f9 f10 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f32 ?v0 ?v1 ?v2) f1) (=> (= (f32 ?v3 ?v4 ?v2) f1) (= (f32 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f32 ?v0 ?v1 ?v2) f1) (=> (= (f32 ?v3 ?v4 ?v2) f1) (= (f32 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f32 ?v0 ?v1 ?v2) f1) (=> (= (f32 ?v1 ?v3 ?v2) f1) (= (f32 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f32 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f32 ?v3 ?v4 ?v2) f1) (= (f32 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f32 ?v0 ?v1 ?v2) f1) (= (f32 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f32 ?v1 (- 1) ?v0) f1) (not (= (f32 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f32 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f32 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f32 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f32 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f32 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f32 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f32 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f32 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int)) (= (f32 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f32 ?v0 ?v1 (- ?v2)) f1) (= (f32 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f32 ?v0 ?v1 ?v2) f1) (= (f32 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f32 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S2)) (=> (= (f32 ?v0 ?v1 ?v2) f1) (= (f32 (f11 (f15 f16 ?v0) ?v3) (f11 (f15 f16 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f32 ?v0 ?v1 ?v2) f1) (= (f30 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f32 ?v0 0 ?v1) f1) (= (f30 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f32 ?v0 0 ?v1) f1) (= (f30 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0)) (?v_1 (f9 f10 ?v1))) (= (f8 (f9 f10 (f33 f34 (f35 ?v0 ?v1))) (f33 f34 (f35 ?v2 ?v3))) (f33 f34 (f35 (+ (f8 ?v_0 ?v2) (f8 ?v_1 ?v3)) (- (f8 ?v_0 ?v3) (f8 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 ?v0) f1) (=> (< 0 ?v1) (=> (= (f32 (f8 (f9 f10 ?v1) ?v1) 1 ?v0) f1) (or (= (f32 ?v1 1 ?v0) f1) (= (f32 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f24 ?v0) f1) (=> (< 0 ?v1) (=> (= (f32 (f8 (f9 f10 ?v1) ?v2) 0 ?v0) f1) (or (= (f32 ?v1 0 ?v0) f1) (= (f32 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f24 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f32 ?v1 0 ?v0) f1)) (not (= (f32 ?v2 0 ?v0) f1))) (not (= (f32 (f8 (f9 f10 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f32 (f8 (f9 f10 ?v1) ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f24 ?v0) f1) (=> (not (= (f32 ?v1 0 ?v0) f1)) (=> (not (= (f32 ?v2 0 ?v0) f1)) (not (= (f32 (f8 (f9 f10 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f9 f10 ?v1))) (= (+ (f8 (f9 f10 (- ?v0 (f8 ?v_0 ?v2))) ?v3) (f8 (f9 f10 (- ?v4 (f8 ?v_0 ?v5))) ?v6)) (- (+ (f8 (f9 f10 ?v0) ?v3) (f8 (f9 f10 ?v4) ?v6)) (f8 ?v_0 (+ (f8 (f9 f10 ?v2) ?v3) (f8 (f9 f10 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f30 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f6 f7 0))) (= (= (f30 (f11 (f15 f16 ?v1) ?v0) (f11 (f15 f16 ?v2) ?v0)) f1) (= (f30 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (=> (< 0 (f11 f12 ?v0)) (=> (= (f30 ?v1 ?v2) f1) (= (f30 ?v1 (f11 (f15 f16 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int)) (= (= (f23 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f33 f34 (f35 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 ?v0) f1) (=> (not (= (f30 ?v0 ?v1) f1)) (= (f32 (f11 (f15 f16 ?v1) (f6 f7 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f25 ?v0) ?v1) (ite (= (f32 ?v0 0 ?v1) f1) 0 (ite (= (f28 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f28 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f32 (f11 (f15 f16 ?v2) (f6 f7 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f32 ?v0 0 ?v1) f1)) (=> (= (f32 (f11 (f15 f16 ?v2) (f6 f7 2)) ?v0 ?v1) f1) (not (= (f30 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 ?v1)) (?v_1 (f6 f7 ?v0))) (=> (< 0 ?v0) (= (f11 ?v_0 ?v_1) (f8 (f9 f10 ?v1) (f11 ?v_0 (f6 f7 (- (f11 f12 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f15 f16 (- 1)))) (let ((?v_1 (f11 ?v_0 ?v1)) (?v_2 (f11 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f32 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (not (= ?v0 0)) (= (= (f30 ?v1 ?v2) f1) (= (f30 (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f32 (f8 (f9 f10 ?v0) ?v_0) 1 ?v1) f1) (= (f32 ?v0 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f8 (f9 f10 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f8 (f9 f10 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f32 1 (- 1) ?v0) f1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 (f15 f16 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 ?v0 ?v1) f1) (= (f30 (- ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 ?v0 ?v1) f1) (= (f30 ?v0 (- ?v1)) f1))))
(assert (forall ((?v0 Int)) (=> (= (f24 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f30 ?v0 ?v1) f1) (= (f30 (f11 (f15 f16 ?v0) ?v2) (f11 (f15 f16 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f37 ?v0 ?v1) f1) (= (f37 (f3 (f4 f38 ?v0) ?v2) (f3 (f4 f38 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f15 f16 ?v2))) (=> (<= (f11 f12 ?v0) (f11 f12 ?v1)) (= (f30 (f11 ?v_0 ?v0) (f11 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f38 ?v2))) (=> (<= (f11 f12 ?v0) (f11 f12 ?v1)) (= (f37 (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 S2)) (=> (= (f30 ?v0 ?v1) f1) (=> (<= (f11 f12 ?v2) (f11 f12 ?v3)) (= (f30 (f11 (f15 f16 ?v0) ?v2) (f11 (f15 f16 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f37 ?v0 ?v1) f1) (=> (<= (f11 f12 ?v2) (f11 f12 ?v3)) (= (f37 (f3 (f4 f38 ?v0) ?v2) (f3 (f4 f38 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f37 (f6 f7 ?v0) ?v1) f1) (ite (<= 0 ?v0) (= (f30 ?v0 (f11 f12 ?v1)) f1) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 Int)) (= (= (f30 (f11 f12 ?v0) ?v1) f1) (= (f37 ?v0 (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f30 ?v0 (f11 f12 ?v1)) f1) (= (f37 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f37 ?v0 ?v1) f1) (= (f30 (f11 f12 ?v0) (f11 f12 ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 f12 (f3 (f4 f38 ?v0) ?v1)) (f11 (f15 f16 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 (f15 f16 (f11 f12 ?v0)) ?v1) (f11 f12 (f3 (f4 f38 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f6 f7 (f11 (f15 f16 ?v0) ?v1)) (f3 (f4 f38 (f6 f7 ?v0)) ?v1)))))
(assert (forall ((?v0 Int)) (= (f11 (f15 f16 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f38 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f8 f39 (f11 (f15 f16 ?v0) ?v1)) (f11 (f15 f16 (f8 f39 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f11 (f15 f16 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f11 (f15 f16 ?v0) ?v2)) (f11 (f15 f16 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f4 f38 (f3 (f4 f40 ?v0) ?v1)) ?v2) (f3 (f4 f40 (f3 (f4 f38 ?v0) ?v2)) (f3 (f4 f38 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f11 (f15 f16 ?v0) ?v1))) (= (f8 (f9 f10 ?v_0) ?v0) (f8 (f9 f10 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f3 (f4 f38 ?v0) ?v1))) (= (f3 (f4 f40 ?v_0) ?v0) (f3 (f4 f40 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f15 f16 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f38 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f3 (f4 f40 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f15 f16 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 (f11 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f38 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f40 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f15 f16 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f38 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f40 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 S2)) (let ((?v_0 (f15 f16 ?v0))) (=> (= (f30 (f11 ?v_0 ?v1) ?v2) f1) (=> (<= (f11 f12 ?v3) (f11 f12 ?v1)) (= (f30 (f11 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f38 ?v0))) (=> (= (f37 (f3 ?v_0 ?v1) ?v2) f1) (=> (<= (f11 f12 ?v3) (f11 f12 ?v1)) (= (f37 (f3 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f30 (f8 (f9 f10 ?v0) ?v1) ?v2) f1) (= (f30 ?v1 ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f37 (f3 (f4 f40 ?v0) ?v1) ?v2) f1) (= (f37 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f30 (f8 (f9 f10 ?v0) ?v1) ?v2) f1) (= (f30 ?v0 ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f37 (f3 (f4 f40 ?v0) ?v1) ?v2) f1) (= (f37 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 (f8 (f9 f10 ?v1) ?v2)) (= (f30 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= ?v0 (f3 (f4 f40 ?v1) ?v2)) (= (f37 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 0))) (not (and (= (f37 ?v_0 ?v0) f1) (not (= (f37 ?v0 ?v_0) f1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 1))) (not (and (= (f37 ?v0 ?v_0) f1) (not (= (f37 ?v_0 ?v0) f1)))))))
(assert (forall ((?v0 S2)) (= (f37 (f6 f7 1) ?v0) f1)))
(assert (forall ((?v0 S2)) (= (f37 ?v0 (f6 f7 0)) f1)))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 1))) (= (not (= ?v0 ?v_0)) (and (= (f37 ?v_0 ?v0) f1) (not (= (f37 ?v0 ?v_0) f1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 0))) (= (not (= ?v0 ?v_0)) (and (= (f37 ?v0 ?v_0) f1) (not (= (f37 ?v_0 ?v0) f1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f37 ?v_0 ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f37 ?v0 ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 (f6 f7 0))) (= (= (f37 (f3 (f4 f38 ?v1) ?v0) (f3 (f4 f38 ?v2) ?v0)) f1) (= (f37 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 0))) (=> (= (f37 ?v_0 ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (< 0 (f11 f12 ?v0)) (=> (= (f37 ?v1 ?v0) f1) (< 0 (f11 f12 ?v1))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 1))) (=> (= (f37 ?v0 ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f15 f16 ?v0))) (= (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f11 (f15 f16 (f11 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f38 ?v0))) (= (f3 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f3 (f4 f38 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f11 f12 (f3 (f4 f38 ?v0) ?v1))) (or (< 0 (f11 f12 ?v0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (f3 (f4 f38 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f3 (f4 f38 ?v0) ?v1) ?v_0) (or (= ?v1 (f6 f7 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f38 ?v0))) (=> (< 0 (f11 f12 ?v0)) (=> (< (f11 f12 (f3 ?v_0 ?v1)) (f11 f12 (f3 ?v_0 ?v2))) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f11 f12 ?v0)) (<= ?v_0 (f11 f12 (f3 (f4 f38 ?v0) ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f38 ?v0))) (=> (= (f37 (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) f1) (=> (< 1 (f11 f12 ?v0)) (<= (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f15 f16 ?v0))) (= (f11 (f15 f16 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v0)))) (f11 f12 (f6 f7 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (= (f6 f7 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0)))) (f11 f12 (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 S2)) (let ((?v_0 (f15 f16 ?v0))) (=> (= (f32 (f11 ?v_0 ?v1) 1 ?v2) f1) (= (f32 (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v3)))) 1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 f39 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f8 f39 ?v0)) (f8 f39 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f39 ?v0))) (= (f8 (f9 f10 ?v_0) ?v_0) (f8 (f9 f10 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 f39 ?v0) (f8 f39 ?v1)) (= (f30 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f30 ?v0 ?v1) f1) (=> (= (f30 ?v1 ?v2) f1) (= (f30 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f37 ?v0 ?v1) f1) (=> (= (f37 ?v1 ?v2) f1) (= (f37 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 (f8 f39 ?v0) ?v1) f1) (= (f30 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 ?v0 (f8 f39 ?v1)) f1) (= (f30 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int)) (= (f30 ?v0 ?v0) f1)))
(assert (forall ((?v0 S2)) (= (f37 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f30 ?v0 (f8 (f9 f10 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f37 ?v0 (f3 (f4 f40 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f30 ?v0 (f8 (f9 f10 ?v1) ?v0)) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f37 ?v0 (f3 (f4 f40 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f30 ?v0 ?v1) f1) (= (f30 ?v0 (f8 (f9 f10 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f37 ?v0 ?v1) f1) (= (f37 ?v0 (f3 (f4 f40 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f30 ?v0 ?v1) f1) (= (f30 ?v0 (f8 (f9 f10 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f37 ?v0 ?v1) f1) (= (f37 ?v0 (f3 (f4 f40 ?v2) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f30 ?v0 ?v1) f1) (=> (= (f30 ?v2 ?v3) f1) (= (f30 (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f37 ?v0 ?v1) f1) (=> (= (f37 ?v2 ?v3) f1) (= (f37 (f3 (f4 f40 ?v0) ?v2) (f3 (f4 f40 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2)) (= (f37 (f6 f7 (+ 0 1)) ?v0) f1)))
(assert (forall ((?v0 S2)) (= (f37 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f30 ?v0 ?v1) f1) (=> (forall ((?v2 Int)) (=> (= ?v1 (f8 (f9 f10 ?v0) ?v2)) false)) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f37 ?v0 ?v1) f1) (=> (forall ((?v2 S2)) (=> (= ?v1 (f3 (f4 f40 ?v0) ?v2)) false)) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (or (= ?v1 (f6 f7 1)) (= ?v0 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_3 (f11 f12 ?v3)) (?v_1 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_3 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v2))) (let ((?v_2 (f9 f10 ?v_0))) (=> (< ?v_1 ?v_3) (=> (< 0 ?v_0) (< (f8 ?v_2 ?v_1) (f8 ?v_2 ?v_3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f9 f10 (f11 f12 ?v2)))) (=> (<= ?v_0 ?v_2) (<= (f8 ?v_1 ?v_0) (f8 ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f8 (f9 f10 ?v_0) ?v_2) (f8 (f9 f10 ?v_1) ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (<= (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (< (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1)))) (= (= (f6 f7 (f8 ?v_0 (f11 f12 ?v1))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) ?v_0)) (f6 f7 (f8 (f9 f10 (f11 f12 ?v2)) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0)))) (= (= (f6 f7 (f8 ?v_0 (f11 f12 ?v1))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (<= (f8 (f9 f10 ?v_1) ?v_0) (f8 (f9 f10 ?v_2) ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v0))) (let ((?v_0 (f9 f10 ?v_1)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (= (<= (f8 ?v_0 ?v_2) (f8 ?v_0 ?v_3)) (=> (< 0 ?v_1) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (< (f8 (f9 f10 ?v_1) ?v_0) (f8 (f9 f10 ?v_2) ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v0))) (let ((?v_0 (f9 f10 ?v_1)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (= (< (f8 ?v_0 ?v_2) (f8 ?v_0 ?v_3)) (and (< 0 ?v_1) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_2)))) ?v_1)) (f6 f7 (- (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (+ ?v_0 ?v_2)) ?v_1)) (f6 f7 (+ (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f8 ?v_0 ?v_1)) ?v_2)) (f6 f7 (f8 ?v_0 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 (+ ?v_1 1)) ?v_0)) (f6 f7 (+ ?v_0 (f8 (f9 f10 ?v_1) ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (= (<= ?v_0 (f8 (f9 f10 ?v_1) ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_0 (f11 f12 (f6 f7 (- ?v_1 ?v_2))))) (f6 f7 (- (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 ?v_0 (+ ?v_1 ?v_2))) (f6 f7 (+ (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0)) (?v_2 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_1 (+ ?v_2 1))) (f6 f7 (+ ?v_0 (f8 ?v_1 ?v_2))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)) (f6 f7 (f8 (f9 f10 ?v_0) ?v_1))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 0)) (f6 f7 0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
