(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S5 S4) Int)
(declare-fun f7 (S6 Int) S5)
(declare-fun f8 () S6)
(declare-fun f9 (S7 Int) S4)
(declare-fun f10 () S7)
(declare-fun f11 () Int)
(declare-fun f12 () S5)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v2) (- (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (< 0 (f6 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (f6 (f7 f8 (- ?v0 ?v1)) ?v_0) (+ (- (f6 (f7 f8 ?v0) ?v_0) (f3 (f4 f5 (* 2 ?v0)) ?v1)) (f6 (f7 f8 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (f6 (f7 f8 (+ ?v0 ?v1)) ?v_0) (+ (+ (f6 (f7 f8 ?v0) ?v_0) (f3 (f4 f5 (* 2 ?v0)) ?v1)) (f6 (f7 f8 ?v1) ?v_0))))))
(assert (not (=> (not (= f11 0)) (< 0 (f6 (f7 f8 f11) (f9 f10 2))))))
(assert (forall ((?v0 S4)) (= (f9 f10 (f6 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f12 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f6 f12 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
