(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int Int) S1)
(declare-fun f4 (S2 S3) Int)
(declare-fun f5 (S4 Int) S2)
(declare-fun f6 () S4)
(declare-fun f7 () S2)
(declare-fun f8 () S3)
(declare-fun f9 (S5 Int) S3)
(declare-fun f10 () S5)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 () S3)
(declare-fun f16 (S6 Int) Int)
(declare-fun f17 (S7 Int) S6)
(declare-fun f18 () S7)
(declare-fun f19 () Int)
(declare-fun f20 (Int) S1)
(declare-fun f21 (Int) S1)
(declare-fun f22 () S7)
(declare-fun f23 () Int)
(declare-fun f24 () S6)
(declare-fun f25 (Int Int) S1)
(declare-fun f26 () Int)
(declare-fun f27 () Int)
(declare-fun f28 () Int)
(declare-fun f29 () Int)
(declare-fun f30 (Int Int Int) S1)
(declare-fun f31 (S8 S9) Int)
(declare-fun f32 () S8)
(declare-fun f33 (Int Int) S9)
(declare-fun f34 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f9 f10 2))) (not (= (f3 (f4 (f5 f6 (+ 1 (f4 f7 f8))) ?v_0) (+ (f4 (f5 f6 f11) ?v_0) (f4 (f5 f6 f12) ?v_0))) f1))))
(assert (let ((?v_0 (f9 f10 2))) (let ((?v_1 (f4 (f5 f6 (+ 1 (f4 f7 f8))) ?v_0))) (and (= (f3 ?v_1 (f4 (f5 f6 f11) ?v_0)) f1) (= (f3 ?v_1 (f4 (f5 f6 f12) ?v_0)) f1)))))
(assert (< 1 f13))
(assert (< 0 (f4 f7 f8)))
(assert (< 0 (+ 1 (f4 f7 f8))))
(assert (let ((?v_0 (f9 f10 2))) (let ((?v_1 (f4 (f5 f6 (+ 1 (f4 f7 f8))) ?v_0))) (and (= (f3 ?v_1 (f4 (f5 f6 f11) ?v_0)) f1) (= (f3 ?v_1 (f4 (f5 f6 f12) ?v_0)) f1)))))
(assert (let ((?v_0 (+ 1 (f4 f7 f8)))) (and (= (f3 ?v_0 f11) f1) (= (f3 ?v_0 f12) f1))))
(assert (< f14 (+ 1 (f4 f7 f8))))
(assert (= f15 (f9 f10 (- (f4 f7 (f9 f10 f13)) 1))))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f4 (f5 f6 f11) ?v_0) (f4 (f5 f6 f12) ?v_0)) (f16 (f17 f18 (+ (* 4 f19) 1)) (+ 1 (f4 f7 f8))))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f9 f10 0))) (= (= (f3 (f4 (f5 f6 ?v1) ?v0) (f4 (f5 f6 ?v2) ?v0)) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f4 f7 ?v0)) (=> (= (f3 ?v1 ?v2) f1) (= (f3 ?v1 (f4 (f5 f6 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f3 (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v2) ?v1)) f1) (=> (not (= ?v1 (f9 f10 0))) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f3 ?v0 ?v1) f1) (= (f3 (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f5 f6 ?v2))) (=> (<= (f4 f7 ?v0) (f4 f7 ?v1)) (= (f3 (f4 ?v_0 ?v0) (f4 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f3 ?v0 ?v1) f1) (=> (<= (f4 f7 ?v2) (f4 f7 ?v3)) (= (f3 (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f3 (f4 ?v_0 ?v1) ?v2) f1) (=> (<= (f4 f7 ?v3) (f4 f7 ?v1)) (= (f3 (f4 ?v_0 ?v3) ?v2) f1))))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f4 f7 f8)))) (=> (and (= ?v1 (- f11 (f16 (f17 f18 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f4 f7 f8)))) (=> (and (= ?v1 (- f12 (f16 (f17 f18 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (< 0 (f4 f7 f15)))
(assert (< 0 (+ (* 4 f19) 1)))
(assert (<= 1 f13))
(assert (not (= (f20 (f16 (f17 f18 (+ (* 4 f19) 1)) (+ 1 0))) f1)))
(assert (< f13 (+ (* 4 f19) 1)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f9 f10 (- (f4 f7 (f9 f10 f13)) 1))) (=> (< 0 (f4 f7 ?v0)) false))) false))
(assert (let ((?v_1 (+ 1 (f4 f7 f8))) (?v_0 (+ (* 4 f19) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f20 (f16 (f17 f18 ?v_0) ?v_1)) f1))))))
(assert (= (f21 (+ (* 4 f19) 1)) f1))
(assert (= (f16 (f17 f22 (- 1)) (+ (* 4 f19) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (=> (= (+ (f4 (f5 f6 ?v0) ?v_0) (f4 (f5 f6 ?v1) ?v_0)) (f16 (f17 f18 (+ (* 4 f19) 1)) (+ 1 (f4 f7 f8)))) false))) false))
(assert (= (+ (f4 (f5 f6 f23) (f9 f10 2)) 1) (f16 (f17 f18 (+ (* 4 f19) 1)) f13)))
(assert (let ((?v_1 (+ 1 (f4 f7 f8))) (?v_0 (+ (* 4 f19) 1))) (and (< ?v_1 ?v_0) (= (f20 (f16 (f17 f18 ?v_0) ?v_1)) f1))))
(assert (= (f20 (f16 (f17 f18 (+ (* 4 f19) 1)) f13)) f1))
(assert (= (f20 (f16 (f17 f18 (+ (* 4 f19) 1)) f14)) f1))
(assert (=> (= f13 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (+ (f4 (f5 f6 ?v0) ?v_0) (f4 (f5 f6 ?v1) ?v_0)) (+ (* 4 f19) 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f4 (f5 f6 (f16 (f17 f18 ?v0) ?v1)) ?v2) (f16 (f17 f18 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v1))) (= (f16 (f17 f18 ?v_0) ?v0) (f16 (f17 f18 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f9 f10 (+ (f4 f7 ?v1) (f4 f7 ?v2)))) (f16 (f17 f18 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f9 f10 (+ (f4 f7 ?v1) 1))) (f16 (f17 f18 (f4 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f9 f10 (+ (f4 f7 ?v1) 1))) (f16 (f17 f18 ?v0) (f4 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (f4 (f5 f6 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f16 f24 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f6 (f16 f24 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (= (f25 (+ (* 4 f19) 1) (- 1)) f1))
(assert (let ((?v_0 (+ 1 (f4 f7 f8)))) (and (= f26 (- f12 (f16 (f17 f18 f27) ?v_0))) (<= (ite (< f26 0) (* (- 2) f26) (* 2 f26)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f4 f7 f8)))) (and (= f28 (- f11 (f16 (f17 f18 f29) ?v_0))) (<= (ite (< f28 0) (* (- 2) f28) (* 2 f28)) ?v_0))))
(assert (= (f3 (+ (* 4 f19) 1) (- (f4 (f5 f6 f23) (f9 f10 2)) (- 1))) f1))
(assert (= (f3 (+ (* 4 f19) 1) (+ (f4 (f5 f6 f23) (f9 f10 2)) 1)) f1))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f4 (f5 f6 f28) ?v_0) (f4 (f5 f6 f26) ?v_0)) (f16 (f17 f18 (+ 1 (f4 f7 f8))) f14))))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f4 (f5 f6 f23) (f9 f10 2)) 1) (f16 (f17 f18 (+ (* 4 f19) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f5 f6 ?v1)) (?v_1 (f9 f10 ?v0))) (=> (< 0 ?v0) (= (f4 ?v_0 ?v_1) (f16 (f17 f18 ?v1) (f4 ?v_0 (f9 f10 (- (f4 f7 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (f16 (f17 f18 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f4 (f5 f6 ?v0) ?v_0) (f4 (f5 f6 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f9 f10 2)) (?v_0 (f9 f10 3)) (?v_3 (f5 f6 ?v1)) (?v_1 (f5 f6 ?v0))) (= (f4 (f5 f6 (- ?v0 ?v1)) ?v_0) (- (+ (- (f4 ?v_1 ?v_0) (f16 (f17 f18 (* 3 (f4 ?v_1 ?v_2))) ?v1)) (f16 (f17 f18 (* 3 ?v0)) (f4 ?v_3 ?v_2))) (f4 ?v_3 ?v_0))))))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f4 (f5 f6 f28) ?v_0) (f4 (f5 f6 f26) ?v_0)) 0)))
(assert (let ((?v_0 (f4 (f5 f6 f23) (f9 f10 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (and (= f28 0) (= f26 0)))
(assert (let ((?v_0 (+ (* 4 f19) 1))) (=> (not (= (f25 ?v_0 (- 1)) f1)) (not (= (f16 (f17 f22 (- 1)) ?v_0) 1)))))
(assert (let ((?v_0 (f9 f10 2))) (=> (not (= f28 0)) (< 0 (+ (f4 (f5 f6 f28) ?v_0) (f4 (f5 f6 f26) ?v_0))))))
(assert (let ((?v_0 (f9 f10 2))) (=> (not (= f26 0)) (< 0 (+ (f4 (f5 f6 f28) ?v_0) (f4 (f5 f6 f26) ?v_0))))))
(assert (let ((?v_0 (f9 f10 2))) (= (f3 (+ 1 (f4 f7 f8)) (+ (f4 (f5 f6 f28) ?v_0) (f4 (f5 f6 f26) ?v_0))) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2))) (=> (= (+ (f4 (f5 f6 f28) ?v_0) (f4 (f5 f6 f26) ?v_0)) (f16 (f17 f18 (+ 1 (f4 f7 f8))) ?v0)) false))) false))
(assert (let ((?v_2 (f9 f10 2)) (?v_1 (f17 f18 f27)) (?v_0 (f17 f18 f29))) (= (+ (f4 (f5 f6 (+ (+ (f16 ?v_0 f28) (f16 ?v_1 f26)) f14)) ?v_2) (f4 (f5 f6 (- (f16 ?v_0 f26) (f16 ?v_1 f28))) ?v_2)) (f16 (f17 f18 (+ (* 4 f19) 1)) f14))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f21 ?v_0) f1) (= (f16 (f17 f22 (- 1)) ?v_0) 1)))))
(assert (= (f21 2) f1))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f9 f10 (f16 (f17 f18 (f4 f7 ?v1)) (f4 f7 ?v2)))) (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f21 ?v0) f1) (=> (= (f3 ?v0 (f4 (f5 f6 ?v1) ?v2)) f1) (= (f3 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v2))) (=> (= (f21 ?v0) f1) (=> (not (= (f3 ?v0 ?v1) f1)) (=> (= (f3 ?v_0 (f16 (f17 f18 ?v1) ?v3)) f1) (= (f3 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v2))) (=> (= (f21 ?v0) f1) (=> (not (= (f3 ?v0 ?v1) f1)) (=> (= (f3 ?v_0 (f16 (f17 f18 ?v3) ?v1)) f1) (= (f3 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f21 ?v0) f1) (=> (= (f3 ?v0 (f16 (f17 f18 ?v1) ?v2)) f1) (or (= (f3 ?v0 ?v1) f1) (= (f3 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f21 ?v0) f1) (=> (= (f3 ?v0 (f4 (f5 f6 ?v1) ?v2)) f1) (=> (< 0 (f4 f7 ?v2)) (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0) f1) (=> (= (f20 ?v1) f1) (= (f20 (f16 (f17 f18 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f16 (f17 f18 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int)) (<= ?v0 (f4 (f5 f6 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f9 f10 2))) (let ((?v_0 (f4 (f5 f6 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f4 (f5 f6 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f9 f10 3))) (let ((?v_0 (f4 (f5 f6 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f4 (f5 f6 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 3))) (= (f4 (f5 f6 (- ?v0)) ?v_0) (- (f4 (f5 f6 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2)) (?v_1 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_1 ?v_0)) ?v_0) (f4 ?v_1 (f9 f10 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (= (f4 (f5 f6 ?v0) ?v_0) (f4 (f5 f6 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (=> (= (f4 (f5 f6 ?v0) (f9 f10 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f16 (f17 f18 ?v0) (f4 ?v_0 (f9 f10 2))) (f4 ?v_0 (f9 f10 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (f4 (f5 f6 (+ ?v0 ?v1)) ?v_0) (+ (+ (f4 (f5 f6 ?v0) ?v_0) (f16 (f17 f18 (* 2 ?v0)) ?v1)) (f4 (f5 f6 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (f4 (f5 f6 (- ?v0 ?v1)) ?v_0) (+ (- (f4 (f5 f6 ?v0) ?v_0) (f16 (f17 f18 (* 2 ?v0)) ?v1)) (f4 (f5 f6 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f9 f10 2)) (?v_0 (f9 f10 3)) (?v_1 (f5 f6 ?v0)) (?v_3 (f5 f6 ?v1))) (= (f4 (f5 f6 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f4 ?v_1 ?v_0) (f16 (f17 f18 (* 3 (f4 ?v_1 ?v_2))) ?v1)) (f16 (f17 f18 (* 3 ?v0)) (f4 ?v_3 ?v_2))) (f4 ?v_3 ?v_0))))))
(assert (= (f30 (f4 (f5 f6 f23) (f9 f10 2)) (- 1) (+ (* 4 f19) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f21 ?v1) f1) (=> (= (f3 ?v1 (f16 (f17 f18 ?v0) ?v2)) f1) (or (= (f3 ?v1 ?v0) f1) (= (f3 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f21 ?v1) f1) (= (f3 ?v1 ?v0) f1))))))
(assert (= (f31 f32 (f33 f23 1)) (f16 (f17 f18 (+ (* 4 f19) 1)) f13)))
(assert (let ((?v_0 (+ (* 4 f19) 1))) (and (<= 0 f23) (and (< f23 ?v_0) (= (f30 f34 f23 ?v_0) f1)))))
(assert (forall ((?v0 Int)) (= (= (f21 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f3 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f9 f10 (+ (f4 f7 ?v1) (f4 f7 ?v2)))) (f16 (f17 f18 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 ?v0 (+ ?v1 (f16 (f17 f18 ?v0) ?v2))) f1) (= (f3 ?v0 ?v1) f1))))
(assert (= (f30 (f4 (f5 f6 f34) (f9 f10 2)) (- 1) (+ (* 4 f19) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f30 (f4 (f5 f6 ?v0) (f9 f10 2)) (- 1) (+ (* 4 f19) 1)) f1) false)) false))
(assert (let ((?v_0 (f9 f10 2))) (= (f30 (f4 (f5 f6 f23) ?v_0) (f4 (f5 f6 f34) ?v_0) (+ (* 4 f19) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f19) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f30 f34 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f30 f34 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f19) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f30 f34 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= (f30 ?v3 ?v4 ?v2) f1) (= (f30 (f16 (f17 f18 ?v0) ?v3) (f16 (f17 f18 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f17 f18 ?v3))) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 (f16 ?v_0 ?v0) (f16 ?v_0 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 (f16 (f17 f18 ?v0) ?v3) (f16 (f17 f18 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f30 (f16 (f17 f18 ?v0) ?v1) (f16 (f17 f18 ?v2) ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f16 (f17 f18 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 ?v1 ?v2) f1) (= (f3 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 ?v1 (- ?v2)) f1) (= (f30 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f30 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f30 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f30 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f30 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f30 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= (f30 ?v1 ?v3 ?v2) f1) (= (f30 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= (f30 ?v3 ?v4 ?v2) f1) (= (f30 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= (f30 ?v3 ?v4 ?v2) f1) (= (f30 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f30 ?v3 ?v4 ?v2) f1) (= (f30 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f30 ?v1 (- 1) ?v0) f1) (not (= (f30 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f30 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f30 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int)) (= (f30 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f17 f18 ?v0)) (?v_1 (f17 f18 ?v1))) (= (f16 (f17 f18 (f31 f32 (f33 ?v0 ?v1))) (f31 f32 (f33 ?v2 ?v3))) (f31 f32 (f33 (+ (f16 ?v_0 ?v2) (f16 ?v_1 ?v3)) (- (f16 ?v_0 ?v3) (f16 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (= (f30 ?v3 (f16 (f17 f18 ?v0) ?v4) ?v2) f1) (= (f30 ?v3 (f16 (f17 f18 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f17 f18 ?v4))) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (= (f30 ?v3 (f16 ?v_0 ?v0) ?v2) f1) (= (f30 ?v3 (f16 ?v_0 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 ?v0 0 ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 ?v0 0 ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 (f4 (f5 f6 ?v0) ?v3) (f4 (f5 f6 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 ?v0) f1) (=> (< 0 ?v1) (=> (= (f30 (f16 (f17 f18 ?v1) ?v1) 1 ?v0) f1) (or (= (f30 ?v1 1 ?v0) f1) (= (f30 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f30 (f16 (f17 f18 ?v1) ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 S3)) (= (f9 f10 (f4 f7 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f4 f7 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f4 f7 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
