(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () Int)
(declare-fun f4 () Int)
(declare-fun f5 (S2 S3) Int)
(declare-fun f6 () S2)
(declare-fun f7 () S3)
(declare-fun f8 () S3)
(declare-fun f9 (S4 Int) S3)
(declare-fun f10 () S4)
(declare-fun f11 (Int) S1)
(declare-fun f12 (S5 Int) Int)
(declare-fun f13 (S6 Int) S5)
(declare-fun f14 () S6)
(declare-fun f15 () Int)
(declare-fun f16 (S7 Int) S2)
(declare-fun f17 () S7)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 (Int) S1)
(declare-fun f21 () S6)
(declare-fun f22 () Int)
(declare-fun f23 () Int)
(declare-fun f24 () Int)
(declare-fun f25 () Int)
(declare-fun f26 () Int)
(declare-fun f27 (Int Int) S1)
(declare-fun f28 (Int Int) S1)
(declare-fun f29 (Int Int Int) S1)
(declare-fun f30 (S8 S9) Int)
(declare-fun f31 () S8)
(declare-fun f32 (Int Int) S9)
(declare-fun f33 () Int)
(declare-fun f34 (S3 S3) S1)
(declare-fun f35 (S10 S3) S3)
(declare-fun f36 (S11 S3) S10)
(declare-fun f37 () S11)
(declare-fun f38 () S5)
(declare-fun f39 () S11)
(assert (not (= f1 f2)))
(assert (not (< 0 f3)))
(assert (not (= f3 0)))
(assert (<= 0 f3))
(assert (< 1 f4))
(assert (not (= f3 0)))
(assert (<= 0 f3))
(assert (< 0 (f5 f6 f7)))
(assert (= f8 (f9 f10 (- (f5 f6 (f9 f10 f4)) 1))))
(assert (< f3 (+ 1 (f5 f6 f7))))
(assert (<= 1 f4))
(assert (= (f11 (f12 (f13 f14 (+ (* 4 f15) 1)) f3)) f1))
(assert (< 0 (+ 1 (f5 f6 f7))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f9 f10 (- (f5 f6 (f9 f10 f4)) 1))) (=> (< 0 (f5 f6 ?v0)) false))) false))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f5 (f16 f17 f18) ?v_0) (f5 (f16 f17 f19) ?v_0)) (f12 (f13 f14 (+ 1 (f5 f6 f7))) f3))))
(assert (< 0 (+ (* 4 f15) 1)))
(assert (< 0 (f5 f6 f8)))
(assert (not (= (f11 (f12 (f13 f14 (+ (* 4 f15) 1)) (+ 1 0))) f1)))
(assert (let ((?v_0 (f9 f10 2))) (not (= (+ (f5 (f16 f17 f18) ?v_0) (* 1 (f5 (f16 f17 f19) ?v_0))) 0))))
(assert (let ((?v_1 (+ 1 (f5 f6 f7))) (?v_0 (+ (* 4 f15) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f11 (f12 (f13 f14 ?v_0) ?v_1)) f1))))))
(assert (< f4 (+ (* 4 f15) 1)))
(assert (let ((?v_0 (f9 f10 2))) (< 0 (+ (f5 (f16 f17 f18) ?v_0) (f5 (f16 f17 f19) ?v_0)))))
(assert (let ((?v_0 (f9 f10 2))) (<= 0 (+ (f5 (f16 f17 f18) ?v_0) (f5 (f16 f17 f19) ?v_0)))))
(assert (let ((?v_0 (f9 f10 2))) (=> (= (+ (f5 (f16 f17 f18) ?v_0) (f5 (f16 f17 f19) ?v_0)) 0) false)))
(assert (let ((?v_1 (+ 1 (f5 f6 f7))) (?v_0 (+ (* 4 f15) 1))) (and (< ?v_1 ?v_0) (= (f11 (f12 (f13 f14 ?v_0) ?v_1)) f1))))
(assert (= (f11 (f12 (f13 f14 (+ (* 4 f15) 1)) f4)) f1))
(assert (= (f20 (+ (* 4 f15) 1)) f1))
(assert (= (f12 (f13 f21 (- 1)) (+ (* 4 f15) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (=> (= (+ (f5 (f16 f17 ?v0) ?v_0) (f5 (f16 f17 ?v1) ?v_0)) (f12 (f13 f14 (+ (* 4 f15) 1)) (+ 1 (f5 f6 f7)))) false))) false))
(assert (= (+ (f5 (f16 f17 f22) (f9 f10 2)) 1) (f12 (f13 f14 (+ (* 4 f15) 1)) f4)))
(assert (let ((?v_0 (+ 1 (f5 f6 f7)))) (and (= f18 (- f23 (f12 (f13 f14 f24) ?v_0))) (<= (ite (< f18 0) (* (- 2) f18) (* 2 f18)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f5 f6 f7)))) (and (= f19 (- f25 (f12 (f13 f14 f26) ?v_0))) (<= (ite (< f19 0) (* (- 2) f19) (* 2 f19)) ?v_0))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2))) (=> (= (+ (f5 (f16 f17 f18) ?v_0) (f5 (f16 f17 f19) ?v_0)) (f12 (f13 f14 (+ 1 (f5 f6 f7))) ?v0)) false))) false))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f5 (f16 f17 f23) ?v_0) (f5 (f16 f17 f25) ?v_0)) (f12 (f13 f14 (+ (* 4 f15) 1)) (+ 1 (f5 f6 f7))))))
(assert (=> (= f4 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (+ (f5 (f16 f17 ?v0) ?v_0) (f5 (f16 f17 ?v1) ?v_0)) (+ (* 4 f15) 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 ?v0) f1) (=> (= (f11 ?v1) f1) (= (f11 (f12 (f13 f14 ?v0) ?v1)) f1)))))
(assert (= (f27 (+ (* 4 f15) 1) (- 1)) f1))
(assert (let ((?v_2 (f9 f10 2)) (?v_0 (f13 f14 f24)) (?v_1 (f13 f14 f26))) (= (+ (f5 (f16 f17 (+ (+ (f12 ?v_0 f18) (f12 ?v_1 f19)) f3)) ?v_2) (f5 (f16 f17 (- (f12 ?v_0 f19) (f12 ?v_1 f18))) ?v_2)) (f12 (f13 f14 (+ (* 4 f15) 1)) f3))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f5 f6 f7)))) (=> (and (= ?v1 (- f23 (f12 (f13 f14 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f5 f6 f7)))) (=> (and (= ?v1 (- f25 (f12 (f13 f14 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (f9 f10 2))) (= (f28 (+ 1 (f5 f6 f7)) (+ (f5 (f16 f17 f18) ?v_0) (f5 (f16 f17 f19) ?v_0))) f1)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f5 (f16 f17 f22) (f9 f10 2)) 1) (f12 (f13 f14 (+ (* 4 f15) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f5 ?v_0 (f9 f10 (+ (f5 f6 ?v1) (f5 f6 ?v2)))) (f12 (f13 f14 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f17 ?v0))) (= (f12 (f13 f14 ?v0) (f5 ?v_0 (f9 f10 2))) (f5 ?v_0 (f9 f10 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (f5 (f16 f17 (+ ?v0 ?v1)) ?v_0) (+ (+ (f5 (f16 f17 ?v0) ?v_0) (f12 (f13 f14 (* 2 ?v0)) ?v1)) (f5 (f16 f17 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (f5 (f16 f17 (- ?v0 ?v1)) ?v_0) (+ (- (f5 (f16 f17 ?v0) ?v_0) (f12 (f13 f14 (* 2 ?v0)) ?v1)) (f5 (f16 f17 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f9 f10 2)) (?v_0 (f9 f10 3)) (?v_1 (f16 f17 ?v0)) (?v_3 (f16 f17 ?v1))) (= (f5 (f16 f17 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f5 ?v_1 ?v_0) (f12 (f13 f14 (* 3 (f5 ?v_1 ?v_2))) ?v1)) (f12 (f13 f14 (* 3 ?v0)) (f5 ?v_3 ?v_2))) (f5 ?v_3 ?v_0))))))
(assert (let ((?v_0 (f5 (f16 f17 f22) (f9 f10 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f15) 1))) (=> (not (= (f27 ?v_0 (- 1)) f1)) (not (= (f12 (f13 f21 (- 1)) ?v_0) 1)))))
(assert (= (f28 (+ (* 4 f15) 1) (- (f5 (f16 f17 f22) (f9 f10 2)) (- 1))) f1))
(assert (= (f28 (+ (* 4 f15) 1) (+ (f5 (f16 f17 f22) (f9 f10 2)) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f20 ?v0) f1) (=> (= (f28 ?v0 (f5 (f16 f17 ?v1) ?v2)) f1) (= (f28 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f28 ?v0 (- ?v1 ?v2)) f1) (=> (= (f28 ?v0 ?v2) f1) (= (f28 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (=> (= (f28 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f28 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f28 ?v0 ?v1) f1) (=> (= (f28 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f20 ?v_0) f1) (= (f12 (f13 f21 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f28 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (= (= (f28 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (= (f20 2) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v0))) (=> (= (f28 (f12 ?v_0 ?v1) (f12 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f28 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f28 ?v0 ?v1) f1) (= (= (f28 ?v0 (+ ?v2 ?v3)) f1) (= (f28 ?v0 (+ (+ ?v2 (f12 (f13 f14 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f28 (f12 (f13 f14 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f28 ?v0 (+ ?v1 (f12 (f13 f14 ?v0) ?v2))) f1) (= (f28 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f5 (f16 f17 ?v0) ?v2))) (=> (= (f20 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (=> (= (f28 ?v_0 (f12 (f13 f14 ?v3) ?v1)) f1) (= (f28 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f5 (f16 f17 ?v0) ?v2))) (=> (= (f20 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (=> (= (f28 ?v_0 (f12 (f13 f14 ?v1) ?v3)) f1) (= (f28 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f12 (f13 f14 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 (f13 f14 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f5 f6 ?v2))) (let ((?v_1 (f13 f14 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f12 ?v_1 ?v0) (f12 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f12 ?v_0 ?v0) (f12 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f12 (f13 f14 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f12 (f13 f14 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f12 (f13 f14 (- ?v0 ?v1)) ?v2) (- (f12 (f13 f14 ?v0) ?v2) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f12 (f13 f14 (+ ?v0 ?v1)) ?v2) (+ (f12 (f13 f14 ?v0) ?v2) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f12 (f13 f14 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f12 (f13 f14 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 (f13 f14 (- ?v0)) ?v1) (- (f12 (f13 f14 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (- ?v1 ?v2)) (- (f12 ?v_0 ?v1) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (+ ?v1 ?v2)) (+ (f12 ?v_0 ?v1) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 (f13 f14 ?v0) ?v1) (f12 (f13 f14 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f5 (f16 f17 ?v0) (f9 f10 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (= (f5 (f16 f17 ?v0) ?v_0) (f5 (f16 f17 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2)) (?v_1 (f16 f17 ?v0))) (= (f5 (f16 f17 (f5 ?v_1 ?v_0)) ?v_0) (f5 ?v_1 (f9 f10 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 3))) (= (f5 (f16 f17 (- ?v0)) ?v_0) (- (f5 (f16 f17 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f5 (f16 f17 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f9 f10 3))) (let ((?v_0 (f5 (f16 f17 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f5 (f16 f17 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f9 f10 2))) (let ((?v_0 (f5 (f16 f17 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f5 (f16 f17 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f5 (f16 f17 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f5 (f16 f17 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (f12 (f13 f14 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f5 (f16 f17 ?v0) ?v_0) (f5 (f16 f17 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f9 f10 2)) (?v_0 (f9 f10 3)) (?v_3 (f16 f17 ?v1)) (?v_1 (f16 f17 ?v0))) (= (f5 (f16 f17 (- ?v0 ?v1)) ?v_0) (- (+ (- (f5 ?v_1 ?v_0) (f12 (f13 f14 (* 3 (f5 ?v_1 ?v_2))) ?v1)) (f12 (f13 f14 (* 3 ?v0)) (f5 ?v_3 ?v_2))) (f5 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f20 ?v0) f1) (=> (= (f28 ?v0 (f5 (f16 f17 ?v1) ?v2)) f1) (=> (< 0 (f5 f6 ?v2)) (= (f28 ?v0 ?v1) f1))))))
(assert (= (f29 (f5 (f16 f17 f22) (f9 f10 2)) (- 1) (+ (* 4 f15) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f20 ?v0) f1) (=> (= (f28 ?v0 (f12 (f13 f14 ?v1) ?v2)) f1) (or (= (f28 ?v0 ?v1) f1) (= (f28 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f20 ?v1) f1) (=> (= (f28 ?v1 (f12 (f13 f14 ?v0) ?v2)) f1) (or (= (f28 ?v1 ?v0) f1) (= (f28 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f20 ?v1) f1) (= (f28 ?v1 ?v0) f1))))))
(assert (= (f30 f31 (f32 f22 1)) (f12 (f13 f14 (+ (* 4 f15) 1)) f4)))
(assert (let ((?v_0 (+ (* 4 f15) 1))) (and (<= 0 f22) (and (< f22 ?v_0) (= (f29 f33 f22 ?v_0) f1)))))
(assert (forall ((?v0 Int)) (= (= (f20 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f28 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (= (f29 (f5 (f16 f17 f33) (f9 f10 2)) (- 1) (+ (* 4 f15) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f29 (f5 (f16 f17 ?v0) (f9 f10 2)) (- 1) (+ (* 4 f15) 1)) f1) false)) false))
(assert (let ((?v_0 (f9 f10 2))) (= (f29 (f5 (f16 f17 f22) ?v_0) (f5 (f16 f17 f33) ?v_0) (+ (* 4 f15) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f15) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f29 f33 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f15) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (= (f28 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 0 ?v1) f1) (= (f28 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 0 ?v1) f1) (= (f28 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (f12 (f13 f14 ?v0) ?v3) (f12 (f13 f14 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f13 f14 ?v3))) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f12 ?v_0 ?v0) (f12 ?v_0 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f12 (f13 f14 ?v0) ?v3) (f12 (f13 f14 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f13 f14 ?v4))) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (= (f29 ?v3 (f12 ?v_0 ?v0) ?v2) f1) (= (f29 ?v3 (f12 ?v_0 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (= (f29 ?v3 (f12 (f13 f14 ?v0) ?v4) ?v2) f1) (= (f29 ?v3 (f12 (f13 f14 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f29 (f12 (f13 f14 ?v0) ?v1) (f12 (f13 f14 ?v2) ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f12 (f13 f14 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f5 (f16 f17 ?v0) ?v3) (f5 (f16 f17 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 (- ?v2)) f1) (= (f29 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int)) (= (f29 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f29 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f29 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f29 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f29 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f29 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f29 ?v1 (- 1) ?v0) f1) (not (= (f29 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v1 ?v3 ?v2) f1) (= (f29 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f13 f14 ?v0)) (?v_1 (f13 f14 ?v1))) (= (f12 (f13 f14 (f30 f31 (f32 ?v0 ?v1))) (f30 f31 (f32 ?v2 ?v3))) (f30 f31 (f32 (+ (f12 ?v_0 ?v2) (f12 ?v_1 ?v3)) (- (f12 ?v_0 ?v3) (f12 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0) f1) (=> (< 0 ?v1) (=> (= (f29 (f12 (f13 f14 ?v1) ?v1) 1 ?v0) f1) (or (= (f29 ?v1 1 ?v0) f1) (= (f29 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f20 ?v0) f1) (=> (< 0 ?v1) (=> (= (f29 (f12 (f13 f14 ?v1) ?v2) 0 ?v0) f1) (or (= (f29 ?v1 0 ?v0) f1) (= (f29 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f20 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f29 ?v1 0 ?v0) f1)) (not (= (f29 ?v2 0 ?v0) f1))) (not (= (f29 (f12 (f13 f14 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f29 (f12 (f13 f14 ?v1) ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f20 ?v0) f1) (=> (not (= (f29 ?v1 0 ?v0) f1)) (=> (not (= (f29 ?v2 0 ?v0) f1)) (not (= (f29 (f12 (f13 f14 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f13 f14 ?v1))) (= (+ (f12 (f13 f14 (- ?v0 (f12 ?v_0 ?v2))) ?v3) (f12 (f13 f14 (- ?v4 (f12 ?v_0 ?v5))) ?v6)) (- (+ (f12 (f13 f14 ?v0) ?v3) (f12 (f13 f14 ?v4) ?v6)) (f12 ?v_0 (+ (f12 (f13 f14 ?v2) ?v3) (f12 (f13 f14 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f5 f6 ?v0)) (=> (= (f28 ?v1 ?v2) f1) (= (f28 ?v1 (f5 (f16 f17 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int)) (= (= (f11 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f30 f31 (f32 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (= (f29 (f5 (f16 f17 ?v1) (f9 f10 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 (f13 f21 ?v0) ?v1) (ite (= (f29 ?v0 0 ?v1) f1) 0 (ite (= (f27 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f27 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f29 (f5 (f16 f17 ?v2) (f9 f10 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f29 ?v0 0 ?v1) f1)) (=> (= (f29 (f5 (f16 f17 ?v2) (f9 f10 2)) ?v0 ?v1) f1) (not (= (f28 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 ?v1)) (?v_1 (f9 f10 ?v0))) (=> (< 0 ?v0) (= (f5 ?v_0 ?v_1) (f12 (f13 f14 ?v1) (f5 ?v_0 (f9 f10 (- (f5 f6 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f28 (f5 (f16 f17 ?v0) ?v1) (f5 (f16 f17 ?v2) ?v1)) f1) (=> (not (= ?v1 (f9 f10 0))) (= (f28 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f9 f10 0))) (= (= (f28 (f5 (f16 f17 ?v1) ?v0) (f5 (f16 f17 ?v2) ?v0)) f1) (= (f28 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f17 (- 1)))) (let ((?v_1 (f5 ?v_0 ?v1)) (?v_2 (f5 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f29 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f29 1 (- 1) ?v0) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f5 (f16 f17 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v0))) (=> (not (= ?v0 0)) (= (= (f28 ?v1 ?v2) f1) (= (f28 (f12 ?v_0 ?v1) (f12 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f29 (f12 (f13 f14 ?v0) ?v_0) 1 ?v1) f1) (= (f29 ?v0 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f28 ?v0 ?v1) f1) (= (f28 (f5 (f16 f17 ?v0) ?v2) (f5 (f16 f17 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f34 ?v0 ?v1) f1) (= (f34 (f35 (f36 f37 ?v0) ?v2) (f35 (f36 f37 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f34 ?v0 ?v1) f1) (= (f28 (f5 f6 ?v0) (f5 f6 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f28 ?v0 (f5 f6 ?v1)) f1) (= (f34 (f9 f10 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 Int)) (= (= (f28 (f5 f6 ?v0) ?v1) f1) (= (f34 ?v0 (f9 f10 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f34 (f9 f10 ?v0) ?v1) f1) (ite (<= 0 ?v0) (= (f28 ?v0 (f5 f6 ?v1)) f1) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 f6 (f35 (f36 f37 ?v0) ?v1)) (f5 (f16 f17 (f5 f6 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 (f16 f17 (f5 f6 ?v0)) ?v1) (f5 f6 (f35 (f36 f37 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f9 f10 (f5 (f16 f17 ?v0) ?v1)) (f35 (f36 f37 (f9 f10 ?v0)) ?v1)))))
(assert (forall ((?v0 Int)) (= (f5 (f16 f17 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f35 (f36 f37 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f12 f38 (f5 (f16 f17 ?v0) ?v1)) (f5 (f16 f17 (f12 f38 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f12 (f13 f14 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f12 (f13 f14 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f28 ?v0 ?v1) f1) (= (f28 (- ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f28 ?v0 ?v1) f1) (= (f28 ?v0 (- ?v1)) f1))))
(assert (forall ((?v0 Int)) (=> (= (f20 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f5 (f16 f17 (f12 (f13 f14 ?v0) ?v1)) ?v2) (f12 (f13 f14 (f5 (f16 f17 ?v0) ?v2)) (f5 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f35 (f36 f37 (f35 (f36 f39 ?v0) ?v1)) ?v2) (f35 (f36 f39 (f35 (f36 f37 ?v0) ?v2)) (f35 (f36 f37 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f5 (f16 f17 ?v0) ?v1))) (= (f12 (f13 f14 ?v_0) ?v0) (f12 (f13 f14 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f35 (f36 f37 ?v0) ?v1))) (= (f35 (f36 f39 ?v_0) ?v0) (f35 (f36 f39 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f5 ?v_0 (f9 f10 (+ (f5 f6 ?v1) (f5 f6 ?v2)))) (f12 (f13 f14 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f9 f10 (+ (f5 f6 ?v1) (f5 f6 ?v2)))) (f35 (f36 f39 (f35 ?v_0 ?v1)) (f35 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f5 ?v_0 (f9 f10 (+ (f5 f6 ?v1) 1))) (f12 (f13 f14 (f5 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f9 f10 (+ (f5 f6 ?v1) 1))) (f35 (f36 f39 (f35 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f5 ?v_0 (f9 f10 (+ (f5 f6 ?v1) 1))) (f12 (f13 f14 ?v0) (f5 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f9 f10 (+ (f5 f6 ?v1) 1))) (f35 (f36 f39 ?v0) (f35 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f16 f17 ?v0))) (=> (= (f28 (f5 ?v_0 ?v1) ?v2) f1) (=> (<= (f5 f6 ?v3) (f5 f6 ?v1)) (= (f28 (f5 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f36 f37 ?v0))) (=> (= (f34 (f35 ?v_0 ?v1) ?v2) f1) (=> (<= (f5 f6 ?v3) (f5 f6 ?v1)) (= (f34 (f35 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f28 ?v0 ?v1) f1) (=> (<= (f5 f6 ?v2) (f5 f6 ?v3)) (= (f28 (f5 (f16 f17 ?v0) ?v2) (f5 (f16 f17 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f34 ?v0 ?v1) f1) (=> (<= (f5 f6 ?v2) (f5 f6 ?v3)) (= (f34 (f35 (f36 f37 ?v0) ?v2) (f35 (f36 f37 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f16 f17 ?v2))) (=> (<= (f5 f6 ?v0) (f5 f6 ?v1)) (= (f28 (f5 ?v_0 ?v0) (f5 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f37 ?v2))) (=> (<= (f5 f6 ?v0) (f5 f6 ?v1)) (= (f34 (f35 ?v_0 ?v0) (f35 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f28 (f12 (f13 f14 ?v0) ?v1) ?v2) f1) (= (f28 ?v1 ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f34 (f35 (f36 f39 ?v0) ?v1) ?v2) f1) (= (f34 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f28 (f12 (f13 f14 ?v0) ?v1) ?v2) f1) (= (f28 ?v0 ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f34 (f35 (f36 f39 ?v0) ?v1) ?v2) f1) (= (f34 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 (f12 (f13 f14 ?v1) ?v2)) (= (f28 ?v1 ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 (f35 (f36 f39 ?v1) ?v2)) (= (f34 ?v1 ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 (f9 f10 0))) (= (= (f34 (f35 (f36 f37 ?v1) ?v0) (f35 (f36 f37 ?v2) ?v0)) f1) (= (f34 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 1))) (=> (= (f34 ?v0 ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (< 0 (f5 f6 ?v0)) (=> (= (f34 ?v1 ?v0) f1) (< 0 (f5 f6 ?v1))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 0))) (=> (= (f34 ?v_0 ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 1))) (= (= (f34 ?v0 ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 0))) (= (= (f34 ?v_0 ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 0))) (= (not (= ?v0 ?v_0)) (and (= (f34 ?v0 ?v_0) f1) (not (= (f34 ?v_0 ?v0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 1))) (= (not (= ?v0 ?v_0)) (and (= (f34 ?v_0 ?v0) f1) (not (= (f34 ?v0 ?v_0) f1)))))))
(assert (forall ((?v0 S3)) (= (f34 ?v0 (f9 f10 0)) f1)))
(assert (forall ((?v0 S3)) (= (f34 (f9 f10 1) ?v0) f1)))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 1))) (not (and (= (f34 ?v0 ?v_0) f1) (not (= (f34 ?v_0 ?v0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 0))) (not (and (= (f34 ?v_0 ?v0) f1) (not (= (f34 ?v0 ?v_0) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f5 f6 (f35 (f36 f37 ?v0) ?v1))) (or (< 0 (f5 f6 ?v0)) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (f35 (f36 f37 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (= (f35 (f36 f37 ?v0) ?v1) ?v_0) (or (= ?v1 (f9 f10 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f37 ?v0))) (=> (< 0 (f5 f6 ?v0)) (=> (< (f5 f6 (f35 ?v_0 ?v1)) (f5 f6 (f35 ?v_0 ?v2))) (< (f5 f6 ?v1) (f5 f6 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f5 f6 ?v0)) (<= ?v_0 (f5 f6 (f35 (f36 f37 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f5 ?v_0 (f9 f10 (f12 (f13 f14 (f5 f6 ?v1)) (f5 f6 ?v2)))) (f5 (f16 f17 (f5 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f9 f10 (f12 (f13 f14 (f5 f6 ?v1)) (f5 f6 ?v2)))) (f35 (f36 f37 (f35 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f37 ?v0))) (=> (= (f34 (f35 ?v_0 ?v1) (f35 ?v_0 ?v2)) f1) (=> (< 1 (f5 f6 ?v0)) (<= (f5 f6 ?v1) (f5 f6 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (f5 (f16 f17 (f5 ?v_0 ?v1)) ?v2) (f5 ?v_0 (f9 f10 (f12 (f13 f14 (f5 f6 ?v1)) (f5 f6 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f9 f10 (f12 (f13 f14 ?v0) ?v1)) (f9 f10 (f12 (f13 f14 (f5 f6 (f9 f10 (- ?v0)))) (f5 f6 (f9 f10 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f9 f10 (f12 (f13 f14 ?v0) ?v1)) (f9 f10 (f12 (f13 f14 (f5 f6 (f9 f10 ?v0))) (f5 f6 (f9 f10 ?v1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f12 (f13 f14 (f5 f6 ?v0)) (f5 f6 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f12 (f13 f14 (f5 f6 ?v0)) (f5 f6 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 (f13 f14 ?v0) ?v1))) (= (f9 f10 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f9 f10 (f12 (f13 f14 (f5 f6 (f9 f10 (ite (< ?v0 0) (- ?v0) ?v0)))) (f5 f6 (f9 f10 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f16 f17 ?v0))) (=> (= (f29 (f5 ?v_0 ?v1) 1 ?v2) f1) (= (f29 (f5 ?v_0 (f9 f10 (f12 (f13 f14 (f5 f6 ?v1)) (f5 f6 ?v3)))) 1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 f38 (f12 (f13 f14 ?v0) ?v1)) (f12 (f13 f14 (f12 f38 ?v0)) (f12 f38 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f38 ?v0))) (= (f12 (f13 f14 ?v_0) ?v_0) (f12 (f13 f14 ?v0) ?v0)))))
(assert (forall ((?v0 Int)) (= (f28 ?v0 ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f34 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f28 ?v0 (f12 f38 ?v1)) f1) (= (f28 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f28 (f12 f38 ?v0) ?v1) f1) (= (f28 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f28 ?v0 ?v1) f1) (=> (= (f28 ?v1 ?v2) f1) (= (f28 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f34 ?v0 ?v1) f1) (=> (= (f34 ?v1 ?v2) f1) (= (f34 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f12 f38 ?v0) (f12 f38 ?v1)) (= (f28 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f28 ?v0 (f12 (f13 f14 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f34 ?v0 (f35 (f36 f39 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f28 ?v0 (f12 (f13 f14 ?v1) ?v0)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f34 ?v0 (f35 (f36 f39 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f28 ?v0 ?v1) f1) (= (f28 ?v0 (f12 (f13 f14 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f34 ?v0 ?v1) f1) (= (f34 ?v0 (f35 (f36 f39 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f28 ?v0 ?v1) f1) (= (f28 ?v0 (f12 (f13 f14 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f34 ?v0 ?v1) f1) (= (f34 ?v0 (f35 (f36 f39 ?v2) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f28 ?v0 ?v1) f1) (=> (= (f28 ?v2 ?v3) f1) (= (f28 (f12 (f13 f14 ?v0) ?v2) (f12 (f13 f14 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f34 ?v0 ?v1) f1) (=> (= (f34 ?v2 ?v3) f1) (= (f34 (f35 (f36 f39 ?v0) ?v2) (f35 (f36 f39 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3)) (= (f34 ?v0 ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f34 (f9 f10 (+ 0 1)) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (=> (forall ((?v2 Int)) (=> (= ?v1 (f12 (f13 f14 ?v0) ?v2)) false)) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f34 ?v0 ?v1) f1) (=> (forall ((?v2 S3)) (=> (= ?v1 (f35 (f36 f39 ?v0) ?v2)) false)) false))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f5 f6 (f9 f10 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f9 f10 (f12 (f13 f14 ?v_0) ?v_0)) (f9 f10 (+ (f12 (f13 f14 (f5 f6 (f9 f10 (- ?v0 1)))) (f5 f6 (f9 f10 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_2 (f5 f6 ?v0)) (?v_1 (f5 f6 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f12 (f13 f14 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_1 (f5 f6 ?v0)) (?v_2 (f5 f6 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f12 (f13 f14 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_1 (f5 f6 ?v0)) (?v_2 (f5 f6 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f12 (f13 f14 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 (f9 f10 (f12 (f13 f14 (f5 f6 ?v0)) (f5 f6 ?v1)))) (or (= ?v1 (f9 f10 1)) (= ?v0 (f9 f10 0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_2 (f5 f6 ?v1)) (?v_0 (f5 f6 ?v0)) (?v_3 (f5 f6 ?v3)) (?v_1 (f5 f6 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (f12 (f13 f14 ?v_0) ?v_1) (f12 (f13 f14 ?v_2) ?v_3)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_3 (f5 f6 ?v1)) (?v_1 (f5 f6 ?v0)) (?v_0 (f5 f6 ?v2))) (let ((?v_2 (f13 f14 ?v_0))) (=> (< ?v_1 ?v_3) (=> (< 0 ?v_0) (< (f12 ?v_2 ?v_1) (f12 ?v_2 ?v_3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f5 f6 ?v1)) (?v_0 (f5 f6 ?v0)) (?v_1 (f5 f6 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (f12 (f13 f14 ?v_0) ?v_1) (f12 (f13 f14 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f5 f6 ?v1)) (?v_0 (f5 f6 ?v0)) (?v_1 (f13 f14 (f5 f6 ?v2)))) (=> (<= ?v_0 ?v_2) (<= (f12 ?v_1 ?v_0) (f12 ?v_1 ?v_2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f5 f6 ?v1)) (?v_0 (f5 f6 ?v0)) (?v_2 (f5 f6 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f12 (f13 f14 ?v_0) ?v_2) (f12 (f13 f14 ?v_1) ?v_2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f13 f14 (+ (f5 f6 ?v0) 1))) (?v_2 (f5 f6 ?v2)) (?v_1 (f5 f6 ?v1))) (= (<= (f12 ?v_0 ?v_1) (f12 ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f13 f14 (+ (f5 f6 ?v0) 1))) (?v_2 (f5 f6 ?v2)) (?v_1 (f5 f6 ?v1))) (= (< (f12 ?v_0 ?v_1) (f12 ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f13 f14 (+ (f5 f6 ?v0) 1)))) (= (= (f9 f10 (f12 ?v_0 (f5 f6 ?v1))) (f9 f10 (f12 ?v_0 (f5 f6 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f5 f6 ?v1))) (= (= (f9 f10 (f12 (f13 f14 (f5 f6 ?v0)) ?v_0)) (f9 f10 (f12 (f13 f14 (f5 f6 ?v2)) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f9 f10 0)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f13 f14 (f5 f6 ?v0)))) (= (= (f9 f10 (f12 ?v_0 (f5 f6 ?v1))) (f9 f10 (f12 ?v_0 (f5 f6 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f9 f10 0)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f5 f6 ?v2)) (?v_0 (f5 f6 ?v1)) (?v_1 (f5 f6 ?v0))) (= (<= (f12 (f13 f14 ?v_1) ?v_0) (f12 (f13 f14 ?v_2) ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f5 f6 ?v0))) (let ((?v_0 (f13 f14 ?v_1)) (?v_3 (f5 f6 ?v2)) (?v_2 (f5 f6 ?v1))) (= (<= (f12 ?v_0 ?v_2) (f12 ?v_0 ?v_3)) (=> (< 0 ?v_1) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f5 f6 ?v2)) (?v_0 (f5 f6 ?v1)) (?v_1 (f5 f6 ?v0))) (= (< (f12 (f13 f14 ?v_1) ?v_0) (f12 (f13 f14 ?v_2) ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f5 f6 ?v0))) (let ((?v_0 (f13 f14 ?v_1)) (?v_3 (f5 f6 ?v2)) (?v_2 (f5 f6 ?v1))) (= (< (f12 ?v_0 ?v_2) (f12 ?v_0 ?v_3)) (and (< 0 ?v_1) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (= (f9 f10 (f12 (f13 f14 (f5 f6 ?v0)) (f5 f6 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f5 f6 ?v1)) (?v_0 (f5 f6 ?v0)) (?v_1 (f5 f6 ?v2))) (= (f9 f10 (f12 (f13 f14 (f5 f6 (f9 f10 (- ?v_0 ?v_2)))) ?v_1)) (f9 f10 (- (f12 (f13 f14 ?v_0) ?v_1) (f12 (f13 f14 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f5 f6 ?v0)) (?v_2 (f5 f6 ?v1)) (?v_1 (f5 f6 ?v2))) (= (f9 f10 (f12 (f13 f14 (+ ?v_0 ?v_2)) ?v_1)) (f9 f10 (+ (f12 (f13 f14 ?v_0) ?v_1) (f12 (f13 f14 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f13 f14 (f5 f6 ?v0))) (?v_1 (f5 f6 ?v1)) (?v_2 (f5 f6 ?v2))) (= (f9 f10 (f12 (f13 f14 (f12 ?v_0 ?v_1)) ?v_2)) (f9 f10 (f12 ?v_0 (f12 (f13 f14 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f9 f10 0))) (= (= (f9 f10 (f12 (f13 f14 (f5 f6 ?v0)) (f5 f6 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f9 f10 1))) (= (= (f9 f10 (f12 (f13 f14 (f5 f6 ?v0)) (f5 f6 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (f5 f6 ?v0)) (?v_0 (f5 f6 ?v1))) (= (f9 f10 (f12 (f13 f14 (+ ?v_1 1)) ?v_0)) (f9 f10 (+ ?v_0 (f12 (f13 f14 ?v_1) ?v_0)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_1 (f5 f6 ?v0)) (?v_2 (f5 f6 ?v1))) (= (<= ?v_0 (f12 (f13 f14 ?v_1) ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f13 f14 (f5 f6 ?v0))) (?v_2 (f5 f6 ?v2)) (?v_1 (f5 f6 ?v1))) (= (f9 f10 (f12 ?v_0 (f5 f6 (f9 f10 (- ?v_1 ?v_2))))) (f9 f10 (- (f12 ?v_0 ?v_1) (f12 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f13 f14 (f5 f6 ?v0))) (?v_1 (f5 f6 ?v1)) (?v_2 (f5 f6 ?v2))) (= (f9 f10 (f12 ?v_0 (+ ?v_1 ?v_2))) (f9 f10 (+ (f12 ?v_0 ?v_1) (f12 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f5 f6 ?v0))) (let ((?v_1 (f13 f14 ?v_0)) (?v_2 (f5 f6 ?v1))) (= (f9 f10 (f12 ?v_1 (+ ?v_2 1))) (f9 f10 (+ ?v_0 (f12 ?v_1 ?v_2))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (f5 f6 ?v0)) (?v_0 (f5 f6 ?v1))) (= (f9 f10 (f12 (f13 f14 ?v_1) ?v_0)) (f9 f10 (f12 (f13 f14 ?v_0) ?v_1))))))
(assert (forall ((?v0 S3)) (= (f9 f10 (f5 f6 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f5 f6 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f5 f6 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
