(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 () S3)
(declare-fun f6 () Int)
(declare-fun f7 () S3)
(declare-fun f8 (Int) S1)
(declare-fun f9 (S4 Int) Int)
(declare-fun f10 (S5 Int) S4)
(declare-fun f11 () S5)
(declare-fun f12 () Int)
(declare-fun f13 (Int) S1)
(declare-fun f14 () S5)
(declare-fun f15 (Int Int) S1)
(declare-fun f16 () S3)
(declare-fun f17 (S6 Int) S3)
(declare-fun f18 () S6)
(declare-fun f19 () Int)
(declare-fun f20 (S7 Int) S2)
(declare-fun f21 () S7)
(declare-fun f22 () Int)
(declare-fun f23 () Int)
(declare-fun f24 () Int)
(declare-fun f25 () Int)
(declare-fun f26 () Int)
(declare-fun f27 () Int)
(declare-fun f28 () Int)
(declare-fun f29 (Int Int) S1)
(declare-fun f30 (Int Int Int) S1)
(declare-fun f31 (S8 S9) Int)
(declare-fun f32 () S8)
(declare-fun f33 (Int Int) S9)
(declare-fun f34 () Int)
(declare-fun f35 (S10 S3) S3)
(declare-fun f36 (S11 S3) S10)
(declare-fun f37 () S11)
(declare-fun f38 () S11)
(declare-fun f39 () S4)
(declare-fun f40 (S3 S3) S1)
(assert (not (= f1 f2)))
(assert (not (< (+ 1 (f3 f4 f5)) (+ (* 4 f6) 1))))
(assert (let ((?v_0 (+ (* 4 f6) 1)) (?v_1 (+ 1 (f3 f4 f7)))) (and (< ?v_1 ?v_0) (= (f8 (f9 (f10 f11 ?v_0) ?v_1)) f1))))
(assert (< (f3 f4 f5) (f3 f4 f7)))
(assert (< 1 f12))
(assert (< 0 (+ 1 (f3 f4 f7))))
(assert (let ((?v_0 (+ (* 4 f6) 1)) (?v_1 (+ 1 (f3 f4 f7)))) (and (< ?v_1 ?v_0) (= (f8 (f9 (f10 f11 ?v_0) ?v_1)) f1))))
(assert (< (f3 f4 f5) (f3 f4 f7)))
(assert (not (= (f8 (f9 (f10 f11 (+ (* 4 f6) 1)) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f6) 1)))
(assert (let ((?v_0 (+ (* 4 f6) 1)) (?v_1 (+ 1 (f3 f4 f7)))) (not (=> (< ?v_1 ?v_0) (not (= (f8 (f9 (f10 f11 ?v_0) ?v_1)) f1))))))
(assert (= (f13 (+ (* 4 f6) 1)) f1))
(assert (= (f9 (f10 f14 (- 1)) (+ (* 4 f6) 1)) 1))
(assert (= (f15 (+ (* 4 f6) 1) (- 1)) f1))
(assert (= f16 (f17 f18 (- (f3 f4 (f17 f18 f12)) 1))))
(assert (and (= f5 (f17 f18 (- (f3 f4 (f17 f18 f19)) 1))) (= (f8 (f9 (f10 f11 (+ (* 4 f6) 1)) (+ 1 (f3 f4 f5)))) f1)))
(assert (< f12 (+ (* 4 f6) 1)))
(assert (let ((?v_0 (+ (* 4 f6) 1))) (=> (not (= (f15 ?v_0 (- 1)) f1)) (not (= (f9 (f10 f14 (- 1)) ?v_0) 1)))))
(assert (= (f8 (f9 (f10 f11 (+ (* 4 f6) 1)) f12)) f1))
(assert (= (f8 (f9 (f10 f11 (+ (* 4 f6) 1)) f19)) f1))
(assert (= (f8 (f9 (f10 f11 (+ (* 4 f6) 1)) (+ 1 (f3 f4 (f17 f18 (- (f3 f4 (f17 f18 f19)) 1)))))) f1))
(assert (=> (forall ((?v0 S3)) (=> (and (= ?v0 (f17 f18 (- (f3 f4 (f17 f18 f19)) 1))) (= (f8 (f9 (f10 f11 (+ (* 4 f6) 1)) (+ 1 (f3 f4 ?v0)))) f1)) false)) false))
(assert (<= 1 f12))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 2))) (=> (= (+ (f3 (f20 f21 ?v0) ?v_0) (f3 (f20 f21 ?v1) ?v_0)) (f9 (f10 f11 (+ (* 4 f6) 1)) (+ 1 (f3 f4 f7)))) false))) false))
(assert (let ((?v_0 (f17 f18 2))) (= (+ (f3 (f20 f21 f22) ?v_0) (f3 (f20 f21 f23) ?v_0)) (f9 (f10 f11 (+ (* 4 f6) 1)) (+ 1 (f3 f4 f7))))))
(assert (< 0 (f3 f4 f7)))
(assert (< 0 (f3 f4 f16)))
(assert (= (+ 1 (f3 f4 (f17 f18 (- (f3 f4 (f17 f18 f19)) 1)))) f19))
(assert (< 0 f19))
(assert (< f19 (+ 1 (f3 f4 f7))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f17 f18 (- (f3 f4 (f17 f18 f12)) 1))) (=> (< 0 (f3 f4 ?v0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f7)))) (=> (and (= ?v1 (- f23 (f9 (f10 f11 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f7)))) (=> (and (= ?v1 (- f22 (f9 (f10 f11 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (= (+ (f3 (f20 f21 f24) (f17 f18 2)) 1) (f9 (f10 f11 (+ (* 4 f6) 1)) f12)))
(assert (=> (= f12 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 2))) (= (+ (f3 (f20 f21 ?v0) ?v_0) (f3 (f20 f21 ?v1) ?v_0)) (+ (* 4 f6) 1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f13 ?v_0) f1) (= (f9 (f10 f14 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 ?v0) f1) (=> (= (f8 ?v1) f1) (= (f8 (f9 (f10 f11 ?v0) ?v1)) f1)))))
(assert (let ((?v_0 (+ 1 (f3 f4 f7)))) (and (= f25 (- f22 (f9 (f10 f11 f26) ?v_0))) (<= (ite (< f25 0) (* (- 2) f25) (* 2 f25)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f4 f7)))) (and (= f27 (- f23 (f9 (f10 f11 f28) ?v_0))) (<= (ite (< f27 0) (* (- 2) f27) (* 2 f27)) ?v_0))))
(assert (let ((?v_0 (f17 f18 2))) (= (+ (f3 (f20 f21 f25) ?v_0) (f3 (f20 f21 f27) ?v_0)) (f9 (f10 f11 (+ 1 (f3 f4 f7))) f19))))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f20 f21 f24) (f17 f18 2)) 1) (f9 (f10 f11 (+ (* 4 f6) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 ?v_0 (f17 f18 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (f9 (f10 f11 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f20 f21 ?v0))) (= (f9 (f10 f11 ?v0) (f3 ?v_0 (f17 f18 2))) (f3 ?v_0 (f17 f18 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 2))) (= (f3 (f20 f21 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f20 f21 ?v0) ?v_0) (f9 (f10 f11 (* 2 ?v0)) ?v1)) (f3 (f20 f21 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 2))) (= (f3 (f20 f21 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f20 f21 ?v0) ?v_0) (f9 (f10 f11 (* 2 ?v0)) ?v1)) (f3 (f20 f21 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f17 f18 2)) (?v_0 (f17 f18 3)) (?v_1 (f20 f21 ?v0)) (?v_3 (f20 f21 ?v1))) (= (f3 (f20 f21 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f9 (f10 f11 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f9 (f10 f11 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f17 f18 2)) (?v_0 (f17 f18 3)) (?v_3 (f20 f21 ?v1)) (?v_1 (f20 f21 ?v0))) (= (f3 (f20 f21 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f9 (f10 f11 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f9 (f10 f11 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (let ((?v_0 (f3 (f20 f21 f24) (f17 f18 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f17 f18 2))) (=> (= (+ (f3 (f20 f21 f25) ?v_0) (f3 (f20 f21 f27) ?v_0)) (f9 (f10 f11 (+ 1 (f3 f4 f7))) ?v0)) false))) false))
(assert (let ((?v_2 (f17 f18 2)) (?v_0 (f10 f11 f26)) (?v_1 (f10 f11 f28))) (= (+ (f3 (f20 f21 (+ (+ (f9 ?v_0 f25) (f9 ?v_1 f27)) f19)) ?v_2) (f3 (f20 f21 (- (f9 ?v_0 f27) (f9 ?v_1 f25))) ?v_2)) (f9 (f10 f11 (+ (* 4 f6) 1)) f19))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 (f10 f11 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 (f10 f11 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f4 ?v2))) (let ((?v_1 (f10 f11 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f9 ?v_1 ?v0) (f9 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f9 ?v_0 ?v0) (f9 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f9 (f10 f11 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f9 (f10 f11 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f9 (f10 f11 (- ?v0 ?v1)) ?v2) (- (f9 (f10 f11 ?v0) ?v2) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f9 (f10 f11 (+ ?v0 ?v1)) ?v2) (+ (f9 (f10 f11 ?v0) ?v2) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f10 f11 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f9 (f10 f11 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f9 (f10 f11 (- ?v0)) ?v1) (- (f9 (f10 f11 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (- ?v1 ?v2)) (- (f9 ?v_0 ?v1) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (+ ?v1 ?v2)) (+ (f9 ?v_0 ?v1) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f9 (f10 f11 ?v0) ?v1) (f9 (f10 f11 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f20 f21 ?v0) (f17 f18 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 2))) (= (= (f3 (f20 f21 ?v0) ?v_0) (f3 (f20 f21 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 2)) (?v_1 (f20 f21 ?v0))) (= (f3 (f20 f21 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f17 f18 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 3))) (= (f3 (f20 f21 (- ?v0)) ?v_0) (- (f3 (f20 f21 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f20 f21 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f17 f18 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f17 f18 3))) (let ((?v_0 (f3 (f20 f21 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f20 f21 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f17 f18 2))) (let ((?v_0 (f3 (f20 f21 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f20 f21 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f20 f21 ?v0) (f17 f18 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f20 f21 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (= (f13 2) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 2))) (= (f9 (f10 f11 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f20 f21 ?v0) ?v_0) (f3 (f20 f21 ?v1) ?v_0))))))
(assert (let ((?v_0 (f17 f18 2))) (= (f29 (+ 1 (f3 f4 f7)) (+ (f3 (f20 f21 f25) ?v_0) (f3 (f20 f21 f27) ?v_0))) f1)))
(assert (= (f29 (+ (* 4 f6) 1) (+ (f3 (f20 f21 f24) (f17 f18 2)) 1)) f1))
(assert (= (f29 (+ (* 4 f6) 1) (- (f3 (f20 f21 f24) (f17 f18 2)) (- 1))) f1))
(assert (= (f30 (f3 (f20 f21 f24) (f17 f18 2)) (- 1) (+ (* 4 f6) 1)) f1))
(assert (= (f31 f32 (f33 f24 1)) (f9 (f10 f11 (+ (* 4 f6) 1)) f12)))
(assert (let ((?v_0 (+ (* 4 f6) 1))) (and (<= 0 f24) (and (< f24 ?v_0) (= (f30 f34 f24 ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f20 f21 ?v1)) (?v_1 (f17 f18 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (f9 (f10 f11 ?v1) (f3 ?v_0 (f17 f18 (- (f3 f4 ?v_1) 1)))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f3 f4 ?v1)) (?v_1 (f3 f4 ?v0)) (?v_2 (f20 f21 ?v2))) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f17 f18 (- (+ ?v_0 1) ?v_1))) (f9 (f10 f11 (f3 ?v_2 (f17 f18 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f3 f4 ?v1)) (?v_1 (f3 f4 ?v0)) (?v_2 (f36 f37 ?v2))) (=> (<= ?v_1 ?v_0) (= (f35 ?v_2 (f17 f18 (- (+ ?v_0 1) ?v_1))) (f35 (f36 f38 (f35 ?v_2 (f17 f18 (- ?v_0 ?v_1)))) ?v2))))))
(assert (= (f30 (f3 (f20 f21 f34) (f17 f18 2)) (- 1) (+ (* 4 f6) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f30 (f3 (f20 f21 ?v0) (f17 f18 2)) (- 1) (+ (* 4 f6) 1)) f1) false)) false))
(assert (let ((?v_0 (f17 f18 2))) (= (f30 (f3 (f20 f21 f24) ?v_0) (f3 (f20 f21 f34) ?v_0) (+ (* 4 f6) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f6) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f30 f34 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f6) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f30 f34 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f30 f34 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f29 ?v0 (- ?v1 ?v2)) f1) (=> (= (f29 ?v0 ?v2) f1) (= (f29 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0 ?v1) f1) (=> (= (f29 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f29 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f29 ?v0 ?v1) f1) (=> (= (f29 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f29 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (= (= (f29 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f30 ?v0 0 ?v1) f1)) (=> (= (f30 (f3 (f20 f21 ?v2) (f17 f18 2)) ?v0 ?v1) f1) (not (= (f29 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f10 f11 ?v0)) (?v_1 (f10 f11 ?v1))) (= (f9 (f10 f11 (f31 f32 (f33 ?v0 ?v1))) (f31 f32 (f33 ?v2 ?v3))) (f31 f32 (f33 (+ (f9 ?v_0 ?v2) (f9 ?v_1 ?v3)) (- (f9 ?v_0 ?v3) (f9 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 (+ ?v1 (f9 (f10 f11 ?v0) ?v2))) f1) (= (f29 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f29 (f9 (f10 f11 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1) f1) (= (= (f29 ?v0 (+ ?v2 ?v3)) f1) (= (f29 ?v0 (+ (+ ?v2 (f9 (f10 f11 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f29 (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f29 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f4 (f35 (f36 f37 ?v0) ?v1)) (f3 (f20 f21 (f3 f4 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f20 f21 (f3 f4 ?v0)) ?v1) (f3 f4 (f35 (f36 f37 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f17 f18 (f3 (f20 f21 ?v0) ?v1)) (f35 (f36 f37 (f17 f18 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 (f10 f11 ?v0) ?v1))) (= (f17 f18 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f17 f18 (f9 (f10 f11 (f3 f4 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)))) (f3 f4 (f17 f18 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f9 (f10 f11 (f3 f4 ?v0)) (f3 f4 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f9 (f10 f11 (f3 f4 ?v0)) (f3 f4 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f17 f18 (f9 (f10 f11 ?v0) ?v1)) (f17 f18 (f9 (f10 f11 (f3 f4 (f17 f18 ?v0))) (f3 f4 (f17 f18 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f17 f18 (f9 (f10 f11 ?v0) ?v1)) (f17 f18 (f9 (f10 f11 (f3 f4 (f17 f18 (- ?v0)))) (f3 f4 (f17 f18 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 (f20 f21 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f17 f18 (f9 (f10 f11 (f3 f4 ?v1)) (f3 f4 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f13 ?v0) f1) (=> (= (f29 ?v0 (f3 (f20 f21 ?v1) ?v2)) f1) (= (f29 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f20 f21 ?v0) ?v2))) (=> (= (f13 ?v0) f1) (=> (not (= (f29 ?v0 ?v1) f1)) (=> (= (f29 ?v_0 (f9 (f10 f11 ?v1) ?v3)) f1) (= (f29 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f20 f21 ?v0) ?v2))) (=> (= (f13 ?v0) f1) (=> (not (= (f29 ?v0 ?v1) f1)) (=> (= (f29 ?v_0 (f9 (f10 f11 ?v3) ?v1)) f1) (= (f29 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int)) (= (= (f8 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f31 f32 (f33 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 ?v0) f1) (=> (not (= (f29 ?v0 ?v1) f1)) (= (f30 (f3 (f20 f21 ?v1) (f17 f18 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f9 (f10 f14 ?v0) ?v1) (ite (= (f30 ?v0 0 ?v1) f1) 0 (ite (= (f15 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f30 (f3 (f20 f21 ?v2) (f17 f18 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f13 ?v0) f1) (=> (= (f29 ?v0 (f3 (f20 f21 ?v1) ?v2)) f1) (=> (< 0 (f3 f4 ?v2)) (= (f29 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f13 ?v0) f1) (=> (= (f29 ?v0 (f9 (f10 f11 ?v1) ?v2)) f1) (or (= (f29 ?v0 ?v1) f1) (= (f29 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f30 ?v3 ?v4 ?v2) f1) (= (f30 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f30 ?v1 (- 1) ?v0) f1) (not (= (f30 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f30 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f30 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int)) (= (f30 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (= (f30 ?v3 (f9 (f10 f11 ?v0) ?v4) ?v2) f1) (= (f30 ?v3 (f9 (f10 f11 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f10 f11 ?v4))) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (= (f30 ?v3 (f9 ?v_0 ?v0) ?v2) f1) (= (f30 ?v3 (f9 ?v_0 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 ?v0 0 ?v1) f1) (= (f29 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 ?v0 0 ?v1) f1) (= (f29 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 (f3 (f20 f21 ?v0) ?v3) (f3 (f20 f21 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f3 f4 ?v0)) (=> (= (f29 ?v1 ?v2) f1) (= (f29 ?v1 (f3 (f20 f21 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f13 ?v0) f1) (=> (< 0 ?v1) (=> (= (f30 (f9 (f10 f11 ?v1) ?v2) 0 ?v0) f1) (or (= (f30 ?v1 0 ?v0) f1) (= (f30 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f13 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f30 ?v1 0 ?v0) f1)) (not (= (f30 ?v2 0 ?v0) f1))) (not (= (f30 (f9 (f10 f11 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f13 ?v0) f1) (=> (not (= (f30 ?v1 0 ?v0) f1)) (=> (not (= (f30 ?v2 0 ?v0) f1)) (not (= (f30 (f9 (f10 f11 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f13 ?v1) f1) (=> (= (f29 ?v1 (f9 (f10 f11 ?v0) ?v2)) f1) (or (= (f29 ?v1 ?v0) f1) (= (f29 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 ?v0) f1) (=> (< 0 ?v1) (=> (= (f30 (f9 (f10 f11 ?v1) ?v1) 1 ?v0) f1) (or (= (f30 ?v1 1 ?v0) f1) (= (f30 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f30 (f9 (f10 f11 ?v1) ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f30 (f3 ?v_0 ?v1) 1 ?v2) f1) (= (f30 (f3 ?v_0 (f17 f18 (f9 (f10 f11 (f3 f4 ?v1)) (f3 f4 ?v3)))) 1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f10 f11 ?v1))) (= (+ (f9 (f10 f11 (- ?v0 (f9 ?v_0 ?v2))) ?v3) (f9 (f10 f11 (- ?v4 (f9 ?v_0 ?v5))) ?v6)) (- (+ (f9 (f10 f11 ?v0) ?v3) (f9 (f10 f11 ?v4) ?v6)) (f9 ?v_0 (+ (f9 (f10 f11 ?v2) ?v3) (f9 (f10 f11 ?v5) ?v6))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f4 (f17 f18 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f17 f18 (f9 (f10 f11 ?v_0) ?v_0)) (f17 f18 (+ (f9 (f10 f11 (f3 f4 (f17 f18 (- ?v0 1)))) (f3 f4 (f17 f18 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 ?v1 (- ?v2)) f1) (= (f30 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f30 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f30 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f30 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f30 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f30 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= (f30 ?v1 ?v3 ?v2) f1) (= (f30 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= (f30 ?v3 ?v4 ?v2) f1) (= (f30 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= (f30 ?v3 ?v4 ?v2) f1) (= (f30 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f13 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= (f30 ?v3 ?v4 ?v2) f1) (= (f30 (f9 (f10 f11 ?v0) ?v3) (f9 (f10 f11 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f10 f11 ?v3))) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 (f9 ?v_0 ?v0) (f9 ?v_0 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 (f9 (f10 f11 ?v0) ?v3) (f9 (f10 f11 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f30 (f9 (f10 f11 ?v0) ?v1) (f9 (f10 f11 ?v2) ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f30 (f9 (f10 f11 ?v0) ?v_0) 1 ?v1) f1) (= (f30 ?v0 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f9 (f10 f11 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 ?v1 ?v2) f1) (= (f29 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int)) (= (= (f13 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f29 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 ?v_0 (f17 f18 (+ (* 2 (f3 f4 ?v1)) 1))) (f9 (f10 f11 ?v0) (f3 (f20 f21 (f3 ?v_0 ?v1)) (f17 f18 2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f17 f18 (+ (* 2 (f3 f4 ?v1)) 1))) (f35 (f36 f38 ?v0) (f35 (f36 f37 (f35 ?v_0 ?v1)) (f17 f18 2)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f17 f18 (+ (* 2 (f3 f4 ?v1)) 1))) (f9 (f10 f11 ?v0) (f9 (f10 f11 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f36 f37 ?v0))) (let ((?v_1 (f35 ?v_0 ?v1))) (= (f35 ?v_0 (f17 f18 (+ (* 2 (f3 f4 ?v1)) 1))) (f35 (f36 f38 ?v0) (f35 (f36 f38 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f17 f18 (* 2 (f3 f4 ?v1)))) (f9 (f10 f11 ?v_1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f36 f37 ?v0))) (let ((?v_1 (f35 ?v_0 ?v1))) (= (f35 ?v_0 (f17 f18 (* 2 (f3 f4 ?v1)))) (f35 (f36 f38 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f13 ?v1) f1) (= (f29 ?v1 ?v0) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f36 f38 ?v0))) (= (f35 (f36 f38 (f35 ?v_0 ?v1)) (f35 (f36 f38 ?v2) ?v3)) (f35 (f36 f38 (f35 ?v_0 ?v2)) (f35 (f36 f38 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) (f9 (f10 f11 ?v2) ?v3)) (f9 (f10 f11 (f9 ?v_0 ?v2)) (f9 (f10 f11 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f36 f38 (f35 (f36 f38 ?v0) ?v1))) (?v_0 (f36 f38 ?v2))) (= (f35 ?v_1 (f35 ?v_0 ?v3)) (f35 ?v_0 (f35 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f10 f11 (f9 (f10 f11 ?v0) ?v1))) (?v_0 (f10 f11 ?v2))) (= (f9 ?v_1 (f9 ?v_0 ?v3)) (f9 ?v_0 (f9 ?v_1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f36 f38 ?v0)) (?v_1 (f35 (f36 f38 ?v2) ?v3))) (= (f35 (f36 f38 (f35 ?v_0 ?v1)) ?v_1) (f35 ?v_0 (f35 (f36 f38 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f10 f11 ?v0)) (?v_1 (f9 (f10 f11 ?v2) ?v3))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v_1) (f9 ?v_0 (f9 (f10 f11 ?v1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f38 ?v0))) (= (f35 (f36 f38 (f35 ?v_0 ?v1)) ?v2) (f35 (f36 f38 (f35 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2) (f9 (f10 f11 (f9 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f38 ?v0))) (= (f35 (f36 f38 (f35 ?v_0 ?v1)) ?v2) (f35 ?v_0 (f35 (f36 f38 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f10 f11 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f38 ?v0))) (= (f35 ?v_0 (f35 (f36 f38 ?v1) ?v2)) (f35 (f36 f38 (f35 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f9 (f10 f11 ?v1) ?v2)) (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f36 f38 ?v0)) (?v_0 (f36 f38 ?v1))) (= (f35 ?v_1 (f35 ?v_0 ?v2)) (f35 ?v_0 (f35 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f10 f11 ?v0)) (?v_0 (f10 f11 ?v1))) (= (f9 ?v_1 (f9 ?v_0 ?v2)) (f9 ?v_0 (f9 ?v_1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f35 (f36 f38 ?v0) ?v1) (f35 (f36 f38 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f9 (f10 f11 ?v0) ?v1) (f9 (f10 f11 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 2))) (= (f3 (f20 f21 (f9 f39 ?v0)) ?v_0) (f3 (f20 f21 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f3 (f20 f21 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f35 (f36 f37 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 (f20 f21 ?v0) (f17 f18 2)))) (= (f9 f39 ?v_0) ?v_0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 f4 ?v0))) (= (f17 f18 (* 2 ?v_0)) (f17 f18 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 f4 ?v0))) (= (f17 f18 (* ?v_0 2)) (f17 f18 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f17 f18 0)) (?v_2 (f3 f4 ?v0)) (?v_1 (f3 f4 ?v1))) (= (f17 f18 (f9 (f10 f11 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f17 f18 (+ ?v_1 (f9 (f10 f11 (f3 f4 (f17 f18 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f9 (f10 f11 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f17 f18 (+ (f3 f4 ?v1) (f3 f4 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 (f36 f38 (f35 ?v_0 ?v1)) (f35 ?v_0 ?v2)) (f35 ?v_0 (f17 f18 (+ (f3 f4 ?v1) (f3 f4 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f20 f21 (f9 (f10 f11 ?v0) ?v1)) ?v2) (f9 (f10 f11 (f3 (f20 f21 ?v0) ?v2)) (f3 (f20 f21 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f35 (f36 f37 (f35 (f36 f38 ?v0) ?v1)) ?v2) (f35 (f36 f38 (f35 (f36 f37 ?v0) ?v2)) (f35 (f36 f37 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f9 (f10 f11 (f3 ?v_0 ?v1)) ?v0) (f3 ?v_0 (f17 f18 (+ (f3 f4 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 (f36 f38 (f35 ?v_0 ?v1)) ?v0) (f35 ?v_0 (f17 f18 (+ (f3 f4 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f9 (f10 f11 ?v0) (f3 ?v_0 ?v1)) (f3 ?v_0 (f17 f18 (+ (f3 f4 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 (f36 f38 ?v0) (f35 ?v_0 ?v1)) (f35 ?v_0 (f17 f18 (+ (f3 f4 ?v1) 1)))))))
(assert (forall ((?v0 Int)) (= (f3 (f20 f21 ?v0) (f17 f18 3)) (f9 (f10 f11 (f9 (f10 f11 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S3)) (= (f35 (f36 f37 ?v0) (f17 f18 3)) (f35 (f36 f38 (f35 (f36 f38 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f3 (f20 f21 ?v0) (f17 f18 2)) (f9 (f10 f11 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f35 (f36 f37 ?v0) (f17 f18 2)) (f35 (f36 f38 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 ?v_0 (f17 f18 (+ (f3 f4 ?v1) 1))) (f9 (f10 f11 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f17 f18 (+ (f3 f4 ?v1) 1))) (f35 (f36 f38 ?v0) (f35 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (f9 (f10 f11 ?v0) ?v0) (f3 (f20 f21 ?v0) (f17 f18 2)))))
(assert (forall ((?v0 S3)) (= (f35 (f36 f38 ?v0) ?v0) (f35 (f36 f37 ?v0) (f17 f18 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 ?v_0 (f17 f18 (* 2 (f3 f4 ?v1)))) (f3 (f20 f21 (f3 ?v_0 ?v1)) (f17 f18 2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f17 f18 (* 2 (f3 f4 ?v1)))) (f35 (f36 f37 (f35 ?v_0 ?v1)) (f17 f18 2))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 (f20 f21 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f17 f18 (f9 (f10 f11 (f3 f4 ?v1)) (f3 f4 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 (f36 f37 (f35 ?v_0 ?v1)) ?v2) (f35 ?v_0 (f17 f18 (f9 (f10 f11 (f3 f4 ?v1)) (f3 f4 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 ?v1) (ite (= ?v1 (f17 f18 0)) (f17 f18 1) (f17 f18 (f9 (f10 f11 (f3 f4 ?v0)) (f3 f4 (f35 ?v_0 (f17 f18 (- (f3 f4 ?v1) 1)))))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f20 f21 (f3 f4 ?v0)) ?v1) (f3 f4 (f35 (f36 f37 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f35 (f36 f37 (f17 f18 ?v0)) ?v1) (f17 f18 (f3 (f20 f21 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f17 f18 0))) (= (= (f29 (f3 (f20 f21 ?v1) ?v0) (f3 (f20 f21 ?v2) ?v0)) f1) (= (f29 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f9 (f10 f11 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (<= 0 (f3 (f20 f21 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f17 f18 (f9 (f10 f11 (f3 f4 (f17 f18 ?v0))) (f3 f4 (f17 f18 ?v1)))) (f17 f18 (f9 (f10 f11 ?v0) ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f9 (f10 f11 (f3 f4 ?v0)) (f3 f4 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f29 (f3 (f20 f21 ?v0) ?v1) (f3 (f20 f21 ?v2) ?v1)) f1) (=> (not (= ?v1 (f17 f18 0))) (= (f29 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f20 f21 (- 1)))) (let ((?v_1 (f3 ?v_0 ?v1)) (?v_2 (f3 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f30 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f17 f18 2)) (?v_1 (f3 f4 ?v0)) (?v_2 (f3 f4 ?v1))) (= (f17 f18 (- (f3 f4 (f35 (f36 f37 ?v0) ?v_0)) (f3 f4 (f35 (f36 f37 ?v1) ?v_0)))) (f17 f18 (f9 (f10 f11 (+ ?v_1 ?v_2)) (f3 f4 (f17 f18 (- ?v_1 ?v_2)))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f17 f18 1))) (= (= (f17 f18 (f9 (f10 f11 (f3 f4 ?v0)) (f3 f4 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f30 1 (- 1) ?v0) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 (f20 f21 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 (+ (f3 f4 ?v1) 1)))) (= (<= (f3 f4 (f35 (f36 f37 ?v0) ?v_0)) (f3 f4 (f35 (f36 f37 ?v2) ?v_0))) (<= (f3 f4 ?v0) (f3 f4 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 (+ (f3 f4 ?v1) 1)))) (= (< (f3 f4 (f35 (f36 f37 ?v0) ?v_0)) (f3 f4 (f35 (f36 f37 ?v2) ?v_0))) (< (f3 f4 ?v0) (f3 f4 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 (+ (f3 f4 ?v1) 1)))) (= (= (f35 (f36 f37 ?v0) ?v_0) (f35 (f36 f37 ?v2) ?v_0)) (= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f17 f18 1))) (= (= (f35 (f36 f37 ?v0) ?v1) ?v_0) (or (= ?v0 ?v_0) (= ?v1 (f17 f18 0)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f17 f18 0))) (= (= (f35 (f36 f37 ?v0) ?v1) ?v_0) (and (not (= ?v1 ?v_0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (=> (not (= ?v0 0)) (= (= (f29 ?v1 ?v2) f1) (= (f29 (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 ?v_0 (f17 f18 (f9 (f10 f11 (f3 f4 ?v1)) (f3 f4 ?v2)))) (f3 (f20 f21 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f17 f18 (f9 (f10 f11 (f3 f4 ?v1)) (f3 f4 ?v2)))) (f35 (f36 f37 (f35 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f9 f39 (f3 (f20 f21 ?v0) ?v1)) (f3 (f20 f21 (f9 f39 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f3 (f20 f21 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f35 (f36 f37 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f9 (f10 f11 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f9 (f10 f11 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 ?v1) f1) (= (f29 ?v0 (- ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 ?v1) f1) (= (f29 (- ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f3 f4 (f35 (f36 f37 ?v0) ?v1))) (or (< 0 (f3 f4 ?v0)) (= ?v1 (f17 f18 0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f17 f18 (+ 0 1)))) (= (f35 (f36 f37 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f17 f18 (+ 0 1)))) (= (= (f35 (f36 f37 ?v0) ?v1) ?v_0) (or (= ?v1 (f17 f18 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f37 ?v0))) (=> (< 0 (f3 f4 ?v0)) (=> (< (f3 f4 (f35 ?v_0 ?v1)) (f3 f4 (f35 ?v_0 ?v2))) (< (f3 f4 ?v1) (f3 f4 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f3 f4 ?v0)) (<= ?v_0 (f3 f4 (f35 (f36 f37 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 ?v_0 (f17 f18 (+ (f3 f4 ?v1) 1))) (f9 (f10 f11 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f17 f18 (+ (f3 f4 ?v1) 1))) (f35 (f36 f38 ?v0) (f35 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 ?v_0 (f17 f18 (+ (f3 f4 ?v1) 1))) (f9 (f10 f11 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f17 f18 (+ (f3 f4 ?v1) 1))) (f35 (f36 f38 (f35 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 ?v_0 (f17 f18 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (f9 (f10 f11 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f17 f18 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (f35 (f36 f38 (f35 ?v_0 ?v1)) (f35 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f3 (f20 f21 ?v0) ?v1))) (= (f9 (f10 f11 ?v_0) ?v0) (f9 (f10 f11 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f35 (f36 f37 ?v0) ?v1))) (= (f35 (f36 f38 ?v_0) ?v0) (f35 (f36 f38 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f20 f21 (f9 (f10 f11 ?v0) ?v1)) ?v2) (f9 (f10 f11 (f3 (f20 f21 ?v0) ?v2)) (f3 (f20 f21 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f35 (f36 f37 (f35 (f36 f38 ?v0) ?v1)) ?v2) (f35 (f36 f38 (f35 (f36 f37 ?v0) ?v2)) (f35 (f36 f37 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f29 (f3 ?v_0 ?v1) ?v2) f1) (=> (<= (f3 f4 ?v3) (f3 f4 ?v1)) (= (f29 (f3 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f36 f37 ?v0))) (=> (= (f40 (f35 ?v_0 ?v1) ?v2) f1) (=> (<= (f3 f4 ?v3) (f3 f4 ?v1)) (= (f40 (f35 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f29 ?v0 ?v1) f1) (=> (<= (f3 f4 ?v2) (f3 f4 ?v3)) (= (f29 (f3 (f20 f21 ?v0) ?v2) (f3 (f20 f21 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f40 ?v0 ?v1) f1) (=> (<= (f3 f4 ?v2) (f3 f4 ?v3)) (= (f40 (f35 (f36 f37 ?v0) ?v2) (f35 (f36 f37 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f20 f21 ?v2))) (=> (<= (f3 f4 ?v0) (f3 f4 ?v1)) (= (f29 (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f37 ?v2))) (=> (<= (f3 f4 ?v0) (f3 f4 ?v1)) (= (f40 (f35 ?v_0 ?v0) (f35 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f29 ?v0 ?v1) f1) (= (f29 (f3 (f20 f21 ?v0) ?v2) (f3 (f20 f21 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f40 ?v0 ?v1) f1) (= (f40 (f35 (f36 f37 ?v0) ?v2) (f35 (f36 f37 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f29 (f9 (f10 f11 ?v0) ?v1) ?v2) f1) (= (f29 ?v1 ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f40 (f35 (f36 f38 ?v0) ?v1) ?v2) f1) (= (f40 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f29 (f9 (f10 f11 ?v0) ?v1) ?v2) f1) (= (f29 ?v0 ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f40 (f35 (f36 f38 ?v0) ?v1) ?v2) f1) (= (f40 ?v0 ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f37 ?v0))) (=> (= (f40 (f35 ?v_0 ?v1) (f35 ?v_0 ?v2)) f1) (=> (< 1 (f3 f4 ?v0)) (<= (f3 f4 ?v1) (f3 f4 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 (f17 f18 0))) (= (= (f40 (f35 (f36 f37 ?v1) ?v0) (f35 (f36 f37 ?v2) ?v0)) f1) (= (f40 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (f40 (f17 f18 ?v0) (f17 f18 ?v1)) f1) (= (f29 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f29 (f3 f4 ?v0) (f3 f4 ?v1)) f1) (= (f40 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f40 (f17 f18 ?v0) ?v1) f1) (ite (<= 0 ?v0) (= (f29 ?v0 (f3 f4 ?v1)) f1) (= ?v1 (f17 f18 0))))))
(assert (forall ((?v0 S3) (?v1 Int)) (= (= (f29 (f3 f4 ?v0) ?v1) f1) (= (f40 ?v0 (f17 f18 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f29 ?v0 (f3 f4 ?v1)) f1) (= (f40 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f40 ?v0 ?v1) f1) (= (f29 (f3 f4 ?v0) (f3 f4 ?v1)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f40 (f35 (f36 f37 ?v0) ?v1) (f35 (f36 f37 ?v2) ?v1)) f1) (=> (not (= ?v1 (f17 f18 0))) (= (f40 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f3 f4 ?v2)) (?v_0 (f3 f4 ?v3))) (=> (= ?v0 (f17 f18 (+ (f9 (f10 f11 (f3 f4 ?v1)) ?v_1) ?v_0))) (=> (< 0 ?v_0) (=> (< ?v_0 ?v_1) (not (= (f40 ?v2 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f40 ?v0 ?v1) f1) (= (f40 (f35 (f36 f37 ?v0) ?v2) (f35 (f36 f37 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f11 (f3 f4 ?v2)))) (=> (= (f40 ?v0 ?v1) f1) (= (f40 (f17 f18 (f9 ?v_0 (f3 f4 ?v0))) (f17 f18 (f9 ?v_0 (f3 f4 ?v1)))) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f3 f4 ?v2))) (=> (= (f40 ?v0 ?v1) f1) (= (f40 (f17 f18 (f9 (f10 f11 (f3 f4 ?v0)) ?v_0)) (f17 f18 (f9 (f10 f11 (f3 f4 ?v1)) ?v_0))) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f40 ?v0 ?v1) f1) (or (= ?v1 (f17 f18 0)) (or (= ?v1 ?v0) (<= (* 2 (f3 f4 ?v0)) (f3 f4 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f40 ?v0 ?v1) f1) (= (f40 ?v0 (f35 (f36 f37 ?v1) (f17 f18 (+ (f3 f4 ?v2) 1)))) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 (f17 f18 0))) (=> (= (f40 (f35 (f36 f37 ?v1) ?v0) ?v2) f1) (= (f40 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f3 f4 ?v1))) (= (= (f40 (f17 f18 (f9 (f10 f11 (f3 f4 ?v0)) ?v_0)) (f17 f18 (f9 (f10 f11 (f3 f4 ?v2)) ?v_0))) f1) (or (= ?v1 (f17 f18 0)) (= (f40 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f39 ?v0))) (= (f9 (f10 f11 ?v_0) ?v_0) (f9 (f10 f11 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f9 f39 (f9 (f10 f11 ?v0) ?v1)) (f9 (f10 f11 (f9 f39 ?v0)) (f9 f39 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 f39 ?v0) (f9 f39 ?v1)) (= (f29 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f29 ?v0 ?v1) f1) (=> (= (f29 ?v1 ?v2) f1) (= (f29 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f40 ?v0 ?v1) f1) (=> (= (f40 ?v1 ?v2) f1) (= (f40 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3)) (= (f17 f18 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f17 f18 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f17 f18 ?v0)) 0))))
(check-sat)
(exit)
