(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source | 
  Boogie/Spec# benchmarks.
  This benchmark was translated by Michal Moskal.
|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun AfterLoop_2_GeneratedUnifiedExit_correct () Int)
(declare-fun InRange (Int Int) Bool)
(declare-fun int_18446744073709551615 () Int)
(declare-fun Smt.false () Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun select1 (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun CONCVARSYM (Int) Int)
(declare-fun divides (Int Int) Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun subtypes (Int Int) Bool)
(declare-fun store1 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun UnlockNow_2_LoopEnd_correct () Int)
(declare-fun ContinueIteration_correct () Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun int_2147483647 () Int)
(declare-fun x_0 () Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun x_1 () Int)
(declare-fun ReallyLastGeneratedExit_correct () Int)
(declare-fun x_2 () Int)
(declare-fun LoopEnd_correct () Int)
(declare-fun AfterLoop_correct () Int)
(declare-fun int_m9223372036854775808 () Int)
(declare-fun Smt.true () Int)
(declare-fun UnlockNow_correct () Int)
(declare-fun int_4294967295 () Int)
(declare-fun LoopHead_correct () Int)
(declare-fun start_correct () Int)
(declare-fun LoopHead_2_LoopEnd_correct () Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun boolNot (Int) Int)
(declare-fun GeneratedUnifiedExit_correct () Int)
(declare-fun held_0 () Int)
(declare-fun held_1 () Int)
(declare-fun held_2 () Int)
(declare-fun intLess (Int Int) Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun EndIteration_correct () Int)
(declare-fun is (Int Int) Int)
(declare-fun int_m2147483648 () Int)
(declare-fun modulo (Int Int) Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun int_9223372036854775807 () Int)
(assert true)
(assert true)
(assert (forall ((?A Int) (?i Int) (?v Int)) (= (select1 (store1 ?A ?i ?v) ?i) ?v)))
(assert (forall ((?A Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A ?i ?v) ?j) (select1 ?A ?j)))))
(assert (forall ((?A Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A ?o ?f ?v) ?o ?f) ?v)))
(assert (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g)))))
(assert (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolIff ?x ?y) Smt.true) (= (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolImplies ?x ?y) Smt.true) (=> (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolAnd ?x ?y) Smt.true) (and (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolOr ?x ?y) Smt.true) (or (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int)) (! (= (= (boolNot ?x) Smt.true) (not (= ?x Smt.true))) :pattern ((boolNot ?x)) )))
(assert (forall ((?x Int) (?y Int)) (= (= (anyEqual ?x ?y) Smt.true) (= ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (! (= (= (anyNeq ?x ?y) Smt.true) (not (= ?x ?y))) :pattern ((anyNeq ?x ?y)) )))
(assert (forall ((?x Int) (?y Int)) (= (= (intLess ?x ?y) Smt.true) (< ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (= (= (intAtMost ?x ?y) Smt.true) (<= ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (= (= (intAtLeast ?x ?y) Smt.true) (>= ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (= (= (intGreater ?x ?y) Smt.true) (> ?x ?y))))
(assert (distinct Smt.false Smt.true))
(assert (forall ((?t Int)) (! (subtypes ?t ?t) :pattern ((subtypes ?t ?t)) )))
(assert (forall ((?t Int) (?u Int) (?v Int)) (! (=> (and (subtypes ?t ?u) (subtypes ?u ?v)) (subtypes ?t ?v)) :pattern ((subtypes ?t ?u) (subtypes ?u ?v)) )))
(assert (forall ((?t Int) (?u Int)) (! (=> (and (subtypes ?t ?u) (subtypes ?u ?t)) (= ?t ?u)) :pattern ((subtypes ?t ?u) (subtypes ?u ?t)) )))
(assert (let ((?v_0 (<= 0 0)) (?v_1 (= 0 0)) (?v_3 (<= 0 x_0)) (?v_2 (<= 1 1))) (let ((?v_18 (and ?v_2 ?v_2 ?v_3 ?v_3)) (?v_5 (<= 0 held_1)) (?v_6 (<= 0 x_2))) (let ((?v_4 (and ?v_5 (<= held_1 1) ?v_6 ?v_3)) (?v_8 (= x_2 x_0)) (?v_7 (= held_1 0)) (?v_10 (=> true true)) (?v_15 (= ContinueIteration_correct Smt.true)) (?v_9 (= held_1 1)) (?v_11 (= ReallyLastGeneratedExit_correct Smt.true)) (?v_12 (= GeneratedUnifiedExit_correct Smt.true)) (?v_13 (= AfterLoop_2_GeneratedUnifiedExit_correct Smt.true)) (?v_14 (= AfterLoop_correct Smt.true)) (?v_16 (= EndIteration_correct Smt.true)) (?v_17 (= LoopEnd_correct Smt.true))) (let ((?v_20 (=> true ?v_17)) (?v_23 (= LoopHead_2_LoopEnd_correct Smt.true)) (?v_19 (= 1 1)) (?v_21 (= UnlockNow_2_LoopEnd_correct Smt.true)) (?v_22 (= UnlockNow_correct Smt.true)) (?v_24 (= LoopHead_correct Smt.true)) (?v_25 (= start_correct Smt.true))) (not (=> (=> (=> true (=> true (=> (and ?v_0 ?v_0 ?v_0 ?v_0) (=> (and ?v_0 ?v_0) (and ?v_1 (=> ?v_1 (=> (=> (=> true (=> (and (<= 0 held_0) ?v_3) (=> (= held_0 0) (=> ?v_18 (=> (and (=> (=> true (=> ?v_4 (=> ?v_4 (=> (and (=> (=> true (=> ?v_4 (=> (not ?v_8) (=> ?v_4 (=> (and ?v_5 ?v_6) (and ?v_7 (=> ?v_7 (=> false ?v_10)))))))) ?v_15) (=> (=> true (=> ?v_4 (=> ?v_8 (=> ?v_4 (=> (=> (=> true (=> ?v_4 (and ?v_9 (=> ?v_9 (=> (and ?v_0 ?v_0 ?v_6 ?v_3) (=> (=> (=> true (=> (= held_2 0) (=> (=> (=> true (=> (=> (=> true ?v_10) ?v_11) ?v_11)) ?v_12) ?v_12))) ?v_13) ?v_13)))))) ?v_14) ?v_14))))) ?v_16)) (and ?v_15 ?v_16))))) ?v_17) (=> (=> true (=> ?v_8 (=> ?v_9 ?v_20))) ?v_23) (=> (=> true (=> ?v_18 (and ?v_19 (=> ?v_19 (=> (= x_1 (+ x_0 1)) (=> (and ?v_0 ?v_0 (<= 1 x_1) ?v_3) (=> (=> (=> true (=> (= x_2 x_1) (=> ?v_7 ?v_20))) ?v_21) ?v_21))))))) ?v_22)) (and ?v_22 ?v_23)))))) ?v_24) ?v_24))))))) ?v_25) ?v_25)))))))
(check-sat)
(exit)
