(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sl_sorted_set/delete.spl:56:12-24:A postcondition of procedure delete might not hold at this return point
  tests/spl/sl_sorted_set/delete.spl:27:10-52:Related location: This is the postcondition that might not hold
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldLoc Loc) Loc)
(declare-fun read$1 (FldInt Loc) Int)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetInt)
(declare-fun emptyset$1 () SetLoc)
(declare-fun setenum$0 (Int) SetInt)
(declare-fun setenum$1 (Loc) SetLoc)
(declare-fun union$0 (SetInt SetInt) SetInt)
(declare-fun union$1 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetInt SetInt) SetInt)
(declare-fun intersection$1 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetInt SetInt) SetInt)
(declare-fun setminus$1 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun Frame$0 (SetLoc SetLoc FldLoc FldLoc) Bool)
(declare-fun Frame$1 (SetLoc SetLoc FldInt FldInt) Bool)
(declare-fun in$0 (Int SetInt) Bool)
(declare-fun in$1 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Alloc_1$0 () SetLoc)
(declare-fun Axiom_24$0 () Bool)
(declare-fun Axiom_25$0 () Bool)
(declare-fun Axiom_26$0 () Bool)
(declare-fun Axiom_27$0 () Bool)
(declare-fun Axiom_28$0 () Bool)
(declare-fun Axiom_29$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_1$0 () SetLoc)
(declare-fun FP_2$0 () SetLoc)
(declare-fun FP_3$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_1$0 () SetLoc)
(declare-fun FP_Caller_final_2$0 () SetLoc)
(declare-fun c1_2$0 () SetInt)
(declare-fun c1_3$0 () SetInt)
(declare-fun c2_2$0 () SetInt)
(declare-fun c2_3$0 () SetInt)
(declare-fun content$0 () SetInt)
(declare-fun content_1$0 () SetInt)
(declare-fun curr_2$0 () Loc)
(declare-fun curr_3$0 () Loc)
(declare-fun curr_4$0 () Loc)
(declare-fun data$0 () FldInt)
(declare-fun lst$0 () Loc)
(declare-fun lst_1$0 () Loc)
(declare-fun n_2$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun prev_2$0 () Loc)
(declare-fun prev_3$0 () Loc)
(declare-fun res_2$0 () Loc)
(declare-fun sk_?X_78$0 () SetLoc)
(declare-fun sk_?X_79$0 () SetLoc)
(declare-fun sk_?X_80$0 () SetLoc)
(declare-fun sk_?X_81$0 () SetLoc)
(declare-fun sk_?X_82$0 () SetLoc)
(declare-fun sk_?X_83$0 () SetLoc)
(declare-fun sk_?X_84$0 () SetLoc)
(declare-fun sk_?X_85$0 () SetLoc)
(declare-fun sk_?X_86$0 () SetLoc)
(declare-fun sk_?X_87$0 () SetLoc)
(declare-fun sk_?X_88$0 () SetLoc)
(declare-fun sk_?X_89$0 () SetLoc)
(declare-fun sk_?X_90$0 () SetLoc)
(declare-fun sk_?X_91$0 () SetLoc)
(declare-fun sk_?X_92$0 () SetLoc)
(declare-fun sk_?X_93$0 () SetLoc)
(declare-fun sk_?X_94$0 () SetLoc)
(declare-fun sk_?X_95$0 () SetLoc)
(declare-fun sk_?e_3$0 () Int)
(declare-fun sk_l1_3$0 () Loc)
(declare-fun sk_l2_3$0 () Loc)
(declare-fun sorted_set_c$0 (FldInt FldLoc Loc Loc) SetInt)
(declare-fun sorted_set_domain$0 (FldInt FldLoc Loc Loc) SetLoc)
(declare-fun sorted_set_struct$0 (SetLoc FldInt FldLoc Loc Loc SetInt) Bool)
(declare-fun t_514$0 () Int)
(declare-fun t_515$0 () Int)
(declare-fun t_516$0 () Int)
(declare-fun t_517$0 () Int)
(declare-fun t_518$0 () Int)
(declare-fun t_519$0 () Int)
(declare-fun t_520$0 () Int)
(declare-fun t_521$0 () Int)
(declare-fun t_522$0 () Int)
(declare-fun t_523$0 () Int)
(declare-fun t_524$0 () Int)
(declare-fun t_525$0 () Int)
(declare-fun t_526$0 () Int)
(declare-fun t_527$0 () Int)
(declare-fun t_528$0 () Int)
(declare-fun t_529$0 () Int)
(declare-fun t_530$0 () Int)
(declare-fun t_531$0 () Int)
(declare-fun t_532$0 () Int)
(declare-fun t_533$0 () Int)
(declare-fun t_534$0 () Int)
(declare-fun t_535$0 () Int)
(declare-fun t_536$0 () Int)
(declare-fun t_537$0 () Int)
(declare-fun t_538$0 () Int)
(declare-fun t_539$0 () Int)
(declare-fun t_540$0 () Int)
(declare-fun t_541$0 () Int)
(declare-fun t_542$0 () Int)
(declare-fun t_543$0 () Int)
(declare-fun t_544$0 () Int)
(declare-fun t_545$0 () Int)
(declare-fun t_546$0 () Int)
(declare-fun t_547$0 () Int)
(declare-fun t_548$0 () Int)
(declare-fun t_549$0 () Int)
(declare-fun t_550$0 () Int)
(declare-fun t_551$0 () Int)
(declare-fun t_552$0 () Int)
(declare-fun t_553$0 () Int)
(declare-fun t_554$0 () Int)
(declare-fun t_555$0 () Int)
(declare-fun t_556$0 () Int)
(declare-fun t_557$0 () Int)
(declare-fun t_558$0 () Int)
(declare-fun t_559$0 () Int)
(declare-fun t_560$0 () Int)
(declare-fun t_561$0 () Int)
(declare-fun t_562$0 () Int)
(declare-fun t_563$0 () Int)
(declare-fun t_564$0 () Int)
(declare-fun t_565$0 () Int)
(declare-fun t_566$0 () Int)
(declare-fun t_567$0 () Int)
(declare-fun t_568$0 () Loc)
(declare-fun t_569$0 () Loc)
(declare-fun t_570$0 () Loc)
(declare-fun t_571$0 () Loc)
(declare-fun t_572$0 () Loc)
(declare-fun t_573$0 () Loc)
(declare-fun t_574$0 () Loc)
(declare-fun t_575$0 () Loc)
(declare-fun t_576$0 () Loc)
(declare-fun t_577$0 () Loc)
(declare-fun t_578$0 () Loc)
(declare-fun t_579$0 () Loc)
(declare-fun t_580$0 () Loc)
(declare-fun t_581$0 () Loc)
(declare-fun t_582$0 () Loc)
(declare-fun t_583$0 () Loc)
(declare-fun t_584$0 () Loc)
(declare-fun t_585$0 () Loc)
(declare-fun t_586$0 () Loc)
(declare-fun t_587$0 () Loc)
(declare-fun t_588$0 () Loc)
(declare-fun t_589$0 () Loc)
(declare-fun t_590$0 () Loc)
(declare-fun t_591$0 () Loc)
(declare-fun t_592$0 () Loc)
(declare-fun t_593$0 () Loc)
(declare-fun t_594$0 () Loc)
(declare-fun t_595$0 () Loc)
(declare-fun t_596$0 () Loc)
(declare-fun t_597$0 () Loc)
(declare-fun t_598$0 () Loc)
(declare-fun t_599$0 () Loc)
(declare-fun t_600$0 () Loc)
(declare-fun t_601$0 () Loc)
(declare-fun t_602$0 () Loc)
(declare-fun t_603$0 () Loc)
(declare-fun t_604$0 () Loc)
(declare-fun t_605$0 () Loc)
(declare-fun t_606$0 () Loc)
(declare-fun t_607$0 () Loc)
(declare-fun t_608$0 () Loc)
(declare-fun t_609$0 () Loc)
(declare-fun t_610$0 () Loc)
(declare-fun t_611$0 () Loc)
(declare-fun t_612$0 () Loc)
(declare-fun t_613$0 () Loc)
(declare-fun t_614$0 () Loc)
(declare-fun t_615$0 () Loc)
(declare-fun t_616$0 () Loc)
(declare-fun t_617$0 () Loc)
(declare-fun t_618$0 () Loc)
(declare-fun t_619$0 () Loc)
(declare-fun t_620$0 () Loc)
(declare-fun t_621$0 () Loc)
(declare-fun t_622$0 () Loc)
(declare-fun t_623$0 () Loc)
(declare-fun t_624$0 () Loc)
(declare-fun t_625$0 () Loc)
(declare-fun t_626$0 () Loc)
(declare-fun t_627$0 () Loc)
(declare-fun t_628$0 () Loc)
(declare-fun t_629$0 () Loc)
(declare-fun t_630$0 () Loc)
(declare-fun t_631$0 () Loc)
(declare-fun t_632$0 () Loc)
(declare-fun t_633$0 () Loc)
(declare-fun t_634$0 () Loc)
(declare-fun t_635$0 () Loc)
(declare-fun t_636$0 () Loc)
(declare-fun t_637$0 () Loc)
(declare-fun t_638$0 () Loc)
(declare-fun t_639$0 () Loc)
(declare-fun t_640$0 () Loc)
(declare-fun t_641$0 () Loc)
(declare-fun t_642$0 () Loc)
(declare-fun t_643$0 () Loc)
(declare-fun t_644$0 () Loc)
(declare-fun t_645$0 () Loc)
(declare-fun t_646$0 () Loc)
(declare-fun t_647$0 () Loc)
(declare-fun t_648$0 () Loc)
(declare-fun t_649$0 () Loc)
(declare-fun t_650$0 () Loc)
(declare-fun t_651$0 () Loc)
(declare-fun t_652$0 () Loc)
(declare-fun t_653$0 () Loc)
(declare-fun t_654$0 () Loc)
(declare-fun t_655$0 () Loc)
(declare-fun t_656$0 () Loc)
(declare-fun t_657$0 () Loc)
(declare-fun t_658$0 () Loc)
(declare-fun t_659$0 () Loc)
(declare-fun t_660$0 () Loc)
(declare-fun t_661$0 () Loc)
(declare-fun t_662$0 () Loc)
(declare-fun t_663$0 () Loc)
(declare-fun t_664$0 () Loc)
(declare-fun t_665$0 () Loc)
(declare-fun t_666$0 () Loc)
(declare-fun t_667$0 () Loc)
(declare-fun t_668$0 () Loc)
(declare-fun t_669$0 () Loc)
(declare-fun t_670$0 () Loc)
(declare-fun t_671$0 () Loc)
(declare-fun t_672$0 () Loc)
(declare-fun t_673$0 () Loc)
(declare-fun t_674$0 () Loc)
(declare-fun t_675$0 () Loc)
(declare-fun t_676$0 () Loc)
(declare-fun t_677$0 () Loc)
(declare-fun t_678$0 () Loc)
(declare-fun t_679$0 () Loc)
(declare-fun t_680$0 () Loc)
(declare-fun t_681$0 () Loc)
(declare-fun t_682$0 () Loc)
(declare-fun t_683$0 () Loc)
(declare-fun val$0 () Int)
(declare-fun val_1$0 () Int)
(declare-fun witness$0 (FldInt Int SetInt) Loc)

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 res_2$0 null$0))
  t_683$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_682$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_681$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_680$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_679$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_678$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 res_2$0 null$0))
  t_677$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_676$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_675$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_674$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_673$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_672$0))

(assert (= (witness$0 data$0 sk_?e_3$0 (sorted_set_c$0 data$0 next$0 res_2$0 null$0))
  t_671$0))

(assert (=
  (witness$0 data$0 sk_?e_3$0
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_670$0))

(assert (= (witness$0 data$0 sk_?e_3$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_669$0))

(assert (= (witness$0 data$0 sk_?e_3$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_668$0))

(assert (=
  (witness$0 data$0 sk_?e_3$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_667$0))

(assert (=
  (witness$0 data$0 sk_?e_3$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_666$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
    (sorted_set_c$0 data$0 next$0 res_2$0 null$0))
  t_665$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_664$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_663$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_662$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_661$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_660$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
    (sorted_set_c$0 data$0 next$0 res_2$0 null$0))
  t_659$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_658$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_657$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_656$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_655$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_654$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 res_2$0 null$0))
  t_653$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_652$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_651$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_650$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_649$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_648$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 res_2$0 null$0))
  t_647$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_646$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_645$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_644$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_643$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_642$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 res_2$0 null$0))
  t_641$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_640$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_639$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_638$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_637$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_636$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 res_2$0 null$0))
  t_635$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_634$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_633$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_632$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_631$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_630$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))
  t_629$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_628$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_627$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_626$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_625$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_624$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))
  t_623$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_622$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_621$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_620$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_619$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_618$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 sk_?e_3$0
      (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))
  t_617$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 sk_?e_3$0
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_616$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 sk_?e_3$0
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_615$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 sk_?e_3$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_614$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 sk_?e_3$0
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_613$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 sk_?e_3$0
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_612$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
      (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))
  t_611$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_610$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_609$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_608$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_607$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_606$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
      (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))
  t_605$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_604$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_603$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_602$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_601$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_600$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))
  t_599$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_598$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_597$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_596$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_595$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_594$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))
  t_593$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_592$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_591$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_590$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_589$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_588$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))
  t_587$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_586$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_585$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_584$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_583$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_582$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))
  t_581$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_580$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_579$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_578$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_577$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_576$0))

(assert (= (ep$0 next$0 FP_1$0 sk_l2_3$0) t_575$0))

(assert (= (ep$0 next$0 FP_1$0 sk_l1_3$0) t_574$0))

(assert (= (ep$0 next$0 FP_1$0 res_2$0) t_573$0))

(assert (= (ep$0 next$0 FP_1$0 lst_1$0) t_572$0))

(assert (= (ep$0 next$0 FP_1$0 lst$0) t_571$0))

(assert (= (ep$0 next$0 FP_1$0 curr_3$0) t_570$0))

(assert (= (ep$0 next$0 FP_1$0 curr_2$0) t_569$0))

(assert (= (ep$0 next$0 FP_1$0 null$0) t_568$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))
  t_567$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_566$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_565$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_564$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_563$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_562$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))
  t_561$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_560$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_559$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_558$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_557$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_556$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_3$0
      (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))
  t_555$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_3$0
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_554$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_3$0
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_553$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_3$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_552$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_3$0
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_551$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_3$0
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_550$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
      (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))
  t_549$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_548$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_547$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_546$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_545$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_544$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
      (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))
  t_543$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_542$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_541$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_540$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_539$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_538$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))
  t_537$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_536$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_535$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_534$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_533$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_532$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))
  t_531$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_530$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_529$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_528$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_527$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_526$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))
  t_525$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_524$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_523$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_522$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_521$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_520$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))
  t_519$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_518$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_517$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_516$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_515$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_514$0))

(assert (forall ((?f FldLoc)) (= (read$0 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$1 x (setenum$1 y)))
            (and (not (= x y)) (not (in$1 x (setenum$1 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x (setminus$1 X Y)) (not (in$1 x Y)))
            (and (or (in$1 x Y) (not (in$1 x X)))
                 (not (in$1 x (setminus$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x Y) (in$1 x (intersection$1 X Y)))
            (and (or (not (in$1 x X)) (not (in$1 x Y)))
                 (not (in$1 x (intersection$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x (union$1 X Y)) (or (in$1 x X) (in$1 x Y)))
            (and (not (in$1 x X)) (not (in$1 x Y))
                 (not (in$1 x (union$1 X Y)))))))

(assert (forall ((x Loc)) (not (in$1 x emptyset$1))))

(assert (forall ((x Int) (y Int))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Int)) (not (in$0 x emptyset$0))))

(assert (or (= curr_3$0 null$0) (not (< (read$1 data$0 curr_3$0) val_1$0))))

(assert (or (not Axiom_24$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_91$0))
                (not (in$1 l2 sk_?X_91$0))))))

(assert (or (and (Btwn$0 next$0 curr_3$0 null$0 null$0) Axiom_25$0)
    (not
         (sorted_set_struct$0 sk_?X_80$0 data$0 next$0 curr_3$0 null$0
           c1_3$0))))

(assert (or (not Axiom_26$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_94$0))
                (not (in$1 l2 sk_?X_94$0))))))

(assert (or (and (Btwn$0 next$0 lst$0 curr_2$0 curr_2$0) Axiom_27$0)
    (not
         (sorted_set_struct$0 sk_?X_93$0 data$0 next$0 lst$0 curr_2$0 c2_2$0))))

(assert (or (not Axiom_28$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_3$0))
                (not (in$1 l1 sk_?X_78$0)) (not (in$1 l2 sk_?X_78$0))))))

(assert (or (and (Btwn$0 next$0 res_2$0 null$0 null$0) Axiom_29$0)
    (not
         (sorted_set_struct$0 sk_?X_95$0 data$0 next$0 res_2$0 null$0
           (setminus$0 content$0 (setenum$0 val$0))))))

(assert (= Alloc_1$0 (setminus$1 Alloc$0 (setenum$1 n_2$0))))

(assert (= FP_3$0 (setminus$1 FP_2$0 (setenum$1 n_2$0))))

(assert (= FP_Caller_final_2$0 (union$1 FP_Caller_1$0 FP_3$0)))

(assert (= c2_2$0 emptyset$0))

(assert (= curr_2$0 lst$0))

(assert (= lst_1$0 lst$0))

(assert (= prev_2$0 null$0))

(assert (= res_2$0 curr_4$0))

(assert (Frame$1 FP_1$0 Alloc$0 data$0 data$0))

(assert (= Alloc$0 (union$1 FP_2$0 Alloc$0)))

(assert (= content$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))

(assert (= sk_?X_94$0 (sorted_set_domain$0 data$0 next$0 lst$0 null$0)))

(assert (sorted_set_struct$0 sk_?X_94$0 data$0 next$0 lst$0 null$0 content$0))

(assert (= sk_?X_79$0 sk_?X_78$0))

(assert (= sk_?X_81$0 sk_?X_80$0))

(assert (= sk_?X_83$0 sk_?X_81$0))

(assert (= sk_?X_85$0 sk_?X_83$0))

(assert (= sk_?X_86$0 sk_?X_88$0))

(assert (= sk_?X_88$0 sk_?X_90$0))

(assert (= sk_?X_90$0 sk_?X_91$0))

(assert (= sk_?X_92$0 sk_?X_93$0))

(assert (= FP$0 (union$1 FP_1$0 FP$0)))

(assert (= sk_?X_95$0
  (union$1 (intersection$1 Alloc_1$0 FP$0) (setminus$1 Alloc_1$0 Alloc$0))))

(assert (not (= curr_3$0 null$0)))

(assert (not (in$1 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
            (not
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))
            (not
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 res_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
            (not
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 res_2$0 null$0))
            (not
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 res_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_3$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_3$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst$0 l1 curr_2$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))
                 (not (= l1 curr_2$0)))
            (and (or (= l1 curr_2$0) (not (Btwn$0 next$0 lst$0 l1 curr_2$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 res_2$0 l1 null$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 res_2$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 res_2$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 res_2$0 null$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 res_2$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 res_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 res_2$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 res_2$0 null$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
              (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 res_2$0 null$0))
              (sorted_set_domain$0 data$0 next$0 res_2$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 res_2$0 null$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$1 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (and (Btwn$0 next$0 curr_2$0 null$0 null$0) Axiom_24$0)
    (not
         (sorted_set_struct$0 sk_?X_91$0 data$0 next$0 curr_2$0 null$0
           c1_2$0))))

(assert (or (not Axiom_25$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_80$0))
                (not (in$1 l2 sk_?X_80$0))))))

(assert (or (and (Btwn$0 next$0 lst$0 null$0 null$0) Axiom_26$0)
    (not
         (sorted_set_struct$0 sk_?X_94$0 data$0 next$0 lst$0 null$0
           content$0))))

(assert (or (not Axiom_27$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_2$0))
                (not (in$1 l1 sk_?X_93$0)) (not (in$1 l2 sk_?X_93$0))))))

(assert (or (and (Btwn$0 next$0 lst_1$0 curr_3$0 curr_3$0) Axiom_28$0)
    (not
         (sorted_set_struct$0 sk_?X_78$0 data$0 next$0 lst_1$0 curr_3$0
           c2_3$0))))

(assert (or (not Axiom_29$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_95$0))
                (not (in$1 l2 sk_?X_95$0))))))

(assert (= (read$1 data$0 curr_3$0) val_1$0))

(assert (= FP_2$0
  (union$1 (setminus$1 FP$0 FP_1$0)
    (union$1 (intersection$1 Alloc$0 FP_1$0) (setminus$1 Alloc$0 Alloc$0)))))

(assert (= FP_Caller_1$0 (setminus$1 FP_Caller$0 FP$0)))

(assert (= c1_2$0 content$0))

(assert (= content_1$0 content$0))

(assert (= curr_4$0 (read$0 next$0 curr_3$0)))

(assert (= n_2$0 curr_3$0))

(assert (= prev_3$0 null$0))

(assert (= val_1$0 val$0))

(assert (Frame$0 FP_1$0 Alloc$0 next$0 next$0))

(assert (= Alloc$0 (union$1 FP_Caller$0 Alloc$0)))

(assert (= sk_?X_94$0 FP$0))

(assert (= FP_Caller$0 (union$1 FP$0 FP_Caller$0)))

(assert (= sk_?X_78$0 (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0)))

(assert (= sk_?X_80$0 (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0)))

(assert (= sk_?X_82$0 (union$1 sk_?X_79$0 sk_?X_81$0)))

(assert (= sk_?X_84$0 sk_?X_82$0))

(assert (or
    (and (= (read$0 next$0 prev_3$0) curr_3$0) (= emptyset$1 emptyset$1)
         (= emptyset$1 (intersection$1 sk_?X_79$0 sk_?X_81$0))
         (= c1_3$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
         (= c2_3$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
         (= content_1$0 (union$0 c1_3$0 c2_3$0))
         (= sk_?X_84$0
           (union$1 (intersection$1 Alloc$0 FP_1$0)
             (setminus$1 Alloc$0 Alloc$0)))
         (> val_1$0 (read$1 data$0 prev_3$0))
         (Btwn$0 next$0 lst_1$0 prev_3$0 curr_3$0)
         (sorted_set_struct$0 sk_?X_78$0 data$0 next$0 lst_1$0 curr_3$0
           c2_3$0)
         (sorted_set_struct$0 sk_?X_80$0 data$0 next$0 curr_3$0 null$0
           c1_3$0)
         (or (= curr_3$0 null$0) (= prev_3$0 null$0)
             (< (read$1 data$0 prev_3$0) (read$1 data$0 curr_3$0)))
         (not (= prev_3$0 curr_3$0)))
    (and (= emptyset$1 emptyset$1)
         (= c1_3$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
         (= c2_3$0 emptyset$0) (= content_1$0 (union$0 c1_3$0 c2_3$0))
         (= curr_3$0 lst_1$0) (= prev_3$0 null$0)
         (= sk_?X_85$0
           (union$1 (intersection$1 Alloc$0 FP_1$0)
             (setminus$1 Alloc$0 Alloc$0)))
         (sorted_set_struct$0 sk_?X_80$0 data$0 next$0 curr_3$0 null$0
           c1_3$0)
         (or (= curr_3$0 null$0) (= prev_3$0 null$0)
             (< (read$1 data$0 prev_3$0) (read$1 data$0 curr_3$0))))))

(assert (= sk_?X_87$0 sk_?X_89$0))

(assert (= sk_?X_89$0 (union$1 sk_?X_92$0 sk_?X_90$0)))

(assert (= sk_?X_91$0 (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0)))

(assert (= sk_?X_93$0 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0)))

(assert (or
    (and (= (read$0 next$0 prev_2$0) curr_2$0) (= emptyset$1 emptyset$1)
         (= emptyset$1 (intersection$1 sk_?X_92$0 sk_?X_90$0))
         (= c1_2$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
         (= c2_2$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
         (= content$0 (union$0 c1_2$0 c2_2$0)) (= sk_?X_87$0 FP_1$0)
         (> val$0 (read$1 data$0 prev_2$0))
         (Btwn$0 next$0 lst$0 prev_2$0 curr_2$0)
         (sorted_set_struct$0 sk_?X_91$0 data$0 next$0 curr_2$0 null$0
           c1_2$0)
         (sorted_set_struct$0 sk_?X_93$0 data$0 next$0 lst$0 curr_2$0 c2_2$0)
         (or (= curr_2$0 null$0) (= prev_2$0 null$0)
             (< (read$1 data$0 prev_2$0) (read$1 data$0 curr_2$0)))
         (not (= prev_2$0 curr_2$0)))
    (and (= emptyset$1 emptyset$1)
         (= c1_2$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
         (= c2_2$0 emptyset$0) (= content$0 (union$0 c1_2$0 c2_2$0))
         (= curr_2$0 lst$0) (= prev_2$0 null$0) (= sk_?X_86$0 FP_1$0)
         (sorted_set_struct$0 sk_?X_91$0 data$0 next$0 curr_2$0 null$0
           c1_2$0)
         (or (= curr_2$0 null$0) (= prev_2$0 null$0)
             (< (read$1 data$0 prev_2$0) (read$1 data$0 curr_2$0))))))

(assert (or
    (and (in$0 sk_?e_3$0 (setminus$0 content$0 (setenum$0 val$0)))
         (not (in$0 sk_?e_3$0 (sorted_set_c$0 data$0 next$0 res_2$0 null$0))))
    (and (in$0 sk_?e_3$0 (sorted_set_c$0 data$0 next$0 res_2$0 null$0))
         (not (in$0 sk_?e_3$0 (setminus$0 content$0 (setenum$0 val$0)))))
    (and (in$1 sk_l2_3$0 sk_?X_95$0)
         (not
              (in$1 sk_l2_3$0
                (sorted_set_domain$0 data$0 next$0 res_2$0 null$0))))
    (and (in$1 sk_l2_3$0 (sorted_set_domain$0 data$0 next$0 res_2$0 null$0))
         (not (in$1 sk_l2_3$0 sk_?X_95$0)))
    (not (Btwn$0 next$0 res_2$0 null$0 null$0))
    (and (Btwn$0 next$0 sk_l1_3$0 sk_l2_3$0 null$0)
         (in$1 sk_l1_3$0 sk_?X_95$0) (in$1 sk_l2_3$0 sk_?X_95$0)
         (not (= sk_l1_3$0 sk_l2_3$0))
         (not (< (read$1 data$0 sk_l1_3$0) (read$1 data$0 sk_l2_3$0))))))

(assert (not (in$1 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst$0 null$0))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_2$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_2$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst$0 l1 null$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 lst$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_1$0 l1 curr_3$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))
                 (not (= l1 curr_3$0)))
            (and
                 (or (= l1 curr_3$0)
                     (not (Btwn$0 next$0 lst_1$0 l1 curr_3$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 null$0))
              (sorted_set_domain$0 data$0 next$0 lst$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
              (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$1 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$1 ?y ?X))
            (in$1 (ep$0 ?f ?X ?x) ?X))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$0 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$0 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$0 ?f ?x) (read$0 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
