(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sl_sorted_set/delete.spl:59:8-19:A postcondition of procedure delete might not hold at this return point
  tests/spl/sl_sorted_set/delete.spl:27:10-52:Related location: This is the postcondition that might not hold
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldLoc Loc) Loc)
(declare-fun read$1 (FldInt Loc) Int)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetInt)
(declare-fun emptyset$1 () SetLoc)
(declare-fun setenum$0 (Int) SetInt)
(declare-fun setenum$1 (Loc) SetLoc)
(declare-fun union$0 (SetInt SetInt) SetInt)
(declare-fun union$1 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetInt SetInt) SetInt)
(declare-fun intersection$1 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetInt SetInt) SetInt)
(declare-fun setminus$1 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun Frame$0 (SetLoc SetLoc FldInt FldInt) Bool)
(declare-fun Frame$1 (SetLoc SetLoc FldLoc FldLoc) Bool)
(declare-fun in$0 (Int SetInt) Bool)
(declare-fun in$1 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Axiom_30$0 () Bool)
(declare-fun Axiom_31$0 () Bool)
(declare-fun Axiom_32$0 () Bool)
(declare-fun Axiom_33$0 () Bool)
(declare-fun Axiom_34$0 () Bool)
(declare-fun Axiom_35$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_1$0 () SetLoc)
(declare-fun FP_2$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_1$0 () SetLoc)
(declare-fun FP_Caller_final_1$0 () SetLoc)
(declare-fun c1_2$0 () SetInt)
(declare-fun c1_3$0 () SetInt)
(declare-fun c2_2$0 () SetInt)
(declare-fun c2_3$0 () SetInt)
(declare-fun content$0 () SetInt)
(declare-fun content_1$0 () SetInt)
(declare-fun curr_2$0 () Loc)
(declare-fun curr_3$0 () Loc)
(declare-fun data$0 () FldInt)
(declare-fun lst$0 () Loc)
(declare-fun lst_1$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun prev_2$0 () Loc)
(declare-fun prev_3$0 () Loc)
(declare-fun res_1$0 () Loc)
(declare-fun sk_?X_96$0 () SetLoc)
(declare-fun sk_?X_97$0 () SetLoc)
(declare-fun sk_?X_98$0 () SetLoc)
(declare-fun sk_?X_99$0 () SetLoc)
(declare-fun sk_?X_100$0 () SetLoc)
(declare-fun sk_?X_101$0 () SetLoc)
(declare-fun sk_?X_102$0 () SetLoc)
(declare-fun sk_?X_103$0 () SetLoc)
(declare-fun sk_?X_104$0 () SetLoc)
(declare-fun sk_?X_105$0 () SetLoc)
(declare-fun sk_?X_106$0 () SetLoc)
(declare-fun sk_?X_107$0 () SetLoc)
(declare-fun sk_?X_108$0 () SetLoc)
(declare-fun sk_?X_109$0 () SetLoc)
(declare-fun sk_?X_110$0 () SetLoc)
(declare-fun sk_?X_111$0 () SetLoc)
(declare-fun sk_?X_112$0 () SetLoc)
(declare-fun sk_?X_113$0 () SetLoc)
(declare-fun sk_?e_4$0 () Int)
(declare-fun sk_l1_4$0 () Loc)
(declare-fun sk_l2_4$0 () Loc)
(declare-fun sorted_set_c$0 (FldInt FldLoc Loc Loc) SetInt)
(declare-fun sorted_set_domain$0 (FldInt FldLoc Loc Loc) SetLoc)
(declare-fun sorted_set_struct$0 (SetLoc FldInt FldLoc Loc Loc SetInt) Bool)
(declare-fun t_684$0 () Int)
(declare-fun t_685$0 () Int)
(declare-fun t_686$0 () Int)
(declare-fun t_687$0 () Int)
(declare-fun t_688$0 () Int)
(declare-fun t_689$0 () Int)
(declare-fun t_690$0 () Int)
(declare-fun t_691$0 () Int)
(declare-fun t_692$0 () Int)
(declare-fun t_693$0 () Int)
(declare-fun t_694$0 () Int)
(declare-fun t_695$0 () Int)
(declare-fun t_696$0 () Int)
(declare-fun t_697$0 () Int)
(declare-fun t_698$0 () Int)
(declare-fun t_699$0 () Int)
(declare-fun t_700$0 () Int)
(declare-fun t_701$0 () Int)
(declare-fun t_702$0 () Int)
(declare-fun t_703$0 () Int)
(declare-fun t_704$0 () Int)
(declare-fun t_705$0 () Int)
(declare-fun t_706$0 () Int)
(declare-fun t_707$0 () Int)
(declare-fun t_708$0 () Int)
(declare-fun t_709$0 () Int)
(declare-fun t_710$0 () Int)
(declare-fun t_711$0 () Int)
(declare-fun t_712$0 () Int)
(declare-fun t_713$0 () Int)
(declare-fun t_714$0 () Int)
(declare-fun t_715$0 () Int)
(declare-fun t_716$0 () Int)
(declare-fun t_717$0 () Int)
(declare-fun t_718$0 () Int)
(declare-fun t_719$0 () Int)
(declare-fun t_720$0 () Int)
(declare-fun t_721$0 () Int)
(declare-fun t_722$0 () Int)
(declare-fun t_723$0 () Int)
(declare-fun t_724$0 () Int)
(declare-fun t_725$0 () Int)
(declare-fun t_726$0 () Int)
(declare-fun t_727$0 () Int)
(declare-fun t_728$0 () Int)
(declare-fun t_729$0 () Int)
(declare-fun t_730$0 () Int)
(declare-fun t_731$0 () Int)
(declare-fun t_732$0 () Int)
(declare-fun t_733$0 () Int)
(declare-fun t_734$0 () Int)
(declare-fun t_735$0 () Int)
(declare-fun t_736$0 () Int)
(declare-fun t_737$0 () Int)
(declare-fun t_738$0 () Loc)
(declare-fun t_739$0 () Loc)
(declare-fun t_740$0 () Loc)
(declare-fun t_741$0 () Loc)
(declare-fun t_742$0 () Loc)
(declare-fun t_743$0 () Loc)
(declare-fun t_744$0 () Loc)
(declare-fun t_745$0 () Loc)
(declare-fun t_746$0 () Loc)
(declare-fun t_747$0 () Loc)
(declare-fun t_748$0 () Loc)
(declare-fun t_749$0 () Loc)
(declare-fun t_750$0 () Loc)
(declare-fun t_751$0 () Loc)
(declare-fun t_752$0 () Loc)
(declare-fun t_753$0 () Loc)
(declare-fun t_754$0 () Loc)
(declare-fun t_755$0 () Loc)
(declare-fun t_756$0 () Loc)
(declare-fun t_757$0 () Loc)
(declare-fun t_758$0 () Loc)
(declare-fun t_759$0 () Loc)
(declare-fun t_760$0 () Loc)
(declare-fun t_761$0 () Loc)
(declare-fun t_762$0 () Loc)
(declare-fun t_763$0 () Loc)
(declare-fun t_764$0 () Loc)
(declare-fun t_765$0 () Loc)
(declare-fun t_766$0 () Loc)
(declare-fun t_767$0 () Loc)
(declare-fun t_768$0 () Loc)
(declare-fun t_769$0 () Loc)
(declare-fun t_770$0 () Loc)
(declare-fun t_771$0 () Loc)
(declare-fun t_772$0 () Loc)
(declare-fun t_773$0 () Loc)
(declare-fun t_774$0 () Loc)
(declare-fun t_775$0 () Loc)
(declare-fun t_776$0 () Loc)
(declare-fun t_777$0 () Loc)
(declare-fun t_778$0 () Loc)
(declare-fun t_779$0 () Loc)
(declare-fun t_780$0 () Loc)
(declare-fun t_781$0 () Loc)
(declare-fun t_782$0 () Loc)
(declare-fun t_783$0 () Loc)
(declare-fun t_784$0 () Loc)
(declare-fun t_785$0 () Loc)
(declare-fun t_786$0 () Loc)
(declare-fun t_787$0 () Loc)
(declare-fun t_788$0 () Loc)
(declare-fun t_789$0 () Loc)
(declare-fun t_790$0 () Loc)
(declare-fun t_791$0 () Loc)
(declare-fun t_792$0 () Loc)
(declare-fun t_793$0 () Loc)
(declare-fun t_794$0 () Loc)
(declare-fun t_795$0 () Loc)
(declare-fun t_796$0 () Loc)
(declare-fun t_797$0 () Loc)
(declare-fun t_798$0 () Loc)
(declare-fun t_799$0 () Loc)
(declare-fun t_800$0 () Loc)
(declare-fun t_801$0 () Loc)
(declare-fun t_802$0 () Loc)
(declare-fun t_803$0 () Loc)
(declare-fun t_804$0 () Loc)
(declare-fun t_805$0 () Loc)
(declare-fun t_806$0 () Loc)
(declare-fun t_807$0 () Loc)
(declare-fun t_808$0 () Loc)
(declare-fun t_809$0 () Loc)
(declare-fun t_810$0 () Loc)
(declare-fun t_811$0 () Loc)
(declare-fun t_812$0 () Loc)
(declare-fun t_813$0 () Loc)
(declare-fun t_814$0 () Loc)
(declare-fun t_815$0 () Loc)
(declare-fun t_816$0 () Loc)
(declare-fun t_817$0 () Loc)
(declare-fun t_818$0 () Loc)
(declare-fun t_819$0 () Loc)
(declare-fun t_820$0 () Loc)
(declare-fun t_821$0 () Loc)
(declare-fun t_822$0 () Loc)
(declare-fun t_823$0 () Loc)
(declare-fun t_824$0 () Loc)
(declare-fun t_825$0 () Loc)
(declare-fun t_826$0 () Loc)
(declare-fun t_827$0 () Loc)
(declare-fun t_828$0 () Loc)
(declare-fun t_829$0 () Loc)
(declare-fun t_830$0 () Loc)
(declare-fun t_831$0 () Loc)
(declare-fun t_832$0 () Loc)
(declare-fun t_833$0 () Loc)
(declare-fun t_834$0 () Loc)
(declare-fun t_835$0 () Loc)
(declare-fun t_836$0 () Loc)
(declare-fun t_837$0 () Loc)
(declare-fun t_838$0 () Loc)
(declare-fun t_839$0 () Loc)
(declare-fun t_840$0 () Loc)
(declare-fun t_841$0 () Loc)
(declare-fun t_842$0 () Loc)
(declare-fun t_843$0 () Loc)
(declare-fun t_844$0 () Loc)
(declare-fun t_845$0 () Loc)
(declare-fun t_846$0 () Loc)
(declare-fun t_847$0 () Loc)
(declare-fun t_848$0 () Loc)
(declare-fun t_849$0 () Loc)
(declare-fun t_850$0 () Loc)
(declare-fun t_851$0 () Loc)
(declare-fun t_852$0 () Loc)
(declare-fun t_853$0 () Loc)
(declare-fun val$0 () Int)
(declare-fun val_1$0 () Int)
(declare-fun witness$0 (FldInt Int SetInt) Loc)

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 res_1$0 null$0))
  t_853$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_852$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_851$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_850$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_849$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_848$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 res_1$0 null$0))
  t_847$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_846$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_845$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_844$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_843$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_842$0))

(assert (= (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 res_1$0 null$0))
  t_841$0))

(assert (=
  (witness$0 data$0 sk_?e_4$0
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_840$0))

(assert (= (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_839$0))

(assert (= (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_838$0))

(assert (=
  (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_837$0))

(assert (=
  (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_836$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
    (sorted_set_c$0 data$0 next$0 res_1$0 null$0))
  t_835$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_834$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_833$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_832$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_831$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_830$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
    (sorted_set_c$0 data$0 next$0 res_1$0 null$0))
  t_829$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_828$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_827$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_826$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_825$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_824$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 res_1$0 null$0))
  t_823$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_822$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_821$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_820$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_819$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_818$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 res_1$0 null$0))
  t_817$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_816$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_815$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_814$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_813$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_812$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 res_1$0 null$0))
  t_811$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_810$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_809$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_808$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_807$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_806$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 res_1$0 null$0))
  t_805$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_804$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_803$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_802$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_801$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_800$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))
  t_799$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_798$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_797$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_796$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_795$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_794$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))
  t_793$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_792$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_791$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_790$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_789$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_788$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))
  t_787$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_786$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_785$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_784$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_783$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_782$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))
  t_781$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_780$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_779$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_778$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_777$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_776$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))
  t_775$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_774$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_773$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_772$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_771$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_770$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))
  t_769$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_768$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_767$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_766$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_765$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_764$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))
  t_763$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_762$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_761$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_760$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_759$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_758$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))
  t_757$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_756$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_755$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_754$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_753$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_752$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))
  t_751$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_750$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_749$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_748$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_747$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_746$0))

(assert (= (ep$0 next$0 FP_1$0 sk_l2_4$0) t_745$0))

(assert (= (ep$0 next$0 FP_1$0 sk_l1_4$0) t_744$0))

(assert (= (ep$0 next$0 FP_1$0 res_1$0) t_743$0))

(assert (= (ep$0 next$0 FP_1$0 lst_1$0) t_742$0))

(assert (= (ep$0 next$0 FP_1$0 lst$0) t_741$0))

(assert (= (ep$0 next$0 FP_1$0 curr_3$0) t_740$0))

(assert (= (ep$0 next$0 FP_1$0 curr_2$0) t_739$0))

(assert (= (ep$0 next$0 FP_1$0 null$0) t_738$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))
  t_737$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_736$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_735$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_734$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_733$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_732$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))
  t_731$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_730$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_729$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_728$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_727$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_726$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))
  t_725$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_724$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_723$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_722$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_721$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_720$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))
  t_719$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_718$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_717$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_716$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_715$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_714$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))
  t_713$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_712$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_711$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_710$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_709$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_708$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))
  t_707$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_706$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_705$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_704$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_703$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_702$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))
  t_701$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_700$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_699$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_698$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_697$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_696$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))
  t_695$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_694$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_693$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_692$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_691$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_690$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))
  t_689$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_688$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_687$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_686$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_685$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_684$0))

(assert (forall ((?f FldLoc)) (= (read$0 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$1 x (setenum$1 y)))
            (and (not (= x y)) (not (in$1 x (setenum$1 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x (setminus$1 X Y)) (not (in$1 x Y)))
            (and (or (in$1 x Y) (not (in$1 x X)))
                 (not (in$1 x (setminus$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x Y) (in$1 x (intersection$1 X Y)))
            (and (or (not (in$1 x X)) (not (in$1 x Y)))
                 (not (in$1 x (intersection$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x (union$1 X Y)) (or (in$1 x X) (in$1 x Y)))
            (and (not (in$1 x X)) (not (in$1 x Y))
                 (not (in$1 x (union$1 X Y)))))))

(assert (forall ((x Loc)) (not (in$1 x emptyset$1))))

(assert (forall ((x Int) (y Int))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Int)) (not (in$0 x emptyset$0))))

(assert (or (= curr_3$0 null$0) (not (= (read$1 data$0 curr_3$0) val_1$0))))

(assert (or (and (Btwn$0 next$0 curr_2$0 null$0 null$0) Axiom_30$0)
    (not
         (sorted_set_struct$0 sk_?X_109$0 data$0 next$0 curr_2$0 null$0
           c1_2$0))))

(assert (or (not Axiom_31$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_98$0))
                (not (in$1 l2 sk_?X_98$0))))))

(assert (or (and (Btwn$0 next$0 lst$0 null$0 null$0) Axiom_32$0)
    (not
         (sorted_set_struct$0 sk_?X_112$0 data$0 next$0 lst$0 null$0
           content$0))))

(assert (or (not Axiom_33$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_2$0))
                (not (in$1 l1 sk_?X_111$0)) (not (in$1 l2 sk_?X_111$0))))))

(assert (or (and (Btwn$0 next$0 lst_1$0 curr_3$0 curr_3$0) Axiom_34$0)
    (not
         (sorted_set_struct$0 sk_?X_96$0 data$0 next$0 lst_1$0 curr_3$0
           c2_3$0))))

(assert (or (not Axiom_35$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0))
                (not (in$1 l1 sk_?X_113$0)) (not (in$1 l2 sk_?X_113$0))))))

(assert (= FP_2$0
  (union$1 (setminus$1 FP$0 FP_1$0)
    (union$1 (intersection$1 Alloc$0 FP_1$0) (setminus$1 Alloc$0 Alloc$0)))))

(assert (= FP_Caller_final_1$0 (union$1 FP_Caller_1$0 FP_2$0)))

(assert (= c2_2$0 emptyset$0))

(assert (= curr_2$0 lst$0))

(assert (= prev_2$0 null$0))

(assert (= val_1$0 val$0))

(assert (Frame$1 FP_1$0 Alloc$0 next$0 next$0))

(assert (= Alloc$0 (union$1 FP_Caller$0 Alloc$0)))

(assert (= sk_?X_112$0 FP$0))

(assert (= FP_Caller$0 (union$1 FP$0 FP_Caller$0)))

(assert (= sk_?X_96$0 (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0)))

(assert (= sk_?X_98$0 (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0)))

(assert (= sk_?X_100$0 (union$1 sk_?X_97$0 sk_?X_99$0)))

(assert (= sk_?X_102$0 sk_?X_100$0))

(assert (or
    (and (= (read$0 next$0 prev_3$0) curr_3$0) (= emptyset$1 emptyset$1)
         (= emptyset$1 (intersection$1 sk_?X_97$0 sk_?X_99$0))
         (= c1_3$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
         (= c2_3$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
         (= content_1$0 (union$0 c1_3$0 c2_3$0))
         (= sk_?X_102$0
           (union$1 (intersection$1 Alloc$0 FP_1$0)
             (setminus$1 Alloc$0 Alloc$0)))
         (> val_1$0 (read$1 data$0 prev_3$0))
         (Btwn$0 next$0 lst_1$0 prev_3$0 curr_3$0)
         (sorted_set_struct$0 sk_?X_96$0 data$0 next$0 lst_1$0 curr_3$0
           c2_3$0)
         (sorted_set_struct$0 sk_?X_98$0 data$0 next$0 curr_3$0 null$0
           c1_3$0)
         (or (= curr_3$0 null$0) (= prev_3$0 null$0)
             (< (read$1 data$0 prev_3$0) (read$1 data$0 curr_3$0)))
         (not (= prev_3$0 curr_3$0)))
    (and (= emptyset$1 emptyset$1)
         (= c1_3$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
         (= c2_3$0 emptyset$0) (= content_1$0 (union$0 c1_3$0 c2_3$0))
         (= curr_3$0 lst_1$0) (= prev_3$0 null$0)
         (= sk_?X_103$0
           (union$1 (intersection$1 Alloc$0 FP_1$0)
             (setminus$1 Alloc$0 Alloc$0)))
         (sorted_set_struct$0 sk_?X_98$0 data$0 next$0 curr_3$0 null$0
           c1_3$0)
         (or (= curr_3$0 null$0) (= prev_3$0 null$0)
             (< (read$1 data$0 prev_3$0) (read$1 data$0 curr_3$0))))))

(assert (= sk_?X_105$0 sk_?X_107$0))

(assert (= sk_?X_107$0 (union$1 sk_?X_110$0 sk_?X_108$0)))

(assert (= sk_?X_109$0 (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0)))

(assert (= sk_?X_111$0 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0)))

(assert (or
    (and (= (read$0 next$0 prev_2$0) curr_2$0) (= emptyset$1 emptyset$1)
         (= emptyset$1 (intersection$1 sk_?X_110$0 sk_?X_108$0))
         (= c1_2$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
         (= c2_2$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
         (= content$0 (union$0 c1_2$0 c2_2$0)) (= sk_?X_105$0 FP_1$0)
         (> val$0 (read$1 data$0 prev_2$0))
         (Btwn$0 next$0 lst$0 prev_2$0 curr_2$0)
         (sorted_set_struct$0 sk_?X_109$0 data$0 next$0 curr_2$0 null$0
           c1_2$0)
         (sorted_set_struct$0 sk_?X_111$0 data$0 next$0 lst$0 curr_2$0
           c2_2$0)
         (or (= curr_2$0 null$0) (= prev_2$0 null$0)
             (< (read$1 data$0 prev_2$0) (read$1 data$0 curr_2$0)))
         (not (= prev_2$0 curr_2$0)))
    (and (= emptyset$1 emptyset$1)
         (= c1_2$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
         (= c2_2$0 emptyset$0) (= content$0 (union$0 c1_2$0 c2_2$0))
         (= curr_2$0 lst$0) (= prev_2$0 null$0) (= sk_?X_104$0 FP_1$0)
         (sorted_set_struct$0 sk_?X_109$0 data$0 next$0 curr_2$0 null$0
           c1_2$0)
         (or (= curr_2$0 null$0) (= prev_2$0 null$0)
             (< (read$1 data$0 prev_2$0) (read$1 data$0 curr_2$0))))))

(assert (or
    (and (in$0 sk_?e_4$0 (setminus$0 content$0 (setenum$0 val$0)))
         (not (in$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 res_1$0 null$0))))
    (and (in$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 res_1$0 null$0))
         (not (in$0 sk_?e_4$0 (setminus$0 content$0 (setenum$0 val$0)))))
    (and (in$1 sk_l2_4$0 sk_?X_113$0)
         (not
              (in$1 sk_l2_4$0
                (sorted_set_domain$0 data$0 next$0 res_1$0 null$0))))
    (and (in$1 sk_l2_4$0 (sorted_set_domain$0 data$0 next$0 res_1$0 null$0))
         (not (in$1 sk_l2_4$0 sk_?X_113$0)))
    (not (Btwn$0 next$0 res_1$0 null$0 null$0))
    (and (Btwn$0 next$0 sk_l1_4$0 sk_l2_4$0 null$0)
         (in$1 sk_l1_4$0 sk_?X_113$0) (in$1 sk_l2_4$0 sk_?X_113$0)
         (not (= sk_l1_4$0 sk_l2_4$0))
         (not (< (read$1 data$0 sk_l1_4$0) (read$1 data$0 sk_l2_4$0))))))

(assert (not (in$1 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
            (not
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))
            (not
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 res_1$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
            (not
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 res_1$0 null$0))
            (not
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 res_1$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_3$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_3$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst$0 l1 curr_2$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))
                 (not (= l1 curr_2$0)))
            (and (or (= l1 curr_2$0) (not (Btwn$0 next$0 lst$0 l1 curr_2$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 res_1$0 l1 null$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 res_1$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 res_1$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 res_1$0 null$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 res_1$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 res_1$0 null$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 res_1$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 res_1$0 null$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
              (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 res_1$0 null$0))
              (sorted_set_domain$0 data$0 next$0 res_1$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 res_1$0 null$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$1 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (= curr_3$0 null$0) (not (< (read$1 data$0 curr_3$0) val_1$0))))

(assert (or (not Axiom_30$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0))
                (not (in$1 l1 sk_?X_109$0)) (not (in$1 l2 sk_?X_109$0))))))

(assert (or (and (Btwn$0 next$0 curr_3$0 null$0 null$0) Axiom_31$0)
    (not
         (sorted_set_struct$0 sk_?X_98$0 data$0 next$0 curr_3$0 null$0
           c1_3$0))))

(assert (or (not Axiom_32$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0))
                (not (in$1 l1 sk_?X_112$0)) (not (in$1 l2 sk_?X_112$0))))))

(assert (or (and (Btwn$0 next$0 lst$0 curr_2$0 curr_2$0) Axiom_33$0)
    (not
         (sorted_set_struct$0 sk_?X_111$0 data$0 next$0 lst$0 curr_2$0
           c2_2$0))))

(assert (or (not Axiom_34$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_3$0))
                (not (in$1 l1 sk_?X_96$0)) (not (in$1 l2 sk_?X_96$0))))))

(assert (or (and (Btwn$0 next$0 res_1$0 null$0 null$0) Axiom_35$0)
    (not
         (sorted_set_struct$0 sk_?X_113$0 data$0 next$0 res_1$0 null$0
           (setminus$0 content$0 (setenum$0 val$0))))))

(assert (= FP_Caller_1$0 (setminus$1 FP_Caller$0 FP$0)))

(assert (= c1_2$0 content$0))

(assert (= content_1$0 content$0))

(assert (= lst_1$0 lst$0))

(assert (= res_1$0 lst_1$0))

(assert (Frame$0 FP_1$0 Alloc$0 data$0 data$0))

(assert (= Alloc$0 (union$1 FP_2$0 Alloc$0)))

(assert (= content$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))

(assert (= sk_?X_112$0 (sorted_set_domain$0 data$0 next$0 lst$0 null$0)))

(assert (sorted_set_struct$0 sk_?X_112$0 data$0 next$0 lst$0 null$0 content$0))

(assert (= sk_?X_97$0 sk_?X_96$0))

(assert (= sk_?X_99$0 sk_?X_98$0))

(assert (= sk_?X_101$0 sk_?X_99$0))

(assert (= sk_?X_103$0 sk_?X_101$0))

(assert (= sk_?X_104$0 sk_?X_106$0))

(assert (= sk_?X_106$0 sk_?X_108$0))

(assert (= sk_?X_108$0 sk_?X_109$0))

(assert (= sk_?X_110$0 sk_?X_111$0))

(assert (= FP$0 (union$1 FP_1$0 FP$0)))

(assert (= sk_?X_113$0
  (union$1 (intersection$1 Alloc$0 FP$0) (setminus$1 Alloc$0 Alloc$0))))

(assert (not (in$1 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst$0 null$0))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_2$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_2$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst$0 l1 null$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 lst$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_1$0 l1 curr_3$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))
                 (not (= l1 curr_3$0)))
            (and
                 (or (= l1 curr_3$0)
                     (not (Btwn$0 next$0 lst_1$0 l1 curr_3$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 null$0))
              (sorted_set_domain$0 data$0 next$0 lst$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
              (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$1 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$1 ?y ?X))
            (in$1 (ep$0 ?f ?X ?x) ?X))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$0 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$0 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$0 ?f ?x) (read$0 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
