(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sls/sls_insertion_sort.spl:62:3-4:An invariant might not be maintained by a loop in procedure insertion_sort
  tests/spl/sls/sls_insertion_sort.spl:38:14:Related location: This is the loop invariant that might not be maintained
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldLoc Loc) Loc)
(declare-fun read$1 (FldInt Loc) Int)
(declare-fun write$0 (FldInt Loc Int) FldInt)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetLoc)
(declare-fun setenum$0 (Loc) SetLoc)
(declare-fun union$0 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun Frame$0 (SetLoc SetLoc FldInt FldInt) Bool)
(declare-fun Frame$1 (SetLoc SetLoc FldLoc FldLoc) Bool)
(declare-fun in$0 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Axiom_65$0 () Bool)
(declare-fun Axiom_66$0 () Bool)
(declare-fun Axiom_67$0 () Bool)
(declare-fun Axiom_68$0 () Bool)
(declare-fun Axiom_69$0 () Bool)
(declare-fun Axiom_70$0 () Bool)
(declare-fun Axiom_71$0 () Bool)
(declare-fun Axiom_72$0 () Bool)
(declare-fun Axiom_73$0 () Bool)
(declare-fun Axiom_74$0 () Bool)
(declare-fun Axiom_75$0 () Bool)
(declare-fun Axiom_76$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_3$0 () SetLoc)
(declare-fun FP_4$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_2$0 () SetLoc)
(declare-fun curr_2$0 () Loc)
(declare-fun curr_4$0 () Loc)
(declare-fun curr_5$0 () Loc)
(declare-fun curr_init$0 () Loc)
(declare-fun data$0 () FldInt)
(declare-fun data_2$0 () FldInt)
(declare-fun data_3$0 () FldInt)
(declare-fun lseg_domain$0 (FldLoc Loc Loc) SetLoc)
(declare-fun lseg_struct$0 (SetLoc FldLoc Loc Loc) Bool)
(declare-fun lslseg_domain$0 (FldInt FldLoc Loc Loc Int) SetLoc)
(declare-fun lslseg_struct$0 (SetLoc FldInt FldLoc Loc Loc Int) Bool)
(declare-fun lst_2$0 () Loc)
(declare-fun lst_init$0 () Loc)
(declare-fun min_2$0 () Loc)
(declare-fun min_4$0 () Loc)
(declare-fun min_5$0 () Loc)
(declare-fun min_init$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun prv_4$0 () Loc)
(declare-fun prv_5$0 () Loc)
(declare-fun prv_6$0 () Loc)
(declare-fun prv_init$0 () Loc)
(declare-fun sk_?X_225$0 () SetLoc)
(declare-fun sk_?X_226$0 () SetLoc)
(declare-fun sk_?X_227$0 () SetLoc)
(declare-fun sk_?X_228$0 () SetLoc)
(declare-fun sk_?X_229$0 () SetLoc)
(declare-fun sk_?X_230$0 () SetLoc)
(declare-fun sk_?X_231$0 () SetLoc)
(declare-fun sk_?X_232$0 () SetLoc)
(declare-fun sk_?X_233$0 () SetLoc)
(declare-fun sk_?X_234$0 () SetLoc)
(declare-fun sk_?X_235$0 () SetLoc)
(declare-fun sk_?X_236$0 () SetLoc)
(declare-fun sk_?X_237$0 () SetLoc)
(declare-fun sk_?X_238$0 () SetLoc)
(declare-fun sk_?X_239$0 () SetLoc)
(declare-fun sk_?X_240$0 () SetLoc)
(declare-fun sk_?X_241$0 () SetLoc)
(declare-fun sk_?X_242$0 () SetLoc)
(declare-fun sk_?X_243$0 () SetLoc)
(declare-fun sk_?X_244$0 () SetLoc)
(declare-fun sk_?X_245$0 () SetLoc)
(declare-fun sk_?X_246$0 () SetLoc)
(declare-fun sk_?X_247$0 () SetLoc)
(declare-fun sk_?X_248$0 () SetLoc)
(declare-fun sk_?X_249$0 () SetLoc)
(declare-fun sk_?X_250$0 () SetLoc)
(declare-fun sk_?X_251$0 () SetLoc)
(declare-fun sk_?X_252$0 () SetLoc)
(declare-fun sk_?X_253$0 () SetLoc)
(declare-fun sk_?X_254$0 () SetLoc)
(declare-fun sk_?X_255$0 () SetLoc)
(declare-fun sk_?X_256$0 () SetLoc)
(declare-fun sk_?X_257$0 () SetLoc)
(declare-fun sk_?X_258$0 () SetLoc)
(declare-fun sk_?X_259$0 () SetLoc)
(declare-fun sk_?X_260$0 () SetLoc)
(declare-fun sk_?X_261$0 () SetLoc)
(declare-fun sk_?X_262$0 () SetLoc)
(declare-fun sk_?X_263$0 () SetLoc)
(declare-fun sk_?X_264$0 () SetLoc)
(declare-fun sk_?X_265$0 () SetLoc)
(declare-fun sk_?X_266$0 () SetLoc)
(declare-fun sk_?e_1$0 () Loc)
(declare-fun sk_FP_4$0 () SetLoc)
(declare-fun sk_FP_5$0 () SetLoc)
(declare-fun sk_l1_4$0 () Loc)
(declare-fun sk_l2_2$0 () Loc)
(declare-fun srt_4$0 () Loc)
(declare-fun srt_5$0 () Loc)
(declare-fun srt_6$0 () Loc)
(declare-fun srt_init$0 () Loc)
(declare-fun t_70$0 () Int)
(declare-fun t_71$0 () Int)
(declare-fun t_72$0 () Int)
(declare-fun t_73$0 () Int)
(declare-fun t_74$0 () Int)
(declare-fun t_75$0 () Int)
(declare-fun t_76$0 () Int)
(declare-fun t_77$0 () Int)
(declare-fun t_78$0 () Int)
(declare-fun t_79$0 () Int)
(declare-fun t_80$0 () Int)
(declare-fun t_81$0 () Int)
(declare-fun t_82$0 () Int)
(declare-fun t_83$0 () Int)
(declare-fun t_84$0 () Int)
(declare-fun t_85$0 () Int)
(declare-fun t_86$0 () Int)
(declare-fun t_87$0 () Int)
(declare-fun t_88$0 () Int)
(declare-fun t_89$0 () Int)
(declare-fun t_90$0 () Loc)
(declare-fun t_91$0 () Loc)
(declare-fun t_92$0 () Loc)
(declare-fun t_93$0 () Loc)
(declare-fun t_94$0 () Loc)
(declare-fun t_95$0 () Loc)
(declare-fun t_96$0 () Loc)
(declare-fun t_97$0 () Loc)
(declare-fun t_98$0 () Loc)
(declare-fun t_99$0 () Loc)
(declare-fun t_100$0 () Loc)
(declare-fun t_101$0 () Loc)
(declare-fun t_102$0 () Loc)
(declare-fun t_103$0 () Loc)
(declare-fun tmp_2$0 () Int)
(declare-fun tmp_4$0 () Int)
(declare-fun tmp_init$0 () Int)
(declare-fun ulseg_domain$0 (FldInt FldLoc Loc Loc Int) SetLoc)
(declare-fun ulseg_struct$0 (SetLoc FldInt FldLoc Loc Loc Int) Bool)

(assert (= (ep$0 next$0 FP_3$0 srt_init$0) t_103$0))

(assert (= (ep$0 next$0 FP_3$0 srt_6$0) t_102$0))

(assert (= (ep$0 next$0 FP_3$0 srt_5$0) t_101$0))

(assert (= (ep$0 next$0 FP_3$0 srt_4$0) t_100$0))

(assert (= (ep$0 next$0 FP_3$0 sk_l2_2$0) t_99$0))

(assert (= (ep$0 next$0 FP_3$0 sk_l1_4$0) t_98$0))

(assert (= (ep$0 next$0 FP_3$0 sk_?e_1$0) t_97$0))

(assert (= (ep$0 next$0 FP_3$0 min_5$0) t_96$0))

(assert (= (ep$0 next$0 FP_3$0 min_4$0) t_95$0))

(assert (= (ep$0 next$0 FP_3$0 lst_init$0) t_94$0))

(assert (= (ep$0 next$0 FP_3$0 lst_2$0) t_93$0))

(assert (= (ep$0 next$0 FP_3$0 curr_5$0) t_92$0))

(assert (= (ep$0 next$0 FP_3$0 curr_4$0) t_91$0))

(assert (= (ep$0 next$0 FP_3$0 null$0) t_90$0))

(assert (= (read$1 data_2$0 srt_5$0) t_89$0))

(assert (= (read$1 data_2$0 sk_l2_2$0) t_88$0))

(assert (= (read$1 data_2$0 sk_l1_4$0) t_87$0))

(assert (= (read$1 data_2$0 prv_6$0) t_86$0))

(assert (= (read$1 data$0 sk_l2_2$0) t_85$0))

(assert (= (read$1 data$0 sk_l1_4$0) t_84$0))

(assert (= (read$1 data$0 prv_6$0) t_83$0))

(assert (= (read$1 (write$0 data_2$0 srt_5$0 tmp_4$0) srt_5$0) t_82$0))

(assert (= (read$1 (write$0 data_2$0 srt_5$0 tmp_4$0) sk_l2_2$0) t_81$0))

(assert (= (read$1 (write$0 data_2$0 srt_5$0 tmp_4$0) sk_l1_4$0) t_80$0))

(assert (= (read$1 (write$0 data_2$0 srt_5$0 tmp_4$0) prv_6$0) t_79$0))

(assert (= (read$1 (write$0 data$0 min_5$0 (read$1 data$0 srt_5$0)) srt_5$0) t_78$0))

(assert (= (read$1 (write$0 data$0 min_5$0 (read$1 data$0 srt_5$0)) sk_l2_2$0)
  t_77$0))

(assert (= (read$1 (write$0 data$0 min_5$0 (read$1 data$0 srt_5$0)) sk_l1_4$0)
  t_76$0))

(assert (= (read$1 (write$0 data$0 min_5$0 (read$1 data$0 srt_5$0)) prv_init$0)
  t_75$0))

(assert (= (read$1 (write$0 data$0 min_5$0 (read$1 data$0 srt_5$0)) prv_6$0) t_74$0))

(assert (= (read$1 (write$0 data$0 min_5$0 (read$1 data$0 srt_5$0)) prv_5$0) t_73$0))

(assert (= (read$1 (write$0 data$0 min_5$0 (read$1 data$0 srt_5$0)) prv_4$0) t_72$0))

(assert (= (read$1 (write$0 data$0 min_5$0 (read$1 data$0 srt_5$0)) min_5$0) t_71$0))

(assert (= (read$1 (write$0 data$0 min_5$0 (read$1 data$0 srt_5$0)) min_4$0) t_70$0))

(assert (forall ((?d_24 Int) (?x Loc) (?y Loc))
        (or (= ?y ?x)
            (= (read$1 data_2$0 ?y) (read$1 (write$0 data_2$0 ?x ?d_24) ?y)))))

(assert (forall ((?d_24 Int) (?x Loc))
        (= (read$1 (write$0 data_2$0 ?x ?d_24) ?x) ?d_24)))

(assert (forall ((?d_23 Int) (?x Loc) (?y Loc))
        (or (= ?y ?x)
            (= (read$1 data$0 ?y) (read$1 (write$0 data$0 ?x ?d_23) ?y)))))

(assert (forall ((?d_23 Int) (?x Loc))
        (= (read$1 (write$0 data$0 ?x ?d_23) ?x) ?d_23)))

(assert (forall ((?f FldLoc)) (= (read$0 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Loc)) (not (in$0 x emptyset$0))))

(assert (or (Btwn$0 next$0 curr_5$0 null$0 null$0)
    (not (lseg_struct$0 sk_?X_225$0 next$0 curr_5$0 null$0))))

(assert (or (Btwn$0 next$0 lst_init$0 null$0 null$0)
    (not (lseg_struct$0 sk_?X_256$0 next$0 lst_init$0 null$0))))

(assert (or (not Axiom_65$0)
    (forall ((l1 Loc))
            (or (<= (read$1 data$0 prv_4$0) (read$1 data$0 l1))
                (not (in$0 l1 sk_?X_246$0))))))

(assert (or (and (Btwn$0 next$0 curr_5$0 null$0 null$0) Axiom_66$0)
    (not
         (ulseg_struct$0 sk_?X_227$0 data$0 next$0 curr_5$0 null$0
           (read$1 data$0 prv_5$0)))))

(assert (or (not Axiom_67$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$1 data_3$0 l1) (read$1 data_3$0 l2))
                (not (Btwn$0 next$0 l1 l2 prv_6$0))
                (not (in$0 l1 sk_?X_263$0)) (not (in$0 l2 sk_?X_263$0))))))

(assert (or (not Axiom_68$0)
    (forall ((l1 Loc))
            (or (<= (read$1 data_3$0 l1) (read$1 data_3$0 prv_6$0))
                (not (in$0 l1 sk_?X_263$0))))))

(assert (or
    (and (Btwn$0 next$0 lst_init$0 prv_init$0 prv_init$0) Axiom_70$0
         Axiom_69$0)
    (not
         (lslseg_struct$0 sk_?X_254$0 data$0 next$0 lst_init$0 prv_init$0
           (read$1 data$0 prv_init$0)))))

(assert (or (not Axiom_71$0)
    (forall ((l1 Loc))
            (or (<= (read$1 data$0 min_4$0) (read$1 data$0 l1))
                (not (in$0 l1 sk_?X_241$0))))))

(assert (or (and (Btwn$0 next$0 min_5$0 curr_5$0 curr_5$0) Axiom_72$0)
    (not
         (ulseg_struct$0 sk_?X_232$0 data$0 next$0 min_5$0 curr_5$0
           (read$1 data$0 min_5$0)))))

(assert (or (not Axiom_73$0)
    (forall ((l1 Loc))
            (or (<= (read$1 data$0 min_4$0) (read$1 data$0 l1))
                (not (in$0 l1 sk_?X_244$0))))))

(assert (or (and (Btwn$0 next$0 srt_5$0 min_5$0 min_5$0) Axiom_74$0)
    (not
         (ulseg_struct$0 sk_?X_229$0 data$0 next$0 srt_5$0 min_5$0
           (read$1 data$0 min_5$0)))))

(assert (or (not Axiom_75$0)
    (forall ((l1 Loc))
            (or (<= (read$1 data_3$0 prv_6$0) (read$1 data_3$0 l1))
                (not (in$0 l1 sk_?X_259$0))))))

(assert (or (and (Btwn$0 next$0 srt_init$0 null$0 null$0) Axiom_76$0)
    (not
         (ulseg_struct$0 sk_?X_250$0 data$0 next$0 srt_init$0 null$0
           (read$1 data$0 prv_init$0)))))

(assert (= FP_Caller_2$0 (setminus$0 FP_Caller$0 FP$0)))

(assert (= curr_4$0 (read$0 next$0 srt_4$0)))

(assert (= data_2$0 (write$0 data$0 min_5$0 (read$1 data$0 srt_5$0))))

(assert (= lst_2$0 lst_init$0))

(assert (= min_4$0 srt_4$0))

(assert (= prv_5$0 prv_4$0))

(assert (= srt_4$0 srt_init$0))

(assert (= srt_6$0 (read$0 next$0 srt_5$0)))

(assert (= tmp_4$0 (read$1 data$0 min_5$0)))

(assert (Frame$1 FP_3$0 Alloc$0 next$0 next$0))

(assert (= Alloc$0 (union$0 FP_Caller$0 Alloc$0)))

(assert (= sk_?X_226$0 sk_?X_225$0))

(assert (= sk_?X_228$0 sk_?X_227$0))

(assert (= sk_?X_230$0 (union$0 sk_?X_228$0 sk_?X_229$0)))

(assert (= sk_?X_232$0
  (ulseg_domain$0 data$0 next$0 min_5$0 curr_5$0 (read$1 data$0 min_5$0))))

(assert (= sk_?X_234$0 (union$0 sk_?X_231$0 sk_?X_232$0)))

(assert (= sk_?X_236$0 sk_?X_234$0))

(assert (= sk_?X_237$0 sk_?X_239$0))

(assert (= sk_?X_239$0 (union$0 sk_?X_242$0 sk_?X_241$0)))

(assert (= sk_?X_241$0
  (ulseg_domain$0 data$0 next$0 min_4$0 curr_4$0 (read$1 data$0 min_4$0))))

(assert (= sk_?X_243$0 (union$0 sk_?X_245$0 sk_?X_244$0)))

(assert (= sk_?X_245$0 sk_?X_246$0))

(assert (= sk_?X_247$0 sk_?X_248$0))

(assert (= FP$0 (union$0 FP_3$0 FP$0)))

(assert (= sk_?X_249$0 (union$0 sk_?X_251$0 sk_?X_250$0)))

(assert (= sk_?X_251$0 (union$0 sk_?X_254$0 sk_?X_252$0)))

(assert (= sk_?X_253$0 (setenum$0 prv_init$0)))

(assert (= sk_?X_255$0 (union$0 sk_?X_257$0 sk_?X_256$0)))

(assert (= sk_?X_257$0 emptyset$0))

(assert (or
    (and (= (read$0 next$0 prv_init$0) srt_init$0) (= emptyset$0 emptyset$0)
         (= emptyset$0 (intersection$0 sk_?X_251$0 sk_?X_250$0))
         (= emptyset$0 (intersection$0 sk_?X_254$0 sk_?X_252$0))
         (= sk_?X_249$0 FP$0)
         (lslseg_struct$0 sk_?X_254$0 data$0 next$0 lst_init$0 prv_init$0
           (read$1 data$0 prv_init$0))
         (ulseg_struct$0 sk_?X_250$0 data$0 next$0 srt_init$0 null$0
           (read$1 data$0 prv_init$0)))
    (and (= emptyset$0 emptyset$0)
         (= emptyset$0 (intersection$0 sk_?X_257$0 sk_?X_256$0))
         (= prv_init$0 null$0) (= sk_?X_255$0 FP$0) (= srt_init$0 lst_init$0)
         (lseg_struct$0 sk_?X_256$0 next$0 lst_init$0 null$0))))

(assert (= sk_?X_259$0
  (ulseg_domain$0 data_3$0 next$0 srt_6$0 null$0 (read$1 data_3$0 prv_6$0))))

(assert (= sk_?X_261$0 sk_?X_262$0))

(assert (= sk_?X_263$0
  (lslseg_domain$0 data_3$0 next$0 lst_2$0 prv_6$0 (read$1 data_3$0 prv_6$0))))

(assert (= sk_?X_265$0 (lseg_domain$0 next$0 lst_2$0 null$0)))

(assert (= sk_FP_4$0 sk_?X_264$0))

(assert (or (in$0 sk_l1_4$0 (intersection$0 sk_?X_263$0 sk_?X_261$0))
    (in$0 sk_l2_2$0 (intersection$0 sk_?X_260$0 sk_?X_259$0))
    (and (in$0 sk_l1_4$0 sk_?X_259$0)
         (not (<= (read$1 data_3$0 prv_6$0) (read$1 data_3$0 sk_l1_4$0))))
    (and (in$0 sk_l2_2$0 sk_?X_263$0)
         (not (<= (read$1 data_3$0 sk_l2_2$0) (read$1 data_3$0 prv_6$0))))
    (and (in$0 sk_l2_2$0 sk_FP_5$0) (not (in$0 sk_l2_2$0 FP_4$0)))
    (not (= (read$0 next$0 prv_6$0) srt_6$0))
    (not (Btwn$0 next$0 lst_2$0 prv_6$0 prv_6$0))
    (not (Btwn$0 next$0 srt_6$0 null$0 null$0))
    (and (Btwn$0 next$0 sk_l1_4$0 sk_l2_2$0 prv_6$0)
         (in$0 sk_l1_4$0 sk_?X_263$0) (in$0 sk_l2_2$0 sk_?X_263$0)
         (not (<= (read$1 data_3$0 sk_l1_4$0) (read$1 data_3$0 sk_l2_2$0))))))

(assert (not (= srt_4$0 null$0)))

(assert (not (in$0 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_4$0 l1 null$0)
                 (in$0 l1
                   (ulseg_domain$0 data$0 next$0 curr_4$0 null$0
                     (read$1 data$0 prv_4$0)))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_4$0 l1 null$0)))
                 (not
                      (in$0 l1
                        (ulseg_domain$0 data$0 next$0 curr_4$0 null$0
                          (read$1 data$0 prv_4$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_5$0 l1 null$0)
                 (in$0 l1
                   (ulseg_domain$0 data$0 next$0 curr_5$0 null$0
                     (read$1 data$0 prv_5$0)))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_5$0 l1 null$0)))
                 (not
                      (in$0 l1
                        (ulseg_domain$0 data$0 next$0 curr_5$0 null$0
                          (read$1 data$0 prv_5$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_2$0 l1 prv_6$0)
                 (in$0 l1
                   (lslseg_domain$0 data_3$0 next$0 lst_2$0 prv_6$0
                     (read$1 data_3$0 prv_6$0)))
                 (not (= l1 prv_6$0)))
            (and (or (= l1 prv_6$0) (not (Btwn$0 next$0 lst_2$0 l1 prv_6$0)))
                 (not
                      (in$0 l1
                        (lslseg_domain$0 data_3$0 next$0 lst_2$0 prv_6$0
                          (read$1 data_3$0 prv_6$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_init$0 l1 prv_init$0)
                 (in$0 l1
                   (lslseg_domain$0 data$0 next$0 lst_init$0 prv_init$0
                     (read$1 data$0 prv_init$0)))
                 (not (= l1 prv_init$0)))
            (and
                 (or (= l1 prv_init$0)
                     (not (Btwn$0 next$0 lst_init$0 l1 prv_init$0)))
                 (not
                      (in$0 l1
                        (lslseg_domain$0 data$0 next$0 lst_init$0 prv_init$0
                          (read$1 data$0 prv_init$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 min_5$0 l1 curr_5$0)
                 (in$0 l1
                   (ulseg_domain$0 data$0 next$0 min_5$0 curr_5$0
                     (read$1 data$0 min_5$0)))
                 (not (= l1 curr_5$0)))
            (and
                 (or (= l1 curr_5$0)
                     (not (Btwn$0 next$0 min_5$0 l1 curr_5$0)))
                 (not
                      (in$0 l1
                        (ulseg_domain$0 data$0 next$0 min_5$0 curr_5$0
                          (read$1 data$0 min_5$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 srt_5$0 l1 min_5$0)
                 (in$0 l1
                   (ulseg_domain$0 data$0 next$0 srt_5$0 min_5$0
                     (read$1 data$0 min_5$0)))
                 (not (= l1 min_5$0)))
            (and (or (= l1 min_5$0) (not (Btwn$0 next$0 srt_5$0 l1 min_5$0)))
                 (not
                      (in$0 l1
                        (ulseg_domain$0 data$0 next$0 srt_5$0 min_5$0
                          (read$1 data$0 min_5$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 srt_init$0 l1 null$0)
                 (in$0 l1
                   (ulseg_domain$0 data$0 next$0 srt_init$0 null$0
                     (read$1 data$0 prv_init$0)))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next$0 srt_init$0 l1 null$0)))
                 (not
                      (in$0 l1
                        (ulseg_domain$0 data$0 next$0 srt_init$0 null$0
                          (read$1 data$0 prv_init$0))))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$0 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (Btwn$0 next$0 curr_4$0 null$0 null$0)
    (not (lseg_struct$0 sk_?X_248$0 next$0 curr_4$0 null$0))))

(assert (or (Btwn$0 next$0 lst_2$0 null$0 null$0)
    (not (lseg_struct$0 sk_?X_265$0 next$0 lst_2$0 null$0))))

(assert (or (and (Btwn$0 next$0 curr_4$0 null$0 null$0) Axiom_65$0)
    (not
         (ulseg_struct$0 sk_?X_246$0 data$0 next$0 curr_4$0 null$0
           (read$1 data$0 prv_4$0)))))

(assert (or (not Axiom_66$0)
    (forall ((l1 Loc))
            (or (<= (read$1 data$0 prv_5$0) (read$1 data$0 l1))
                (not (in$0 l1 sk_?X_227$0))))))

(assert (or (and (Btwn$0 next$0 lst_2$0 prv_6$0 prv_6$0) Axiom_68$0 Axiom_67$0)
    (not
         (lslseg_struct$0 sk_?X_263$0 data_3$0 next$0 lst_2$0 prv_6$0
           (read$1 data_3$0 prv_6$0)))))

(assert (or (not Axiom_69$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 prv_init$0))
                (not (in$0 l1 sk_?X_254$0)) (not (in$0 l2 sk_?X_254$0))))))

(assert (or (not Axiom_70$0)
    (forall ((l1 Loc))
            (or (<= (read$1 data$0 l1) (read$1 data$0 prv_init$0))
                (not (in$0 l1 sk_?X_254$0))))))

(assert (or (and (Btwn$0 next$0 min_4$0 curr_4$0 curr_4$0) Axiom_71$0)
    (not
         (ulseg_struct$0 sk_?X_241$0 data$0 next$0 min_4$0 curr_4$0
           (read$1 data$0 min_4$0)))))

(assert (or (not Axiom_72$0)
    (forall ((l1 Loc))
            (or (<= (read$1 data$0 min_5$0) (read$1 data$0 l1))
                (not (in$0 l1 sk_?X_232$0))))))

(assert (or (and (Btwn$0 next$0 srt_4$0 min_4$0 min_4$0) Axiom_73$0)
    (not
         (ulseg_struct$0 sk_?X_244$0 data$0 next$0 srt_4$0 min_4$0
           (read$1 data$0 min_4$0)))))

(assert (or (not Axiom_74$0)
    (forall ((l1 Loc))
            (or (<= (read$1 data$0 min_5$0) (read$1 data$0 l1))
                (not (in$0 l1 sk_?X_229$0))))))

(assert (or (and (Btwn$0 next$0 srt_6$0 null$0 null$0) Axiom_75$0)
    (not
         (ulseg_struct$0 sk_?X_259$0 data_3$0 next$0 srt_6$0 null$0
           (read$1 data_3$0 prv_6$0)))))

(assert (or (not Axiom_76$0)
    (forall ((l1 Loc))
            (or (<= (read$1 data$0 prv_init$0) (read$1 data$0 l1))
                (not (in$0 l1 sk_?X_250$0))))))

(assert (= FP_4$0
  (union$0 (setminus$0 FP$0 FP_3$0)
    (union$0 (intersection$0 Alloc$0 FP_3$0) (setminus$0 Alloc$0 Alloc$0)))))

(assert (= curr_2$0 curr_init$0))

(assert (= curr_5$0 null$0))

(assert (= data_3$0 (write$0 data_2$0 srt_5$0 tmp_4$0)))

(assert (= min_2$0 min_init$0))

(assert (= prv_4$0 prv_init$0))

(assert (= prv_6$0 srt_5$0))

(assert (= srt_5$0 srt_4$0))

(assert (= tmp_2$0 tmp_init$0))

(assert (Frame$0 FP_3$0 Alloc$0 data$0 data$0))

(assert (= Alloc$0 (union$0 FP_4$0 Alloc$0)))

(assert (= sk_?X_225$0 (lseg_domain$0 next$0 curr_5$0 null$0)))

(assert (= sk_?X_227$0
  (ulseg_domain$0 data$0 next$0 curr_5$0 null$0 (read$1 data$0 prv_5$0))))

(assert (= sk_?X_229$0
  (ulseg_domain$0 data$0 next$0 srt_5$0 min_5$0 (read$1 data$0 min_5$0))))

(assert (= sk_?X_231$0 (union$0 sk_?X_226$0 sk_?X_229$0)))

(assert (= sk_?X_233$0 (union$0 sk_?X_230$0 sk_?X_232$0)))

(assert (= sk_?X_235$0 sk_?X_233$0))

(assert (or
    (and (= emptyset$0 emptyset$0)
         (= emptyset$0 (intersection$0 sk_?X_226$0 sk_?X_229$0))
         (= emptyset$0 (intersection$0 sk_?X_231$0 sk_?X_232$0))
         (= prv_5$0 null$0)
         (= sk_?X_236$0
           (union$0 (intersection$0 Alloc$0 FP_3$0)
             (setminus$0 Alloc$0 Alloc$0)))
         (lseg_struct$0 sk_?X_225$0 next$0 curr_5$0 null$0)
         (ulseg_struct$0 sk_?X_229$0 data$0 next$0 srt_5$0 min_5$0
           (read$1 data$0 min_5$0))
         (ulseg_struct$0 sk_?X_232$0 data$0 next$0 min_5$0 curr_5$0
           (read$1 data$0 min_5$0))
         (not (= min_5$0 null$0)))
    (and (= emptyset$0 emptyset$0)
         (= emptyset$0 (intersection$0 sk_?X_228$0 sk_?X_229$0))
         (= emptyset$0 (intersection$0 sk_?X_230$0 sk_?X_232$0))
         (= sk_?X_235$0
           (union$0 (intersection$0 Alloc$0 FP_3$0)
             (setminus$0 Alloc$0 Alloc$0)))
         (<= (read$1 data$0 prv_5$0) (read$1 data$0 min_5$0))
         (ulseg_struct$0 sk_?X_227$0 data$0 next$0 curr_5$0 null$0
           (read$1 data$0 prv_5$0))
         (ulseg_struct$0 sk_?X_229$0 data$0 next$0 srt_5$0 min_5$0
           (read$1 data$0 min_5$0))
         (ulseg_struct$0 sk_?X_232$0 data$0 next$0 min_5$0 curr_5$0
           (read$1 data$0 min_5$0))
         (not (= min_5$0 null$0)))))

(assert (= sk_?X_238$0 sk_?X_240$0))

(assert (= sk_?X_240$0 (union$0 sk_?X_243$0 sk_?X_241$0)))

(assert (= sk_?X_242$0 (union$0 sk_?X_247$0 sk_?X_244$0)))

(assert (= sk_?X_244$0
  (ulseg_domain$0 data$0 next$0 srt_4$0 min_4$0 (read$1 data$0 min_4$0))))

(assert (= sk_?X_246$0
  (ulseg_domain$0 data$0 next$0 curr_4$0 null$0 (read$1 data$0 prv_4$0))))

(assert (= sk_?X_248$0 (lseg_domain$0 next$0 curr_4$0 null$0)))

(assert (or
    (and (= emptyset$0 emptyset$0)
         (= emptyset$0 (intersection$0 sk_?X_242$0 sk_?X_241$0))
         (= emptyset$0 (intersection$0 sk_?X_247$0 sk_?X_244$0))
         (= prv_4$0 null$0) (= sk_?X_237$0 FP_3$0)
         (lseg_struct$0 sk_?X_248$0 next$0 curr_4$0 null$0)
         (ulseg_struct$0 sk_?X_241$0 data$0 next$0 min_4$0 curr_4$0
           (read$1 data$0 min_4$0))
         (ulseg_struct$0 sk_?X_244$0 data$0 next$0 srt_4$0 min_4$0
           (read$1 data$0 min_4$0))
         (not (= min_4$0 null$0)))
    (and (= emptyset$0 emptyset$0)
         (= emptyset$0 (intersection$0 sk_?X_243$0 sk_?X_241$0))
         (= emptyset$0 (intersection$0 sk_?X_245$0 sk_?X_244$0))
         (= sk_?X_238$0 FP_3$0)
         (<= (read$1 data$0 prv_4$0) (read$1 data$0 min_4$0))
         (ulseg_struct$0 sk_?X_241$0 data$0 next$0 min_4$0 curr_4$0
           (read$1 data$0 min_4$0))
         (ulseg_struct$0 sk_?X_244$0 data$0 next$0 srt_4$0 min_4$0
           (read$1 data$0 min_4$0))
         (ulseg_struct$0 sk_?X_246$0 data$0 next$0 curr_4$0 null$0
           (read$1 data$0 prv_4$0))
         (not (= min_4$0 null$0)))))

(assert (= sk_?X_250$0
  (ulseg_domain$0 data$0 next$0 srt_init$0 null$0 (read$1 data$0 prv_init$0))))

(assert (= sk_?X_252$0 sk_?X_253$0))

(assert (= sk_?X_254$0
  (lslseg_domain$0 data$0 next$0 lst_init$0 prv_init$0
    (read$1 data$0 prv_init$0))))

(assert (= sk_?X_256$0 (lseg_domain$0 next$0 lst_init$0 null$0)))

(assert (= FP_Caller$0 (union$0 FP$0 FP_Caller$0)))

(assert (= sk_?X_258$0 (union$0 sk_?X_260$0 sk_?X_259$0)))

(assert (= sk_?X_260$0 (union$0 sk_?X_263$0 sk_?X_261$0)))

(assert (= sk_?X_262$0 (setenum$0 prv_6$0)))

(assert (= sk_?X_264$0 (union$0 sk_?X_266$0 sk_?X_265$0)))

(assert (= sk_?X_266$0 emptyset$0))

(assert (= sk_FP_5$0 sk_?X_258$0))

(assert (or (in$0 sk_?e_1$0 (intersection$0 sk_?X_266$0 sk_?X_265$0))
    (and (in$0 sk_?e_1$0 sk_FP_4$0) (not (in$0 sk_?e_1$0 FP_4$0)))
    (not (= prv_6$0 null$0)) (not (= srt_6$0 lst_2$0))
    (not (Btwn$0 next$0 lst_2$0 null$0 null$0))))

(assert (not (in$0 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_4$0 l1 null$0)
                 (in$0 l1 (lseg_domain$0 next$0 curr_4$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_4$0 l1 null$0)))
                 (not (in$0 l1 (lseg_domain$0 next$0 curr_4$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_5$0 l1 null$0)
                 (in$0 l1 (lseg_domain$0 next$0 curr_5$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_5$0 l1 null$0)))
                 (not (in$0 l1 (lseg_domain$0 next$0 curr_5$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_2$0 l1 null$0)
                 (in$0 l1 (lseg_domain$0 next$0 lst_2$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 lst_2$0 l1 null$0)))
                 (not (in$0 l1 (lseg_domain$0 next$0 lst_2$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_init$0 l1 null$0)
                 (in$0 l1 (lseg_domain$0 next$0 lst_init$0 null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next$0 lst_init$0 l1 null$0)))
                 (not (in$0 l1 (lseg_domain$0 next$0 lst_init$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 min_4$0 l1 curr_4$0)
                 (in$0 l1
                   (ulseg_domain$0 data$0 next$0 min_4$0 curr_4$0
                     (read$1 data$0 min_4$0)))
                 (not (= l1 curr_4$0)))
            (and
                 (or (= l1 curr_4$0)
                     (not (Btwn$0 next$0 min_4$0 l1 curr_4$0)))
                 (not
                      (in$0 l1
                        (ulseg_domain$0 data$0 next$0 min_4$0 curr_4$0
                          (read$1 data$0 min_4$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 srt_4$0 l1 min_4$0)
                 (in$0 l1
                   (ulseg_domain$0 data$0 next$0 srt_4$0 min_4$0
                     (read$1 data$0 min_4$0)))
                 (not (= l1 min_4$0)))
            (and (or (= l1 min_4$0) (not (Btwn$0 next$0 srt_4$0 l1 min_4$0)))
                 (not
                      (in$0 l1
                        (ulseg_domain$0 data$0 next$0 srt_4$0 min_4$0
                          (read$1 data$0 min_4$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 srt_6$0 l1 null$0)
                 (in$0 l1
                   (ulseg_domain$0 data_3$0 next$0 srt_6$0 null$0
                     (read$1 data_3$0 prv_6$0)))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 srt_6$0 l1 null$0)))
                 (not
                      (in$0 l1
                        (ulseg_domain$0 data_3$0 next$0 srt_6$0 null$0
                          (read$1 data_3$0 prv_6$0))))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$0 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$0 ?y ?X))
            (in$0 (ep$0 ?f ?X ?x) ?X))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$0 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$0 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$0 ?f ?x) (read$0 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
