(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S4)
(declare-fun f4 () S3)
(declare-fun f5 (S5 S6) Int)
(declare-fun f6 () S5)
(declare-fun f7 (S7 S2) S6)
(declare-fun f8 () S7)
(declare-fun f9 () S6)
(declare-fun f10 () S4)
(declare-fun f11 () S4)
(declare-fun f12 () S3)
(declare-fun f13 (S8 S9) S4)
(declare-fun f14 (S4) S8)
(declare-fun f15 () S3)
(declare-fun f16 () S9)
(declare-fun f17 (S10 S9) S8)
(declare-fun f18 (S4) S10)
(declare-fun f19 () S9)
(declare-fun f20 (S4) S8)
(declare-fun f21 (S6) S3)
(declare-fun f22 (S11 S4) S1)
(declare-fun f23 (S12 S9) S11)
(declare-fun f24 (S13 S9) S12)
(declare-fun f25 () S13)
(declare-fun f26 () S9)
(declare-fun f27 () S9)
(declare-fun f28 () S9)
(declare-fun f29 (S3 S14) S1)
(declare-fun f30 () S14)
(declare-fun f31 (S4 S15) S1)
(declare-fun f32 () S15)
(declare-fun f33 (S16 S6) S2)
(declare-fun f34 (S17 S7) S16)
(declare-fun f35 (S18 S19) S17)
(declare-fun f36 () S18)
(declare-fun f37 () S19)
(declare-fun f38 (S20 S3) S4)
(declare-fun f39 () S20)
(declare-fun f40 (S4 S11) S1)
(declare-fun f41 (S20) S1)
(declare-fun f42 (S20) S1)
(declare-fun f43 (S21 Int) S6)
(declare-fun f44 () S21)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 f4 ?v0) (ite (< (f5 f6 (f7 f8 ?v0)) (+ (f5 f6 f9) 1)) f10 f11))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_1 (f3 f15 ?v0))) (= (f3 f12 ?v0) (ite (< (f5 f6 ?v_0) (f5 f6 f9)) (f13 (f14 ?v_1) f16) (ite (= ?v_0 f9) (f13 (f17 (f18 ?v_1) f19) f16) (f13 (f20 ?v_1) f16)))))))
(assert (forall ((?v0 S6) (?v1 S2)) (= (f3 (f21 ?v0) ?v1) (ite (< (f5 f6 (f7 f8 ?v1)) (f5 f6 ?v0)) f10 f11))))
(assert (not (forall ((?v0 S2)) (let ((?v_3 (f5 f6 f9)) (?v_0 (f7 f8 ?v0))) (let ((?v_2 (f5 f6 ?v_0)) (?v_1 (f3 f15 ?v0))) (= (= (f22 (f23 (f24 f25 f19) f16) (ite (< ?v_2 ?v_3) (f13 (f14 ?v_1) f16) (ite (= ?v_0 f9) (f13 (f17 (f18 ?v_1) f19) f16) (f13 (f20 ?v_1) f16)))) f1) (= (f22 (f23 (f24 f25 f26) f27) (ite (< ?v_2 (+ ?v_3 1)) f10 f11)) f1)))))))
(assert (distinct f19 f28 f16))
(assert (= (f29 f15 f30) f1))
(assert (= (f29 f15 f30) f1))
(assert (not (= f19 f28)))
(assert (not (= f26 f27)))
(assert (distinct f19 f28 f16))
(assert (= (f31 f10 f32) f1))
(assert (= (f31 f11 f32) f1))
(assert (= (f22 (f23 (f24 f25 f26) f27) f10) f1))
(assert (= (f22 (f23 (f24 f25 f27) f26) f11) f1))
(assert (not (= (f22 (f23 (f24 f25 f26) f27) f11) f1)))
(assert (not (= (f22 (f23 (f24 f25 f27) f26) f10) f1)))
(assert (forall ((?v0 S2)) (let ((?v_0 (f23 (f24 f25 f19) f28)) (?v_1 (f3 f15 ?v0)) (?v_2 (f7 f8 ?v0))) (= (= (f22 ?v_0 ?v_1) f1) (= (f22 ?v_0 (ite (< (f5 f6 ?v_2) (f5 f6 f9)) (f13 (f14 ?v_1) f16) (ite (= ?v_2 f9) (f13 (f17 (f18 ?v_1) f19) f16) (f13 (f20 ?v_1) f16)))) f1)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S4) (?v3 S9)) (let ((?v_0 (f23 (f24 f25 ?v0) ?v1))) (= (= (f22 ?v_0 (f13 (f20 ?v2) ?v3)) f1) (and (not (= ?v1 ?v3)) (ite (= ?v0 ?v3) (not (= ?v0 ?v1)) (= (f22 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S4) (?v3 S9)) (let ((?v_0 (f23 (f24 f25 ?v0) ?v1))) (= (= (f22 ?v_0 (f13 (f14 ?v2) ?v3)) f1) (and (not (= ?v0 ?v3)) (ite (= ?v1 ?v3) (not (= ?v0 ?v1)) (= (f22 ?v_0 ?v2) f1)))))))
(assert (=> (forall ((?v0 S4)) (=> (= (f22 (f23 (f24 f25 f26) f27) ?v0) f1) (=> (= (f31 ?v0 f32) f1) false))) false))
(assert (=> (forall ((?v0 S4)) (=> (= (f22 (f23 (f24 f25 f27) f26) ?v0) f1) (=> (= (f31 ?v0 f32) f1) false))) false))
(assert (= (f22 (f23 (f24 f25 f19) f28) (f3 f15 (f33 (f34 (f35 f36 f37) f8) f9))) f1))
(assert (= (f29 f12 f30) f1))
(assert (=> (forall ((?v0 S9)) (=> (distinct f19 f28 ?v0) false)) false))
(assert (forall ((?v0 S6)) (=> (<= (f5 f6 ?v0) (f5 f6 f9)) (= (f22 (f23 (f24 f25 f27) f26) (f38 f39 (f21 ?v0))) f1))))
(assert (= (f22 (f23 (f24 f25 f26) f27) (f38 f39 f4)) f1))
(assert (let ((?v_0 (f23 (f24 f25 f19) f28))) (= (= (f22 ?v_0 (f38 f39 f15)) f1) (= (f22 ?v_0 (f38 f39 f12)) f1))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S4) (?v3 S9) (?v4 S9)) (let ((?v_0 (f24 f25 ?v3))) (let ((?v_1 (f23 ?v_0 ?v4))) (=> (not (= ?v0 ?v1)) (=> (= (f31 ?v2 f32) f1) (= (= (f22 ?v_1 (f13 (f17 (f18 ?v2) ?v0) ?v1)) f1) (and (not (= ?v3 ?v4)) (ite (= ?v3 ?v1) (= (f22 (f23 (f24 f25 ?v0) ?v4) ?v2) f1) (ite (= ?v4 ?v1) (or (= ?v3 ?v0) (= (f22 (f23 ?v_0 ?v0) ?v2) f1)) (= (f22 ?v_1 ?v2) f1)))))))))))
(assert (forall ((?v0 S6)) (= (f29 (f21 ?v0) f30) f1)))
(assert (forall ((?v0 S4)) (= (forall ((?v1 S11)) (= (f40 ?v0 ?v1) f1)) (forall ((?v1 S9) (?v2 S9)) (= (f40 ?v0 (f23 (f24 f25 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (= (= (f23 (f24 f25 ?v0) ?v1) (f23 (f24 f25 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (= (f41 f39) f1))
(assert (= (f42 f39) f1))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S3) (?v3 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f29 ?v2 f30) f1) (=> (= (f29 ?v3 f30) f1) (=> (forall ((?v4 S2)) (= (= (f22 (f23 (f24 f25 ?v0) ?v1) (f3 ?v2 ?v4)) f1) (= (f22 (f23 (f24 f25 ?v1) ?v0) (f3 ?v3 ?v4)) f1))) (= (= (f22 (f23 (f24 f25 ?v0) ?v1) (f38 f39 ?v2)) f1) (= (f22 (f23 (f24 f25 ?v1) ?v0) (f38 f39 ?v3)) f1))))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9) (?v4 S3) (?v5 S3)) (=> (not (= ?v0 ?v1)) (=> (not (= ?v2 ?v3)) (=> (= (f29 ?v4 f30) f1) (=> (= (f29 ?v5 f30) f1) (=> (forall ((?v6 S2)) (= (= (f22 (f23 (f24 f25 ?v0) ?v1) (f3 ?v4 ?v6)) f1) (= (f22 (f23 (f24 f25 ?v2) ?v3) (f3 ?v5 ?v6)) f1))) (= (= (f22 (f23 (f24 f25 ?v0) ?v1) (f38 f39 ?v4)) f1) (= (f22 (f23 (f24 f25 ?v2) ?v3) (f38 f39 ?v5)) f1)))))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S3) (?v4 S3)) (=> (not (= ?v0 ?v1)) (=> (not (= ?v1 ?v2)) (=> (not (= ?v0 ?v2)) (=> (= (f29 ?v3 f30) f1) (=> (= (f29 ?v4 f30) f1) (=> (forall ((?v5 S2)) (= (= (f22 (f23 (f24 f25 ?v0) ?v1) (f3 ?v3 ?v5)) f1) (= (f22 (f23 (f24 f25 ?v1) ?v2) (f3 ?v4 ?v5)) f1))) (= (= (f22 (f23 (f24 f25 ?v0) ?v1) (f38 f39 ?v3)) f1) (= (f22 (f23 (f24 f25 ?v1) ?v2) (f38 f39 ?v4)) f1))))))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9) (?v4 S3) (?v5 S3)) (=> (not (= ?v0 ?v1)) (=> (not (= ?v2 ?v3)) (=> (not (= ?v0 ?v3)) (=> (not (= ?v1 ?v2)) (=> (= (f29 ?v4 f30) f1) (=> (= (f29 ?v5 f30) f1) (=> (forall ((?v6 S2)) (= (= (f22 (f23 (f24 f25 ?v0) ?v1) (f3 ?v4 ?v6)) f1) (= (f22 (f23 (f24 f25 ?v2) ?v3) (f3 ?v5 ?v6)) f1))) (=> (= (f22 (f23 (f24 f25 ?v0) ?v1) (f38 f39 ?v4)) f1) (= (f22 (f23 (f24 f25 ?v2) ?v3) (f38 f39 ?v5)) f1)))))))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9) (?v4 S3) (?v5 S3)) (=> (not (= ?v0 ?v1)) (=> (not (= ?v2 ?v3)) (=> (not (= ?v0 ?v3)) (=> (not (= ?v1 ?v2)) (=> (= (f29 ?v4 f30) f1) (=> (= (f29 ?v5 f30) f1) (=> (forall ((?v6 S2)) (= (= (f22 (f23 (f24 f25 ?v0) ?v1) (f3 ?v4 ?v6)) f1) (= (f22 (f23 (f24 f25 ?v2) ?v3) (f3 ?v5 ?v6)) f1))) (= (= (f22 (f23 (f24 f25 ?v0) ?v1) (f38 f39 ?v4)) f1) (= (f22 (f23 (f24 f25 ?v2) ?v3) (f38 f39 ?v5)) f1)))))))))))
(assert (forall ((?v0 S6)) (= (f43 f44 (f5 f6 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f5 f6 (f43 f44 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f5 f6 (f43 f44 ?v0)) 0))))
(check-sat)
(exit)
