(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S3)
(declare-fun f4 (S4 S3) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 S6) S3)
(declare-fun f7 () S5)
(declare-fun f8 () S6)
(declare-fun f9 (S7 S8) S3)
(declare-fun f10 (S9 S5) S7)
(declare-fun f11 () S9)
(declare-fun f12 () S5)
(declare-fun f13 (S10 S6) S8)
(declare-fun f14 (S6) S10)
(declare-fun f15 () S6)
(declare-fun f16 (S6) S10)
(declare-fun f17 (S11 S6) Int)
(declare-fun f18 () S11)
(declare-fun f19 (S12 S8) Int)
(declare-fun f20 (S13 S11) S12)
(declare-fun f21 () S13)
(declare-fun f22 (S14 Int) S6)
(declare-fun f23 () S14)
(declare-fun f24 (S8 S6) S1)
(declare-fun f25 (S6 S8) S1)
(declare-fun f26 (S15 Int) Int)
(declare-fun f27 () S15)
(declare-fun f28 (S16 Int) S15)
(declare-fun f29 () S16)
(declare-fun f30 () S16)
(declare-fun f31 (S8) S10)
(declare-fun f32 () S3)
(declare-fun f33 (S8) S1)
(declare-fun f34 (S6) S10)
(declare-fun f35 (S10) S10)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 (f6 f7 f8)) (f9 (f10 f11 f12) (f13 (f14 f8) f15))) (f9 (f10 f11 f7) (f13 (f16 f8) f15)))))
(assert (< (f17 f18 f8) (f17 f18 f15)))
(assert (forall ((?v0 S6)) (let ((?v_0 (f17 f18 ?v0))) (=> (< (f17 f18 f8) ?v_0) (=> (< ?v_0 (f17 f18 f15)) (= (f6 f12 ?v0) (f6 f7 ?v0)))))))
(assert (< (f17 f18 f8) (f17 f18 f15)))
(assert (forall ((?v0 S6)) (let ((?v_0 (f17 f18 ?v0))) (=> (< (f17 f18 f8) ?v_0) (=> (< ?v_0 (f17 f18 f15)) (= (f6 f12 ?v0) (f6 f7 ?v0)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S11)) (let ((?v_0 (f20 f21 ?v2))) (=> (< (f17 f18 ?v0) (f17 f18 ?v1)) (= (+ (f17 ?v2 ?v0) (f19 ?v_0 (f13 (f14 ?v0) ?v1))) (f19 ?v_0 (f13 (f16 ?v0) ?v1)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S5)) (let ((?v_0 (f10 f11 ?v2))) (=> (< (f17 f18 ?v0) (f17 f18 ?v1)) (= (f3 (f4 f5 (f6 ?v2 ?v0)) (f9 ?v_0 (f13 (f14 ?v0) ?v1))) (f9 ?v_0 (f13 (f16 ?v0) ?v1)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S11)) (let ((?v_1 (f17 f18 ?v0)) (?v_0 (f20 f21 ?v2))) (=> (< ?v_1 (f17 f18 ?v1)) (= (f19 ?v_0 (f13 (f16 ?v0) ?v1)) (+ (f17 ?v2 ?v0) (f19 ?v_0 (f13 (f16 (f22 f23 (+ ?v_1 1))) ?v1))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S5)) (let ((?v_1 (f17 f18 ?v0)) (?v_0 (f10 f11 ?v2))) (=> (< ?v_1 (f17 f18 ?v1)) (= (f9 ?v_0 (f13 (f16 ?v0) ?v1)) (f3 (f4 f5 (f6 ?v2 ?v0)) (f9 ?v_0 (f13 (f16 (f22 f23 (+ ?v_1 1))) ?v1))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S11)) (let ((?v_0 (f17 f18 ?v1)) (?v_1 (f20 f21 ?v3)) (?v_2 (f16 ?v0))) (=> (<= (f17 f18 ?v0) ?v_0) (=> (<= ?v_0 (f17 f18 ?v2)) (= (+ (f19 ?v_1 (f13 ?v_2 ?v1)) (f19 ?v_1 (f13 (f16 ?v1) ?v2))) (f19 ?v_1 (f13 ?v_2 ?v2))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S5)) (let ((?v_0 (f17 f18 ?v1)) (?v_1 (f10 f11 ?v3)) (?v_2 (f16 ?v0))) (=> (<= (f17 f18 ?v0) ?v_0) (=> (<= ?v_0 (f17 f18 ?v2)) (= (f3 (f4 f5 (f9 ?v_1 (f13 ?v_2 ?v1))) (f9 ?v_1 (f13 (f16 ?v1) ?v2))) (f9 ?v_1 (f13 ?v_2 ?v2))))))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f13 (f16 (f22 f23 (+ (f17 f18 ?v0) 1))) ?v1) (f13 (f14 ?v0) ?v1))))
(assert (forall ((?v0 S6) (?v1 S8)) (= (exists ((?v2 S6)) (and (< (f17 f18 ?v2) (f17 f18 ?v0)) (= (f24 ?v1 ?v2) f1))) (exists ((?v2 S6)) (and (= (f25 ?v2 (f13 (f16 (f22 f23 0)) ?v0)) f1) (= (f24 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S6) (?v1 S8)) (= (forall ((?v2 S6)) (=> (< (f17 f18 ?v2) (f17 f18 ?v0)) (= (f24 ?v1 ?v2) f1))) (forall ((?v2 S6)) (=> (= (f25 ?v2 (f13 (f16 (f22 f23 0)) ?v0)) f1) (= (f24 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f26 f27 ?v0) (f26 f27 ?v1)))) (= (f26 f27 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f5 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f26 (f28 f29 ?v0) ?v1) ?v2) (f26 (f28 f29 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f26 (f28 f30 ?v0) ?v1) ?v2) (f26 (f28 f30 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S6) (?v2 S6)) (= (= (f24 (f13 (f31 ?v0) ?v1) ?v2) f1) (forall ((?v3 S6)) (=> (= (f25 ?v3 (f13 (f16 ?v1) ?v2)) f1) (= (f24 ?v0 ?v3) f1))))))
(assert (forall ((?v0 S11) (?v1 S6) (?v2 S6)) (let ((?v_1 (f20 f21 ?v0)) (?v_2 (f16 ?v1)) (?v_0 (f17 f18 ?v2))) (= (f19 ?v_1 (f13 ?v_2 (f22 f23 (+ ?v_0 1)))) (ite (< ?v_0 (f17 f18 ?v1)) 0 (+ (f19 ?v_1 (f13 ?v_2 ?v2)) (f17 ?v0 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S6) (?v2 S6)) (let ((?v_1 (f10 f11 ?v0)) (?v_2 (f16 ?v1)) (?v_0 (f17 f18 ?v2))) (= (f9 ?v_1 (f13 ?v_2 (f22 f23 (+ ?v_0 1)))) (ite (< ?v_0 (f17 f18 ?v1)) f32 (f3 (f4 f5 (f9 ?v_1 (f13 ?v_2 ?v2))) (f6 ?v0 ?v2)))))))
(assert (forall ((?v0 S11) (?v1 S6)) (let ((?v_1 (f22 f23 0)) (?v_0 (f20 f21 ?v0))) (=> (= (f17 ?v0 ?v_1) 0) (= (f19 ?v_0 (f13 (f16 (f22 f23 (+ 0 1))) ?v1)) (f19 ?v_0 (f13 (f16 ?v_1) ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S6)) (let ((?v_1 (f22 f23 0)) (?v_0 (f10 f11 ?v0))) (=> (= (f6 ?v0 ?v_1) f32) (= (f9 ?v_0 (f13 (f16 (f22 f23 (+ 0 1))) ?v1)) (f9 ?v_0 (f13 (f16 ?v_1) ?v1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f33 (f13 (f14 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S11)) (let ((?v_0 (f17 f18 ?v1)) (?v_1 (f20 f21 ?v3)) (?v_2 (f16 ?v0))) (=> (<= (f17 f18 ?v0) ?v_0) (=> (<= ?v_0 (f17 f18 ?v2)) (= (- (f19 ?v_1 (f13 ?v_2 ?v2)) (f19 ?v_1 (f13 ?v_2 ?v1))) (f19 ?v_1 (f13 (f16 ?v1) ?v2))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S11) (?v3 S6)) (let ((?v_0 (f17 f18 ?v1))) (let ((?v_3 (+ ?v_0 1)) (?v_1 (f20 f21 ?v2)) (?v_2 (f34 ?v0)) (?v_4 (f22 f23 (+ ?v_0 (f17 f18 ?v3))))) (=> (<= (f17 f18 ?v0) ?v_3) (= (f19 ?v_1 (f13 ?v_2 ?v_4)) (+ (f19 ?v_1 (f13 ?v_2 ?v1)) (f19 ?v_1 (f13 (f34 (f22 f23 ?v_3)) ?v_4)))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S5) (?v3 S6)) (let ((?v_0 (f17 f18 ?v1))) (let ((?v_3 (+ ?v_0 1)) (?v_1 (f10 f11 ?v2)) (?v_2 (f34 ?v0)) (?v_4 (f22 f23 (+ ?v_0 (f17 f18 ?v3))))) (=> (<= (f17 f18 ?v0) ?v_3) (= (f9 ?v_1 (f13 ?v_2 ?v_4)) (f3 (f4 f5 (f9 ?v_1 (f13 ?v_2 ?v1))) (f9 ?v_1 (f13 (f34 (f22 f23 ?v_3)) ?v_4)))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S11)) (let ((?v_1 (f17 f18 ?v0)) (?v_0 (f20 f21 ?v2))) (=> (<= ?v_1 (f17 f18 ?v1)) (= (f19 ?v_0 (f13 (f34 ?v0) ?v1)) (+ (f17 ?v2 ?v0) (f19 ?v_0 (f13 (f34 (f22 f23 (+ ?v_1 1))) ?v1))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S5)) (let ((?v_1 (f17 f18 ?v0)) (?v_0 (f10 f11 ?v2))) (=> (<= ?v_1 (f17 f18 ?v1)) (= (f9 ?v_0 (f13 (f34 ?v0) ?v1)) (f3 (f4 f5 (f6 ?v2 ?v0)) (f9 ?v_0 (f13 (f34 (f22 f23 (+ ?v_1 1))) ?v1))))))))
(assert (forall ((?v0 S6) (?v1 S10) (?v2 S6)) (= (= (f25 ?v0 (f13 (f35 ?v1) ?v2)) f1) (= (f24 (f13 ?v1 ?v0) ?v2) f1))))
(assert (forall ((?v0 S6)) (= (f22 f23 (f17 f18 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f17 f18 (f22 f23 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f17 f18 (f22 f23 ?v0)) 0))))
(check-sat)
(exit)
