(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 Int) Int)
(declare-fun f9 (S7 Int) S6)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S2) Int)
(declare-fun f12 () S8)
(declare-fun f13 () S2)
(declare-fun f14 () S2)
(declare-fun f15 () S6)
(declare-fun f16 () S4)
(declare-fun f17 (S2 S9) S1)
(declare-fun f18 (S9 S2) S1)
(declare-fun f19 (Int S10) S1)
(declare-fun f20 (S10 Int) S1)
(declare-fun f21 () S10)
(declare-fun f22 () S9)
(declare-fun f23 (S11 Int) S3)
(declare-fun f24 () S11)
(declare-fun f25 () S4)
(declare-fun f26 (S12 Int) S8)
(declare-fun f27 () S12)
(declare-fun f28 () S6)
(declare-fun f29 () S3)
(declare-fun f30 () S2)
(declare-fun f31 () S7)
(declare-fun f32 () S7)
(declare-fun f33 (S13 S7) S12)
(declare-fun f34 (S14 Int) S13)
(declare-fun f35 () S14)
(declare-fun f36 (S15 S4) S4)
(declare-fun f37 (S16 S2) S15)
(declare-fun f38 () S16)
(declare-fun f39 (S17 S8) S8)
(declare-fun f40 () S17)
(declare-fun f41 (S2) S9)
(declare-fun f42 () S4)
(declare-fun f43 () S4)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))))))
(assert (not (exists ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (and (< ?v_0 (f11 f12 f13)) (= f14 (f6 f7 (* 2 ?v_0))))))))
(assert (< (f11 f12 f14) (* 2 (f11 f12 f13))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (< ?v_0 (f11 f12 f13)) (not (= f14 (f6 f7 (+ (* 2 ?v_0) 1))))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (<= ?v_0 (f8 (f9 f10 ?v_0) ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0))) (<= ?v_0 (f8 ?v_1 (f8 ?v_1 ?v_0)))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 0 (f11 f12 ?v0))) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 1 (f11 f12 ?v0))) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (< 0 (f8 (f9 f10 ?v_0) ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 0)) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)) (f6 f7 (f8 (f9 f10 ?v_0) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f6 f7 (+ ?v_1 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0)) (?v_2 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_1 (+ ?v_2 1))) (f6 f7 (+ ?v_0 (f8 ?v_1 ?v_2))))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (* ?v_0 2)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_2 (f11 f12 ?v0)) (?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (or (= ?v1 (f6 f7 1)) (= ?v0 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_3 (f11 f12 ?v3)) (?v_1 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_3 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v2))) (let ((?v_2 (f9 f10 ?v_0))) (=> (< ?v_1 ?v_3) (=> (< 0 ?v_0) (< (f8 ?v_2 ?v_1) (f8 ?v_2 ?v_3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f9 f10 (f11 f12 ?v2)))) (=> (<= ?v_0 ?v_2) (<= (f8 ?v_1 ?v_0) (f8 ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f8 (f9 f10 ?v_0) ?v_2) (f8 (f9 f10 ?v_1) ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (<= (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (< (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1)))) (= (= (f6 f7 (f8 ?v_0 (f11 f12 ?v1))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) ?v_0)) (f6 f7 (f8 (f9 f10 (f11 f12 ?v2)) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0)))) (= (= (f6 f7 (f8 ?v_0 (f11 f12 ?v1))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (<= (f8 (f9 f10 ?v_1) ?v_0) (f8 (f9 f10 ?v_2) ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v0))) (let ((?v_0 (f9 f10 ?v_1)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (= (<= (f8 ?v_0 ?v_2) (f8 ?v_0 ?v_3)) (=> (< 0 ?v_1) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (< (f8 (f9 f10 ?v_1) ?v_0) (f8 (f9 f10 ?v_2) ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v0))) (let ((?v_0 (f9 f10 ?v_1)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (= (< (f8 ?v_0 ?v_2) (f8 ?v_0 ?v_3)) (and (< 0 ?v_1) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_2)))) ?v_1)) (f6 f7 (- (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (+ ?v_0 ?v_2)) ?v_1)) (f6 f7 (+ (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f8 ?v_0 ?v_1)) ?v_2)) (f6 f7 (f8 ?v_0 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (* 2 ?v_0)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 (+ ?v_1 1)) ?v_0)) (f6 f7 (+ ?v_0 (f8 (f9 f10 ?v_1) ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (= (<= ?v_0 (f8 (f9 f10 ?v_1) ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_0 (f11 f12 (f6 f7 (- ?v_1 ?v_2))))) (f6 f7 (- (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 ?v_0 (+ ?v_1 ?v_2))) (f6 f7 (+ (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (<= (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4)) (<= (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_1)))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (< (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4)) (< (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_1)))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (f6 f7 (- (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4))) (f6 f7 (- (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_1)))) ?v_2) ?v_3) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (= (f6 f7 (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3)) (f6 f7 (+ (f8 (f9 f10 ?v_1) ?v_2) (f11 f12 ?v4)))) (= (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_1)))) ?v_2) ?v_3)) ?v4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (<= (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4)) (<= ?v_3 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (< (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4)) (< ?v_3 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (f6 f7 (- (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4))) (f6 f7 (- ?v_3 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_2) ?v_4))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v4))) (=> (<= ?v_0 ?v_1) (= (= (f6 f7 (+ (f8 (f9 f10 ?v_0) ?v_2) (f11 f12 ?v3))) (f6 f7 (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_3))) (= ?v3 (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_2) ?v_3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (<= (f8 ?v_1 ?v_2) (f8 ?v_1 ?v_3)) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (< (f8 ?v_1 ?v_2) (f8 ?v_1 ?v_3)) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< 0 ?v_0) (= (= (f6 f7 (f8 ?v_1 (f11 f12 ?v1))) (f6 f7 (f8 ?v_1 (f11 f12 ?v2)))) (= ?v1 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0)))) (= (= (f6 f7 (f8 ?v_0 (f11 f12 ?v1))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) (or (= ?v0 (f6 f7 0)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v3))) (= (f6 f7 (+ (f8 (f9 f10 ?v_1) ?v_0) (+ (f8 (f9 f10 ?v_2) ?v_0) ?v_3))) (f6 f7 (+ (f8 (f9 f10 (+ ?v_1 ?v_2)) ?v_0) ?v_3))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (* 2 (f11 f12 ?v0)))) (=> (not (= ?v0 (f6 f7 0))) (= (f6 f7 (+ (+ (f11 f12 (f6 f7 (- ?v_0 2))) 1) 1)) (f6 f7 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (* 4 (f11 f12 ?v0)))) (=> (not (= ?v0 (f6 f7 0))) (= (f6 f7 (+ (+ (f11 f12 (f6 f7 (- ?v_0 2))) 1) 1)) (f6 f7 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (* 2 (f11 f12 ?v0)))) (=> (not (= ?v0 (f6 f7 0))) (= (f6 f7 (+ (f11 f12 (f6 f7 (- ?v_0 1))) 1)) (f6 f7 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 f15 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f8 f15 ?v0)) (f8 f15 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f16 ?v0) ?v1) (f3 (f4 f16 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) (f8 (f9 f10 ?v2) ?v3)) (f8 (f9 f10 (f8 ?v_0 ?v2)) (f8 (f9 f10 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f16 ?v0))) (= (f3 (f4 f16 (f3 ?v_0 ?v1)) (f3 (f4 f16 ?v2) ?v3)) (f3 (f4 f16 (f3 ?v_0 ?v2)) (f3 (f4 f16 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f9 f10 (f8 (f9 f10 ?v0) ?v1))) (?v_0 (f9 f10 ?v2))) (= (f8 ?v_1 (f8 ?v_0 ?v3)) (f8 ?v_0 (f8 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f4 f16 (f3 (f4 f16 ?v0) ?v1))) (?v_0 (f4 f16 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0)) (?v_1 (f8 (f9 f10 ?v2) ?v3))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v_1) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f16 ?v0)) (?v_1 (f3 (f4 f16 ?v2) ?v3))) (= (f3 (f4 f16 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f4 f16 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 (f9 f10 (f8 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f16 ?v0))) (= (f3 (f4 f16 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f16 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f16 ?v0))) (= (f3 (f4 f16 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f16 ?v1) ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f15 ?v0))) (= (f8 (f9 f10 ?v_0) ?v_0) (f8 (f9 f10 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2)) (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f16 ?v0))) (= (f3 ?v_0 (f3 (f4 f16 ?v1) ?v2)) (f3 (f4 f16 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f9 f10 ?v0)) (?v_0 (f9 f10 ?v1))) (= (f8 ?v_1 (f8 ?v_0 ?v2)) (f8 ?v_0 (f8 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f4 f16 ?v0)) (?v_0 (f4 f16 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (= (f6 f7 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0)))) (f11 f12 (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S9)) (= (= (f17 ?v0 ?v1) f1) (= (f18 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (= (f19 ?v0 ?v1) f1) (= (f20 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1)))) (f6 f7 (f8 (f9 f10 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v0)))) (f11 f12 (f6 f7 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (+ ?v1 ?v2)) (+ (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (- ?v1 ?v2)) (- (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) ?v1) (- (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (+ ?v0 ?v1)) ?v2) (+ (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (- ?v0 ?v1)) ?v2) (- (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f8 (f9 f10 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f11 f12 ?v2))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f8 ?v_1 ?v0) (f8 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 (f9 f10 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f8 (f9 f10 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f8 (f9 f10 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f8 (f9 f10 ?v0) ?v2))) (=> (<= 0 ?v1) (<= ?v2 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f8 (f9 f10 ?v0) ?v2))) (=> (< ?v1 ?v0) (<= 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 (+ (f8 (f9 f10 ?v0) ?v1) ?v2)) (=> (< ?v2 ?v0) (=> (< 0 ?v0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ (f8 (f9 f10 ?v0) ?v1) ?v2) 0) (=> (<= 0 ?v2) (=> (< 0 ?v0) (<= ?v1 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f8 (f9 f10 ?v3) ?v4) ?v5))) (=> (= (+ (f8 (f9 f10 ?v0) ?v1) ?v2) ?v_0) (=> (< ?v_0 0) (=> (< ?v2 ?v0) (=> (<= 0 ?v5) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v4 ?v1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (<= (+ (f8 ?v_0 ?v1) ?v2) (+ (f8 ?v_0 ?v3) ?v4)) (=> (<= ?v4 0) (=> (< ?v0 ?v4) (=> (< ?v0 ?v2) (<= ?v3 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f8 (f9 f10 ?v3) ?v4) ?v5))) (=> (= (+ (f8 (f9 f10 ?v0) ?v1) ?v2) ?v_0) (=> (<= 0 ?v_0) (=> (< ?v5 ?v3) (=> (<= 0 ?v2) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v1 ?v4))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (<= (+ (f8 ?v_0 ?v1) ?v2) (+ (f8 ?v_0 ?v3) ?v4)) (=> (<= 0 ?v2) (=> (< ?v2 ?v0) (=> (< ?v4 ?v0) (<= ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (=> (< 0 ?v0) (=> (forall ((?v3 Int)) (=> (= (f20 ?v1 ?v3) f1) (= (f20 ?v1 (- ?v3 ?v0)) f1))) (=> (<= 0 ?v2) (forall ((?v3 Int)) (=> (= (f20 ?v1 ?v3) f1) (= (f20 ?v1 (- ?v3 (f8 (f9 f10 ?v2) ?v0))) f1))))))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (=> (< 0 ?v0) (=> (forall ((?v3 Int)) (=> (= (f20 ?v1 ?v3) f1) (= (f20 ?v1 (+ ?v3 ?v0)) f1))) (=> (<= 0 ?v2) (forall ((?v3 Int)) (=> (= (f20 ?v1 ?v3) f1) (= (f20 ?v1 (+ ?v3 (f8 (f9 f10 ?v2) ?v0))) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f16 ?v0))) (= (f3 (f4 f16 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f16 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (=> (< 0 ?v0) (=> (forall ((?v3 Int) (?v4 Int)) (= (= (f20 ?v1 ?v3) f1) (= (f20 ?v1 (- ?v3 (f8 (f9 f10 ?v4) ?v0))) f1))) (=> (exists ((?v3 Int)) (forall ((?v4 Int)) (=> (< ?v4 ?v3) (= (= (f20 ?v2 ?v4) f1) (= (f20 ?v1 ?v4) f1))))) (=> (exists ((?v3 Int)) (= (f20 ?v1 ?v3) f1)) (exists ((?v3 Int)) (= (f20 ?v2 ?v3) f1))))))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (=> (< 0 ?v0) (=> (forall ((?v3 Int) (?v4 Int)) (= (= (f20 ?v1 ?v3) f1) (= (f20 ?v1 (- ?v3 (f8 (f9 f10 ?v4) ?v0))) f1))) (=> (exists ((?v3 Int)) (forall ((?v4 Int)) (=> (< ?v3 ?v4) (= (= (f20 ?v2 ?v4) f1) (= (f20 ?v1 ?v4) f1))))) (=> (exists ((?v3 Int)) (= (f20 ?v1 ?v3) f1)) (exists ((?v3 Int)) (= (f20 ?v2 ?v3) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f19 ?v0 f21) f1) (=> (= (f19 ?v1 f21) f1) (= (f19 (f8 (f9 f10 ?v0) ?v1) f21) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f17 ?v0 f22) f1) (=> (= (f17 ?v1 f22) f1) (= (f17 (f3 (f4 f16 ?v0) ?v1) f22) f1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f3 (f23 f24 ?v0) ?v1) (f6 f7 (+ (f11 f12 (f6 f7 ?v0)) (f11 f12 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f3 (f4 f16 ?v0) (f3 (f4 f25 (f3 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f26 f27 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f8 (f9 f10 ?v0) (f11 (f26 f27 (f11 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f26 f27 (f8 f15 ?v0)) ?v_0) (f11 (f26 f27 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 (f26 f27 ?v0) (f6 f7 2)))) (= (f8 f15 ?v_0) ?v_0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f11 (f26 f27 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f26 f27 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f26 f27 ?v0))) (= (f11 (f26 f27 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) (f6 f7 1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 (f3 ?v_0 (f6 f7 (- (f11 f12 ?v1) 1)))))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f3 (f4 f25 (f3 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f26 f27 ?v0))) (= (f11 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f11 (f26 f27 (f11 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f26 f27 ?v0))) (= (f11 (f26 f27 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 ?v0) (f6 f7 2)) (f3 (f4 f16 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f26 f27 ?v0) (f6 f7 2)) (f8 (f9 f10 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 ?v0) (f6 f7 3)) (f3 (f4 f16 (f3 (f4 f16 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f26 f27 ?v0) (f6 f7 3)) (f8 (f9 f10 (f8 (f9 f10 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f16 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f26 f27 ?v0))) (= (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f4 f25 (f3 (f4 f16 ?v0) ?v1)) ?v2) (f3 (f4 f16 (f3 (f4 f25 ?v0) ?v2)) (f3 (f4 f25 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f11 (f26 f27 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f11 (f26 f27 ?v0) ?v2)) (f11 (f26 f27 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f16 (f3 ?v_0 ?v1)) ?v0) (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f26 f27 ?v0))) (= (f8 (f9 f10 (f11 ?v_0 ?v1)) ?v0) (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f16 ?v0) (f3 ?v_0 ?v1)) (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f26 f27 ?v0))) (= (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1)) (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f16 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f26 f27 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f16 ?v0) ?v0) (f3 (f4 f25 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 ?v0) ?v0) (f11 (f26 f27 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f3 (f4 f16 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f26 f27 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f8 (f9 f10 ?v_1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f3 (f4 f16 ?v0) (f3 (f4 f16 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f26 f27 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f8 (f9 f10 ?v0) (f8 (f9 f10 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f26 f27 ?v0))) (= (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f11 (f26 f27 (f11 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f16 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f26 f27 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f16 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f26 f27 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 (f11 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f3 (f4 f16 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f26 f27 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f3 (f4 f25 (f6 f7 ?v0)) ?v1) (f6 f7 (f11 (f26 f27 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f6 f7 (f11 (f26 f27 ?v0) ?v1)) (f3 (f4 f25 (f6 f7 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (<= 0 (f11 (f26 f27 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 (f26 f27 (f11 f12 ?v0)) ?v1) (f11 f12 (f3 (f4 f25 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 (f26 f27 (f11 f12 ?v0)) ?v1) (f11 f12 (f3 (f4 f25 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (< 0 (f11 (f26 f27 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 f12 (f3 (f4 f25 ?v0) ?v1)) (f11 (f26 f27 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f11 (f26 f27 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f11 f12 (f3 (f4 f25 ?v0) ?v1))) (or (< 0 (f11 f12 ?v0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (f3 (f4 f25 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f3 (f4 f25 ?v0) ?v1) ?v_0) (or (= ?v1 (f6 f7 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (=> (< 0 (f11 f12 ?v0)) (=> (< (f11 f12 (f3 ?v_0 ?v1)) (f11 f12 (f3 ?v_0 ?v2))) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f11 f12 ?v0)) (<= ?v_0 (f11 f12 (f3 (f4 f25 ?v0) ?v1)))))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f11 (f26 f27 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f8 f15 (f11 (f26 f27 ?v0) ?v1)) (f11 (f26 f27 (f8 f15 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f4 f25 (f3 (f4 f16 ?v0) ?v1)) ?v2) (f3 (f4 f16 (f3 (f4 f25 ?v0) ?v2)) (f3 (f4 f25 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f11 (f26 f27 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f11 (f26 f27 ?v0) ?v2)) (f11 (f26 f27 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f3 (f4 f25 ?v0) ?v1))) (= (f3 (f4 f16 ?v_0) ?v0) (f3 (f4 f16 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f11 (f26 f27 ?v0) ?v1))) (= (f8 (f9 f10 ?v_0) ?v0) (f8 (f9 f10 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f4 f25 ?v2))) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f3 (f4 f16 (f3 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f26 f27 ?v2))) (=> (<= ?v_1 ?v_0) (= (f11 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f8 (f9 f10 (f11 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f4 f25 ?v1))) (=> (< 0 ?v_0) (= (f3 (f4 f16 (f3 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f26 f27 ?v1))) (=> (< 0 ?v_0) (= (f8 (f9 f10 (f11 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f11 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f11 f12 (f3 (f4 f25 ?v0) ?v1))) (or (= ?v1 (f6 f7 0)) (< 0 (f11 f12 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f8 f28 (f11 (f26 f27 ?v0) ?v1)) (f11 (f26 f27 (f8 f28 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 f28 ?v0) (f8 f28 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 f28 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f8 f28 ?v0)) (f8 f28 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 f29 (f3 (f4 f25 ?v0) ?v1)) (f3 (f4 f25 (f3 f29 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 f12 (f3 (f4 f25 ?v0) ?v1)) (f11 (f26 f27 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f26 f27 ?v0))) (= (f11 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) 1 (f8 (f9 f10 ?v0) (f11 ?v_0 (f6 f7 (- (f11 f12 ?v1) 1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) f30 (f3 (f4 f16 ?v0) (f3 ?v_0 (f6 f7 (- (f11 f12 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f6 f7 (* 2 (f11 f12 ?v1))))) (= (f11 (f26 f27 (- ?v0)) ?v_0) (f11 (f26 f27 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 (+ (+ 0 1) 1)))) (= (= (f11 (f26 f27 ?v0) ?v_0) (f11 (f26 f27 ?v1) ?v_0)) (or (= ?v0 ?v1) (= ?v0 (- ?v1)))))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f6 f7 ?v0)) (f8 f28 ?v0)))))
(assert (forall ((?v0 Int)) (= (f8 f28 (- ?v0)) (- (f8 f28 ?v0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f8 f28 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f8 f28 ?v0) (ite (< ?v0 0) (- (f11 f12 (f6 f7 (- ?v0)))) (f11 f12 (f6 f7 ?v0))))))
(assert (= (f8 f28 1) 1))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (- (f8 ?v_0 ?v1)) (f8 ?v_0 (- ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) ?v1) (f8 (f9 f10 ?v0) (- ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) (- ?v1)) (f8 (f9 f10 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v0) (f8 (f9 f10 ?v1) ?v1)) (or (= ?v0 ?v1) (= ?v0 (- ?v1))))))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f16 f30) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f16 ?v0) f30) ?v0)))
(assert (= (f8 f15 1) 1))
(assert (= (f11 f12 (f6 f7 1)) 1))
(assert (= (f3 f29 (f6 f7 1)) f30))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f8 f15 ?v_0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f11 f12 ?v0) (f11 f12 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 f29 ?v0) (f3 f29 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (= (f8 (f9 f10 ?v0) ?v0) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int)) (= (- ?v0) (* (- 1) ?v0))))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f16 f30) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f16 f30) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f16 ?v0) f30) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f16 ?v0) f30) ?v0)))
(assert (forall ((?v0 Int)) (= (- (- ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (= (f8 f15 (- ?v0)) (f8 f15 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f8 (f9 f31 ?v0) ?v1)) (f8 (f9 f32 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f8 (f9 f32 ?v0) ?v1)) (f8 (f9 f31 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S2)) (= (= f30 ?v0) (= ?v0 f30))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (- ?v1)) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) ?v1) (= (- ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) (- ?v1)) (= ?v0 ?v1))))
(assert (= (f19 1 f21) f1))
(assert (= (f17 f30 f22) f1))
(assert (forall ((?v0 S2)) (= (f19 (f11 f12 ?v0) f21) f1)))
(assert (forall ((?v0 S2)) (= (f17 (f3 f29 ?v0) f22) f1)))
(assert (forall ((?v0 Int)) (= (f11 (f26 f27 ?v0) (f6 f7 0)) 1)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 ?v0) (f6 f7 0)) f30)))
(assert (= (f11 (f26 f27 1) (f6 f7 2)) 1))
(assert (= (f3 (f4 f25 f30) (f6 f7 2)) f30))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f26 f27 (- ?v0)) ?v_0) (f11 (f26 f27 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (= (f11 (f26 f27 ?v0) (f6 f7 2)) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int)) (= (f11 (f26 f27 ?v0) (f6 f7 0)) 1)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 ?v0) (f6 f7 0)) f30)))
(assert (forall ((?v0 S2)) (= (f11 (f26 f27 1) ?v0) 1)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 f30) ?v0) f30)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f8 f15 (f11 (f26 f27 (- ?v0)) ?v1)) (f8 f15 (f11 (f26 f27 ?v0) ?v1)))))
(assert (forall ((?v0 S2)) (= (f11 (f26 f27 (- 1)) (f6 f7 (+ (* 2 (f11 f12 ?v0)) 1))) (- 1))))
(assert (forall ((?v0 S2)) (= (f11 (f26 f27 (- 1)) (f6 f7 (* 2 (f11 f12 ?v0)))) 1)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f11 (f26 f27 (- ?v0)) ?v1) (f8 (f9 f10 (f11 (f26 f27 (- 1)) ?v1)) (f11 (f26 f27 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= (f11 f12 (f6 f7 ?v_0)) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 f29 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (f3 (f4 f16 (f3 f29 ?v0)) (f3 f29 ?v1)))))
(assert (forall ((?v0 Int)) (=> (= (f19 ?v0 f21) f1) (=> (forall ((?v1 S2)) (=> (= ?v0 (f11 f12 ?v1)) false)) false))))
(assert (forall ((?v0 S2)) (=> (= (f17 ?v0 f22) f1) (=> (forall ((?v1 S2)) (=> (= ?v0 (f3 f29 ?v1)) false)) false))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (= (f19 ?v0 f21) f1) (=> (forall ((?v2 S2)) (= (f20 ?v1 (f11 f12 ?v2)) f1)) (= (f20 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S2) (?v1 S9)) (=> (= (f17 ?v0 f22) f1) (=> (forall ((?v2 S2)) (= (f18 ?v1 (f3 f29 ?v2)) f1)) (= (f18 ?v1 ?v0) f1)))))
(assert (= f27 (f33 (f34 f35 1) f10)))
(assert (= f25 (f36 (f37 f38 f30) f16)))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 (f36 (f37 f38 ?v0) ?v1) ?v2))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v3) 1))) (f3 (f4 ?v1 ?v2) (f3 ?v_0 ?v3))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int) (?v3 S2)) (let ((?v_0 (f26 (f33 (f34 f35 ?v0) ?v1) ?v2))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v3) 1))) (f8 (f9 ?v1 ?v2) (f11 ?v_0 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S2)) (= (f3 (f4 (f36 (f37 f38 ?v0) ?v1) ?v2) (f6 f7 0)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int)) (= (f11 (f26 (f33 (f34 f35 ?v0) ?v1) ?v2) (f6 f7 0)) ?v0)))
(assert (forall ((?v0 S8) (?v1 S2)) (let ((?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))) (= (f11 (f39 f40 ?v0) ?v1) (f8 (f9 f10 (f11 f12 ?v_0)) (f11 ?v0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f11 (f26 f27 ?v0) ?v1))) (=> (< 1 ?v0) (< ?v_0 (f8 (f9 f10 ?v0) ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f3 (f4 f25 ?v0) ?v1))) (=> (= (f18 (f41 f30) ?v0) f1) (= (f18 (f41 ?v_0) (f3 (f4 f16 ?v0) ?v_0)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (< (f11 f12 ?v0) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f18 (f41 (f3 f29 ?v0)) (f3 f29 ?v1)) f1) (< (f11 f12 ?v0) (f11 f12 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (< (f11 f12 ?v0) (f11 f12 ?v1)))) (=> ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (< (f11 f12 ?v0) (f11 f12 ?v1)) (= (f18 (f41 (f3 f29 ?v0)) (f3 f29 ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (< (f11 f12 ?v0) (f11 f12 ?v1)))) (=> ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f18 (f41 (f3 f29 ?v0)) (f3 f29 ?v1)) f1) (< (f11 f12 ?v0) (f11 f12 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f8 (f9 f32 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f18 (f41 ?v0) ?v1) f1) (= (f18 (f41 (f3 (f4 f42 ?v2) ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f8 (f9 f32 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f18 (f41 ?v0) ?v1) f1) (= (f18 (f41 (f3 (f4 f42 ?v0) ?v2)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f8 (f9 f31 ?v2) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f41 ?v0))) (=> (= (f18 ?v_0 ?v1) f1) (= (f18 ?v_0 (f3 (f4 f43 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f8 (f9 f31 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f41 ?v0))) (=> (= (f18 ?v_0 ?v1) f1) (= (f18 ?v_0 (f3 (f4 f43 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f8 f15 ?v0)) (?v_1 (f8 f15 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v1) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f8 f28 ?v0) (f8 f28 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f26 f27 ?v2))) (=> (< (f11 f12 ?v0) (f11 f12 ?v1)) (=> (< 1 ?v2) (< (f11 ?v_0 ?v0) (f11 ?v_0 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v2))) (=> (< (f11 f12 ?v0) (f11 f12 ?v1)) (=> (= (f18 (f41 f30) ?v2) f1) (= (f18 (f41 (f3 ?v_0 ?v0)) (f3 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f26 f27 ?v0))) (=> (< 1 ?v0) (=> (< (f11 ?v_0 ?v1) (f11 ?v_0 ?v2)) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (=> (= (f18 (f41 f30) ?v0) f1) (=> (= (f18 (f41 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) f1) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (< 1 ?v0) (=> (< 0 (f11 f12 ?v1)) (< 1 (f11 (f26 f27 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f41 f30))) (=> (= (f18 ?v_0 ?v0) f1) (=> (< 0 (f11 f12 ?v1)) (= (f18 ?v_0 (f3 (f4 f25 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f26 f27 ?v0))) (=> (< 1 ?v0) (= (< (f11 ?v_0 ?v1) (f11 ?v_0 ?v2)) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (=> (= (f18 (f41 f30) ?v0) f1) (= (= (f18 (f41 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) f1) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f26 f27 ?v0))) (=> (< 1 ?v0) (= (= (f11 ?v_0 ?v1) (f11 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (=> (= (f18 (f41 f30) ?v0) f1) (= (= (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (< 1 ?v0) (< 1 (f11 (f26 f27 ?v0) (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f41 f30))) (=> (= (f18 ?v_0 ?v0) f1) (= (f18 ?v_0 (f3 (f4 f25 ?v0) (f6 f7 (+ (f11 f12 ?v1) 1)))) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (< 1 ?v1) (< 1 (f8 (f9 f10 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f41 f30))) (=> (= (f18 ?v_0 ?v0) f1) (=> (= (f18 ?v_0 ?v1) f1) (= (f18 ?v_0 (f3 (f4 f16 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) (- ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) ?v1) (< (- ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 (- ?v1)) (< ?v1 (- ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f8 f15 ?v0) ?v1) (and (< ?v0 ?v1) (< (- ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (< 1 ?v0) (< 1 (f8 (f9 f10 ?v0) (f11 (f26 f27 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f41 f30))) (=> (= (f18 ?v_0 ?v0) f1) (= (f18 ?v_0 (f3 (f4 f16 ?v0) (f3 (f4 f25 ?v0) ?v1))) f1)))))
(assert (forall ((?v0 S8) (?v1 S2) (?v2 S2)) (=> (forall ((?v3 S2)) (< (f11 ?v0 ?v3) (f11 ?v0 (f6 f7 (+ (f11 f12 ?v3) 1))))) (=> (< (f11 f12 ?v1) (f11 f12 ?v2)) (< (f11 ?v0 ?v1) (f11 ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S2)) (=> (forall ((?v3 S2)) (= (f18 (f41 (f3 ?v0 ?v3)) (f3 ?v0 (f6 f7 (+ (f11 f12 ?v3) 1)))) f1)) (=> (< (f11 f12 ?v1) (f11 f12 ?v2)) (= (f18 (f41 (f3 ?v0 ?v1)) (f3 ?v0 ?v2)) f1)))))
(assert (forall ((?v0 S8) (?v1 S2) (?v2 S2)) (=> (forall ((?v3 S2)) (< (f11 ?v0 ?v3) (f11 ?v0 (f6 f7 (+ (f11 f12 ?v3) 1))))) (= (< (f11 ?v0 ?v1) (f11 ?v0 ?v2)) (< (f11 f12 ?v1) (f11 f12 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S2)) (=> (forall ((?v3 S2)) (= (f18 (f41 (f3 ?v0 ?v3)) (f3 ?v0 (f6 f7 (+ (f11 f12 ?v3) 1)))) f1)) (= (= (f18 (f41 (f3 ?v0 ?v1)) (f3 ?v0 ?v2)) f1) (< (f11 f12 ?v1) (f11 f12 ?v2))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
