(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) S6)
(declare-fun f7 (S7 S6) S4)
(declare-fun f8 () S7)
(declare-fun f9 () S4)
(declare-fun f10 () S5)
(declare-fun f11 () S6)
(declare-fun f12 (S8 S5) Int)
(declare-fun f13 (S9 Int) S8)
(declare-fun f14 () S9)
(declare-fun f15 (S10 Int) S5)
(declare-fun f16 () S10)
(declare-fun f17 (S11 Int) Int)
(declare-fun f18 () S11)
(declare-fun f19 () S6)
(declare-fun f20 () S8)
(declare-fun f21 (S12 S6) S6)
(declare-fun f22 () S12)
(declare-fun f23 (S13 Int) S11)
(declare-fun f24 () S13)
(declare-fun f25 () S13)
(declare-fun f26 (S14 S3) S13)
(declare-fun f27 () S14)
(declare-fun f28 () S14)
(declare-fun f29 () S13)
(declare-fun f30 () S11)
(declare-fun f31 (S15 S6) S12)
(declare-fun f32 () S15)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (<= ?v0 ?v1))))
(assert (not (= (f6 (f7 f8 (f6 f9 f10)) f10) f11)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f11) ?v0) f11)))
(assert (forall ((?v0 S5)) (= (f12 (f13 f14 1) ?v0) 1)))
(assert (= (f6 (f7 f8 f11) (f15 f16 2)) f11))
(assert (= (f12 (f13 f14 1) (f15 f16 2)) 1))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f15 f16 0)) f11)))
(assert (forall ((?v0 Int)) (= (f12 (f13 f14 ?v0) (f15 f16 0)) 1)))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f15 f16 0)) f11)))
(assert (forall ((?v0 Int)) (= (f12 (f13 f14 ?v0) (f15 f16 0)) 1)))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f17 f18 (f12 (f13 f14 ?v0) ?v1)) (f12 (f13 f14 (f17 f18 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 (f13 f14 ?v0) (f15 f16 2)))) (= (f17 f18 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f12 (f13 f14 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f12 (f13 f14 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f16 2))) (= (f12 (f13 f14 (f17 f18 ?v0)) ?v_0) (f12 (f13 f14 ?v0) ?v_0)))))
(assert (= (f17 f18 1) 1))
(assert (forall ((?v0 S6)) (= (= f11 ?v0) (= ?v0 f11))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S5)) (not (= (f6 f9 ?v0) f19))))
(assert (= (f17 f18 0) 0))
(assert (forall ((?v0 S6)) (= (= f19 ?v0) (= ?v0 f19))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= (f17 f18 ?v0) 0) (= ?v0 0))))
(assert (not (= f19 f11)))
(assert (not (= 0 1)))
(assert (not (= f11 f19)))
(assert (not (= 1 0)))
(assert (forall ((?v0 S6) (?v1 S5)) (=> (not (= ?v0 f19)) (not (= (f6 (f7 f8 ?v0) ?v1) f19)))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (not (= ?v0 0)) (not (= (f12 (f13 f14 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S6)) (= (= (f6 (f7 f8 ?v0) (f15 f16 2)) f19) (= ?v0 f19))))
(assert (forall ((?v0 Int)) (= (= (f12 (f13 f14 ?v0) (f15 f16 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S6) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v1) f19) (and (= ?v0 f19) (not (= ?v1 (f15 f16 0)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (= (f12 (f13 f14 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f15 f16 0)))))))
(assert (= (f6 (f7 f8 f19) (f15 f16 2)) f19))
(assert (= (f12 (f13 f14 0) (f15 f16 2)) 0))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f19) (f15 f16 (+ (f12 f20 ?v0) 1))) f19)))
(assert (forall ((?v0 S5)) (= (f12 (f13 f14 0) (f15 f16 (+ (f12 f20 ?v0) 1))) 0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f19) ?v0) (ite (= ?v0 (f15 f16 0)) f11 f19))))
(assert (forall ((?v0 S5)) (= (f12 (f13 f14 0) ?v0) (ite (= ?v0 (f15 f16 0)) 1 0))))
(assert (= (f21 f22 f19) f11))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f13 f14 ?v2))) (=> (<= (f12 f20 ?v0) (f12 f20 ?v1)) (=> (<= 0 ?v2) (=> (<= ?v2 1) (<= (f12 ?v_0 ?v1) (f12 ?v_0 ?v0))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f13 f14 ?v2))) (=> (< (f12 f20 ?v0) (f12 f20 ?v1)) (=> (< 0 ?v2) (=> (< ?v2 1) (< (f12 ?v_0 ?v1) (f12 ?v_0 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f12 (f13 f14 ?v0) (f15 f16 (+ (f12 f20 ?v1) 1))) 1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f13 f14 ?v2))) (=> (<= (f12 f20 ?v0) (f12 f20 ?v1)) (=> (<= 1 ?v2) (<= (f12 ?v_0 ?v0) (f12 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 1 ?v0) (<= 1 (f12 (f13 f14 ?v0) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f13 f14 ?v2))) (=> (< (f12 f20 ?v0) (f12 f20 ?v1)) (=> (< 1 ?v2) (< (f12 ?v_0 ?v0) (f12 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f13 f14 ?v0))) (=> (< 1 ?v0) (=> (< (f12 ?v_0 ?v1) (f12 ?v_0 ?v2)) (< (f12 f20 ?v1) (f12 f20 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (< 1 ?v0) (=> (< 0 (f12 f20 ?v1)) (< 1 (f12 (f13 f14 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f13 f14 ?v0))) (=> (< 1 ?v0) (= (< (f12 ?v_0 ?v1) (f12 ?v_0 ?v2)) (< (f12 f20 ?v1) (f12 f20 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f13 f14 ?v0))) (=> (< 1 ?v0) (= (= (f12 ?v_0 ?v1) (f12 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f17 f18 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f17 f18 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (=> (< (f12 (f13 f14 ?v0) ?v_0) (f12 (f13 f14 ?v1) ?v_0)) (=> (<= 0 ?v1) (< ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (=> (< (f12 (f13 f14 ?v0) ?v1) (f12 (f13 f14 ?v2) ?v1)) (=> (<= 0 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (< ?v0 ?v1) (=> (<= 0 ?v0) (=> (< 0 (f12 f20 ?v2)) (< (f12 (f13 f14 ?v0) ?v2) (f12 (f13 f14 ?v1) ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f13 f14 ?v0))) (=> (< 1 ?v0) (= (<= (f12 ?v_0 ?v1) (f12 ?v_0 ?v2)) (<= (f12 f20 ?v1) (f12 f20 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f13 f14 ?v0))) (=> (< 1 ?v0) (=> (<= (f12 ?v_0 ?v1) (f12 ?v_0 ?v2)) (<= (f12 f20 ?v1) (f12 f20 ?v2)))))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f17 f18 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (< 0 (f17 f18 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 Int)) (not (< (f17 f18 ?v0) 0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f17 f18 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f17 f18 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (<= 0 (f17 f18 ?v0))))
(assert (< 0 1))
(assert (not (< 1 0)))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (< 0 ?v0) (< 0 (f12 (f13 f14 ?v0) ?v1)))))
(assert (forall ((?v0 Int)) (= (< 0 (f12 (f13 f14 ?v0) (f15 f16 2))) (not (= ?v0 0)))))
(assert (forall ((?v0 Int)) (not (< (f12 (f13 f14 ?v0) (f15 f16 2)) 0))))
(assert (<= 0 1))
(assert (not (<= 1 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (=> (= (f12 (f13 f14 ?v0) ?v_0) (f12 (f13 f14 ?v1) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (=> (<= (f12 (f13 f14 ?v0) ?v_0) (f12 (f13 f14 ?v1) ?v_0)) (=> (<= 0 ?v1) (<= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (let ((?v_0 (f15 f16 (+ (f12 f20 ?v1) 1)))) (=> (= (f12 (f13 f14 ?v0) ?v_0) (f12 (f13 f14 ?v2) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (let ((?v_0 (f15 f16 (+ (f12 f20 ?v1) 1)))) (=> (<= (f12 (f13 f14 ?v0) ?v_0) (f12 (f13 f14 ?v2) ?v_0)) (=> (<= 0 ?v2) (<= ?v0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (=> (= (f12 (f13 f14 ?v0) ?v1) (f12 (f13 f14 ?v2) ?v1)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (=> (< 0 (f12 f20 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v0) (<= (f12 (f13 f14 ?v0) ?v2) (f12 (f13 f14 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 ?v0) (<= 0 (f12 (f13 f14 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S5)) (<= 0 (f12 (f13 f14 (f17 f18 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= 0 (f12 (f13 f14 ?v0) (f15 f16 2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (< 1 ?v0) (< 1 (f12 (f13 f14 ?v0) (f15 f16 (+ (f12 f20 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 ?v0) (=> (<= ?v0 1) (<= (f12 (f13 f14 ?v0) (f15 f16 (+ (f12 f20 ?v1) 1))) ?v0)))))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f17 (f23 f24 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f17 (f23 f25 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f17 (f23 f24 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f17 (f23 f25 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f17 (f23 f24 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f17 (f23 f25 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 S11) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f17 ?v1 ?v2)) (=> (< ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f17 ?v1 ?v5) (f17 ?v1 ?v4)))) (< (f17 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S11) (?v3 Int)) (=> (< ?v0 ?v1) (=> (= (f17 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f17 ?v2 ?v5) (f17 ?v2 ?v4)))) (< ?v3 (f17 ?v2 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f17 (f23 f24 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f17 (f23 f24 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 S11) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f17 ?v1 ?v2)) (=> (<= ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f17 ?v1 ?v5) (f17 ?v1 ?v4)))) (<= (f17 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f17 (f23 f25 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f17 (f23 f25 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S11) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (= (f17 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f17 ?v2 ?v5) (f17 ?v2 ?v4)))) (<= ?v3 (f17 ?v2 ?v1)))))))
(assert (= f24 (f26 f27 f5)))
(assert (= f25 (f26 f28 f5)))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f12 (f13 f14 ?v0) ?v1))) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f17 (f23 f29 ?v0) ?v_0) ?v_0))))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f17 f30 ?v0) 1))))
(assert (forall ((?v0 Int)) (= (= (f17 f30 ?v0) 1) (< 0 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (f17 (f23 f29 ?v0) ?v1) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f17 f18 (f17 (f23 f29 ?v0) ?v1)) (f17 (f23 f29 (f17 f18 ?v0)) (f17 f18 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (f17 (f23 f29 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (f17 (f23 f29 ?v0) ?v2) (f17 (f23 f29 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (f17 (f23 f29 ?v0) ?v2) (f17 (f23 f29 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f29 ?v2))) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f17 ?v_0 ?v1) (f17 ?v_0 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f17 (f23 f29 ?v1) ?v2) (f17 (f23 f29 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f29 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f17 ?v_0 ?v0) (f17 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f29 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f17 ?v_0 ?v0) (f17 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f17 (f23 f29 ?v0) ?v2) (f17 (f23 f29 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (f17 (f23 f29 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (f17 (f23 f29 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f17 (f23 f29 ?v1) ?v0) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f17 (f23 f29 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f17 (f23 f29 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f17 (f23 f29 (f17 f18 ?v1)) ?v0) (f17 f18 (f17 (f23 f29 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f17 (f23 f29 ?v0) ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (f17 (f23 f29 ?v0) ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 Int)) (<= 0 (f17 (f23 f29 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f29 ?v2))) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (f17 ?v_0 ?v1) (f17 ?v_0 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (f17 (f23 f29 ?v1) ?v2) (f17 (f23 f29 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f29 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f17 ?v_0 ?v0) (f17 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f29 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f17 ?v_0 ?v0) (f17 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f17 (f23 f29 ?v0) ?v2) (f17 (f23 f29 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (f17 (f23 f29 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f17 (f23 f29 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f29 ?v0))) (=> (< ?v0 0) (= (< (f17 ?v_0 ?v1) (f17 ?v_0 ?v2)) (< ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (f17 (f23 f29 ?v0) ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (f17 (f23 f29 ?v0) ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (f17 (f23 f29 ?v1) ?v0) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (f17 (f23 f29 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (f17 (f23 f29 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f29 ?v0))) (=> (< 0 ?v0) (= (< (f17 ?v_0 ?v1) (f17 ?v_0 ?v2)) (< ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f29 ?v0))) (= (< (f17 ?v_0 ?v1) (f17 ?v_0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f17 (f23 f29 ?v0) ?v1) (f17 (f23 f29 ?v2) ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 Int)) (not (< (f17 (f23 f29 ?v0) ?v0) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (< 1 ?v1) (< 1 (f17 (f23 f29 ?v0) ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f21 (f31 f32 ?v0) ?v1) f19) (or (= ?v0 f19) (= ?v1 f19)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 (f23 f29 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (not (= ?v0 f19)) (=> (not (= ?v1 f19)) (not (= (f21 (f31 f32 ?v0) ?v1) f19))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (f17 (f23 f29 ?v0) ?v1) 0))))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f21 (f31 f32 ?v0) ?v1) f19) (or (= ?v0 f19) (= ?v1 f19)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f17 (f23 f29 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S6)) (= (f21 (f31 f32 ?v0) f19) f19)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S6)) (= (f21 (f31 f32 ?v0) f19) f19)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S6)) (= (f21 (f31 f32 f19) ?v0) f19)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S6)) (= (f21 (f31 f32 f19) ?v0) f19)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S6)) (= (f21 (f31 f32 f11) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S6)) (= (f21 (f31 f32 f11) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S6)) (= (f21 (f31 f32 f11) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S6)) (= (f21 (f31 f32 ?v0) f11) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S6)) (= (f21 (f31 f32 ?v0) f11) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S6)) (= (f21 (f31 f32 ?v0) f11) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 Int)) (= (f17 (f23 f29 ?v0) ?v0) (f12 (f13 f14 ?v0) (f15 f16 2)))))
(assert (forall ((?v0 S6)) (= (f21 (f31 f32 ?v0) ?v0) (f6 (f7 f8 ?v0) (f15 f16 2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (+ (f12 f20 ?v1) 1))) (f17 (f23 f29 ?v0) (f12 ?v_0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f15 f16 (+ (f12 f20 ?v1) 1))) (f21 (f31 f32 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (+ (f12 f20 ?v1) 1))) (f17 (f23 f29 ?v0) (f12 ?v_0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f15 f16 (+ (f12 f20 ?v1) 1))) (f21 (f31 f32 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (+ (f12 f20 ?v1) 1))) (f17 (f23 f29 (f12 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f15 f16 (+ (f12 f20 ?v1) 1))) (f21 (f31 f32 (f6 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int)) (= (f12 (f13 f14 ?v0) (f15 f16 2)) (f17 (f23 f29 ?v0) ?v0))))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f15 f16 2)) (f21 (f31 f32 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f12 (f13 f14 ?v0) (f15 f16 3)) (f17 (f23 f29 (f17 (f23 f29 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f15 f16 3)) (f21 (f31 f32 (f21 (f31 f32 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f13 f14 ?v0))) (= (f17 (f23 f29 ?v0) (f12 ?v_0 ?v1)) (f12 ?v_0 (f15 f16 (+ (f12 f20 ?v1) 1)))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f21 (f31 f32 ?v0) (f6 ?v_0 ?v1)) (f6 ?v_0 (f15 f16 (+ (f12 f20 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (+ (f12 f20 ?v1) (f12 f20 ?v2)))) (f17 (f23 f29 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f15 f16 (+ (f12 f20 ?v1) (f12 f20 ?v2)))) (f21 (f31 f32 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f13 f14 ?v0))) (= (f17 (f23 f29 (f12 ?v_0 ?v1)) ?v0) (f12 ?v_0 (f15 f16 (+ (f12 f20 ?v1) 1)))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f21 (f31 f32 (f6 ?v_0 ?v1)) ?v0) (f6 ?v_0 (f15 f16 (+ (f12 f20 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f12 (f13 f14 ?v0) ?v1))) (= (f17 (f23 f29 ?v_0) ?v0) (f17 (f23 f29 ?v0) ?v_0)))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f6 (f7 f8 ?v0) ?v1))) (= (f21 (f31 f32 ?v_0) ?v0) (f21 (f31 f32 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f12 (f13 f14 (f17 (f23 f29 ?v0) ?v1)) ?v2) (f17 (f23 f29 (f12 (f13 f14 ?v0) ?v2)) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S5)) (= (f6 (f7 f8 (f21 (f31 f32 ?v0) ?v1)) ?v2) (f21 (f31 f32 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f12 (f13 f14 (f17 (f23 f29 ?v0) ?v1)) ?v2) (f17 (f23 f29 (f12 (f13 f14 ?v0) ?v2)) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S5)) (= (f6 (f7 f8 (f21 (f31 f32 ?v0) ?v1)) ?v2) (f21 (f31 f32 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f13 f14 ?v0))) (= (f17 (f23 f29 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2)) (f12 ?v_0 (f15 f16 (+ (f12 f20 ?v1) (f12 f20 ?v2))))))))
(assert (forall ((?v0 S6) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f21 (f31 f32 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) (f6 ?v_0 (f15 f16 (+ (f12 f20 ?v1) (f12 f20 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 Int)) (let ((?v_0 (f12 f20 ?v0)) (?v_1 (f13 f14 ?v1))) (=> (< 0 ?v_0) (= (f17 (f23 f29 (f12 ?v_1 (f15 f16 (- ?v_0 1)))) ?v1) (f12 ?v_1 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S6)) (let ((?v_0 (f12 f20 ?v0)) (?v_1 (f7 f8 ?v1))) (=> (< 0 ?v_0) (= (f21 (f31 f32 (f6 ?v_1 (f15 f16 (- ?v_0 1)))) ?v1) (f6 ?v_1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (f17 (f23 f29 (f12 f20 ?v1)) (f12 f20 ?v2)))) (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f15 f16 (f17 (f23 f29 (f12 f20 ?v1)) (f12 f20 ?v2)))) (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (* 2 (f12 f20 ?v1)))) (f12 (f13 f14 (f12 ?v_0 ?v1)) (f15 f16 2))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f15 f16 (* 2 (f12 f20 ?v1)))) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f15 f16 2))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f15 f16 (f17 (f23 f29 (f12 f20 ?v1)) (f12 f20 ?v2))))))))
(assert (forall ((?v0 S6) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f15 f16 (f17 (f23 f29 (f12 f20 ?v1)) (f12 f20 ?v2))))))))
(assert (forall ((?v0 Int)) (= (= (f17 f30 ?v0) 0) (= ?v0 0))))
(assert (= (f17 f30 0) 0))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f13 f14 ?v0))) (let ((?v_1 (f12 ?v_0 ?v1))) (= (f12 ?v_0 (f15 f16 (* 2 (f12 f20 ?v1)))) (f17 (f23 f29 ?v_1) ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f15 f16 (* 2 (f12 f20 ?v1)))) (f21 (f31 f32 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f13 f14 ?v0))) (let ((?v_1 (f12 ?v_0 ?v1))) (= (f12 ?v_0 (f15 f16 (+ (* 2 (f12 f20 ?v1)) 1))) (f17 (f23 f29 ?v0) (f17 (f23 f29 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f15 f16 (+ (* 2 (f12 f20 ?v1)) 1))) (f21 (f31 f32 ?v0) (f21 (f31 f32 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (+ (* 2 (f12 f20 ?v1)) 1))) (f17 (f23 f29 ?v0) (f12 (f13 f14 (f12 ?v_0 ?v1)) (f15 f16 2)))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f15 f16 (+ (* 2 (f12 f20 ?v1)) 1))) (f21 (f31 f32 ?v0) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f15 f16 2)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f31 f32 ?v0))) (= (f21 (f31 f32 (f21 ?v_0 ?v1)) (f21 (f31 f32 ?v2) ?v3)) (f21 (f31 f32 (f21 ?v_0 ?v2)) (f21 (f31 f32 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f23 f29 ?v0))) (= (f17 (f23 f29 (f17 ?v_0 ?v1)) (f17 (f23 f29 ?v2) ?v3)) (f17 (f23 f29 (f17 ?v_0 ?v2)) (f17 (f23 f29 ?v1) ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_1 (f31 f32 (f21 (f31 f32 ?v0) ?v1))) (?v_0 (f31 f32 ?v2))) (= (f21 ?v_1 (f21 ?v_0 ?v3)) (f21 ?v_0 (f21 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f23 f29 (f17 (f23 f29 ?v0) ?v1))) (?v_0 (f23 f29 ?v2))) (= (f17 ?v_1 (f17 ?v_0 ?v3)) (f17 ?v_0 (f17 ?v_1 ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f31 f32 ?v0)) (?v_1 (f21 (f31 f32 ?v2) ?v3))) (= (f21 (f31 f32 (f21 ?v_0 ?v1)) ?v_1) (f21 ?v_0 (f21 (f31 f32 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f23 f29 ?v0)) (?v_1 (f17 (f23 f29 ?v2) ?v3))) (= (f17 (f23 f29 (f17 ?v_0 ?v1)) ?v_1) (f17 ?v_0 (f17 (f23 f29 ?v1) ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f31 f32 ?v0))) (= (f21 (f31 f32 (f21 ?v_0 ?v1)) ?v2) (f21 (f31 f32 (f21 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f29 ?v0))) (= (f17 (f23 f29 (f17 ?v_0 ?v1)) ?v2) (f17 (f23 f29 (f17 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f31 f32 ?v0))) (= (f21 (f31 f32 (f21 ?v_0 ?v1)) ?v2) (f21 ?v_0 (f21 (f31 f32 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f29 ?v0))) (= (f17 (f23 f29 (f17 ?v_0 ?v1)) ?v2) (f17 ?v_0 (f17 (f23 f29 ?v1) ?v2))))))
(assert (forall ((?v0 S5)) (= (f15 f16 (f12 f20 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f12 f20 (f15 f16 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f12 f20 (f15 f16 ?v0)) 0))))
(check-sat)
(exit)
