(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S4)
(declare-fun f4 (S5 S4) S2)
(declare-fun f5 () S5)
(declare-fun f6 (S6 S4) S4)
(declare-fun f7 (S7 S4) S6)
(declare-fun f8 () S7)
(declare-fun f9 () S4)
(declare-fun f10 () S2)
(declare-fun f11 () S3)
(declare-fun f12 () S3)
(declare-fun f13 (S8 S3) Int)
(declare-fun f14 () S8)
(declare-fun f15 (S9 Int) S8)
(declare-fun f16 () S9)
(declare-fun f17 (S10 Int) S3)
(declare-fun f18 () S10)
(declare-fun f19 (S11 Int) Int)
(declare-fun f20 () S11)
(declare-fun f21 (S12 Int) S11)
(declare-fun f22 () S12)
(declare-fun f23 () S4)
(declare-fun f24 () S7)
(assert (not (= f1 f2)))
(assert (not (not (= (f3 (f4 f5 (f6 (f7 f8 f9) (f3 f10 f11))) f12) f9))))
(assert (< 0 (f13 f14 f12)))
(assert (< (f13 f14 f12) (f13 f14 f11)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 (f3 f10 ?v0)) ?v0) f9)))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f7 f8 f9))) (= (f6 ?v_0 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 (f6 ?v_0 ?v0)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S3)) (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f3 (f4 f5 ?v0) ?v2)) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 S4)) (= (f6 (f7 f8 ?v0) f9) ?v0)))
(assert (forall ((?v0 S3)) (= (f13 (f15 f16 1) ?v0) 1)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f9) ?v0) f9)))
(assert (= (f13 (f15 f16 1) (f17 f18 2)) 1))
(assert (= (f3 (f4 f5 f9) (f17 f18 2)) f9))
(assert (forall ((?v0 Int)) (= (f13 (f15 f16 ?v0) (f17 f18 0)) 1)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f17 f18 0)) f9)))
(assert (forall ((?v0 Int)) (= (f13 (f15 f16 ?v0) (f17 f18 0)) 1)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f17 f18 0)) f9)))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f19 f20 (f13 (f15 f16 ?v0) ?v1)) (f13 (f15 f16 (f19 f20 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 (f15 f16 ?v0) (f17 f18 2)))) (= (f19 f20 ?v_0) ?v_0))))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f13 (f15 f16 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f13 (f15 f16 ?v0) (f17 f18 1)) ?v0)))
(assert (= (f19 f20 1) 1))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 2))) (= (f13 (f15 f16 (f19 f20 ?v0)) ?v_0) (f13 (f15 f16 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S4)) (= (= f9 ?v0) (= ?v0 f9))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f13 f14 ?v0))) (let ((?v_1 (f21 f22 ?v_0))) (=> (< 0 ?v_0) (= (f3 (f4 f5 (f3 f10 (f17 f18 (f19 ?v_1 (f13 f14 ?v1))))) (f17 f18 (f19 ?v_1 (f13 f14 ?v2)))) (f3 (f4 f5 (f3 f10 ?v1)) ?v2)))))))
(assert (forall ((?v0 S4) (?v1 S3) (?v2 S3)) (let ((?v_0 (f13 f14 ?v2)) (?v_1 (f13 f14 ?v1)) (?v_2 (f4 f5 ?v0))) (=> (not (= ?v0 f23)) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f17 f18 (- ?v_0 ?v_1))) (f6 (f7 f8 (f3 ?v_2 ?v2)) (f3 ?v_2 ?v1))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S3)) (=> (not (= ?v0 f23)) (= (f3 (f4 f5 (f6 (f7 f8 ?v1) ?v0)) ?v2) (f6 (f7 f8 (f3 (f4 f5 ?v1) ?v2)) (f3 (f4 f5 ?v0) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 f23)) (= (= (f6 (f7 f8 ?v1) ?v0) f9) (= ?v1 ?v0)))))
(assert (forall ((?v0 S4)) (=> (not (= ?v0 f23)) (= (f6 (f7 f8 ?v0) ?v0) f9))))
(assert (forall ((?v0 S4)) (= (f6 (f7 f8 ?v0) ?v0) (ite (= ?v0 f23) f23 f9))))
(assert (forall ((?v0 S3)) (= (f13 (f15 f16 0) ?v0) (ite (= ?v0 (f17 f18 0)) 1 0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f23) ?v0) (ite (= ?v0 (f17 f18 0)) f9 f23))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f15 f16 ?v2))) (=> (<= (f13 f14 ?v0) (f13 f14 ?v1)) (=> (<= 1 ?v2) (<= (f13 ?v_0 ?v0) (f13 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 1 ?v0) (<= 1 (f13 (f15 f16 ?v0) ?v1)))))
(assert (forall ((?v0 Int)) (<= 0 (f19 (f21 f22 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f13 (f15 f16 ?v0) (f17 f18 (* 2 (f13 f14 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f19 f20 (f19 (f21 f22 ?v0) ?v1)) (f19 (f21 f22 (f19 f20 ?v0)) (f19 f20 ?v1)))))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f24 f23) ?v0) f23)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f24 f23) ?v0) f23)))
(assert (forall ((?v0 S3)) (= (f17 f18 (f13 f14 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f13 f14 (f17 f18 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f13 f14 (f17 f18 ?v0)) 0))))
(check-sat)
(exit)
