(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) S5)
(declare-fun f7 (S6 S5) S4)
(declare-fun f8 () S6)
(declare-fun f9 () S6)
(declare-fun f10 (S7 S8) S5)
(declare-fun f11 (S9 S5) S7)
(declare-fun f12 () S9)
(declare-fun f13 () S5)
(declare-fun f14 () S7)
(declare-fun f15 () S8)
(declare-fun f16 () S8)
(declare-fun f17 () S5)
(declare-fun f18 (S10 S8) Int)
(declare-fun f19 () S10)
(declare-fun f20 (S11 Int) S8)
(declare-fun f21 () S11)
(declare-fun f22 (S12 Int) S10)
(declare-fun f23 () S12)
(declare-fun f24 () S2)
(declare-fun f25 () S3)
(declare-fun f26 () S3)
(declare-fun f27 () S6)
(declare-fun f28 () S3)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (- ?v0 ?v1))))
(assert (let ((?v_0 (f11 f12 (f6 (f7 f8 f13) (f10 f14 f15))))) (not (= (f6 (f7 f8 (f6 (f7 f9 (f10 (f11 f12 (f10 ?v_0 f15)) f16)) f13)) (f6 (f7 f9 (f10 ?v_0 f16)) f13)) f17))))
(assert (< 0 (f18 f19 f16)))
(assert (< (f18 f19 f16) (f18 f19 f15)))
(assert (let ((?v_1 (f11 f12 (f6 (f7 f8 f13) (f10 f14 f15))))) (let ((?v_0 (f10 ?v_1 f16))) (let ((?v_2 (f6 (f7 f9 ?v_0) f13))) (= (f6 (f7 f8 (f6 (f7 f9 (f10 (f11 f12 ?v_0) f15)) f13)) ?v_2) (f6 (f7 f8 (f6 (f7 f9 (f10 (f11 f12 (f10 ?v_1 f15)) f16)) f13)) ?v_2))))))
(assert (forall ((?v0 S8)) (not (= (f10 f14 ?v0) f17))))
(assert (forall ((?v0 S8)) (= (f10 (f11 f12 (f10 f14 ?v0)) ?v0) f13)))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f7 f8 f13))) (= (f6 ?v_0 (f10 (f11 f12 ?v0) ?v1)) (f10 (f11 f12 (f6 ?v_0 ?v0)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S8)) (=> (not (= ?v0 f17)) (= (f10 (f11 f12 (f6 (f7 f8 ?v1) ?v0)) ?v2) (f6 (f7 f8 (f10 (f11 f12 ?v1) ?v2)) (f10 (f11 f12 ?v0) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f18 f19 ?v2)) (?v_1 (f18 f19 ?v1)) (?v_2 (f11 f12 ?v0))) (=> (not (= ?v0 f17)) (=> (<= ?v_1 ?v_0) (= (f10 ?v_2 (f20 f21 (- ?v_0 ?v_1))) (f6 (f7 f8 (f10 ?v_2 ?v2)) (f10 ?v_2 ?v1))))))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) ?v0) (ite (= ?v0 f17) f17 f13))))
(assert (forall ((?v0 S5)) (=> (not (= ?v0 f17)) (= (f6 (f7 f8 ?v0) ?v0) f13))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 f17)) (= (= (f6 (f7 f8 ?v1) ?v0) f13) (= ?v1 ?v0)))))
(assert (forall ((?v0 S8)) (= (f10 (f11 f12 f17) ?v0) (ite (= ?v0 (f20 f21 0)) f13 f17))))
(assert (forall ((?v0 S8)) (= (f18 (f22 f23 0) ?v0) (ite (= ?v0 (f20 f21 0)) 1 0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S8)) (= (f10 (f11 f12 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f10 (f11 f12 ?v0) ?v2)) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f6 (f7 f8 (f6 (f7 f9 ?v0) ?v1)) ?v2) (f6 (f7 f9 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f6 (f7 f8 (f6 (f7 f9 ?v0) ?v1)) ?v2) (f6 (f7 f9 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) f13) ?v0)))
(assert (forall ((?v0 S8)) (= (f10 (f11 f12 f13) ?v0) f13)))
(assert (forall ((?v0 S8)) (= (f18 (f22 f23 1) ?v0) 1)))
(assert (= (f3 f24 1) 1))
(assert (forall ((?v0 Int)) (= (f18 (f22 f23 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S8)) (= (f3 f24 (f18 (f22 f23 ?v0) ?v1)) (f18 (f22 f23 (f3 f24 ?v0)) ?v1))))
(assert (not (= f17 f13)))
(assert (not (= 0 1)))
(assert (not (= f13 f17)))
(assert (not (= 1 0)))
(assert (forall ((?v0 S5) (?v1 S8)) (=> (not (= ?v0 f17)) (not (= (f10 (f11 f12 ?v0) ?v1) f17)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (not (= ?v0 0)) (not (= (f18 (f22 f23 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S5) (?v1 S8)) (= (= (f10 (f11 f12 ?v0) ?v1) f17) (and (= ?v0 f17) (not (= ?v1 (f20 f21 0)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (= (f18 (f22 f23 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f20 f21 0)))))))
(assert (forall ((?v0 S8)) (= (f10 (f11 f12 f17) (f20 f21 (+ (f18 f19 ?v0) 1))) f17)))
(assert (forall ((?v0 S8)) (= (f18 (f22 f23 0) (f20 f21 (+ (f18 f19 ?v0) 1))) 0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) f17) f17)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f17) ?v0) f17)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f17) ?v0) f17)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 ?v0) (f20 f21 0)) f13)))
(assert (forall ((?v0 Int)) (= (f18 (f22 f23 ?v0) (f20 f21 0)) 1)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 ?v0) (f20 f21 0)) f13)))
(assert (forall ((?v0 Int)) (= (f18 (f22 f23 ?v0) (f20 f21 0)) 1)))
(assert (= (f10 (f11 f12 f13) (f20 f21 2)) f13))
(assert (= (f18 (f22 f23 1) (f20 f21 2)) 1))
(assert (forall ((?v0 S5)) (= (= (f10 (f11 f12 ?v0) (f20 f21 2)) f17) (= ?v0 f17))))
(assert (forall ((?v0 Int)) (= (= (f18 (f22 f23 ?v0) (f20 f21 2)) 0) (= ?v0 0))))
(assert (= (f10 (f11 f12 f17) (f20 f21 2)) f17))
(assert (= (f18 (f22 f23 0) (f20 f21 2)) 0))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f9 ?v0) ?v1) f17) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0 ?v1) 0) (= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 ?v1) (= (f6 (f7 f9 ?v0) ?v1) f17))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f9 ?v0) ?v0) f17)))
(assert (forall ((?v0 Int)) (= (- ?v0 ?v0) 0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f9 ?v0) f17) ?v0)))
(assert (forall ((?v0 Int)) (= (- ?v0 0) ?v0)))
(assert (= (f3 f24 0) 0))
(assert (forall ((?v0 S5)) (= (= f17 ?v0) (= ?v0 f17))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= (f3 f24 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= f13 ?v0) (= ?v0 f13))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f24 (- ?v0 ?v1)) (f3 f24 (- ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f25 ?v0) ?v1) ?v2) (f3 (f4 f25 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f26 ?v0) ?v1) ?v2) (f3 (f4 f26 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f9 ?v0) ?v1) (f6 (f7 f9 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f18 (f22 f23 ?v0) (f20 f21 2)))) (= (f3 f24 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f18 (f22 f23 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f20 f21 2))) (= (f18 (f22 f23 (f3 f24 ?v0)) ?v_0) (f18 (f22 f23 ?v0) ?v_0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f22 f23 ?v2))) (=> (<= (f18 f19 ?v0) (f18 f19 ?v1)) (=> (<= 0 ?v2) (=> (<= ?v2 1) (<= (f18 ?v_0 ?v1) (f18 ?v_0 ?v0))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f17)) (= (f6 (f7 f9 ?v1) (f6 (f7 f8 ?v2) ?v0)) (f6 (f7 f8 (f6 (f7 f9 (f6 (f7 f27 ?v0) ?v1)) ?v2)) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f17)) (= (f6 (f7 f9 (f6 (f7 f8 ?v1) ?v0)) ?v2) (f6 (f7 f8 (f6 (f7 f9 ?v1) (f6 (f7 f27 ?v0) ?v2))) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (not (= ?v0 f17)) (=> (not (= ?v1 f17)) (= (f6 (f7 f9 (f6 (f7 f8 ?v2) ?v0)) (f6 (f7 f8 ?v3) ?v1)) (f6 (f7 f8 (f6 (f7 f9 (f6 (f7 f27 ?v2) ?v1)) (f6 (f7 f27 ?v3) ?v0))) (f6 (f7 f27 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f18 (f22 f23 ?v0) (f20 f21 (+ (f18 f19 ?v1) 1))) 1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f22 f23 ?v2))) (=> (< (f18 f19 ?v0) (f18 f19 ?v1)) (=> (< 0 ?v2) (=> (< ?v2 1) (< (f18 ?v_0 ?v1) (f18 ?v_0 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f18 ?v_0 (f20 f21 (+ (* 2 (f18 f19 ?v1)) 1))) (f3 (f4 f28 ?v0) (f18 (f22 f23 (f18 ?v_0 ?v1)) (f20 f21 2)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f20 f21 (+ (* 2 (f18 f19 ?v1)) 1))) (f6 (f7 f27 ?v0) (f10 (f11 f12 (f10 ?v_0 ?v1)) (f20 f21 2)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 f23 ?v0))) (let ((?v_1 (f18 ?v_0 ?v1))) (= (f18 ?v_0 (f20 f21 (+ (* 2 (f18 f19 ?v1)) 1))) (f3 (f4 f28 ?v0) (f3 (f4 f28 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f10 ?v_0 ?v1))) (= (f10 ?v_0 (f20 f21 (+ (* 2 (f18 f19 ?v1)) 1))) (f6 (f7 f27 ?v0) (f6 (f7 f27 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 f23 ?v0))) (let ((?v_1 (f18 ?v_0 ?v1))) (= (f18 ?v_0 (f20 f21 (* 2 (f18 f19 ?v1)))) (f3 (f4 f28 ?v_1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f10 ?v_0 ?v1))) (= (f10 ?v_0 (f20 f21 (* 2 (f18 f19 ?v1)))) (f6 (f7 f27 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f3 f24 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 (f7 f27 (f6 ?v_0 ?v1)) (f6 (f7 f27 ?v2) ?v3)) (f6 (f7 f27 (f6 ?v_0 ?v2)) (f6 (f7 f27 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f28 ?v0))) (= (f3 (f4 f28 (f3 ?v_0 ?v1)) (f3 (f4 f28 ?v2) ?v3)) (f3 (f4 f28 (f3 ?v_0 ?v2)) (f3 (f4 f28 ?v1) ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f7 f27 (f6 (f7 f27 ?v0) ?v1))) (?v_0 (f7 f27 ?v2))) (= (f6 ?v_1 (f6 ?v_0 ?v3)) (f6 ?v_0 (f6 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f4 f28 (f3 (f4 f28 ?v0) ?v1))) (?v_0 (f4 f28 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f27 ?v0)) (?v_1 (f6 (f7 f27 ?v2) ?v3))) (= (f6 (f7 f27 (f6 ?v_0 ?v1)) ?v_1) (f6 ?v_0 (f6 (f7 f27 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f28 ?v0)) (?v_1 (f3 (f4 f28 ?v2) ?v3))) (= (f3 (f4 f28 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f4 f28 ?v1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 (f7 f27 (f6 ?v_0 ?v1)) ?v2) (f6 (f7 f27 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v0))) (= (f3 (f4 f28 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f28 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 (f7 f27 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f27 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v0))) (= (f3 (f4 f28 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f28 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 (f7 f27 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f27 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v0))) (= (f3 (f4 f28 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f28 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 ?v_0 (f6 (f7 f27 ?v1) ?v2)) (f6 (f7 f27 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v0))) (= (f3 ?v_0 (f3 (f4 f28 ?v1) ?v2)) (f3 (f4 f28 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f7 f27 ?v0)) (?v_0 (f7 f27 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f4 f28 ?v0)) (?v_0 (f4 f28 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f27 ?v0) ?v1) (f6 (f7 f27 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f28 ?v0) ?v1) (f3 (f4 f28 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 f24 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f3 (f4 f25 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f3 (f4 f25 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f3 (f4 f26 ?v0) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f3 (f4 f26 ?v0) ?v1) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f3 (f4 f25 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f3 (f4 f26 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f3 (f4 f26 ?v1) ?v2)) (and (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f25 ?v0))) (<= (f3 ?v_0 (f3 (f4 f26 ?v1) ?v2)) (f3 (f4 f26 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f3 (f4 f25 ?v0) ?v1) ?v2) (and (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f26 ?v0))) (<= (f3 (f4 f25 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 (f4 f25 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f3 (f4 f25 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f3 (f4 f25 ?v2) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f3 (f4 f25 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f3 (f4 f25 ?v2) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f3 (f4 f26 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f3 (f4 f26 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f3 (f4 f26 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f3 (f4 f26 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f3 (f4 f25 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f3 (f4 f26 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f3 (f4 f25 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f3 (f4 f26 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f3 (f4 f26 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f3 (f4 f26 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f3 (f4 f25 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f3 (f4 f25 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f3 (f4 f25 ?v0) ?v2) (f3 (f4 f25 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f3 (f4 f26 ?v0) ?v2) (f3 (f4 f26 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 (f3 (f4 f26 ?v1) ?v2)) (=> (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) false)) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (f3 (f4 f25 ?v0) ?v1) ?v2) (=> (=> (<= ?v0 ?v2) (=> (<= ?v1 ?v2) false)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (f3 (f4 f28 ?v0) ?v1) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f3 f24 (f3 (f4 f28 ?v0) ?v1)) (f3 (f4 f28 (f3 f24 ?v0)) (f3 f24 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (f3 (f4 f28 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v0))) (=> (<= (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) (=> (< 0 ?v0) (<= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (f3 (f4 f28 ?v0) ?v1) (f3 (f4 f28 ?v2) ?v1)) (=> (< 0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v0))) (=> (< (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v0))) (=> (< (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (f3 (f4 f28 ?v0) ?v1) (f3 (f4 f28 ?v2) ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (f3 (f4 f28 ?v0) ?v1) (f3 (f4 f28 ?v2) ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f3 f24 ?v0)) (?v_1 (f3 f24 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (f3 (f4 f28 ?v_0) ?v_1) (f3 (f4 f28 ?v1) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (f3 (f4 f28 ?v0) ?v2) (f3 (f4 f28 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (f3 (f4 f28 ?v0) ?v2) (f3 (f4 f28 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v0) (=> (<= 0 ?v2) (< (f3 (f4 f28 ?v0) ?v2) (f3 (f4 f28 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (< 0 ?v2) (< (f3 (f4 f28 ?v0) ?v2) (f3 (f4 f28 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (< (f3 (f4 f28 ?v0) ?v2) (f3 (f4 f28 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v1) (=> (<= 0 ?v2) (< (f3 (f4 f28 ?v0) ?v2) (f3 (f4 f28 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v2))) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f3 ?v_0 ?v1) (f3 ?v_0 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f3 (f4 f28 ?v1) ?v2) (f3 (f4 f28 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v2))) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (f3 ?v_0 ?v1) (f3 ?v_0 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (f3 (f4 f28 ?v1) ?v2) (f3 (f4 f28 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f3 (f4 f28 ?v0) ?v2) (f3 (f4 f28 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f3 (f4 f28 ?v0) ?v2) (f3 (f4 f28 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (f3 (f4 f28 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (f3 (f4 f28 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (f3 (f4 f28 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f3 (f4 f28 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v0))) (=> (< ?v0 0) (= (<= (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) (<= ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v0))) (=> (< ?v0 0) (= (< (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) (< ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (f3 (f4 f28 ?v0) ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (f3 (f4 f28 ?v0) ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f3 (f4 f28 ?v1) ?v0) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f3 (f4 f28 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (f3 (f4 f28 ?v1) ?v0) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (f3 (f4 f28 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f3 (f4 f28 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (f3 (f4 f28 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (< 1 ?v1) (< 1 (f3 (f4 f28 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v0))) (=> (< 0 ?v0) (= (<= (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) (<= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v0))) (=> (< 0 ?v0) (= (< (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) (< ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f3 (f4 f28 (f3 f24 ?v1)) ?v0) (f3 f24 (f3 (f4 f28 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v0))) (= (< (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f3 (f4 f28 ?v0) ?v1) (f3 (f4 f28 ?v2) ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f3 (f4 f28 ?v0) ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f24 ?v0))) (= (f3 (f4 f28 ?v_0) ?v_0) (f3 (f4 f28 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (f3 (f4 f28 ?v0) ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f24 (f3 (f4 f28 ?v0) ?v1)) (f3 (f4 f28 (f3 f24 ?v0)) (f3 f24 ?v1)))))
(assert (forall ((?v0 Int)) (<= 0 (f3 (f4 f28 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (not (< (f3 (f4 f28 ?v0) ?v0) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (f3 (f4 f28 ?v1) ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (f3 (f4 f28 ?v0) ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int)) (=> (< (f18 (f22 f23 ?v0) ?v1) (f18 (f22 f23 ?v2) ?v1)) (=> (<= 0 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (=> (< ?v0 ?v1) (=> (<= 0 ?v0) (=> (< 0 (f18 f19 ?v2)) (< (f18 (f22 f23 ?v0) ?v2) (f18 (f22 f23 ?v1) ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f20 f21 2))) (=> (< (f18 (f22 f23 ?v0) ?v_0) (f18 (f22 f23 ?v1) ?v_0)) (=> (<= 0 ?v1) (< ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< ?v0 0) (< (f18 (f22 f23 ?v0) (f20 f21 (+ (* 2 (f18 f19 ?v1)) 1))) 0))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 0 (f18 (f22 f23 ?v0) (f20 f21 (+ (* 2 (f18 f19 ?v1)) 1)))) (<= 0 ?v0))))
(assert (forall ((?v0 Int) (?v1 S8)) (<= 0 (f18 (f22 f23 ?v0) (f20 f21 (* 2 (f18 f19 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f18 (f22 f23 ?v0) ?v1))) (=> (< 1 ?v0) (< ?v_0 (f3 (f4 f28 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (< 1 (f3 (f4 f28 ?v0) (f18 (f22 f23 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f22 f23 ?v0))) (=> (< 1 ?v0) (=> (<= (f18 ?v_0 ?v1) (f18 ?v_0 ?v2)) (<= (f18 f19 ?v1) (f18 f19 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f22 f23 ?v0))) (=> (< 1 ?v0) (= (<= (f18 ?v_0 ?v1) (f18 ?v_0 ?v2)) (<= (f18 f19 ?v1) (f18 f19 ?v2)))))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f3 f24 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (< 0 (f3 f24 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 Int)) (not (< (f3 f24 ?v0) 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f27 ?v0) ?v1) f17) (or (= ?v0 f17) (= ?v1 f17)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 (f4 f28 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 f17)) (=> (not (= ?v1 f17)) (not (= (f6 (f7 f27 ?v0) ?v1) f17))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (f3 (f4 f28 ?v0) ?v1) 0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f27 ?v0) ?v1) f17) (or (= ?v0 f17) (= ?v1 f17)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f28 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f27 ?v0) f17) f17)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f27 ?v0) f17) f17)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f27 ?v0) f17) f17)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f27 f17) ?v0) f17)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f27 f17) ?v0) f17)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f27 f17) ?v0) f17)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f27 ?v0) f17) f17)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f27 f17) ?v0) f17)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f24 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f3 f24 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (<= 0 (f3 f24 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (< ?v0 ?v1) (< ?v2 ?v3)))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f27 ?v0) f13) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f27 ?v0) f13) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f27 ?v0) f13) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f27 f13) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f27 f13) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f27 f13) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f6 (f7 f27 (f6 (f7 f9 ?v0) ?v1)) ?v2) (f6 (f7 f9 (f6 (f7 f27 ?v0) ?v2)) (f6 (f7 f27 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f6 (f7 f27 (f6 (f7 f9 ?v0) ?v1)) ?v2) (f6 (f7 f9 (f6 (f7 f27 ?v0) ?v2)) (f6 (f7 f27 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 ?v_0 (f6 (f7 f9 ?v1) ?v2)) (f6 (f7 f9 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 ?v_0 (f6 (f7 f9 ?v1) ?v2)) (f6 (f7 f9 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (<= ?v0 ?v1) (<= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f3 f24 ?v0) (f3 f24 ?v1)) (f3 f24 (- ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f3 f24 ?v0) (f3 f24 ?v1)) (f3 f24 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f3 f24 (- (f3 f24 ?v0) (f3 f24 ?v1))) (f3 f24 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f18 (f22 f23 (f3 (f4 f28 ?v0) ?v1)) ?v2) (f3 (f4 f28 (f18 (f22 f23 ?v0) ?v2)) (f18 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S8)) (= (f10 (f11 f12 (f6 (f7 f27 ?v0) ?v1)) ?v2) (f6 (f7 f27 (f10 (f11 f12 ?v0) ?v2)) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f18 (f22 f23 ?v0) ?v1))) (= (f3 (f4 f28 ?v_0) ?v0) (f3 (f4 f28 ?v0) ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f10 (f11 f12 ?v0) ?v1))) (= (f6 (f7 f27 ?v_0) ?v0) (f6 (f7 f27 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f18 ?v_0 (f20 f21 (+ (f18 f19 ?v1) (f18 f19 ?v2)))) (f3 (f4 f28 (f18 ?v_0 ?v1)) (f18 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f20 f21 (+ (f18 f19 ?v1) (f18 f19 ?v2)))) (f6 (f7 f27 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f18 ?v_0 (f20 f21 (+ (f18 f19 ?v1) 1))) (f3 (f4 f28 (f18 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f20 f21 (+ (f18 f19 ?v1) 1))) (f6 (f7 f27 (f10 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f18 ?v_0 (f20 f21 (+ (f18 f19 ?v1) 1))) (f3 (f4 f28 ?v0) (f18 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f20 f21 (+ (f18 f19 ?v1) 1))) (f6 (f7 f27 ?v0) (f10 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 (f4 f28 (f18 ?v_0 ?v1)) (f18 ?v_0 ?v2)) (f18 ?v_0 (f20 f21 (+ (f18 f19 ?v1) (f18 f19 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 (f7 f27 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2)) (f10 ?v_0 (f20 f21 (+ (f18 f19 ?v1) (f18 f19 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f18 (f22 f23 (f3 (f4 f28 ?v0) ?v1)) ?v2) (f3 (f4 f28 (f18 (f22 f23 ?v0) ?v2)) (f18 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S8)) (= (f10 (f11 f12 (f6 (f7 f27 ?v0) ?v1)) ?v2) (f6 (f7 f27 (f10 (f11 f12 ?v0) ?v2)) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 (f4 f28 (f18 ?v_0 ?v1)) ?v0) (f18 ?v_0 (f20 f21 (+ (f18 f19 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 (f7 f27 (f10 ?v_0 ?v1)) ?v0) (f10 ?v_0 (f20 f21 (+ (f18 f19 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 (f4 f28 ?v0) (f18 ?v_0 ?v1)) (f18 ?v_0 (f20 f21 (+ (f18 f19 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 (f7 f27 ?v0) (f10 ?v_0 ?v1)) (f10 ?v_0 (f20 f21 (+ (f18 f19 ?v1) 1)))))))
(assert (forall ((?v0 Int)) (= (f18 (f22 f23 ?v0) (f20 f21 3)) (f3 (f4 f28 (f3 (f4 f28 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 ?v0) (f20 f21 3)) (f6 (f7 f27 (f6 (f7 f27 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f18 (f22 f23 ?v0) (f20 f21 2)) (f3 (f4 f28 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 ?v0) (f20 f21 2)) (f6 (f7 f27 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f18 ?v_0 (f20 f21 (+ (f18 f19 ?v1) 1))) (f3 (f4 f28 ?v0) (f18 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f20 f21 (+ (f18 f19 ?v1) 1))) (f6 (f7 f27 ?v0) (f10 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f28 ?v0) ?v0) (f18 (f22 f23 ?v0) (f20 f21 2)))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f27 ?v0) ?v0) (f10 (f11 f12 ?v0) (f20 f21 2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (= (f6 (f7 f27 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 ?v2) ?v3)) (f6 (f7 f8 (f6 (f7 f27 ?v0) ?v2)) (f6 (f7 f27 ?v1) ?v3)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f18 ?v_0 (f20 f21 (f3 (f4 f28 (f18 f19 ?v1)) (f18 f19 ?v2)))) (f18 (f22 f23 (f18 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f20 f21 (f3 (f4 f28 (f18 f19 ?v1)) (f18 f19 ?v2)))) (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f18 (f22 f23 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f20 f21 (f3 (f4 f28 (f18 f19 ?v1)) (f18 f19 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f20 f21 (f3 (f4 f28 (f18 f19 ?v1)) (f18 f19 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f18 ?v_0 (f20 f21 (* 2 (f18 f19 ?v1)))) (f18 (f22 f23 (f18 ?v_0 ?v1)) (f20 f21 2))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f20 f21 (* 2 (f18 f19 ?v1)))) (f10 (f11 f12 (f10 ?v_0 ?v1)) (f20 f21 2))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f18 (f22 f23 ?v0) ?v1))) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f3 (f4 f28 ?v0) ?v_0) ?v_0))))))
(assert (forall ((?v0 S8)) (= (f20 f21 (f18 f19 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f18 f19 (f20 f21 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f18 f19 (f20 f21 ?v0)) 0))))
(check-sat)
(exit)
