(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S4)
(declare-fun f4 (S5 S4) S2)
(declare-fun f5 () S5)
(declare-fun f6 (S6 S4) S4)
(declare-fun f7 () S6)
(declare-fun f8 () S4)
(declare-fun f9 (S7 Int) S3)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S3) Int)
(declare-fun f12 () S8)
(declare-fun f13 () S3)
(declare-fun f14 () S3)
(declare-fun f15 (S9 S4) S6)
(declare-fun f16 () S9)
(declare-fun f17 () S4)
(declare-fun f18 (S10 Int) Int)
(declare-fun f19 () S10)
(declare-fun f20 (S11 Int) S8)
(declare-fun f21 () S11)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f4 f5 f8))) (not (= (f3 (f4 f5 (f6 f7 f8)) (f9 f10 (- (f11 f12 f13) (f11 f12 f14)))) (f6 (f15 f16 (f3 ?v_0 f14)) (f3 ?v_0 f13))))))
(assert (<= (f11 f12 f14) (f11 f12 f13)))
(assert (not (= f8 f17)))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f18 f19 (f11 (f20 f21 ?v0) ?v1)) (f11 (f20 f21 (f18 f19 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 (f20 f21 ?v0) (f9 f10 2)))) (= (f18 f19 ?v_0) ?v_0))))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f11 (f20 f21 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f11 (f20 f21 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (not (= ?v0 0)) (not (= (f11 (f20 f21 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S4) (?v1 S3)) (=> (not (= ?v0 f17)) (not (= (f3 (f4 f5 ?v0) ?v1) f17)))))
(assert (forall ((?v0 Int)) (= (= (f11 (f20 f21 ?v0) (f9 f10 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S4)) (= (= (f3 (f4 f5 ?v0) (f9 f10 2)) f17) (= ?v0 f17))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f11 (f20 f21 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f9 f10 0)))))))
(assert (forall ((?v0 S4) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f17) (and (= ?v0 f17) (not (= ?v1 (f9 f10 0)))))))
(assert (= (f11 (f20 f21 0) (f9 f10 2)) 0))
(assert (= (f3 (f4 f5 f17) (f9 f10 2)) f17))
(assert (forall ((?v0 S3)) (= (f11 (f20 f21 0) (f9 f10 (+ (f11 f12 ?v0) 1))) 0)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f17) (f9 f10 (+ (f11 f12 ?v0) 1))) f17)))
(assert (forall ((?v0 S4)) (= (f6 (f15 f16 f17) ?v0) f17)))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 f7 ?v0) (f6 f7 ?v1)) (=> (not (= ?v0 f17)) (=> (not (= ?v1 f17)) (= ?v0 ?v1))))))
(assert (forall ((?v0 S4)) (=> (= (f6 f7 ?v0) f17) (= ?v0 f17))))
(assert (forall ((?v0 S4)) (=> (not (= ?v0 f17)) (= (f6 f7 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 S4)) (=> (not (= ?v0 f17)) (not (= (f6 f7 ?v0) f17)))))
(assert (forall ((?v0 S4) (?v1 S3) (?v2 S3)) (let ((?v_0 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1)) (?v_2 (f4 f5 ?v0))) (=> (not (= ?v0 f17)) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f9 f10 (- ?v_0 ?v_1))) (f6 (f15 f16 (f3 ?v_2 ?v2)) (f3 ?v_2 ?v1))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S3)) (=> (not (= ?v0 f17)) (= (f3 (f4 f5 (f6 (f15 f16 ?v1) ?v0)) ?v2) (f6 (f15 f16 (f3 (f4 f5 ?v1) ?v2)) (f3 (f4 f5 ?v0) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S3)) (=> (not (= ?v0 f17)) (= (f6 f7 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 (f6 f7 ?v0)) ?v1)))))
(assert (forall ((?v0 S3)) (= (f9 f10 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
