(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S4) S2)
(declare-fun f4 (S5 S2) S3)
(declare-fun f5 () S5)
(declare-fun f6 (S6 Int) S4)
(declare-fun f7 () S6)
(declare-fun f8 () S2)
(declare-fun f9 (S7 S2) S2)
(declare-fun f10 (S8 S2) S7)
(declare-fun f11 () S8)
(declare-fun f12 () S8)
(declare-fun f13 () S7)
(declare-fun f14 () S2)
(declare-fun f15 () S2)
(declare-fun f16 (S9 S4) Int)
(declare-fun f17 () S9)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f5 ?v0) (f6 f7 0)) f8)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f9 (f10 f11 ?v0) ?v1) (f9 (f10 f12 ?v0) (f9 f13 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f9 (f10 f12 ?v0) ?v1) (f9 (f10 f12 ?v1) ?v0))))
(assert (forall ((?v0 S2)) (= (f9 (f10 f12 ?v0) f8) ?v0)))
(assert (not (= f14 f15)))
(assert (forall ((?v0 S2) (?v1 S4)) (=> (not (= ?v0 f15)) (= (f9 f13 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 (f9 f13 ?v0)) ?v1)))))
(assert (not (forall ((?v0 S4)) (let ((?v_0 (f16 f17 ?v0)) (?v_1 (f4 f5 f14))) (=> (<= 0 ?v_0) (= (f3 (f4 f5 (f9 f13 f14)) (f6 f7 (- ?v_0 0))) (f9 (f10 f11 (f3 ?v_1 (f6 f7 0))) (f3 ?v_1 ?v0))))))))
(assert (forall ((?v0 S4)) (= (f6 f7 (f16 f17 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f16 f17 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f16 f17 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
