(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) S5)
(declare-fun f7 (S6 S5) S4)
(declare-fun f8 () S6)
(declare-fun f9 (S7 S8) S5)
(declare-fun f10 (S9 S5) S7)
(declare-fun f11 () S9)
(declare-fun f12 () S5)
(declare-fun f13 () S8)
(declare-fun f14 () S8)
(declare-fun f15 (S10 S8) Int)
(declare-fun f16 () S10)
(declare-fun f17 (S11 Int) S8)
(declare-fun f18 () S11)
(declare-fun f19 () S5)
(declare-fun f20 () S5)
(declare-fun f21 (S12 Int) S10)
(declare-fun f22 () S12)
(declare-fun f23 (S13 Int) Int)
(declare-fun f24 () S13)
(declare-fun f25 () S4)
(declare-fun f26 (S14 Int) S13)
(declare-fun f27 () S14)
(declare-fun f28 () S14)
(declare-fun f29 (S15 S3) S14)
(declare-fun f30 () S15)
(declare-fun f31 () S15)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (<= ?v0 ?v1))))
(assert (let ((?v_0 (f10 f11 f12)) (?v_1 (f15 f16 f13)) (?v_2 (f15 f16 f14))) (not (= (f6 (f7 f8 (f9 ?v_0 f13)) (f9 ?v_0 f14)) (ite (<= ?v_2 ?v_1) (f9 ?v_0 (f17 f18 (- ?v_1 ?v_2))) (f9 (f10 f11 (f6 (f7 f8 f19) f12)) (f17 f18 (- ?v_2 ?v_1))))))))
(assert (not (= f12 f20)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) f19) ?v0)))
(assert (forall ((?v0 S8)) (= (f9 (f10 f11 f19) ?v0) f19)))
(assert (forall ((?v0 S8)) (= (f15 (f21 f22 1) ?v0) 1)))
(assert (= (f9 (f10 f11 f19) (f17 f18 2)) f19))
(assert (= (f15 (f21 f22 1) (f17 f18 2)) 1))
(assert (forall ((?v0 S5)) (= (f9 (f10 f11 ?v0) (f17 f18 0)) f19)))
(assert (forall ((?v0 Int)) (= (f15 (f21 f22 ?v0) (f17 f18 0)) 1)))
(assert (forall ((?v0 S5)) (= (f9 (f10 f11 ?v0) (f17 f18 0)) f19)))
(assert (forall ((?v0 Int)) (= (f15 (f21 f22 ?v0) (f17 f18 0)) 1)))
(assert (forall ((?v0 Int) (?v1 S8)) (= (f23 f24 (f15 (f21 f22 ?v0) ?v1)) (f15 (f21 f22 (f23 f24 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 (f21 f22 ?v0) (f17 f18 2)))) (= (f23 f24 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f15 (f21 f22 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f9 (f10 f11 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f15 (f21 f22 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f9 (f10 f11 ?v0) (f17 f18 1)) ?v0)))
(assert (not (= f20 f19)))
(assert (not (= 0 1)))
(assert (not (= f19 f20)))
(assert (not (= 1 0)))
(assert (forall ((?v0 S5) (?v1 S8)) (=> (not (= ?v0 f20)) (not (= (f9 (f10 f11 ?v0) ?v1) f20)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (not (= ?v0 0)) (not (= (f15 (f21 f22 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S5)) (= (= (f9 (f10 f11 ?v0) (f17 f18 2)) f20) (= ?v0 f20))))
(assert (forall ((?v0 Int)) (= (= (f15 (f21 f22 ?v0) (f17 f18 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S5) (?v1 S8)) (= (= (f9 (f10 f11 ?v0) ?v1) f20) (and (= ?v0 f20) (not (= ?v1 (f17 f18 0)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (= (f15 (f21 f22 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f17 f18 0)))))))
(assert (= (f9 (f10 f11 f20) (f17 f18 2)) f20))
(assert (= (f15 (f21 f22 0) (f17 f18 2)) 0))
(assert (forall ((?v0 S8)) (= (f9 (f10 f11 f20) (f17 f18 (+ (f15 f16 ?v0) 1))) f20)))
(assert (forall ((?v0 S8)) (= (f15 (f21 f22 0) (f17 f18 (+ (f15 f16 ?v0) 1))) 0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f20) ?v0) f20)))
(assert (forall ((?v0 S8)) (= (f9 (f10 f11 f20) ?v0) (ite (= ?v0 (f17 f18 0)) f19 f20))))
(assert (forall ((?v0 S8)) (= (f15 (f21 f22 0) ?v0) (ite (= ?v0 (f17 f18 0)) 1 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 f20)) (= (= (f6 (f7 f8 ?v1) ?v0) f19) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5)) (=> (not (= ?v0 f20)) (= (f6 (f7 f8 ?v0) ?v0) f19))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f15 f16 ?v2)) (?v_1 (f15 f16 ?v1)) (?v_2 (f10 f11 ?v0))) (=> (not (= ?v0 f20)) (=> (<= ?v_1 ?v_0) (= (f9 ?v_2 (f17 f18 (- ?v_0 ?v_1))) (f6 (f7 f8 (f9 ?v_2 ?v2)) (f9 ?v_2 ?v1))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S8)) (=> (not (= ?v0 f20)) (= (f9 (f10 f11 (f6 (f7 f8 ?v1) ?v0)) ?v2) (f6 (f7 f8 (f9 (f10 f11 ?v1) ?v2)) (f9 (f10 f11 ?v0) ?v2))))))
(assert (= (f23 f24 1) 1))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 2))) (= (f15 (f21 f22 (f23 f24 ?v0)) ?v_0) (f15 (f21 f22 ?v0) ?v_0)))))
(assert (forall ((?v0 S5)) (= (= f19 ?v0) (= ?v0 f19))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (= (f23 f24 0) 0))
(assert (forall ((?v0 S5)) (= (= f20 ?v0) (= ?v0 f20))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= (f23 f24 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f21 f22 ?v2))) (=> (<= (f15 f16 ?v0) (f15 f16 ?v1)) (=> (<= 0 ?v2) (=> (<= ?v2 1) (<= (f15 ?v_0 ?v1) (f15 ?v_0 ?v0))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f21 f22 ?v2))) (=> (< (f15 f16 ?v0) (f15 f16 ?v1)) (=> (< 0 ?v2) (=> (< ?v2 1) (< (f15 ?v_0 ?v1) (f15 ?v_0 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f15 (f21 f22 ?v0) (f17 f18 (+ (f15 f16 ?v1) 1))) 1)))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f15 f16 ?v2)) (?v_1 (f15 f16 ?v1)) (?v_2 (f10 f11 ?v0))) (=> (not (= ?v0 f20)) (=> (<= ?v_1 ?v_0) (= (f9 (f10 f11 (f6 f25 ?v0)) (f17 f18 (- ?v_0 ?v_1))) (f6 (f7 f8 (f9 ?v_2 ?v1)) (f9 ?v_2 ?v2))))))))
(assert (forall ((?v0 S5)) (=> (not (= ?v0 f20)) (= (f6 f25 ?v0) (f6 (f7 f8 f19) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f21 f22 ?v2))) (=> (<= (f15 f16 ?v0) (f15 f16 ?v1)) (=> (<= 1 ?v2) (<= (f15 ?v_0 ?v0) (f15 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f23 f24 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f23 f24 ?v0))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f23 f24 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (< 0 (f23 f24 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 Int)) (not (< (f23 f24 ?v0) 0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f23 f24 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f23 f24 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (<= 0 (f23 f24 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 2))) (=> (< (f15 (f21 f22 ?v0) ?v_0) (f15 (f21 f22 ?v1) ?v_0)) (=> (<= 0 ?v1) (< ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int)) (=> (< (f15 (f21 f22 ?v0) ?v1) (f15 (f21 f22 ?v2) ?v1)) (=> (<= 0 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (=> (< ?v0 ?v1) (=> (<= 0 ?v0) (=> (< 0 (f15 f16 ?v2)) (< (f15 (f21 f22 ?v0) ?v2) (f15 (f21 f22 ?v1) ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (=> (< 1 ?v0) (= (<= (f15 ?v_0 ?v1) (f15 ?v_0 ?v2)) (<= (f15 f16 ?v1) (f15 f16 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (=> (< 1 ?v0) (=> (<= (f15 ?v_0 ?v1) (f15 ?v_0 ?v2)) (<= (f15 f16 ?v1) (f15 f16 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 f25 ?v0) (f6 f25 ?v1)) (=> (not (= ?v0 f20)) (=> (not (= ?v1 f20)) (= ?v0 ?v1))))))
(assert (forall ((?v0 S5)) (=> (= (f6 f25 ?v0) f20) (= ?v0 f20))))
(assert (forall ((?v0 S5)) (=> (not (= ?v0 f20)) (= (f6 f25 (f6 f25 ?v0)) ?v0))))
(assert (forall ((?v0 S5)) (=> (not (= ?v0 f20)) (not (= (f6 f25 ?v0) f20)))))
(assert (= (f6 f25 f19) f19))
(assert (forall ((?v0 S5) (?v1 S8)) (=> (not (= ?v0 f20)) (= (f6 f25 (f9 (f10 f11 ?v0) ?v1)) (f9 (f10 f11 (f6 f25 ?v0)) ?v1)))))
(assert (forall ((?v0 S5)) (= (f6 f25 ?v0) (f6 (f7 f8 f19) ?v0))))
(assert (forall ((?v0 S5)) (= (f6 f25 ?v0) (f6 (f7 f8 f19) ?v0))))
(assert (< 0 1))
(assert (not (< 1 0)))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 0 ?v0) (< 0 (f15 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 Int)) (= (< 0 (f15 (f21 f22 ?v0) (f17 f18 2))) (not (= ?v0 0)))))
(assert (forall ((?v0 Int)) (not (< (f15 (f21 f22 ?v0) (f17 f18 2)) 0))))
(assert (<= 0 1))
(assert (not (<= 1 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 2))) (=> (= (f15 (f21 f22 ?v0) ?v_0) (f15 (f21 f22 ?v1) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 2))) (=> (<= (f15 (f21 f22 ?v0) ?v_0) (f15 (f21 f22 ?v1) ?v_0)) (=> (<= 0 ?v1) (<= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int)) (let ((?v_0 (f17 f18 (+ (f15 f16 ?v1) 1)))) (=> (= (f15 (f21 f22 ?v0) ?v_0) (f15 (f21 f22 ?v2) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int)) (let ((?v_0 (f17 f18 (+ (f15 f16 ?v1) 1)))) (=> (<= (f15 (f21 f22 ?v0) ?v_0) (f15 (f21 f22 ?v2) ?v_0)) (=> (<= 0 ?v2) (<= ?v0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int)) (=> (= (f15 (f21 f22 ?v0) ?v1) (f15 (f21 f22 ?v2) ?v1)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (=> (< 0 (f15 f16 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v0) (<= (f15 (f21 f22 ?v0) ?v2) (f15 (f21 f22 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 0 ?v0) (<= 0 (f15 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (<= 0 (f15 (f21 f22 (f23 f24 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= 0 (f15 (f21 f22 ?v0) (f17 f18 2)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (< 1 (f15 (f21 f22 ?v0) (f17 f18 (+ (f15 f16 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (=> (< 1 ?v0) (= (= (f15 ?v_0 ?v1) (f15 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (=> (< 1 ?v0) (= (< (f15 ?v_0 ?v1) (f15 ?v_0 ?v2)) (< (f15 f16 ?v1) (f15 f16 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (=> (< 0 (f15 f16 ?v1)) (< 1 (f15 (f21 f22 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (=> (< 1 ?v0) (=> (< (f15 ?v_0 ?v1) (f15 ?v_0 ?v2)) (< (f15 f16 ?v1) (f15 f16 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f21 f22 ?v2))) (=> (< (f15 f16 ?v0) (f15 f16 ?v1)) (=> (< 1 ?v2) (< (f15 ?v_0 ?v0) (f15 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 1 ?v0) (<= 1 (f15 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 0 ?v0) (=> (<= ?v0 1) (<= (f15 (f21 f22 ?v0) (f17 f18 (+ (f15 f16 ?v1) 1))) ?v0)))))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f23 (f26 f27 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f23 (f26 f28 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f23 (f26 f27 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f23 (f26 f28 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f23 (f26 f27 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f23 (f26 f28 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 S13) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f23 ?v1 ?v2)) (=> (< ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f23 ?v1 ?v5) (f23 ?v1 ?v4)))) (< (f23 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S13) (?v3 Int)) (=> (< ?v0 ?v1) (=> (= (f23 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f23 ?v2 ?v5) (f23 ?v2 ?v4)))) (< ?v3 (f23 ?v2 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f23 (f26 f27 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f23 (f26 f27 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 S13) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f23 ?v1 ?v2)) (=> (<= ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f23 ?v1 ?v5) (f23 ?v1 ?v4)))) (<= (f23 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f23 (f26 f28 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f23 (f26 f28 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S13) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (= (f23 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f23 ?v2 ?v5) (f23 ?v2 ?v4)))) (<= ?v3 (f23 ?v2 ?v1)))))))
(assert (= f28 (f29 f30 f5)))
(assert (= f27 (f29 f31 f5)))
(assert (forall ((?v0 S8)) (= (f17 f18 (f15 f16 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f15 f16 (f17 f18 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f15 f16 (f17 f18 ?v0)) 0))))
(check-sat)
(exit)
