(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S2)
(declare-fun f4 (S4 S3) Int)
(declare-fun f5 () S4)
(declare-fun f6 (S5 S3) S2)
(declare-fun f7 (S6 S2) S5)
(declare-fun f8 () S6)
(declare-fun f9 (S7 S2) S2)
(declare-fun f10 () S7)
(declare-fun f11 (S8 Int) S3)
(declare-fun f12 () S8)
(declare-fun f13 (S9 S2) S7)
(declare-fun f14 () S9)
(declare-fun f15 (S10 Int) S4)
(declare-fun f16 () S10)
(declare-fun f17 () S2)
(declare-fun f18 () S2)
(declare-fun f19 () S3)
(declare-fun f20 () S3)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2)) (?v_1 (f4 f5 ?v1)) (?v_2 (f7 f8 ?v0))) (=> (not (= ?v0 f3)) (=> (<= ?v_1 ?v_0) (= (f6 (f7 f8 (f9 f10 ?v0)) (f11 f12 (- ?v_0 ?v_1))) (f9 (f13 f14 (f6 ?v_2 ?v1)) (f6 ?v_2 ?v2))))))))
(assert (forall ((?v0 Int)) (= (f4 (f15 f16 ?v0) (f11 f12 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f6 (f7 f8 ?v0) (f11 f12 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f6 (f7 f8 ?v0) (f11 f12 0)) f17)))
(assert (forall ((?v0 Int)) (= (f4 (f15 f16 ?v0) (f11 f12 0)) 1)))
(assert (let ((?v_2 (f4 f5 f20)) (?v_3 (f4 f5 f19))) (let ((?v_1 (<= ?v_3 ?v_2)) (?v_0 (f7 f8 f18))) (not (=> (not (= f18 f3)) (=> (not ?v_1) (= (f9 (f13 f14 (f6 ?v_0 f20)) (f6 ?v_0 f19)) (ite ?v_1 (f6 ?v_0 (f11 f12 (- ?v_2 ?v_3))) (f6 (f7 f8 (f9 (f13 f14 f17) f18)) (f11 f12 (- ?v_3 ?v_2)))))))))))
(assert (forall ((?v0 S3)) (= (f11 f12 (f4 f5 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f4 f5 (f11 f12 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f4 f5 (f11 f12 ?v0)) 0))))
(check-sat)
(exit)
