(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S4)
(declare-fun f4 () S3)
(declare-fun f5 (S2) S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 S2) Int)
(declare-fun f9 () S6)
(declare-fun f10 () S3)
(declare-fun f11 (S4 S4) S4)
(declare-fun f12 (S7 S3) S3)
(declare-fun f13 (S2) S7)
(declare-fun f14 (S8 S2) S2)
(declare-fun f15 (S9 S2) S8)
(declare-fun f16 () S9)
(declare-fun f17 () S2)
(declare-fun f18 () S2)
(declare-fun f19 (S4 S4) S4)
(declare-fun f20 (S4) S3)
(declare-fun f21 (S2) S4)
(declare-fun f22 (S2) S7)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 f4 ?v0) (f5 (f6 f7 (+ (* 2 (f8 f9 ?v0)) 1))))))
(assert (forall ((?v0 S2)) (= (f3 f10 ?v0) (f5 (f6 f7 (* 2 (f8 f9 ?v0)))))))
(assert (let ((?v_0 (f14 (f15 f16 (f6 f7 2)) f17))) (let ((?v_3 (f13 ?v_0)) (?v_1 (f8 f9 ?v_0))) (let ((?v_2 (f6 f7 (- (f8 f9 f18) ?v_1)))) (let ((?v_4 (f3 (f20 (f21 (f6 f7 (* 2 ?v_1)))) ?v_2)) (?v_5 (f22 f17))) (not (= (f11 (f3 (f12 ?v_3 f10) ?v_2) (f19 ?v_4 (f3 (f12 ?v_3 f4) ?v_2))) (f11 (f3 (f12 ?v_5 f10) ?v_2) (f19 ?v_4 (f3 (f12 ?v_5 f4) ?v_2))))))))))
(assert (not (< (f8 f9 f18) (f8 f9 (f14 (f15 f16 (f6 f7 2)) f17)))))
(assert (< (f8 f9 f18) (* 2 (f8 f9 (f14 (f15 f16 (f6 f7 2)) f17)))))
(assert (let ((?v_0 (f8 f9 (f14 (f15 f16 (f6 f7 2)) f17)))) (< (f8 f9 (f6 f7 (- (f8 f9 f18) ?v_0))) ?v_0)))
(assert (let ((?v_0 (f8 f9 (f14 (f15 f16 (f6 f7 2)) f17)))) (< (f8 f9 (f6 f7 (- (f8 f9 f18) ?v_0))) ?v_0)))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f14 (f15 f16 (f6 f7 2)) f17))) (=> (< (f8 f9 ?v0) (f8 f9 ?v_0)) (= (f3 (f12 (f13 ?v_0) ?v1) ?v0) (f3 (f12 (f22 f17) ?v1) ?v0))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
