(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S2) S1)
(declare-fun f4 () S2)
(declare-fun f5 () S2)
(declare-fun f6 () S2)
(declare-fun f7 (S3 S2) S2)
(declare-fun f8 (S4 S2) S3)
(declare-fun f9 () S4)
(declare-fun f10 () S2)
(declare-fun f11 () S3)
(declare-fun f12 () S5)
(declare-fun f13 () S5)
(declare-fun f14 (S6 Int) Int)
(declare-fun f15 () S6)
(declare-fun f16 () S5)
(declare-fun f17 () S2)
(declare-fun f18 (S7 S5) S5)
(declare-fun f19 (S8 S5) S7)
(declare-fun f20 () S8)
(declare-fun f21 () S4)
(declare-fun f22 (S9 Int) S6)
(declare-fun f23 () S9)
(declare-fun f24 () S4)
(declare-fun f25 () S9)
(assert (not (= f1 f2)))
(assert (not (= (f3 f4 f5) f1)))
(assert (= (f3 f6 (f7 (f8 f9 f5) f10)) f1))
(assert (= (f3 (f7 (f8 f9 (f7 f11 f4)) f10) f6) f1))
(assert (not (= f12 f13)))
(assert (forall ((?v0 S2)) (= (f3 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v2))) (=> (= (f3 ?v0 ?v1) f1) (= (f3 (f7 ?v_0 ?v0) (f7 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f7 f11 (f7 (f8 f9 ?v0) ?v1)) (f7 (f8 f9 (f7 f11 ?v0)) (f7 f11 ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f14 f15 (+ ?v0 ?v1)) (+ (f14 f15 ?v0) (f14 f15 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f3 (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v2) ?v1)) f1) (= (f3 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (= (f3 (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (= (f3 (f7 (f8 f9 ?v0) ?v2) (f7 (f8 f9 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v2))) (=> (= (f3 ?v0 ?v1) f1) (= (f3 (f7 ?v_0 ?v0) (f7 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v2 ?v3) f1) (= (f3 (f7 (f8 f9 ?v0) ?v2) (f7 (f8 f9 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v2) ?v1)) f1) (= (f3 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f3 (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S2)) (= (f3 ?v0 ?v0) f1)))
(assert (not (not (= f16 f13))))
(assert (= (f7 f11 f17) f17))
(assert (= (f14 f15 0) 0))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= f13 ?v0) (= ?v0 f13))))
(assert (forall ((?v0 S2)) (= (= f17 ?v0) (= ?v0 f17))))
(assert (forall ((?v0 S2)) (= (= (f7 f11 ?v0) f17) (= ?v0 f17))))
(assert (forall ((?v0 Int)) (= (= (f14 f15 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (=> (= (f3 f17 ?v0) f1) (= (f7 f11 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f14 f15 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (= (f3 (f7 f11 ?v0) f17) f1) (= ?v0 f17))))
(assert (forall ((?v0 Int)) (= (<= (f14 f15 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (f3 f17 (f7 f11 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= 0 (f14 f15 ?v0))))
(assert (forall ((?v0 S2)) (= (f7 (f8 f9 ?v0) f17) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S5)) (= (f18 (f19 f20 ?v0) f13) ?v0)))
(assert (forall ((?v0 S2)) (= (f7 (f8 f9 ?v0) f17) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S5)) (= (f18 (f19 f20 ?v0) f13) ?v0)))
(assert (forall ((?v0 S2)) (= (= f17 (f7 (f8 f9 ?v0) ?v0)) (= ?v0 f17))))
(assert (forall ((?v0 Int)) (= (= 0 (+ ?v0 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (f7 (f8 f9 f17) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f18 (f19 f20 f13) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f7 (f8 f9 f17) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f18 (f19 f20 f13) ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 f17) f1) (=> (= (f3 ?v1 f17) f1) (= (f3 (f7 (f8 f9 ?v0) ?v1) f17) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 f17 ?v0) f1) (=> (= (f3 ?v1 ?v2) f1) (= (f3 ?v1 (f7 (f8 f9 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v2 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 f17 ?v0) f1) (=> (= (f3 ?v1 ?v2) f1) (= (f3 ?v1 (f7 (f8 f9 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 f17 ?v0) f1) (=> (= (f3 f17 ?v1) f1) (= (= (f7 (f8 f9 ?v0) ?v1) f17) (and (= ?v0 f17) (= ?v1 f17)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (+ ?v0 ?v1) 0) (and (= ?v0 0) (= ?v1 0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 f17 ?v0) f1) (=> (= (f3 f17 ?v1) f1) (= (f3 f17 (f7 (f8 f9 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S2)) (= (= (f3 (f7 (f8 f9 ?v0) ?v0) f17) f1) (= (f3 ?v0 f17) f1))))
(assert (forall ((?v0 Int)) (= (<= (+ ?v0 ?v0) 0) (<= ?v0 0))))
(assert (forall ((?v0 S2)) (= (= (f3 f17 (f7 (f8 f9 ?v0) ?v0)) f1) (= (f3 f17 ?v0) f1))))
(assert (forall ((?v0 Int)) (= (<= 0 (+ ?v0 ?v0)) (<= 0 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (=> (= (f3 ?v0 ?v1) f1) false) (=> (=> (= (f3 ?v1 ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f7 f11 ?v0) ?v1) f1) (= (f3 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f14 f15 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v2 ?v0) f1) (= (f3 ?v2 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 ?v2) f1) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= ?v0 ?v2) (= (f3 ?v2 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= ?v0 ?v1) (=> (= (f3 ?v2 ?v1) f1) (= (f3 ?v2 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= ?v0 ?v1) (=> (= (f3 ?v1 ?v2) f1) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 ?v1) f1) (= (= (f3 ?v1 ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 ?v1) (= (f3 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f3 (f7 (f8 f21 ?v0) ?v1) ?v2) f1) (or (= (f3 ?v0 ?v2) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f14 (f22 f23 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f3 ?v0 (f7 (f8 f24 ?v1) ?v2)) f1) (or (= (f3 ?v0 ?v1) f1) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f14 (f22 f25 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= ?v0 ?v1) (and (= (f3 ?v0 ?v1) f1) (= (f3 ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (or (= (f3 ?v0 ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S2)) (= (f3 ?v0 (f7 f11 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 (f14 f15 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f18 (f19 f20 ?v0) ?v1) (f18 (f19 f20 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f19 f20 ?v0))) (=> (= (f18 ?v_0 ?v1) (f18 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f19 f20 ?v0))) (=> (= (f18 ?v_0 ?v1) (f18 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f18 (f19 f20 ?v0) ?v1) (f18 (f19 f20 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f19 f20 ?v0))) (= (= (f18 ?v_0 ?v1) (f18 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f7 (f8 f9 (f7 (f8 f21 ?v0) ?v1)) ?v2) (f7 (f8 f21 (f7 (f8 f9 ?v0) ?v2)) (f7 (f8 f9 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f14 (f22 f23 ?v0) ?v1) ?v2) (f14 (f22 f23 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f7 (f8 f9 (f7 (f8 f24 ?v0) ?v1)) ?v2) (f7 (f8 f24 (f7 (f8 f9 ?v0) ?v2)) (f7 (f8 f9 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f14 (f22 f25 ?v0) ?v1) ?v2) (f14 (f22 f25 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f7 (f8 f9 (f7 f11 ?v0)) (f7 f11 ?v1)))) (= (f7 f11 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f14 f15 ?v0) (f14 f15 ?v1)))) (= (f14 f15 ?v_0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 ?v2) f1) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (or (= (f3 ?v0 ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(check-sat)
(exit)
