(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S4)
(declare-fun f4 () S3)
(declare-fun f5 (S5 Int) S4)
(declare-fun f6 () S5)
(declare-fun f7 () S2)
(declare-fun f8 (S6 S4) Int)
(declare-fun f9 () S6)
(declare-fun f10 () S2)
(declare-fun f11 () S2)
(declare-fun f12 () S4)
(declare-fun f13 (S7 S2) S2)
(declare-fun f14 (S8 S9) S7)
(declare-fun f15 () S8)
(declare-fun f16 (S9) S9)
(declare-fun f17 (S2 S9) S9)
(declare-fun f18 () S2)
(declare-fun f19 () S9)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (= (f3 f4 ?v0) (f5 f6 0)) (= ?v0 f7))))
(assert (<= 2 (f8 f9 (f3 f4 f10))))
(assert (let ((?v_2 (f3 f4 f10)) (?v_3 (f8 f9 f12)) (?v_0 (f3 f4 (f13 (f14 f15 (f16 (f17 f18 f19))) f18))) (?v_1 (f3 f4 f18))) (not (=> (= (f5 f6 (+ (+ (f8 f9 (f3 f4 f11)) ?v_3) 1)) ?v_0) (=> (= ?v_0 ?v_1) (=> (= ?v_1 ?v_2) (=> (= ?v_2 (f5 f6 (+ ?v_3 1))) (= f11 f7))))))))
(assert (forall ((?v0 S4)) (= (f5 f6 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f5 f6 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f5 f6 ?v0)) 0))))
(check-sat)
(exit)
