(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 S6) S2)
(declare-fun f7 (S7 S2) S5)
(declare-fun f8 () S7)
(declare-fun f9 (S8 Int) S6)
(declare-fun f10 () S8)
(declare-fun f11 (S9 S6) Int)
(declare-fun f12 () S9)
(declare-fun f13 () S6)
(declare-fun f14 () S2)
(declare-fun f15 () S2)
(declare-fun f16 (S10 S6) S11)
(declare-fun f17 () S10)
(declare-fun f18 (S11 S6) S6)
(declare-fun f19 () S10)
(declare-fun f20 (S12 Int) S13)
(declare-fun f21 () S12)
(declare-fun f22 (S13 Int) Int)
(declare-fun f23 (S14 Int) S9)
(declare-fun f24 () S14)
(declare-fun f25 () S13)
(assert (not (= f1 f2)))
(assert (not (exists ((?v0 S2) (?v1 S2)) (let ((?v_0 (f9 f10 (- (f11 f12 f13) (+ 0 1))))) (not (= (f3 (f4 f5 ?v0) (f6 (f7 f8 ?v0) ?v_0)) (f3 (f4 f5 ?v1) (f6 (f7 f8 ?v1) ?v_0))))))))
(assert (not (= f14 f15)))
(assert (not (= f13 (f9 f10 0))))
(assert (not (= f14 f15)))
(assert (forall ((?v0 S6)) (= (f18 (f16 f17 ?v0) ?v0) (f18 (f16 f19 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f5 ?v0) ?v0) (f6 (f7 f8 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 Int)) (= (f22 (f20 f21 ?v0) ?v0) (f11 (f23 f24 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f16 f19 ?v0))) (= (f18 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f18 (f16 f17 ?v0) (f18 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f3 (f4 f5 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f22 (f20 f21 ?v0) (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f16 f19 ?v0))) (= (f18 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f18 (f16 f17 ?v0) (f18 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f3 (f4 f5 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f22 (f20 f21 ?v0) (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f16 f19 ?v0))) (= (f18 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f18 (f16 f17 (f18 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f3 (f4 f5 (f6 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f22 (f20 f21 (f11 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S6)) (= (f18 (f16 f19 ?v0) (f9 f10 2)) (f18 (f16 f17 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (f6 (f7 f8 ?v0) (f9 f10 2)) (f3 (f4 f5 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f23 f24 ?v0) (f9 f10 2)) (f22 (f20 f21 ?v0) ?v0))))
(assert (forall ((?v0 S6)) (= (f18 (f16 f19 ?v0) (f9 f10 3)) (f18 (f16 f17 (f18 (f16 f17 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S2)) (= (f6 (f7 f8 ?v0) (f9 f10 3)) (f3 (f4 f5 (f3 (f4 f5 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f23 f24 ?v0) (f9 f10 3)) (f22 (f20 f21 (f22 (f20 f21 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f16 f19 ?v0))) (= (f18 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f18 (f16 f17 ?v0) (f18 (f16 f19 (f18 ?v_0 ?v1)) (f9 f10 2)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f3 (f4 f5 ?v0) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f9 f10 2)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f22 (f20 f21 ?v0) (f11 (f23 f24 (f11 ?v_0 ?v1)) (f9 f10 2)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f16 f19 ?v0))) (let ((?v_1 (f18 ?v_0 ?v1))) (= (f18 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f18 (f16 f17 ?v0) (f18 (f16 f17 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f3 (f4 f5 ?v0) (f3 (f4 f5 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f23 f24 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f22 (f20 f21 ?v0) (f22 (f20 f21 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f16 f19 ?v0))) (= (f18 (f16 f17 ?v0) (f18 ?v_0 ?v1)) (f18 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f7 f8 ?v0))) (= (f3 (f4 f5 ?v0) (f6 ?v_0 ?v1)) (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f20 f21 ?v0) (f11 ?v_0 ?v1)) (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f16 f19 ?v0))) (= (f18 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f18 (f16 f17 (f18 ?v_0 ?v1)) (f18 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f22 (f20 f21 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f16 f19 ?v0))) (let ((?v_1 (f18 ?v_0 ?v1))) (= (f18 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f18 (f16 f17 ?v_1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f3 (f4 f5 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f23 f24 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f22 (f20 f21 ?v_1) ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f16 f19 ?v0))) (= (f18 (f16 f17 (f18 ?v_0 ?v1)) ?v0) (f18 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f7 f8 ?v0))) (= (f3 (f4 f5 (f6 ?v_0 ?v1)) ?v0) (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f20 f21 (f11 ?v_0 ?v1)) ?v0) (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f16 f19 ?v0))) (= (f18 ?v_0 ?v1) (ite (= ?v1 (f9 f10 0)) (f9 f10 1) (f9 f10 (f22 (f20 f21 (f11 f12 ?v0)) (f11 f12 (f18 ?v_0 (f9 f10 (- (f11 f12 ?v1) 1)))))))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f9 f10 0)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f9 f10 (f22 (f20 f21 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f9 f10 (+ ?v_1 (f22 (f20 f21 (f11 f12 (f9 f10 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f11 f12 ?v0))) (= (f9 f10 (* ?v_0 2)) (f9 f10 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f11 f12 ?v0))) (= (f9 f10 (* 2 ?v_0)) (f9 f10 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f16 f19 ?v0))) (= (f18 (f16 f19 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f9 f10 (f22 (f20 f21 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f9 f10 (f22 (f20 f21 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 (f23 f24 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f9 f10 (f22 (f20 f21 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f16 f19 ?v0))) (= (f18 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f18 (f16 f19 (f18 ?v_0 ?v1)) (f9 f10 2))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f9 f10 2))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f11 (f23 f24 (f11 ?v_0 ?v1)) (f9 f10 2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f16 f19 ?v0))) (= (f18 ?v_0 (f9 f10 (f22 (f20 f21 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f18 (f16 f19 (f18 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f9 f10 (f22 (f20 f21 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f9 f10 (f22 (f20 f21 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f11 (f23 f24 (f11 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f20 f21 ?v0))) (= (f22 (f20 f21 (f22 ?v_0 ?v1)) (f22 (f20 f21 ?v2) ?v3)) (f22 (f20 f21 (f22 ?v_0 ?v2)) (f22 (f20 f21 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) (f3 (f4 f5 ?v2) ?v3)) (f3 (f4 f5 (f3 ?v_0 ?v2)) (f3 (f4 f5 ?v1) ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f16 f17 ?v0))) (= (f18 (f16 f17 (f18 ?v_0 ?v1)) (f18 (f16 f17 ?v2) ?v3)) (f18 (f16 f17 (f18 ?v_0 ?v2)) (f18 (f16 f17 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f20 f21 (f22 (f20 f21 ?v0) ?v1))) (?v_0 (f20 f21 ?v2))) (= (f22 ?v_1 (f22 ?v_0 ?v3)) (f22 ?v_0 (f22 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f4 f5 (f3 (f4 f5 ?v0) ?v1))) (?v_0 (f4 f5 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_1 (f16 f17 (f18 (f16 f17 ?v0) ?v1))) (?v_0 (f16 f17 ?v2))) (= (f18 ?v_1 (f18 ?v_0 ?v3)) (f18 ?v_0 (f18 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f20 f21 ?v0)) (?v_1 (f22 (f20 f21 ?v2) ?v3))) (= (f22 (f20 f21 (f22 ?v_0 ?v1)) ?v_1) (f22 ?v_0 (f22 (f20 f21 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f5 ?v0)) (?v_1 (f3 (f4 f5 ?v2) ?v3))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f4 f5 ?v1) ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f16 f17 ?v0)) (?v_1 (f18 (f16 f17 ?v2) ?v3))) (= (f18 (f16 f17 (f18 ?v_0 ?v1)) ?v_1) (f18 ?v_0 (f18 (f16 f17 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f20 f21 ?v0))) (= (f22 (f20 f21 (f22 ?v_0 ?v1)) ?v2) (f22 (f20 f21 (f22 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f5 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f16 f17 ?v0))) (= (f18 (f16 f17 (f18 ?v_0 ?v1)) ?v2) (f18 (f16 f17 (f18 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f20 f21 ?v0))) (= (f22 (f20 f21 (f22 ?v_0 ?v1)) ?v2) (f22 ?v_0 (f22 (f20 f21 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f5 ?v1) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f16 f17 ?v0))) (= (f18 (f16 f17 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f16 f17 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f20 f21 ?v0))) (= (f22 ?v_0 (f22 (f20 f21 ?v1) ?v2)) (f22 (f20 f21 (f22 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f3 (f4 f5 ?v1) ?v2)) (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f16 f17 ?v0))) (= (f18 ?v_0 (f18 (f16 f17 ?v1) ?v2)) (f18 (f16 f17 (f18 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f20 f21 ?v0)) (?v_0 (f20 f21 ?v1))) (= (f22 ?v_1 (f22 ?v_0 ?v2)) (f22 ?v_0 (f22 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f4 f5 ?v0)) (?v_0 (f4 f5 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f16 f17 ?v0)) (?v_0 (f16 f17 ?v1))) (= (f18 ?v_1 (f18 ?v_0 ?v2)) (f18 ?v_0 (f18 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f22 (f20 f21 ?v0) ?v1) (f22 (f20 f21 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v1) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f18 (f16 f17 ?v0) ?v1) (f18 (f16 f17 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2))) (= (f11 (f23 f24 (f22 f25 ?v0)) ?v_0) (f11 (f23 f24 ?v0) ?v_0)))))
(assert (forall ((?v0 S6)) (= (f18 (f16 f19 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f6 (f7 f8 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f11 (f23 f24 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S6)) (= (f18 (f16 f19 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f6 (f7 f8 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f11 (f23 f24 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S6)) (= (f9 f10 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
