(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S4)
(declare-fun f4 (S5 S4) S2)
(declare-fun f5 () S5)
(declare-fun f6 (S6 S4) S4)
(declare-fun f7 () S6)
(declare-fun f8 () S4)
(declare-fun f9 (S7 Int) S3)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S8) S1)
(declare-fun f12 () S8)
(declare-fun f13 () S8)
(declare-fun f14 () S8)
(declare-fun f15 (S9 S8) S4)
(declare-fun f16 (S10 S8) S9)
(declare-fun f17 () S10)
(declare-fun f18 (S11 S3) S8)
(declare-fun f19 (S12 S8) S11)
(declare-fun f20 () S12)
(declare-fun f21 (S13 S8) S8)
(declare-fun f22 () S13)
(declare-fun f23 () S13)
(declare-fun f24 (S14 Int) Int)
(declare-fun f25 () S14)
(declare-fun f26 (S15 S3) Int)
(declare-fun f27 (S16 Int) S15)
(declare-fun f28 () S16)
(declare-fun f29 () S15)
(declare-fun f30 () S4)
(declare-fun f31 (S17 S8) S13)
(declare-fun f32 () S17)
(declare-fun f33 (S18 Int) S14)
(declare-fun f34 () S18)
(declare-fun f35 () S17)
(declare-fun f36 () S18)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 (f6 f7 f8)) (f9 f10 2)) f8)))
(assert (= (f11 f12 f13) f1))
(assert (= f14 f12))
(assert (= f8 (f15 (f16 f17 f13) f14)))
(assert (= (f18 (f19 f20 (f21 f22 f13)) (f9 f10 2)) f13))
(assert (= f8 (f15 (f16 f17 f13) f14)))
(assert (=> (forall ((?v0 S8) (?v1 S8)) (=> (= f8 (f15 (f16 f17 ?v0) ?v1)) false)) false))
(assert (forall ((?v0 S8) (?v1 S3)) (= (f21 f23 (f18 (f19 f20 ?v0) ?v1)) (f18 (f19 f20 (f21 f23 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f24 f25 (f26 (f27 f28 ?v0) ?v1)) (f26 (f27 f28 (f24 f25 ?v0)) ?v1))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f18 (f19 f20 ?v0) (f9 f10 2)))) (= (f21 f23 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f26 (f27 f28 ?v0) (f9 f10 2)))) (= (f24 f25 ?v_0) ?v_0))))
(assert (forall ((?v0 S8)) (= (f18 (f19 f20 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f26 (f27 f28 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f18 (f19 f20 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f26 (f27 f28 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S8)) (let ((?v_0 (f9 f10 2))) (= (f18 (f19 f20 (f21 f23 ?v0)) ?v_0) (f18 (f19 f20 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2))) (= (f26 (f27 f28 (f24 f25 ?v0)) ?v_0) (f26 (f27 f28 ?v0) ?v_0)))))
(assert (forall ((?v0 S3)) (= (f26 (f27 f28 0) (f9 f10 (+ (f26 f29 ?v0) 1))) 0)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f30) (f9 f10 (+ (f26 f29 ?v0) 1))) f30)))
(assert (forall ((?v0 S3)) (= (f18 (f19 f20 f12) (f9 f10 (+ (f26 f29 ?v0) 1))) f12)))
(assert (= (f26 (f27 f28 0) (f9 f10 2)) 0))
(assert (= (f3 (f4 f5 f30) (f9 f10 2)) f30))
(assert (= (f18 (f19 f20 f12) (f9 f10 2)) f12))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f26 (f27 f28 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f9 f10 0)))))))
(assert (forall ((?v0 S4) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f30) (and (= ?v0 f30) (not (= ?v1 (f9 f10 0)))))))
(assert (forall ((?v0 S8) (?v1 S3)) (= (= (f18 (f19 f20 ?v0) ?v1) f12) (and (= ?v0 f12) (not (= ?v1 (f9 f10 0)))))))
(assert (forall ((?v0 Int)) (= (= (f26 (f27 f28 ?v0) (f9 f10 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S4)) (= (= (f3 (f4 f5 ?v0) (f9 f10 2)) f30) (= ?v0 f30))))
(assert (forall ((?v0 S8)) (= (= (f18 (f19 f20 ?v0) (f9 f10 2)) f12) (= ?v0 f12))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (not (= ?v0 0)) (not (= (f26 (f27 f28 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S4) (?v1 S3)) (=> (not (= ?v0 f30)) (not (= (f3 (f4 f5 ?v0) ?v1) f30)))))
(assert (forall ((?v0 S8) (?v1 S3)) (=> (not (= ?v0 f12)) (not (= (f18 (f19 f20 ?v0) ?v1) f12)))))
(assert (forall ((?v0 Int)) (<= 0 (f26 (f27 f28 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 S8)) (= (f11 f12 (f18 (f19 f20 ?v0) (f9 f10 2))) f1)))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f26 (f27 f28 (f24 f25 ?v0)) ?v1))))
(assert (forall ((?v0 S8) (?v1 S3)) (= (f11 f12 (f18 (f19 f20 (f21 f23 ?v0)) ?v1)) f1)))
(assert (= (f11 f12 f13) f1))
(assert (= (f18 (f19 f20 (f21 f22 f13)) (f9 f10 2)) f13))
(assert (= f14 f12))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (=> (= (f26 (f27 f28 ?v0) ?v_0) (f26 (f27 f28 ?v1) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f9 f10 2))) (=> (= (f18 (f19 f20 ?v0) ?v_0) (f18 (f19 f20 ?v1) ?v_0)) (=> (= (f11 f12 ?v0) f1) (=> (= (f11 f12 ?v1) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (=> (<= (f26 (f27 f28 ?v0) ?v_0) (f26 (f27 f28 ?v1) ?v_0)) (=> (<= 0 ?v1) (<= ?v0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f9 f10 2))) (=> (= (f11 (f18 (f19 f20 ?v0) ?v_0) (f18 (f19 f20 ?v1) ?v_0)) f1) (=> (= (f11 f12 ?v1) f1) (= (f11 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (let ((?v_0 (f9 f10 (+ (f26 f29 ?v1) 1)))) (=> (= (f26 (f27 f28 ?v0) ?v_0) (f26 (f27 f28 ?v2) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S3) (?v2 S8)) (let ((?v_0 (f9 f10 (+ (f26 f29 ?v1) 1)))) (=> (= (f18 (f19 f20 ?v0) ?v_0) (f18 (f19 f20 ?v2) ?v_0)) (=> (= (f11 f12 ?v0) f1) (=> (= (f11 f12 ?v2) f1) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (let ((?v_0 (f9 f10 (+ (f26 f29 ?v1) 1)))) (=> (<= (f26 (f27 f28 ?v0) ?v_0) (f26 (f27 f28 ?v2) ?v_0)) (=> (<= 0 ?v2) (<= ?v0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S3) (?v2 S8)) (let ((?v_0 (f9 f10 (+ (f26 f29 ?v1) 1)))) (=> (= (f11 (f18 (f19 f20 ?v0) ?v_0) (f18 (f19 f20 ?v2) ?v_0)) f1) (=> (= (f11 f12 ?v2) f1) (= (f11 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f26 (f27 f28 ?v0) ?v1) (f26 (f27 f28 ?v2) ?v1)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (=> (< 0 (f26 f29 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S3) (?v2 S8)) (=> (= (f18 (f19 f20 ?v0) ?v1) (f18 (f19 f20 ?v2) ?v1)) (=> (= (f11 f12 ?v0) f1) (=> (= (f11 f12 ?v2) f1) (=> (< 0 (f26 f29 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v0) (<= (f26 (f27 f28 ?v0) ?v2) (f26 (f27 f28 ?v1) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S3)) (=> (= (f11 ?v0 ?v1) f1) (=> (= (f11 f12 ?v0) f1) (= (f11 (f18 (f19 f20 ?v0) ?v2) (f18 (f19 f20 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (<= 0 (f26 (f27 f28 ?v0) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S3)) (=> (= (f11 f12 ?v0) f1) (= (f11 f12 (f18 (f19 f20 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S8)) (= (f11 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 Int)) (<= 0 (f24 f25 ?v0))))
(assert (forall ((?v0 S8)) (= (f11 f12 (f21 f23 ?v0)) f1)))
(assert (forall ((?v0 Int)) (= (<= (f24 f25 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S8)) (= (= (f11 (f21 f23 ?v0) f12) f1) (= ?v0 f12))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f24 f25 ?v0) ?v0))))
(assert (forall ((?v0 S8)) (=> (= (f11 f12 ?v0) f1) (= (f21 f23 ?v0) ?v0))))
(assert (= f30 (f15 (f16 f17 f12) f12)))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f15 (f16 f17 ?v0) ?v1) f30) (and (= ?v0 f12) (= ?v1 f12)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (= (= (f15 (f16 f17 ?v0) ?v1) (f15 (f16 f17 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S8)) (= (f11 ?v0 (f21 f23 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 (f24 f25 ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f11 ?v0 (f21 (f31 f32 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f24 (f33 f34 ?v0) ?v1))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f11 ?v0 (f21 (f31 f32 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f24 (f33 f34 ?v1) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f11 (f21 (f31 f35 ?v0) ?v1) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f24 (f33 f36 ?v0) ?v1) ?v0)))
(assert (forall ((?v0 Int)) (= (= (f24 f25 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S8)) (= (= (f21 f23 ?v0) f12) (= ?v0 f12))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S4)) (= (= f30 ?v0) (= ?v0 f30))))
(assert (forall ((?v0 S8)) (= (= f12 ?v0) (= ?v0 f12))))
(assert (= (f24 f25 0) 0))
(assert (= (f21 f23 f12) f12))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (=> (= (f11 ?v0 ?v1) f1) false) (=> (=> (= (f11 ?v1 ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f11 (f21 (f31 f32 ?v0) ?v1) ?v2) f1) (=> (=> (= (f11 ?v0 ?v2) f1) (=> (= (f11 ?v1 ?v2) f1) false)) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (f24 (f33 f34 ?v0) ?v1) ?v2) (=> (=> (<= ?v0 ?v2) (=> (<= ?v1 ?v2) false)) false))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f11 (f21 f23 ?v0) ?v1) f1) (= (f11 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f24 f25 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f11 ?v0 (f21 (f31 f35 ?v1) ?v2)) f1) (=> (=> (= (f11 ?v0 ?v1) f1) (=> (= (f11 ?v0 ?v2) f1) false)) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 (f24 (f33 f36 ?v1) ?v2)) (=> (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) false)) false))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (=> (= (f11 ?v0 ?v1) f1) (=> (= (f11 ?v2 ?v3) f1) (= (f11 (f21 (f31 f35 ?v0) ?v2) (f21 (f31 f35 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f24 (f33 f36 ?v0) ?v2) (f24 (f33 f36 ?v1) ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (=> (= (f11 ?v0 ?v1) f1) (=> (= (f11 ?v2 ?v3) f1) (= (f11 (f21 (f31 f32 ?v0) ?v2) (f21 (f31 f32 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f24 (f33 f34 ?v0) ?v2) (f24 (f33 f34 ?v1) ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f11 ?v0 ?v1) f1) (=> (= (f11 ?v2 ?v1) f1) (= (f11 (f21 (f31 f32 ?v0) ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f24 (f33 f34 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f11 ?v0 ?v1) f1) (=> (= (f11 ?v2 ?v1) f1) (= (f11 (f21 (f31 f32 ?v0) ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f24 (f33 f34 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f11 ?v0 ?v1) f1) (=> (= (f11 ?v0 ?v2) f1) (= (f11 ?v0 (f21 (f31 f35 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f24 (f33 f36 ?v1) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f11 ?v0 ?v1) f1) (=> (= (f11 ?v0 ?v2) f1) (= (f11 ?v0 (f21 (f31 f35 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f24 (f33 f36 ?v1) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f11 ?v0 ?v1) f1) (=> (= (f11 ?v2 ?v0) f1) (= (f11 ?v2 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f11 ?v0 ?v1) f1) (=> (= (f11 ?v1 ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f11 ?v0 ?v1) f1) (=> (= (f11 ?v1 ?v2) f1) (= (f11 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f11 ?v0 ?v1) f1) (=> (= (f11 ?v1 ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f11 ?v0 ?v1) f1) (=> (= ?v0 ?v2) (= (f11 ?v2 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f11 ?v0 ?v1) f1) (=> (= ?v1 ?v2) (= (f11 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= ?v0 ?v1) (=> (= (f11 ?v2 ?v1) f1) (= (f11 ?v2 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= ?v0 ?v1) (=> (= (f11 ?v1 ?v2) f1) (= (f11 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f11 ?v0 ?v1) f1) (= (= (f11 ?v1 ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f11 ?v0 ?v1) f1) (= (f21 (f31 f35 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f24 (f33 f36 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f11 ?v0 ?v1) f1) (= (f21 (f31 f32 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f24 (f33 f34 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f11 ?v0 ?v1) f1) (= (f21 (f31 f35 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f24 (f33 f36 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f11 ?v0 ?v1) f1) (= (f21 (f31 f32 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f24 (f33 f34 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f11 ?v0 ?v1) f1) (= (f11 (f21 (f31 f35 ?v2) ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f24 (f33 f36 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S3)) (= (f9 f10 (f26 f29 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f26 f29 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f26 f29 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
