(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S3)
(declare-fun f4 () S2)
(declare-fun f5 (S4 Int) S3)
(declare-fun f6 () S4)
(declare-fun f7 (S5 Int) Int)
(declare-fun f8 () S5)
(declare-fun f9 () S5)
(declare-fun f10 () Int)
(declare-fun f11 (S6 S7) S3)
(declare-fun f12 (S8 S3) S6)
(declare-fun f13 () S8)
(declare-fun f14 (S9 Int) S7)
(declare-fun f15 () S9)
(declare-fun f16 (S10 S3) S2)
(declare-fun f17 () S10)
(declare-fun f18 () S2)
(declare-fun f19 () S5)
(declare-fun f20 () S10)
(declare-fun f21 (S3) S1)
(declare-fun f22 (Int) S1)
(declare-fun f23 (S3 S11) S1)
(declare-fun f24 () S11)
(declare-fun f25 (Int S12) S1)
(declare-fun f26 () S12)
(declare-fun f27 () S10)
(declare-fun f28 () S3)
(declare-fun f29 (S11 S3) S1)
(declare-fun f30 (S3) S11)
(declare-fun f31 (S13 Int) S5)
(declare-fun f32 () S13)
(declare-fun f33 (S12 Int) S1)
(declare-fun f34 (S14 S7) Int)
(declare-fun f35 () S14)
(declare-fun f36 (S15 Int) S14)
(declare-fun f37 () S15)
(declare-fun f38 () S5)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 (f7 f9 f10)))) (not (= (f3 f4 (f5 f6 (f7 f8 ?v_0))) (f3 f4 (f11 (f12 f13 (f5 f6 ?v_0)) (f14 f15 2)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 (f7 f9 f10))) (?v_1 (f14 f15 2))) (= (f3 (f16 f17 (f11 (f12 f13 ?v0) ?v_1)) (f5 f6 (f7 f8 ?v_0))) (f11 (f12 f13 (f3 (f16 f17 ?v0) (f5 f6 ?v_0))) ?v_1)))))
(assert (forall ((?v0 S3) (?v1 S7)) (= (f3 f4 (f11 (f12 f13 ?v0) ?v1)) (f11 (f12 f13 (f3 f4 ?v0)) ?v1))))
(assert (forall ((?v0 S3)) (= (f3 f4 (f11 (f12 f13 ?v0) (f14 f15 2))) (f3 f18 ?v0))))
(assert (= (f7 f8 f10) f10))
(assert (forall ((?v0 Int)) (= (- f10 (f7 f8 ?v0)) (f7 f8 (- f10 ?v0)))))
(assert (forall ((?v0 Int)) (= (= f10 (f7 f8 ?v0)) (= f10 ?v0))))
(assert (forall ((?v0 Int)) (= (< f10 (f7 f8 ?v0)) (< f10 ?v0))))
(assert (forall ((?v0 Int)) (= (<= f10 (f7 f8 ?v0)) (<= f10 ?v0))))
(assert (forall ((?v0 Int)) (= (= (f7 f8 ?v0) f10) (= ?v0 f10))))
(assert (forall ((?v0 Int)) (= (< (f7 f8 ?v0) f10) (< ?v0 f10))))
(assert (forall ((?v0 Int)) (= (<= (f7 f8 ?v0) f10) (<= ?v0 f10))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f7 f8 ?v0) (f7 f9 ?v1)) false)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f4 (f3 (f16 f17 ?v0) ?v1)) (f3 (f16 f17 (f3 f4 ?v0)) (f3 f4 ?v1)))))
(assert (forall ((?v0 S3)) (= (f3 (f16 f17 ?v0) (f5 f6 (f7 f9 f10))) ?v0)))
(assert (forall ((?v0 S3)) (= (f3 (f16 f17 ?v0) (f5 f6 (f7 f9 f10))) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f5 f6 ?v0) (f5 f6 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f7 f19 ?v0) (f7 f19 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f19 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f7 f9 ?v0) (f7 f9 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f7 f9 ?v0) (f7 f9 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f7 f9 ?v0) (f7 f9 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f7 f9 ?v0) (f7 f9 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f7 f9 ?v0) (f7 f9 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (< (f7 f9 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (f7 f9 ?v0) (+ (+ 1 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (- ?v0 f10) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 f10) ?v0)))
(assert (forall ((?v0 Int)) (= (+ f10 ?v0) ?v0)))
(assert (= (<= f10 f10) true))
(assert (= (< f10 0) false))
(assert (= (< f10 f10) false))
(assert (= (= f10 f10) true))
(assert (= (- f10) f10))
(assert (= f10 0))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f7 f8 ?v0) (f7 f8 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f7 f8 ?v0) (f7 f8 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f7 f8 ?v0) (f7 f8 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f7 f8 ?v0) (f7 f8 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f7 f8 ?v0) (f7 f8 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f7 f8 ?v0) (f7 f8 ?v1)) (f7 f8 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f7 f8 ?v0) (f7 f8 ?v1)) (f7 f8 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (= (< (f7 f8 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (- (f7 f8 ?v0)) (f7 f8 (- ?v0)))))
(assert (forall ((?v0 Int)) (= (f7 f8 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 f4 ?v0) (f3 f4 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (<= (f7 f9 ?v0) f10) (< ?v0 f10))))
(assert (forall ((?v0 Int)) (= (< (f7 f9 ?v0) f10) (< ?v0 f10))))
(assert (forall ((?v0 Int)) (= (= (f7 f9 ?v0) f10) false)))
(assert (forall ((?v0 Int)) (= (<= f10 (f7 f9 ?v0)) (<= f10 ?v0))))
(assert (forall ((?v0 Int)) (= (< f10 (f7 f9 ?v0)) (<= f10 ?v0))))
(assert (forall ((?v0 Int)) (= (= f10 (f7 f9 ?v0)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f7 f9 ?v0) (f7 f8 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f7 f9 ?v0) (f7 f8 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f7 f8 ?v0) (f7 f9 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f7 f8 ?v0) (f7 f9 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f7 f9 ?v0) (f7 f8 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f7 f9 ?v0) (f7 f8 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f7 f8 ?v0) (f7 f9 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f7 f8 ?v0) (f7 f9 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f7 f9 ?v0) (f7 f9 ?v1)) (f7 f8 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f7 f9 ?v0) (f7 f8 ?v1)) (f7 f9 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f7 f9 ?v0) (f7 f8 ?v1)) (f7 f9 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f7 f8 ?v0) (f7 f9 ?v1)) (f7 f9 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f7 f9 ?v0) (f7 f8 ?v1)) false)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S7)) (= (f11 (f12 f13 (f3 (f16 f17 ?v0) ?v1)) ?v2) (f3 (f16 f17 (f11 (f12 f13 ?v0) ?v2)) (f11 (f12 f13 ?v1) ?v2)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 (f7 f9 f10))) (?v_1 (f14 f15 2))) (= (f3 (f16 f20 (f5 f6 (f7 f8 ?v_0))) (f11 (f12 f13 ?v0) ?v_1)) (f11 (f12 f13 (f3 (f16 f20 (f5 f6 ?v_0)) ?v0)) ?v_1)))))
(assert (not (= (f21 (f5 f6 (f7 f9 f10))) f1)))
(assert (not (= (f22 1) f1)))
(assert (forall ((?v0 Int)) (=> (<= f10 ?v0) (= (f23 (f5 f6 ?v0) f24) f1))))
(assert (forall ((?v0 Int)) (=> (<= f10 ?v0) (= (f25 (f7 f19 ?v0) f26) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f20 (f5 f6 (f7 f8 (f7 f9 f10))))) (?v_1 (f16 f17 ?v1))) (= (= ?v0 (f3 ?v_1 (f3 ?v_0 ?v2))) (= (f3 ?v_0 ?v0) (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 (f16 f17 ?v0) (f5 f6 (f7 f8 (f7 f9 f10)))))) (= (f3 (f16 f27 ?v_0) ?v_0) ?v0))))
(assert (let ((?v_0 (f5 f6 (f7 f8 (f7 f9 f10))))) (not (= (f3 (f16 f17 f28) ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (= (f21 (f5 f6 (f7 f8 ?v0))) f1) (= (f21 (f5 f6 ?v0)) f1))))
(assert (forall ((?v0 Int)) (= (= (f22 (f7 f19 (f7 f8 ?v0))) f1) (= (f22 (f7 f19 ?v0)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f14 f15 2)) (?v_0 (f3 (f16 f17 ?v1) (f3 f4 (f5 f6 (f7 f8 (f7 f9 f10))))))) (=> (= (f29 (f30 (f3 f18 ?v0)) ?v_0) f1) (=> (= (f29 (f30 (f3 f18 ?v2)) ?v_0) f1) (= (f29 (f30 (f3 f4 (f3 (f16 f27 (f11 (f12 f13 ?v0) ?v_1)) (f11 (f12 f13 ?v2) ?v_1)))) ?v1) f1))))))
(assert (= (f21 (f5 f6 f10)) f1))
(assert (= (f22 0) f1))
(assert (forall ((?v0 Int)) (not (= (f21 (f5 f6 (f7 f9 ?v0))) f1))))
(assert (forall ((?v0 Int)) (not (= (f22 (f7 f19 (f7 f9 ?v0))) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f19 ?v2))) (= (f7 (f31 f32 (+ ?v0 ?v1)) ?v_0) (+ (f7 (f31 f32 ?v0) ?v_0) (f7 (f31 f32 ?v1) ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f5 f6 ?v2))) (= (f3 (f16 f20 (f3 (f16 f27 ?v0) ?v1)) ?v_0) (f3 (f16 f27 (f3 (f16 f20 ?v0) ?v_0)) (f3 (f16 f20 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S12)) (= (= (f25 ?v0 ?v1) f1) (= (f33 ?v1 ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S11)) (= (= (f23 ?v0 ?v1) f1) (= (f29 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f31 f32 (f7 f19 ?v0)))) (= (f7 ?v_0 (+ ?v1 ?v2)) (+ (f7 ?v_0 ?v1) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f16 f20 (f5 f6 ?v0)))) (= (f3 ?v_0 (f3 (f16 f27 ?v1) ?v2)) (f3 (f16 f27 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f16 f20 (f5 f6 ?v0)) (f3 (f16 f20 (f5 f6 ?v1)) ?v2)) (f3 (f16 f20 (f5 f6 (f7 (f31 f32 ?v0) ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f7 (f31 f32 (f7 f19 ?v0)) (f7 (f31 f32 (f7 f19 ?v1)) ?v2)) (f7 (f31 f32 (f7 f19 (f7 (f31 f32 ?v0) ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f16 f20 (f5 f6 ?v0)) (f5 f6 ?v1)) (f5 f6 (f7 (f31 f32 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f31 f32 (f7 f19 ?v0)) (f7 f19 ?v1)) (f7 f19 (f7 (f31 f32 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 f6 (f7 (f31 f32 ?v0) ?v1)) (f3 (f16 f20 (f5 f6 ?v0)) (f5 f6 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 f19 (f7 (f31 f32 ?v0) ?v1)) (f7 (f31 f32 (f7 f19 ?v0)) (f7 f19 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S7)) (let ((?v_0 (f12 f13 ?v0))) (= (f11 ?v_0 (f14 f15 (+ (f34 f35 ?v1) 1))) (f3 (f16 f20 ?v0) (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f36 f37 ?v0))) (= (f34 ?v_0 (f14 f15 (+ (f34 f35 ?v1) 1))) (f7 (f31 f32 ?v0) (f34 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S7)) (let ((?v_0 (f12 f13 ?v0))) (= (f11 ?v_0 (f14 f15 (+ (f34 f35 ?v1) 1))) (f3 (f16 f20 (f11 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f36 f37 ?v0))) (= (f34 ?v_0 (f14 f15 (+ (f34 f35 ?v1) 1))) (f7 (f31 f32 (f34 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S7) (?v2 S7)) (let ((?v_0 (f12 f13 ?v0))) (= (f11 ?v_0 (f14 f15 (+ (f34 f35 ?v1) (f34 f35 ?v2)))) (f3 (f16 f20 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f36 f37 ?v0))) (= (f34 ?v_0 (f14 f15 (+ (f34 f35 ?v1) (f34 f35 ?v2)))) (f7 (f31 f32 (f34 ?v_0 ?v1)) (f34 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S7)) (let ((?v_0 (f11 (f12 f13 ?v0) ?v1))) (= (f3 (f16 f20 ?v_0) ?v0) (f3 (f16 f20 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f34 (f36 f37 ?v0) ?v1))) (= (f7 (f31 f32 ?v_0) ?v0) (f7 (f31 f32 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S7)) (= (f11 (f12 f13 (f3 (f16 f20 ?v0) ?v1)) ?v2) (f3 (f16 f20 (f11 (f12 f13 ?v0) ?v2)) (f11 (f12 f13 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (= (f34 (f36 f37 (f7 (f31 f32 ?v0) ?v1)) ?v2) (f7 (f31 f32 (f34 (f36 f37 ?v0) ?v2)) (f34 (f36 f37 ?v1) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S3)) (let ((?v_0 (f34 f35 ?v1)) (?v_1 (f34 f35 ?v0)) (?v_2 (f12 f13 ?v2))) (=> (<= ?v_1 ?v_0) (= (f11 ?v_2 (f14 f15 (- (+ ?v_0 1) ?v_1))) (f3 (f16 f20 (f11 ?v_2 (f14 f15 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int)) (let ((?v_0 (f34 f35 ?v1)) (?v_1 (f34 f35 ?v0)) (?v_2 (f36 f37 ?v2))) (=> (<= ?v_1 ?v_0) (= (f34 ?v_2 (f14 f15 (- (+ ?v_0 1) ?v_1))) (f7 (f31 f32 (f34 ?v_2 (f14 f15 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f14 f15 2))) (let ((?v_1 (f3 (f16 f20 (f3 (f16 f27 (f11 (f12 f13 ?v0) ?v_0)) (f11 (f12 f13 ?v1) ?v_0))) (f3 (f16 f27 (f11 (f12 f13 ?v2) ?v_0)) (f11 (f12 f13 ?v3) ?v_0))))) (= (f11 (f12 f13 (f3 f4 ?v_1)) ?v_0) ?v_1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 f19 (+ ?v0 ?v1)) (+ (f7 f19 ?v0) (f7 f19 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 f6 (+ ?v0 ?v1)) (f3 (f16 f27 (f5 f6 ?v0)) (f5 f6 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f7 f19 ?v0) (f7 f19 ?v1)) (f7 f19 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f16 f27 (f5 f6 ?v0)) (f5 f6 ?v1)) (f5 f6 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f7 f19 ?v0) (+ (f7 f19 ?v1) ?v2)) (+ (f7 f19 (+ ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f16 f27 (f5 f6 ?v0)) (f3 (f16 f27 (f5 f6 ?v1)) ?v2)) (f3 (f16 f27 (f5 f6 (+ ?v0 ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f7 f19 ?v0) (f7 f19 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 (f30 (f5 f6 ?v0)) (f5 f6 ?v1)) f1) (< ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f16 f20 ?v0))) (= (f3 (f16 f17 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v0)) (f3 (f16 f17 ?v1) ?v0)))))
(assert (forall ((?v0 S3)) (= (f3 f4 (f3 (f16 f20 ?v0) ?v0)) (f3 f18 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f4 (f3 (f16 f20 ?v0) ?v1)) (f3 (f16 f20 (f3 f4 ?v0)) (f3 f4 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f29 (f30 (f3 f4 ?v0)) (f3 f4 ?v1)) f1) (= (f29 (f30 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f29 (f30 ?v0) ?v1) f1) (= (f29 (f30 (f3 f4 ?v0)) (f3 f4 ?v1)) f1))))
(assert (= (f29 (f30 f28) (f5 f6 (f7 f8 (f7 f8 (f7 f9 f10))))) f1))
(assert (forall ((?v0 Int)) (= (* ?v0 2) (+ ?v0 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f16 f20 ?v0) (f5 f6 (f7 f8 (f7 f9 f10)))) (f3 (f16 f27 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* ?v0 2) (+ ?v0 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f16 f20 ?v0) (f5 f6 (f7 f8 (f7 f9 f10)))) (f3 (f16 f27 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* 2 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f16 f20 (f5 f6 (f7 f8 (f7 f9 f10)))) ?v0) (f3 (f16 f27 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* 2 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f16 f20 (f5 f6 (f7 f8 (f7 f9 f10)))) ?v0) (f3 (f16 f27 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f5 f6 ?v0) (f5 f6 ?v1)) (= (f21 (f5 f6 (+ ?v0 (- ?v1)))) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f7 f19 ?v0) (f7 f19 ?v1)) (= (f22 (f7 f19 (+ ?v0 (- ?v1)))) f1))))
(assert (let ((?v_0 (f5 f6 (f7 f8 (f7 f9 f10))))) (= (f29 (f30 (f3 (f16 f17 f28) ?v_0)) ?v_0) f1)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S3)) (= (f3 (f16 f27 ?v0) (f5 f6 f10)) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f3 (f16 f27 (f5 f6 f10)) ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f3 (f16 f20 ?v0) (f5 f6 (f7 f9 f10))) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S3)) (= (f3 (f16 f20 (f5 f6 (f7 f9 f10))) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 S7)) (= (f7 f38 (f34 (f36 f37 ?v0) ?v1)) (f34 (f36 f37 (f7 f38 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S7)) (= (f3 f18 (f11 (f12 f13 ?v0) ?v1)) (f11 (f12 f13 (f3 f18 ?v0)) ?v1))))
(assert (forall ((?v0 S3)) (= (f11 (f12 f13 ?v0) (f14 f15 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f34 (f36 f37 ?v0) (f14 f15 1)) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f14 f15 2))) (= (f11 (f12 f13 (f3 (f16 f27 ?v0) ?v1)) ?v_0) (f3 (f16 f27 (f3 (f16 f27 (f11 (f12 f13 ?v0) ?v_0)) (f11 (f12 f13 ?v1) ?v_0))) (f3 (f16 f20 (f3 (f16 f20 (f5 f6 (f7 f8 (f7 f9 f10)))) ?v0)) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f30 ?v0))) (=> (= (f29 ?v_0 ?v1) f1) (= (f29 ?v_0 (f3 (f16 f17 (f3 (f16 f27 ?v0) ?v1)) (f5 f6 (f7 f8 (f7 f9 f10))))) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f29 (f30 ?v0) ?v1) f1) (= (f29 (f30 (f3 (f16 f17 (f3 (f16 f27 ?v0) ?v1)) (f5 f6 (f7 f8 (f7 f9 f10))))) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (f34 (f36 f37 (+ ?v0 ?v1)) ?v_0) (+ (+ (f34 (f36 f37 ?v0) ?v_0) (f34 (f36 f37 ?v1) ?v_0)) (f7 (f31 f32 (* 2 ?v0)) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f14 f15 2))) (= (f11 (f12 f13 (f3 (f16 f27 ?v0) ?v1)) ?v_0) (f3 (f16 f27 (f3 (f16 f27 (f11 (f12 f13 ?v0) ?v_0)) (f11 (f12 f13 ?v1) ?v_0))) (f3 (f16 f20 (f3 (f16 f20 (f5 f6 (f7 f8 (f7 f9 f10)))) ?v0)) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f10 ?v0) (=> (<= f10 ?v1) (= (+ (f7 f19 ?v0) (f7 f19 ?v1)) (f7 f19 (+ ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f10 ?v0) (=> (<= f10 ?v1) (= (f3 (f16 f27 (f5 f6 ?v0)) (f5 f6 ?v1)) (f5 f6 (+ ?v0 ?v1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f11 (f12 f13 ?v_0) (f14 f15 2)) (f3 (f16 f20 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f19 ?v0))) (= (f34 (f36 f37 ?v_0) (f14 f15 2)) (f7 (f31 f32 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 (f31 f32 ?v0) ?v1))) (= (f14 f15 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f14 f15 (f7 (f31 f32 (f34 f35 (f14 f15 (ite (< ?v0 0) (- ?v0) ?v0)))) (f34 f35 (f14 f15 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f7 (f31 f32 (f34 f35 ?v0)) (f34 f35 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f31 f32 ?v0) ?v1) (f7 (f31 f32 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f36 f37 ?v0))) (= (f34 ?v_0 (f14 f15 (+ (f34 f35 ?v1) (f34 f35 ?v2)))) (f7 (f31 f32 (f34 ?v_0 ?v1)) (f34 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f31 f32 ?v0))) (= (f7 ?v_0 (+ ?v1 ?v2)) (+ (f7 ?v_0 ?v1) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f31 f32 ?v0))) (= (f7 ?v_0 (- ?v1 ?v2)) (- (f7 ?v_0 ?v1) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f31 f32 (- ?v0)) ?v1) (- (f7 (f31 f32 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f31 f32 (f7 f19 ?v0)) (f7 f19 ?v1)) (f7 f19 (f7 (f31 f32 ?v0) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f7 (f31 f32 (f34 f35 ?v0)) (f34 f35 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f7 (f31 f32 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 S7)) (= (f14 f15 (f34 f35 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f34 f35 (f14 f15 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f34 f35 (f14 f15 ?v0)) 0))))
(check-sat)
(exit)
