(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S2) S1)
(declare-fun f4 (S3 S2) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S2) S3)
(declare-fun f7 () S4)
(declare-fun f8 (S5 Int) S2)
(declare-fun f9 () S5)
(declare-fun f10 (S6 Int) Int)
(declare-fun f11 () S6)
(declare-fun f12 () S6)
(declare-fun f13 () Int)
(declare-fun f14 () S2)
(declare-fun f15 () S2)
(declare-fun f16 () Int)
(declare-fun f17 () S2)
(declare-fun f18 () S6)
(declare-fun f19 (S7 Int) S8)
(declare-fun f20 () S7)
(declare-fun f21 () S8)
(declare-fun f22 (S9 S8) S8)
(declare-fun f23 (S10 S8) S9)
(declare-fun f24 () S10)
(declare-fun f25 (S11 Int) S6)
(declare-fun f26 () S11)
(declare-fun f27 () S7)
(declare-fun f28 (S12 S8) Int)
(declare-fun f29 () S12)
(declare-fun f30 () S4)
(declare-fun f31 () S11)
(declare-fun f32 () S4)
(declare-fun f33 () S11)
(declare-fun f34 () S6)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 (f4 (f6 f7 (f8 f9 (f10 f11 (f10 f12 f13)))) f14)) f15) f1)))
(assert (= (f3 (f4 (f6 f7 (f8 f9 (f10 f11 (f10 f12 f13)))) f14) f15) f1))
(assert (= (f3 (f8 f9 f16) (f4 (f6 f7 (f8 f9 (f10 f11 (f10 f12 f13)))) f14)) f1))
(assert (= (f3 (f4 (f6 f7 (f8 f9 (f10 f11 (f10 f12 f13)))) f17) f15) f1))
(assert (= (f3 (f8 f9 f16) (f4 (f6 f7 (f8 f9 (f10 f11 (f10 f12 f13)))) f17)) f1))
(assert (= (f3 (f4 (f6 f7 (f8 f9 (f10 f11 (f10 f12 f13)))) f17) f15) f1))
(assert (= (f3 (f8 f9 f16) (f4 (f6 f7 (f8 f9 (f10 f11 (f10 f12 f13)))) f17)) f1))
(assert (= (f3 (f4 (f6 f7 (f8 f9 (f10 f11 (f10 f12 f13)))) f14) f15) f1))
(assert (= (f3 (f8 f9 f16) (f4 (f6 f7 (f8 f9 (f10 f11 (f10 f12 f13)))) f14)) f1))
(assert (forall ((?v0 Int)) (= (= (f3 f15 (f8 f9 ?v0)) f1) (<= (f10 f12 f13) ?v0))))
(assert (forall ((?v0 Int)) (= (<= 1 (f10 f18 ?v0)) (<= (f10 f12 f13) ?v0))))
(assert (forall ((?v0 Int)) (= (= (f3 (f8 f9 ?v0) f15) f1) (<= ?v0 (f10 f12 f13)))))
(assert (forall ((?v0 Int)) (= (<= (f10 f18 ?v0) 1) (<= ?v0 (f10 f12 f13)))))
(assert (= f15 (f8 f9 (f10 f12 f13))))
(assert (= 1 1))
(assert (= (f8 f9 (f10 f12 f13)) f15))
(assert (= 1 1))
(assert (= (f19 f20 (f10 f12 f13)) f21))
(assert (= (f8 f9 (f10 f12 f13)) f15))
(assert (= 1 1))
(assert (forall ((?v0 S2)) (= (f4 (f6 f7 ?v0) (f8 f9 (f10 f12 f13))) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f6 f7 (f8 f9 (f10 f12 f13))) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f13 ?v0) (=> (<= f13 ?v1) (= (f22 (f23 f24 (f19 f20 ?v0)) (f19 f20 ?v1)) (f19 f20 (f10 (f25 f26 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f13 ?v0) (=> (<= f13 ?v1) (= (f4 (f6 f7 (f8 f9 ?v0)) (f8 f9 ?v1)) (f8 f9 (f10 (f25 f26 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f13 ?v0) (=> (<= f13 ?v1) (= (f10 (f25 f26 (f10 f18 ?v0)) (f10 f18 ?v1)) (f10 f18 (f10 (f25 f26 ?v0) ?v1)))))))
(assert (forall ((?v0 S2)) (= (f3 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f6 f7 f15) ?v0) ?v0)))
(assert (= (f10 f11 f13) f13))
(assert (forall ((?v0 Int)) (= (- f13 (f10 f11 ?v0)) (f10 f11 (- f13 ?v0)))))
(assert (= f16 (- 1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 (f25 f26 ?v0) ?v1))) (= (f19 f27 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f19 f27 (f10 (f25 f26 (f28 f29 (f19 f27 (ite (< ?v0 0) (- ?v0) ?v0)))) (f28 f29 (f19 f27 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f10 (f25 f26 (f28 f29 ?v0)) (f28 f29 ?v1)))) (= ?v_0 ?v_0))))
(assert (= (= f16 f16) true))
(assert (= (< f16 f16) false))
(assert (= (< f16 0) true))
(assert (= (<= f16 f16) true))
(assert (forall ((?v0 Int)) (= (f10 (f25 f26 f16) ?v0) (- ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f25 f26 ?v0) ?v1) (f10 (f25 f26 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f25 f26 ?v0))) (= (f10 ?v_0 (+ ?v1 ?v2)) (+ (f10 ?v_0 ?v1) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f25 f26 ?v0))) (= (f10 ?v_0 (- ?v1 ?v2)) (- (f10 ?v_0 ?v1) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f25 f26 (- ?v0)) ?v1) (- (f10 (f25 f26 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f25 f26 (f10 f18 ?v0)) (f10 f18 ?v1)) (f10 f18 (f10 (f25 f26 ?v0) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f10 (f25 f26 (f28 f29 ?v0)) (f28 f29 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f19 f27 (f10 (f25 f26 (f28 f29 (f19 f20 ?v0))) (f28 f29 (f19 f20 ?v1)))) (ite (< ?v0 f13) (f19 f27 0) (f19 f27 (f10 f18 (f10 (f25 f26 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (let ((?v_0 (f28 f29 ?v2))) (= (f19 f27 (f10 (f25 f26 (f28 f29 (f19 f20 ?v0))) (f10 (f25 f26 (f28 f29 (f19 f20 ?v1))) ?v_0))) (ite (< ?v0 f13) (f19 f27 0) (f19 f27 (f10 (f25 f26 (f28 f29 (f19 f20 (f10 (f25 f26 ?v0) ?v1)))) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 (f25 f26 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f25 f26 ?v0))) (= (f10 (f25 f26 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f25 f26 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f10 (f25 f26 (+ ?v0 ?v1)) ?v2) (+ (f10 (f25 f26 ?v0) ?v2) (f10 (f25 f26 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f10 (f25 f26 (- ?v0 ?v1)) ?v2) (- (f10 (f25 f26 ?v0) ?v2) (f10 (f25 f26 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f19 f27 (f10 (f25 f26 ?v0) ?v1)) (f19 f27 (f10 (f25 f26 (f28 f29 (f19 f27 ?v0))) (f28 f29 (f19 f27 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f10 (f25 f26 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f19 f27 (f10 (f25 f26 ?v0) ?v1)) (f19 f27 (f10 (f25 f26 (f28 f29 (f19 f27 (- ?v0)))) (f28 f29 (f19 f27 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f25 f26 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f10 ?v_0 ?v0) (f10 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (let ((?v_0 (f28 f29 ?v2))) (let ((?v_1 (f25 f26 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f10 ?v_1 ?v0) (f10 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 (f25 f26 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 (f25 f26 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f28 f29 (f19 f20 ?v0)) (f28 f29 (f19 f20 ?v1))) (ite (< ?v0 ?v1) (< f13 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f28 f29 (f19 f20 ?v0)) (f28 f29 (f19 f20 ?v1))) (ite (<= ?v0 ?v1) true (<= ?v0 f13)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f19 f27 (+ (f28 f29 (f19 f20 ?v0)) (f28 f29 (f19 f20 ?v1)))) (ite (< ?v0 f13) (f19 f27 (f10 f18 ?v1)) (ite (< ?v1 f13) (f19 f27 (f10 f18 ?v0)) (f19 f27 (f10 f18 (+ ?v0 ?v1))))))))
(assert (forall ((?v0 Int)) (= (= (f19 f27 (f10 f18 ?v0)) (f19 f27 0)) (<= ?v0 f13))))
(assert (forall ((?v0 Int)) (= (= (f19 f27 0) (f19 f27 (f10 f18 ?v0))) (<= ?v0 f13))))
(assert (forall ((?v0 Int)) (= (< 0 (f28 f29 (f19 f20 ?v0))) (< f13 ?v0))))
(assert (forall ((?v0 Int)) (= (f10 (f25 f26 f13) ?v0) f13)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f25 f26 (f10 f11 ?v0)) ?v1) (f10 f11 (f10 (f25 f26 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f25 f26 (f10 f12 ?v0)) ?v1) (+ (f10 f11 (f10 (f25 f26 ?v0) ?v1)) ?v1))))
(assert (forall ((?v0 Int)) (= (<= (f10 f12 ?v0) f16) (<= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (< (f10 f12 ?v0) f16) (< ?v0 f16))))
(assert (forall ((?v0 Int)) (= (= (f10 f12 ?v0) f16) (= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (<= f16 (f10 f12 ?v0)) (<= f16 ?v0))))
(assert (forall ((?v0 Int)) (= (< f16 (f10 f12 ?v0)) (< f16 ?v0))))
(assert (forall ((?v0 Int)) (= (= f16 (f10 f12 ?v0)) (= f16 ?v0))))
(assert (= (f10 f12 f16) f16))
(assert (= (<= f13 f16) false))
(assert (= (<= f16 f13) true))
(assert (= (< f13 f16) false))
(assert (= (< f16 f13) true))
(assert (= (= f13 f16) false))
(assert (= (= f16 f13) false))
(assert (forall ((?v0 Int)) (= (<= (f10 f11 ?v0) f16) (<= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (< (f10 f11 ?v0) f16) (<= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (= (f10 f11 ?v0) f16) false)))
(assert (forall ((?v0 Int)) (= (<= f16 (f10 f11 ?v0)) (< f16 ?v0))))
(assert (forall ((?v0 Int)) (= (< f16 (f10 f11 ?v0)) (< f16 ?v0))))
(assert (forall ((?v0 Int)) (= (= f16 (f10 f11 ?v0)) false)))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (=> (= (f3 ?v0 ?v1) f1) false) (=> (=> (= (f3 ?v1 ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v2 ?v0) f1) (= (f3 ?v2 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 ?v2) f1) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= ?v0 ?v2) (= (f3 ?v2 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= ?v0 ?v1) (=> (= (f3 ?v2 ?v1) f1) (= (f3 ?v2 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= ?v0 ?v1) (=> (= (f3 ?v1 ?v2) f1) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 ?v1) f1) (= (= (f3 ?v1 ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 ?v1) (= (f3 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f3 (f4 (f6 f30 ?v0) ?v1) ?v2) f1) (or (= (f3 ?v0 ?v2) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f10 (f25 f31 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f3 ?v0 (f4 (f6 f32 ?v1) ?v2)) f1) (or (= (f3 ?v0 ?v1) f1) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f10 (f25 f33 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= ?v0 ?v1) (and (= (f3 ?v0 ?v1) f1) (= (f3 ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (or (= (f3 ?v0 ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 f9 ?v0) (f8 f9 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 f18 ?v0) (f10 f18 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f18 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f19 f20 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f10 f12 ?v0) (f10 f12 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f10 f12 ?v0) (f10 f12 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f10 f12 ?v0) (f10 f12 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f10 f12 ?v0) (f10 f12 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 f12 ?v0) (f10 f12 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (< (f10 f12 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (f10 f12 ?v0) (+ (+ 1 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (- ?v0 f13) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 f13) ?v0)))
(assert (forall ((?v0 Int)) (= (+ f13 ?v0) ?v0)))
(assert (= (<= f13 f13) true))
(assert (= (< f13 0) false))
(assert (= (< f13 f13) false))
(assert (= (= f13 f13) true))
(assert (= (- f13) f13))
(assert (= f13 0))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 ?v2) f1) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (or (= (f3 ?v0 ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2)) (= (f3 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f10 f11 ?v0) (f10 f11 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f10 f11 ?v0) (f10 f11 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f10 f11 ?v0) (f10 f11 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f10 f11 ?v0) (f10 f11 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 f11 ?v0) (f10 f11 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f10 f11 ?v0) (f10 f11 ?v1)) (f10 f11 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f10 f11 ?v0) (f10 f11 ?v1)) (f10 f11 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (= (< (f10 f11 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (- (f10 f11 ?v0)) (f10 f11 (- ?v0)))))
(assert (forall ((?v0 Int)) (= (f10 f11 ?v0) (+ ?v0 ?v0))))
(assert (= (f10 f34 (- 1)) 1))
(assert (= (f4 f5 (f8 f9 f16)) f15))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f7 ?v0))) (= (f4 (f6 f7 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f6 f7 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f6 f7 ?v0) ?v1) (f4 (f6 f7 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (= (- f13 (f10 f12 ?v0)) (f10 f12 (- f16 ?v0)))))
(assert (forall ((?v0 S8)) (= (f19 f27 (f28 f29 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f28 f29 (f19 f27 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f28 f29 (f19 f27 ?v0)) 0))))
(check-sat)
(exit)
