(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) S1)
(declare-fun f7 (S6 S5) S4)
(declare-fun f8 () S6)
(declare-fun f9 (S7 S8) S5)
(declare-fun f10 () S7)
(declare-fun f11 (S9 S8) S8)
(declare-fun f12 (S10 S8) S9)
(declare-fun f13 () S10)
(declare-fun f14 () S8)
(declare-fun f15 () S8)
(declare-fun f16 () S5)
(declare-fun f17 () S6)
(declare-fun f18 () S5)
(declare-fun f19 () S5)
(declare-fun f20 (S11 S5) S5)
(declare-fun f21 (S12 S5) S11)
(declare-fun f22 () S12)
(declare-fun f23 () S5)
(declare-fun f24 () S5)
(declare-fun f25 () S5)
(declare-fun f26 () S11)
(declare-fun f27 () S12)
(declare-fun f28 () S11)
(declare-fun f29 () S2)
(declare-fun f30 () S10)
(declare-fun f31 () S8)
(declare-fun f32 () S8)
(declare-fun f33 () S12)
(declare-fun f34 () S3)
(declare-fun f35 () S12)
(declare-fun f36 () S3)
(declare-fun f37 () S12)
(declare-fun f38 () S10)
(declare-fun f39 () S3)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (- ?v0 ?v1))))
(assert (not (= (f6 (f7 f8 (f9 f10 (f11 (f12 f13 f14) f15))) f16) f1)))
(assert (= (f6 (f7 f17 f18) f16) f1))
(assert (= (f6 (f7 f17 f16) f19) f1))
(assert (= (f6 (f7 f17 f16) (f20 (f21 f22 f23) f24)) f1))
(assert (not (= f14 f15)))
(assert (= (f6 (f7 f17 (f9 f10 (f11 (f12 f13 f14) f15))) f16) f1))
(assert (= (f6 (f7 f17 f18) f23) f1))
(assert (= (f6 (f7 f17 f18) f24) f1))
(assert (= (f6 (f7 f17 f18) f16) f1))
(assert (= (f6 (f7 f17 f16) f19) f1))
(assert (not (= f14 f15)))
(assert (= (f6 (f7 f17 f16) (f20 (f21 f22 f23) f24)) f1))
(assert (= (f6 (f7 f17 f18) f25) f1))
(assert (= (f6 (f7 f17 f25) f19) f1))
(assert (= (f6 (f7 f17 (f9 f10 (f11 (f12 f13 f14) f15))) f16) f1))
(assert (= (f6 (f7 f8 f18) f16) f1))
(assert (= (f6 (f7 f8 (f9 f10 (f11 (f12 f13 f14) f15))) f19) f1))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f20 f26 (f20 (f21 f27 (f20 f28 ?v0)) (f20 f28 ?v1)))) (f20 f28 (f20 (f21 f27 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f6 (f7 f8 (f20 f26 (f20 (f21 f27 (f9 f10 ?v0)) (f9 f10 ?v1)))) (f9 f10 (f11 (f12 f13 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f20 (f21 f27 (f20 f28 ?v0)) (f20 f28 ?v1))) (f20 f28 (f20 (f21 f27 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f6 (f7 f8 (f20 (f21 f27 (f9 f10 ?v0)) (f9 f10 ?v1))) (f9 f10 (f11 (f12 f13 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f20 f28 (f20 (f21 f27 ?v0) ?v1)) (f20 f28 (f20 (f21 f27 ?v1) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f9 f10 (f11 (f12 f13 ?v0) ?v1)) (f9 f10 (f11 (f12 f13 ?v1) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f20 f26 (f20 (f21 f27 (f20 f26 ?v0)) (f20 f26 ?v1)))) (f20 f26 (f20 (f21 f27 ?v0) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f3 f29 (- (f3 f29 ?v0) (f3 f29 ?v1))) (f3 f29 (- ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f20 (f21 f27 (f20 f26 ?v0)) (f20 f26 ?v1))) (f20 f26 (f20 (f21 f27 ?v0) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f3 f29 ?v0) (f3 f29 ?v1)) (f3 f29 (- ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f20 (f21 f27 (f20 f26 ?v0)) (f20 f26 ?v1))) (f20 f26 (f20 (f21 f27 ?v1) ?v0))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f3 f29 ?v0) (f3 f29 ?v1)) (f3 f29 (- ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f20 (f21 f27 ?v0) ?v1) (f20 (f21 f27 ?v2) ?v3)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v2) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (<= ?v0 ?v1) (<= ?v2 ?v3)))))
(assert (forall ((?v0 S8)) (= (f6 (f7 f8 f18) (f9 f10 ?v0)) f1)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f18) (f20 f28 ?v0)) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 (f20 (f21 f27 ?v0) ?v1)) f18) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (<= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f9 f10 ?v0))) (= (f20 f26 ?v_0) ?v_0))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f20 f28 ?v0))) (= (f20 f26 ?v_0) ?v_0))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) ?v0) f1)))
(assert (= (f6 (f7 f17 f18) f19) f1))
(assert (= (f6 (f7 f17 f25) (f20 (f21 f22 f23) f24)) f1))
(assert (= (f6 (f7 f17 f18) (f20 (f21 f22 f23) f24)) f1))
(assert (exists ((?v0 S5)) (let ((?v_0 (f7 f17 ?v0))) (and (= (f6 (f7 f17 f18) ?v0) f1) (and (= (f6 ?v_0 f19) f1) (= (f6 ?v_0 (f20 (f21 f22 f23) f24)) f1))))))
(assert (=> (forall ((?v0 S5)) (let ((?v_0 (f7 f17 ?v0))) (=> (= (f6 (f7 f17 f18) ?v0) f1) (=> (= (f6 ?v_0 f19) f1) (=> (= (f6 ?v_0 (f20 (f21 f22 f23) f24)) f1) false))))) false))
(assert (not (= f18 f19)))
(assert (forall ((?v0 S5)) (not (= (f6 (f7 f17 ?v0) ?v0) f1))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 S5)) (not (= (f6 (f7 f17 (f20 f26 ?v0)) f18) f1))))
(assert (forall ((?v0 Int)) (not (< (f3 f29 ?v0) 0))))
(assert (= (f20 f26 f18) f18))
(assert (= (f3 f29 0) 0))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= ?v0 ?v1)) (or (= (f6 (f7 f17 ?v0) ?v1) f1) (= (f6 (f7 f17 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= (f6 (f7 f17 ?v0) ?v1) f1)) (or (= (f6 (f7 f17 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5)) (= (f20 (f21 f22 f18) ?v0) f18)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f30 f31) ?v0) f31)))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S5)) (= (= f19 ?v0) (= ?v0 f19))))
(assert (forall ((?v0 S8)) (= (= f32 ?v0) (= ?v0 f32))))
(assert (forall ((?v0 S5)) (= (= f18 ?v0) (= ?v0 f18))))
(assert (forall ((?v0 S8)) (= (= f31 ?v0) (= ?v0 f31))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f17 f18) (f20 f26 ?v0)) f1) (not (= ?v0 f18)))))
(assert (forall ((?v0 Int)) (= (< 0 (f3 f29 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f17 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f6 (f7 f17 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f17 ?v0))) (= (= (f6 ?v_0 (f20 (f21 f33 ?v1) ?v2)) f1) (or (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f3 (f4 f34 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f17 ?v0))) (= (= (f6 ?v_0 (f20 (f21 f35 ?v1) ?v2)) f1) (and (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f3 (f4 f36 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5)) (= (= (f20 f26 ?v0) f18) (= ?v0 f18))))
(assert (forall ((?v0 Int)) (= (= (f3 f29 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f17 (f20 (f21 f33 ?v0) ?v1)) ?v2) f1) (and (= (f6 (f7 f17 ?v0) ?v2) f1) (= (f6 (f7 f17 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f3 (f4 f34 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f17 (f20 (f21 f35 ?v0) ?v1)) ?v2) f1) (or (= (f6 (f7 f17 ?v0) ?v2) f1) (= (f6 (f7 f17 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f3 (f4 f36 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f17 ?v0) ?v1) f1)) (= (not (= (f6 (f7 f17 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f6 (f7 f17 ?v0) ?v1) f1) false) (=> (=> (= (f6 (f7 f17 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f17 f18) ?v0) f1) (= (f20 f26 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f3 f29 ?v0) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (not (= (f6 (f7 f17 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (= (not (= (f6 (f7 f17 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S1)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (= (=> (= (f6 (f7 f17 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 (f7 f17 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 (f7 f17 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= ?v0 ?v1) (=> (= (f6 (f7 f17 ?v1) ?v2) f1) (= (f6 (f7 f17 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f17 ?v2))) (=> (= ?v0 ?v1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f17 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f6 (f7 f17 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f17 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f17 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f17 ?v2))) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (=> (not false) (= (f6 (f7 f17 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (=> (= (f6 (f7 f17 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f6 (f7 f17 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 (f20 (f21 f27 ?v0) ?v1)) f18) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 f18)) (= (f20 f28 (f20 (f21 f22 ?v1) ?v0)) (f20 (f21 f22 (f20 f28 ?v1)) (f20 f28 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (not (= ?v0 f31)) (= (f9 f10 (f11 (f12 f30 ?v1) ?v0)) (f20 (f21 f22 (f9 f10 ?v1)) (f9 f10 ?v0))))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f17 f18) (f20 f28 ?v0)) f1) (not (= ?v0 f18)))))
(assert (forall ((?v0 S8)) (= (= (f6 (f7 f17 f18) (f9 f10 ?v0)) f1) (not (= ?v0 f31)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f17 ?v0) ?v1) f1) (= (f6 (f7 f17 (f20 (f21 f27 ?v0) ?v1)) f18) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (< (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f9 f10 (f11 (f12 f30 ?v0) ?v1)) (f20 (f21 f22 (f9 f10 ?v0)) (f9 f10 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f20 f28 (f20 (f21 f22 ?v0) ?v1)) (f20 (f21 f22 (f20 f28 ?v0)) (f20 f28 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f18))) (= (= (f6 ?v_0 (f20 (f21 f22 ?v0) ?v1)) f1) (and (or (= (f6 (f7 f8 ?v0) f18) f1) (= (f6 ?v_0 ?v1) f1)) (or (= (f6 ?v_0 ?v0) f1) (= (f6 (f7 f8 ?v1) f18) f1)))))))
(assert (= (f20 f28 f19) f19))
(assert (= (f9 f10 f32) f19))
(assert (forall ((?v0 S8)) (not (= (f6 (f7 f17 (f9 f10 ?v0)) f18) f1))))
(assert (forall ((?v0 S5)) (not (= (f6 (f7 f17 (f20 f28 ?v0)) f18) f1))))
(assert (forall ((?v0 S5)) (= (= (f20 f28 ?v0) f18) (= ?v0 f18))))
(assert (forall ((?v0 S8)) (= (= (f9 f10 ?v0) f18) (= ?v0 f31))))
(assert (= (f20 f28 f18) f18))
(assert (= (f9 f10 f31) f18))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f17 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f17 ?v1) ?v2) f1) (= (f6 (f7 f17 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) ?v0) f1) (= (f6 (f7 f17 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f17 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (not (= ?v1 ?v0)) (= (f6 (f7 f17 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (not (= ?v0 ?v1)) (= (f6 (f7 f17 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (or (= (f6 (f7 f17 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (not (= (f6 (f7 f17 ?v0) ?v1) f1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (not (= (f6 (f7 f17 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= (f6 (f7 f17 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f17 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f17 ?v0) ?v1) f1)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f8 ?v0) ?v1) f1)) (= (f6 (f7 f17 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f17 ?v0) ?v1) f1)) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (or (= (f6 (f7 f17 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f17 ?v0) ?v1) f1) (and (= (f6 (f7 f8 ?v0) ?v1) f1) (not (= (f6 (f7 f8 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f17 ?v0) ?v1) f1) (and (= (f6 (f7 f8 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f17 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= (f6 (f7 f8 ?v0) ?v1) f1)) (= (f6 (f7 f17 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= (f6 (f7 f17 ?v0) ?v1) f1)) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f20 (f21 f22 (f20 (f21 f27 ?v0) ?v1)) ?v2) (f20 (f21 f27 (f20 (f21 f22 ?v0) ?v2)) (f20 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f11 (f12 f30 (f11 (f12 f13 ?v0) ?v1)) ?v2) (f11 (f12 f13 (f11 (f12 f30 ?v0) ?v2)) (f11 (f12 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f8 f18) ?v0) f1) (= (f20 f26 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f29 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f8 (f20 f26 ?v0)) f18) f1) (= ?v0 f18))))
(assert (forall ((?v0 Int)) (= (<= (f3 f29 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f18) (f20 f26 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= 0 (f3 f29 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f20 (f21 f27 ?v0) ?v1) (f20 (f21 f27 ?v2) ?v3)) (= (= (f6 (f7 f17 ?v0) ?v1) f1) (= (f6 (f7 f17 ?v2) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (< ?v0 ?v1) (< ?v2 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (or (= (f6 (f7 f17 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f17 ?v0) ?v1) f1) (and (= (f6 (f7 f8 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f20 (f21 f27 ?v0) ?v1) f18) (= ?v0 ?v1))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f11 (f12 f13 ?v0) ?v1) f31) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0 ?v1) 0) (= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 ?v1) (= (f20 (f21 f27 ?v0) ?v1) f18))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= ?v0 ?v1) (= (f11 (f12 f13 ?v0) ?v1) f31))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S5)) (= (f20 (f21 f27 ?v0) ?v0) f18)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f13 ?v0) ?v0) f31)))
(assert (forall ((?v0 Int)) (= (- ?v0 ?v0) 0)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f27 ?v0) f18) ?v0)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f13 ?v0) f31) ?v0)))
(assert (forall ((?v0 Int)) (= (- ?v0 0) ?v0)))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f8 (f20 f28 ?v0)) f18) f1) (= ?v0 f18))))
(assert (forall ((?v0 S8)) (= (= (f6 (f7 f8 (f9 f10 ?v0)) f18) f1) (= ?v0 f31))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (=> (= (f6 (f7 f8 ?v0) ?v1) f1) false) (=> (=> (= (f6 (f7 f8 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 (f20 f26 ?v0)) ?v1) f1) (= (f6 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f3 f29 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f6 (f7 f8 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v2))) (=> (= ?v0 ?v1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= ?v0 ?v1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 (f7 f8 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= ?v0 ?v1) (= (f6 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f8 (f20 (f21 f35 ?v0) ?v1)) ?v2) f1) (or (= (f6 (f7 f8 ?v0) ?v2) f1) (= (f6 (f7 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f3 (f4 f36 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (= (f6 ?v_0 (f20 (f21 f33 ?v1) ?v2)) f1) (or (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f3 (f4 f34 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 ?v1) (and (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) (f20 f26 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 f29 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f20 (f21 f27 ?v0) ?v1) (f20 (f21 f27 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (=> (= (f11 (f12 f13 ?v0) ?v1) (f11 (f12 f13 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f20 (f21 f27 (f20 (f21 f35 ?v0) ?v1)) ?v2) (f20 (f21 f35 (f20 (f21 f27 ?v0) ?v2)) (f20 (f21 f27 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f36 ?v0) ?v1) ?v2) (f3 (f4 f36 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f20 (f21 f27 (f20 (f21 f33 ?v0) ?v1)) ?v2) (f20 (f21 f33 (f20 (f21 f27 ?v0) ?v2)) (f20 (f21 f27 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f34 ?v0) ?v1) ?v2) (f3 (f4 f34 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f20 f26 (f20 (f21 f27 ?v0) ?v1)) (f20 f26 (f20 (f21 f27 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f29 (- ?v0 ?v1)) (f3 f29 (- ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (= (f6 (f7 f17 (f20 (f21 f37 f25) f24)) f23) f1))
(assert (= (f6 (f7 f17 (f20 (f21 f37 f16) f24)) f23) f1))
(assert (= (f6 (f7 f17 f18) (f20 (f21 f37 f25) f24)) f1))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) f18) f1) (=> (= (f6 (f7 f17 ?v1) f18) f1) (= (f6 (f7 f8 f18) (f20 (f21 f22 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) f18) f1) (=> (= (f6 (f7 f17 f18) ?v1) f1) (= (f6 (f7 f8 (f20 (f21 f22 ?v0) ?v1)) f18) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f8 f18) ?v0) f1) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f17 f18) ?v2) f1) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (= (f6 (f7 f8 (f20 (f21 f22 ?v0) ?v3)) (f20 (f21 f22 ?v1) ?v2)) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f8 f18) ?v0) f1) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 (f7 f17 f18) ?v2) f1) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (= (f6 (f7 f17 (f20 (f21 f22 ?v0) ?v3)) (f20 (f21 f22 ?v1) ?v2)) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f17 f18))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 ?v_0 ?v2) f1) (=> (= (f6 (f7 f17 ?v2) ?v3) f1) (= (f6 (f7 f17 (f20 (f21 f22 ?v0) ?v3)) (f20 (f21 f22 ?v1) ?v2)) f1))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 f18) ?v0) f1) (=> (= (f6 (f7 f17 ?v1) f18) f1) (= (f6 (f7 f8 (f20 (f21 f22 ?v0) ?v1)) f18) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f18))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 (f7 f17 f18) ?v1) f1) (= (f6 ?v_0 (f20 (f21 f22 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f20 f28 (f20 (f21 f37 ?v0) ?v1)) (f20 (f21 f37 (f20 f28 ?v0)) (f20 f28 ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f9 f10 (f11 (f12 f38 ?v0) ?v1)) (f20 (f21 f37 (f9 f10 ?v0)) (f9 f10 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f20 (f21 f37 ?v0) ?v1) (f20 (f21 f37 ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f37 ?v0))) (= (f20 (f21 f37 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f20 (f21 f37 ?v1) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f12 f38 ?v0))) (= (f11 (f12 f38 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f11 (f12 f38 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f39 ?v0))) (= (f3 (f4 f39 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f39 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f37 ?v0))) (= (f20 (f21 f37 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f20 (f21 f37 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (= (f20 (f21 f37 (f20 (f21 f22 ?v0) ?v1)) (f20 (f21 f22 ?v2) ?v3)) (f20 (f21 f22 (f20 (f21 f37 ?v0) ?v2)) (f20 (f21 f37 ?v1) ?v3)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (= (f11 (f12 f38 (f11 (f12 f30 ?v0) ?v1)) (f11 (f12 f30 ?v2) ?v3)) (f11 (f12 f30 (f11 (f12 f38 ?v0) ?v2)) (f11 (f12 f38 ?v1) ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f20 f28 (f20 (f21 f37 ?v0) ?v1))) (f20 (f21 f37 (f20 f28 ?v0)) (f20 f28 ?v1))) f1)))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f6 (f7 f8 (f9 f10 (f11 (f12 f38 ?v0) ?v1))) (f20 (f21 f37 (f9 f10 ?v0)) (f9 f10 ?v1))) f1)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f17 (f20 f28 ?v0)) ?v1) f1) (=> (= (f6 (f7 f17 (f20 f28 ?v2)) ?v3) f1) (= (f6 (f7 f17 (f20 f28 (f20 (f21 f37 ?v0) ?v2))) (f20 (f21 f37 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S8) (?v1 S5) (?v2 S8) (?v3 S5)) (=> (= (f6 (f7 f17 (f9 f10 ?v0)) ?v1) f1) (=> (= (f6 (f7 f17 (f9 f10 ?v2)) ?v3) f1) (= (f6 (f7 f17 (f9 f10 (f11 (f12 f38 ?v0) ?v2))) (f20 (f21 f37 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S5)) (= (f20 (f21 f37 ?v0) f18) f18)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f38 ?v0) f31) f31)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f37 ?v0) f18) f18)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f38 ?v0) f31) f31)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f37 f18) ?v0) f18)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f38 f31) ?v0) f31)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f37 f18) ?v0) f18)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f38 f31) ?v0) f31)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f37 ?v0) f19) ?v0)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f38 ?v0) f32) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f37 ?v0) f19) ?v0)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f38 ?v0) f32) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f37 f19) ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f38 f32) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f37 f19) ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f38 f32) ?v0) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f37 ?v0))) (= (f20 ?v_0 (f20 (f21 f27 ?v1) ?v2)) (f20 (f21 f27 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f12 f38 ?v0))) (= (f11 ?v_0 (f11 (f12 f13 ?v1) ?v2)) (f11 (f12 f13 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f37 ?v0))) (= (f20 ?v_0 (f20 (f21 f27 ?v1) ?v2)) (f20 (f21 f27 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f12 f38 ?v0))) (= (f11 ?v_0 (f11 (f12 f13 ?v1) ?v2)) (f11 (f12 f13 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f20 (f21 f37 (f20 (f21 f27 ?v0) ?v1)) ?v2) (f20 (f21 f27 (f20 (f21 f37 ?v0) ?v2)) (f20 (f21 f37 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f11 (f12 f38 (f11 (f12 f13 ?v0) ?v1)) ?v2) (f11 (f12 f13 (f11 (f12 f38 ?v0) ?v2)) (f11 (f12 f38 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f20 (f21 f37 (f20 (f21 f27 ?v0) ?v1)) ?v2) (f20 (f21 f27 (f20 (f21 f37 ?v0) ?v2)) (f20 (f21 f37 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f11 (f12 f38 (f11 (f12 f13 ?v0) ?v1)) ?v2) (f11 (f12 f13 (f11 (f12 f38 ?v0) ?v2)) (f11 (f12 f38 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f37 ?v0))) (=> (not (= ?v0 f18)) (= (= (f20 ?v_0 ?v1) (f20 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f18)) (= (= (f20 (f21 f37 ?v1) ?v0) (f20 (f21 f37 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S5)) (= (f20 (f21 f37 f19) ?v0) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (not (= ?v0 f18)) (=> (not (= ?v1 f18)) (= (= (f20 (f21 f22 ?v2) ?v0) (f20 (f21 f22 ?v3) ?v1)) (= (f20 (f21 f37 ?v2) ?v1) (f20 (f21 f37 ?v3) ?v0)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (=> (not (= ?v0 f31)) (=> (not (= ?v1 f31)) (= (= (f11 (f12 f30 ?v2) ?v0) (f11 (f12 f30 ?v3) ?v1)) (= (f11 (f12 f38 ?v2) ?v1) (f11 (f12 f38 ?v3) ?v0)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f37 ?v0))) (=> (not (= ?v0 f18)) (= (f20 (f21 f22 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2)) (f20 (f21 f22 ?v1) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f12 f38 ?v0))) (=> (not (= ?v0 f31)) (= (f11 (f12 f30 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) (f11 (f12 f30 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f18)) (= (f20 (f21 f22 (f20 (f21 f37 ?v1) ?v0)) (f20 (f21 f37 ?v2) ?v0)) (f20 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (not (= ?v0 f31)) (= (f11 (f12 f30 (f11 (f12 f38 ?v1) ?v0)) (f11 (f12 f38 ?v2) ?v0)) (f11 (f12 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f20 (f21 f22 ?v0) ?v1) ?v2) (ite (not (= ?v1 f18)) (= ?v0 (f20 (f21 f37 ?v2) ?v1)) (= ?v2 f18)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (= (f11 (f12 f30 ?v0) ?v1) ?v2) (ite (not (= ?v1 f31)) (= ?v0 (f11 (f12 f38 ?v2) ?v1)) (= ?v2 f31)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= ?v0 (f20 (f21 f22 ?v1) ?v2)) (ite (not (= ?v2 f18)) (= (f20 (f21 f37 ?v0) ?v2) ?v1) (= ?v0 f18)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (= ?v0 (f11 (f12 f30 ?v1) ?v2)) (ite (not (= ?v2 f31)) (= (f11 (f12 f38 ?v0) ?v2) ?v1) (= ?v0 f31)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f22 ?v2))) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 (f7 f17 ?v2) f18) f1) (=> (= (f6 (f7 f17 f18) (f20 (f21 f37 ?v0) ?v1)) f1) (= (f6 (f7 f17 (f20 ?v_0 ?v0)) (f20 ?v_0 ?v1)) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f17 f18)) (?v_1 (f21 f22 ?v2))) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 ?v_0 ?v2) f1) (=> (= (f6 ?v_0 (f20 (f21 f37 ?v1) ?v0)) f1) (= (f6 (f7 f17 (f20 ?v_1 ?v1)) (f20 ?v_1 ?v0)) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 ?v0) f18) f1) (= (= (f6 (f7 f17 (f20 (f21 f22 ?v1) ?v0)) ?v2) f1) (= (f6 (f7 f17 (f20 (f21 f37 ?v2) ?v0)) ?v1) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 ?v0) f18) f1) (= (= (f6 (f7 f17 ?v1) (f20 (f21 f22 ?v2) ?v0)) f1) (= (f6 (f7 f17 ?v2) (f20 (f21 f37 ?v1) ?v0)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 f18) ?v0) f1) (=> (= (f6 (f7 f17 (f20 (f21 f37 ?v1) ?v0)) ?v2) f1) (= (f6 (f7 f17 ?v1) (f20 (f21 f22 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 f18) ?v0) f1) (=> (= (f6 (f7 f17 ?v1) (f20 (f21 f37 ?v2) ?v0)) f1) (= (f6 (f7 f17 (f20 (f21 f22 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 f18) ?v0) f1) (= (= (f6 (f7 f17 (f20 (f21 f22 ?v1) ?v0)) ?v2) f1) (= (f6 (f7 f17 ?v1) (f20 (f21 f37 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 f18) ?v0) f1) (= (= (f6 (f7 f17 ?v1) (f20 (f21 f22 ?v2) ?v0)) f1) (= (f6 (f7 f17 (f20 (f21 f37 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f7 f17 f18)) (?v_0 (f20 (f21 f37 ?v2) ?v1))) (= (= (f6 (f7 f17 (f20 (f21 f22 ?v0) ?v1)) ?v2) f1) (ite (= (f6 ?v_1 ?v1) f1) (= (f6 (f7 f17 ?v0) ?v_0) f1) (ite (= (f6 (f7 f17 ?v1) f18) f1) (= (f6 (f7 f17 ?v_0) ?v0) f1) (= (f6 ?v_1 ?v2) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f7 f17 ?v0)) (?v_0 (f20 (f21 f37 ?v0) ?v2))) (= (= (f6 ?v_1 (f20 (f21 f22 ?v1) ?v2)) f1) (ite (= (f6 (f7 f17 f18) ?v2) f1) (= (f6 (f7 f17 ?v_0) ?v1) f1) (ite (= (f6 (f7 f17 ?v2) f18) f1) (= (f6 (f7 f17 ?v1) ?v_0) f1) (= (f6 ?v_1 f18) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (not (= ?v0 f18)) (=> (not (= ?v1 f18)) (= (f20 (f21 f27 (f20 (f21 f22 ?v2) ?v0)) (f20 (f21 f22 ?v3) ?v1)) (f20 (f21 f22 (f20 (f21 f27 (f20 (f21 f37 ?v2) ?v1)) (f20 (f21 f37 ?v3) ?v0))) (f20 (f21 f37 ?v0) ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (=> (not (= ?v0 f31)) (=> (not (= ?v1 f31)) (= (f11 (f12 f13 (f11 (f12 f30 ?v2) ?v0)) (f11 (f12 f30 ?v3) ?v1)) (f11 (f12 f30 (f11 (f12 f13 (f11 (f12 f38 ?v2) ?v1)) (f11 (f12 f38 ?v3) ?v0))) (f11 (f12 f38 ?v0) ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f18)) (= (f20 (f21 f27 (f20 (f21 f22 ?v1) ?v0)) ?v2) (f20 (f21 f22 (f20 (f21 f27 ?v1) (f20 (f21 f37 ?v0) ?v2))) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (not (= ?v0 f31)) (= (f11 (f12 f13 (f11 (f12 f30 ?v1) ?v0)) ?v2) (f11 (f12 f30 (f11 (f12 f13 ?v1) (f11 (f12 f38 ?v0) ?v2))) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f18)) (= (f20 (f21 f27 ?v1) (f20 (f21 f22 ?v2) ?v0)) (f20 (f21 f22 (f20 (f21 f27 (f20 (f21 f37 ?v0) ?v1)) ?v2)) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (not (= ?v0 f31)) (= (f11 (f12 f13 ?v1) (f11 (f12 f30 ?v2) ?v0)) (f11 (f12 f30 (f11 (f12 f13 (f11 (f12 f38 ?v0) ?v1)) ?v2)) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f37 ?v0))) (=> (= (f6 (f7 f17 f18) ?v0) f1) (=> (= (f6 (f7 f17 ?v1) ?v2) f1) (= (f6 (f7 f17 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f17 f18))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 (f20 (f21 f37 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 f18) ?v0) f1) (= (= (f6 (f7 f17 (f20 (f21 f37 ?v1) ?v0)) (f20 (f21 f37 ?v2) ?v0)) f1) (= (f6 (f7 f17 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f22 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) f18) f1) (=> (= (f6 (f7 f17 f18) (f20 (f21 f37 ?v0) ?v1)) f1) (= (f6 (f7 f8 (f20 ?v_0 ?v0)) (f20 ?v_0 ?v1)) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f22 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 f18) ?v2) f1) (=> (= (f6 (f7 f17 f18) (f20 (f21 f37 ?v1) ?v0)) f1) (= (f6 (f7 f8 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 ?v0) f18) f1) (= (= (f6 (f7 f8 (f20 (f21 f22 ?v1) ?v0)) ?v2) f1) (= (f6 (f7 f8 (f20 (f21 f37 ?v2) ?v0)) ?v1) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 ?v0) f18) f1) (= (= (f6 (f7 f8 ?v1) (f20 (f21 f22 ?v2) ?v0)) f1) (= (f6 (f7 f8 ?v2) (f20 (f21 f37 ?v1) ?v0)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 f18) ?v0) f1) (=> (= (f6 (f7 f8 (f20 (f21 f37 ?v1) ?v0)) ?v2) f1) (= (f6 (f7 f8 ?v1) (f20 (f21 f22 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 f18) ?v0) f1) (=> (= (f6 (f7 f8 ?v1) (f20 (f21 f37 ?v2) ?v0)) f1) (= (f6 (f7 f8 (f20 (f21 f22 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 f18) ?v0) f1) (= (= (f6 (f7 f8 (f20 (f21 f22 ?v1) ?v0)) ?v2) f1) (= (f6 (f7 f8 ?v1) (f20 (f21 f37 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 f18) ?v0) f1) (= (= (f6 (f7 f8 ?v1) (f20 (f21 f22 ?v2) ?v0)) f1) (= (f6 (f7 f8 (f20 (f21 f37 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f20 (f21 f37 ?v2) ?v1))) (= (= (f6 (f7 f8 (f20 (f21 f22 ?v0) ?v1)) ?v2) f1) (ite (= (f6 (f7 f17 f18) ?v1) f1) (= (f6 (f7 f8 ?v0) ?v_0) f1) (ite (= (f6 (f7 f17 ?v1) f18) f1) (= (f6 (f7 f8 ?v_0) ?v0) f1) (= (f6 (f7 f8 f18) ?v2) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f7 f8 ?v0)) (?v_0 (f20 (f21 f37 ?v0) ?v2))) (= (= (f6 ?v_1 (f20 (f21 f22 ?v1) ?v2)) f1) (ite (= (f6 (f7 f17 f18) ?v2) f1) (= (f6 (f7 f8 ?v_0) ?v1) f1) (ite (= (f6 (f7 f17 ?v2) f18) f1) (= (f6 (f7 f8 ?v1) ?v_0) f1) (= (f6 ?v_1 f18) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 f18) ?v0) f1) (= (= (f6 (f7 f8 (f20 (f21 f37 ?v1) ?v0)) (f20 (f21 f37 ?v2) ?v0)) f1) (= (f6 (f7 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f37 ?v0))) (=> (= (f6 (f7 f17 f18) ?v0) f1) (= (= (f6 (f7 f8 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2)) f1) (= (f6 (f7 f8 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f20 f26 (f20 (f21 f22 ?v0) ?v1)) (f20 (f21 f22 (f20 f26 ?v0)) (f20 f26 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 f18)) (= (f20 f26 (f20 (f21 f22 ?v1) ?v0)) (f20 (f21 f22 (f20 f26 ?v1)) (f20 f26 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f18))) (= (= (f6 ?v_0 (f20 (f21 f22 ?v0) ?v1)) f1) (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1)) (and (= (f6 (f7 f8 ?v0) f18) f1) (= (f6 (f7 f8 ?v1) f18) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f18))) (= (= (f6 (f7 f8 (f20 (f21 f22 ?v0) ?v1)) f18) f1) (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 (f7 f8 ?v1) f18) f1)) (and (= (f6 (f7 f8 ?v0) f18) f1) (= (f6 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 f18) ?v2) f1) (= (f6 (f7 f8 (f20 (f21 f22 ?v0) ?v2)) (f20 (f21 f22 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) f18) f1) (= (f6 (f7 f8 (f20 (f21 f22 ?v1) ?v2)) (f20 (f21 f22 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 (f7 f17 ?v2) f18) f1) (= (f6 (f7 f17 (f20 (f21 f22 ?v1) ?v2)) (f20 (f21 f22 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 (f7 f17 f18) ?v2) f1) (= (f6 (f7 f17 (f20 (f21 f22 ?v0) ?v2)) (f20 (f21 f22 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) f18) f1) (=> (= (f6 (f7 f17 ?v1) f18) f1) (= (f6 (f7 f17 f18) (f20 (f21 f22 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) f18) f1) (=> (= (f6 (f7 f17 f18) ?v1) f1) (= (f6 (f7 f17 (f20 (f21 f22 ?v0) ?v1)) f18) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 f18) ?v0) f1) (=> (= (f6 (f7 f17 ?v1) f18) f1) (= (f6 (f7 f17 (f20 (f21 f22 ?v0) ?v1)) f18) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f17 f18))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 (f20 (f21 f22 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 f18) ?v0) f1) (= (f20 (f21 f22 (f20 f26 ?v1)) ?v0) (f20 f26 (f20 (f21 f22 ?v1) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f17 (f20 (f21 f22 ?v0) ?v1)) (f20 (f21 f22 ?v2) ?v1)) f1) (and (=> (= (f6 (f7 f17 f18) ?v1) f1) (= (f6 (f7 f17 ?v0) ?v2) f1)) (and (=> (= (f6 (f7 f17 ?v1) f18) f1) (= (f6 (f7 f17 ?v2) ?v0) f1)) (not (= ?v1 f18)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f17 f18))) (= (= (f6 (f7 f17 (f20 (f21 f22 ?v0) ?v1)) f18) f1) (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 (f7 f17 ?v1) f18) f1)) (and (= (f6 (f7 f17 ?v0) f18) f1) (= (f6 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f17 f18))) (= (= (f6 ?v_0 (f20 (f21 f22 ?v0) ?v1)) f1) (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1)) (and (= (f6 (f7 f17 ?v0) f18) f1) (= (f6 (f7 f17 ?v1) f18) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f8 (f20 (f21 f22 ?v0) ?v1)) (f20 (f21 f22 ?v2) ?v1)) f1) (and (=> (= (f6 (f7 f17 f18) ?v1) f1) (= (f6 (f7 f8 ?v0) ?v2) f1)) (=> (= (f6 (f7 f17 ?v1) f18) f1) (= (f6 (f7 f8 ?v2) ?v0) f1))))))
(assert (forall ((?v0 S8)) (exists ((?v1 S5)) (and (= (f6 (f7 f17 f18) ?v1) f1) (forall ((?v2 S8)) (= (f6 (f7 f8 (f9 f10 (f11 (f12 f30 ?v2) ?v0))) (f20 (f21 f37 (f9 f10 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (and (= (f6 (f7 f17 f18) ?v1) f1) (forall ((?v2 S5)) (= (f6 (f7 f8 (f20 f28 (f20 (f21 f22 ?v2) ?v0))) (f20 (f21 f37 (f20 f28 ?v2)) ?v1)) f1))))))
(assert (exists ((?v0 S5)) (and (= (f6 (f7 f17 f18) ?v0) f1) (forall ((?v1 S5) (?v2 S5)) (= (f6 (f7 f8 (f20 f28 (f20 (f21 f37 ?v1) ?v2))) (f20 (f21 f37 (f20 (f21 f37 (f20 f28 ?v1)) (f20 f28 ?v2))) ?v0)) f1)))))
(assert (exists ((?v0 S5)) (and (= (f6 (f7 f17 f18) ?v0) f1) (forall ((?v1 S8) (?v2 S8)) (= (f6 (f7 f8 (f9 f10 (f11 (f12 f38 ?v1) ?v2))) (f20 (f21 f37 (f20 (f21 f37 (f9 f10 ?v1)) (f9 f10 ?v2))) ?v0)) f1)))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (and (= (f6 (f7 f17 f18) ?v1) f1) (forall ((?v2 S5)) (= (f6 (f7 f8 (f20 f28 (f20 (f21 f37 ?v0) ?v2))) (f20 (f21 f37 (f20 f28 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S8)) (exists ((?v1 S5)) (and (= (f6 (f7 f17 f18) ?v1) f1) (forall ((?v2 S8)) (= (f6 (f7 f8 (f9 f10 (f11 (f12 f38 ?v0) ?v2))) (f20 (f21 f37 (f9 f10 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (and (= (f6 (f7 f17 f18) ?v1) f1) (forall ((?v2 S5)) (= (f6 (f7 f8 (f20 f28 (f20 (f21 f37 ?v2) ?v0))) (f20 (f21 f37 (f20 f28 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S8)) (exists ((?v1 S5)) (and (= (f6 (f7 f17 f18) ?v1) f1) (forall ((?v2 S8)) (= (f6 (f7 f8 (f9 f10 (f11 (f12 f38 ?v2) ?v0))) (f20 (f21 f37 (f9 f10 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S8)) (exists ((?v1 S5)) (and (= (f6 (f7 f8 f18) ?v1) f1) (forall ((?v2 S8)) (= (f6 (f7 f8 (f9 f10 (f11 (f12 f30 ?v2) ?v0))) (f20 (f21 f37 (f9 f10 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (and (= (f6 (f7 f8 f18) ?v1) f1) (forall ((?v2 S5)) (= (f6 (f7 f8 (f20 f28 (f20 (f21 f22 ?v2) ?v0))) (f20 (f21 f37 (f20 f28 ?v2)) ?v1)) f1))))))
(assert (exists ((?v0 S5)) (and (= (f6 (f7 f8 f18) ?v0) f1) (forall ((?v1 S5) (?v2 S5)) (= (f6 (f7 f8 (f20 f28 (f20 (f21 f37 ?v1) ?v2))) (f20 (f21 f37 (f20 (f21 f37 (f20 f28 ?v1)) (f20 f28 ?v2))) ?v0)) f1)))))
(assert (exists ((?v0 S5)) (and (= (f6 (f7 f8 f18) ?v0) f1) (forall ((?v1 S8) (?v2 S8)) (= (f6 (f7 f8 (f9 f10 (f11 (f12 f38 ?v1) ?v2))) (f20 (f21 f37 (f20 (f21 f37 (f9 f10 ?v1)) (f9 f10 ?v2))) ?v0)) f1)))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (and (= (f6 (f7 f8 f18) ?v1) f1) (forall ((?v2 S5)) (= (f6 (f7 f8 (f20 f28 (f20 (f21 f37 ?v0) ?v2))) (f20 (f21 f37 (f20 f28 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S8)) (exists ((?v1 S5)) (and (= (f6 (f7 f8 f18) ?v1) f1) (forall ((?v2 S8)) (= (f6 (f7 f8 (f9 f10 (f11 (f12 f38 ?v0) ?v2))) (f20 (f21 f37 (f9 f10 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (and (= (f6 (f7 f8 f18) ?v1) f1) (forall ((?v2 S5)) (= (f6 (f7 f8 (f20 f28 (f20 (f21 f37 ?v2) ?v0))) (f20 (f21 f37 (f20 f28 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S8)) (exists ((?v1 S5)) (and (= (f6 (f7 f8 f18) ?v1) f1) (forall ((?v2 S8)) (= (f6 (f7 f8 (f9 f10 (f11 (f12 f38 ?v2) ?v0))) (f20 (f21 f37 (f9 f10 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (=> (= (f6 (f7 f17 f18) ?v2) f1) (=> (= (f6 (f7 f17 ?v2) f19) f1) (= (f6 (f7 f8 (f20 (f21 f37 ?v2) ?v0)) ?v1) f1)))) (= (f6 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) f18) f1) (=> (= (f6 (f7 f8 (f20 f28 ?v1)) (f20 (f21 f37 ?v0) (f20 f28 ?v2))) f1) (= ?v1 f18)))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (=> (= (f6 (f7 f8 ?v0) f18) f1) (=> (= (f6 (f7 f8 (f9 f10 ?v1)) (f20 (f21 f37 ?v0) (f9 f10 ?v2))) f1) (= ?v1 f31)))))
(assert (forall ((?v0 S8)) (exists ((?v1 S5)) (forall ((?v2 S8)) (= (f6 (f7 f8 (f9 f10 (f11 (f12 f30 ?v2) ?v0))) (f20 (f21 f37 (f9 f10 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (forall ((?v2 S5)) (= (f6 (f7 f8 (f20 f28 (f20 (f21 f22 ?v2) ?v0))) (f20 (f21 f37 (f20 f28 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) f18) f1) (=> (= (f6 (f7 f8 (f20 f26 ?v1)) (f20 (f21 f37 ?v0) (f20 f26 ?v2))) f1) (= ?v1 f18)))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (forall ((?v2 S5)) (= (f6 (f7 f8 (f20 f28 (f20 (f21 f37 ?v2) ?v0))) (f20 (f21 f37 (f20 f28 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S8)) (exists ((?v1 S5)) (forall ((?v2 S8)) (= (f6 (f7 f8 (f9 f10 (f11 (f12 f38 ?v2) ?v0))) (f20 (f21 f37 (f9 f10 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (forall ((?v2 S5)) (= (f6 (f7 f8 (f20 f28 (f20 (f21 f37 ?v0) ?v2))) (f20 (f21 f37 (f20 f28 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S8)) (exists ((?v1 S5)) (forall ((?v2 S8)) (= (f6 (f7 f8 (f9 f10 (f11 (f12 f38 ?v0) ?v2))) (f20 (f21 f37 (f9 f10 ?v2)) ?v1)) f1)))))
(assert (exists ((?v0 S5)) (forall ((?v1 S5) (?v2 S5)) (= (f6 (f7 f8 (f20 f28 (f20 (f21 f37 ?v1) ?v2))) (f20 (f21 f37 (f20 (f21 f37 (f20 f28 ?v1)) (f20 f28 ?v2))) ?v0)) f1))))
(assert (exists ((?v0 S5)) (forall ((?v1 S8) (?v2 S8)) (= (f6 (f7 f8 (f9 f10 (f11 (f12 f38 ?v1) ?v2))) (f20 (f21 f37 (f20 (f21 f37 (f9 f10 ?v1)) (f9 f10 ?v2))) ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (f3 (f4 f39 ?v1) ?v0) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f18))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) f19) f1) (= (f6 (f7 f8 (f20 (f21 f37 ?v1) ?v0)) ?v0) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f6 (f7 f17 ?v0) ?v1) f1) false) (=> (=> (= (f6 (f7 f17 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f20 f26 (f20 (f21 f37 ?v0) ?v1)) (f20 (f21 f37 (f20 f26 ?v0)) (f20 f26 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f29 (f3 (f4 f39 ?v0) ?v1)) (f3 (f4 f39 (f3 f29 ?v0)) (f3 f29 ?v1)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f20 f26 ?v0))) (= (f20 (f21 f37 ?v_0) ?v_0) (f20 (f21 f37 ?v0) ?v0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f29 ?v0))) (= (f3 (f4 f39 ?v_0) ?v_0) (f3 (f4 f39 ?v0) ?v0)))))
(assert (= (f20 f26 f19) f19))
(assert (= (f3 f29 1) 1))
(assert (forall ((?v0 S5)) (= (f20 (f21 f37 f18) ?v0) f18)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f38 f31) ?v0) f31)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f37 ?v0) f18) f18)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f38 ?v0) f31) f31)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f20 (f21 f37 ?v0) ?v1) f18) (or (= ?v0 f18) (= ?v1 f18)))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f11 (f12 f38 ?v0) ?v1) f31) (or (= ?v0 f31) (= ?v1 f31)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f39 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 f18)) (=> (not (= ?v1 f18)) (not (= (f20 (f21 f37 ?v0) ?v1) f18))))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (not (= ?v0 f31)) (=> (not (= ?v1 f31)) (not (= (f11 (f12 f38 ?v0) ?v1) f31))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (f3 (f4 f39 ?v0) ?v1) 0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f20 (f21 f37 ?v0) ?v1) f18) (or (= ?v0 f18) (= ?v1 f18)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f11 (f12 f38 ?v0) ?v1) f31) (or (= ?v0 f31) (= ?v1 f31)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 (f4 f39 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f20 f26 ?v0)) (?v_1 (f20 f26 ?v2))) (=> (= (f6 (f7 f17 ?v_0) ?v1) f1) (=> (= (f6 (f7 f17 ?v_1) ?v3) f1) (= (f6 (f7 f17 (f20 (f21 f37 ?v_0) ?v_1)) (f20 (f21 f37 ?v1) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f3 f29 ?v0)) (?v_1 (f3 f29 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (f3 (f4 f39 ?v_0) ?v_1) (f3 (f4 f39 ?v1) ?v3)))))))
(assert (not (= 1 0)))
(assert (not (= f19 f18)))
(assert (not (= f32 f31)))
(assert (not (= 0 1)))
(assert (not (= f18 f19)))
(assert (not (= f31 f32)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f22 f18) ?v0) f18)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f30 f31) ?v0) f31)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f22 ?v0) f18) f18)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f30 ?v0) f31) f31)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f37 ?v0))) (= (f20 ?v_0 (f20 (f21 f22 ?v1) ?v2)) (f20 (f21 f22 (f20 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f12 f38 ?v0))) (= (f11 ?v_0 (f11 (f12 f30 ?v1) ?v2)) (f11 (f12 f30 (f11 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5)) (= (f20 (f21 f22 ?v0) f19) ?v0)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f30 ?v0) f32) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f20 (f21 f22 (f20 (f21 f27 ?v0) ?v1)) ?v2) (f20 (f21 f27 (f20 (f21 f22 ?v0) ?v2)) (f20 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f11 (f12 f30 (f11 (f12 f13 ?v0) ?v1)) ?v2) (f11 (f12 f13 (f11 (f12 f30 ?v0) ?v2)) (f11 (f12 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f18))) (=> (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 (f7 f8 ?v1) f18) f1)) (and (= (f6 (f7 f8 ?v0) f18) f1) (= (f6 ?v_0 ?v1) f1))) (= (f6 (f7 f8 (f20 (f21 f37 ?v0) ?v1)) f18) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (f3 (f4 f39 ?v0) ?v1) 0))))
(check-sat)
(exit)
