(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S2) S1)
(declare-fun f4 () S2)
(declare-fun f5 () S2)
(declare-fun f6 (S3 S2) S2)
(declare-fun f7 () S3)
(declare-fun f8 (S4 S2) S3)
(declare-fun f9 () S4)
(declare-fun f10 () S2)
(declare-fun f11 () S2)
(declare-fun f12 (S2 S2) S1)
(declare-fun f13 () S4)
(declare-fun f14 (S5 Int) S2)
(declare-fun f15 () S5)
(declare-fun f16 (S6 Int) Int)
(declare-fun f17 () S6)
(declare-fun f18 () S6)
(declare-fun f19 () Int)
(declare-fun f20 () S4)
(declare-fun f21 (S7 Int) S6)
(declare-fun f22 () S7)
(declare-fun f23 () S6)
(declare-fun f24 () S6)
(declare-fun f25 () S4)
(declare-fun f26 () S7)
(declare-fun f27 () S4)
(declare-fun f28 () S7)
(declare-fun f29 (S8 Int) S9)
(declare-fun f30 () S8)
(declare-fun f31 (S10 S9) Int)
(declare-fun f32 () S10)
(assert (not (= f1 f2)))
(assert (not false))
(assert (= (f3 f4 f5) f1))
(assert (= (f3 (f6 f7 (f6 (f8 f9 f10) f11)) f5) f1))
(assert (= (f12 (f6 (f8 f13 (f14 f15 (f16 f17 (f16 f18 f19)))) f5) (f6 (f8 f20 (f6 f7 (f6 (f8 f9 f10) f11))) f4)) f1))
(assert (forall ((?v0 S2)) (= (f6 (f8 f13 ?v0) (f14 f15 (f16 f17 (f16 f18 f19)))) (f6 (f8 f20 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* ?v0 2) (+ ?v0 ?v0))))
(assert (forall ((?v0 S2)) (= (f6 (f8 f13 ?v0) (f14 f15 (f16 f17 (f16 f18 f19)))) (f6 (f8 f20 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* ?v0 2) (+ ?v0 ?v0))))
(assert (forall ((?v0 S2)) (= (f6 (f8 f13 (f14 f15 (f16 f17 (f16 f18 f19)))) ?v0) (f6 (f8 f20 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* 2 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S2)) (= (f6 (f8 f13 (f14 f15 (f16 f17 (f16 f18 f19)))) ?v0) (f6 (f8 f20 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* 2 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S2)) (= (f6 (f8 f13 ?v0) (f14 f15 (f16 f18 f19))) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S2)) (= (f6 (f8 f13 (f14 f15 (f16 f18 f19))) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (= (= (f3 (f6 (f8 f20 (f6 (f8 f13 ?v0) ?v1)) ?v2) (f6 (f8 f20 (f6 (f8 f13 ?v3) ?v1)) ?v4)) f1) (= (f3 ?v2 (f6 (f8 f20 (f6 (f8 f13 (f6 (f8 f9 ?v3) ?v0)) ?v1)) ?v4)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (< (+ (f16 (f21 f22 ?v0) ?v1) ?v2) (+ (f16 (f21 f22 ?v3) ?v1) ?v4)) (< ?v2 (+ (f16 (f21 f22 (- ?v3 ?v0)) ?v1) ?v4)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (= (= (f3 (f6 (f8 f20 (f6 (f8 f13 ?v0) ?v1)) ?v2) (f6 (f8 f20 (f6 (f8 f13 ?v3) ?v1)) ?v4)) f1) (= (f3 (f6 (f8 f20 (f6 (f8 f13 (f6 (f8 f9 ?v0) ?v3)) ?v1)) ?v2) ?v4) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (< (+ (f16 (f21 f22 ?v0) ?v1) ?v2) (+ (f16 (f21 f22 ?v3) ?v1) ?v4)) (< (+ (f16 (f21 f22 (- ?v0 ?v3)) ?v1) ?v2) ?v4))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (= (= (f12 (f6 (f8 f20 (f6 (f8 f13 ?v0) ?v1)) ?v2) (f6 (f8 f20 (f6 (f8 f13 ?v3) ?v1)) ?v4)) f1) (= (f12 ?v2 (f6 (f8 f20 (f6 (f8 f13 (f6 (f8 f9 ?v3) ?v0)) ?v1)) ?v4)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (<= (+ (f16 (f21 f22 ?v0) ?v1) ?v2) (+ (f16 (f21 f22 ?v3) ?v1) ?v4)) (<= ?v2 (+ (f16 (f21 f22 (- ?v3 ?v0)) ?v1) ?v4)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (= (= (f12 (f6 (f8 f20 (f6 (f8 f13 ?v0) ?v1)) ?v2) (f6 (f8 f20 (f6 (f8 f13 ?v3) ?v1)) ?v4)) f1) (= (f12 (f6 (f8 f20 (f6 (f8 f13 (f6 (f8 f9 ?v0) ?v3)) ?v1)) ?v2) ?v4) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (<= (+ (f16 (f21 f22 ?v0) ?v1) ?v2) (+ (f16 (f21 f22 ?v3) ?v1) ?v4)) (<= (+ (f16 (f21 f22 (- ?v0 ?v3)) ?v1) ?v2) ?v4))))
(assert (forall ((?v0 S2)) (= (f6 (f8 f20 ?v0) (f14 f15 f19)) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S2)) (= (f6 (f8 f20 (f14 f15 f19)) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (f16 (f21 f22 f19) ?v0) f19)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f21 f22 (f16 f17 ?v0)) ?v1) (f16 f17 (f16 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f21 f22 (f16 f18 ?v0)) ?v1) (+ (f16 f17 (f16 (f21 f22 ?v0) ?v1)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 ?v0 ?v1) f1) false) (=> (=> (= (f3 ?v1 ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f23 ?v0))) (= (f16 (f21 f22 ?v_0) ?v_0) (f16 (f21 f22 ?v0) ?v0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 ?v0))) (= (f6 (f8 f13 ?v_0) ?v_0) (f6 (f8 f13 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 f23 (f16 (f21 f22 ?v0) ?v1)) (f16 (f21 f22 (f16 f23 ?v0)) (f16 f23 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f6 f7 (f6 (f8 f13 ?v0) ?v1)) (f6 (f8 f13 (f6 f7 ?v0)) (f6 f7 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 f15 ?v0) (f14 f15 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 f24 ?v0) (f16 f24 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f24 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f16 f18 ?v0) (f16 f18 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f16 f18 ?v0) (f16 f18 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f16 f18 ?v0) (f16 f18 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f16 f18 ?v0) (f16 f18 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 f18 ?v0) (f16 f18 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (< (f16 f18 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (f16 f18 ?v0) (+ (+ 1 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (- ?v0 f19) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 f19) ?v0)))
(assert (forall ((?v0 Int)) (= (+ f19 ?v0) ?v0)))
(assert (= (<= f19 f19) true))
(assert (= (< f19 0) false))
(assert (= (< f19 f19) false))
(assert (= (= f19 f19) true))
(assert (= (- f19) f19))
(assert (= f19 0))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f16 f17 ?v0) (f16 f17 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f16 f17 ?v0) (f16 f17 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f16 f17 ?v0) (f16 f17 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f16 f17 ?v0) (f16 f17 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 f17 ?v0) (f16 f17 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f16 f17 ?v0) (f16 f17 ?v1)) (f16 f17 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f16 f17 ?v0) (f16 f17 ?v1)) (f16 f17 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (= (< (f16 f17 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (- (f16 f17 ?v0)) (f16 f17 (- ?v0)))))
(assert (forall ((?v0 Int)) (= (f16 f17 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f16 f23 ?v0)) (?v_1 (f16 f23 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (f16 (f21 f22 ?v_0) ?v_1) (f16 (f21 f22 ?v1) ?v3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f6 f7 ?v0)) (?v_1 (f6 f7 ?v2))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_1 ?v3) f1) (= (f3 (f6 (f8 f13 ?v_0) ?v_1) (f6 (f8 f13 ?v1) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 ?v0)) (?v_1 (f14 f15 ?v1))) (= (f6 (f8 f25 ?v_0) ?v_1) (ite (= (f12 ?v_0 ?v_1) f1) ?v_0 ?v_1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f24 ?v0)) (?v_1 (f16 f24 ?v1))) (= (f16 (f21 f26 ?v_0) ?v_1) (ite (<= ?v_0 ?v_1) ?v_0 ?v_1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 ?v0)) (?v_1 (f14 f15 ?v1))) (= (f6 (f8 f27 ?v_0) ?v_1) (ite (= (f12 ?v_0 ?v_1) f1) ?v_1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f24 ?v0)) (?v_1 (f16 f24 ?v1))) (= (f16 (f21 f28 ?v_0) ?v_1) (ite (<= ?v_0 ?v_1) ?v_1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f12 (f14 f15 ?v0) (f14 f15 ?v1)) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f16 f24 ?v0) (f16 f24 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f14 f15 ?v0) (f14 f15 ?v1)) f1) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f16 f24 ?v0) (f16 f24 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (f6 (f8 f20 (f6 (f8 f13 ?v0) ?v1)) (f6 (f8 f20 (f6 (f8 f13 ?v2) ?v1)) ?v3)) (f6 (f8 f20 (f6 (f8 f13 (f6 (f8 f20 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (f16 (f21 f22 ?v0) ?v1) (+ (f16 (f21 f22 ?v2) ?v1) ?v3)) (+ (f16 (f21 f22 (+ ?v0 ?v2)) ?v1) ?v3))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f6 (f8 f13 (f6 (f8 f20 ?v0) ?v1)) ?v2) (f6 (f8 f20 (f6 (f8 f13 ?v0) ?v2)) (f6 (f8 f13 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f16 (f21 f22 (+ ?v0 ?v1)) ?v2) (+ (f16 (f21 f22 ?v0) ?v2) (f16 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f6 (f8 f13 (f14 f15 ?v0)) (f6 (f8 f13 (f14 f15 ?v1)) ?v2)) (f6 (f8 f13 (f14 f15 (f16 (f21 f22 ?v0) ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f16 (f21 f22 (f16 f24 ?v0)) (f16 (f21 f22 (f16 f24 ?v1)) ?v2)) (f16 (f21 f22 (f16 f24 (f16 (f21 f22 ?v0) ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f8 f13 (f14 f15 ?v0)) (f14 f15 ?v1)) (f14 f15 (f16 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f21 f22 (f16 f24 ?v0)) (f16 f24 ?v1)) (f16 f24 (f16 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f14 f15 (f16 (f21 f22 ?v0) ?v1)) (f6 (f8 f13 (f14 f15 ?v0)) (f14 f15 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 f24 (f16 (f21 f22 ?v0) ?v1)) (f16 (f21 f22 (f16 f24 ?v0)) (f16 f24 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f6 (f8 f20 (f14 f15 ?v0)) (f6 (f8 f20 (f14 f15 ?v1)) ?v2)) (f6 (f8 f20 (f14 f15 (+ ?v0 ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f16 f24 ?v0) (+ (f16 f24 ?v1) ?v2)) (+ (f16 f24 (+ ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f8 f20 (f14 f15 ?v0)) (f14 f15 ?v1)) (f14 f15 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f16 f24 ?v0) (f16 f24 ?v1)) (f16 f24 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f14 f15 (+ ?v0 ?v1)) (f6 (f8 f20 (f14 f15 ?v0)) (f14 f15 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 f24 (+ ?v0 ?v1)) (+ (f16 f24 ?v0) (f16 f24 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f8 f9 (f14 f15 ?v0)) (f14 f15 ?v1)) (f14 f15 (+ ?v0 (- ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f16 f24 ?v0) (f16 f24 ?v1)) (f16 f24 (+ ?v0 (- ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f14 f15 (- ?v0 ?v1)) (f6 (f8 f9 (f14 f15 ?v0)) (f14 f15 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 f24 (- ?v0 ?v1)) (- (f16 f24 ?v0) (f16 f24 ?v1)))))
(assert (forall ((?v0 Int)) (= (<= (f16 f18 ?v0) f19) (< ?v0 f19))))
(assert (forall ((?v0 Int)) (= (< (f16 f18 ?v0) f19) (< ?v0 f19))))
(assert (forall ((?v0 Int)) (= (= (f16 f18 ?v0) f19) false)))
(assert (forall ((?v0 Int)) (= (<= f19 (f16 f18 ?v0)) (<= f19 ?v0))))
(assert (forall ((?v0 Int)) (= (< f19 (f16 f18 ?v0)) (<= f19 ?v0))))
(assert (forall ((?v0 Int)) (= (= f19 (f16 f18 ?v0)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f16 f18 ?v0) (f16 f17 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f16 f18 ?v0) (f16 f17 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f16 f17 ?v0) (f16 f18 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f16 f17 ?v0) (f16 f18 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f16 f18 ?v0) (f16 f17 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f16 f18 ?v0) (f16 f17 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f16 f17 ?v0) (f16 f18 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f16 f17 ?v0) (f16 f18 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f16 f18 ?v0) (f16 f18 ?v1)) (f16 f17 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f16 f18 ?v0) (f16 f17 ?v1)) (f16 f18 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f16 f18 ?v0) (f16 f17 ?v1)) (f16 f18 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f16 f17 ?v0) (f16 f18 ?v1)) (f16 f18 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 f18 ?v0) (f16 f17 ?v1)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 f17 ?v0) (f16 f18 ?v1)) false)))
(assert (forall ((?v0 Int)) (= (<= (f16 f17 ?v0) f19) (<= ?v0 f19))))
(assert (forall ((?v0 Int)) (= (< (f16 f17 ?v0) f19) (< ?v0 f19))))
(assert (forall ((?v0 Int)) (= (= (f16 f17 ?v0) f19) (= ?v0 f19))))
(assert (forall ((?v0 Int)) (= (<= f19 (f16 f17 ?v0)) (<= f19 ?v0))))
(assert (forall ((?v0 Int)) (= (< f19 (f16 f17 ?v0)) (< f19 ?v0))))
(assert (forall ((?v0 Int)) (= (= f19 (f16 f17 ?v0)) (= f19 ?v0))))
(assert (forall ((?v0 Int)) (= (- f19 (f16 f17 ?v0)) (f16 f17 (- f19 ?v0)))))
(assert (= (f16 f17 f19) f19))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_1 (f14 f15 ?v0)) (?v_0 (f14 f15 ?v1))) (= (= (f12 ?v_1 ?v_0) f1) (not (= (f3 ?v_0 ?v_1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f24 ?v1)) (?v_1 (f16 f24 ?v0))) (= (<= ?v_1 ?v_0) (not (< ?v_0 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f14 f15 ?v2))) (= (f6 (f8 f13 (f6 (f8 f20 ?v0) ?v1)) ?v_0) (f6 (f8 f20 (f6 (f8 f13 ?v0) ?v_0)) (f6 (f8 f13 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f24 ?v2))) (= (f16 (f21 f22 (+ ?v0 ?v1)) ?v_0) (+ (f16 (f21 f22 ?v0) ?v_0) (f16 (f21 f22 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f13 (f14 f15 ?v0)))) (= (f6 ?v_0 (f6 (f8 f20 ?v1) ?v2)) (f6 (f8 f20 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f21 f22 (f16 f24 ?v0)))) (= (f16 ?v_0 (+ ?v1 ?v2)) (+ (f16 ?v_0 ?v1) (f16 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (= (= (f6 (f8 f20 (f6 (f8 f13 ?v0) ?v1)) ?v2) (f6 (f8 f20 (f6 (f8 f13 ?v3) ?v1)) ?v4)) (= (f6 (f8 f20 (f6 (f8 f13 (f6 (f8 f9 ?v0) ?v3)) ?v1)) ?v2) ?v4))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (= (+ (f16 (f21 f22 ?v0) ?v1) ?v2) (+ (f16 (f21 f22 ?v3) ?v1) ?v4)) (= (+ (f16 (f21 f22 (- ?v0 ?v3)) ?v1) ?v2) ?v4))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (= (= (f6 (f8 f20 (f6 (f8 f13 ?v0) ?v1)) ?v2) (f6 (f8 f20 (f6 (f8 f13 ?v3) ?v1)) ?v4)) (= ?v2 (f6 (f8 f20 (f6 (f8 f13 (f6 (f8 f9 ?v3) ?v0)) ?v1)) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (= (+ (f16 (f21 f22 ?v0) ?v1) ?v2) (+ (f16 (f21 f22 ?v3) ?v1) ?v4)) (= ?v2 (+ (f16 (f21 f22 (- ?v3 ?v0)) ?v1) ?v4)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f14 f15 ?v2))) (= (f6 (f8 f13 (f6 (f8 f9 ?v0) ?v1)) ?v_0) (f6 (f8 f9 (f6 (f8 f13 ?v0) ?v_0)) (f6 (f8 f13 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 f24 ?v2))) (= (f16 (f21 f22 (- ?v0 ?v1)) ?v_0) (- (f16 (f21 f22 ?v0) ?v_0) (f16 (f21 f22 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f13 (f14 f15 ?v0)))) (= (f6 ?v_0 (f6 (f8 f9 ?v1) ?v2)) (f6 (f8 f9 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f21 f22 (f16 f24 ?v0)))) (= (f16 ?v_0 (- ?v1 ?v2)) (- (f16 ?v_0 ?v1) (f16 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f6 (f8 f20 (f14 f15 ?v0)) (f6 (f8 f9 (f14 f15 ?v1)) ?v2)) (f6 (f8 f9 (f14 f15 (+ ?v0 ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f16 f24 ?v0) (- (f16 f24 ?v1) ?v2)) (- (f16 f24 (+ ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int)) (= (f6 (f8 f20 (f14 f15 ?v0)) (f6 (f8 f9 ?v1) (f14 f15 ?v2))) (f6 (f8 f20 (f14 f15 (+ ?v0 (- ?v2)))) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f16 f24 ?v0) (- ?v1 (f16 f24 ?v2))) (+ (f16 f24 (+ ?v0 (- ?v2))) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f19 ?v0) (=> (<= f19 ?v1) (= (f6 (f8 f20 (f14 f15 ?v0)) (f14 f15 ?v1)) (f14 f15 (+ ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f19 ?v0) (=> (<= f19 ?v1) (= (+ (f16 f24 ?v0) (f16 f24 ?v1)) (f16 f24 (+ ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f19 ?v0) (=> (<= f19 ?v1) (= (f6 (f8 f13 (f14 f15 ?v0)) (f14 f15 ?v1)) (f14 f15 (f16 (f21 f22 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f19 ?v0) (=> (<= f19 ?v1) (= (f16 (f21 f22 (f16 f24 ?v0)) (f16 f24 ?v1)) (f16 f24 (f16 (f21 f22 ?v0) ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f8 f13 ?v2)) (?v_0 (f8 f13 (f6 (f8 f9 ?v0) ?v2))) (?v_2 (f6 (f8 f9 ?v1) ?v3))) (= (f6 (f8 f9 (f6 (f8 f13 ?v0) ?v1)) (f6 ?v_1 ?v3)) (f6 (f8 f20 (f6 (f8 f20 (f6 ?v_0 ?v_2)) (f6 ?v_0 ?v3))) (f6 ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f8 f13 ?v0))) (= (f6 (f8 f9 (f6 ?v_0 ?v1)) (f6 (f8 f13 ?v2) ?v3)) (f6 (f8 f20 (f6 ?v_0 (f6 (f8 f9 ?v1) ?v3))) (f6 (f8 f13 (f6 (f8 f9 ?v0) ?v2)) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f21 f22 ?v0))) (= (- (f16 ?v_0 ?v1) (f16 (f21 f22 ?v2) ?v3)) (+ (f16 ?v_0 (- ?v1 ?v3)) (f16 (f21 f22 (- ?v0 ?v2)) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f16 f23 (- ?v0 ?v1)) ?v2) (and (< (- ?v1 ?v2) ?v0) (< ?v0 (+ ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f3 (f6 f7 (f6 (f8 f9 ?v0) ?v1)) ?v2) f1) (and (= (f3 (f6 (f8 f9 ?v1) ?v2) ?v0) f1) (= (f3 ?v0 (f6 (f8 f20 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (<= (f16 f23 (- (+ ?v0 ?v1) (+ ?v2 ?v3))) (+ (f16 f23 (- ?v0 ?v2)) (f16 f23 (- ?v1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (f12 (f6 f7 (f6 (f8 f9 (f6 (f8 f20 ?v0) ?v1)) (f6 (f8 f20 ?v2) ?v3))) (f6 (f8 f20 (f6 f7 (f6 (f8 f9 ?v0) ?v2))) (f6 f7 (f6 (f8 f9 ?v1) ?v3)))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f16 f23 (- ?v0 ?v1)) (+ (f16 f23 ?v0) (f16 f23 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f12 (f6 f7 (f6 (f8 f9 ?v0) ?v1)) (f6 (f8 f20 (f6 f7 ?v0)) (f6 f7 ?v1))) f1)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f12 ?v0 ?v1) f1) (=> (= (f3 ?v2 ?v3) f1) (= (f3 (f6 (f8 f20 ?v0) ?v2) (f6 (f8 f20 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f12 ?v2 ?v3) f1) (= (f3 (f6 (f8 f20 ?v0) ?v2) (f6 (f8 f20 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S2)) (= (f12 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f6 (f8 f13 (f6 (f8 f20 ?v0) ?v1)) ?v2) (f6 (f8 f20 (f6 (f8 f13 ?v0) ?v2)) (f6 (f8 f13 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 (f21 f22 ?v0) ?v1))) (= (f29 f30 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f29 f30 (f16 (f21 f22 (f31 f32 (f29 f30 (ite (< ?v0 0) (- ?v0) ?v0)))) (f31 f32 (f29 f30 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f16 (f21 f22 (f31 f32 ?v0)) (f31 f32 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f21 f22 ?v0) ?v1) (f16 (f21 f22 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f21 f22 ?v0))) (= (f16 ?v_0 (+ ?v1 ?v2)) (+ (f16 ?v_0 ?v1) (f16 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f21 f22 ?v0))) (= (f16 ?v_0 (- ?v1 ?v2)) (- (f16 ?v_0 ?v1) (f16 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f21 f22 (- ?v0)) ?v1) (- (f16 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f21 f22 (f16 f24 ?v0)) (f16 f24 ?v1)) (f16 f24 (f16 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f16 (f21 f22 (f31 f32 ?v0)) (f31 f32 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 (f21 f22 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f21 f22 ?v0))) (= (f16 (f21 f22 (f16 ?v_0 ?v1)) ?v2) (f16 ?v_0 (f16 (f21 f22 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f16 (f21 f22 (+ ?v0 ?v1)) ?v2) (+ (f16 (f21 f22 ?v0) ?v2) (f16 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f16 (f21 f22 (- ?v0 ?v1)) ?v2) (- (f16 (f21 f22 ?v0) ?v2) (f16 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f29 f30 (f16 (f21 f22 ?v0) ?v1)) (f29 f30 (f16 (f21 f22 (f31 f32 (f29 f30 ?v0))) (f31 f32 (f29 f30 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f16 (f21 f22 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f29 f30 (f16 (f21 f22 ?v0) ?v1)) (f29 f30 (f16 (f21 f22 (f31 f32 (f29 f30 (- ?v0)))) (f31 f32 (f29 f30 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f21 f22 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f16 ?v_0 ?v0) (f16 ?v_0 ?v1)))))))
(assert (forall ((?v0 S9)) (= (f29 f30 (f31 f32 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f31 f32 (f29 f30 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f31 f32 (f29 f30 ?v0)) 0))))
(check-sat)
(exit)
