(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S1)
(declare-fun f4 (S4 S3) S2)
(declare-fun f5 () S4)
(declare-fun f6 () S3)
(declare-fun f7 () S3)
(declare-fun f8 () S4)
(declare-fun f9 (S5 S3) S3)
(declare-fun f10 (S6 S3) S5)
(declare-fun f11 () S6)
(declare-fun f12 (S7 Int) S3)
(declare-fun f13 () S7)
(declare-fun f14 (S8 Int) Int)
(declare-fun f15 () S8)
(declare-fun f16 () S8)
(declare-fun f17 () Int)
(declare-fun f18 () S5)
(declare-fun f19 () S6)
(declare-fun f20 (S9 S10) S3)
(declare-fun f21 () S9)
(declare-fun f22 (S11 S10) S10)
(declare-fun f23 (S12 S13) S11)
(declare-fun f24 () S12)
(declare-fun f25 () S13)
(declare-fun f26 () S10)
(declare-fun f27 () S5)
(declare-fun f28 () S3)
(declare-fun f29 (S14 S15) S3)
(declare-fun f30 () S14)
(declare-fun f31 () S15)
(declare-fun f32 () S3)
(declare-fun f33 () S3)
(declare-fun f34 () S10)
(declare-fun f35 () S10)
(declare-fun f36 () S8)
(declare-fun f37 () S5)
(declare-fun f38 () S10)
(declare-fun f39 (S16 S15) S10)
(declare-fun f40 () S16)
(declare-fun f41 (S17 S10) S11)
(declare-fun f42 () S17)
(declare-fun f43 () S6)
(declare-fun f44 (S18 Int) S8)
(declare-fun f45 () S18)
(declare-fun f46 () S6)
(declare-fun f47 () S18)
(declare-fun f48 (S19 S15) Int)
(declare-fun f49 () S19)
(declare-fun f50 (S20 Int) S15)
(declare-fun f51 () S20)
(declare-fun f52 () S6)
(declare-fun f53 () S11)
(declare-fun f54 () S17)
(declare-fun f55 () S17)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 f6) f7) f1)))
(assert (= (f3 (f4 f8 (f9 (f10 f11 (f12 f13 (f14 f15 (f14 f16 f17)))) (f9 f18 (f9 (f10 f19 (f20 f21 (f22 (f23 f24 f25) f26))) (f9 f27 f28))))) (f29 f30 f31)) f1))
(assert (= (f3 (f4 f8 f6) f32) f1))
(assert (= (f3 (f4 f5 f6) f33) f1))
(assert (not (= (f3 (f4 f5 f7) f6) f1)))
(assert (not (<= 1 0)))
(assert (= (f3 (f4 f5 f6) f7) f1))
(assert (<= 0 1))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (not (= f6 f7)))
(assert (not (= f34 f35)))
(assert (not (= f7 f6)))
(assert (not (= 1 0)))
(assert (not (= f35 f34)))
(assert (not (= f6 f7)))
(assert (not (= 0 1)))
(assert (forall ((?v0 Int)) (<= 0 (f14 f36 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f6) (f9 f18 ?v0)) f1)))
(assert (forall ((?v0 Int)) (= (<= (f14 f36 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 (f9 f18 ?v0)) f6) f1) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f14 f36 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (f9 f18 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 (f9 f37 ?v0)) f6) f1) (= ?v0 f6))))
(assert (forall ((?v0 S10)) (= (= (f3 (f4 f5 (f20 f21 ?v0)) f6) f1) (= ?v0 f35))))
(assert (forall ((?v0 S15)) (= (f3 (f4 f5 f6) (f29 f30 ?v0)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (= (= (f3 ?v_0 (f9 (f10 f11 ?v0) ?v1)) f1) (and (or (= (f3 (f4 f5 ?v0) f6) f1) (= (f3 ?v_0 ?v1) f1)) (or (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f5 ?v1) f6) f1)))))))
(assert (= (f3 (f4 f5 (f20 f21 f38)) f33) f1))
(assert (forall ((?v0 S15)) (= (f3 (f4 f5 (f20 f21 (f39 f40 ?v0))) f33) f1)))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f8 ?v0) ?v0) f1))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 S15)) (let ((?v_0 (f29 f30 ?v0))) (= (f9 f18 ?v_0) ?v_0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f9 f37 ?v0))) (= (f9 f18 ?v_0) ?v_0))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f20 f21 ?v0))) (= (f9 f18 ?v_0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f9 f37 (f9 (f10 f11 ?v0) ?v1)) (f9 (f10 f11 (f9 f37 ?v0)) (f9 f37 ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f20 f21 (f22 (f41 f42 ?v0) ?v1)) (f9 (f10 f11 (f20 f21 ?v0)) (f20 f21 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= ?v0 ?v1)) (or (= (f3 (f4 f8 ?v0) ?v1) f1) (= (f3 (f4 f8 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f8 ?v0) ?v1) f1)) (or (= (f3 (f4 f8 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f8 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f3 (f4 f8 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f8 ?v0))) (= (= (f3 ?v_0 (f9 (f10 f43 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f14 (f44 f45 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f8 ?v0))) (= (= (f3 ?v_0 (f9 (f10 f46 ?v1) ?v2)) f1) (and (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f14 (f44 f47 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S15) (?v1 S15)) (= (= (f29 f30 ?v0) (f29 f30 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S15) (?v1 S15)) (= (= (f3 (f4 f8 (f29 f30 ?v0)) (f29 f30 ?v1)) f1) (< (f48 f49 ?v0) (f48 f49 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f8 (f9 (f10 f43 ?v0) ?v1)) ?v2) f1) (and (= (f3 (f4 f8 ?v0) ?v2) f1) (= (f3 (f4 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f14 (f44 f45 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f8 (f9 (f10 f46 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f8 ?v0) ?v2) f1) (= (f3 (f4 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f14 (f44 f47 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f8 ?v0) ?v1) f1)) (= (not (= (f3 (f4 f8 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 f8 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f8 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 f8 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f8 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f8 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f8 ?v0) ?v1) f1) (not (= (f3 (f4 f8 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f8 ?v0) ?v1) f1) (= (not (= (f3 (f4 f8 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f8 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f8 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S1)) (=> (= (f3 (f4 f8 ?v0) ?v1) f1) (= (=> (= (f3 (f4 f8 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f8 ?v0) ?v1) f1) (=> (= (f3 (f4 f8 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f8 ?v0) ?v1) f1) (=> (= (f3 (f4 f8 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f8 ?v1) ?v2) f1) (= (f3 (f4 f8 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f8 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f8 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f8 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f8 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f8 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f8 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f8 ?v2))) (=> (= (f3 (f4 f8 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f8 ?v0) ?v1) f1) (=> (=> (not false) (= (f3 (f4 f8 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (=> (= (f3 (f4 f8 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f3 (f4 f8 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f6)) (= (f9 f37 (f9 (f10 f11 ?v1) ?v0)) (f9 (f10 f11 (f9 f37 ?v1)) (f9 f37 ?v0))))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (not (= ?v0 f35)) (= (f20 f21 (f22 (f41 f42 ?v1) ?v0)) (f9 (f10 f11 (f20 f21 ?v1)) (f20 f21 ?v0))))))
(assert (forall ((?v0 S15)) (= (= (f3 (f4 f8 f6) (f29 f30 ?v0)) f1) (< 0 (f48 f49 ?v0)))))
(assert (forall ((?v0 S15)) (= (f3 (f4 f8 f6) (f29 f30 (f50 f51 (+ (f48 f49 ?v0) 1)))) f1)))
(assert (forall ((?v0 S15)) (not (= (f3 (f4 f8 (f29 f30 ?v0)) f6) f1))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f8 (f9 f37 ?v0)) f6) f1))))
(assert (forall ((?v0 S10)) (not (= (f3 (f4 f8 (f20 f21 ?v0)) f6) f1))))
(assert (forall ((?v0 S3)) (= (f9 (f10 f11 ?v0) f6) f6)))
(assert (forall ((?v0 S10)) (= (f22 (f41 f42 ?v0) f35) f35)))
(assert (forall ((?v0 S3)) (= (f9 (f10 f11 f6) ?v0) f6)))
(assert (forall ((?v0 S10)) (= (f22 (f41 f42 f35) ?v0) f35)))
(assert (forall ((?v0 S3)) (= (f9 (f10 f11 f6) ?v0) f6)))
(assert (forall ((?v0 S10)) (= (f22 (f41 f42 f35) ?v0) f35)))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f14 f36 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f8 f6) ?v0) f1) (= (f9 f18 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (< 0 (f14 f36 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f8 f6) (f9 f18 ?v0)) f1) (not (= ?v0 f6)))))
(assert (forall ((?v0 Int)) (not (< (f14 f36 ?v0) 0))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f8 (f9 f18 ?v0)) f6) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f8 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f8 ?v1) ?v2) f1) (= (f3 (f4 f8 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f8 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v0) f1) (= (f3 (f4 f8 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f8 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (not (= ?v1 ?v0)) (= (f3 (f4 f8 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (not (= ?v0 ?v1)) (= (f3 (f4 f8 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= (f3 (f4 f8 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (not (= (f3 (f4 f8 ?v0) ?v1) f1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f8 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= (f3 (f4 f8 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= (f3 (f4 f8 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f8 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f8 ?v0) ?v1) f1)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f8 ?v0) ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= (f3 (f4 f8 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f8 ?v0) ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= (f3 (f4 f5 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f8 ?v0) ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f8 ?v0) ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S10)) (= (f22 (f41 f42 ?v0) f34) ?v0)))
(assert (forall ((?v0 S3)) (= (f9 (f10 f11 ?v0) f7) ?v0)))
(assert (forall ((?v0 S15) (?v1 S15)) (= (= (f3 (f4 f5 (f29 f30 ?v0)) (f29 f30 ?v1)) f1) (<= (f48 f49 ?v0) (f48 f49 ?v1)))))
(assert (forall ((?v0 S15)) (= (= (f29 f30 ?v0) f6) (= ?v0 (f50 f51 0)))))
(assert (= (f29 f30 (f50 f51 0)) f6))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= (f3 (f4 f8 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f8 ?v0) ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (= (f29 f30 (f50 f51 (+ 0 1))) f7))
(assert (= (f29 f30 (f50 f51 1)) f7))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f8 f6) (f9 f37 ?v0)) f1) (not (= ?v0 f6)))))
(assert (forall ((?v0 S10)) (= (= (f3 (f4 f8 f6) (f20 f21 ?v0)) f1) (not (= ?v0 f35)))))
(assert (forall ((?v0 Int)) (= (= (f14 f36 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f9 f18 ?v0) f6) (= ?v0 f6))))
(assert (forall ((?v0 S3)) (= (= f6 ?v0) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S10)) (= (= f35 ?v0) (= ?v0 f35))))
(assert (= (f14 f36 0) 0))
(assert (= (f9 f18 f6) f6))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f14 f36 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 (f9 f18 ?v0)) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f5 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f9 (f10 f46 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f5 ?v0) ?v2) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f14 (f44 f47 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f9 (f10 f43 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f14 (f44 f45 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 ?v1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 Int)) (<= ?v0 (f14 f36 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) (f9 f18 ?v0)) f1)))
(assert (forall ((?v0 S10)) (= (= f34 ?v0) (= ?v0 f34))))
(assert (forall ((?v0 S3)) (= (= f7 ?v0) (= ?v0 f7))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (= (f14 f36 1) 1))
(assert (= (f9 f18 f7) f7))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (not (= ?v0 f35)) (= (= (f22 (f41 f42 ?v1) ?v0) f34) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f6)) (= (= (f9 (f10 f11 ?v1) ?v0) f7) (= ?v1 ?v0)))))
(assert (forall ((?v0 S10)) (=> (not (= ?v0 f35)) (= (f22 (f41 f42 ?v0) ?v0) f34))))
(assert (forall ((?v0 S3)) (=> (not (= ?v0 f6)) (= (f9 (f10 f11 ?v0) ?v0) f7))))
(assert (forall ((?v0 S10)) (= (f22 (f41 f42 ?v0) ?v0) (ite (= ?v0 f35) f35 f34))))
(assert (forall ((?v0 S3)) (= (f9 (f10 f11 ?v0) ?v0) (ite (= ?v0 f6) f6 f7))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) ?v0) f1)))
(assert (forall ((?v0 S3)) (= (= (f9 f37 ?v0) f6) (= ?v0 f6))))
(assert (forall ((?v0 S10)) (= (= (f20 f21 ?v0) f6) (= ?v0 f35))))
(assert (= (f9 f37 f6) f6))
(assert (= (f20 f21 f35) f6))
(assert (= (f3 (f4 f8 f6) f7) f1))
(assert (< 0 1))
(assert (not (= (f3 (f4 f8 f7) f6) f1)))
(assert (not (< 1 0)))
(assert (forall ((?v0 S15)) (= (= (f3 (f4 f5 (f29 f30 ?v0)) f6) f1) (= ?v0 (f50 f51 0)))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f6) (f9 f37 ?v0)) f1)))
(assert (forall ((?v0 S10)) (= (f3 (f4 f5 f6) (f20 f21 ?v0)) f1)))
(assert (= (f20 f21 f34) f7))
(assert (= (f9 f37 f7) f7))
(assert (forall ((?v0 S10) (?v1 S3)) (=> (= (f3 (f4 f5 (f20 f21 ?v0)) f33) f1) (=> (= (f20 f21 (f22 (f23 f24 f25) ?v0)) (f9 f27 ?v1)) (=> (not (= (f3 (f4 f8 ?v1) f7) f1)) false)))))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S3)) (and (exists ((?v2 S10)) (and (= (f3 (f4 f5 (f20 f21 ?v2)) f33) f1) (= (f20 f21 (f22 (f23 f24 f25) ?v2)) (f9 f27 ?v1)))) (= (f3 (f4 f8 ?v0) ?v1) f1))) (= (f3 (f4 f8 ?v0) f28) f1))))
(assert (=> (not (= (f3 (f4 f5 f6) f33) f1)) (exists ((?v0 S10)) (forall ((?v1 S10)) (let ((?v_0 (f23 f24 f25))) (=> (= (f3 (f4 f5 (f20 f21 ?v1)) f33) f1) (= (f3 (f4 f5 (f20 f21 (f22 ?v_0 ?v0))) (f20 f21 (f22 ?v_0 ?v1))) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (=> (= (f3 (f4 f8 ?v1) f6) f1) (= (f3 (f4 f5 f6) (f9 (f10 f11 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (=> (= (f3 (f4 f8 f6) ?v1) f1) (= (f3 (f4 f5 (f9 (f10 f11 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f8 f6) ?v2) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f5 (f9 (f10 f11 ?v0) ?v3)) (f9 (f10 f11 ?v1) ?v2)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 (f4 f8 ?v0) ?v1) f1) (=> (= (f3 (f4 f8 f6) ?v2) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f8 (f9 (f10 f11 ?v0) ?v3)) (f9 (f10 f11 ?v1) ?v2)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 f8 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (=> (= (f3 (f4 f8 ?v2) ?v3) f1) (= (f3 (f4 f8 (f9 (f10 f11 ?v0) ?v3)) (f9 (f10 f11 ?v1) ?v2)) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 (f4 f8 ?v1) f6) f1) (= (f3 (f4 f5 (f9 (f10 f11 ?v0) ?v1)) f6) f1)))))
(assert (let ((?v_0 (f20 f21 (f22 (f23 f24 f25) f35)))) (and (= (f3 (f4 f5 (f20 f21 f35)) f33) f1) (= ?v_0 (f9 f27 (f9 f27 ?v_0))))))
(assert (= (f3 (f4 f8 f6) (f9 f18 (f9 (f10 f19 (f20 f21 (f22 (f23 f24 f25) f26))) (f9 f27 f28)))) f1))
(assert (forall ((?v0 S10)) (=> (= (f3 (f4 f5 (f20 f21 ?v0)) f33) f1) (= (f3 (f4 f5 (f9 f27 f28)) (f20 f21 (f22 (f23 f24 f25) ?v0))) f1))))
(assert (forall ((?v0 S15)) (= (f3 (f4 f5 (f9 f27 f28)) (f20 f21 (f22 (f23 f24 f25) (f39 f40 ?v0)))) f1)))
(assert (exists ((?v0 S3)) (forall ((?v1 S3)) (=> (exists ((?v2 S10)) (and (= (f3 (f4 f5 (f20 f21 ?v2)) f33) f1) (= (f20 f21 (f22 (f23 f24 f25) ?v2)) (f9 f27 ?v1)))) (= (f3 (f4 f8 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S15)) (= (f3 (f4 f8 (f20 f21 (f22 (f23 f24 f25) (f39 f40 ?v0)))) (f9 (f10 f52 (f9 f27 f28)) (f9 (f10 f11 f7) (f29 f30 (f50 f51 (+ (f48 f49 ?v0) 1)))))) f1)))
(assert (exists ((?v0 S3) (?v1 S10)) (and (= (f3 (f4 f5 (f20 f21 ?v1)) f33) f1) (= (f20 f21 (f22 (f23 f24 f25) ?v1)) (f9 f27 ?v0)))))
(assert (exists ((?v0 S3)) (forall ((?v1 S3)) (= (exists ((?v2 S3)) (and (exists ((?v3 S10)) (and (= (f3 (f4 f5 (f20 f21 ?v3)) f33) f1) (= (f20 f21 (f22 (f23 f24 f25) ?v3)) (f9 f27 ?v2)))) (= (f3 (f4 f8 ?v1) ?v2) f1))) (= (f3 (f4 f8 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) (- ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f22 f53 ?v0) (f22 f53 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f9 f27 ?v0) (f9 f27 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) ?v1) (= (- ?v1) ?v0))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f22 f53 ?v0) ?v1) (= (f22 f53 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f9 f27 ?v0) ?v1) (= (f9 f27 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (- ?v1)) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= ?v0 (f22 f53 ?v1)) (= ?v1 (f22 f53 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 (f9 f27 ?v1)) (= ?v1 (f9 f27 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f14 (f44 f47 ?v0) ?v1)) (f14 (f44 f45 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f9 f27 (f9 (f10 f46 ?v0) ?v1)) (f9 (f10 f43 (f9 f27 ?v0)) (f9 f27 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f14 (f44 f45 ?v0) ?v1)) (f14 (f44 f47 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f9 f27 (f9 (f10 f43 ?v0) ?v1)) (f9 (f10 f46 (f9 f27 ?v0)) (f9 f27 ?v1)))))
(assert (forall ((?v0 Int)) (= (f14 f36 (- ?v0)) (f14 f36 ?v0))))
(assert (forall ((?v0 S3)) (= (f9 f18 (f9 f27 ?v0)) (f9 f18 ?v0))))
(assert (forall ((?v0 Int)) (= (- (- ?v0)) ?v0)))
(assert (forall ((?v0 S10)) (= (f22 f53 (f22 f53 ?v0)) ?v0)))
(assert (forall ((?v0 S3)) (= (f9 f27 (f9 f27 ?v0)) ?v0)))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f22 (f41 f42 (f22 f53 ?v0)) (f22 f53 ?v1)) (f22 (f41 f42 ?v0) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f9 (f10 f11 (f9 f27 ?v0)) (f9 f27 ?v1)) (f9 (f10 f11 ?v0) ?v1))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f41 f42 ?v0))) (= (f22 f53 (f22 ?v_0 ?v1)) (f22 ?v_0 (f22 f53 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 f27 (f9 ?v_0 ?v1)) (f9 ?v_0 (f9 f27 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f9 f18 (f9 (f10 f11 ?v0) ?v1)) (f9 (f10 f11 (f9 f18 ?v0)) (f9 f18 ?v1)))))
(assert (= (f9 f27 f6) f6))
(assert (= 0 0))
(assert (= (f22 f53 f35) f35))
(assert (forall ((?v0 S3)) (= (= f6 (f9 f27 ?v0)) (= f6 ?v0))))
(assert (forall ((?v0 Int)) (= (= 0 (- ?v0)) (= 0 ?v0))))
(assert (forall ((?v0 S10)) (= (= f35 (f22 f53 ?v0)) (= f35 ?v0))))
(assert (forall ((?v0 S3)) (= (= ?v0 (f9 f27 ?v0)) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (= (= ?v0 (- ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f9 f27 ?v0) f6) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (= (= (- ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S10)) (= (= (f22 f53 ?v0) f35) (= ?v0 f35))))
(assert (forall ((?v0 S3)) (= (= (f9 f27 ?v0) ?v0) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (= (= (- ?v0) ?v0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (<= (- ?v0) (f14 f36 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 (f9 f27 ?v0)) (f9 f18 ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 (- ?v1)) (<= ?v1 (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) (f9 f27 ?v1)) f1) (= (f3 (f4 f5 ?v1) (f9 f27 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (- ?v0) ?v1) (<= (- ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 (f9 f27 ?v0)) ?v1) f1) (= (f3 (f4 f5 (f9 f27 ?v1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f36 ?v0) ?v1) (and (<= ?v0 ?v1) (<= (- ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 (f9 f18 ?v0)) ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f9 f27 ?v0)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (- ?v0) (- ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 (f9 f27 ?v0)) (f9 f27 ?v1)) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (<= (- ?v1) (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f9 f27 ?v1)) (f9 f27 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= (- ?v0) ?v1) (<= (f14 f36 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 (f9 f27 ?v0)) ?v1) f1) (= (f3 (f4 f5 (f9 f18 ?v0)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f14 f36 ?v0) ?v1) (<= (- ?v0) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 (f9 f18 ?v0)) ?v1) f1) (= (f3 (f4 f5 (f9 f27 ?v0)) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f8 (f9 f27 ?v0)) (f9 f27 ?v1)) f1) (= (f3 (f4 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) (- ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f36 ?v0) ?v1) (and (< ?v0 ?v1) (< (- ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f8 (f9 f18 ?v0)) ?v1) f1) (and (= (f3 (f4 f8 ?v0) ?v1) f1) (= (f3 (f4 f8 (f9 f27 ?v0)) ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f8 (f9 f27 ?v0)) ?v1) f1) (= (f3 (f4 f8 (f9 f27 ?v1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) ?v1) (< (- ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f8 ?v0) (f9 f27 ?v1)) f1) (= (f3 (f4 f8 ?v1) (f9 f27 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 (- ?v1)) (< ?v1 (- ?v0)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f22 (f41 f42 (f22 f53 ?v0)) ?v1) (f22 f53 (f22 (f41 f42 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f9 (f10 f11 (f9 f27 ?v0)) ?v1) (f9 f27 (f9 (f10 f11 ?v0) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f22 f53 (f22 (f41 f42 ?v0) ?v1)) (f22 (f41 f42 (f22 f53 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f9 f27 (f9 (f10 f11 ?v0) ?v1)) (f9 (f10 f11 (f9 f27 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 (f9 f18 ?v0)) ?v1) f1) (and (= (f3 (f4 f5 (f9 f27 ?v1)) ?v0) f1) (= (f3 (f4 f5 ?v0) ?v1) f1)))))
(assert (forall ((?v0 S10)) (= (f20 f21 (f22 f53 ?v0)) (f20 f21 ?v0))))
(assert (forall ((?v0 S3)) (= (f9 f37 (f9 f27 ?v0)) (f9 f37 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f6)) (= (f9 f18 (f9 (f10 f11 ?v1) ?v0)) (f9 (f10 f11 (f9 f18 ?v1)) (f9 f18 ?v0))))))
(assert (forall ((?v0 Int)) (<= (- (f14 f36 ?v0)) 0)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 (f9 f27 (f9 f18 ?v0))) f6) f1)))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 f6) (f9 f27 ?v0)) f1) (= (f3 (f4 f5 ?v0) f6) f1))))
(assert (forall ((?v0 Int)) (= (<= 0 (- ?v0)) (<= ?v0 0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f9 f27 ?v0)) f1) (= (f3 ?v_0 f6) f1)))))
(assert (forall ((?v0 Int)) (= (<= ?v0 (- ?v0)) (<= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 (f9 f27 ?v0)) f6) f1) (= (f3 (f4 f5 f6) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (<= (- ?v0) 0) (<= 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 (f9 f27 ?v0)) ?v0) f1) (= (f3 (f4 f5 f6) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (<= (- ?v0) ?v0) (<= 0 ?v0))))
(assert (forall ((?v0 Int)) (=> (<= ?v0 0) (= (f14 f36 ?v0) (- ?v0)))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (= (f9 f18 ?v0) (f9 f27 ?v0)))))
(assert (forall ((?v0 Int)) (= (f14 f36 ?v0) (ite (< ?v0 0) (- ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f9 f18 ?v0) (ite (= (f3 (f4 f8 ?v0) f6) f1) (f9 f27 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f8 f6) (f9 f27 ?v0)) f1) (= (f3 (f4 f8 ?v0) f6) f1))))
(assert (forall ((?v0 Int)) (= (< 0 (- ?v0)) (< ?v0 0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f4 f8 ?v0))) (= (= (f3 ?v_0 (f9 f27 ?v0)) f1) (= (f3 ?v_0 f6) f1)))))
(assert (forall ((?v0 Int)) (= (< ?v0 (- ?v0)) (< ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f8 (f9 f27 ?v0)) f6) f1) (= (f3 (f4 f8 f6) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (< (- ?v0) 0) (< 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f8 (f9 f27 ?v0)) ?v0) f1) (= (f3 (f4 f8 f6) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (< (- ?v0) ?v0) (< 0 ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f14 f36 ?v0) (- ?v0)))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f8 ?v0) f6) f1) (= (f9 f18 ?v0) (f9 f27 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f10 f11 ?v1))) (=> (not (= ?v0 f6)) (= (f9 f27 (f9 ?v_0 ?v0)) (f9 ?v_0 (f9 f27 ?v0)))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f41 f42 ?v1))) (=> (not (= ?v0 f35)) (= (f22 f53 (f22 ?v_0 ?v0)) (f22 ?v_0 (f22 f53 ?v0)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f6)) (= (f9 (f10 f11 (f9 f27 ?v1)) (f9 f27 ?v0)) (f9 (f10 f11 ?v1) ?v0)))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (not (= ?v0 f35)) (= (f22 (f41 f42 (f22 f53 ?v1)) (f22 f53 ?v0)) (f22 (f41 f42 ?v1) ?v0)))))
(assert (forall ((?v0 S3)) (= (f9 f18 ?v0) (ite (= (f3 (f4 f8 ?v0) f6) f1) (f9 f27 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f9 f18 ?v0) (ite (= (f3 (f4 f8 ?v0) f6) f1) (f9 f27 ?v0) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (= (= (f3 ?v_0 (f9 (f10 f11 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f5 ?v0) f6) f1) (= (f3 (f4 f5 ?v1) f6) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (= (= (f3 (f4 f5 (f9 (f10 f11 ?v0) ?v1)) f6) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f5 ?v1) f6) f1)) (and (= (f3 (f4 f5 ?v0) f6) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f6) ?v2) f1) (= (f3 (f4 f5 (f9 (f10 f11 ?v0) ?v2)) (f9 (f10 f11 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) f6) f1) (= (f3 (f4 f5 (f9 (f10 f11 ?v1) ?v2)) (f9 (f10 f11 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f8 f6))) (= (= (f3 ?v_0 (f9 (f10 f11 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f8 ?v0) f6) f1) (= (f3 (f4 f8 ?v1) f6) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f8 f6))) (= (= (f3 (f4 f8 (f9 (f10 f11 ?v0) ?v1)) f6) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f8 ?v1) f6) f1)) (and (= (f3 (f4 f8 ?v0) f6) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f8 (f9 (f10 f11 ?v0) ?v1)) (f9 (f10 f11 ?v2) ?v1)) f1) (and (=> (= (f3 (f4 f8 f6) ?v1) f1) (= (f3 (f4 f8 ?v0) ?v2) f1)) (and (=> (= (f3 (f4 f8 ?v1) f6) f1) (= (f3 (f4 f8 ?v2) ?v0) f1)) (not (= ?v1 f6)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f8 f6) ?v0) f1) (= (f9 (f10 f11 (f9 f18 ?v1)) ?v0) (f9 f18 (f9 (f10 f11 ?v1) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f8 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f9 (f10 f11 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f8 f6) ?v0) f1) (=> (= (f3 (f4 f8 ?v1) f6) f1) (= (f3 (f4 f8 (f9 (f10 f11 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f8 ?v0) f6) f1) (=> (= (f3 (f4 f8 f6) ?v1) f1) (= (f3 (f4 f8 (f9 (f10 f11 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f8 ?v0) f6) f1) (=> (= (f3 (f4 f8 ?v1) f6) f1) (= (f3 (f4 f8 f6) (f9 (f10 f11 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f8 ?v0) ?v1) f1) (=> (= (f3 (f4 f8 f6) ?v2) f1) (= (f3 (f4 f8 (f9 (f10 f11 ?v0) ?v2)) (f9 (f10 f11 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f8 ?v0) ?v1) f1) (=> (= (f3 (f4 f8 ?v2) f6) f1) (= (f3 (f4 f8 (f9 (f10 f11 ?v1) ?v2)) (f9 (f10 f11 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f9 (f10 f11 ?v0) ?v1)) (f9 (f10 f11 ?v2) ?v1)) f1) (and (=> (= (f3 (f4 f8 f6) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)) (=> (= (f3 (f4 f8 ?v1) f6) f1) (= (f3 (f4 f5 ?v2) ?v0) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 (f4 f8 f6) ?v1) f1) (= (f3 ?v_0 (f9 (f10 f11 ?v0) ?v1)) f1))))))
(assert (= (f3 (f4 f8 (f9 (f10 f11 (f12 f13 (f14 f15 (f14 f16 f17)))) (f9 f18 (f9 (f10 f19 (f20 f21 (f22 (f23 f24 f25) f26))) (f9 f27 f28))))) (f29 f30 f31)) f1))
(assert (=> (forall ((?v0 S3)) (=> (forall ((?v1 S3)) (= (exists ((?v2 S3)) (and (exists ((?v3 S10)) (and (= (f3 (f4 f5 (f20 f21 ?v3)) f33) f1) (= (f20 f21 (f22 (f23 f24 f25) ?v3)) (f9 f27 ?v2)))) (= (f3 (f4 f8 ?v1) ?v2) f1))) (= (f3 (f4 f8 ?v1) ?v0) f1))) false)) false))
(assert (forall ((?v0 S15)) (exists ((?v1 S10)) (and (= (f3 (f4 f5 (f20 f21 ?v1)) f33) f1) (= (f3 (f4 f8 (f20 f21 (f22 (f23 f24 f25) ?v1))) (f9 (f10 f52 (f9 f27 f28)) (f9 (f10 f11 f7) (f29 f30 (f50 f51 (+ (f48 f49 ?v0) 1)))))) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f8 ?v1) (f9 (f10 f52 ?v0) ?v2)) f1) (= (f3 (f4 f8 (f9 f18 (f9 (f10 f19 ?v1) ?v0))) ?v2) f1)))))
(assert (= (f3 (f4 f8 f6) (f9 (f10 f11 (f9 f18 (f9 (f10 f19 (f20 f21 (f22 (f23 f24 f25) f26))) (f9 f27 f28)))) (f12 f13 (f14 f15 (f14 f16 f17))))) f1))
(assert (forall ((?v0 S15)) (exists ((?v1 S10)) (and (= (f3 (f4 f5 (f20 f21 ?v1)) f33) f1) (= (f3 (f4 f8 (f20 f21 (f22 (f23 f24 f25) ?v1))) (f9 (f10 f52 (f9 f27 f28)) (f9 (f10 f11 f7) (f29 f30 (f50 f51 (+ (f48 f49 ?v0) 1)))))) f1)))))
(assert (exists ((?v0 S16)) (forall ((?v1 S15)) (let ((?v_0 (f39 ?v0 ?v1))) (and (= (f3 (f4 f5 (f20 f21 ?v_0)) f33) f1) (= (f3 (f4 f8 (f20 f21 (f22 (f23 f24 f25) ?v_0))) (f9 (f10 f52 (f9 f27 f28)) (f9 (f10 f11 f7) (f29 f30 (f50 f51 (+ (f48 f49 ?v1) 1)))))) f1))))))
(assert (exists ((?v0 S15)) (= (f3 (f4 f8 (f9 (f10 f11 (f12 f13 (f14 f15 (f14 f16 f17)))) (f9 f18 (f9 (f10 f19 (f20 f21 (f22 (f23 f24 f25) f26))) (f9 f27 f28))))) (f29 f30 ?v0)) f1)))
(assert (=> (forall ((?v0 S15)) (=> (= (f3 (f4 f8 (f9 (f10 f11 (f12 f13 (f14 f15 (f14 f16 f17)))) (f9 f18 (f9 (f10 f19 (f20 f21 (f22 (f23 f24 f25) f26))) (f9 f27 f28))))) (f29 f30 ?v0)) f1) false)) false))
(assert (forall ((?v0 S10)) (let ((?v_1 (f23 f24 f25))) (let ((?v_2 (f22 ?v_1 f26)) (?v_0 (f20 f21 (f22 (f41 f54 ?v0) f26)))) (=> (and (= (f3 (f4 f8 f6) ?v_0) f1) (= (f3 (f4 f8 ?v_0) f32) f1)) (= (f3 (f4 f8 (f20 f21 (f22 (f41 f54 (f22 ?v_1 ?v0)) ?v_2))) (f9 (f10 f11 (f9 f18 (f9 (f10 f19 (f20 f21 ?v_2)) (f9 f27 f28)))) (f12 f13 (f14 f15 (f14 f16 f17))))) f1))))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f22 f53 (f22 (f41 f55 ?v0) ?v1)) (f22 (f41 f55 (f22 f53 ?v0)) (f22 f53 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1)) (+ (- ?v0) (- ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f9 f27 (f9 (f10 f52 ?v0) ?v1)) (f9 (f10 f52 (f9 f27 ?v0)) (f9 f27 ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f22 f53 (f22 (f41 f55 ?v0) ?v1)) (f22 (f41 f55 (f22 f53 ?v1)) (f22 f53 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1)) (+ (- ?v1) (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f9 f27 (f9 (f10 f52 ?v0) ?v1)) (f9 (f10 f52 (f9 f27 ?v1)) (f9 f27 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f9 f18 (f9 (f10 f52 ?v0) (f9 f27 ?v1))) (f9 f18 (f9 (f10 f52 ?v1) (f9 f27 ?v0))))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f22 (f41 f54 ?v0) ?v1) (f22 (f41 f55 ?v0) (f22 f53 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- ?v0 ?v1) (+ ?v0 (- ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f9 (f10 f19 ?v0) ?v1) (f9 (f10 f52 ?v0) (f9 f27 ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f22 (f41 f54 ?v0) ?v1) (f22 (f41 f55 ?v0) (f22 f53 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- ?v0 ?v1) (+ ?v0 (- ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f9 (f10 f19 ?v0) ?v1) (f9 (f10 f52 ?v0) (f9 f27 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f9 (f10 f19 ?v0) ?v1) (f9 (f10 f52 ?v0) (f9 f27 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f9 (f10 f19 ?v0) ?v1) (f9 (f10 f52 ?v0) (f9 f27 ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f22 (f41 f54 ?v0) (f22 f53 ?v1)) (f22 (f41 f55 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- ?v0 (- ?v1)) (+ ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f9 (f10 f19 ?v0) (f9 f27 ?v1)) (f9 (f10 f52 ?v0) ?v1))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f22 (f41 f55 ?v0) (f22 (f41 f55 (f22 f53 ?v0)) ?v1)) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (+ (- ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f9 (f10 f52 ?v0) (f9 (f10 f52 (f9 f27 ?v0)) ?v1)) ?v1)))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f22 (f41 f55 (f22 f53 ?v0)) (f22 (f41 f55 ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (- ?v0) (+ ?v0 ?v1)) ?v1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f9 (f10 f52 (f9 f27 ?v0)) (f9 (f10 f52 ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f14 f36 (- ?v0 ?v1)) (+ (f14 f36 ?v0) (f14 f36 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f9 f18 (f9 (f10 f19 ?v0) ?v1))) (f9 (f10 f52 (f9 f18 ?v0)) (f9 f18 ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (<= (f14 f36 (- (+ ?v0 ?v1) (+ ?v2 ?v3))) (+ (f14 f36 (- ?v0 ?v2)) (f14 f36 (- ?v1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f3 (f4 f5 (f9 f18 (f9 (f10 f19 (f9 (f10 f52 ?v0) ?v1)) (f9 (f10 f52 ?v2) ?v3)))) (f9 (f10 f52 (f9 f18 (f9 (f10 f19 ?v0) ?v2))) (f9 f18 (f9 (f10 f19 ?v1) ?v3)))) f1)))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (= (f3 (f4 f5 (f20 f21 (f22 (f41 f54 (f22 (f41 f55 ?v0) ?v1)) (f22 (f41 f55 ?v2) ?v3)))) (f9 (f10 f52 (f20 f21 (f22 (f41 f54 ?v0) ?v2))) (f20 f21 (f22 (f41 f54 ?v1) ?v3)))) f1)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f3 (f4 f5 (f9 f37 (f9 (f10 f19 (f9 (f10 f52 ?v0) ?v1)) (f9 (f10 f52 ?v2) ?v3)))) (f9 (f10 f52 (f9 f37 (f9 (f10 f19 ?v0) ?v2))) (f9 f37 (f9 (f10 f19 ?v1) ?v3)))) f1)))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f3 (f4 f5 (f20 f21 (f22 (f41 f55 ?v0) ?v1))) (f9 (f10 f52 (f20 f21 ?v0)) (f20 f21 ?v1))) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f9 f37 (f9 (f10 f52 ?v0) ?v1))) (f9 (f10 f52 (f9 f37 ?v0)) (f9 f37 ?v1))) f1)))
(assert (forall ((?v0 S10) (?v1 S3) (?v2 S10) (?v3 S3)) (=> (= (f3 (f4 f8 (f20 f21 ?v0)) ?v1) f1) (=> (= (f3 (f4 f8 (f20 f21 ?v2)) ?v3) f1) (= (f3 (f4 f8 (f20 f21 (f22 (f41 f55 ?v0) ?v2))) (f9 (f10 f52 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f8 (f9 f37 ?v0)) ?v1) f1) (=> (= (f3 (f4 f8 (f9 f37 ?v2)) ?v3) f1) (= (f3 (f4 f8 (f9 f37 (f9 (f10 f52 ?v0) ?v2))) (f9 (f10 f52 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f8 ?v0) ?v1) f1) (= (f3 (f4 f8 (f9 (f10 f11 (f9 (f10 f52 ?v0) ?v1)) (f12 f13 (f14 f15 (f14 f16 f17))))) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f8 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f9 (f10 f11 (f9 (f10 f52 ?v0) ?v1)) (f12 f13 (f14 f15 (f14 f16 f17))))) f1)))))
(assert (forall ((?v0 S10)) (= (f22 (f41 f55 f35) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f9 (f10 f52 f6) ?v0) ?v0)))
(assert (forall ((?v0 S10)) (= (f22 (f41 f55 f35) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f9 (f10 f52 f6) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (= 0 (+ ?v0 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= f6 (f9 (f10 f52 ?v0) ?v0)) (= ?v0 f6))))
(assert (forall ((?v0 S10)) (= (f22 (f41 f55 ?v0) f35) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S3)) (= (f9 (f10 f52 ?v0) f6) ?v0)))
(assert (forall ((?v0 S10)) (= (f22 (f41 f55 ?v0) f35) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S3)) (= (f9 (f10 f52 ?v0) f6) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f14 f36 (+ ?v0 ?v1)) (+ (f14 f36 ?v0) (f14 f36 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f9 f18 (f9 (f10 f52 ?v0) ?v1))) (f9 (f10 f52 (f9 f18 ?v0)) (f9 f18 ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f9 (f10 f52 ?v0) ?v1)) (f9 (f10 f52 ?v2) ?v1)) f1) (= (f3 (f4 f5 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f52 ?v0))) (= (= (f3 (f4 f5 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S15)) (= (f50 f51 (f48 f49 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f48 f49 (f50 f51 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f48 f49 (f50 f51 ?v0)) 0))))
(check-sat)
(exit)
