(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S1)
(declare-fun f4 (S4 S3) S2)
(declare-fun f5 (S5) S4)
(declare-fun f6 () S5)
(declare-fun f7 () S3)
(declare-fun f8 () S3)
(declare-fun f9 () S1)
(declare-fun f10 () S5)
(declare-fun f11 (S6 S5) S5)
(declare-fun f12 (S7 S5) S6)
(declare-fun f13 () S7)
(declare-fun f14 (S8 S2) S7)
(declare-fun f15 () S8)
(declare-fun f16 (S9 S2) S6)
(declare-fun f17 () S9)
(declare-fun f18 (S10 S5) S11)
(declare-fun f19 () S10)
(declare-fun f20 (S12 Int) S11)
(declare-fun f21 () S12)
(declare-fun f22 (S13 S11) Int)
(declare-fun f23 () S13)
(declare-fun f24 () S10)
(declare-fun f25 (S5) S1)
(declare-fun f26 (S16 S15) S5)
(declare-fun f27 (S17 S14) S16)
(declare-fun f28 () S17)
(declare-fun f29 (S19 S15) S6)
(declare-fun f30 (S20 S18) S19)
(declare-fun f31 () S20)
(declare-fun f32 (S21 S11) S2)
(declare-fun f33 (S22 S3) S21)
(declare-fun f34 (S5) S22)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 f6) f7) f8) f1)))
(assert (= f9 f1))
(assert (forall ((?v0 S3)) (=> (forall ((?v1 S3)) (=> (= (f3 (f4 (f5 f6) f7) ?v1) f1) (= ?v0 ?v1))) (= ?v0 f8))))
(assert (not (exists ((?v0 S3)) (= (f3 (f4 (f5 f6) f7) ?v0) f1))))
(assert (= (= f9 f1) (exists ((?v0 S3) (?v1 S3)) (not (= ?v0 ?v1)))))
(assert (=> (= f9 f1) (forall ((?v0 S3)) (=> (forall ((?v1 S3)) (= ?v1 ?v0)) false))))
(assert (forall ((?v0 S5) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 (f5 ?v0) ?v1))) (=> (= (f3 ?v_0 ?v2) f1) (=> (= (f3 ?v_0 ?v3) f1) (= ?v3 ?v2))))))
(assert (forall ((?v0 S3)) (= (f3 (f4 (f5 f10) ?v0) ?v0) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 (f5 f10) ?v0) ?v1) f1) (=> (=> (= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S5) (?v1 S3) (?v2 S3) (?v3 S5) (?v4 S3)) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f4 (f5 ?v3) ?v2) ?v4) f1) (= (f3 (f4 (f5 (f11 (f12 f13 ?v0) ?v3)) ?v1) ?v4) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S5) (?v3 S3) (?v4 S5)) (=> (not (= (f3 ?v0 ?v1) f1)) (=> (= (f3 (f4 (f5 ?v2) ?v1) ?v3) f1) (= (f3 (f4 (f5 (f11 (f12 (f14 f15 ?v0) ?v4) ?v2)) ?v1) ?v3) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S5) (?v3 S3) (?v4 S5)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 (f4 (f5 ?v2) ?v1) ?v3) f1) (= (f3 (f4 (f5 (f11 (f12 (f14 f15 ?v0) ?v2) ?v4)) ?v1) ?v3) f1)))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5) (?v3 S3) (?v4 S3)) (let ((?v_0 (= (f3 ?v0 ?v3) f1))) (=> (= (f3 (f4 (f5 (f11 (f12 (f14 f15 ?v0) ?v1) ?v2)) ?v3) ?v4) f1) (=> (=> ?v_0 (=> (= (f3 (f4 (f5 ?v1) ?v3) ?v4) f1) false)) (=> (=> (not ?v_0) (=> (= (f3 (f4 (f5 ?v2) ?v3) ?v4) f1) false)) false))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S5)) (=> (not (= (f3 ?v0 ?v1) f1)) (= (f3 (f4 (f5 (f11 (f16 f17 ?v0) ?v2)) ?v1) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S5) (?v3 S3) (?v4 S3)) (let ((?v_0 (f5 (f11 (f16 f17 ?v0) ?v2)))) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 (f4 (f5 ?v2) ?v1) ?v3) f1) (=> (= (f3 (f4 ?v_0 ?v3) ?v4) f1) (= (f3 (f4 ?v_0 ?v1) ?v4) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 (f5 (f11 (f12 f13 ?v0) ?v1)) ?v2) ?v3) f1) (=> (forall ((?v4 S3)) (=> (= (f3 (f4 (f5 ?v0) ?v2) ?v4) f1) (=> (= (f3 (f4 (f5 ?v1) ?v4) ?v3) f1) false))) false))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 (f5 (f11 (f16 f17 ?v0) ?v1)) ?v2) ?v3) f1) (=> (=> (= ?v3 ?v2) (=> (not (= (f3 ?v0 ?v2) f1)) false)) (=> (forall ((?v4 S3)) (=> (= (f3 ?v0 ?v2) f1) (=> (= (f3 (f4 (f5 ?v1) ?v2) ?v4) f1) (=> (= (f3 (f4 (f5 (f11 (f16 f17 ?v0) ?v1)) ?v4) ?v3) f1) false)))) false)))))
(assert (forall ((?v0 S5) (?v1 S5)) (not (= f10 (f11 (f12 f13 ?v0) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (not (= (f11 (f12 f13 ?v0) ?v1) f10))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5)) (not (= f10 (f11 (f12 (f14 f15 ?v0) ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5)) (not (= (f11 (f12 (f14 f15 ?v0) ?v1) ?v2) f10))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S2) (?v3 S5) (?v4 S5)) (not (= (f11 (f12 f13 ?v0) ?v1) (f11 (f12 (f14 f15 ?v2) ?v3) ?v4)))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5) (?v3 S5) (?v4 S5)) (not (= (f11 (f12 (f14 f15 ?v0) ?v1) ?v2) (f11 (f12 f13 ?v3) ?v4)))))
(assert (forall ((?v0 S2) (?v1 S5)) (not (= f10 (f11 (f16 f17 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S5)) (not (= (f11 (f16 f17 ?v0) ?v1) f10))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S2) (?v3 S5)) (not (= (f11 (f12 f13 ?v0) ?v1) (f11 (f16 f17 ?v2) ?v3)))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5) (?v3 S5)) (not (= (f11 (f16 f17 ?v0) ?v1) (f11 (f12 f13 ?v2) ?v3)))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S2) (?v3 S5)) (= (= (f11 (f16 f17 ?v0) ?v1) (f11 (f16 f17 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5) (?v3 S2) (?v4 S5) (?v5 S5)) (= (= (f11 (f12 (f14 f15 ?v0) ?v1) ?v2) (f11 (f12 (f14 f15 ?v3) ?v4) ?v5)) (and (= ?v0 ?v3) (and (= ?v1 ?v4) (= ?v2 ?v5))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (= (= (f11 (f12 f13 ?v0) ?v1) (f11 (f12 f13 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5) (?v3 S2) (?v4 S5)) (not (= (f11 (f12 (f14 f15 ?v0) ?v1) ?v2) (f11 (f16 f17 ?v3) ?v4)))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S2) (?v3 S5) (?v4 S5)) (not (= (f11 (f16 f17 ?v0) ?v1) (f11 (f12 (f14 f15 ?v2) ?v3) ?v4)))))
(assert (= (f18 f19 f10) (f20 f21 0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f18 f19 (f11 (f12 f13 ?v0) ?v1)) (f20 f21 (+ (+ (f22 f23 (f18 f19 ?v0)) (f22 f23 (f18 f19 ?v1))) (+ 0 1))))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5)) (= (f18 f19 (f11 (f12 (f14 f15 ?v0) ?v1) ?v2)) (f20 f21 (+ (+ (f22 f23 (f18 f19 ?v1)) (f22 f23 (f18 f19 ?v2))) (+ 0 1))))))
(assert (= (f18 f24 f10) (f20 f21 0)))
(assert (forall ((?v0 S2) (?v1 S5)) (= (f18 f19 (f11 (f16 f17 ?v0) ?v1)) (f20 f21 (+ (f22 f23 (f18 f19 ?v1)) (+ 0 1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f18 f24 (f11 (f12 f13 ?v0) ?v1)) (f20 f21 (+ (+ (f22 f23 (f18 f24 ?v0)) (f22 f23 (f18 f24 ?v1))) (+ 0 1))))))
(assert (forall ((?v0 S2) (?v1 S5)) (= (f18 f24 (f11 (f16 f17 ?v0) ?v1)) (f20 f21 (+ (f22 f23 (f18 f24 ?v1)) (+ 0 1))))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5)) (= (f18 f24 (f11 (f12 (f14 f15 ?v0) ?v1) ?v2)) (f20 f21 (+ (+ (f22 f23 (f18 f24 ?v1)) (f22 f23 (f18 f24 ?v2))) (+ 0 1))))))
(assert (=> (= (f25 f10) f1) (=> false false)))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f25 (f11 (f12 f13 ?v0) ?v1)) f1) (=> (=> (= (f25 ?v0) f1) (=> (= (f25 ?v1) f1) false)) false))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5)) (=> (= (f25 (f11 (f12 (f14 f15 ?v0) ?v1) ?v2)) f1) (=> (=> (= (f25 ?v1) f1) (=> (= (f25 ?v2) f1) false)) false))))
(assert (forall ((?v0 S2) (?v1 S5)) (=> (= (f25 (f11 (f16 f17 ?v0) ?v1)) f1) (=> (=> (= (f25 ?v1) f1) false) false))))
(assert (forall ((?v0 S5) (?v1 S2)) (=> (= (f25 ?v0) f1) (= (f25 (f11 (f16 f17 ?v1) ?v0)) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S2)) (=> (= (f25 ?v0) f1) (=> (= (f25 ?v1) f1) (= (f25 (f11 (f12 (f14 f15 ?v2) ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f25 ?v0) f1) (=> (= (f25 ?v1) f1) (= (f25 (f11 (f12 f13 ?v0) ?v1)) f1)))))
(assert (= (f25 f10) f1))
(assert (forall ((?v0 S14) (?v1 S15)) (=> (= (f25 (f26 (f27 f28 ?v0) ?v1)) f1) (=> false false))))
(assert (forall ((?v0 S18) (?v1 S15) (?v2 S5)) (=> (= (f25 (f11 (f29 (f30 f31 ?v0) ?v1) ?v2)) f1) (=> (=> (= (f25 ?v2) f1) false) false))))
(assert (forall ((?v0 S3) (?v1 S11) (?v2 S3)) (=> (= (f3 (f32 (f33 (f34 f10) ?v0) ?v1) ?v2) f1) (=> (=> (= ?v2 ?v0) false) false))))
(assert (forall ((?v0 S3) (?v1 S11)) (= (f3 (f32 (f33 (f34 f10) ?v0) ?v1) ?v0) f1)))
(assert (forall ((?v0 S5) (?v1 S3) (?v2 S11) (?v3 S3) (?v4 S5) (?v5 S3)) (=> (= (f3 (f32 (f33 (f34 ?v0) ?v1) ?v2) ?v3) f1) (=> (= (f3 (f32 (f33 (f34 ?v4) ?v3) ?v2) ?v5) f1) (= (f3 (f32 (f33 (f34 (f11 (f12 f13 ?v0) ?v4)) ?v1) ?v2) ?v5) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S5) (?v3 S11)) (=> (not (= (f3 ?v0 ?v1) f1)) (= (f3 (f32 (f33 (f34 (f11 (f16 f17 ?v0) ?v2)) ?v1) ?v3) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S5) (?v3 S11) (?v4 S3) (?v5 S3)) (let ((?v_0 (f34 (f11 (f16 f17 ?v0) ?v2)))) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 (f32 (f33 (f34 ?v2) ?v1) ?v3) ?v4) f1) (=> (= (f3 (f32 (f33 ?v_0 ?v4) ?v3) ?v5) f1) (= (f3 (f32 (f33 ?v_0 ?v1) ?v3) ?v5) f1)))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S5) (?v3 S11) (?v4 S3) (?v5 S5)) (=> (not (= (f3 ?v0 ?v1) f1)) (=> (= (f3 (f32 (f33 (f34 ?v2) ?v1) ?v3) ?v4) f1) (= (f3 (f32 (f33 (f34 (f11 (f12 (f14 f15 ?v0) ?v5) ?v2)) ?v1) ?v3) ?v4) f1)))))
(assert (forall ((?v0 S11)) (= (f20 f21 (f22 f23 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f22 f23 (f20 f21 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f22 f23 (f20 f21 ?v0)) 0))))
(check-sat)
(exit)
