(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3 S4) S1)
(declare-fun f4 () S2)
(declare-fun f5 (S5 S6) S3)
(declare-fun f6 () S5)
(declare-fun f7 () S6)
(declare-fun f8 () S4)
(declare-fun f9 (S7 S8) S1)
(declare-fun f10 (S6) S8)
(declare-fun f11 (S9 S4) S1)
(declare-fun f12 (S2 S7) S9)
(declare-fun f13 (S10 S4) S4)
(declare-fun f14 (S11 Int) S10)
(declare-fun f15 () S11)
(declare-fun f16 () Int)
(declare-fun f17 (S12 S7) Int)
(declare-fun f18 () S12)
(declare-fun f19 (S13 S7) S3)
(declare-fun f20 () S13)
(declare-fun f21 (S15 S14) S3)
(declare-fun f22 () S15)
(declare-fun f23 (S3 S16) S1)
(declare-fun f24 (S14) S16)
(declare-fun f25 (S17 S3) S3)
(declare-fun f26 (S18 S3) S17)
(declare-fun f27 () S18)
(declare-fun f28 () S18)
(declare-fun f29 () S18)
(declare-fun f30 () S18)
(declare-fun f31 () S17)
(declare-fun f32 () S17)
(declare-fun f33 () S15)
(declare-fun f34 (S19 S13) S17)
(declare-fun f35 () S19)
(declare-fun f36 () S13)
(assert (not (= f1 f2)))
(assert (not (= (f3 f4 (f5 f6 f7) f8) f1)))
(assert (forall ((?v0 S7)) (=> (= (f9 ?v0 (f10 f7)) f1) (= (f11 (f12 f4 ?v0) (f13 (f14 f15 f16) f8)) f1))))
(assert (exists ((?v0 Int)) (forall ((?v1 S7)) (=> (= (f9 ?v1 (f10 f7)) f1) (= (f11 (f12 f4 ?v1) (f13 (f14 f15 ?v0) f8)) f1)))))
(assert (=> (forall ((?v0 Int)) (=> (forall ((?v1 S7)) (=> (= (f9 ?v1 (f10 f7)) f1) (= (f11 (f12 f4 ?v1) (f13 (f14 f15 ?v0) f8)) f1))) false)) false))
(assert (forall ((?v0 S7)) (=> (= (f9 ?v0 (f10 f7)) f1) (not (= (f17 f18 ?v0) 0)))))
(assert (forall ((?v0 S7) (?v1 S4)) (= (= (f3 f4 (f19 f20 ?v0) ?v1) f1) (not (= (f11 (f12 f4 ?v0) ?v1) f1)))))
(assert (forall ((?v0 S14) (?v1 S4)) (= (= (f3 f4 (f21 f22 ?v0) ?v1) f1) (forall ((?v2 S3)) (=> (= (f23 ?v2 (f24 ?v0)) f1) (= (f3 f4 ?v2 ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S4)) (= (= (f3 f4 (f25 (f26 f27 ?v0) ?v1) ?v2) f1) (= (f3 f4 (f25 (f26 f28 ?v0) ?v1) ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S4)) (= (= (f3 f4 (f25 (f26 f29 ?v0) ?v1) ?v2) f1) (= (f3 f4 (f25 (f26 f30 ?v0) ?v1) ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 S4)) (= (= (f3 f4 (f25 f31 ?v0) ?v1) f1) (= (f3 f4 (f25 f32 ?v0) ?v1) f1))))
(assert (forall ((?v0 S14) (?v1 S4)) (= (= (f3 f4 (f21 f33 ?v0) ?v1) f1) (exists ((?v2 S3)) (and (= (f23 ?v2 (f24 ?v0)) f1) (= (f3 f4 ?v2 ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S4)) (= (= (f3 f4 (f25 (f34 f35 f20) ?v0) ?v1) f1) (= (f3 f4 ?v0 ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S7) (?v2 S4)) (= (= (f3 ?v0 (f19 f36 ?v1) ?v2) f1) (= (f11 (f12 ?v0 ?v1) ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 S7)) (not (= (f25 f32 ?v0) (f19 f36 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S3)) (not (= (f19 f36 ?v0) (f25 f32 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (not (= (f25 f32 ?v0) (f25 (f26 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (not (= (f25 f32 ?v0) (f25 (f26 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S3) (?v2 S3)) (not (= (f19 f36 ?v0) (f25 (f26 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S3) (?v2 S3)) (not (= (f19 f36 ?v0) (f25 (f26 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (not (= (f25 (f26 f30 ?v0) ?v1) (f25 f32 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S7)) (not (= (f25 (f26 f30 ?v0) ?v1) (f19 f36 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (not (= (f25 (f26 f28 ?v0) ?v1) (f25 f32 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S7)) (not (= (f25 (f26 f28 ?v0) ?v1) (f19 f36 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (not (= (f25 (f26 f30 ?v0) ?v1) (f25 (f26 f28 ?v2) ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (not (= (f25 (f26 f28 ?v0) ?v1) (f25 (f26 f30 ?v2) ?v3)))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f19 f36 ?v0))) (= (f25 (f34 f35 f20) ?v_0) ?v_0))))
(assert (forall ((?v0 S7)) (= (f25 (f34 f35 f20) (f25 f32 (f19 f36 ?v0))) (f19 f20 ?v0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f34 f35 f20))) (= (f25 ?v_0 (f25 f32 (f25 f32 ?v0))) (f25 ?v_0 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f34 f35 f20))) (= (f25 ?v_0 (f25 f32 (f25 (f26 f30 ?v0) ?v1))) (f25 (f26 f28 (f25 ?v_0 (f25 f32 ?v0))) (f25 ?v_0 (f25 f32 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f34 f35 f20))) (= (f25 ?v_0 (f25 f32 (f25 (f26 f28 ?v0) ?v1))) (f25 (f26 f30 (f25 ?v_0 (f25 f32 ?v0))) (f25 ?v_0 (f25 f32 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f34 f35 f20))) (= (f25 ?v_0 (f25 (f26 f30 ?v0) ?v1)) (f25 (f26 f30 (f25 ?v_0 ?v0)) (f25 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f34 f35 f20))) (= (f25 ?v_0 (f25 (f26 f28 ?v0) ?v1)) (f25 (f26 f28 (f25 ?v_0 ?v0)) (f25 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f25 f32 ?v0) (f25 f32 ?v1)) (= ?v0 ?v1))))
(check-sat)
(exit)
