(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 () S3)
(declare-fun f6 () S3)
(declare-fun f7 (S3 S4) S1)
(declare-fun f8 (S5) S4)
(declare-fun f9 (S6 S5) S5)
(declare-fun f10 () S6)
(declare-fun f11 () S5)
(declare-fun f12 (S8 S3) S3)
(declare-fun f13 (S9 S7) S8)
(declare-fun f14 (S10 Int) S9)
(declare-fun f15 () S10)
(declare-fun f16 (S11 S7) S3)
(declare-fun f17 (S12 Int) S11)
(declare-fun f18 () S12)
(declare-fun f19 (S13 Int) S12)
(declare-fun f20 () S13)
(declare-fun f21 () S13)
(declare-fun f22 (S14 Int) S8)
(declare-fun f23 () S14)
(declare-fun f24 (S15 S7) Int)
(declare-fun f25 () S15)
(declare-fun f26 (S16 S5) S7)
(declare-fun f27 (S17 S2) S16)
(declare-fun f28 () S17)
(declare-fun f29 () S2)
(declare-fun f30 (S18 S7) S7)
(declare-fun f31 (S19 Int) S18)
(declare-fun f32 () S19)
(declare-fun f33 () S7)
(declare-fun f34 (S20 S3) S21)
(declare-fun f35 () S20)
(declare-fun f36 (S22 Int) S21)
(declare-fun f37 () S22)
(declare-fun f38 (S23 S21) Int)
(declare-fun f39 () S23)
(assert (not (= f1 f2)))
(assert (not (not (= (f3 f4 f5) 0))))
(assert (not (= (f3 f4 f6) 0)))
(assert (= (f7 f5 (f8 (f9 f10 f11))) f1))
(assert (forall ((?v0 S3)) (=> (= (f7 ?v0 (f8 f11)) f1) (not (= (f3 f4 ?v0) 0)))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S3)) (= (f3 f4 (f12 (f13 (f14 f15 ?v0) ?v1) ?v2)) (f3 f4 ?v2))))
(assert (forall ((?v0 Int) (?v1 S7)) (= (f3 f4 (f16 (f17 f18 ?v0) ?v1)) 1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (= (f3 f4 (f16 (f17 (f19 f20 ?v0) ?v1) ?v2)) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (= (f3 f4 (f16 (f17 (f19 f21 ?v0) ?v1) ?v2)) ?v0)))
(assert (= f5 (f12 (f22 f23 (f24 f25 (f26 (f27 f28 f29) f11))) f6)))
(assert (exists ((?v0 S3)) (and (= (f7 ?v0 (f8 f11)) f1) (= f5 (f12 (f22 f23 (f24 f25 (f26 (f27 f28 f29) f11))) ?v0)))))
(assert (forall ((?v0 S3)) (=> (= (f7 ?v0 (f8 f11)) f1) (not (= (f3 f29 ?v0) 0)))))
(assert (= (f7 f6 (f8 f11)) f1))
(assert (not (= (f3 f29 f6) 0)))
(assert (=> (forall ((?v0 S3)) (=> (= (f7 ?v0 (f8 f11)) f1) (=> (= f5 (f12 (f22 f23 (f24 f25 (f26 (f27 f28 f29) f11))) ?v0)) false))) false))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int) (?v3 Int) (?v4 S7)) (not (= (f16 (f17 f18 ?v0) ?v1) (f16 (f17 (f19 f21 ?v2) ?v3) ?v4)))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int) (?v3 Int) (?v4 S7)) (not (= (f16 (f17 f18 ?v0) ?v1) (f16 (f17 (f19 f20 ?v2) ?v3) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 Int) (?v4 S7)) (not (= (f16 (f17 (f19 f21 ?v0) ?v1) ?v2) (f16 (f17 f18 ?v3) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 Int) (?v4 S7)) (not (= (f16 (f17 (f19 f20 ?v0) ?v1) ?v2) (f16 (f17 f18 ?v3) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 Int) (?v4 Int) (?v5 S7)) (not (= (f16 (f17 (f19 f21 ?v0) ?v1) ?v2) (f16 (f17 (f19 f20 ?v3) ?v4) ?v5)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 Int) (?v4 Int) (?v5 S7)) (not (= (f16 (f17 (f19 f20 ?v0) ?v1) ?v2) (f16 (f17 (f19 f21 ?v3) ?v4) ?v5)))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int) (?v3 S7)) (= (= (f16 (f17 f18 ?v0) ?v1) (f16 (f17 f18 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 Int) (?v4 Int) (?v5 S7)) (= (= (f16 (f17 (f19 f21 ?v0) ?v1) ?v2) (f16 (f17 (f19 f21 ?v3) ?v4) ?v5)) (and (= ?v0 ?v3) (and (= ?v1 ?v4) (= ?v2 ?v5))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 Int) (?v4 Int) (?v5 S7)) (= (= (f16 (f17 (f19 f20 ?v0) ?v1) ?v2) (f16 (f17 (f19 f20 ?v3) ?v4) ?v5)) (and (= ?v0 ?v3) (and (= ?v1 ?v4) (= ?v2 ?v5))))))
(assert (or (= f5 (f16 (f17 (f19 f21 (f24 f25 (f26 (f27 f28 f29) f11))) 0) (f30 (f31 f32 1) f33))) (exists ((?v0 S3)) (and (= (f7 ?v0 (f8 f11)) f1) (= f5 (f12 (f22 f23 (f24 f25 (f26 (f27 f28 f29) f11))) ?v0))))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S2)) (= (= (f26 (f27 f28 ?v0) ?v1) (f26 (f27 f28 ?v2) ?v1)) (forall ((?v3 S3)) (=> (= (f7 ?v3 (f8 ?v1)) f1) (= (f3 ?v0 ?v3) (f3 ?v2 ?v3)))))))
(assert (forall ((?v0 S3)) (=> (forall ((?v1 Int) (?v2 S7)) (=> (= ?v0 (f16 (f17 f18 ?v1) ?v2)) false)) (=> (forall ((?v1 Int) (?v2 Int) (?v3 S7)) (=> (= ?v0 (f16 (f17 (f19 f21 ?v1) ?v2) ?v3)) false)) (=> (forall ((?v1 Int) (?v2 Int) (?v3 S7)) (=> (= ?v0 (f16 (f17 (f19 f20 ?v1) ?v2) ?v3)) false)) false)))))
(assert (forall ((?v0 Int) (?v1 S7)) (= (f34 f35 (f16 (f17 f18 ?v0) ?v1)) (f36 f37 0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (= (f34 f35 (f16 (f17 (f19 f20 ?v0) ?v1) ?v2)) (f36 f37 0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (= (f34 f35 (f16 (f17 (f19 f21 ?v0) ?v1) ?v2)) (f36 f37 0))))
(assert (forall ((?v0 S21)) (= (f36 f37 (f38 f39 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f38 f39 (f36 f37 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f38 f39 (f36 f37 ?v0)) 0))))
(check-sat)
(exit)
