(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 (S4 Int) S3)
(declare-fun f5 () S4)
(declare-fun f6 (Int S5) S1)
(declare-fun f7 (S6 S7) Int)
(declare-fun f8 () S6)
(declare-fun f9 () S7)
(declare-fun f10 (S8 S5) S5)
(declare-fun f11 (Int) S8)
(declare-fun f12 () S5)
(declare-fun f13 (S5 Int) S1)
(declare-fun f14 (Int) S5)
(declare-fun f15 (Int) S5)
(declare-fun f16 (Int) S8)
(declare-fun f17 (Int) S8)
(declare-fun f18 (Int) S8)
(declare-fun f19 (Int) S8)
(declare-fun f20 (S9 Int) S4)
(declare-fun f21 () S9)
(declare-fun f22 () S5)
(declare-fun f23 (S4 S9 S9 S7) S1)
(declare-fun f24 () S7)
(declare-fun f25 (S5) S5)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f6 (f7 f8 f9) (f10 (f11 1) (f10 (f11 (- 1)) f12))) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 (f14 ?v0) ?v1) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 (f15 ?v0) ?v1) f1) (= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (= (= (f13 (f10 (f16 ?v0) ?v1) ?v2) f1) (or (= ?v2 ?v0) (= (f6 ?v2 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (= (= (f13 (f10 (f17 ?v0) ?v1) ?v2) f1) (and (= ?v0 ?v2) (= (f13 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (= (= (f13 (f10 (f18 ?v0) ?v1) ?v2) f1) (and (= ?v2 ?v0) (= (f13 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (= (= (f13 (f10 (f19 ?v0) ?v1) ?v2) f1) (=> (not (= ?v2 ?v0)) (= (f13 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (= (f3 (f4 (f20 f21 ?v0) ?v1) ?v2) f1) (= (f7 f8 f9) 1))))
(assert (forall ((?v0 Int)) (= (= (f13 f22 ?v0) f1) false)))
(assert (not (= (f23 f5 f21 f21 f9) f1)))
(assert (not (= (f7 f8 f24) 0)))
(assert (not (= (f7 f8 f24) 0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f6 ?v0 (f10 (f11 ?v1) ?v2)) f1) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f6 ?v0 ?v2) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (=> (=> (not (= (f6 ?v0 ?v1) f1)) (= ?v0 ?v2)) (= (f6 ?v0 (f10 (f11 ?v2) ?v1)) f1))))
(assert (forall ((?v0 Int)) (=> (= (f6 ?v0 f12) f1) false)))
(assert (forall ((?v0 Int)) (= (f25 (f14 ?v0)) (f10 (f11 ?v0) f12))))
(assert (forall ((?v0 Int)) (= (f25 (f15 ?v0)) (f10 (f11 ?v0) f12))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f25 (f10 (f17 ?v0) ?v1)) (ite (= (f13 ?v1 ?v0) f1) (f10 (f11 ?v0) f12) f12))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f25 (f10 (f18 ?v0) ?v1)) (ite (= (f13 ?v1 ?v0) f1) (f10 (f11 ?v0) f12) f12))))
(assert (forall ((?v0 Int) (?v1 S5)) (not (= f12 (f10 (f11 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S5)) (not (= (f10 (f11 ?v0) ?v1) f12))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f6 ?v0 (f10 (f11 ?v1) f12)) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (= (f10 (f11 ?v0) (f10 (f11 ?v1) f12)) (f10 (f11 ?v2) (f10 (f11 ?v3) f12))) (or (and (= ?v0 ?v2) (= ?v1 ?v3)) (and (= ?v0 ?v3) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f6 ?v0 (f10 (f11 ?v1) f12)) f1) (=> (=> (= ?v0 ?v1) false) false))))
(assert (forall ((?v0 S5) (?v1 Int)) (=> (= ?v0 f12) (not (= (f6 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S5)) (= (= (f25 ?v0) f12) (forall ((?v1 Int)) (not (= (f13 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int)) (= (= (f6 ?v0 f12) f1) false)))
(assert (forall ((?v0 S5)) (= (= f12 (f25 ?v0)) (forall ((?v1 Int)) (not (= (f13 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S5)) (= (forall ((?v1 Int)) (=> (= (f6 ?v1 f12) f1) (= (f13 ?v0 ?v1) f1))) true)))
(assert (forall ((?v0 S5)) (= (exists ((?v1 Int)) (and (= (f6 ?v1 f12) f1) (= (f13 ?v0 ?v1) f1))) false)))
(assert (forall ((?v0 S5)) (= (exists ((?v1 Int)) (= (f6 ?v1 ?v0) f1)) (not (= ?v0 f12)))))
(assert (forall ((?v0 S5)) (= (forall ((?v1 Int)) (not (= (f6 ?v1 ?v0) f1))) (= ?v0 f12))))
(assert (= f12 (f25 f22)))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (= (f6 ?v0 ?v1) f1) (= (f10 (f11 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (=> (= (f6 ?v0 ?v1) f1) (= (f6 ?v0 (f10 (f11 ?v2) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 ?v0))) (=> (not (= (f6 ?v0 ?v1) f1)) (=> (not (= (f6 ?v0 ?v2) f1)) (= (= (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) (= ?v1 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (= (= (f13 (f10 (f11 ?v0) ?v1) ?v2) f1) (or (= ?v0 ?v2) (= (f13 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (= (f6 ?v0 (f10 (f11 ?v1) ?v2)) f1) (or (= ?v0 ?v1) (= (f6 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (let ((?v_1 (f11 ?v0)) (?v_0 (f11 ?v1))) (= (f10 ?v_1 (f10 ?v_0 ?v2)) (f10 ?v_0 (f10 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f11 ?v0))) (let ((?v_1 (f10 ?v_0 ?v1))) (= (f10 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f10 (f11 ?v0) (f25 ?v1)) (f25 (f10 (f19 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f10 (f11 ?v0) ?v1) (f25 (f10 (f16 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f6 ?v0 (f10 (f11 ?v0) ?v1)) f1)))
(check-sat)
(exit)
