(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2) S1)
(declare-fun f4 (S3 S4) S2)
(declare-fun f5 (S5 S2) S3)
(declare-fun f6 (S6 S2) S5)
(declare-fun f7 () S6)
(declare-fun f8 () S2)
(declare-fun f9 () S2)
(declare-fun f10 () S4)
(declare-fun f11 (S7 S2 S8) S1)
(declare-fun f12 (S9 S8) S7)
(declare-fun f13 (S10 S4) S9)
(declare-fun f14 (S11 S7) S10)
(declare-fun f15 () S11)
(declare-fun f16 () S7)
(declare-fun f17 () S8)
(declare-fun f18 () S8)
(declare-fun f19 (S7 S4) S8)
(declare-fun f20 (S12 S4) Int)
(declare-fun f21 () S12)
(declare-fun f22 (S13 Int) S4)
(declare-fun f23 () S13)
(declare-fun f24 () S3)
(declare-fun f25 () S5)
(declare-fun f26 (S14 S2) S2)
(declare-fun f27 () S14)
(declare-fun f28 () S6)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 (f6 f7 f8) f9) f10)) f1)))
(assert (= (f3 f8) f1))
(assert (= (f11 (f12 (f13 (f14 f15 f16) f10) f17) f8 f18) f1))
(assert (= (f3 f9) f1))
(assert (= (f11 f16 f9 f17) f1))
(assert (forall ((?v0 S7) (?v1 S2) (?v2 S8) (?v3 S7) (?v4 S2) (?v5 S8) (?v6 S4)) (=> (= (f11 ?v0 ?v1 ?v2) f1) (=> (= (f11 ?v3 ?v4 ?v5) f1) (=> (= ?v0 (f12 (f13 (f14 f15 ?v3) ?v6) ?v5)) (= (f11 ?v3 (f4 (f5 (f6 f7 ?v1) ?v4) ?v6) ?v2) f1))))))
(assert (forall ((?v0 S7) (?v1 S4) (?v2 S8) (?v3 S4)) (let ((?v_0 (f20 f21 ?v3))) (= (f19 (f12 (f13 (f14 f15 ?v0) ?v1) ?v2) ?v3) (ite (< ?v_0 (f20 f21 ?v1)) (f19 ?v0 ?v3) (ite (= ?v3 ?v1) ?v2 (f19 ?v0 (f22 f23 (- ?v_0 1)))))))))
(assert (forall ((?v0 S7) (?v1 S4) (?v2 S8) (?v3 S8)) (let ((?v_0 (f14 f15 ?v0)) (?v_1 (f22 f23 0))) (= (f12 (f13 (f14 f15 (f12 (f13 ?v_0 ?v1) ?v2)) ?v_1) ?v3) (f12 (f13 (f14 f15 (f12 (f13 ?v_0 ?v_1) ?v3)) (f22 f23 (+ (f20 f21 ?v1) 1))) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S7) (?v3 S8)) (=> (= ?v0 ?v1) (= (f19 (f12 (f13 (f14 f15 ?v2) ?v0) ?v3) ?v1) ?v3))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S7) (?v3 S8)) (=> (< (f20 f21 ?v0) (f20 f21 ?v1)) (= (f19 (f12 (f13 (f14 f15 ?v2) ?v1) ?v3) ?v0) (f19 ?v2 ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S7) (?v3 S8)) (let ((?v_0 (f20 f21 ?v1))) (=> (< (f20 f21 ?v0) ?v_0) (= (f19 (f12 (f13 (f14 f15 ?v2) ?v0) ?v3) ?v1) (f19 ?v2 (f22 f23 (- ?v_0 1))))))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S4)) (=> (= (f3 ?v0) f1) (= (f3 (f4 (f5 (f6 f7 ?v0) (f4 f24 ?v1)) ?v2)) f1))))
(assert (forall ((?v0 S7) (?v1 S2) (?v2 S8) (?v3 S4) (?v4 S8)) (=> (= (f11 ?v0 ?v1 ?v2) f1) (= (f11 (f12 (f13 (f14 f15 ?v0) ?v3) ?v4) (f4 (f5 f25 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 S4)) (=> (= (f3 ?v0) f1) (= (f3 (f4 (f5 f25 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S7) (?v1 S2) (?v2 S8)) (=> (= (f11 ?v0 (f26 f27 ?v1) ?v2) f1) (=> (forall ((?v3 S8) (?v4 S8)) (=> (= (f11 (f12 (f13 (f14 f15 ?v0) (f22 f23 0)) ?v3) ?v1 ?v4) f1) false)) false))))
(assert (forall ((?v0 S4)) (= (f3 (f4 f24 ?v0)) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f22 f23 0))) (= (f4 (f5 (f6 f28 ?v0) ?v1) ?v_0) (f4 (f5 (f6 f7 ?v0) ?v1) ?v_0)))))
(assert (forall ((?v0 S7) (?v1 S4) (?v2 S8)) (=> (= (f11 ?v0 (f4 f24 ?v1) ?v2) f1) (=> (=> (= (f19 ?v0 ?v1) ?v2) false) false))))
(assert (forall ((?v0 S7) (?v1 S4) (?v2 S8)) (=> (= (f19 ?v0 ?v1) ?v2) (= (f11 ?v0 (f4 f24 ?v1) ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 S4)) (not (= (f26 f27 ?v0) (f4 f24 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S2)) (not (= (f4 f24 ?v0) (f26 f27 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S4)) (= (f4 (f5 f25 (f26 f27 ?v0)) ?v1) (f26 f27 (f4 (f5 f25 ?v0) (f22 f23 (+ (f20 f21 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f4 f24 ?v0)) (?v_1 (f20 f21 ?v0))) (= (f4 (f5 f25 ?v_0) ?v1) (ite (< ?v_1 (f20 f21 ?v1)) ?v_0 (f4 f24 (f22 f23 (+ ?v_1 1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f26 f27 ?v0) (f26 f27 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f4 f24 ?v0) (f4 f24 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (= (f4 (f5 (f6 f28 (f26 f27 ?v0)) ?v1) ?v2) (f26 f27 (f4 (f5 (f6 f28 ?v0) ?v1) (f22 f23 (+ (f20 f21 ?v2) 1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (let ((?v_0 (+ (f20 f21 ?v1) 1)) (?v_1 (f5 f25 ?v2))) (=> (< (f20 f21 ?v0) ?v_0) (= (f4 (f5 f25 (f4 ?v_1 ?v0)) (f22 f23 ?v_0)) (f4 (f5 f25 (f4 ?v_1 ?v1)) ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (= (f4 (f5 (f6 f7 (f26 f27 ?v0)) ?v1) ?v2) (f26 f27 (f4 (f5 (f6 f7 ?v0) (f4 (f5 f25 ?v1) (f22 f23 0))) (f22 f23 (+ (f20 f21 ?v2) 1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (let ((?v_0 (f20 f21 ?v1))) (=> (< (f20 f21 ?v0) ?v_0) (= (f4 (f5 (f6 f7 (f4 f24 ?v1)) ?v2) ?v0) (f4 f24 (f22 f23 (- ?v_0 1))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (let ((?v_0 (f4 f24 ?v0))) (=> (< (f20 f21 ?v0) (f20 f21 ?v1)) (= (f4 (f5 (f6 f7 ?v_0) ?v2) ?v1) ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4)) (let ((?v_1 (f4 f24 ?v0)) (?v_0 (f20 f21 ?v0))) (= (f4 (f5 (f6 f7 ?v_1) ?v1) ?v2) (ite (< (f20 f21 ?v2) ?v_0) (f4 f24 (f22 f23 (- ?v_0 1))) (ite (= ?v0 ?v2) ?v1 ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S2)) (= (f4 (f5 (f6 f7 (f4 f24 ?v0)) ?v1) ?v0) ?v1)))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (+ (f20 f21 ?v1) 1)) (?v_1 (f6 f7 ?v2))) (=> (< (f20 f21 ?v0) ?v_0) (= (f4 (f5 (f6 f7 (f4 (f5 ?v_1 (f4 (f5 f25 ?v3) ?v0)) (f22 f23 ?v_0))) (f4 (f5 (f6 f7 ?v4) ?v3) ?v1)) ?v0) (f4 (f5 (f6 f7 (f4 (f5 ?v_1 ?v4) ?v0)) ?v3) ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2)) (let ((?v_0 (+ (f20 f21 ?v1) 1))) (=> (< (f20 f21 ?v0) ?v_0) (= (f4 (f5 f25 (f4 (f5 (f6 f7 ?v2) ?v3) ?v0)) ?v1) (f4 (f5 (f6 f7 (f4 (f5 f25 ?v2) (f22 f23 ?v_0))) (f4 (f5 f25 ?v3) ?v1)) ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2)) (let ((?v_0 (+ (f20 f21 ?v1) 1))) (=> (< (f20 f21 ?v0) ?v_0) (= (f4 (f5 f25 (f4 (f5 (f6 f7 ?v2) ?v3) ?v1)) ?v0) (f4 (f5 (f6 f7 (f4 (f5 f25 ?v2) ?v0)) (f4 (f5 f25 ?v3) ?v0)) (f22 f23 ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S2)) (= (f4 (f5 (f6 f7 (f4 (f5 f25 ?v0) ?v1)) ?v2) ?v1) ?v0)))
(assert (forall ((?v0 S2)) (=> (= (f3 ?v0) f1) (= (f3 (f26 f27 ?v0)) f1))))
(assert (forall ((?v0 S4)) (= (f22 f23 (f20 f21 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f20 f21 (f22 f23 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f20 f21 (f22 f23 ?v0)) 0))))
(check-sat)
(exit)
