(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3 S4) S1)
(declare-fun f4 (S5 S4) S2)
(declare-fun f5 (S6 S7) S5)
(declare-fun f6 (S8 S2) S6)
(declare-fun f7 () S8)
(declare-fun f8 () S2)
(declare-fun f9 (S9 Int) S7)
(declare-fun f10 () S9)
(declare-fun f11 () S4)
(declare-fun f12 (S7) S3)
(declare-fun f13 (S10 S3) S7)
(declare-fun f14 () S10)
(declare-fun f15 (S2 S7) S4)
(declare-fun f16 (S11 S7) Int)
(declare-fun f17 () S11)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f9 f10 0))) (not (= (f3 (f4 (f5 (f6 f7 f8) ?v_0) f11) (f12 ?v_0) f11) f1))))
(assert (forall ((?v0 S7)) (= (f13 f14 (f12 ?v0)) (f9 f10 0))))
(assert (forall ((?v0 S2) (?v1 S7) (?v2 S4)) (=> (= (f15 ?v0 ?v1) ?v2) (= (f3 ?v0 (f12 ?v1) ?v2) f1))))
(assert (forall ((?v0 S7)) (= (f9 f10 (f16 f17 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f16 f17 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f16 f17 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
