(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S4)
(declare-fun f4 (S5 S4) S2)
(declare-fun f5 (S6 S3) S5)
(declare-fun f6 (S7 S2) S6)
(declare-fun f7 () S7)
(declare-fun f8 (S8 S3) Int)
(declare-fun f9 () S8)
(declare-fun f10 (S9 Int) S3)
(declare-fun f11 () S9)
(declare-fun f12 (S2 S10 S4) S1)
(declare-fun f13 (S3) S10)
(declare-fun f14 () S2)
(declare-fun f15 (S11 S4) S4)
(declare-fun f16 (S12 S13) S11)
(declare-fun f17 (S14 S15) S12)
(declare-fun f18 () S14)
(declare-fun f19 () S15)
(declare-fun f20 () S13)
(declare-fun f21 () S4)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S4) (?v3 S3)) (let ((?v_0 (f8 f9 ?v3))) (= (f3 (f4 (f5 (f6 f7 ?v0) ?v1) ?v2) ?v3) (ite (< ?v_0 (f8 f9 ?v1)) (f3 ?v0 ?v3) (ite (= ?v3 ?v1) ?v2 (f3 ?v0 (f10 f11 (- ?v_0 1)))))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S4)) (=> (= (f3 ?v0 ?v1) ?v2) (= (f12 ?v0 (f13 ?v1) ?v2) f1))))
(assert (let ((?v_0 (f10 f11 0)) (?v_1 (f15 (f16 (f17 f18 f19) f20) f21))) (not (= (f12 (f4 (f5 (f6 f7 f14) ?v_0) ?v_1) (f13 ?v_0) ?v_1) f1))))
(assert (forall ((?v0 S3)) (= (f10 f11 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f10 f11 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f10 f11 ?v0)) 0))))
(check-sat)
(exit)
