(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 (Int Int) S3)
(declare-fun f6 () Int)
(declare-fun f7 (S4 Int) Int)
(declare-fun f8 (S5 Int) S4)
(declare-fun f9 () S5)
(declare-fun f10 () Int)
(declare-fun f11 () Int)
(declare-fun f12 (S6 S7) Int)
(declare-fun f13 (S8 Int) S6)
(declare-fun f14 () S8)
(declare-fun f15 (S9 Int) S7)
(declare-fun f16 () S9)
(declare-fun f17 (Int) S1)
(declare-fun f18 () S5)
(declare-fun f19 (Int Int) S1)
(declare-fun f20 (Int Int Int) S1)
(declare-fun f21 () Int)
(declare-fun f22 (Int Int) S1)
(declare-fun f23 (Int) S1)
(declare-fun f24 () S6)
(assert (not (= f1 f2)))
(assert (not (= (f3 f4 (f5 f6 1)) (f7 (f8 f9 (+ (* 4 f10) 1)) f11))))
(assert (= (+ (f12 (f13 f14 f6) (f15 f16 2)) 1) (f7 (f8 f9 (+ (* 4 f10) 1)) f11)))
(assert (< 0 (+ (* 4 f10) 1)))
(assert (let ((?v_0 (f12 (f13 f14 f6) (f15 f16 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (= (+ (f12 (f13 f14 f6) (f15 f16 2)) 1) (f7 (f8 f9 (+ (* 4 f10) 1)) f11)))
(assert (= (f17 (+ (* 4 f10) 1)) f1))
(assert (= (f7 (f8 f18 (- 1)) (+ (* 4 f10) 1)) 1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f12 (f13 f14 f6) (f15 f16 2)) 1) (f7 (f8 f9 (+ (* 4 f10) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (f7 (f8 f9 (f3 f4 (f5 ?v0 ?v1))) (f3 f4 (f5 ?v2 ?v3))) (f3 f4 (f5 (+ (f7 ?v_0 ?v2) (f7 ?v_1 ?v3)) (- (f7 ?v_0 ?v3) (f7 ?v_1 ?v2))))))))
(assert (= (f19 (+ (* 4 f10) 1) (- 1)) f1))
(assert (let ((?v_0 (+ (* 4 f10) 1))) (and (<= 0 f6) (and (< f6 ?v_0) (= (f20 f21 f6 ?v_0) f1)))))
(assert (= (f22 (+ (* 4 f10) 1) (+ (f12 (f13 f14 f6) (f15 f16 2)) 1)) f1))
(assert (= (f22 (+ (* 4 f10) 1) (- (f12 (f13 f14 f6) (f15 f16 2)) (- 1))) f1))
(assert (= (f20 (f12 (f13 f14 f6) (f15 f16 2)) (- 1) (+ (* 4 f10) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f10) 1))) (=> (not (= (f19 ?v_0 (- 1)) f1)) (not (= (f7 (f8 f18 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int)) (= (= (f23 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f3 f4 (f5 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0) f1) (=> (= (f23 ?v1) f1) (= (f23 (f7 (f8 f9 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 ?v_0 (+ ?v1 ?v2)) (+ (f7 ?v_0 ?v1) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 ?v_0 (- ?v1 ?v2)) (- (f7 ?v_0 ?v1) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f8 f9 (- ?v0)) ?v1) (- (f7 (f8 f9 ?v0) ?v1)))))
(assert (= (f20 (f12 (f13 f14 f21) (f15 f16 2)) (- 1) (+ (* 4 f10) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f20 (f12 (f13 f14 ?v0) (f15 f16 2)) (- 1) (+ (* 4 f10) 1)) f1) false)) false))
(assert (let ((?v_0 (f15 f16 2))) (= (f20 (f12 (f13 f14 f6) ?v_0) (f12 (f13 f14 f21) ?v_0) (+ (* 4 f10) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f10) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f20 f21 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f10) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f20 f21 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f20 f21 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 S7)) (<= 0 (f12 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S7)) (= (< 0 (f12 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f15 f16 0))))))
(assert (forall ((?v0 Int)) (= (= (f22 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f22 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f17 ?v_0) f1) (= (f7 (f8 f18 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f22 ?v0 ?v1) f1) (=> (= (f22 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f22 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 S7)) (= (f15 f16 (f12 f24 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f12 f24 (f15 f16 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f12 f24 (f15 f16 ?v0)) 0))))
(check-sat)
(exit)
