(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 (S5 Int) S3)
(declare-fun f8 () S5)
(declare-fun f9 (S6 Int) Int)
(declare-fun f10 (S7 Int) S6)
(declare-fun f11 () S7)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 (Int Int) S1)
(declare-fun f15 (Int Int Int) S1)
(declare-fun f16 (Int) S1)
(declare-fun f17 () S7)
(declare-fun f18 () Int)
(declare-fun f19 (Int) S1)
(declare-fun f20 () S2)
(declare-fun f21 (Int Int) S1)
(declare-fun f22 (S8 S9) Int)
(declare-fun f23 () S8)
(declare-fun f24 (Int Int) S9)
(assert (not (= f1 f2)))
(assert (not (= (+ (f3 (f4 f5 f6) (f7 f8 2)) 1) 0)))
(assert (= (+ (f3 (f4 f5 f6) (f7 f8 2)) 1) (f9 (f10 f11 (+ (* 4 f12) 1)) f13)))
(assert (= f13 0))
(assert (< f13 1))
(assert (< 0 (+ (* 4 f12) 1)))
(assert (< f13 (+ (* 4 f12) 1)))
(assert (= (+ (f3 (f4 f5 f6) (f7 f8 2)) 1) (f9 (f10 f11 (+ (* 4 f12) 1)) f13)))
(assert (let ((?v_0 (f3 (f4 f5 f6) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f6) (f7 f8 2)) 1) (f9 (f10 f11 (+ (* 4 f12) 1)) ?v0)) false)) false))
(assert (= (f14 (+ (* 4 f12) 1) (+ (f3 (f4 f5 f6) (f7 f8 2)) 1)) f1))
(assert (= (f14 (+ (* 4 f12) 1) (- (f3 (f4 f5 f6) (f7 f8 2)) (- 1))) f1))
(assert (= (f15 (f3 (f4 f5 f6) (f7 f8 2)) (- 1) (+ (* 4 f12) 1)) f1))
(assert (= (f16 (+ (* 4 f12) 1)) f1))
(assert (= (f9 (f10 f17 (- 1)) (+ (* 4 f12) 1)) 1))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f7 f8 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 3))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 3))) (= (f3 (f4 f5 (- ?v0)) ?v_0) (- (f3 (f4 f5 ?v0) ?v_0))))))
(assert (= f13 0))
(assert (not (<= 1 f13)))
(assert (= (f15 (f3 (f4 f5 f18) (f7 f8 2)) (- 1) (+ (* 4 f12) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f12) 1))) (and (<= 0 f6) (and (< f6 ?v_0) (= (f15 f18 f6 ?v_0) f1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f15 (f3 (f4 f5 ?v0) (f7 f8 2)) (- 1) (+ (* 4 f12) 1)) f1) false)) false))
(assert (= (f19 (f9 (f10 f11 (+ (* 4 f12) 1)) f13)) f1))
(assert (= (f16 2) f1))
(assert (forall ((?v0 Int)) (= (= (f14 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f9 (f10 f11 ?v0) ?v1) (f9 (f10 f11 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (+ ?v1 ?v2)) (+ (f9 ?v_0 ?v1) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (- ?v1 ?v2)) (- (f9 ?v_0 ?v1) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f14 ?v0 (+ ?v1 (f9 (f10 f11 ?v0) ?v2))) f1) (= (f14 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f9 (f10 f11 (- ?v0)) ?v1) (- (f9 (f10 f11 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f9 (f10 f11 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f10 f11 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f9 (f10 f11 (+ ?v0 ?v1)) ?v2) (+ (f9 (f10 f11 ?v0) ?v2) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f9 (f10 f11 (- ?v0 ?v1)) ?v2) (- (f9 (f10 f11 ?v0) ?v2) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v2))) (=> (= (f16 ?v0) f1) (=> (not (= (f14 ?v0 ?v1) f1)) (=> (= (f14 ?v_0 (f9 (f10 f11 ?v1) ?v3)) f1) (= (f14 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v2))) (=> (= (f16 ?v0) f1) (=> (not (= (f14 ?v0 ?v1) f1)) (=> (= (f14 ?v_0 (f9 (f10 f11 ?v3) ?v1)) f1) (= (f14 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f16 ?v0) f1) (=> (= (f14 ?v0 (f3 (f4 f5 ?v1) ?v2)) f1) (= (f14 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f14 (f9 (f10 f11 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f14 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f16 ?v_0) f1) (= (f9 (f10 f17 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f9 (f10 f11 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f14 ?v0 ?v1) f1) (=> (= (f14 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f9 (f10 f11 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f14 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f14 ?v0 ?v1) f1) (= (= (f14 ?v0 (+ ?v2 ?v3)) f1) (= (f14 ?v0 (+ (+ ?v2 (f9 (f10 f11 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f9 ?v_0 ?v0) (f9 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f20 ?v2))) (let ((?v_1 (f10 f11 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f9 ?v_1 ?v0) (f9 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0 ?v1) f1) (=> (= (f14 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f14 ?v0 (- ?v1 ?v2)) f1) (=> (= (f14 ?v0 ?v2) f1) (= (f14 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 (f10 f11 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 (f10 f11 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f14 (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f14 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f9 (f10 f11 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f9 (f10 f11 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f9 (f10 f11 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f9 (f10 f11 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f9 (f10 f11 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (f9 (f10 f11 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (f9 (f10 f11 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f9 (f10 f11 ?v0) (f3 ?v_0 (f7 f8 2))) (f3 ?v_0 (f7 f8 3))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (f3 f20 ?v1) (f3 f20 ?v2)))) (f9 (f10 f11 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f4 f5 ?v0) (f7 f8 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (= (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f7 f8 4))))))
(assert (let ((?v_0 (f7 f8 2))) (= (f15 (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f18) ?v_0) (+ (* 4 f12) 1)) f1)))
(assert (let ((?v_0 (+ (* 4 f12) 1))) (=> (not (= (f21 ?v_0 (- 1)) f1)) (not (= (f9 (f10 f17 (- 1)) ?v_0) 1)))))
(assert (= (f21 (+ (* 4 f12) 1) (- 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (not (= (f14 ?v0 ?v1) f1)) (= (f15 (f3 (f4 f5 ?v1) (f7 f8 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f16 ?v0) f1) (=> (= (f14 ?v0 (f3 (f4 f5 ?v1) ?v2)) f1) (=> (< 0 (f3 f20 ?v2)) (= (f14 ?v0 ?v1) f1))))))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f12) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f15 f18 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f15 f18 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f12) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f15 f18 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (= (f14 ?v0 (f9 (f10 f11 ?v1) ?v2)) f1) (or (= (f14 ?v0 ?v1) f1) (= (f14 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f16 ?v1) f1) (=> (= (f14 ?v1 (f9 (f10 f11 ?v0) ?v2)) f1) (or (= (f14 ?v1 ?v0) f1) (= (f14 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (not (= (f15 ?v1 0 ?v0) f1)) (=> (not (= (f15 ?v2 0 ?v0) f1)) (not (= (f15 (f9 (f10 f11 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f19 ?v0) f1) (=> (= (f19 ?v1) f1) (= (f19 (f9 (f10 f11 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f10 f11 ?v1))) (= (+ (f9 (f10 f11 (- ?v0 (f9 ?v_0 ?v2))) ?v3) (f9 (f10 f11 (- ?v4 (f9 ?v_0 ?v5))) ?v6)) (- (+ (f9 (f10 f11 ?v0) ?v3) (f9 (f10 f11 ?v4) ?v6)) (f9 ?v_0 (+ (f9 (f10 f11 ?v2) ?v3) (f9 (f10 f11 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f15 ?v0 ?v1 ?v2) f1) (=> (= (f15 ?v3 ?v4 ?v2) f1) (= (f15 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f15 ?v0 ?v1 ?v2) f1) (=> (= (f15 ?v3 ?v4 ?v2) f1) (= (f15 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f15 ?v0 ?v1 ?v2) f1) (=> (= (f15 ?v1 ?v3 ?v2) f1) (= (f15 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f15 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f15 ?v3 ?v4 ?v2) f1) (= (f15 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f15 ?v0 ?v1 ?v2) f1) (= (f15 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f15 ?v1 (- 1) ?v0) f1) (not (= (f15 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f15 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f15 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f15 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f15 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f15 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f15 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int)) (= (f15 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f15 ?v0 ?v1 (- ?v2)) f1) (= (f15 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f15 ?v0 ?v1 ?v2) f1) (= (f15 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f15 ?v0 ?v1 ?v2) f1) (=> (= (f15 ?v3 ?v4 ?v2) f1) (= (f15 (f9 (f10 f11 ?v0) ?v3) (f9 (f10 f11 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f10 f11 ?v3))) (=> (= (f15 ?v0 ?v1 ?v2) f1) (= (f15 (f9 ?v_0 ?v0) (f9 ?v_0 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f15 ?v0 ?v1 ?v2) f1) (= (f15 (f9 (f10 f11 ?v0) ?v3) (f9 (f10 f11 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f10 f11 ?v4))) (=> (= (f15 ?v0 ?v1 ?v2) f1) (= (= (f15 ?v3 (f9 ?v_0 ?v0) ?v2) f1) (= (f15 ?v3 (f9 ?v_0 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f15 ?v0 ?v1 ?v2) f1) (= (= (f15 ?v3 (f9 (f10 f11 ?v0) ?v4) ?v2) f1) (= (f15 ?v3 (f9 (f10 f11 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f15 (f9 (f10 f11 ?v0) ?v1) (f9 (f10 f11 ?v2) ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f15 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f9 (f10 f11 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f15 ?v0 ?v1 ?v2) f1) (= (f14 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 ?v0 0 ?v1) f1) (= (f14 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 ?v0 0 ?v1) f1) (= (f14 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f15 ?v0 ?v1 ?v2) f1) (= (f15 (f3 (f4 f5 ?v0) ?v3) (f3 (f4 f5 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f3 f20 ?v0)) (=> (= (f14 ?v1 ?v2) f1) (= (f14 ?v1 (f3 (f4 f5 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int)) (= (= (f16 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f14 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (= (f15 (f9 (f10 f11 ?v1) ?v1) 1 ?v0) f1) (or (= (f15 ?v1 1 ?v0) f1) (= (f15 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (= (f15 (f9 (f10 f11 ?v1) ?v2) 0 ?v0) f1) (or (= (f15 ?v1 0 ?v0) f1) (= (f15 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f15 ?v1 0 ?v0) f1)) (not (= (f15 ?v2 0 ?v0) f1))) (not (= (f15 (f9 (f10 f11 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f15 (f9 (f10 f11 ?v1) ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f9 (f10 f17 ?v0) ?v1) (ite (= (f15 ?v0 0 ?v1) f1) 0 (ite (= (f21 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f21 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f15 (f3 (f4 f5 ?v2) (f7 f8 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f15 ?v0 0 ?v1) f1)) (=> (= (f15 (f3 (f4 f5 ?v2) (f7 f8 2)) ?v0 ?v1) f1) (not (= (f14 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f16 ?v1) f1) (= (f14 ?v1 ?v0) f1))))))
(assert (= (f22 f23 (f24 f6 1)) (f9 (f10 f11 (+ (* 4 f12) 1)) f13)))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f7 f8 0))) (= (= (f14 (f3 (f4 f5 ?v1) ?v0) (f3 (f4 f5 ?v2) ?v0)) f1) (= (f14 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f10 f11 ?v0)) (?v_1 (f10 f11 ?v1))) (= (f9 (f10 f11 (f22 f23 (f24 ?v0 ?v1))) (f22 f23 (f24 ?v2 ?v3))) (f22 f23 (f24 (+ (f9 ?v_0 ?v2) (f9 ?v_1 ?v3)) (- (f9 ?v_0 ?v3) (f9 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 ?v1)) (?v_1 (f7 f8 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (f9 (f10 f11 ?v1) (f3 ?v_0 (f7 f8 (- (f3 f20 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f14 (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v2) ?v1)) f1) (=> (not (= ?v1 (f7 f8 0))) (= (f14 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int)) (= (= (f19 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f22 f23 (f24 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 (- 1)))) (let ((?v_1 (f3 ?v_0 ?v1)) (?v_2 (f3 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f15 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (=> (not (= ?v0 0)) (= (= (f14 ?v1 ?v2) f1) (= (f14 (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f15 (f9 (f10 f11 ?v0) ?v_0) 1 ?v1) f1) (= (f15 ?v0 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f9 (f10 f11 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 S3)) (= (f7 f8 (f3 f20 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f20 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f20 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
