(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int) S1)
(declare-fun f4 (S2 Int) Int)
(declare-fun f5 (S3 Int) S2)
(declare-fun f6 () S3)
(declare-fun f7 () Int)
(declare-fun f8 () Int)
(declare-fun f9 (Int) S1)
(declare-fun f10 () S3)
(declare-fun f11 (Int Int) S1)
(declare-fun f12 () S4)
(declare-fun f13 (S5 Int) S4)
(declare-fun f14 () S5)
(declare-fun f15 (S6 S4) Int)
(declare-fun f16 () S6)
(declare-fun f17 (S7 Int) S6)
(declare-fun f18 () S7)
(declare-fun f19 () Int)
(declare-fun f20 (Int Int) S1)
(declare-fun f21 (Int Int Int) S1)
(declare-fun f22 (S8 S9) Int)
(declare-fun f23 () S8)
(declare-fun f24 (Int Int) S9)
(declare-fun f25 () Int)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 f6 (+ (* 4 f7) 1)) (+ 1 0))) f1)))
(assert (< 1 f8))
(assert (< 0 (+ (* 4 f7) 1)))
(assert (= (f9 (+ (* 4 f7) 1)) f1))
(assert (= (f4 (f5 f10 (- 1)) (+ (* 4 f7) 1)) 1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 ?v0) f1) (=> (= (f3 ?v1) f1) (= (f3 (f4 (f5 f6 ?v0) ?v1)) f1)))))
(assert (= (f11 (+ (* 4 f7) 1) (- 1)) f1))
(assert (= f12 (f13 f14 (- (f15 f16 (f13 f14 f8)) 1))))
(assert (= (f3 (f4 (f5 f6 (+ (* 4 f7) 1)) f8)) f1))
(assert (< f8 (+ (* 4 f7) 1)))
(assert (let ((?v_0 (+ (* 4 f7) 1))) (=> (not (= (f11 ?v_0 (- 1)) f1)) (not (= (f4 (f5 f10 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (+ ?v1 ?v2)) (+ (f4 ?v_0 ?v1) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (- ?v1 ?v2)) (- (f4 ?v_0 ?v1) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 (f5 f6 (- ?v0)) ?v1) (- (f4 (f5 f6 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f4 (f5 f6 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f4 (f5 f6 (+ ?v0 ?v1)) ?v2) (+ (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v2)))))
(assert (< 0 (f15 f16 f12)))
(assert (<= 1 f8))
(assert (=> (forall ((?v0 S4)) (=> (= ?v0 (f13 f14 (- (f15 f16 (f13 f14 f8)) 1))) (=> (< 0 (f15 f16 ?v0)) false))) false))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f9 ?v_0) f1) (= (f4 (f5 f10 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f4 (f5 f6 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4)) (let ((?v_0 (f15 f16 ?v2))) (let ((?v_1 (f5 f6 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f4 ?v_1 ?v0) (f4 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f4 ?v_0 ?v0) (f4 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f4 (f5 f6 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f4 (f5 f6 (- ?v0 ?v1)) ?v2) (- (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v2)))))
(assert (= (+ (f15 (f17 f18 f19) (f13 f14 2)) 1) (f4 (f5 f6 (+ (* 4 f7) 1)) f8)))
(assert (=> (= f8 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (+ (f15 (f17 f18 ?v0) ?v_0) (f15 (f17 f18 ?v1) ?v_0)) (+ (* 4 f7) 1))))))
(assert (= (f9 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f9 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f4 (f5 f6 ?v3) ?v4) ?v5))) (=> (= (+ (f4 (f5 f6 ?v0) ?v1) ?v2) ?v_0) (=> (< ?v_0 0) (=> (< ?v2 ?v0) (=> (<= 0 ?v5) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v4 ?v1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f5 f6 ?v0))) (=> (<= (+ (f4 ?v_0 ?v1) ?v2) (+ (f4 ?v_0 ?v3) ?v4)) (=> (<= ?v4 0) (=> (< ?v0 ?v4) (=> (< ?v0 ?v2) (<= ?v3 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f4 (f5 f6 ?v3) ?v4) ?v5))) (=> (= (+ (f4 (f5 f6 ?v0) ?v1) ?v2) ?v_0) (=> (<= 0 ?v_0) (=> (< ?v5 ?v3) (=> (<= 0 ?v2) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v1 ?v4))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f5 f6 ?v0))) (=> (<= (+ (f4 ?v_0 ?v1) ?v2) (+ (f4 ?v_0 ?v3) ?v4)) (=> (<= 0 ?v2) (=> (< ?v2 ?v0) (=> (< ?v4 ?v0) (<= ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ (f4 (f5 f6 ?v0) ?v1) ?v2) 0) (=> (<= 0 ?v2) (=> (< 0 ?v0) (<= ?v1 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 (+ (f4 (f5 f6 ?v0) ?v1) ?v2)) (=> (< ?v2 ?v0) (=> (< 0 ?v0) (<= 0 ?v1))))))
(assert (let ((?v_0 (f15 (f17 f18 f19) (f13 f14 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f15 (f17 f18 f19) (f13 f14 2)) 1) (f4 (f5 f6 (+ (* 4 f7) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 S4)) (<= 0 (f15 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (< 0 (f15 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f13 f14 0))))))
(assert (forall ((?v0 Int)) (=> (= (f15 (f17 f18 ?v0) (f13 f14 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (= (f15 (f17 f18 ?v0) ?v_0) (f15 (f17 f18 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 2)) (?v_1 (f17 f18 ?v0))) (= (f15 (f17 f18 (f15 ?v_1 ?v_0)) ?v_0) (f15 ?v_1 (f13 f14 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 3))) (= (f15 (f17 f18 (- ?v0)) ?v_0) (- (f15 (f17 f18 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 3))) (let ((?v_0 (f15 (f17 f18 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f15 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 2))) (let ((?v_0 (f15 (f17 f18 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f15 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f15 (f17 f18 ?v0) (f13 f14 2)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (f4 (f5 f6 ?v0) (f15 ?v_0 (f13 f14 2))) (f15 ?v_0 (f13 f14 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f15 (f17 f18 (+ ?v0 ?v1)) ?v_0) (+ (+ (f15 (f17 f18 ?v0) ?v_0) (f4 (f5 f6 (* 2 ?v0)) ?v1)) (f15 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f15 (f17 f18 (- ?v0 ?v1)) ?v_0) (+ (- (f15 (f17 f18 ?v0) ?v_0) (f4 (f5 f6 (* 2 ?v0)) ?v1)) (f15 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_1 (f17 f18 ?v0)) (?v_3 (f17 f18 ?v1))) (= (f15 (f17 f18 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f15 ?v_1 ?v_0) (f4 (f5 f6 (* 3 (f15 ?v_1 ?v_2))) ?v1)) (f4 (f5 f6 (* 3 ?v0)) (f15 ?v_3 ?v_2))) (f15 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_3 (f17 f18 ?v1)) (?v_1 (f17 f18 ?v0))) (= (f15 (f17 f18 (- ?v0 ?v1)) ?v_0) (- (+ (- (f15 ?v_1 ?v_0) (f4 (f5 f6 (* 3 (f15 ?v_1 ?v_2))) ?v1)) (f4 (f5 f6 (* 3 ?v0)) (f15 ?v_3 ?v_2))) (f15 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f4 (f5 f6 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f15 (f17 f18 ?v0) ?v_0) (f15 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f17 f18 ?v0))) (= (f15 ?v_0 (f13 f14 (+ (f15 f16 ?v1) (f15 f16 ?v2)))) (f4 (f5 f6 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f4 (f5 f6 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f4 (f5 f6 ?v0) ?v2))) (=> (<= 0 ?v1) (<= ?v2 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f4 (f5 f6 ?v0) ?v2))) (=> (< ?v1 ?v0) (<= 1 ?v2))))))
(assert (= (f20 (+ (* 4 f7) 1) (+ (f15 (f17 f18 f19) (f13 f14 2)) 1)) f1))
(assert (= (f20 (+ (* 4 f7) 1) (- (f15 (f17 f18 f19) (f13 f14 2)) (- 1))) f1))
(assert (= (f21 (f15 (f17 f18 f19) (f13 f14 2)) (- 1) (+ (* 4 f7) 1)) f1))
(assert (= (f22 f23 (f24 f19 1)) (f4 (f5 f6 (+ (* 4 f7) 1)) f8)))
(assert (let ((?v_0 (+ (* 4 f7) 1))) (and (<= 0 f19) (and (< f19 ?v_0) (= (f21 f25 f19 ?v_0) f1)))))
(assert (forall ((?v0 S4)) (= (f13 f14 (f15 f16 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f15 f16 (f13 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f15 f16 (f13 f14 ?v0)) 0))))
(check-sat)
(exit)
