(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S1)
(declare-fun f4 (S2 S3) Int)
(declare-fun f5 (S4 Int) S2)
(declare-fun f6 () S4)
(declare-fun f7 (S5 Int) S3)
(declare-fun f8 () S5)
(declare-fun f9 (S6 Int) Int)
(declare-fun f10 (S7 Int) S6)
(declare-fun f11 () S7)
(declare-fun f12 () Int)
(declare-fun f13 () S2)
(declare-fun f14 () S3)
(declare-fun f15 (Int) S1)
(declare-fun f16 () Int)
(declare-fun f17 (Int) S1)
(declare-fun f18 () S7)
(declare-fun f19 (Int Int) S1)
(declare-fun f20 () S3)
(declare-fun f21 () Int)
(assert (not (= f1 f2)))
(assert (not (= f3 f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f4 (f5 f6 ?v0) ?v_0) (f4 (f5 f6 ?v1) ?v_0)) (f9 (f10 f11 (+ (* 4 f12) 1)) (+ 1 (f4 f13 f14)))) (= f3 f1)))))
(assert (< 0 (f4 f13 f14)))
(assert (let ((?v_0 (+ (* 4 f12) 1)) (?v_1 (+ 1 (f4 f13 f14)))) (and (< ?v_1 ?v_0) (= (f15 (f9 (f10 f11 ?v_0) ?v_1)) f1))))
(assert (< 1 f16))
(assert (< 0 (f4 f13 f14)))
(assert (not (= (f15 (f9 (f10 f11 (+ (* 4 f12) 1)) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f12) 1)))
(assert (let ((?v_0 (+ (* 4 f12) 1)) (?v_1 (+ 1 (f4 f13 f14)))) (and (< ?v_1 ?v_0) (= (f15 (f9 (f10 f11 ?v_0) ?v_1)) f1))))
(assert (let ((?v_0 (+ (* 4 f12) 1)) (?v_1 (+ 1 (f4 f13 f14)))) (not (=> (< ?v_1 ?v_0) (not (= (f15 (f9 (f10 f11 ?v_0) ?v_1)) f1))))))
(assert (= (f17 (+ (* 4 f12) 1)) f1))
(assert (= (f9 (f10 f18 (- 1)) (+ (* 4 f12) 1)) 1))
(assert (= (f19 (+ (* 4 f12) 1) (- 1)) f1))
(assert (= f20 (f7 f8 (- (f4 f13 (f7 f8 f16)) 1))))
(assert (< f16 (+ (* 4 f12) 1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (= (f15 ?v1) f1) (= (f15 (f9 (f10 f11 ?v0) ?v1)) f1)))))
(assert (= (f15 (f9 (f10 f11 (+ (* 4 f12) 1)) f16)) f1))
(assert (= (+ (f4 (f5 f6 f21) (f7 f8 2)) 1) (f9 (f10 f11 (+ (* 4 f12) 1)) f16)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f4 (f5 f6 f21) (f7 f8 2)) 1) (f9 (f10 f11 (+ (* 4 f12) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f7 f8 (+ (f4 f13 ?v1) (f4 f13 ?v2)))) (f9 (f10 f11 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f9 (f10 f11 ?v0) (f4 ?v_0 (f7 f8 2))) (f4 ?v_0 (f7 f8 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f4 (f5 f6 (+ ?v0 ?v1)) ?v_0) (+ (+ (f4 (f5 f6 ?v0) ?v_0) (f9 (f10 f11 (* 2 ?v0)) ?v1)) (f4 (f5 f6 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f4 (f5 f6 (- ?v0 ?v1)) ?v_0) (+ (- (f4 (f5 f6 ?v0) ?v_0) (f9 (f10 f11 (* 2 ?v0)) ?v1)) (f4 (f5 f6 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_1 (f5 f6 ?v0)) (?v_3 (f5 f6 ?v1))) (= (f4 (f5 f6 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f4 ?v_1 ?v_0) (f9 (f10 f11 (* 3 (f4 ?v_1 ?v_2))) ?v1)) (f9 (f10 f11 (* 3 ?v0)) (f4 ?v_3 ?v_2))) (f4 ?v_3 ?v_0))))))
(assert (< 0 (f4 f13 f20)))
(assert (<= 1 f16))
(assert (let ((?v_0 (f4 (f5 f6 f21) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f7 f8 (- (f4 f13 (f7 f8 f16)) 1))) (=> (< 0 (f4 f13 ?v0)) false))) false))
(assert (let ((?v_0 (+ (* 4 f12) 1))) (=> (not (= (f19 ?v_0 (- 1)) f1)) (not (= (f9 (f10 f18 (- 1)) ?v_0) 1)))))
(assert (=> (= f16 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (+ (f4 (f5 f6 ?v0) ?v_0) (f4 (f5 f6 ?v1) ?v_0)) (+ (* 4 f12) 1))))))
(assert (= (f17 2) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f17 ?v_0) f1) (= (f9 (f10 f18 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 (f10 f11 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 (f10 f11 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f4 f13 ?v2))) (let ((?v_1 (f10 f11 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f9 ?v_1 ?v0) (f9 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f9 ?v_0 ?v0) (f9 ?v_0 ?v1)))))))
(assert (forall ((?v0 S3)) (= (f7 f8 (f4 f13 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f4 f13 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f4 f13 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
