(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S1)
(declare-fun f4 () Int)
(declare-fun f5 (S2 Int) Int)
(declare-fun f6 (S3 Int) S2)
(declare-fun f7 () S3)
(declare-fun f8 (S4 S5) Int)
(declare-fun f9 () S4)
(declare-fun f10 () S5)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 () S5)
(declare-fun f16 (S6 Int) S5)
(declare-fun f17 () S6)
(declare-fun f18 () Int)
(declare-fun f19 (Int) S1)
(declare-fun f20 (S7 Int) S4)
(declare-fun f21 () S7)
(declare-fun f22 (Int) S1)
(declare-fun f23 () S3)
(declare-fun f24 () Int)
(declare-fun f25 (Int Int) S1)
(declare-fun f26 (S8 S5) S5)
(declare-fun f27 (S9 S5) S8)
(declare-fun f28 () S9)
(declare-fun f29 () S9)
(declare-fun f30 (Int Int) S1)
(declare-fun f31 (Int Int Int) S1)
(declare-fun f32 (S10 S11) Int)
(declare-fun f33 () S10)
(declare-fun f34 (Int Int) S11)
(declare-fun f35 () Int)
(declare-fun f36 (S5 S5) S1)
(declare-fun f37 () S2)
(assert (not (= f1 f2)))
(assert (not (= f3 f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f8 f9 f10)))) (=> (and (= ?v0 (- f4 (f5 (f6 f7 ?v1) ?v_0))) (<= (ite (< ?v0 0) (* (- 2) ?v0) (* 2 ?v0)) ?v_0)) (= f3 f1)))))
(assert (< 0 (+ 1 (f8 f9 f10))))
(assert (< 1 f11))
(assert (< 0 (+ 1 (f8 f9 f10))))
(assert (< 0 (f8 f9 f10)))
(assert (let ((?v_0 (+ 1 (f8 f9 f10)))) (and (= f12 (- f13 (f5 (f6 f7 f14) ?v_0))) (<= (ite (< f12 0) (* (- 2) f12) (* 2 f12)) ?v_0))))
(assert (= f15 (f16 f17 (- (f8 f9 (f16 f17 f11)) 1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f8 f9 f10)))) (=> (and (= ?v1 (- f13 (f5 (f6 f7 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (let ((?v_1 (+ 1 (f8 f9 f10))) (?v_0 (+ (* 4 f18) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f19 (f5 (f6 f7 ?v_0) ?v_1)) f1))))))
(assert (let ((?v_0 (f16 f17 2))) (= (+ (f8 (f20 f21 f13) ?v_0) (f8 (f20 f21 f4) ?v_0)) (f5 (f6 f7 (+ (* 4 f18) 1)) (+ 1 (f8 f9 f10))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 (f6 f7 ?v0) ?v1) (f5 (f6 f7 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 ?v_0 (+ ?v1 ?v2)) (+ (f5 ?v_0 ?v1) (f5 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 ?v_0 (- ?v1 ?v2)) (- (f5 ?v_0 ?v1) (f5 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 (f6 f7 (- ?v0)) ?v1) (- (f5 (f6 f7 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f5 (f6 f7 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2) (f5 ?v_0 (f5 (f6 f7 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f5 (f6 f7 (+ ?v0 ?v1)) ?v2) (+ (f5 (f6 f7 ?v0) ?v2) (f5 (f6 f7 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f5 (f6 f7 (- ?v0 ?v1)) ?v2) (- (f5 (f6 f7 ?v0) ?v2) (f5 (f6 f7 ?v1) ?v2)))))
(assert (< 0 (f8 f9 f15)))
(assert (< 0 (+ (* 4 f18) 1)))
(assert (not (= (f19 (f5 (f6 f7 (+ (* 4 f18) 1)) (+ 1 0))) f1)))
(assert (<= 1 f11))
(assert (< f11 (+ (* 4 f18) 1)))
(assert (=> (forall ((?v0 S5)) (=> (= ?v0 (f16 f17 (- (f8 f9 (f16 f17 f11)) 1))) (=> (< 0 (f8 f9 ?v0)) false))) false))
(assert (let ((?v_1 (+ 1 (f8 f9 f10))) (?v_0 (+ (* 4 f18) 1))) (and (< ?v_1 ?v_0) (= (f19 (f5 (f6 f7 ?v_0) ?v_1)) f1))))
(assert (= (f19 (f5 (f6 f7 (+ (* 4 f18) 1)) f11)) f1))
(assert (= (f22 (+ (* 4 f18) 1)) f1))
(assert (= (f5 (f6 f23 (- 1)) (+ (* 4 f18) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (=> (= (+ (f8 (f20 f21 ?v0) ?v_0) (f8 (f20 f21 ?v1) ?v_0)) (f5 (f6 f7 (+ (* 4 f18) 1)) (+ 1 (f8 f9 f10)))) false))) false))
(assert (= (+ (f8 (f20 f21 f24) (f16 f17 2)) 1) (f5 (f6 f7 (+ (* 4 f18) 1)) f11)))
(assert (=> (= f11 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (+ (f8 (f20 f21 ?v0) ?v_0) (f8 (f20 f21 ?v1) ?v_0)) (+ (* 4 f18) 1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (<= 0 (f8 (f20 f21 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (< 0 (f8 (f20 f21 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f16 f17 0))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f20 f21 ?v0))) (= (f8 ?v_0 (f16 f17 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (f5 (f6 f7 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f19 ?v0) f1) (=> (= (f19 ?v1) f1) (= (f19 (f5 (f6 f7 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f5 (f6 f7 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f5 (f6 f7 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (let ((?v_0 (f8 f9 ?v2))) (let ((?v_1 (f6 f7 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f5 ?v_1 ?v0) (f5 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f5 ?v_0 ?v0) (f5 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f5 (f6 f7 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (= (f25 (+ (* 4 f18) 1) (- 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f8 (f20 f21 f24) (f16 f17 2)) 1) (f5 (f6 f7 (+ (* 4 f18) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f20 f21 ?v1)) (?v_1 (f16 f17 ?v0))) (=> (< 0 ?v0) (= (f8 ?v_0 ?v_1) (f5 (f6 f7 ?v1) (f8 ?v_0 (f16 f17 (- (f8 f9 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (f5 (f6 f7 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f8 (f20 f21 ?v0) ?v_0) (f8 (f20 f21 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f16 f17 2)) (?v_0 (f16 f17 3)) (?v_3 (f20 f21 ?v1)) (?v_1 (f20 f21 ?v0))) (= (f8 (f20 f21 (- ?v0 ?v1)) ?v_0) (- (+ (- (f8 ?v_1 ?v_0) (f5 (f6 f7 (* 3 (f8 ?v_1 ?v_2))) ?v1)) (f5 (f6 f7 (* 3 ?v0)) (f8 ?v_3 ?v_2))) (f8 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f16 f17 2)) (?v_0 (f16 f17 3)) (?v_1 (f20 f21 ?v0)) (?v_3 (f20 f21 ?v1))) (= (f8 (f20 f21 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f8 ?v_1 ?v_0) (f5 (f6 f7 (* 3 (f8 ?v_1 ?v_2))) ?v1)) (f5 (f6 f7 (* 3 ?v0)) (f8 ?v_3 ?v_2))) (f8 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (f8 (f20 f21 (- ?v0 ?v1)) ?v_0) (+ (- (f8 (f20 f21 ?v0) ?v_0) (f5 (f6 f7 (* 2 ?v0)) ?v1)) (f8 (f20 f21 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (f8 (f20 f21 (+ ?v0 ?v1)) ?v_0) (+ (+ (f8 (f20 f21 ?v0) ?v_0) (f5 (f6 f7 (* 2 ?v0)) ?v1)) (f8 (f20 f21 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f20 f21 ?v0))) (= (f5 (f6 f7 ?v0) (f8 ?v_0 (f16 f17 2))) (f8 ?v_0 (f16 f17 3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f20 f21 ?v2))) (=> (<= ?v_1 ?v_0) (= (f8 ?v_2 (f16 f17 (- (+ ?v_0 1) ?v_1))) (f5 (f6 f7 (f8 ?v_2 (f16 f17 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f27 f28 ?v2))) (=> (<= ?v_1 ?v_0) (= (f26 ?v_2 (f16 f17 (- (+ ?v_0 1) ?v_1))) (f26 (f27 f29 (f26 ?v_2 (f16 f17 (- ?v_0 ?v_1)))) ?v2))))))
(assert (let ((?v_0 (f8 (f20 f21 f24) (f16 f17 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f18) 1))) (=> (not (= (f25 ?v_0 (- 1)) f1)) (not (= (f5 (f6 f23 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f22 ?v_0) f1) (= (f5 (f6 f23 (- 1)) ?v_0) 1)))))
(assert (= (f22 2) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f5 (f6 f7 ?v0) ?v1))) (= (f16 f17 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f16 f17 (f5 (f6 f7 (f8 f9 (f16 f17 (ite (< ?v0 0) (- ?v0) ?v0)))) (f8 f9 (f16 f17 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f5 (f6 f7 (f8 f9 ?v0)) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f5 (f6 f7 (f8 f9 ?v0)) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f16 f17 (f5 (f6 f7 ?v0) ?v1)) (f16 f17 (f5 (f6 f7 (f8 f9 (f16 f17 ?v0))) (f8 f9 (f16 f17 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f16 f17 (f5 (f6 f7 ?v0) ?v1)) (f16 f17 (f5 (f6 f7 (f8 f9 (f16 f17 (- ?v0)))) (f8 f9 (f16 f17 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 ?v0) (= (f16 f17 (f8 (f20 f21 ?v0) ?v1)) (f26 (f27 f28 (f16 f17 ?v0)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f8 (f20 f21 (f8 f9 ?v0)) ?v1) (f8 f9 (f26 (f27 f28 ?v0) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f8 f9 (f26 (f27 f28 ?v0) ?v1)) (f8 (f20 f21 (f8 f9 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f20 f21 ?v0))) (= (f8 (f20 f21 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f16 f17 (f5 (f6 f7 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f5 (f6 f7 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int)) (=> (= (f8 (f20 f21 ?v0) (f16 f17 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (= (f8 (f20 f21 ?v0) ?v_0) (f8 (f20 f21 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f17 2)) (?v_1 (f20 f21 ?v0))) (= (f8 (f20 f21 (f8 ?v_1 ?v_0)) ?v_0) (f8 ?v_1 (f16 f17 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f17 3))) (= (f8 (f20 f21 (- ?v0)) ?v_0) (- (f8 (f20 f21 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f16 f17 3))) (let ((?v_0 (f8 (f20 f21 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f8 (f20 f21 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f16 f17 2))) (let ((?v_0 (f8 (f20 f21 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f8 (f20 f21 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f8 (f20 f21 ?v0) (f16 f17 2)))))
(assert (= (f30 (+ (* 4 f18) 1) (- (f8 (f20 f21 f24) (f16 f17 2)) (- 1))) f1))
(assert (= (f30 (+ (* 4 f18) 1) (+ (f8 (f20 f21 f24) (f16 f17 2)) 1)) f1))
(assert (= (f31 (f8 (f20 f21 f24) (f16 f17 2)) (- 1) (+ (* 4 f18) 1)) f1))
(assert (= (f32 f33 (f34 f24 1)) (f5 (f6 f7 (+ (* 4 f18) 1)) f11)))
(assert (let ((?v_0 (+ (* 4 f18) 1))) (and (<= 0 f24) (and (< f24 ?v_0) (= (f31 f35 f24 ?v_0) f1)))))
(assert (forall ((?v0 Int)) (= (f5 (f6 f7 ?v0) ?v0) (f8 (f20 f21 ?v0) (f16 f17 2)))))
(assert (forall ((?v0 S5)) (= (f26 (f27 f29 ?v0) ?v0) (f26 (f27 f28 ?v0) (f16 f17 2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f20 f21 ?v0))) (= (f8 ?v_0 (f16 f17 (+ (f8 f9 ?v1) 1))) (f5 (f6 f7 ?v0) (f8 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f16 f17 (+ (f8 f9 ?v1) 1))) (f26 (f27 f29 ?v0) (f26 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f20 f21 ?v0))) (= (f8 ?v_0 (f16 f17 (+ (f8 f9 ?v1) 1))) (f5 (f6 f7 ?v0) (f8 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f16 f17 (+ (f8 f9 ?v1) 1))) (f26 (f27 f29 ?v0) (f26 ?v_0 ?v1))))))
(assert (= (f31 (f8 (f20 f21 f35) (f16 f17 2)) (- 1) (+ (* 4 f18) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f31 (f8 (f20 f21 ?v0) (f16 f17 2)) (- 1) (+ (* 4 f18) 1)) f1) false)) false))
(assert (let ((?v_0 (f16 f17 2))) (= (f31 (f8 (f20 f21 f24) ?v_0) (f8 (f20 f21 f35) ?v_0) (+ (* 4 f18) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f18) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f31 f35 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f31 f35 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f18) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f31 f35 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 S5) (?v1 S5)) (= (< 0 (f8 f9 (f26 (f27 f28 ?v0) ?v1))) (or (< 0 (f8 f9 ?v0)) (= ?v1 (f16 f17 0))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f16 f17 (+ 0 1)))) (= (f26 (f27 f28 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f16 f17 (+ 0 1)))) (= (= (f26 (f27 f28 ?v0) ?v1) ?v_0) (or (= ?v1 (f16 f17 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f31 ?v0 0 ?v1) f1)) (=> (= (f31 (f8 (f20 f21 ?v2) (f16 f17 2)) ?v0 ?v1) f1) (not (= (f30 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v0))) (=> (< 0 (f8 f9 ?v0)) (=> (< (f8 f9 (f26 ?v_0 ?v1)) (f8 f9 (f26 ?v_0 ?v2))) (< (f8 f9 ?v1) (f8 f9 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f8 f9 ?v0)) (<= ?v_0 (f8 f9 (f26 (f27 f28 ?v0) ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f27 f28 ?v0))) (=> (= (f36 (f26 ?v_0 ?v1) ?v2) f1) (=> (<= (f8 f9 ?v3) (f8 f9 ?v1)) (= (f36 (f26 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int) (?v3 S5)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f30 (f8 ?v_0 ?v1) ?v2) f1) (=> (<= (f8 f9 ?v3) (f8 f9 ?v1)) (= (f30 (f8 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f36 ?v0 ?v1) f1) (=> (<= (f8 f9 ?v2) (f8 f9 ?v3)) (= (f36 (f26 (f27 f28 ?v0) ?v2) (f26 (f27 f28 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 S5)) (=> (= (f30 ?v0 ?v1) f1) (=> (<= (f8 f9 ?v2) (f8 f9 ?v3)) (= (f30 (f8 (f20 f21 ?v0) ?v2) (f8 (f20 f21 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v2))) (=> (<= (f8 f9 ?v0) (f8 f9 ?v1)) (= (f36 (f26 ?v_0 ?v0) (f26 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f20 f21 ?v2))) (=> (<= (f8 f9 ?v0) (f8 f9 ?v1)) (= (f30 (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f36 ?v0 ?v1) f1) (= (f36 (f26 (f27 f28 ?v0) ?v2) (f26 (f27 f28 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f30 ?v0 ?v1) f1) (= (f30 (f8 (f20 f21 ?v0) ?v2) (f8 (f20 f21 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f30 ?v0 (- ?v1 ?v2)) f1) (=> (= (f30 ?v0 ?v2) f1) (= (f30 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f30 ?v0 ?v1) f1) (=> (= (f30 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f30 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f30 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f30 ?v0 ?v1) f1) (=> (= (f30 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f30 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (= (= (f30 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f6 f7 ?v0)) (?v_1 (f6 f7 ?v1))) (= (f5 (f6 f7 (f32 f33 (f34 ?v0 ?v1))) (f32 f33 (f34 ?v2 ?v3))) (f32 f33 (f34 (+ (f5 ?v_0 ?v2) (f5 ?v_1 ?v3)) (- (f5 ?v_0 ?v3) (f5 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f30 (f5 ?v_0 ?v1) (f5 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f30 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1) f1) (= (= (f30 ?v0 (+ ?v2 ?v3)) f1) (= (f30 ?v0 (+ (+ ?v2 (f5 (f6 f7 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f30 (f5 (f6 f7 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 (+ ?v1 (f5 (f6 f7 ?v0) ?v2))) f1) (= (f30 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f22 ?v0) f1) (=> (= (f30 ?v0 (f8 (f20 f21 ?v1) ?v2)) f1) (= (f30 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f8 (f20 f21 ?v0) ?v2))) (=> (= (f22 ?v0) f1) (=> (not (= (f30 ?v0 ?v1) f1)) (=> (= (f30 ?v_0 (f5 (f6 f7 ?v1) ?v3)) f1) (= (f30 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f8 (f20 f21 ?v0) ?v2))) (=> (= (f22 ?v0) f1) (=> (not (= (f30 ?v0 ?v1) f1)) (=> (= (f30 ?v_0 (f5 (f6 f7 ?v3) ?v1)) f1) (= (f30 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f27 f29 ?v0))) (= (f26 (f27 f29 (f26 ?v_0 ?v1)) (f26 (f27 f29 ?v2) ?v3)) (f26 (f27 f29 (f26 ?v_0 ?v2)) (f26 (f27 f29 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) (f5 (f6 f7 ?v2) ?v3)) (f5 (f6 f7 (f5 ?v_0 ?v2)) (f5 (f6 f7 ?v1) ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f27 f29 (f26 (f27 f29 ?v0) ?v1))) (?v_0 (f27 f29 ?v2))) (= (f26 ?v_1 (f26 ?v_0 ?v3)) (f26 ?v_0 (f26 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f6 f7 (f5 (f6 f7 ?v0) ?v1))) (?v_0 (f6 f7 ?v2))) (= (f5 ?v_1 (f5 ?v_0 ?v3)) (f5 ?v_0 (f5 ?v_1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f27 f29 ?v0)) (?v_1 (f26 (f27 f29 ?v2) ?v3))) (= (f26 (f27 f29 (f26 ?v_0 ?v1)) ?v_1) (f26 ?v_0 (f26 (f27 f29 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f6 f7 ?v0)) (?v_1 (f5 (f6 f7 ?v2) ?v3))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v_1) (f5 ?v_0 (f5 (f6 f7 ?v1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f29 ?v0))) (= (f26 (f27 f29 (f26 ?v_0 ?v1)) ?v2) (f26 (f27 f29 (f26 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2) (f5 (f6 f7 (f5 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f29 ?v0))) (= (f26 (f27 f29 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f26 (f27 f29 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2) (f5 ?v_0 (f5 (f6 f7 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f29 ?v0))) (= (f26 ?v_0 (f26 (f27 f29 ?v1) ?v2)) (f26 (f27 f29 (f26 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 ?v_0 (f5 (f6 f7 ?v1) ?v2)) (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f27 f29 ?v0)) (?v_0 (f27 f29 ?v1))) (= (f26 ?v_1 (f26 ?v_0 ?v2)) (f26 ?v_0 (f26 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f6 f7 ?v0)) (?v_0 (f6 f7 ?v1))) (= (f5 ?v_1 (f5 ?v_0 ?v2)) (f5 ?v_0 (f5 ?v_1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f26 (f27 f29 ?v0) ?v1) (f26 (f27 f29 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 (f6 f7 ?v0) ?v1) (f5 (f6 f7 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f5 f37 (f8 (f20 f21 ?v0) ?v1)) (f8 (f20 f21 (f5 f37 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f8 (f20 f21 ?v0) (f16 f17 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f26 (f27 f28 ?v0) (f16 f17 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f8 (f20 f21 ?v0) (f16 f17 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f26 (f27 f28 ?v0) (f16 f17 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f20 f21 ?v0))) (= (f8 ?v_0 (f16 f17 (f5 (f6 f7 (f8 f9 ?v1)) (f8 f9 ?v2)))) (f8 (f20 f21 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f16 f17 (f5 (f6 f7 (f8 f9 ?v1)) (f8 f9 ?v2)))) (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f20 f21 ?v0))) (= (f8 (f20 f21 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f16 f17 (f5 (f6 f7 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f16 f17 (f5 (f6 f7 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f20 f21 ?v0))) (= (f5 (f6 f7 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) (f8 ?v_0 (f16 f17 (+ (f8 f9 ?v1) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f29 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2)) (f26 ?v_0 (f16 f17 (+ (f8 f9 ?v1) (f8 f9 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f8 (f20 f21 (f5 (f6 f7 ?v0) ?v1)) ?v2) (f5 (f6 f7 (f8 (f20 f21 ?v0) ?v2)) (f8 (f20 f21 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f26 (f27 f28 (f26 (f27 f29 ?v0) ?v1)) ?v2) (f26 (f27 f29 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f8 (f20 f21 (f5 (f6 f7 ?v0) ?v1)) ?v2) (f5 (f6 f7 (f8 (f20 f21 ?v0) ?v2)) (f8 (f20 f21 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f26 (f27 f28 (f26 (f27 f29 ?v0) ?v1)) ?v2) (f26 (f27 f29 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f8 (f20 f21 ?v0) ?v1))) (= (f5 (f6 f7 ?v_0) ?v0) (f5 (f6 f7 ?v0) ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f26 (f27 f28 ?v0) ?v1))) (= (f26 (f27 f29 ?v_0) ?v0) (f26 (f27 f29 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f20 f21 ?v0))) (= (f5 (f6 f7 (f8 ?v_0 ?v1)) ?v0) (f8 ?v_0 (f16 f17 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f29 (f26 ?v_0 ?v1)) ?v0) (f26 ?v_0 (f16 f17 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 S5)) (= (f16 f17 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f16 f17 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f16 f17 ?v0)) 0))))
(check-sat)
(exit)
