(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () S2)
(declare-fun f7 () S3)
(declare-fun f8 (S5 Int) S3)
(declare-fun f9 () S5)
(declare-fun f10 () Int)
(declare-fun f11 () Int)
(declare-fun f12 (S6 Int) Int)
(declare-fun f13 (S7 Int) S6)
(declare-fun f14 () S7)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () S3)
(declare-fun f22 (Int Int) S1)
(declare-fun f23 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f8 f9 2))) (let ((?v_1 (f3 (f4 f5 (+ 1 (f3 f6 f7))) ?v_0))) (not (<= (+ ?v_1 (f3 (f4 f5 (ite (< f10 0) (* (- 2) f10) (* 2 f10))) ?v_0)) (+ ?v_1 ?v_1))))))
(assert (let ((?v_0 (+ 1 (f3 f6 f7)))) (and (= f10 (- f11 (f12 (f13 f14 f15) ?v_0))) (<= (ite (< f10 0) (* (- 2) f10) (* 2 f10)) ?v_0))))
(assert (and (<= 0 (ite (< f16 0) (* (- 2) f16) (* 2 f16))) (<= 0 (ite (< f10 0) (* (- 2) f10) (* 2 f10)))))
(assert (< 1 f17))
(assert (and (<= 0 (ite (< f16 0) (* (- 2) f16) (* 2 f16))) (<= 0 (ite (< f10 0) (* (- 2) f10) (* 2 f10)))))
(assert (< 0 (f3 f6 f7)))
(assert (let ((?v_0 (+ 1 (f3 f6 f7)))) (and (= f10 (- f11 (f12 (f13 f14 f15) ?v_0))) (<= (ite (< f10 0) (* (- 2) f10) (* 2 f10)) ?v_0))))
(assert (< 0 (+ 1 (f3 f6 f7))))
(assert (not (< f18 (+ 1 (f3 f6 f7)))))
(assert (let ((?v_0 (f8 f9 2))) (= (+ (* 4 (f3 (f4 f5 f16) ?v_0)) (* 4 (f3 (f4 f5 f10) ?v_0))) (+ (f3 (f4 f5 (ite (< f16 0) (* (- 2) f16) (* 2 f16))) ?v_0) (f3 (f4 f5 (ite (< f10 0) (* (- 2) f10) (* 2 f10))) ?v_0)))))
(assert (let ((?v_0 (f8 f9 2))) (let ((?v_1 (f3 (f4 f5 (ite (< f10 0) (* (- 2) f10) (* 2 f10))) ?v_0))) (<= (+ (f3 (f4 f5 (ite (< f16 0) (* (- 2) f16) (* 2 f16))) ?v_0) ?v_1) (+ (f3 (f4 f5 (+ 1 (f3 f6 f7))) ?v_0) ?v_1)))))
(assert (let ((?v_0 (+ 1 (f3 f6 f7)))) (and (= f16 (- f19 (f12 (f13 f14 f20) ?v_0))) (<= (ite (< f16 0) (* (- 2) f16) (* 2 f16)) ?v_0))))
(assert (= f21 (f8 f9 (- (f3 f6 (f8 f9 f17)) 1))))
(assert (let ((?v_0 (f8 f9 2))) (= (+ (f3 (f4 f5 f16) ?v_0) (f3 (f4 f5 f10) ?v_0)) (f12 (f13 f14 (+ 1 (f3 f6 f7))) f18))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f6 f7)))) (=> (and (= ?v1 (- f11 (f12 (f13 f14 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f8 f9 2))) (=> (= (+ (f3 (f4 f5 f16) ?v_0) (f3 (f4 f5 f10) ?v_0)) (f12 (f13 f14 (+ 1 (f3 f6 f7))) ?v0)) false))) false))
(assert (let ((?v_0 (f3 f6 f7)) (?v_1 (f8 f9 2))) (<= (f12 (f13 f14 (+ 4 (* 4 ?v_0))) f18) (+ (f3 (f4 f5 (+ 1 ?v_0)) ?v_1) (f3 (f4 f5 (ite (< f10 0) (* (- 2) f10) (* 2 f10))) ?v_1)))))
(assert (<= (- (+ 1 (f3 f6 f7)) f18) 0))
(assert (< (- (+ 2 (* 2 (f3 f6 f7))) (* 4 f18)) 0))
(assert (<= (- (+ 4 (* 4 (f3 f6 f7))) (* 4 f18)) 0))
(assert (let ((?v_0 (f8 f9 2))) (= (f12 (f13 f14 (+ 4 (* 4 (f3 f6 f7)))) f18) (+ (* 4 (f3 (f4 f5 f16) ?v_0)) (* 4 (f3 (f4 f5 f10) ?v_0))))))
(assert (let ((?v_0 (f8 f9 2))) (= (f22 (+ 1 (f3 f6 f7)) (+ (f3 (f4 f5 f16) ?v_0) (f3 (f4 f5 f10) ?v_0))) f1)))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f6 f7)))) (=> (and (= ?v1 (- f19 (f12 (f13 f14 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (< 0 (f3 f6 f21)))
(assert (<= 1 f17))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f8 f9 (- (f3 f6 (f8 f9 f17)) 1))) (=> (< 0 (f3 f6 ?v0)) false))) false))
(assert (let ((?v_0 (f3 f6 f7))) (< (f12 (f13 f14 (+ 1 ?v_0)) (- (+ 2 (* 2 ?v_0)) (* 4 f18))) (+ 0 (* 0 ?v_0)))))
(assert (let ((?v_0 (f3 f6 f7))) (< (f12 (f13 f14 (+ 1 ?v_0)) (- (+ 2 (* 2 ?v_0)) (* 4 f18))) 0)))
(assert (let ((?v_0 (f8 f9 2))) (= (+ (f3 (f4 f5 f19) ?v_0) (f3 (f4 f5 f11) ?v_0)) (f12 (f13 f14 (+ (* 4 f23) 1)) (+ 1 (f3 f6 f7))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f22 (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v2) ?v1)) f1) (=> (not (= ?v1 (f8 f9 0))) (= (f22 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f3 f6 ?v0)) (=> (= (f22 ?v1 ?v2) f1) (= (f22 ?v1 (f3 (f4 f5 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f8 f9 0))) (= (= (f22 (f3 (f4 f5 ?v1) ?v0) (f3 (f4 f5 ?v2) ?v0)) f1) (= (f22 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 ?v1)) (?v_1 (f8 f9 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (f12 (f13 f14 ?v1) (f3 ?v_0 (f8 f9 (- (f3 f6 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f9 2))) (= (f12 (f13 f14 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f8 f9 2)) (?v_0 (f8 f9 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f12 (f13 f14 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f12 (f13 f14 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 S3)) (= (f8 f9 (f3 f6 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f6 (f8 f9 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f6 (f8 f9 ?v0)) 0))))
(check-sat)
(exit)
