(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) Int)
(declare-fun f7 () S4)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 (S6 Int) S4)
(declare-fun f11 () S6)
(declare-fun f12 (S7 Int) S5)
(declare-fun f13 () S7)
(declare-fun f14 () Int)
(declare-fun f15 () S5)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () Int)
(declare-fun f22 () Int)
(declare-fun f23 (Int) S1)
(assert (not (= f1 f2)))
(assert (let ((?v_1 (+ 1 (f6 f7 f8)))) (let ((?v_0 (f4 f5 ?v_1))) (not (<= (* (f3 ?v_0 f9) 4) (* (f3 ?v_0 ?v_1) 2))))))
(assert (let ((?v_0 (f6 f7 f8))) (let ((?v_1 (f6 (f10 f11 (+ 1 ?v_0)) (f12 f13 2)))) (<= (f3 (f4 f5 (+ 4 (* 4 ?v_0))) f9) (+ ?v_1 ?v_1)))))
(assert (< 1 f14))
(assert (< 0 (f6 f7 f8)))
(assert (< 0 (+ 1 (f6 f7 f8))))
(assert (not (< f9 (+ 1 (f6 f7 f8)))))
(assert (let ((?v_0 (f6 f7 f8))) (let ((?v_1 (f6 (f10 f11 (+ 1 ?v_0)) (f12 f13 2)))) (<= (f3 (f4 f5 (+ 4 (* 4 ?v_0))) f9) (+ ?v_1 ?v_1)))))
(assert (<= (- (+ 1 (f6 f7 f8)) f9) 0))
(assert (< (- (+ 2 (* 2 (f6 f7 f8))) (* 4 f9)) 0))
(assert (<= (- (+ 4 (* 4 (f6 f7 f8))) (* 4 f9)) 0))
(assert (let ((?v_0 (f6 f7 f8))) (< (f3 (f4 f5 (+ 1 ?v_0)) (- (+ 2 (* 2 ?v_0)) (* 4 f9))) 0)))
(assert (let ((?v_0 (f6 f7 f8))) (< (f3 (f4 f5 (+ 1 ?v_0)) (- (+ 2 (* 2 ?v_0)) (* 4 f9))) (+ 0 (* 0 ?v_0)))))
(assert (= f15 (f12 f13 (- (f6 f7 (f12 f13 f14)) 1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f6 f7 f8)))) (=> (and (= ?v1 (- f16 (f3 (f4 f5 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f6 f7 f8)))) (=> (and (= ?v1 (- f17 (f3 (f4 f5 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (+ 1 (f6 f7 f8)))) (and (= f18 (- f16 (f3 (f4 f5 f19) ?v_0))) (<= (ite (< f18 0) (* (- 2) f18) (* 2 f18)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f6 f7 f8)))) (and (= f20 (- f17 (f3 (f4 f5 f21) ?v_0))) (<= (ite (< f20 0) (* (- 2) f20) (* 2 f20)) ?v_0))))
(assert (let ((?v_0 (f12 f13 2))) (= (+ (f6 (f10 f11 f18) ?v_0) (f6 (f10 f11 f20) ?v_0)) (f3 (f4 f5 (+ 1 (f6 f7 f8))) f9))))
(assert (let ((?v_1 (+ 1 (f6 f7 f8))) (?v_0 (+ (* 4 f22) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f23 (f3 (f4 f5 ?v_0) ?v_1)) f1))))))
(assert (let ((?v_0 (f12 f13 2))) (let ((?v_1 (f6 (f10 f11 (+ 1 (f6 f7 f8))) ?v_0))) (<= (+ ?v_1 (f6 (f10 f11 (ite (< f20 0) (* (- 2) f20) (* 2 f20))) ?v_0)) (+ ?v_1 ?v_1)))))
(assert (let ((?v_0 (f12 f13 2))) (= (f3 (f4 f5 (+ 4 (* 4 (f6 f7 f8)))) f9) (+ (* 4 (f6 (f10 f11 f18) ?v_0)) (* 4 (f6 (f10 f11 f20) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (+ ?v1 ?v2)) (+ (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (- ?v1 ?v2)) (- (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (< 0 (f6 f7 f15)))
(assert (< 0 (+ (* 4 f22) 1)))
(assert (not (= (f23 (f3 (f4 f5 (+ (* 4 f22) 1)) (+ 1 0))) f1)))
(assert (<= 1 f14))
(assert (< f14 (+ (* 4 f22) 1)))
(assert (and (<= 0 (ite (< f18 0) (* (- 2) f18) (* 2 f18))) (<= 0 (ite (< f20 0) (* (- 2) f20) (* 2 f20)))))
(assert (=> (forall ((?v0 S5)) (=> (= ?v0 (f12 f13 (- (f6 f7 (f12 f13 f14)) 1))) (=> (< 0 (f6 f7 ?v0)) false))) false))
(assert (let ((?v_0 (f12 f13 2))) (= (+ (* 4 (f6 (f10 f11 f18) ?v_0)) (* 4 (f6 (f10 f11 f20) ?v_0))) (+ (f6 (f10 f11 (ite (< f18 0) (* (- 2) f18) (* 2 f18))) ?v_0) (f6 (f10 f11 (ite (< f20 0) (* (- 2) f20) (* 2 f20))) ?v_0)))))
(assert (let ((?v_0 (f12 f13 2))) (= (+ (f6 (f10 f11 f16) ?v_0) (f6 (f10 f11 f17) ?v_0)) (f3 (f4 f5 (+ (* 4 f22) 1)) (+ 1 (f6 f7 f8))))))
(assert (let ((?v_1 (+ 1 (f6 f7 f8))) (?v_0 (+ (* 4 f22) 1))) (and (< ?v_1 ?v_0) (= (f23 (f3 (f4 f5 ?v_0) ?v_1)) f1))))
(assert (forall ((?v0 S5)) (= (f12 f13 (f6 f7 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f12 f13 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f6 f7 (f12 f13 ?v0)) 0))))
(check-sat)
(exit)
