(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) Int)
(declare-fun f7 () S4)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 () S5)
(declare-fun f12 (S6 Int) S5)
(declare-fun f13 () S6)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 (S7 Int) S4)
(declare-fun f17 () S7)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () Int)
(declare-fun f22 () Int)
(declare-fun f23 (Int) S1)
(declare-fun f24 (Int) S1)
(declare-fun f25 () S3)
(declare-fun f26 () Int)
(declare-fun f27 (Int Int) S1)
(declare-fun f28 (Int Int) S1)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f6 f7 f8))) (not (<= 0 (f3 (f4 f5 (+ 1 ?v_0)) (- (+ 2 (* 2 ?v_0)) (* 4 f9)))))))
(assert (let ((?v_1 (+ 1 (f6 f7 f8)))) (let ((?v_0 (f4 f5 ?v_1))) (<= (* (f3 ?v_0 f9) 4) (* (f3 ?v_0 ?v_1) 2)))))
(assert (< 1 f10))
(assert (< 0 (f6 f7 f8)))
(assert (let ((?v_1 (+ 1 (f6 f7 f8)))) (let ((?v_0 (f4 f5 ?v_1))) (<= (* (f3 ?v_0 f9) 4) (* (f3 ?v_0 ?v_1) 2)))))
(assert (< 0 (+ 1 (f6 f7 f8))))
(assert (not (< f9 (+ 1 (f6 f7 f8)))))
(assert (<= (- (+ 1 (f6 f7 f8)) f9) 0))
(assert (< (- (+ 2 (* 2 (f6 f7 f8))) (* 4 f9)) 0))
(assert (<= (- (+ 4 (* 4 (f6 f7 f8))) (* 4 f9)) 0))
(assert (let ((?v_0 (f6 f7 f8))) (< (f3 (f4 f5 (+ 1 ?v_0)) (- (+ 2 (* 2 ?v_0)) (* 4 f9))) 0)))
(assert (let ((?v_0 (f6 f7 f8))) (< (f3 (f4 f5 (+ 1 ?v_0)) (- (+ 2 (* 2 ?v_0)) (* 4 f9))) (+ 0 (* 0 ?v_0)))))
(assert (= f11 (f12 f13 (- (f6 f7 (f12 f13 f10)) 1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f6 f7 f8)))) (=> (and (= ?v1 (- f14 (f3 (f4 f5 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f6 f7 f8)))) (=> (and (= ?v1 (- f15 (f3 (f4 f5 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (f6 f7 f8))) (let ((?v_1 (f6 (f16 f17 (+ 1 ?v_0)) (f12 f13 2)))) (<= (f3 (f4 f5 (+ 4 (* 4 ?v_0))) f9) (+ ?v_1 ?v_1)))))
(assert (let ((?v_0 (+ 1 (f6 f7 f8)))) (and (= f18 (- f14 (f3 (f4 f5 f19) ?v_0))) (<= (ite (< f18 0) (* (- 2) f18) (* 2 f18)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f6 f7 f8)))) (and (= f20 (- f15 (f3 (f4 f5 f21) ?v_0))) (<= (ite (< f20 0) (* (- 2) f20) (* 2 f20)) ?v_0))))
(assert (let ((?v_1 (+ 1 (f6 f7 f8))) (?v_0 (+ (* 4 f22) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f23 (f3 (f4 f5 ?v_0) ?v_1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (+ ?v1 ?v2)) (+ (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (- ?v1 ?v2)) (- (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 (- ?v0)) ?v1) (- (f3 (f4 f5 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f5 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (< 0 (f6 f7 f11)))
(assert (< 0 (+ (* 4 f22) 1)))
(assert (not (= (f23 (f3 (f4 f5 (+ (* 4 f22) 1)) (+ 1 0))) f1)))
(assert (<= 1 f10))
(assert (< f10 (+ (* 4 f22) 1)))
(assert (and (<= 0 (ite (< f18 0) (* (- 2) f18) (* 2 f18))) (<= 0 (ite (< f20 0) (* (- 2) f20) (* 2 f20)))))
(assert (=> (forall ((?v0 S5)) (=> (= ?v0 (f12 f13 (- (f6 f7 (f12 f13 f10)) 1))) (=> (< 0 (f6 f7 ?v0)) false))) false))
(assert (let ((?v_0 (f12 f13 2))) (let ((?v_1 (f6 (f16 f17 (+ 1 (f6 f7 f8))) ?v_0))) (<= (+ ?v_1 (f6 (f16 f17 (ite (< f20 0) (* (- 2) f20) (* 2 f20))) ?v_0)) (+ ?v_1 ?v_1)))))
(assert (let ((?v_0 (f12 f13 2))) (= (+ (f6 (f16 f17 f18) ?v_0) (f6 (f16 f17 f20) ?v_0)) (f3 (f4 f5 (+ 1 (f6 f7 f8))) f9))))
(assert (let ((?v_0 (f12 f13 2))) (= (+ (* 4 (f6 (f16 f17 f18) ?v_0)) (* 4 (f6 (f16 f17 f20) ?v_0))) (+ (f6 (f16 f17 (ite (< f18 0) (* (- 2) f18) (* 2 f18))) ?v_0) (f6 (f16 f17 (ite (< f20 0) (* (- 2) f20) (* 2 f20))) ?v_0)))))
(assert (let ((?v_0 (f12 f13 2))) (= (+ (f6 (f16 f17 f14) ?v_0) (f6 (f16 f17 f15) ?v_0)) (f3 (f4 f5 (+ (* 4 f22) 1)) (+ 1 (f6 f7 f8))))))
(assert (let ((?v_1 (+ 1 (f6 f7 f8))) (?v_0 (+ (* 4 f22) 1))) (and (< ?v_1 ?v_0) (= (f23 (f3 (f4 f5 ?v_0) ?v_1)) f1))))
(assert (= (f23 (f3 (f4 f5 (+ (* 4 f22) 1)) f10)) f1))
(assert (let ((?v_0 (f12 f13 2))) (let ((?v_1 (f6 (f16 f17 (ite (< f20 0) (* (- 2) f20) (* 2 f20))) ?v_0))) (<= (+ (f6 (f16 f17 (ite (< f18 0) (* (- 2) f18) (* 2 f18))) ?v_0) ?v_1) (+ (f6 (f16 f17 (+ 1 (f6 f7 f8))) ?v_0) ?v_1)))))
(assert (= (f24 (+ (* 4 f22) 1)) f1))
(assert (= (f3 (f4 f25 (- 1)) (+ (* 4 f22) 1)) 1))
(assert (let ((?v_0 (f12 f13 2))) (= (f3 (f4 f5 (+ 4 (* 4 (f6 f7 f8)))) f9) (+ (* 4 (f6 (f16 f17 f18) ?v_0)) (* 4 (f6 (f16 f17 f20) ?v_0))))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (=> (= (+ (f6 (f16 f17 ?v0) ?v_0) (f6 (f16 f17 ?v1) ?v_0)) (f3 (f4 f5 (+ (* 4 f22) 1)) (+ 1 (f6 f7 f8)))) false))) false))
(assert (= (+ (f6 (f16 f17 f26) (f12 f13 2)) 1) (f3 (f4 f5 (+ (* 4 f22) 1)) f10)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f12 f13 2))) (=> (= (+ (f6 (f16 f17 f18) ?v_0) (f6 (f16 f17 f20) ?v_0)) (f3 (f4 f5 (+ 1 (f6 f7 f8))) ?v0)) false))) false))
(assert (=> (= f10 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (= (+ (f6 (f16 f17 ?v0) ?v_0) (f6 (f16 f17 ?v1) ?v_0)) (+ (* 4 f22) 1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (<= 0 (f6 (f16 f17 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (< 0 (f6 (f16 f17 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f12 f13 0))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f6 ?v_0 (f12 f13 (+ (f6 f7 ?v1) (f6 f7 ?v2)))) (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0) f1) (=> (= (f23 ?v1) f1) (= (f23 (f3 (f4 f5 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 (f4 f5 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (let ((?v_0 (f6 f7 ?v2))) (let ((?v_1 (f4 f5 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f3 ?v_1 ?v0) (f3 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f3 (f4 f5 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v2) (- (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v2) (+ (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f5 ?v1) ?v2))))))
(assert (= (f27 (+ (* 4 f22) 1) (- 1)) f1))
(assert (let ((?v_0 (f12 f13 2))) (= (f28 (+ 1 (f6 f7 f8)) (+ (f6 (f16 f17 f18) ?v_0) (f6 (f16 f17 f20) ?v_0))) f1)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f6 (f16 f17 f26) (f12 f13 2)) 1) (f3 (f4 f5 (+ (* 4 f22) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 ?v1)) (?v_1 (f12 f13 ?v0))) (=> (< 0 ?v0) (= (f6 ?v_0 ?v_1) (f3 (f4 f5 ?v1) (f6 ?v_0 (f12 f13 (- (f6 f7 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f6 (f16 f17 ?v0) ?v_0) (f6 (f16 f17 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f12 f13 2)) (?v_0 (f12 f13 3)) (?v_3 (f16 f17 ?v1)) (?v_1 (f16 f17 ?v0))) (= (f6 (f16 f17 (- ?v0 ?v1)) ?v_0) (- (+ (- (f6 ?v_1 ?v_0) (f3 (f4 f5 (* 3 (f6 ?v_1 ?v_2))) ?v1)) (f3 (f4 f5 (* 3 ?v0)) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f12 f13 2)) (?v_0 (f12 f13 3)) (?v_1 (f16 f17 ?v0)) (?v_3 (f16 f17 ?v1))) (= (f6 (f16 f17 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f6 ?v_1 ?v_0) (f3 (f4 f5 (* 3 (f6 ?v_1 ?v_2))) ?v1)) (f3 (f4 f5 (* 3 ?v0)) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (= (f6 (f16 f17 (- ?v0 ?v1)) ?v_0) (+ (- (f6 (f16 f17 ?v0) ?v_0) (f3 (f4 f5 (* 2 ?v0)) ?v1)) (f6 (f16 f17 ?v1) ?v_0))))))
(assert (forall ((?v0 S5)) (= (f12 f13 (f6 f7 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f12 f13 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f6 f7 (f12 f13 ?v0)) 0))))
(check-sat)
(exit)
