(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 () S3)
(declare-fun f6 () Int)
(declare-fun f7 (Int) S1)
(declare-fun f8 (Int Int) S1)
(declare-fun f9 () Int)
(declare-fun f10 (S4 Int) Int)
(declare-fun f11 (S5 Int) S4)
(declare-fun f12 () S5)
(declare-fun f13 () Int)
(declare-fun f14 (Int Int) S1)
(declare-fun f15 () S3)
(declare-fun f16 (S6 Int) S3)
(declare-fun f17 () S6)
(declare-fun f18 (Int) S1)
(declare-fun f19 () S5)
(declare-fun f20 (S7 Int) S2)
(declare-fun f21 () S7)
(declare-fun f22 () Int)
(declare-fun f23 () Int)
(declare-fun f24 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (not (or (= ?v_0 1) (= ?v_0 (+ (* 4 f6) 1))))))
(assert (= (f7 (+ (* 4 f6) 1)) f1))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (and (<= 0 ?v_0) (= (f8 ?v_0 (+ (* 4 f6) 1)) f1))))
(assert (< 1 f9))
(assert (= (f7 (+ (* 4 f6) 1)) f1))
(assert (< 0 (f3 f4 f5)))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (and (<= 0 ?v_0) (= (f8 ?v_0 (+ (* 4 f6) 1)) f1))))
(assert (< 0 (+ (* 4 f6) 1)))
(assert (not (= (+ 1 (f3 f4 f5)) 0)))
(assert (< 0 (+ 1 (f3 f4 f5))))
(assert (= (f8 (+ 1 (f3 f4 f5)) (+ (* 4 f6) 1)) f1))
(assert (= (f10 (f11 f12 (- 1)) (+ (* 4 f6) 1)) 1))
(assert (< f13 (+ 1 (f3 f4 f5))))
(assert (= (f14 (+ (* 4 f6) 1) (- 1)) f1))
(assert (= f15 (f16 f17 (- (f3 f4 (f16 f17 f9)) 1))))
(assert (< f9 (+ (* 4 f6) 1)))
(assert (let ((?v_1 (+ 1 (f3 f4 f5))) (?v_0 (+ (* 4 f6) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f18 (f10 (f11 f19 ?v_0) ?v_1)) f1))))))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (let ((?v_1 (f11 f19 ?v_0))) (= (f8 (f10 ?v_1 ?v_0) (f10 ?v_1 (+ (* 4 f6) 1))) f1))))
(assert (not (= (f18 (f10 (f11 f19 (+ (* 4 f6) 1)) (+ 1 0))) f1)))
(assert (let ((?v_0 (+ (* 4 f6) 1))) (=> (not (= (f14 ?v_0 (- 1)) f1)) (not (= (f10 (f11 f12 (- 1)) ?v_0) 1)))))
(assert (let ((?v_1 (+ 1 (f3 f4 f5))) (?v_0 (+ (* 4 f6) 1))) (and (< ?v_1 ?v_0) (= (f18 (f10 (f11 f19 ?v_0) ?v_1)) f1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (=> (= (+ (f3 (f20 f21 ?v0) ?v_0) (f3 (f20 f21 ?v1) ?v_0)) (f10 (f11 f19 (+ (* 4 f6) 1)) (+ 1 (f3 f4 f5)))) false))) false))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (and (= (f8 ?v_0 f22) f1) (= (f8 ?v_0 f23) f1))))
(assert (<= 1 f9))
(assert (< 0 (f3 f4 f15)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f16 f17 (- (f3 f4 (f16 f17 f9)) 1))) (=> (< 0 (f3 f4 ?v0)) false))) false))
(assert (let ((?v_0 (f16 f17 2))) (= (+ (f3 (f20 f21 f22) ?v_0) (f3 (f20 f21 f23) ?v_0)) (f10 (f11 f19 (+ (* 4 f6) 1)) (+ 1 (f3 f4 f5))))))
(assert (= (f18 (f10 (f11 f19 (+ (* 4 f6) 1)) f9)) f1))
(assert (= (f18 (f10 (f11 f19 (+ (* 4 f6) 1)) f13)) f1))
(assert (let ((?v_0 (f16 f17 2))) (let ((?v_1 (f3 (f20 f21 (+ 1 (f3 f4 f5))) ?v_0))) (and (= (f8 ?v_1 (f3 (f20 f21 f22) ?v_0)) f1) (= (f8 ?v_1 (f3 (f20 f21 f23) ?v_0)) f1)))))
(assert (let ((?v_0 (f16 f17 2))) (= (f8 (f3 (f20 f21 (+ 1 (f3 f4 f5))) ?v_0) (+ (f3 (f20 f21 f22) ?v_0) (f3 (f20 f21 f23) ?v_0))) f1)))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f5)))) (=> (and (= ?v1 (- f23 (f10 (f11 f19 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f5)))) (=> (and (= ?v1 (- f22 (f10 (f11 f19 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (= (+ (f3 (f20 f21 f24) (f16 f17 2)) 1) (f10 (f11 f19 (+ (* 4 f6) 1)) f9)))
(assert (=> (= f9 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (+ (f3 (f20 f21 ?v0) ?v_0) (f3 (f20 f21 ?v1) ?v_0)) (+ (* 4 f6) 1))))))
(assert (forall ((?v0 S3)) (= (f16 f17 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f16 f17 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f16 f17 ?v0)) 0))))
(check-sat)
(exit)
