(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () Int)
(declare-fun f4 (S2 S3) Int)
(declare-fun f5 (S4 Int) S2)
(declare-fun f6 () S4)
(declare-fun f7 () Int)
(declare-fun f8 (S5 Int) S3)
(declare-fun f9 () S5)
(declare-fun f10 () Int)
(declare-fun f11 (S6 Int) Int)
(declare-fun f12 (S7 Int) S6)
(declare-fun f13 () S7)
(declare-fun f14 () S2)
(declare-fun f15 () S3)
(assert (not (= f1 f2)))
(assert (not (not (= f3 0))))
(assert (let ((?v_0 (f8 f9 2))) (= (+ (f4 (f5 f6 f7) ?v_0) (f4 (f5 f6 f10) ?v_0)) (f11 (f12 f13 (+ 1 (f4 f14 f15))) f3))))
(assert (let ((?v_0 (f8 f9 2))) (< 0 (+ (f4 (f5 f6 f7) ?v_0) (f4 (f5 f6 f10) ?v_0)))))
(assert (let ((?v_0 (f8 f9 2))) (= (+ (f4 (f5 f6 f7) ?v_0) (f4 (f5 f6 f10) ?v_0)) (f11 (f12 f13 (+ 1 (f4 f14 f15))) f3))))
(assert (let ((?v_0 (f8 f9 2))) (< 0 (+ (f4 (f5 f6 f7) ?v_0) (f4 (f5 f6 f10) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f13 ?v0))) (= (f11 ?v_0 (+ ?v1 ?v2)) (+ (f11 ?v_0 ?v1) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S3)) (= (f8 f9 (f4 f14 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f4 f14 (f8 f9 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f4 f14 (f8 f9 ?v0)) 0))))
(check-sat)
(exit)
