(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S3)
(declare-fun f7 () S5)
(declare-fun f8 () Int)
(declare-fun f9 (Int) S1)
(declare-fun f10 (S6 Int) Int)
(declare-fun f11 (S7 Int) S6)
(declare-fun f12 () S7)
(declare-fun f13 () Int)
(declare-fun f14 (Int) S1)
(declare-fun f15 () S7)
(declare-fun f16 (Int Int) S1)
(declare-fun f17 () S3)
(declare-fun f18 () S2)
(declare-fun f19 (Int Int Int) S1)
(declare-fun f20 () Int)
(declare-fun f21 () Int)
(declare-fun f22 (Int Int) S1)
(declare-fun f23 (S8 S9) Int)
(declare-fun f24 () S8)
(declare-fun f25 (Int Int) S9)
(assert (not (= f1 f2)))
(assert (not (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f8) 1))))))
(assert (= (f9 (f10 (f11 f12 (+ (* 4 f8) 1)) (+ 1 0))) f1))
(assert (< 1 f13))
(assert (= (f9 (f10 (f11 f12 (+ (* 4 f8) 1)) (+ 1 0))) f1))
(assert (< 0 (+ (* 4 f8) 1)))
(assert (= (f14 (+ (* 4 f8) 1)) f1))
(assert (= (f10 (f11 f15 (- 1)) (+ (* 4 f8) 1)) 1))
(assert (= (f16 (+ (* 4 f8) 1) (- 1)) f1))
(assert (= f17 (f6 f7 (- (f3 f18 (f6 f7 f13)) 1))))
(assert (< f13 (+ (* 4 f8) 1)))
(assert (= (f19 (f3 (f4 f5 f20) (f6 f7 2)) (- 1) (+ (* 4 f8) 1)) f1))
(assert (let ((?v_0 (f3 (f4 f5 f21) (f6 f7 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f8) 1))) (=> (not (= (f16 ?v_0 (- 1)) f1)) (not (= (f10 (f11 f15 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f19 (f3 (f4 f5 ?v0) (f6 f7 2)) (- 1) (+ (* 4 f8) 1)) f1) false)) false))
(assert (=> (= f13 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f8) 1))))))
(assert (= (+ (f3 (f4 f5 f21) (f6 f7 2)) 1) (f10 (f11 f12 (+ (* 4 f8) 1)) f13)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f21) (f6 f7 2)) 1) (f10 (f11 f12 (+ (* 4 f8) 1)) ?v0)) false)) false))
(assert (= (f9 (f10 (f11 f12 (+ (* 4 f8) 1)) f13)) f1))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (< 0 (f3 f18 f17)))
(assert (<= 1 f13))
(assert (let ((?v_0 (+ (* 4 f8) 1))) (and (<= 0 f21) (and (< f21 ?v_0) (= (f19 f20 f21 ?v_0) f1)))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f6 f7 (- (f3 f18 (f6 f7 f13)) 1))) (=> (< 0 (f3 f18 ?v0)) false))) false))
(assert (= (f19 (f3 (f4 f5 f21) (f6 f7 2)) (- 1) (+ (* 4 f8) 1)) f1))
(assert (let ((?v_0 (f6 f7 2))) (= (f19 (f3 (f4 f5 f21) ?v_0) (f3 (f4 f5 f20) ?v_0) (+ (* 4 f8) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f8) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f19 f20 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f8) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f19 f20 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f19 f20 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f12 ?v0) ?v1) (f10 (f11 f12 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (+ ?v1 ?v2)) (+ (f10 ?v_0 ?v1) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (- ?v1 ?v2)) (- (f10 ?v_0 ?v1) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f12 (- ?v0)) ?v1) (- (f10 (f11 f12 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 (f11 f12 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f11 f12 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f10 (f11 f12 (+ ?v0 ?v1)) ?v2) (+ (f10 (f11 f12 ?v0) ?v2) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f10 (f11 f12 (- ?v0 ?v1)) ?v2) (- (f10 (f11 f12 ?v0) ?v2) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f14 ?v_0) f1) (= (f10 (f11 f15 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f10 (f11 f12 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f10 ?v_0 ?v0) (f10 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f18 ?v2))) (let ((?v_1 (f11 f12 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f10 ?v_1 ?v0) (f10 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 (f11 f12 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 (f11 f12 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (= (f9 ?v1) f1) (= (f9 (f10 (f11 f12 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f3 f18 ?v1) (f3 f18 ?v2)))) (f10 (f11 f12 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f15 ?v0) ?v1) (ite (= (f19 ?v0 0 ?v1) f1) 0 (ite (= (f16 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f19 (f3 (f4 f5 ?v2) (f6 f7 2)) ?v1 ?v0) f1)))))
(assert (= (f22 (+ (* 4 f8) 1) (- (f3 (f4 f5 f21) (f6 f7 2)) (- 1))) f1))
(assert (= (f22 (+ (* 4 f8) 1) (+ (f3 (f4 f5 f21) (f6 f7 2)) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f14 ?v0) f1) (=> (not (= (f19 ?v1 0 ?v0) f1)) (=> (not (= (f19 ?v2 0 ?v0) f1)) (not (= (f19 (f10 (f11 f12 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f19 (f10 (f11 f12 ?v1) ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f14 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f19 ?v1 0 ?v0) f1)) (not (= (f19 ?v2 0 ?v0) f1))) (not (= (f19 (f10 (f11 f12 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f14 ?v0) f1) (=> (< 0 ?v1) (=> (= (f19 (f10 (f11 f12 ?v1) ?v2) 0 ?v0) f1) (or (= (f19 ?v1 0 ?v0) f1) (= (f19 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0) f1) (=> (< 0 ?v1) (=> (= (f19 (f10 (f11 f12 ?v1) ?v1) 1 ?v0) f1) (or (= (f19 ?v1 1 ?v0) f1) (= (f19 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (= (f23 f24 (f25 f21 1)) (f10 (f11 f12 (+ (* 4 f8) 1)) f13)))
(assert (forall ((?v0 Int)) (= (= (f22 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f22 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f22 ?v0 ?v1) f1) (=> (= (f22 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f22 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 ?v0 ?v1) f1) (=> (= (f22 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f22 ?v0 (- ?v1 ?v2)) f1) (=> (= (f22 ?v0 ?v2) f1) (= (f22 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f19 ?v0 ?v1 ?v2) f1) (= (f22 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f19 ?v0 0 ?v1) f1) (= (f22 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f19 ?v0 0 ?v1) f1) (= (f22 ?v1 ?v0) f1))))
(assert (forall ((?v0 S3)) (= (f6 f7 (f3 f18 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f18 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f18 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
