(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int Int Int) S1)
(declare-fun f4 (Int) S1)
(declare-fun f5 () Int)
(declare-fun f6 (S2 Int) Int)
(declare-fun f7 (S3 Int) S2)
(declare-fun f8 () S3)
(declare-fun f9 (Int Int) S1)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f3 ?v1 (- 1) ?v0) f1) (not (= (f3 ?v1 1 ?v0) f1))))))
(assert (= (f4 (+ (* 4 f5) 1)) f1))
(assert (forall ((?v0 Int)) (=> (= (f4 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 ?v0 ?v1 ?v2) f1) (= (f3 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 ?v0) ?v1) (ite (= (f3 ?v0 0 ?v1) f1) 0 (ite (= (f9 ?v1 ?v0) f1) 1 (- 1))))))
(assert (let ((?v_0 (+ (* 4 f5) 1))) (not (=> (not (= (f9 ?v_0 (- 1)) f1)) (not (= (f6 (f7 f8 (- 1)) ?v_0) 1))))))
(check-sat)
(exit)
