(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
      Tokeneer case study <http://www.adacore.com/home/products/gnatpro/tokeneer/>
  |)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun display__blank () Int)
(declare-fun display__doorunlocked () Int)
(declare-fun display__insertfinger () Int)
(declare-fun display__msgt__base__first () Int)
(declare-fun display__msgt__base__last () Int)
(declare-fun display__msgt__first () Int)
(declare-fun display__msgt__last () Int)
(declare-fun display__msgt__size () Int)
(declare-fun display__opendoor () Int)
(declare-fun display__removetoken () Int)
(declare-fun display__tokenupdatefailed () Int)
(declare-fun display__wait () Int)
(declare-fun display__welcome () Int)
(declare-fun gotfinger () Int)
(declare-fun gotusertoken () Int)
(declare-fun quiescent () Int)
(declare-fun statust__base__first () Int)
(declare-fun statust__base__last () Int)
(declare-fun statust__first () Int)
(declare-fun statust__last () Int)
(declare-fun statust__size () Int)
(declare-fun waitingentry () Int)
(declare-fun waitingfinger () Int)
(declare-fun waitingremovetokenfail () Int)
(declare-fun waitingremovetokensuccess () Int)
(declare-fun waitingupdatetoken () Int)
(declare-fun latch__state () Int)
(declare-fun init.latch__state () Int)
(declare-fun |status'| () Int)
(declare-fun init.status () Int)
(declare-fun bit__and (Int Int) Int)
(declare-fun bit__not (Int Int) Int)
(declare-fun bit__or (Int Int) Int)
(declare-fun bit__xor (Int Int) Int)
(declare-fun character__pos (Int) Int)
(declare-fun character__val (Int) Int)
(declare-fun display__msgt__pos (Int) Int)
(declare-fun display__msgt__pred (Int) Int)
(declare-fun display__msgt__succ (Int) Int)
(declare-fun display__msgt__val (Int) Int)
(declare-fun integer__pred (Int) Int)
(declare-fun integer__succ (Int) Int)
(declare-fun round__ (Int) Int)
(declare-fun statust__pos (Int) Int)
(declare-fun statust__pred (Int) Int)
(declare-fun statust__succ (Int) Int)
(declare-fun statust__val (Int) Int)
(declare-fun i.div (Int Int) Int)
(declare-fun i.mod (Int Int) Int)
(declare-fun i.mult (Int Int) Int)
(declare-fun i.exp (Int Int) Int)
(declare-fun tm.true () Int)
(declare-fun tm.false () Int)
(declare-fun tm.not (Int) Int)
(declare-fun tm.and (Int Int) Int)
(declare-fun tm.or (Int Int) Int)
(declare-fun tm.iff (Int Int) Int)
(declare-fun tm.eq (Int Int) Int)
(declare-fun tm.ne (Int Int) Int)
(declare-fun tm.lt (Int Int) Int)
(declare-fun tm.le (Int Int) Int)
(declare-fun tuple.2 (Int Int) Int)
(declare-fun a.store (Int Int Int) Int)
(declare-fun a.select (Int Int) Int)
(declare-fun a.mk_const_array (Int) Int)
(declare-fun a.default_array () Int)
(declare-fun r.default_record () Int)
(declare-fun display__msgt__LE (Int Int) Bool)
(declare-fun display__msgt__LT (Int Int) Bool)
(declare-fun latch__islocked (Int) Bool)
(declare-fun statust__LE (Int Int) Bool)
(declare-fun statust__LT (Int Int) Bool)
(assert (forall ((?i Int)) (=> (and (<= 0 ?i) (< ?i 8)) (= (display__msgt__pos ?i) ?i))))
(assert (forall ((?i Int)) (=> (and (<= 0 ?i) (< ?i 8)) (= (display__msgt__val ?i) ?i))))
(assert (forall ((?i Int)) (=> (and (<= 0 ?i) (< ?i 7)) (= (display__msgt__succ ?i) (+ ?i 1)))))
(assert (forall ((?i Int)) (=> (and (<= 1 ?i) (< ?i 8)) (= (display__msgt__pred ?i) (- ?i 1)))))
(assert (= display__blank 0))
(assert (= display__welcome 1))
(assert (= display__insertfinger 2))
(assert (= display__opendoor 3))
(assert (= display__wait 4))
(assert (= display__removetoken 5))
(assert (= display__tokenupdatefailed 6))
(assert (= display__doorunlocked 7))
(assert (forall ((?i Int)) (=> (and (<= 0 ?i) (< ?i 8)) (= (statust__pos ?i) ?i))))
(assert (forall ((?i Int)) (=> (and (<= 0 ?i) (< ?i 8)) (= (statust__val ?i) ?i))))
(assert (forall ((?i Int)) (=> (and (<= 0 ?i) (< ?i 7)) (= (statust__succ ?i) (+ ?i 1)))))
(assert (forall ((?i Int)) (=> (and (<= 1 ?i) (< ?i 8)) (= (statust__pred ?i) (- ?i 1)))))
(assert (= quiescent 0))
(assert (= gotusertoken 1))
(assert (= waitingfinger 2))
(assert (= gotfinger 3))
(assert (= waitingupdatetoken 4))
(assert (= waitingentry 5))
(assert (= waitingremovetokensuccess 6))
(assert (= waitingremovetokenfail 7))
(assert (<= 0 display__msgt__size))
(assert (= display__msgt__first display__blank))
(assert (= display__msgt__last display__doorunlocked))
(assert (= display__msgt__base__first display__blank))
(assert (= display__msgt__base__last display__doorunlocked))
(assert (<= 0 statust__size))
(assert (= statust__first quiescent))
(assert (= statust__last waitingremovetokenfail))
(assert (= statust__base__first quiescent))
(assert (= statust__base__last waitingremovetokenfail))
(assert (forall ((?X Int) (?Y Int)) (=> (< 0 ?Y) (<= 0 (i.mod ?X ?Y)))))
(assert (forall ((?X Int) (?Y Int)) (=> (< 0 ?Y) (< (i.mod ?X ?Y) ?Y))))
(assert (forall ((?X Int) (?Y Int)) (=> (and (<= 0 ?X) (< 0 ?Y)) (<= (i.mult ?Y (i.div ?X ?Y)) ?X))))
(assert (forall ((?X Int) (?Y Int)) (=> (and (<= 0 ?X) (< 0 ?Y)) (< (- ?X ?Y) (i.mult ?Y (i.div ?X ?Y))))))
(assert (forall ((?X Int) (?Y Int)) (=> (and (<= ?X 0) (< 0 ?Y)) (<= ?X (i.mult ?Y (i.div ?X ?Y))))))
(assert (forall ((?X Int) (?Y Int)) (=> (and (<= ?X 0) (< 0 ?Y)) (< (i.mult ?Y (i.div ?X ?Y)) (+ ?X ?Y)))))
(assert (forall ((?X Int) (?Y Int)) (=> (and (<= 0 ?X) (<= 0 ?Y)) (<= 0 (bit__or ?X ?Y)))))
(assert (forall ((?X Int) (?Y Int)) (=> (and (<= 0 ?X) (<= 0 ?Y)) (<= ?X (bit__or ?X ?Y)))))
(assert (forall ((?X Int) (?Y Int)) (=> (and (<= 0 ?X) (<= 0 ?Y)) (<= ?Y (bit__or ?X ?Y)))))
(assert (forall ((?X Int) (?Y Int)) (=> (and (<= 0 ?X) (<= 0 ?Y)) (<= (bit__or ?X ?Y) (+ ?X ?Y)))))
(assert (distinct tm.true tm.false))
(assert (forall ((?x Int)) (! (= (= (tm.not ?x) tm.true) (not (= ?x tm.true))) :pattern ((tm.not ?x)) )))
(assert (forall ((?x Int) (?y Int)) (! (= (= (tm.and ?x ?y) tm.true) (and (= ?x tm.true) (= ?y tm.true))) :pattern ((tm.and ?x ?y)) )))
(assert (forall ((?x Int) (?y Int)) (! (= (= (tm.or ?x ?y) tm.true) (or (= ?x tm.true) (= ?y tm.true))) :pattern ((tm.or ?x ?y)) )))
(assert (forall ((?x Int) (?y Int)) (! (= (= (tm.iff ?x ?y) tm.true) (= (= ?x tm.true) (= ?y tm.true))) :pattern ((tm.iff ?x ?y)) )))
(assert (forall ((?x Int) (?y Int)) (! (= (= (tm.eq ?x ?y) tm.true) (= ?x ?y)) :pattern ((tm.eq ?x ?y)) )))
(assert (forall ((?x Int) (?y Int)) (! (= (= (tm.ne ?x ?y) tm.true) (not (= ?x ?y))) :pattern ((tm.ne ?x ?y)) )))
(assert (forall ((?x Int) (?y Int)) (! (= (= (tm.lt ?x ?y) tm.true) (< ?x ?y)) :pattern ((tm.lt ?x ?y)) )))
(assert (forall ((?x Int) (?y Int)) (! (= (= (tm.le ?x ?y) tm.true) (<= ?x ?y)) :pattern ((tm.le ?x ?y)) )))
(assert (forall ((?a Int) (?i Int) (?v Int)) (! (= (a.select (a.store ?a ?i ?v) ?i) ?v) :pattern ((a.select (a.store ?a ?i ?v) ?i)) )))
(assert (forall ((?a Int) (?i Int) (?v Int) (?j Int)) (! (or (= ?i ?j) (= (a.select (a.store ?a ?i ?v) ?j) (a.select ?a ?j))) :pattern ((a.select (a.store ?a ?i ?v) ?j)) )))
(assert (forall ((?i Int) (?v Int)) (! (= (a.select (a.mk_const_array ?v) ?i) ?v) :pattern ((a.select (a.mk_const_array ?v) ?i)) )))
(assert true)
(assert (<= statust__first |status'|))
(assert (<= |status'| statust__last))
(assert true)
(assert (latch__islocked latch__state))
(assert (not (= |status'| waitingremovetokenfail)))
(assert (not (and (<= display__msgt__first display__welcome) (<= display__welcome display__msgt__last))))
(check-sat)
(exit)
